"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/core/lineRange","vs/base/common/arrays","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/advancedLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/editor/common/services/editorSimpleWorker"],ue=function(x){for(var t=[],y=0,k=x.length;y<k;y++)t[y]=le[x[y]];return t};const Ve=this,je=typeof global=="object"?global:{};var Ae;(function(x){x.global=Ve;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof x.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}x.Environment=t})(Ae||(Ae={}));var Ae;(function(x){class t{constructor(o,v,u){this.type=o,this.detail=v,this.timestamp=u}}x.LoaderEvent=t;class y{constructor(o){this._events=[new t(1,"",o)]}record(o,v){this._events.push(new t(o,v,x.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}x.LoaderEventRecorder=y;class k{record(o,v){}getEvents(){return[]}}k.INSTANCE=new k,x.NullLoaderEventRecorder=k})(Ae||(Ae={}));var Ae;(function(x){class t{static fileUriToFilePath(k,i){if(i=decodeURI(i).replace(/%23/g,"#"),k){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(k,i){return k.length>=i.length&&k.substr(0,i.length)===i}static endsWith(k,i){return k.length>=i.length&&k.substr(k.length-i.length)===i}static containsQueryString(k){return/^[^\#]*\?/gi.test(k)}static isAbsolutePath(k){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(k)}static forEachProperty(k,i){if(k){let o;for(o in k)k.hasOwnProperty(o)&&i(o,k[o])}}static isEmpty(k){let i=!0;return t.forEachProperty(k,()=>{i=!1}),i}static recursiveClone(k){if(!k||typeof k!="object"||k instanceof RegExp||!Array.isArray(k)&&Object.getPrototypeOf(k)!==Object.prototype)return k;let i=Array.isArray(k)?[]:{};return t.forEachProperty(k,(o,v)=>{v&&typeof v=="object"?i[o]=t.recursiveClone(v):i[o]=v}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(k){return t.startsWith(k,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=x.global.performance&&typeof x.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?x.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,x.Utilities=t})(Ae||(Ae={}));var Ae;(function(x){function t(i){if(i instanceof Error)return i;const o=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(o.stack=i.stack),o}x.ensureError=t;class y{static validateConfigurationOptions(o){function v(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory function of "'+u.moduleId+'" has thrown an exception'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=v),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(x.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const u=t(new Error("INVALID cached data configuration, 'path' MUST be set"));u.phase="configuration",o.onError(u),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,v=null){let u=x.Utilities.recursiveClone(v||{});return x.Utilities.forEachProperty(o,(s,l)=>{s==="ignoreDuplicateModules"&&typeof u.ignoreDuplicateModules<"u"?u.ignoreDuplicateModules=u.ignoreDuplicateModules.concat(l):s==="paths"&&typeof u.paths<"u"?x.Utilities.forEachProperty(l,(h,R)=>u.paths[h]=R):s==="config"&&typeof u.config<"u"?x.Utilities.forEachProperty(l,(h,R)=>u.config[h]=R):u[s]=x.Utilities.recursiveClone(l)}),y.validateConfigurationOptions(u)}}x.ConfigurationOptionsUtil=y;class k{constructor(o,v){if(this._env=o,this.options=y.mergeConfigurationOptions(v),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let u=this.options.nodeRequire.main.filename,s=Math.max(u.lastIndexOf("/"),u.lastIndexOf("\\"));this.options.baseUrl=u.substring(0,s+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],x.Utilities.forEachProperty(this.options.paths,(o,v)=>{Array.isArray(v)?this.sortedPathsRules.push({from:o,to:v}):this.sortedPathsRules.push({from:o,to:[v]})}),this.sortedPathsRules.sort((o,v)=>v.from.length-o.from.length)}cloneAndMerge(o){return new k(this._env,y.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let v;for(let u=0,s=this.sortedPathsRules.length;u<s;u++)if(v=this.sortedPathsRules[u],x.Utilities.startsWith(o,v.from)){let l=[];for(let h=0,R=v.to.length;h<R;h++)l.push(v.to[h]+o.substr(v.from.length));return l}return[o]}_addUrlArgsToUrl(o){return x.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let v=0,u=o.length;v<u;v++)o[v]=this._addUrlArgsToUrl(o[v]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let v=o,u;if(!x.Utilities.endsWith(v,".js")&&!x.Utilities.isAbsolutePath(v)){u=this._applyPaths(v);for(let s=0,l=u.length;s<l;s++)this.isBuild()&&u[s]==="empty:"||(x.Utilities.isAbsolutePath(u[s])||(u[s]=this.options.baseUrl+u[s]),!x.Utilities.endsWith(u[s],".js")&&!x.Utilities.containsQueryString(u[s])&&(u[s]=u[s]+".js"))}else!x.Utilities.endsWith(v,".js")&&!x.Utilities.containsQueryString(v)&&(v=v+".js"),u=[v];return this._addUrlArgsIfNecessaryToUrls(u)}requireToUrl(o){let v=o;return x.Utilities.isAbsolutePath(v)||(v=this._applyPaths(v)[0],x.Utilities.isAbsolutePath(v)||(v=this.options.baseUrl+v)),this._addUrlArgsIfNecessaryToUrl(v)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||x.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}x.Configuration=k})(Ae||(Ae={}));var Ae;(function(x){class t{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,h,R,f){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new y:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new y;let d={callback:R,errorback:f};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(d);return}this._callbackMap[h]=[d],this._scriptLoader.load(l,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(l){let h=this._callbackMap[l];delete this._callbackMap[l];for(let R=0;R<h.length;R++)h[R].callback()}triggerErrorback(l,h){let R=this._callbackMap[l];delete this._callbackMap[l];for(let f=0;f<R.length;f++)R[f].errorback(h)}}class y{attachListeners(l,h,R){let f=()=>{l.removeEventListener("load",d),l.removeEventListener("error",e)},d=N=>{f(),h()},e=N=>{f(),R(N)};l.addEventListener("load",d),l.addEventListener("error",e)}load(l,h,R,f){if(/^node\|/.test(h)){let d=l.getConfig().getOptionsLiteral(),e=v(l.getRecorder(),d.nodeRequire||x.global.nodeRequire),N=h.split("|"),p=null;try{p=e(N[1])}catch(A){f(A);return}l.enqueueDefineAnonymousModule([],()=>p),R()}else{let d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript"),this.attachListeners(d,R,f);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),d.setAttribute("src",h);const{cspNonce:N}=l.getConfig().getOptionsLiteral();N&&d.setAttribute("nonce",N),document.getElementsByTagName("head")[0].appendChild(d)}}}function k(s){const{trustedTypesPolicy:l}=s.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=k(l)),this._cachedCanUseEval}load(l,h,R,f){if(/^node\|/.test(h)){const d=l.getConfig().getOptionsLiteral(),e=v(l.getRecorder(),d.nodeRequire||x.global.nodeRequire),N=h.split("|");let p=null;try{p=e(N[1])}catch(A){f(A);return}l.enqueueDefineAnonymousModule([],function(){return p}),R()}else{const{trustedTypesPolicy:d}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(h).then(N=>{if(N.status!==200)throw new Error(N.statusText);return N.text()}).then(N=>{N=`${N}
//# sourceURL=${h}`,(d?self.eval(d.createScript("",N)):new Function(N)).call(self),R()}).then(void 0,f);return}try{d&&(h=d.createScriptURL(h)),importScripts(h),R()}catch(N){f(N)}}}}class o{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,h){const{nodeCachedData:R}=h.getConfig().getOptionsLiteral();if(!R||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const f=this,d=l("module");function e(N){const p=N.constructor;let A=function(M){try{return N.require(M)}finally{}};return A.resolve=function(M,g){return p._resolveFilename(M,N,!1,g)},A.resolve.paths=function(M){return p._resolveLookupPaths(M,N)},A.main=process.mainModule,A.extensions=p._extensions,A.cache=p._cache,A}d.prototype._compile=function(N,p){const A=d.wrap(N.replace(/^#!.*/,"")),b=h.getRecorder(),M=f._getCachedDataPath(R,p),g={filename:p};let c;try{const $=f._fs.readFileSync(M);c=$.slice(0,16),g.cachedData=$.slice(16),b.record(60,M)}catch{b.record(61,M)}const r=new f._vm.Script(A,g),a=r.runInThisContext(g),E=f._path.dirname(p),m=e(this),L=[this.exports,m,this,p,E,process,je,Buffer],w=a.apply(this.exports,L);return f._handleCachedData(r,A,M,!g.cachedData,h),f._verifyCachedData(r,A,M,c,h),w}}load(l,h,R,f){const d=l.getConfig().getOptionsLiteral(),e=v(l.getRecorder(),d.nodeRequire||x.global.nodeRequire),N=d.nodeInstrumenter||function(A){return A};this._init(e),this._initNodeRequire(e,l);let p=l.getRecorder();if(/^node\|/.test(h)){let A=h.split("|"),b=null;try{b=e(A[1])}catch(M){f(M);return}l.enqueueDefineAnonymousModule([],()=>b),R()}else{h=x.Utilities.fileUriToFilePath(this._env.isWindows,h);const A=this._path.normalize(h),b=this._getElectronRendererScriptPathOrUri(A),M=!!d.nodeCachedData,g=M?this._getCachedDataPath(d.nodeCachedData,h):void 0;this._readSourceAndCachedData(A,g,p,(c,r,a,E)=>{if(c){f(c);return}let m;r.charCodeAt(0)===o._BOM?m=o._PREFIX+r.substring(1)+o._SUFFIX:m=o._PREFIX+r+o._SUFFIX,m=N(m,A);const L={filename:b,cachedData:a},w=this._createAndEvalScript(l,m,L,R,f);this._handleCachedData(w,m,g,M&&!a,l),this._verifyCachedData(w,m,g,E,l)})}}_createAndEvalScript(l,h,R,f,d){const e=l.getRecorder();e.record(31,R.filename);const N=new this._vm.Script(h,R),p=N.runInThisContext(R),A=l.getGlobalAMDDefineFunc();let b=!1;const M=function(){return b=!0,A.apply(null,arguments)};return M.amd=A.amd,p.call(x.global,l.getGlobalAMDRequireFunc(),M,R.filename,this._path.dirname(R.filename)),e.record(32,R.filename),b?f():d(new Error(`Didn't receive define call in ${R.filename}!`)),N}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let h=l.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,h){const R=this._crypto.createHash("md5").update(h,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),f=this._path.basename(h).replace(/\.js$/,"");return this._path.join(l.path,`${f}-${R}.code`)}_handleCachedData(l,h,R,f,d){l.cachedDataRejected?this._fs.unlink(R,e=>{d.getRecorder().record(62,R),this._createAndWriteCachedData(l,h,R,d),e&&d.getConfig().onError(e)}):f&&this._createAndWriteCachedData(l,h,R,d)}_createAndWriteCachedData(l,h,R,f){let d=Math.ceil(f.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,N=0,p;const A=()=>{setTimeout(()=>{p||(p=this._crypto.createHash("md5").update(h,"utf8").digest());const b=l.createCachedData();if(!(b.length===0||b.length===e||N>=5)){if(b.length<e){A();return}e=b.length,this._fs.writeFile(R,Buffer.concat([p,b]),M=>{M&&f.getConfig().onError(M),f.getRecorder().record(63,R),A()})}},d*Math.pow(4,N++))};A()}_readSourceAndCachedData(l,h,R,f){if(!h)this._fs.readFile(l,{encoding:"utf8"},f);else{let d,e,N,p=2;const A=b=>{b?f(b):--p===0&&f(void 0,d,e,N)};this._fs.readFile(l,{encoding:"utf8"},(b,M)=>{d=M,A(b)}),this._fs.readFile(h,(b,M)=>{!b&&M&&M.length>0?(N=M.slice(0,16),e=M.slice(16),R.record(60,h)):R.record(61,h),A()})}}_verifyCachedData(l,h,R,f,d){f&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();f.equals(e)||(d.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${R}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(R,N=>{N&&d.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function v(s,l){if(l.__$__isRecorded)return l;const h=function(f){s.record(33,f);try{return l(f)}finally{s.record(34,f)}};return h.__$__isRecorded=!0,h}x.ensureRecordedNodeRequire=v;function u(s){return new t(s)}x.createScriptLoader=u})(Ae||(Ae={}));var Ae;(function(x){class t{constructor(s){let l=s.lastIndexOf("/");l!==-1?this.fromModulePath=s.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(s){let l=s,h;for(h=/\/\.\//;h.test(l);)l=l.replace(h,"/");for(l=l.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(l);)l=l.replace(h,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(s){let l=s;return x.Utilities.isAbsolutePath(l)||(x.Utilities.startsWith(l,"./")||x.Utilities.startsWith(l,"../"))&&(l=t._normalizeModuleId(this.fromModulePath+l)),l}}t.ROOT=new t(""),x.ModuleIdResolver=t;class y{constructor(s,l,h,R,f,d){this.id=s,this.strId=l,this.dependencies=h,this._callback=R,this._errorback=f,this.moduleIdResolver=d,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(s,l){try{return{returnedValue:s.apply(x.global,l),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(s,l,h,R){return s.shouldInvokeFactory(l)?s.shouldCatchError()?this._safeInvokeFunction(h,R):{returnedValue:h.apply(x.global,R),producedError:null}:{returnedValue:null,producedError:null}}complete(s,l,h,R){this._isComplete=!0;let f=null;if(this._callback)if(typeof this._callback=="function"){s.record(21,this.strId);let d=y._invokeFactory(l,this.strId,this._callback,h);f=d.producedError,s.record(22,this.strId),!f&&typeof d.returnedValue<"u"&&(!this.exportsPassedIn||x.Utilities.isEmpty(this.exports))&&(this.exports=d.returnedValue)}else this.exports=this._callback;if(f){let d=x.ensureError(f);d.phase="factory",d.moduleId=this.strId,d.neededBy=R(this.id),this.error=d,l.onError(d)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(s){return this._isComplete=!0,this.error=s,this._errorback?(this._errorback(s),!0):!1}isComplete(){return this._isComplete}}x.Module=y;class k{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(s){let l=this._strModuleIdToIntModuleId.get(s);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(s,l),this._intModuleIdToStrModuleId[l]=s),l}getStrModuleId(s){return this._intModuleIdToStrModuleId[s]}}class i{constructor(s){this.id=s}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),x.RegularDependency=i;class o{constructor(s,l,h){this.id=s,this.pluginId=l,this.pluginParam=h}}x.PluginDependency=o;class v{constructor(s,l,h,R,f=0){this._env=s,this._scriptLoader=l,this._loaderAvailableTimestamp=f,this._defineFunc=h,this._requireFunc=R,this._moduleIdProvider=new k,this._config=new x.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(s,l){let h=d=>d.replace(/\\/g,"/"),R=h(s),f=l.split(/\n/);for(let d=0;d<f.length;d++){let e=f[d].match(/(.*):(\d+):(\d+)\)?$/);if(e){let N=e[1],p=e[2],A=e[3],b=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(b),N=h(N),N===R){let M={line:parseInt(p,10),col:parseInt(A,10)};return M.line===1&&(M.col-=53),M}}}throw new Error("Could not correlate define call site for needle "+s)}getBuildInfo(){if(!this._config.isBuild())return null;let s=[],l=0;for(let h=0,R=this._modules2.length;h<R;h++){let f=this._modules2[h];if(!f)continue;let d=this._buildInfoPath[f.id]||null,e=this._buildInfoDefineStack[f.id]||null,N=this._buildInfoDependencies[f.id];s[l++]={id:f.strId,path:d,defineLocation:d&&e?v._findRelevantLocationInStack(d,e):null,dependencies:N,shim:null,exports:f.exports}}return s}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new x.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=x.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(s,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:s,callback:l}}defineModule(s,l,h,R,f,d=new t(s)){let e=this._moduleIdProvider.getModuleId(s);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(s)||console.warn("Duplicate definition of module '"+s+"'");return}let N=new y(e,s,this._normalizeDependencies(l,d),h,R,d);this._modules2[e]=N,this._config.isBuild()&&(this._buildInfoDefineStack[e]=f,this._buildInfoDependencies[e]=(N.dependencies||[]).map(p=>this._moduleIdProvider.getStrModuleId(p.id))),this._resolve(N)}_normalizeDependency(s,l){if(s==="exports")return i.EXPORTS;if(s==="module")return i.MODULE;if(s==="require")return i.REQUIRE;let h=s.indexOf("!");if(h>=0){let R=l.resolveModule(s.substr(0,h)),f=l.resolveModule(s.substr(h+1)),d=this._moduleIdProvider.getModuleId(R+"!"+f),e=this._moduleIdProvider.getModuleId(R);return new o(d,e,f)}return new i(this._moduleIdProvider.getModuleId(l.resolveModule(s)))}_normalizeDependencies(s,l){let h=[],R=0;for(let f=0,d=s.length;f<d;f++)h[R++]=this._normalizeDependency(s[f],l);return h}_relativeRequire(s,l,h,R){if(typeof l=="string")return this.synchronousRequire(l,s);this.defineModule(x.Utilities.generateAnonymousModule(),l,h,R,null,s)}synchronousRequire(s,l=new t(s)){let h=this._normalizeDependency(s,l),R=this._modules2[h.id];if(!R)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This is the first mention of this module!");if(!R.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This module has not been resolved completely yet.");if(R.error)throw R.error;return R.exports}configure(s,l){let h=this._config.shouldRecordStats();l?this._config=new x.Configuration(this._env,s):this._config=this._config.cloneAndMerge(s),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(s){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(s),l.dependencies,l.callback,null,l.stack)}}_createLoadError(s,l){let h=this._moduleIdProvider.getStrModuleId(s),R=(this._inverseDependencies2[s]||[]).map(d=>this._moduleIdProvider.getStrModuleId(d));const f=x.ensureError(l);return f.phase="loading",f.moduleId=h,f.neededBy=R,f}_onLoadError(s,l){const h=this._createLoadError(s,l);this._modules2[s]||(this._modules2[s]=new y(s,this._moduleIdProvider.getStrModuleId(s),[],()=>{},null,null));let R=[];for(let e=0,N=this._moduleIdProvider.getMaxModuleId();e<N;e++)R[e]=!1;let f=!1,d=[];for(d.push(s),R[s]=!0;d.length>0;){let e=d.shift(),N=this._modules2[e];N&&(f=N.onDependencyError(h)||f);let p=this._inverseDependencies2[e];if(p)for(let A=0,b=p.length;A<b;A++){let M=p[A];R[M]||(d.push(M),R[M]=!0)}}f||this._config.onError(h)}_hasDependencyPath(s,l){let h=this._modules2[s];if(!h)return!1;let R=[];for(let d=0,e=this._moduleIdProvider.getMaxModuleId();d<e;d++)R[d]=!1;let f=[];for(f.push(h),R[s]=!0;f.length>0;){let e=f.shift().dependencies;if(e)for(let N=0,p=e.length;N<p;N++){let A=e[N];if(A.id===l)return!0;let b=this._modules2[A.id];b&&!R[A.id]&&(R[A.id]=!0,f.push(b))}}return!1}_findCyclePath(s,l,h){if(s===l||h===50)return[s];let R=this._modules2[s];if(!R)return null;let f=R.dependencies;if(f)for(let d=0,e=f.length;d<e;d++){let N=this._findCyclePath(f[d].id,l,h+1);if(N!==null)return N.push(s),N}return null}_createRequire(s){let l=(h,R,f)=>this._relativeRequire(s,h,R,f);return l.toUrl=h=>this._config.requireToUrl(s.resolveModule(h)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(h,R=!1)=>{this.configure(h,R)},l.__$__nodeRequire=x.global.nodeRequire,l}_loadModule(s){if(this._modules2[s]||this._knownModules2[s])return;this._knownModules2[s]=!0;let l=this._moduleIdProvider.getStrModuleId(s),h=this._config.moduleIdToPaths(l),R=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||R.test(l))&&h.push("node|"+l);let f=-1,d=e=>{if(f++,f>=h.length)this._onLoadError(s,e);else{let N=h[f],p=this.getRecorder();if(this._config.isBuild()&&N==="empty:"){this._buildInfoPath[s]=N,this.defineModule(this._moduleIdProvider.getStrModuleId(s),[],null,null,null),this._onLoad(s);return}p.record(10,N),this._scriptLoader.load(this,N,()=>{this._config.isBuild()&&(this._buildInfoPath[s]=N),p.record(11,N),this._onLoad(s)},A=>{p.record(12,N),d(A)})}};d(null)}_loadPluginDependency(s,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let h=R=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],R,null,null)};h.error=R=>{this._config.onError(this._createLoadError(l.id,R))},s.load(l.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(s){let l=s.dependencies;if(l)for(let h=0,R=l.length;h<R;h++){let f=l[h];if(f===i.EXPORTS){s.exportsPassedIn=!0,s.unresolvedDependenciesCount--;continue}if(f===i.MODULE){s.unresolvedDependenciesCount--;continue}if(f===i.REQUIRE){s.unresolvedDependenciesCount--;continue}let d=this._modules2[f.id];if(d&&d.isComplete()){if(d.error){s.onDependencyError(d.error);return}s.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,s.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(s.id)+"'. The cyclic path follows:");let e=this._findCyclePath(f.id,s.id,0)||[];e.reverse(),e.push(f.id),console.warn(e.map(N=>this._moduleIdProvider.getStrModuleId(N)).join(` => 
`)),s.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(s.id),f instanceof o){let e=this._modules2[f.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,f);continue}let N=this._inversePluginDependencies2.get(f.pluginId);N||(N=[],this._inversePluginDependencies2.set(f.pluginId,N)),N.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}_onModuleComplete(s){let l=this.getRecorder();if(s.isComplete())return;let h=s.dependencies,R=[];if(h)for(let N=0,p=h.length;N<p;N++){let A=h[N];if(A===i.EXPORTS){R[N]=s.exports;continue}if(A===i.MODULE){R[N]={id:s.strId,config:()=>this._config.getConfigForModule(s.strId)};continue}if(A===i.REQUIRE){R[N]=this._createRequire(s.moduleIdResolver);continue}let b=this._modules2[A.id];if(b){R[N]=b.exports;continue}R[N]=null}const f=N=>(this._inverseDependencies2[N]||[]).map(p=>this._moduleIdProvider.getStrModuleId(p));s.complete(l,this._config,R,f);let d=this._inverseDependencies2[s.id];if(this._inverseDependencies2[s.id]=null,d)for(let N=0,p=d.length;N<p;N++){let A=d[N],b=this._modules2[A];b.unresolvedDependenciesCount--,b.unresolvedDependenciesCount===0&&this._onModuleComplete(b)}let e=this._inversePluginDependencies2.get(s.id);if(e){this._inversePluginDependencies2.delete(s.id);for(let N=0,p=e.length;N<p;N++)this._loadPluginDependency(s.exports,e[N])}}}x.ModuleManager=v})(Ae||(Ae={}));var re,Ae;(function(x){const t=new x.Environment;let y=null;const k=function(u,s,l){typeof u!="string"&&(l=s,s=u,u=null),(typeof s!="object"||!Array.isArray(s))&&(l=s,s=null),s||(s=["require","exports","module"]),u?y.defineModule(u,s,l,null,null):y.enqueueDefineAnonymousModule(s,l)};k.amd={jQuery:!0};const i=function(u,s=!1){y.configure(u,s)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return y.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){y.defineModule(x.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=i,o.getConfig=function(){return y.getConfig().getOptionsLiteral()},o.reset=function(){y=y.reset()},o.getBuildInfo=function(){return y.getBuildInfo()},o.getStats=function(){return y.getLoaderEvents()},o.define=k;function v(){if(typeof x.global.require<"u"||typeof require<"u"){const u=x.global.require||require;if(typeof u=="function"&&typeof u.resolve=="function"){const s=x.ensureRecordedNodeRequire(y.getRecorder(),u);x.global.nodeRequire=s,o.nodeRequire=s,o.__$__nodeRequire=s}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(x.global.define=k),x.global.require=o)}x.init=v,(typeof x.global.define!="function"||!x.global.define.amd)&&(y=new x.ModuleManager(t,x.createScriptLoader(t),k,o,x.Utilities.getHighPerformanceTimestamp()),typeof x.global.require<"u"&&typeof x.global.require!="function"&&o.config(x.global.require),re=function(){return k.apply(null,arguments)},re.amd=k.amd,typeof doNotInitLoader>"u"&&v())})(Ae||(Ae={})),re(le[60],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function y(u,s,l,h){if(h=h||{},(h["vs/css"]||{}).disabled){l({});return}const f=s.toUrl(u+".css");k(u,f,()=>{l({})},d=>{typeof l.error=="function"&&l.error("Could not find "+f+".")})}t.load=y;function k(u,s,l,h){if(i(u,s)){l();return}o(u,s,l,h)}function i(u,s){const l=document.getElementsByTagName("link");for(let h=0,R=l.length;h<R;h++){const f=l[h].getAttribute("data-name"),d=l[h].getAttribute("href");if(f===u||d===s)return!0}return!1}function o(u,s,l,h){const R=document.createElement("link");R.setAttribute("rel","stylesheet"),R.setAttribute("type","text/css"),R.setAttribute("data-name",u),v(u,R,l,h),R.setAttribute("href",s),(document.head||document.getElementsByTagName("head")[0]).appendChild(R)}function v(u,s,l,h){const R=()=>{s.removeEventListener("load",f),s.removeEventListener("error",d)},f=e=>{R(),l()},d=e=>{R(),h(e)};s.addEventListener("load",f),s.addEventListener("error",d)}}),re("vs/nls",["require","exports"],function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let y=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const k="i-default";function i(e,N){let p;return N.length===0?p=e:p=e.replace(/\{(\d+)\}/g,(A,b)=>{const M=b[0],g=N[M];let c=A;return typeof g=="string"?c=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(c=String(g)),c}),y&&(p="\uFF3B"+p.replace(/[aouei]/g,"$&$&")+"\uFF3D"),p}function o(e,N){let p=e[N];return p||(p=e["*"],p)?p:null}function v(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function u(e,N,p){const A=v(e)+v(N)+"vscode/"+v(p),b=await fetch(A);if(b.ok)return await b.json();throw new Error(`${b.status} - ${b.statusText}`)}function s(e){return function(N,p){const A=Array.prototype.slice.call(arguments,2);return i(e[N],A)}}function l(e,N,...p){return i(N,p)}t.localize=l;function h(e){}t.getConfiguredDefaultLocale=h;function R(e){y=e}t.setPseudoTranslation=R;function f(e,N){return{localize:s(N[e]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??(p=>{})}}t.create=f;function d(e,N,p,A){const b=A["vs/nls"]??{};if(!e||e.length===0)return p({localize:l,getConfiguredDefaultLocale:()=>b.availableLanguages?.["*"]});const M=b.availableLanguages?o(b.availableLanguages,e):null,g=M===null||M===k;let c=".nls";g||(c=c+"."+M);const r=a=>{Array.isArray(a)?a.localize=s(a):a.localize=s(a[e]),a.getConfiguredDefaultLocale=()=>b.availableLanguages?.["*"],p(a)};typeof b.loadBundle=="function"?b.loadBundle(e,M,(a,E)=>{a?N([e+".nls"],r):r(E)}):b.translationServiceUrl&&!g?(async()=>{try{const a=await u(b.translationServiceUrl,M,e);return r(a)}catch(a){if(!M.includes("-"))return console.error(a),N([e+".nls"],r);try{const E=M.split("-")[0],m=await u(b.translationServiceUrl,E,e);return b.availableLanguages??(b.availableLanguages={}),b.availableLanguages["*"]=E,r(m)}catch(E){return console.error(E),N([e+".nls"],r)}}})():N([e+c],r,a=>{if(c===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${M}. Falling back to the default language:`,a),N([e+".nls"],r)})}t.load=d}),function(){const x=globalThis.MonacoEnvironment,t=x&&x.baseUrl?x.baseUrl:"../../../";function y(h,R){if(x?.createTrustedTypesPolicy)try{return x.createTrustedTypesPolicy(h,R)}catch(f){console.warn(f);return}try{return self.trustedTypes?.createPolicy(h,R)}catch(f){console.warn(f);return}}const k=y("amdLoader",{createScriptURL:h=>h,createScript:(h,...R)=>{const f=R.slice(0,-1).join(","),d=R.pop().toString();return`(function anonymous(${f}) { ${d}
})`}});function i(){try{return(k?globalThis.eval(k.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((h,R)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const f=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(f).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${f}`,(k?globalThis.eval(k.createScript("",e)):new Function(e)).call(globalThis),h()}).then(void 0,R);return}k?importScripts(k.createScriptURL(f)):importScripts(f),h()})}function v(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:k,amdModulesPattern:/^vs\//})}function u(h){o().then(()=>{v(),require([h],function(R){setTimeout(function(){const f=R.create((d,e)=>{globalThis.postMessage(d,e)},null);for(globalThis.onmessage=d=>f.onmessage(d.data,d.ports);l.length>0;){const d=l.shift();f.onmessage(d.data,d.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&v();let s=!0;const l=[];globalThis.onmessage=h=>{if(!s){l.push(h);return}s=!1,u(h.data)}}(),re(le[28],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$G=t.$F=t.$E=t.$D=void 0;function y(v,u){const s=Object.create(null);for(const l of v){const h=u(l);let R=s[h];R||(R=s[h]=[]),R.push(l)}return s}t.$D=y;function k(v,u){const s=[],l=[];for(const h of v)u.has(h)||s.push(h);for(const h of u)v.has(h)||l.push(h);return{removed:s,added:l}}t.$E=k;function i(v,u){const s=[],l=[];for(const[h,R]of v)u.has(h)||s.push(R);for(const[h,R]of u)v.has(h)||l.push(R);return{removed:s,added:l}}t.$F=i;class o{constructor(){this.a=new Map}add(u,s){let l=this.a.get(u);l||(l=new Set,this.a.set(u,l)),l.add(s)}delete(u,s){const l=this.a.get(u);l&&(l.delete(s),l.size===0&&this.a.delete(u))}forEach(u,s){const l=this.a.get(u);l&&l.forEach(s)}get(u){const s=this.a.get(u);return s||new Set}}t.$G=o}),re(le[29],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$es=t.$ds=t.$cs=t.$bs=void 0;function y(u,s){const l=Math.pow(10,s);return Math.round(u*l)/l}class k{constructor(s,l,h,R=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,s))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=y(Math.max(Math.min(1,R),0),3)}static equals(s,l){return s.r===l.r&&s.g===l.g&&s.b===l.b&&s.a===l.a}}t.$bs=k;class i{constructor(s,l,h,R){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=y(Math.max(Math.min(1,l),0),3),this.l=y(Math.max(Math.min(1,h),0),3),this.a=y(Math.max(Math.min(1,R),0),3)}static equals(s,l){return s.h===l.h&&s.s===l.s&&s.l===l.l&&s.a===l.a}static fromRGBA(s){const l=s.r/255,h=s.g/255,R=s.b/255,f=s.a,d=Math.max(l,h,R),e=Math.min(l,h,R);let N=0,p=0;const A=(e+d)/2,b=d-e;if(b>0){switch(p=Math.min(A<=.5?b/(2*A):b/(2-2*A),1),d){case l:N=(h-R)/b+(h<R?6:0);break;case h:N=(R-l)/b+2;break;case R:N=(l-h)/b+4;break}N*=60,N=Math.round(N)}return new i(N,p,A,f)}static i(s,l,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?s+(l-s)*6*h:h<1/2?l:h<2/3?s+(l-s)*(2/3-h)*6:s}static toRGBA(s){const l=s.h/360,{s:h,l:R,a:f}=s;let d,e,N;if(h===0)d=e=N=R;else{const p=R<.5?R*(1+h):R+h-R*h,A=2*R-p;d=i.i(A,p,l+1/3),e=i.i(A,p,l),N=i.i(A,p,l-1/3)}return new k(Math.round(d*255),Math.round(e*255),Math.round(N*255),f)}}t.$cs=i;class o{constructor(s,l,h,R){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=y(Math.max(Math.min(1,l),0),3),this.v=y(Math.max(Math.min(1,h),0),3),this.a=y(Math.max(Math.min(1,R),0),3)}static equals(s,l){return s.h===l.h&&s.s===l.s&&s.v===l.v&&s.a===l.a}static fromRGBA(s){const l=s.r/255,h=s.g/255,R=s.b/255,f=Math.max(l,h,R),d=Math.min(l,h,R),e=f-d,N=f===0?0:e/f;let p;return e===0?p=0:f===l?p=((h-R)/e%6+6)%6:f===h?p=(R-l)/e+2:p=(l-h)/e+4,new o(Math.round(p*60),N,f,s.a)}static toRGBA(s){const{h:l,s:h,v:R,a:f}=s,d=R*h,e=d*(1-Math.abs(l/60%2-1)),N=R-d;let[p,A,b]=[0,0,0];return l<60?(p=d,A=e):l<120?(p=e,A=d):l<180?(A=d,b=e):l<240?(A=e,b=d):l<300?(p=e,b=d):l<=360&&(p=d,b=e),p=Math.round((p+N)*255),A=Math.round((A+N)*255),b=Math.round((b+N)*255),new k(p,A,b,f)}}t.$ds=o;class v{static fromHex(s){return v.Format.CSS.parseHex(s)||v.red}static equals(s,l){return!s&&!l?!0:!s||!l?!1:s.equals(l)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(s){if(s)if(s instanceof k)this.rgba=s;else if(s instanceof i)this.i=s,this.rgba=i.toRGBA(s);else if(s instanceof o)this.j=s,this.rgba=o.toRGBA(s);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(s){return!!s&&k.equals(this.rgba,s.rgba)&&i.equals(this.hsla,s.hsla)&&o.equals(this.hsva,s.hsva)}getRelativeLuminance(){const s=v.k(this.rgba.r),l=v.k(this.rgba.g),h=v.k(this.rgba.b),R=.2126*s+.7152*l+.0722*h;return y(R,4)}static k(s){const l=s/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(s){const l=this.getRelativeLuminance(),h=s.getRelativeLuminance();return l>h?(l+.05)/(h+.05):(h+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(s){const l=this.getRelativeLuminance(),h=s.getRelativeLuminance();return l>h}isDarkerThan(s){const l=this.getRelativeLuminance(),h=s.getRelativeLuminance();return l<h}lighten(s){return new v(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*s,this.hsla.a))}darken(s){return new v(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*s,this.hsla.a))}transparent(s){const{r:l,g:h,b:R,a:f}=this.rgba;return new v(new k(l,h,R,f*s))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(s){const l=s.rgba,h=this.rgba.a,R=l.a,f=h+R*(1-h);if(f<1e-6)return v.transparent;const d=this.rgba.r*h/f+l.r*R*(1-h)/f,e=this.rgba.g*h/f+l.g*R*(1-h)/f,N=this.rgba.b*h/f+l.b*R*(1-h)/f;return new v(new k(d,e,N,f))}makeOpaque(s){if(this.isOpaque()||s.rgba.a!==1)return this;const{r:l,g:h,b:R,a:f}=this.rgba;return new v(new k(s.rgba.r-f*(s.rgba.r-l),s.rgba.g-f*(s.rgba.g-h),s.rgba.b-f*(s.rgba.b-R),1))}flatten(...s){const l=s.reduceRight((h,R)=>v.o(R,h));return v.o(this,l)}static o(s,l){const h=1-s.rgba.a;return new v(new k(h*l.rgba.r+s.rgba.a*s.rgba.r,h*l.rgba.g+s.rgba.a*s.rgba.g,h*l.rgba.b+s.rgba.a*s.rgba.b))}toString(){return this.u||(this.u=v.Format.CSS.format(this)),this.u}static getLighterColor(s,l,h){if(s.isLighterThan(l))return s;h=h||.5;const R=s.getRelativeLuminance(),f=l.getRelativeLuminance();return h=h*(f-R)/f,s.lighten(h)}static getDarkerColor(s,l,h){if(s.isDarkerThan(l))return s;h=h||.5;const R=s.getRelativeLuminance(),f=l.getRelativeLuminance();return h=h*(R-f)/R,s.darken(h)}}t.$es=v,v.white=new v(new k(255,255,255,1)),v.black=new v(new k(0,0,0,1)),v.red=new v(new k(255,0,0,1)),v.blue=new v(new k(0,0,255,1)),v.green=new v(new k(0,255,0,1)),v.cyan=new v(new k(0,255,255,1)),v.lightgrey=new v(new k(211,211,211,1)),v.transparent=new v(new k(0,0,0,0)),function(u){let s;(function(l){let h;(function(R){function f(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:u.Format.CSS.formatRGBA(r)}R.formatRGB=f;function d(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}R.formatRGBA=d;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:u.Format.CSS.formatHSLA(r)}R.formatHSL=e;function N(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}R.formatHSLA=N;function p(r){const a=r.toString(16);return a.length!==2?"0"+a:a}function A(r){return`#${p(r.rgba.r)}${p(r.rgba.g)}${p(r.rgba.b)}`}R.formatHex=A;function b(r,a=!1){return a&&r.rgba.a===1?u.Format.CSS.formatHex(r):`#${p(r.rgba.r)}${p(r.rgba.g)}${p(r.rgba.b)}${p(Math.round(r.rgba.a*255))}`}R.formatHexA=b;function M(r){return r.isOpaque()?u.Format.CSS.formatHex(r):u.Format.CSS.formatRGBA(r)}R.format=M;function g(r){const a=r.length;if(a===0||r.charCodeAt(0)!==35)return null;if(a===7){const E=16*c(r.charCodeAt(1))+c(r.charCodeAt(2)),m=16*c(r.charCodeAt(3))+c(r.charCodeAt(4)),L=16*c(r.charCodeAt(5))+c(r.charCodeAt(6));return new u(new k(E,m,L,1))}if(a===9){const E=16*c(r.charCodeAt(1))+c(r.charCodeAt(2)),m=16*c(r.charCodeAt(3))+c(r.charCodeAt(4)),L=16*c(r.charCodeAt(5))+c(r.charCodeAt(6)),w=16*c(r.charCodeAt(7))+c(r.charCodeAt(8));return new u(new k(E,m,L,w/255))}if(a===4){const E=c(r.charCodeAt(1)),m=c(r.charCodeAt(2)),L=c(r.charCodeAt(3));return new u(new k(16*E+E,16*m+m,16*L+L))}if(a===5){const E=c(r.charCodeAt(1)),m=c(r.charCodeAt(2)),L=c(r.charCodeAt(3)),w=c(r.charCodeAt(4));return new u(new k(16*E+E,16*m+m,16*L+L,(16*w+w)/255))}return null}R.parseHex=g;function c(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=l.CSS||(l.CSS={}))})(s=u.Format||(u.Format={}))}(v||(t.$es=v={}))}),re(le[30],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$su=void 0;class y{constructor(i,o,v,u){this.originalStart=i,this.originalLength=o,this.modifiedStart=v,this.modifiedLength=u}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$su=y}),re(le[3],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class y{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?g.isErrorNoTelemetry(a)?new g(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(E=>{E(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}t.$U=y,t.$V=new y;function k(r){t.$V.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=k;function i(r){if(!r||typeof r!="object")return!1;const a=r;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}t.$X=i;function o(r){l(r)||t.$V.onUnexpectedError(r)}t.$Y=o;function v(r){l(r)||t.$V.onUnexpectedExternalError(r)}t.$Z=v;function u(r){if(r instanceof Error){const{name:a,message:E}=r,m=r.stacktrace||r.stack;return{$isError:!0,name:a,message:E,stack:m,noTelemetry:g.isErrorNoTelemetry(r)}}return r}t.$1=u;const s="Canceled";function l(r){return r instanceof h?!0:r instanceof Error&&r.name===s&&r.message===s}t.$2=l;class h extends Error{constructor(){super(s),this.name=this.message}}t.$3=h;function R(){const r=new Error(s);return r.name=r.message,r}t.$4=R;function f(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.$5=f;function d(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.$6=d;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.$7=e;function N(r){const a=new Error(`${r} has been disposed`);return a.name="DISPOSED",a}t.$8=N;function p(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.$9=p;class A extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}t.$0=A;class b extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}t.$$=b;class M extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=M;class g extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof g)return a;const E=new g;return E.message=a.message,E.stack=a.stack,E}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}t.$ab=g;class c extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}t.$bb=c}),re(le[15],ue([0,1,3]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.CompareResult=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.top=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=void 0;function k(S,q=0){return S[S.length-(1+q)]}t.$9e=k;function i(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}t.$0e=i;function o(S,q,T=(B,O)=>B===O){if(S===q)return!0;if(!S||!q||S.length!==q.length)return!1;for(let B=0,O=S.length;B<O;B++)if(!T(S[B],q[B]))return!1;return!0}t.$$e=o;function v(S,q){const T=S.length-1;q<T&&(S[q]=S[T]),S.pop()}t.$_e=v;function u(S,q,T){return s(S.length,B=>T(S[B],q))}t.$af=u;function s(S,q){let T=0,B=S-1;for(;T<=B;){const O=(T+B)/2|0,Q=q(O);if(Q<0)T=O+1;else if(Q>0)B=O-1;else return O}return-(T+1)}t.$bf=s;function l(S,q){let T=0,B=S.length;if(B===0)return 0;for(;T<B;){const O=Math.floor((T+B)/2);q(S[O])?B=O:T=O+1}return T}t.$cf=l;function h(S,q,T){if(S=S|0,S>=q.length)throw new TypeError("invalid index");const B=q[Math.floor(q.length*Math.random())],O=[],Q=[],te=[];for(const ce of q){const he=T(ce,B);he<0?O.push(ce):he>0?Q.push(ce):te.push(ce)}return S<O.length?h(S,O,T):S<O.length+te.length?te[0]:h(S-(O.length+te.length),Q,T)}t.$df=h;function R(S,q){const T=[];let B;for(const O of S.slice(0).sort(q))!B||q(B[0],O)!==0?(B=[O],T.push(B)):B.push(O);return T}t.$ef=R;function f(S,q,T){const B=[];function O(ce,he,me){if(he===0&&me.length===0)return;const $e=B[B.length-1];$e&&$e.start+$e.deleteCount===ce?($e.deleteCount+=he,$e.toInsert.push(...me)):B.push({start:ce,deleteCount:he,toInsert:me})}let Q=0,te=0;for(;;){if(Q===S.length){O(Q,0,q.slice(te));break}if(te===q.length){O(Q,S.length-Q,[]);break}const ce=S[Q],he=q[te],me=T(ce,he);me===0?(Q+=1,te+=1):me<0?(O(Q,1,[]),Q+=1):me>0&&(O(Q,0,[he]),te+=1)}return B}t.$ff=f;function d(S,q,T){const B=f(S,q,T),O=[],Q=[];for(const te of B)O.push(...S.slice(te.start,te.start+te.deleteCount)),Q.push(...te.toInsert);return{removed:O,added:Q}}t.$gf=d;function e(S,q,T){if(T===0)return[];const B=S.slice(0,T).sort(q);return p(S,q,B,T,S.length),B}t.top=e;function N(S,q,T,B,O){return T===0?Promise.resolve([]):new Promise((Q,te)=>{(async()=>{const ce=S.length,he=S.slice(0,T).sort(q);for(let me=T,$e=Math.min(T+B,ce);me<ce;me=$e,$e=Math.min($e+B,ce)){if(me>T&&await new Promise(ke=>setTimeout(ke)),O&&O.isCancellationRequested)throw new y.$3;p(S,q,he,me,$e)}return he})().then(Q,te)})}t.$if=N;function p(S,q,T,B,O){for(const Q=T.length;B<O;B++){const te=S[B];if(q(te,T[Q-1])<0){T.pop();const ce=l(T,he=>q(te,he)<0);T.splice(ce,0,te)}}}function A(S){return S.filter(q=>!!q)}t.$jf=A;function b(S){let q=0;for(let T=0;T<S.length;T++)S[T]&&(S[q]=S[T],q+=1);S.length=q}t.$kf=b;function M(S,q,T){S.splice(T,0,S.splice(q,1)[0])}t.$lf=M;function g(S){return!Array.isArray(S)||S.length===0}t.$mf=g;function c(S){return Array.isArray(S)&&S.length>0}t.$nf=c;function r(S,q=T=>T){const T=new Set;return S.filter(B=>{const O=q(B);return T.has(O)?!1:(T.add(O),!0)})}t.$of=r;function a(S){const q=new Set;return T=>{const B=S(T);return q.has(B)?!1:(q.add(B),!0)}}t.$pf=a;function E(S,q){const T=m(S,q);if(T!==-1)return S[T]}t.$qf=E;function m(S,q){for(let T=S.length-1;T>=0;T--){const B=S[T];if(q(B))return T}return-1}t.$rf=m;function L(S,q){return S.length>0?S[0]:q}t.$sf=L;function w(S,q){return S.length>0?S[S.length-1]:q}t.$tf=w;function $(S,q,T=(B,O)=>B===O){let B=0;for(let O=0,Q=Math.min(S.length,q.length);O<Q&&T(S[O],q[O]);O++)B++;return B}t.$uf=$;function F(S){return[].concat(...S)}t.$vf=F;function I(S,q){let T=typeof q=="number"?S:0;typeof q=="number"?T=S:(T=0,q=S);const B=[];if(T<=q)for(let O=T;O<q;O++)B.push(O);else for(let O=T;O>q;O--)B.push(O);return B}t.$wf=I;function P(S,q,T){return S.reduce((B,O)=>(B[q(O)]=T?T(O):O,B),Object.create(null))}t.$xf=P;function U(S,q){return S.push(q),()=>C(S,q)}t.$yf=U;function C(S,q){const T=S.indexOf(q);if(T>-1)return S.splice(T,1),q}t.$zf=C;function V(S,q,T){const B=S.slice(0,q),O=S.slice(q);return B.concat(T,O)}t.$Af=V;function X(S,q){let T;if(typeof q=="number"){let B=q;T=()=>{const O=Math.sin(B++)*179426549;return O-Math.floor(O)}}else T=Math.random;for(let B=S.length-1;B>0;B-=1){const O=Math.floor(T()*(B+1)),Q=S[B];S[B]=S[O],S[O]=Q}}t.$Bf=X;function _(S,q){const T=S.indexOf(q);T>-1&&(S.splice(T,1),S.unshift(q))}t.$Cf=_;function z(S,q){const T=S.indexOf(q);T>-1&&(S.splice(T,1),S.push(q))}t.$Df=z;function Z(S,q){for(const T of q)S.push(T)}t.$Ef=Z;function J(S,q){return Array.isArray(S)?S.map(q):q(S)}t.$Ff=J;function ge(S){return Array.isArray(S)?S:[S]}t.$Gf=ge;function n(S){return S[Math.floor(Math.random()*S.length)]}t.$Hf=n;function j(S,q){for(const T of S){const B=q(T);if(B!==void 0)return B}}t.$If=j;function H(S,q,T){const B=G(S,q),O=S.length,Q=T.length;S.length=O+Q;for(let te=O-1;te>=B;te--)S[te+Q]=S[te];for(let te=0;te<Q;te++)S[te+B]=T[te]}t.$Jf=H;function K(S,q,T,B){const O=G(S,q),Q=S.splice(O,T);return H(S,O,B),Q}t.$Kf=K;function G(S,q){return q<0?Math.max(q+S.length,0):Math.min(q,S.length)}var ie;(function(S){function q(Q){return Q<0}S.isLessThan=q;function T(Q){return Q<=0}S.isLessThanOrEqual=T;function B(Q){return Q>0}S.isGreaterThan=B;function O(Q){return Q===0}S.isNeitherLessOrGreaterThan=O,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})(ie||(t.CompareResult=ie={}));function ae(S,q){return(T,B)=>q(S(T),S(B))}t.$Lf=ae;function oe(...S){return(q,T)=>{for(const B of S){const O=B(q,T);if(!ie.isNeitherLessOrGreaterThan(O))return O}return ie.neitherLessOrGreaterThan}}t.$Mf=oe;const fe=(S,q)=>S-q;t.$Nf=fe;const be=(S,q)=>(0,t.$Nf)(S?1:0,q?1:0);t.$Of=be;function ve(S){return(q,T)=>-S(q,T)}t.$Pf=ve;function we(S,q){if(S.length===0)return;let T=S[0];for(let B=1;B<S.length;B++){const O=S[B];q(O,T)>0&&(T=O)}return T}t.$Qf=we;function Me(S,q){if(S.length===0)return;let T=S[0];for(let B=1;B<S.length;B++){const O=S[B];q(O,T)>=0&&(T=O)}return T}t.$Rf=Me;function Le(S,q){return we(S,(T,B)=>-q(T,B))}t.$Sf=Le;function Re(S,q){if(S.length===0)return-1;let T=0;for(let B=1;B<S.length;B++){const O=S[B];q(O,S[T])>0&&(T=B)}return T}t.$Tf=Re;class pe{constructor(q){this.f=q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(q){let T=this.c;for(;T<this.f.length&&q(this.f[T]);)T++;const B=T===this.c?null:this.f.slice(this.c,T);return this.c=T,B}takeFromEndWhile(q){let T=this.d;for(;T>=0&&q(this.f[T]);)T--;const B=T===this.d?null:this.f.slice(T+1,this.d+1);return this.d=T,B}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const q=this.f[this.c];return this.c++,q}removeLast(){const q=this.f[this.d];return this.d--,q}takeCount(q){const T=this.f.slice(this.c,this.c+q);return this.c+=q,T}}t.$Uf=pe;class ne{constructor(q){this.iterate=q}forEach(q){this.iterate(T=>(q(T),!0))}toArray(){const q=[];return this.iterate(T=>(q.push(T),!0)),q}filter(q){return new ne(T=>this.iterate(B=>q(B)?T(B):!0))}map(q){return new ne(T=>this.iterate(B=>T(q(B))))}some(q){let T=!1;return this.iterate(B=>(T=q(B),!T)),T}findFirst(q){let T;return this.iterate(B=>q(B)?(T=B,!1):!0),T}findLast(q){let T;return this.iterate(B=>(q(B)&&(T=B),!0)),T}findLastMaxBy(q){let T,B=!0;return this.iterate(O=>((B||ie.isGreaterThan(q(O,T)))&&(B=!1,T=O),!0)),T}}t.$Vf=ne,ne.empty=new ne(S=>{})}),re(le[10],ue([0,1,3]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zb=t.$yb=t.$xb=t.$wb=t.ok=void 0;function k(s,l){if(!s)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=k;function i(s,l="Unreachable"){throw new Error(l)}t.$wb=i;function o(s){if(!s)throw new y.$bb("Assertion Failed")}t.$xb=o;function v(s){if(!s()){debugger;s(),(0,y.$Y)(new y.$bb("Assertion Failed"))}}t.$yb=v;function u(s,l){let h=0;for(;h<s.length-1;){const R=s[h],f=s[h+1];if(!l(R,f))return!1;h++}return!0}t.$zb=u}),re(le[16],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function y(k){const i=this;let o=!1,v;return function(){return o||(o=!0,v=k.apply(i,arguments)),v}}t.$cb=y}),re(le[17],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(k){function i(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}k.is=i;const o=Object.freeze([]);function v(){return o}k.empty=v;function*u(g){yield g}k.single=u;function s(g){return i(g)?g:u(g)}k.wrap=s;function l(g){return g||o}k.from=l;function h(g){return!g||g[Symbol.iterator]().next().done===!0}k.isEmpty=h;function R(g){return g[Symbol.iterator]().next().value}k.first=R;function f(g,c){for(const r of g)if(c(r))return!0;return!1}k.some=f;function d(g,c){for(const r of g)if(c(r))return r}k.find=d;function*e(g,c){for(const r of g)c(r)&&(yield r)}k.filter=e;function*N(g,c){let r=0;for(const a of g)yield c(a,r++)}k.map=N;function*p(...g){for(const c of g)for(const r of c)yield r}k.concat=p;function A(g,c,r){let a=r;for(const E of g)a=c(a,E);return a}k.reduce=A;function*b(g,c,r=g.length){for(c<0&&(c+=g.length),r<0?r+=g.length:r>g.length&&(r=g.length);c<r;c++)yield g[c]}k.slice=b;function M(g,c=Number.POSITIVE_INFINITY){const r=[];if(c===0)return[r,g];const a=g[Symbol.iterator]();for(let E=0;E<c;E++){const m=a.next();if(m.done)return[r,k.empty()];r.push(m.value)}return[r,{[Symbol.iterator](){return a}}]}k.consume=M})(y||(t.Iterable=y={}))}),re(le[31],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nq=t.KeyMod=t.KeyCodeUtils=t.$mq=t.$lq=t.$kq=t.$jq=t.$iq=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(y||(t.KeyCode=y={}));var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(k||(t.ScanCode=k={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,p){this._keyCodeToStr[N]=p,this._strToKeyCode[p.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const o=new i,v=new i,u=new i;t.$iq=new Array(230),t.$jq={};const s=[],l=Object.create(null),h=Object.create(null);t.$kq={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>l[e]||0,toString:e=>s[e]||"None"},t.$lq=[],t.$mq=[];for(let e=0;e<=193;e++)t.$lq[e]=-1;for(let e=0;e<=132;e++)t.$mq[e]=-1;(function(){const e="",N=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],p=[],A=[];for(const b of N){const[M,g,c,r,a,E,m,L,w]=b;if(A[g]||(A[g]=!0,s[g]=c,l[c]=g,h[c.toLowerCase()]=g,M&&(t.$lq[g]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$mq[r]=g))),!p[r]){if(p[r]=!0,!a)throw new Error(`String representation missing for key code ${r} around scan code ${c}`);o.define(r,a),v.define(r,L||a),u.define(r,w||L||a)}E&&(t.$iq[E]=r),m&&(t.$jq[m]=r)}t.$mq[3]=46})();var R;(function(e){function N(c){return o.keyCodeToStr(c)}e.toString=N;function p(c){return o.strToKeyCode(c)}e.fromString=p;function A(c){return v.keyCodeToStr(c)}e.toUserSettingsUS=A;function b(c){return u.keyCodeToStr(c)}e.toUserSettingsGeneral=b;function M(c){return v.strToKeyCode(c)||u.strToKeyCode(c)}e.fromUserSettings=M;function g(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(c)}e.toElectronAccelerator=g})(R||(t.KeyCodeUtils=R={}));var f;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(f||(t.KeyMod=f={}));function d(e,N){const p=(N&65535)<<16>>>0;return(e|p)>>>0}t.$nq=d}),re(le[32],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class y{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=y}),re(le[7],ue([0,1,16,17]),function(x,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tb=t.$sb=t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;const i=!1;let o=null;function v(w){o=w}if(t.$db=v,i){const w="__is_disposable_tracked__";v(new class{trackDisposable($){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{$[w]||console.log(F)},3e3)}setParent($,F){if($&&$!==b.None)try{$[w]=!0}catch{}}markAsDisposed($){if($&&$!==b.None)try{$[w]=!0}catch{}}markAsSingleton($){}})}function u(w){return o?.trackDisposable(w),w}function s(w){o?.markAsDisposed(w)}function l(w,$){o?.setParent(w,$)}function h(w,$){if(o)for(const F of w)o.setParent(F,$)}function R(w){return o?.markAsSingleton(w),w}t.$eb=R;function f(w){return typeof w.dispose=="function"&&w.dispose.length===0}t.$fb=f;function d(w){if(k.Iterable.is(w)){const $=[];for(const F of w)if(F)try{F.dispose()}catch(I){$.push(I)}if($.length===1)throw $[0];if($.length>1)throw new AggregateError($,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}t.$gb=d;function e(w){for(const $ of w)f($)&&$.dispose();return[]}t.$hb=e;function N(...w){const $=p(()=>d(w));return h(w,$),$}t.$ib=N;function p(w){const $=u({dispose:(0,y.$cb)(()=>{s($),w()})});return $}t.$jb=p;class A{constructor(){this.f=new Set,this.g=!1,u(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add($){if(!$)return $;if($===this)throw new Error("Cannot register a disposable on itself!");return l($,this),this.g?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add($),$}}t.$kb=A,A.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this.q=new A,u(this),l(this.q,this)}dispose(){s(this),this.q.dispose()}B($){if($===this)throw new Error("Cannot register a disposable on itself!");return this.q.add($)}}t.$lb=b,b.None=Object.freeze({dispose(){}});class M{constructor(){this.b=!1,u(this)}get value(){return this.b?void 0:this.a}set value($){this.b||$===this.a||(this.a?.dispose(),$&&l($,this),this.a=$)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const $=this.a;return this.a=void 0,$&&l($,null),$}}t.$mb=M;class g{constructor($){this.b=$,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$nb=g;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set($){let F=$;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,s(this))},this}}t.$ob=c;class r{constructor(){this.a=new Map}acquire($,...F){let I=this.a.get($);I||(I={counter:0,object:this.b($,...F)},this.a.set($,I));const{object:P}=I,U=(0,y.$cb)(()=>{--I.counter===0&&(this.c($,I.object),this.a.delete($))});return I.counter++,{object:P,dispose:U}}}t.$pb=r;class a{constructor($){this.a=$}async acquire($,...F){const I=this.a.acquire($,...F);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(P){throw I.dispose(),P}}}t.$qb=a;class E{constructor($){this.object=$}dispose(){}}t.$rb=E;function m(w){const $=new A;try{w($)}finally{$.dispose()}}t.$sb=m;class L{constructor(){this.a=new Map,this.b=!1,u(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has($){return this.a.has($)}get($){return this.a.get($)}set($,F,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get($)?.dispose(),this.a.set($,F)}deleteAndDispose($){this.a.get($)?.dispose(),this.a.delete($)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$tb=L}),re(le[18],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ub=void 0;class y{constructor(o){this.element=o,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class k{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let o=this.a;for(;o!==y.Undefined;){const v=o.next;o.prev=y.Undefined,o.next=y.Undefined,o=v}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,v){const u=new y(o);if(this.a===y.Undefined)this.a=u,this.b=u;else if(v){const l=this.b;this.b=u,u.prev=l,l.next=u}else{const l=this.a;this.a=u,u.next=l,l.prev=u}this.c+=1;let s=!1;return()=>{s||(s=!0,this.e(u))}}shift(){if(this.a!==y.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==y.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==y.Undefined&&o.next!==y.Undefined){const v=o.prev;v.next=o.next,o.next.prev=v}else o.prev===y.Undefined&&o.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):o.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):o.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==y.Undefined;)yield o.element,o=o.next}}t.$ub=k}),re(le[11],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$C=t.$B=t.$A=t.$z=t.$y=t.$x=t.OS=t.OperatingSystem=t.$v=t.$u=t.$t=t.$s=t.$r=t.Language=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.$g=t.$f=t.$e=t.$d=t.$c=t.Platform=t.$b=t.$a=void 0,t.$a="en";let y=!1,k=!1,i=!1,o=!1,v=!1,u=!1,s=!1,l=!1,h=!1,R=!1,f,d=t.$a,e=t.$a,N,p;t.$b=typeof self=="object"?self:typeof global=="object"?global:{};let A;typeof t.$b.vscode<"u"&&typeof t.$b.vscode.process<"u"?A=t.$b.vscode.process:typeof process<"u"&&(A=process);const b=typeof A?.versions?.electron=="string",M=b&&A?.type==="renderer";if(typeof navigator=="object"&&!M){p=navigator.userAgent,y=p.indexOf("Windows")>=0,k=p.indexOf("Macintosh")>=0,l=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,i=p.indexOf("Linux")>=0,R=p?.indexOf("Mobi")>=0,u=!0,f=t.$a,d=f,e=navigator.language;const $=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),F=$&&$.getAttribute("data-settings");if(F)try{const I=JSON.parse(F),P=I.availableLanguages["*"];f=I.locale,e=I.osLocale,d=P||t.$a,N=I._translationsConfigFile}catch{}}else if(typeof A=="object"){y=A.platform==="win32",k=A.platform==="darwin",i=A.platform==="linux",o=i&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,s=b,h=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t.$a,d=t.$a;const $=A.env.VSCODE_NLS_CONFIG;if($)try{const F=JSON.parse($),I=F.availableLanguages["*"];f=F.locale,e=F.osLocale,d=I||t.$a,N=F._translationsConfigFile}catch{}v=!0}else console.error("Unable to resolve platform.");var g;(function($){$[$.Web=0]="Web",$[$.Mac=1]="Mac",$[$.Linux=2]="Linux",$[$.Windows=3]="Windows"})(g||(t.Platform=g={}));function c($){switch($){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$c=c;let r=0;k?r=1:y?r=3:i&&(r=2),t.$d=y,t.$e=k,t.$f=i,t.$g=o,t.$h=v,t.$i=s,t.$j=u,t.$k=u&&typeof t.$b.importScripts=="function",t.$l=l,t.$m=R,t.$n=h,t.$o=r,t.$p=p,t.$q=d;var a;(function($){function F(){return t.$q}$.value=F;function I(){return t.$q.length===2?t.$q==="en":t.$q.length>=3?t.$q[0]==="e"&&t.$q[1]==="n"&&t.$q[2]==="-":!1}$.isDefaultVariant=I;function P(){return t.$q==="en"}$.isDefault=P})(a||(t.Language=a={})),t.$r=f,t.$s=e,t.$t=N,t.$u=typeof t.$b.postMessage=="function"&&!t.$b.importScripts,t.$v=(()=>{if(t.$u){const $=[];t.$b.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let P=0,U=$.length;P<U;P++){const C=$[P];if(C.id===I.data.vscodeScheduleAsyncWork){$.splice(P,1),C.callback();return}}});let F=0;return I=>{const P=++F;$.push({id:P,callback:I}),t.$b.postMessage({vscodeScheduleAsyncWork:P},"*")}}return $=>setTimeout($)})();var E;(function($){$[$.Windows=1]="Windows",$[$.Macintosh=2]="Macintosh",$[$.Linux=3]="Linux"})(E||(t.OperatingSystem=E={})),t.OS=k||l?2:y?1:3;let m=!0,L=!1;function w(){if(!L){L=!0;const $=new Uint8Array(2);$[0]=1,$[1]=2,m=new Uint16Array($.buffer)[0]===(2<<8)+1}return m}t.$x=w,t.$y=!!(t.$p&&t.$p.indexOf("Chrome")>=0),t.$z=!!(t.$p&&t.$p.indexOf("Firefox")>=0),t.$A=!!(!t.$y&&t.$p&&t.$p.indexOf("Safari")>=0),t.$B=!!(t.$p&&t.$p.indexOf("Edg/")>=0),t.$C=!!(t.$p&&t.$p.indexOf("Android")>=0)}),re(le[33],ue([0,1,11]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.env=t.cwd=void 0;let k;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.process<"u"){const i=y.$b.vscode.process;k={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return y.$d?"win32":y.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=k.cwd,t.env=k.env,t.$2c=k.platform,t.$3c=k.arch}),re(le[34],ue([0,1,33]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fd=t.sep=t.$dd=t.$cd=t.$bd=t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.$8c=t.$7c=t.$6c=t.$5c=t.$4c=void 0;const k=65,i=97,o=90,v=122,u=46,s=47,l=92,h=58,R=63;class f extends Error{constructor(a,E,m){let L;typeof E=="string"&&E.indexOf("not ")===0?(L="must not be",E=E.replace(/^not /,"")):L="must be";const w=a.indexOf(".")!==-1?"property":"argument";let $=`The "${a}" ${w} ${L} of type ${E}`;$+=`. Received type ${typeof m}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,a){if(r===null||typeof r!="object")throw new f(a,"Object",r)}function e(r,a){if(typeof r!="string")throw new f(a,"string",r)}const N=y.$2c==="win32";function p(r){return r===s||r===l}function A(r){return r===s}function b(r){return r>=k&&r<=o||r>=i&&r<=v}function M(r,a,E,m){let L="",w=0,$=-1,F=0,I=0;for(let P=0;P<=r.length;++P){if(P<r.length)I=r.charCodeAt(P);else{if(m(I))break;I=s}if(m(I)){if(!($===P-1||F===1))if(F===2){if(L.length<2||w!==2||L.charCodeAt(L.length-1)!==u||L.charCodeAt(L.length-2)!==u){if(L.length>2){const U=L.lastIndexOf(E);U===-1?(L="",w=0):(L=L.slice(0,U),w=L.length-1-L.lastIndexOf(E)),$=P,F=0;continue}else if(L.length!==0){L="",w=0,$=P,F=0;continue}}a&&(L+=L.length>0?`${E}..`:"..",w=2)}else L.length>0?L+=`${E}${r.slice($+1,P)}`:L=r.slice($+1,P),w=P-$-1;$=P,F=0}else I===u&&F!==-1?++F:F=-1}return L}function g(r,a){d(a,"pathObject");const E=a.dir||a.root,m=a.base||`${a.name||""}${a.ext||""}`;return E?E===a.root?`${E}${m}`:`${E}${r}${m}`:m}t.$4c={resolve(...r){let a="",E="",m=!1;for(let L=r.length-1;L>=-1;L--){let w;if(L>=0){if(w=r[L],e(w,"path"),w.length===0)continue}else a.length===0?w=y.cwd():(w=y.env[`=${a}`]||y.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==a.toLowerCase()&&w.charCodeAt(2)===l)&&(w=`${a}\\`));const $=w.length;let F=0,I="",P=!1;const U=w.charCodeAt(0);if($===1)p(U)&&(F=1,P=!0);else if(p(U))if(P=!0,p(w.charCodeAt(1))){let C=2,V=C;for(;C<$&&!p(w.charCodeAt(C));)C++;if(C<$&&C!==V){const X=w.slice(V,C);for(V=C;C<$&&p(w.charCodeAt(C));)C++;if(C<$&&C!==V){for(V=C;C<$&&!p(w.charCodeAt(C));)C++;(C===$||C!==V)&&(I=`\\\\${X}\\${w.slice(V,C)}`,F=C)}}}else F=1;else b(U)&&w.charCodeAt(1)===h&&(I=w.slice(0,2),F=2,$>2&&p(w.charCodeAt(2))&&(P=!0,F=3));if(I.length>0)if(a.length>0){if(I.toLowerCase()!==a.toLowerCase())continue}else a=I;if(m){if(a.length>0)break}else if(E=`${w.slice(F)}\\${E}`,m=P,P&&a.length>0)break}return E=M(E,!m,"\\",p),m?`${a}\\${E}`:`${a}${E}`||"."},normalize(r){e(r,"path");const a=r.length;if(a===0)return".";let E=0,m,L=!1;const w=r.charCodeAt(0);if(a===1)return A(w)?"\\":r;if(p(w))if(L=!0,p(r.charCodeAt(1))){let F=2,I=F;for(;F<a&&!p(r.charCodeAt(F));)F++;if(F<a&&F!==I){const P=r.slice(I,F);for(I=F;F<a&&p(r.charCodeAt(F));)F++;if(F<a&&F!==I){for(I=F;F<a&&!p(r.charCodeAt(F));)F++;if(F===a)return`\\\\${P}\\${r.slice(I)}\\`;F!==I&&(m=`\\\\${P}\\${r.slice(I,F)}`,E=F)}}}else E=1;else b(w)&&r.charCodeAt(1)===h&&(m=r.slice(0,2),E=2,a>2&&p(r.charCodeAt(2))&&(L=!0,E=3));let $=E<a?M(r.slice(E),!L,"\\",p):"";return $.length===0&&!L&&($="."),$.length>0&&p(r.charCodeAt(a-1))&&($+="\\"),m===void 0?L?`\\${$}`:$:L?`${m}\\${$}`:`${m}${$}`},isAbsolute(r){e(r,"path");const a=r.length;if(a===0)return!1;const E=r.charCodeAt(0);return p(E)||a>2&&b(E)&&r.charCodeAt(1)===h&&p(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let a,E;for(let w=0;w<r.length;++w){const $=r[w];e($,"path"),$.length>0&&(a===void 0?a=E=$:a+=`\\${$}`)}if(a===void 0)return".";let m=!0,L=0;if(typeof E=="string"&&p(E.charCodeAt(0))){++L;const w=E.length;w>1&&p(E.charCodeAt(1))&&(++L,w>2&&(p(E.charCodeAt(2))?++L:m=!1))}if(m){for(;L<a.length&&p(a.charCodeAt(L));)L++;L>=2&&(a=`\\${a.slice(L)}`)}return t.$4c.normalize(a)},relative(r,a){if(e(r,"from"),e(a,"to"),r===a)return"";const E=t.$4c.resolve(r),m=t.$4c.resolve(a);if(E===m||(r=E.toLowerCase(),a=m.toLowerCase(),r===a))return"";let L=0;for(;L<r.length&&r.charCodeAt(L)===l;)L++;let w=r.length;for(;w-1>L&&r.charCodeAt(w-1)===l;)w--;const $=w-L;let F=0;for(;F<a.length&&a.charCodeAt(F)===l;)F++;let I=a.length;for(;I-1>F&&a.charCodeAt(I-1)===l;)I--;const P=I-F,U=$<P?$:P;let C=-1,V=0;for(;V<U;V++){const _=r.charCodeAt(L+V);if(_!==a.charCodeAt(F+V))break;_===l&&(C=V)}if(V!==U){if(C===-1)return m}else{if(P>U){if(a.charCodeAt(F+V)===l)return m.slice(F+V+1);if(V===2)return m.slice(F+V)}$>U&&(r.charCodeAt(L+V)===l?C=V:V===2&&(C=3)),C===-1&&(C=0)}let X="";for(V=L+C+1;V<=w;++V)(V===w||r.charCodeAt(V)===l)&&(X+=X.length===0?"..":"\\..");return F+=C,X.length>0?`${X}${m.slice(F,I)}`:(m.charCodeAt(F)===l&&++F,m.slice(F,I))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const a=t.$4c.resolve(r);if(a.length<=2)return r;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const E=a.charCodeAt(2);if(E!==R&&E!==u)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(b(a.charCodeAt(0))&&a.charCodeAt(1)===h&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return r},dirname(r){e(r,"path");const a=r.length;if(a===0)return".";let E=-1,m=0;const L=r.charCodeAt(0);if(a===1)return p(L)?r:".";if(p(L)){if(E=m=1,p(r.charCodeAt(1))){let F=2,I=F;for(;F<a&&!p(r.charCodeAt(F));)F++;if(F<a&&F!==I){for(I=F;F<a&&p(r.charCodeAt(F));)F++;if(F<a&&F!==I){for(I=F;F<a&&!p(r.charCodeAt(F));)F++;if(F===a)return r;F!==I&&(E=m=F+1)}}}}else b(L)&&r.charCodeAt(1)===h&&(E=a>2&&p(r.charCodeAt(2))?3:2,m=E);let w=-1,$=!0;for(let F=a-1;F>=m;--F)if(p(r.charCodeAt(F))){if(!$){w=F;break}}else $=!1;if(w===-1){if(E===-1)return".";w=E}return r.slice(0,w)},basename(r,a){a!==void 0&&e(a,"ext"),e(r,"path");let E=0,m=-1,L=!0,w;if(r.length>=2&&b(r.charCodeAt(0))&&r.charCodeAt(1)===h&&(E=2),a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let $=a.length-1,F=-1;for(w=r.length-1;w>=E;--w){const I=r.charCodeAt(w);if(p(I)){if(!L){E=w+1;break}}else F===-1&&(L=!1,F=w+1),$>=0&&(I===a.charCodeAt($)?--$===-1&&(m=w):($=-1,m=F))}return E===m?m=F:m===-1&&(m=r.length),r.slice(E,m)}for(w=r.length-1;w>=E;--w)if(p(r.charCodeAt(w))){if(!L){E=w+1;break}}else m===-1&&(L=!1,m=w+1);return m===-1?"":r.slice(E,m)},extname(r){e(r,"path");let a=0,E=-1,m=0,L=-1,w=!0,$=0;r.length>=2&&r.charCodeAt(1)===h&&b(r.charCodeAt(0))&&(a=m=2);for(let F=r.length-1;F>=a;--F){const I=r.charCodeAt(F);if(p(I)){if(!w){m=F+1;break}continue}L===-1&&(w=!1,L=F+1),I===u?E===-1?E=F:$!==1&&($=1):E!==-1&&($=-1)}return E===-1||L===-1||$===0||$===1&&E===L-1&&E===m+1?"":r.slice(E,L)},format:g.bind(null,"\\"),parse(r){e(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const E=r.length;let m=0,L=r.charCodeAt(0);if(E===1)return p(L)?(a.root=a.dir=r,a):(a.base=a.name=r,a);if(p(L)){if(m=1,p(r.charCodeAt(1))){let C=2,V=C;for(;C<E&&!p(r.charCodeAt(C));)C++;if(C<E&&C!==V){for(V=C;C<E&&p(r.charCodeAt(C));)C++;if(C<E&&C!==V){for(V=C;C<E&&!p(r.charCodeAt(C));)C++;C===E?m=C:C!==V&&(m=C+1)}}}}else if(b(L)&&r.charCodeAt(1)===h){if(E<=2)return a.root=a.dir=r,a;if(m=2,p(r.charCodeAt(2))){if(E===3)return a.root=a.dir=r,a;m=3}}m>0&&(a.root=r.slice(0,m));let w=-1,$=m,F=-1,I=!0,P=r.length-1,U=0;for(;P>=m;--P){if(L=r.charCodeAt(P),p(L)){if(!I){$=P+1;break}continue}F===-1&&(I=!1,F=P+1),L===u?w===-1?w=P:U!==1&&(U=1):w!==-1&&(U=-1)}return F!==-1&&(w===-1||U===0||U===1&&w===F-1&&w===$+1?a.base=a.name=r.slice($,F):(a.name=r.slice($,w),a.base=r.slice($,F),a.ext=r.slice(w,F))),$>0&&$!==m?a.dir=r.slice(0,$-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(N){const r=/\\/g;return()=>{const a=y.cwd().replace(r,"/");return a.slice(a.indexOf("/"))}}return()=>y.cwd()})();t.$5c={resolve(...r){let a="",E=!1;for(let m=r.length-1;m>=-1&&!E;m--){const L=m>=0?r[m]:c();e(L,"path"),L.length!==0&&(a=`${L}/${a}`,E=L.charCodeAt(0)===s)}return a=M(a,!E,"/",A),E?`/${a}`:a.length>0?a:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===s,E=r.charCodeAt(r.length-1)===s;return r=M(r,!a,"/",A),r.length===0?a?"/":E?"./":".":(E&&(r+="/"),a?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===s},join(...r){if(r.length===0)return".";let a;for(let E=0;E<r.length;++E){const m=r[E];e(m,"path"),m.length>0&&(a===void 0?a=m:a+=`/${m}`)}return a===void 0?".":t.$5c.normalize(a)},relative(r,a){if(e(r,"from"),e(a,"to"),r===a||(r=t.$5c.resolve(r),a=t.$5c.resolve(a),r===a))return"";const E=1,m=r.length,L=m-E,w=1,$=a.length-w,F=L<$?L:$;let I=-1,P=0;for(;P<F;P++){const C=r.charCodeAt(E+P);if(C!==a.charCodeAt(w+P))break;C===s&&(I=P)}if(P===F)if($>F){if(a.charCodeAt(w+P)===s)return a.slice(w+P+1);if(P===0)return a.slice(w+P)}else L>F&&(r.charCodeAt(E+P)===s?I=P:P===0&&(I=0));let U="";for(P=E+I+1;P<=m;++P)(P===m||r.charCodeAt(P)===s)&&(U+=U.length===0?"..":"/..");return`${U}${a.slice(w+I)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===s;let E=-1,m=!0;for(let L=r.length-1;L>=1;--L)if(r.charCodeAt(L)===s){if(!m){E=L;break}}else m=!1;return E===-1?a?"/":".":a&&E===1?"//":r.slice(0,E)},basename(r,a){a!==void 0&&e(a,"ext"),e(r,"path");let E=0,m=-1,L=!0,w;if(a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let $=a.length-1,F=-1;for(w=r.length-1;w>=0;--w){const I=r.charCodeAt(w);if(I===s){if(!L){E=w+1;break}}else F===-1&&(L=!1,F=w+1),$>=0&&(I===a.charCodeAt($)?--$===-1&&(m=w):($=-1,m=F))}return E===m?m=F:m===-1&&(m=r.length),r.slice(E,m)}for(w=r.length-1;w>=0;--w)if(r.charCodeAt(w)===s){if(!L){E=w+1;break}}else m===-1&&(L=!1,m=w+1);return m===-1?"":r.slice(E,m)},extname(r){e(r,"path");let a=-1,E=0,m=-1,L=!0,w=0;for(let $=r.length-1;$>=0;--$){const F=r.charCodeAt($);if(F===s){if(!L){E=$+1;break}continue}m===-1&&(L=!1,m=$+1),F===u?a===-1?a=$:w!==1&&(w=1):a!==-1&&(w=-1)}return a===-1||m===-1||w===0||w===1&&a===m-1&&a===E+1?"":r.slice(a,m)},format:g.bind(null,"/"),parse(r){e(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const E=r.charCodeAt(0)===s;let m;E?(a.root="/",m=1):m=0;let L=-1,w=0,$=-1,F=!0,I=r.length-1,P=0;for(;I>=m;--I){const U=r.charCodeAt(I);if(U===s){if(!F){w=I+1;break}continue}$===-1&&(F=!1,$=I+1),U===u?L===-1?L=I:P!==1&&(P=1):L!==-1&&(P=-1)}if($!==-1){const U=w===0&&E?1:w;L===-1||P===0||P===1&&L===$-1&&L===w+1?a.base=a.name=r.slice(U,$):(a.name=r.slice(U,L),a.base=r.slice(U,$),a.ext=r.slice(L,$))}return w>0?a.dir=r.slice(0,w-1):E&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.$5c.win32=t.$4c.win32=t.$4c,t.$5c.posix=t.$4c.posix=t.$5c,t.$6c=N?t.$4c.normalize:t.$5c.normalize,t.$7c=N?t.$4c.isAbsolute:t.$5c.isAbsolute,t.$8c=N?t.$4c.join:t.$5c.join,t.$9c=N?t.$4c.resolve:t.$5c.resolve,t.$0c=N?t.$4c.relative:t.$5c.relative,t.$$c=N?t.$4c.dirname:t.$5c.dirname,t.$_c=N?t.$4c.basename:t.$5c.basename,t.$ad=N?t.$4c.extname:t.$5c.extname,t.$bd=N?t.$4c.format:t.$5c.format,t.$cd=N?t.$4c.parse:t.$5c.parse,t.$dd=N?t.$4c.toNamespacedPath:t.$5c.toNamespacedPath,t.sep=N?t.$4c.sep:t.$5c.sep,t.$fd=N?t.$4c.delimiter:t.$5c.delimiter}),re(le[19],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class k{static create(o){return new k(o)}constructor(o){this.c=y&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ac=k}),re(le[8],ue([0,1,3,16,7,18,19]),function(x,t,y,k,i,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=t.$cc=t.Event=void 0;const u=!1,s=!1;var l;(function(I){I.None=()=>i.$lb.None;function P(ne){if(s){const{onDidAddListener:S}=ne,q=e.create();let T=0;ne.onDidAddListener=()=>{++T===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),q.print()),S?.()}}}function U(ne,S){return n(ne,()=>{},0,void 0,!0,void 0,S)}I.defer=U;function C(ne){return(S,q=null,T)=>{let B=!1,O;return O=ne(Q=>{if(!B)return O?O.dispose():B=!0,S.call(q,Q)},null,T),B&&O.dispose(),O}}I.once=C;function V(ne,S,q){return ge((T,B=null,O)=>ne(Q=>T.call(B,S(Q)),null,O),q)}I.map=V;function X(ne,S,q){return ge((T,B=null,O)=>ne(Q=>{S(Q),T.call(B,Q)},null,O),q)}I.forEach=X;function _(ne,S,q){return ge((T,B=null,O)=>ne(Q=>S(Q)&&T.call(B,Q),null,O),q)}I.filter=_;function z(ne){return ne}I.signal=z;function Z(...ne){return(S,q=null,T)=>(0,i.$ib)(...ne.map(B=>B(O=>S.call(q,O),null,T)))}I.any=Z;function J(ne,S,q,T){let B=q;return V(ne,O=>(B=S(B,O),B),T)}I.reduce=J;function ge(ne,S){let q;const T={onWillAddFirstListener(){q=ne(B.fire,B)},onDidRemoveLastListener(){q?.dispose()}};S||P(T);const B=new M(T);return S?.add(B),B.event}function n(ne,S,q=100,T=!1,B=!1,O,Q){let te,ce,he,me=0,$e;const ke={leakWarningThreshold:O,onWillAddFirstListener(){te=ne(qe=>{me++,ce=S(ce,qe),T&&!he&&(ye.fire(ce),ce=void 0),$e=()=>{const Ue=ce;ce=void 0,he=void 0,(!T||me>1)&&ye.fire(Ue),me=0},typeof q=="number"?(clearTimeout(he),he=setTimeout($e,q)):he===void 0&&(he=0,queueMicrotask($e))})},onWillRemoveListener(){B&&me>0&&$e?.()},onDidRemoveLastListener(){$e=void 0,te.dispose()}};Q||P(ke);const ye=new M(ke);return Q?.add(ye),ye.event}I.debounce=n;function j(ne,S=0,q){return I.debounce(ne,(T,B)=>T?(T.push(B),T):[B],S,void 0,!0,void 0,q)}I.accumulate=j;function H(ne,S=(T,B)=>T===B,q){let T=!0,B;return _(ne,O=>{const Q=T||!S(O,B);return T=!1,B=O,Q},q)}I.latch=H;function K(ne,S,q){return[I.filter(ne,S,q),I.filter(ne,T=>!S(T),q)]}I.split=K;function G(ne,S=!1,q=[]){let T=q.slice(),B=ne(te=>{T?T.push(te):Q.fire(te)});const O=()=>{T?.forEach(te=>Q.fire(te)),T=null},Q=new M({onWillAddFirstListener(){B||(B=ne(te=>Q.fire(te)))},onDidAddFirstListener(){T&&(S?setTimeout(O):O())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return Q.event}I.buffer=G;class ie{constructor(S){this.event=S,this.d=new i.$kb}map(S){return new ie(V(this.event,S,this.d))}forEach(S){return new ie(X(this.event,S,this.d))}filter(S){return new ie(_(this.event,S,this.d))}reduce(S,q){return new ie(J(this.event,S,q,this.d))}latch(){return new ie(H(this.event,void 0,this.d))}debounce(S,q=100,T=!1,B=!1,O){return new ie(n(this.event,S,q,T,B,O,this.d))}on(S,q,T){return this.event(S,q,T)}once(S,q,T){return C(this.event)(S,q,T)}dispose(){this.d.dispose()}}function ae(ne){return new ie(ne)}I.chain=ae;function oe(ne,S,q=T=>T){const T=(...te)=>Q.fire(q(...te)),B=()=>ne.on(S,T),O=()=>ne.removeListener(S,T),Q=new M({onWillAddFirstListener:B,onDidRemoveLastListener:O});return Q.event}I.fromNodeEventEmitter=oe;function fe(ne,S,q=T=>T){const T=(...te)=>Q.fire(q(...te)),B=()=>ne.addEventListener(S,T),O=()=>ne.removeEventListener(S,T),Q=new M({onWillAddFirstListener:B,onDidRemoveLastListener:O});return Q.event}I.fromDOMEventEmitter=fe;function be(ne){return new Promise(S=>C(ne)(S))}I.toPromise=be;function ve(ne){const S=new M;return ne.then(q=>{S.fire(q)},()=>{S.fire(void 0)}).finally(()=>{S.dispose()}),S.event}I.fromPromise=ve;function we(ne,S){return S(void 0),ne(q=>S(q))}I.runAndSubscribe=we;function Me(ne,S){let q=null;function T(O){q?.dispose(),q=new i.$kb,S(O,q)}T(void 0);const B=ne(O=>T(O));return(0,i.$jb)(()=>{B.dispose(),q?.dispose()})}I.runAndSubscribeWithStore=Me;class Le{constructor(S,q){this._observable=S,this.d=0,this.f=!1;const T={onWillAddFirstListener:()=>{S.addObserver(this)},onDidRemoveLastListener:()=>{S.removeObserver(this)}};q||P(T),this.emitter=new M(T),q&&q.add(this.emitter)}beginUpdate(S){this.d++}handlePossibleChange(S){}handleChange(S,q){this.f=!0}endUpdate(S){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function Re(ne,S){return new Le(ne,S).emitter.event}I.fromObservable=Re;function pe(ne){return S=>{let q=0,T=!1;const B={beginUpdate(){q++},endUpdate(){q--,q===0&&(ne.reportChanges(),T&&(T=!1,S()))},handlePossibleChange(){},handleChange(){T=!0}};return ne.addObserver(B),ne.reportChanges(),{dispose(){ne.removeObserver(B)}}}}I.fromObservableLight=pe})(l||(t.Event=l={}));class h{constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${h.d++}`,h.all.add(this)}start(P){this.f=new v.$ac,this.listenerCount=P}stop(){if(this.f){const P=this.f.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.f=void 0}}}t.$cc=h,h.all=new Set,h.d=0;let R=-1;function f(I){const P=R;return R=I,{dispose(){R=P}}}t.$dc=f;class d{constructor(P,U=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=U,this.f=0}dispose(){this.d?.clear()}check(P,U){const C=this.threshold;if(C<=0||U<C)return;this.d||(this.d=new Map);const V=this.d.get(P.value)||0;if(this.d.set(P.value,V+1),this.f-=1,this.f<=0){this.f=C*.5;let X,_=0;for(const[z,Z]of this.d)(!X||_<Z)&&(X=z,_=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${U} listeners already. MOST frequent listener (${_}):`),console.warn(X)}return()=>{const X=this.d.get(P.value)||0;this.d.set(P.value,X-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let N=0;class p{constructor(P){this.value=P,this.id=N++}}const A=2,b=(I,P)=>{if(I instanceof p)P(I);else for(let U=0;U<I.length;U++){const C=I[U];C&&P(C)}};class M{constructor(P){this.u=0,this.d=P,this.f=R>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??R):void 0,this.g=this.d?._profName?new h(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(u){const P=this.q;queueMicrotask(()=>{b(P,U=>U.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??(this.m=(P,U,C)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$lb.None;if(this.j)return i.$lb.None;U&&(P=P.bind(U));const V=new p(P);let X,_;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(V.stack=e.create(),X=this.f.check(V.stack,this.u+1)),u&&(V.stack=_??e.create()),this.q?this.q instanceof p?(this.t??(this.t=new c),this.q=[this.q,V]):this.q.push(V):(this.d?.onWillAddFirstListener?.(this),this.q=V,this.d?.onDidAddFirstListener?.(this)),this.u++;const z=(0,i.$jb)(()=>{X?.(),this.v(V)});return C instanceof i.$kb?C.add(z):Array.isArray(C)&&C.push(z),z}),this.m}v(P){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const U=this.q,C=U.indexOf(P);if(C===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,U[C]=void 0;const V=this.t.current===this;if(this.u*A<=U.length){let X=0;for(let _=0;_<U.length;_++)U[_]?U[X++]=U[_]:V&&(this.t.end--,X<this.t.i&&this.t.i--);U.length=X}}w(P,U){if(!P)return;const C=this.d?.onListenerError||y.$Y;if(!C){P.value(U);return}try{P.value(U)}catch(V){C(V)}}x(P){const U=P.current.q;for(;P.i<P.end;)this.w(U[P.i++],P.value);P.reset()}fire(P){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof p)this.w(this.q,P);else{const U=this.t;U.enqueue(this,P,this.q.length),this.x(U)}this.g?.stop()}hasListeners(){return this.u>0}}t.$ec=M;const g=()=>new c;t.$fc=g;class c{constructor(){this.i=-1,this.end=0}enqueue(P,U,C){this.i=0,this.end=C,this.current=P,this.value=U}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends M{async fireAsync(P,U,C){if(this.q)for(this.h||(this.h=new o.$ub),b(this.q,V=>this.h.push([V.value,P]));this.h.size>0&&!U.isCancellationRequested;){const[V,X]=this.h.shift(),_=[],z={...X,token:U,waitUntil:Z=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");C&&(Z=C(Z,V)),_.push(Z)}};try{V(z)}catch(Z){(0,y.$Y)(Z);continue}Object.freeze(_),await Promise.allSettled(_).then(Z=>{for(const J of Z)J.status==="rejected"&&(0,y.$Y)(J.reason)})}}}t.$gc=r;class a extends M{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new o.$ub,this.y=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.y(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.u&&(this.h!==0?this.s.push(P):super.fire(P))}}t.$hc=a;class E extends a{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}t.$ic=E;class m extends M{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(U=>super.fire(U)),this.h=[]}))}}t.$jc=m;class L{constructor(){this.f=!1,this.g=[],this.d=new M({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(P){const U={event:P,listener:null};this.g.push(U),this.f&&this.k(U);const C=()=>{this.f&&this.m(U);const V=this.g.indexOf(U);this.g.splice(V,1)};return(0,i.$jb)((0,k.$cb)(C))}h(){this.f=!0,this.g.forEach(P=>this.k(P))}j(){this.f=!1,this.g.forEach(P=>this.m(P))}k(P){P.listener=P.event(U=>this.d.fire(U))}m(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.d.dispose()}}t.$kc=L;class w{constructor(P,U,C,V){this.d=new i.$kb;const X=this.d.add(new L),_=this.d.add(new i.$tb);function z(Z){_.set(Z,X.add(V(Z)))}for(const Z of P)z(Z);this.d.add(U(Z=>{z(Z)})),this.d.add(C(Z=>{_.deleteAndDispose(Z)})),this.event=X.event}dispose(){this.d.dispose()}}t.$lc=w;class ${constructor(){this.d=[]}wrapEvent(P){return(U,C,V)=>P(X=>{const _=this.d[this.d.length-1];_?_.push(()=>U.call(C,X)):U.call(C,X)},void 0,V)}bufferEvents(P){const U=[];this.d.push(U);const C=P();return this.d.pop(),U.forEach(V=>V()),C}}t.$mc=$;class F{constructor(){this.d=!1,this.f=l.None,this.g=i.$lb.None,this.h=new M({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(P){this.f=P,this.d&&(this.g.dispose(),this.g=P(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}t.$nc=F}),re(le[20],ue([0,1,8]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oc=t.CancellationToken=void 0;const k=Object.freeze(function(u,s){const l=setTimeout(u.bind(s),0);return{dispose(){clearTimeout(l)}}});var i;(function(u){function s(l){return l===u.None||l===u.Cancelled||l instanceof o?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}u.isCancellationToken=s,u.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),u.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(i||(t.CancellationToken=i={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?k:(this.b||(this.b=new y.$ec),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class v{constructor(s){this.a=void 0,this.b=void 0,this.b=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new o),this.a}cancel(){this.a?this.a instanceof o&&this.a.cancel():this.a=i.Cancelled}dispose(s=!1){s&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof o&&this.a.dispose():this.a=i.None}}t.$oc=v}),re(le[35],ue([0,1,20]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$id=t.$hd=t.$gd=void 0;class k{constructor(u){this.b=u,this.a=null}get(){if(this.a)return this.a;const u=new y.$oc,s=this.b(u.token);return this.a={promise:s,dispose:()=>{this.a=null,u.cancel(),u.dispose()}},this.a}}t.$gd=k;class i{constructor(u){this.c=u,this.a=void 0,this.b=void 0}get(u){const s=JSON.stringify(u);return this.b!==s&&(this.b=s,this.a=this.c(u)),this.a}}t.$hd=i;class o{get cachedValues(){return this.a}constructor(u){this.b=u,this.a=new Map}get(u){if(this.a.has(u))return this.a.get(u);const s=this.b(u);return this.a.set(u,s),s}}t.$id=o}),re(le[5],ue([0,1,35,32]),function(x,t,y,k){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.$he=t.$ge=t.$fe=t.$ee=t.GraphemeBreakType=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.$Id=t.$Hd=t.$Gd=t.$Fd=t.$Ed=t.$Dd=t.$Cd=t.$Bd=t.$Ad=t.$zd=t.$yd=t.$xd=t.$wd=t.$vd=t.$ud=t.$td=t.$sd=t.$rd=t.$qd=t.$pd=t.$od=t.$nd=t.$md=t.$ld=void 0;function o(D){return!D||typeof D!="string"?!0:D.trim().length===0}t.$ld=o;const v=/{(\d+)}/g;function u(D,...W){return W.length===0?D:D.replace(v,function(Y,ee){const se=parseInt(ee,10);return isNaN(se)||se<0||se>=W.length?Y:W[se]})}t.$md=u;const s=/{([^}]+)}/g;function l(D,W){return D.replace(s,(Y,ee)=>W[ee]??Y)}t.$nd=l;function h(D){return D.replace(/[<>&]/g,function(W){switch(W){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return W}})}t.$od=h;function R(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$pd=R;function f(D,W){let Y=0;const ee=W.charCodeAt(0);for(let se=D.length-1;se>=0;se--)D.charCodeAt(se)===ee&&Y++;return Y}t.$qd=f;function d(D,W,Y="\u2026"){return D.length<=W?D:`${D.substr(0,W)}${Y}`}t.$rd=d;function e(D,W=" "){const Y=N(D,W);return p(Y,W)}t.$sd=e;function N(D,W){if(!D||!W)return D;const Y=W.length;if(Y===0||D.length===0)return D;let ee=0;for(;D.indexOf(W,ee)===ee;)ee=ee+Y;return D.substring(ee)}t.$td=N;function p(D,W){if(!D||!W)return D;const Y=W.length,ee=D.length;if(Y===0||ee===0)return D;let se=ee,de=-1;for(;de=D.lastIndexOf(W,se-1),!(de===-1||de+Y!==se);){if(de===0)return"";se=de}return D.substring(0,se)}t.$ud=p;function A(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$vd=A;function b(D){return D.replace(/\*/g,"")}t.$wd=b;function M(D,W,Y={}){if(!D)throw new Error("Cannot create regex from empty string");W||(D=R(D)),Y.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let ee="";return Y.global&&(ee+="g"),Y.matchCase||(ee+="i"),Y.multiline&&(ee+="m"),Y.unicode&&(ee+="u"),new RegExp(D,ee)}t.$xd=M;function g(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}t.$yd=g;function c(D){return D.split(/\r\n|\r|\n/)}t.$zd=c;function r(D){for(let W=0,Y=D.length;W<Y;W++){const ee=D.charCodeAt(W);if(ee!==32&&ee!==9)return W}return-1}t.$Ad=r;function a(D,W=0,Y=D.length){for(let ee=W;ee<Y;ee++){const se=D.charCodeAt(ee);if(se!==32&&se!==9)return D.substring(W,ee)}return D.substring(W,Y)}t.$Bd=a;function E(D,W=D.length-1){for(let Y=W;Y>=0;Y--){const ee=D.charCodeAt(Y);if(ee!==32&&ee!==9)return Y}return-1}t.$Cd=E;function m(D,W,Y){const ee=[];let se=0;for(const de of D.matchAll(W)){if(ee.push(D.slice(se,de.index)),de.index===void 0)throw new Error("match.index should be defined");se=de.index+de[0].length,ee.push(Y(de[0],...de.slice(1),de.index,D,de.groups))}return ee.push(D.slice(se)),Promise.all(ee).then(de=>de.join(""))}t.$Dd=m;function L(D,W){return D<W?-1:D>W?1:0}t.$Ed=L;function w(D,W,Y=0,ee=D.length,se=0,de=W.length){for(;Y<ee&&se<de;Y++,se++){const Pe=D.charCodeAt(Y),Ne=W.charCodeAt(se);if(Pe<Ne)return-1;if(Pe>Ne)return 1}const Ee=ee-Y,De=de-se;return Ee<De?-1:Ee>De?1:0}t.$Fd=w;function $(D,W){return F(D,W,0,D.length,0,W.length)}t.$Gd=$;function F(D,W,Y=0,ee=D.length,se=0,de=W.length){for(;Y<ee&&se<de;Y++,se++){let Pe=D.charCodeAt(Y),Ne=W.charCodeAt(se);if(Pe===Ne)continue;if(Pe>=128||Ne>=128)return w(D.toLowerCase(),W.toLowerCase(),Y,ee,se,de);P(Pe)&&(Pe-=32),P(Ne)&&(Ne-=32);const Fe=Pe-Ne;if(Fe!==0)return Fe}const Ee=ee-Y,De=de-se;return Ee<De?-1:Ee>De?1:0}t.$Hd=F;function I(D){return D>=48&&D<=57}t.$Id=I;function P(D){return D>=97&&D<=122}t.$Jd=P;function U(D){return D>=65&&D<=90}t.$Kd=U;function C(D,W){return D.length===W.length&&F(D,W)===0}t.$Ld=C;function V(D,W){const Y=W.length;return W.length>D.length?!1:F(D,W,0,Y)===0}t.$Md=V;function X(D,W){const Y=Math.min(D.length,W.length);let ee;for(ee=0;ee<Y;ee++)if(D.charCodeAt(ee)!==W.charCodeAt(ee))return ee;return Y}t.$Nd=X;function _(D,W){const Y=Math.min(D.length,W.length);let ee;const se=D.length-1,de=W.length-1;for(ee=0;ee<Y;ee++)if(D.charCodeAt(se-ee)!==W.charCodeAt(de-ee))return ee;return Y}t.$Od=_;function z(D){return 55296<=D&&D<=56319}t.$Pd=z;function Z(D){return 56320<=D&&D<=57343}t.$Qd=Z;function J(D,W){return(D-55296<<10)+(W-56320)+65536}t.$Rd=J;function ge(D,W,Y){const ee=D.charCodeAt(Y);if(z(ee)&&Y+1<W){const se=D.charCodeAt(Y+1);if(Z(se))return J(ee,se)}return ee}t.$Sd=ge;function n(D,W){const Y=D.charCodeAt(W-1);if(Z(Y)&&W>1){const ee=D.charCodeAt(W-2);if(z(ee))return J(ee,Y)}return Y}class j{get offset(){return this.e}constructor(W,Y=0){this.c=W,this.d=W.length,this.e=Y}setOffset(W){this.e=W}prevCodePoint(){const W=n(this.c,this.e);return this.e-=W>=65536?2:1,W}nextCodePoint(){const W=ge(this.c,this.d,this.e);return this.e+=W>=65536?2:1,W}eol(){return this.e>=this.d}}t.$Td=j;class H{get offset(){return this.c.offset}constructor(W,Y=0){this.c=new j(W,Y)}nextGraphemeLength(){const W=ye.getInstance(),Y=this.c,ee=Y.offset;let se=W.getGraphemeBreakType(Y.nextCodePoint());for(;!Y.eol();){const de=Y.offset,Ee=W.getGraphemeBreakType(Y.nextCodePoint());if($e(se,Ee)){Y.setOffset(de);break}se=Ee}return Y.offset-ee}prevGraphemeLength(){const W=ye.getInstance(),Y=this.c,ee=Y.offset;let se=W.getGraphemeBreakType(Y.prevCodePoint());for(;Y.offset>0;){const de=Y.offset,Ee=W.getGraphemeBreakType(Y.prevCodePoint());if($e(Ee,se)){Y.setOffset(de);break}se=Ee}return ee-Y.offset}eol(){return this.c.eol()}}t.$Ud=H;function K(D,W){return new H(D,W).nextGraphemeLength()}t.$Vd=K;function G(D,W){return new H(D,W).prevGraphemeLength()}t.$Wd=G;function ie(D,W){W>0&&Z(D.charCodeAt(W))&&W--;const Y=W+K(D,W);return[Y-G(D,Y),Y]}t.$Xd=ie;function ae(D){const W=new H(D);let Y=0;for(;!W.eol();)Y++,W.nextGraphemeLength();return Y}t.$Yd=ae;let oe;function fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(D){return oe||(oe=fe()),oe.test(D)}t.$Zd=be;const ve=/^[\t\n\r\x20-\x7E]*$/;function we(D){return ve.test(D)}t.$1d=we,t.$2d=/[\u2028\u2029]/;function Me(D){return t.$2d.test(D)}t.$3d=Me;function Le(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}t.$4d=Le;function Re(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}t.$5d=Re;function pe(D,W){if(D.length<W)return D;const Y=/\b/g;let ee=0;for(;Y.test(D)&&!(D.length-Y.lastIndex<W);)ee=Y.lastIndex,Y.lastIndex+=1;return D.substring(ee).replace(/^\s/,"")}t.$6d=pe;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,S=/\x1b\].*?\x07/g;function q(D){return D&&(D=D.replace(ne,"").replace(S,"")),D}t.$7d=q,t.$8d=String.fromCharCode(65279);function T(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}t.$9d=T;function B(D){return T(D)?D.substr(1):D}t.$0d=B;function O(D,W){if(!D||!W||D.length<W.length)return!1;const Y=W.length,ee=D.toLowerCase();let se=0,de=-1;for(;se<Y;){const Ee=ee.indexOf(W[se],de+1);if(Ee<0)return!1;de=Ee,se++}return!0}t.$$d=O;function Q(D,W=!1){return D?(W&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}t.$_d=Q;function te(D){return D.charAt(0).toUpperCase()+D.slice(1)}t.$ae=te;function ce(D,W=1){if(W===0)return"";let Y=-1;do Y=D.indexOf(`
`,Y+1),W--;while(W>0&&Y>=0);return Y===-1?D:(D[Y-1]==="\r"&&Y--,D.substr(0,Y))}t.$be=ce;function he(D){return D=D%(2*26),D<26?String.fromCharCode(97+D):String.fromCharCode(65+D-26)}t.$ce=he;function me(D){return ye.getInstance().getGraphemeBreakType(D)}t.$de=me;function $e(D,W){return D===0?W!==5&&W!==7:D===2&&W===3?!1:D===4||D===2||D===3||W===4||W===2||W===3?!0:!(D===8&&(W===8||W===9||W===11||W===12)||(D===11||D===9)&&(W===9||W===10)||(D===12||D===10)&&W===10||W===5||W===13||W===7||D===1||D===13&&W===14||D===6&&W===6)}var ke;(function(D){D[D.Other=0]="Other",D[D.Prepend=1]="Prepend",D[D.CR=2]="CR",D[D.LF=3]="LF",D[D.Control=4]="Control",D[D.Extend=5]="Extend",D[D.Regional_Indicator=6]="Regional_Indicator",D[D.SpacingMark=7]="SpacingMark",D[D.L=8]="L",D[D.V=9]="V",D[D.T=10]="T",D[D.LV=11]="LV",D[D.LVT=12]="LVT",D[D.ZWJ=13]="ZWJ",D[D.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(t.GraphemeBreakType=ke={}));class ye{static getInstance(){return ye.c||(ye.c=new ye),ye.c}constructor(){this.d=qe()}getGraphemeBreakType(W){if(W<32)return W===10?3:W===13?2:4;if(W<127)return 0;const Y=this.d,ee=Y.length/3;let se=1;for(;se<=ee;)if(W<Y[3*se])se=2*se;else if(W>Y[3*se+1])se=2*se+1;else return Y[3*se+2];return 0}}ye.c=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(D,W){if(D===0)return 0;const Y=We(D,W);if(Y!==void 0)return Y;const ee=new j(W,D);return ee.prevCodePoint(),ee.offset}t.$ee=Ue;function We(D,W){const Y=new j(W,D);let ee=Y.prevCodePoint();for(;Ce(ee)||ee===65039||ee===8419;){if(Y.offset===0)return;ee=Y.prevCodePoint()}if(!Re(ee))return;let se=Y.offset;return se>0&&Y.prevCodePoint()===8205&&(se=Y.offset),se}function Ce(D){return 127995<=D&&D<=127999}var Oe;(function(D){D[D.zwj=8205]="zwj",D[D.emojiVariantSelector=65039]="emojiVariantSelector",D[D.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),t.$fe="\xA0";class Se{static getInstance(W){return i.d.get(Array.from(W))}static getLocales(){return i.e.value}constructor(W){this.f=W}isAmbiguous(W){return this.f.has(W)}getPrimaryConfusable(W){return this.f.get(W)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$ge=Se,i=Se,Se.c=new k.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Se.d=new y.$hd(D=>{function W(Ne){const Fe=new Map;for(let _e=0;_e<Ne.length;_e+=2)Fe.set(Ne[_e],Ne[_e+1]);return Fe}function Y(Ne,Fe){const _e=new Map(Ne);for(const[Ie,Be]of Fe)_e.set(Ie,Be);return _e}function ee(Ne,Fe){if(!Ne)return Fe;const _e=new Map;for(const[Ie,Be]of Ne)Fe.has(Ie)&&_e.set(Ie,Be);return _e}const se=i.c.value;let de=D.filter(Ne=>!Ne.startsWith("_")&&Ne in se);de.length===0&&(de=["_default"]);let Ee;for(const Ne of de){const Fe=W(se[Ne]);Ee=ee(Ee,Fe)}const De=W(se._common),Pe=Y(De,Ee);return new i(Pe)}),Se.e=new k.$T(()=>Object.keys(i.c.value).filter(D=>!D.startsWith("_")));class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(W){return Te.e().has(W)}static get codePoints(){return Te.e()}}t.$he=Te,Te.d=void 0}),re(le[36],ue([0,1,5]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ji=t.$ii=t.$hi=t.$gi=t.$fi=t.$ei=t.$di=void 0;function k(A){return i(A,0)}t.$di=k;function i(A,b){switch(typeof A){case"object":return A===null?o(349,b):Array.isArray(A)?s(A,b):l(A,b);case"string":return u(A,b);case"boolean":return v(A,b);case"number":return o(A,b);case"undefined":return o(937,b);default:return o(617,b)}}t.$ei=i;function o(A,b){return(b<<5)-b+A|0}t.$fi=o;function v(A,b){return o(A?433:863,b)}function u(A,b){b=o(149417,b);for(let M=0,g=A.length;M<g;M++)b=o(A.charCodeAt(M),b);return b}t.$gi=u;function s(A,b){return b=o(104579,b),A.reduce((M,g)=>i(g,M),b)}function l(A,b){return b=o(181387,b),Object.keys(A).sort().reduce((M,g)=>(M=u(g,M),i(A[g],M)),b)}class h{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=i(b,this.g),this.g}}t.$hi=h;var R;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function f(A,b,M=32){const g=M-b,c=~((1<<g)-1);return(A<<b|(c&A)>>>g)>>>0}function d(A,b=0,M=A.byteLength,g=0){for(let c=0;c<M;c++)A[b+c]=g}function e(A,b,M="0"){for(;A.length<b;)A=M+A;return A}function N(A,b=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(M=>M.toString(16).padStart(2,"0")).join(""):e((A>>>0).toString(16),b/4)}t.$ii=N;class p{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const M=b.length;if(M===0)return;const g=this.p;let c=this.r,r=this.u,a,E;for(r!==0?(a=r,E=-1,r=0):(a=b.charCodeAt(0),E=0);;){let m=a;if(y.$Pd(a))if(E+1<M){const L=b.charCodeAt(E+1);y.$Qd(L)?(E++,m=y.$Rd(a,L)):m=65533}else{r=a;break}else y.$Qd(a)&&(m=65533);if(c=this.w(g,c,m),E++,E<M)a=b.charCodeAt(E);else break}this.r=c,this.u=r}w(b,M,g){return g<128?b[M++]=g:g<2048?(b[M++]=192|(g&1984)>>>6,b[M++]=128|(g&63)>>>0):g<65536?(b[M++]=224|(g&61440)>>>12,b[M++]=128|(g&4032)>>>6,b[M++]=128|(g&63)>>>0):(b[M++]=240|(g&1835008)>>>18,b[M++]=128|(g&258048)>>>12,b[M++]=128|(g&4032)>>>6,b[M++]=128|(g&63)>>>0),M>=64&&(this.y(),M-=64,this.t+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),M}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=p.g,M=this.q;for(let $=0;$<64;$+=4)b.setUint32($,M.getUint32($,!1),!1);for(let $=64;$<320;$+=4)b.setUint32($,f(b.getUint32($-12,!1)^b.getUint32($-32,!1)^b.getUint32($-56,!1)^b.getUint32($-64,!1),1),!1);let g=this.h,c=this.l,r=this.m,a=this.n,E=this.o,m,L,w;for(let $=0;$<80;$++)$<20?(m=c&r|~c&a,L=1518500249):$<40?(m=c^r^a,L=1859775393):$<60?(m=c&r|c&a|r&a,L=2400959708):(m=c^r^a,L=3395469782),w=f(g,5)+m+E+L+b.getUint32($*4,!1)&4294967295,E=a,a=r,r=f(c,30),c=g,g=w;this.h=this.h+g&4294967295,this.l=this.l+c&4294967295,this.m=this.m+r&4294967295,this.n=this.n+a&4294967295,this.o=this.o+E&4294967295}}t.$ji=p,p.g=new DataView(new ArrayBuffer(320))}),re(le[21],ue([0,1,30,36]),function(x,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vu=t.$uu=t.$tu=void 0;class i{constructor(f){this.a=f}getElements(){const f=this.a,d=new Int32Array(f.length);for(let e=0,N=f.length;e<N;e++)d[e]=f.charCodeAt(e);return d}}t.$tu=i;function o(R,f,d){return new h(new i(R),new i(f)).ComputeDiff(d).changes}t.$uu=o;class v{static Assert(f,d){if(!f)throw new Error(d)}}class u{static Copy(f,d,e,N,p){for(let A=0;A<p;A++)e[N+A]=f[d+A]}static Copy2(f,d,e,N,p){for(let A=0;A<p;A++)e[N+A]=f[d+A]}}var s;(function(R){R[R.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(s||(s={}));class l{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new y.$su(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(f,d){this.b=Math.min(this.b,f),this.c=Math.min(this.c,d),this.d++}AddModifiedElement(f,d){this.b=Math.min(this.b,f),this.c=Math.min(this.c,d),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class h{constructor(f,d,e=null){this.a=e,this.b=f,this.c=d;const[N,p,A]=h.o(f),[b,M,g]=h.o(d);this.d=A&&g,this.e=N,this.f=p,this.g=b,this.h=M,this.k=[],this.m=[]}static n(f){return f.length>0&&typeof f[0]=="string"}static o(f){const d=f.getElements();if(h.n(d)){const e=new Int32Array(d.length);for(let N=0,p=d.length;N<p;N++)e[N]=(0,k.$gi)(d[N],0);return[d,e,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}p(f,d){return this.f[f]!==this.h[d]?!1:this.d?this.e[f]===this.g[d]:!0}q(f,d){if(!this.p(f,d))return!1;const e=h.r(this.b,f),N=h.r(this.c,d);return e===N}static r(f,d){return typeof f.getStrictElement=="function"?f.getStrictElement(d):null}s(f,d){return this.f[f]!==this.f[d]?!1:this.d?this.e[f]===this.e[d]:!0}u(f,d){return this.h[f]!==this.h[d]?!1:this.d?this.g[f]===this.g[d]:!0}ComputeDiff(f){return this.v(0,this.f.length-1,0,this.h.length-1,f)}v(f,d,e,N,p){const A=[!1];let b=this.w(f,d,e,N,A);return p&&(b=this.z(b)),{quitEarly:A[0],changes:b}}w(f,d,e,N,p){for(p[0]=!1;f<=d&&e<=N&&this.p(f,e);)f++,e++;for(;d>=f&&N>=e&&this.p(d,N);)d--,N--;if(f>d||e>N){let r;return e<=N?(v.Assert(f===d+1,"originalStart should only be one more than originalEnd"),r=[new y.$su(f,0,e,N-e+1)]):f<=d?(v.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[new y.$su(f,d-f+1,e,0)]):(v.Assert(f===d+1,"originalStart should only be one more than originalEnd"),v.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const A=[0],b=[0],M=this.y(f,d,e,N,A,b,p),g=A[0],c=b[0];if(M!==null)return M;if(!p[0]){const r=this.w(f,g,e,c,p);let a=[];return p[0]?a=[new y.$su(g+1,d-(g+1)+1,c+1,N-(c+1)+1)]:a=this.w(g+1,d,c+1,N,p),this.H(r,a)}return[new y.$su(f,d-f+1,e,N-e+1)]}x(f,d,e,N,p,A,b,M,g,c,r,a,E,m,L,w,$,F){let I=null,P=null,U=new l,C=d,V=e,X=E[0]-w[0]-N,_=-1073741824,z=this.k.length-1;do{const Z=X+f;Z===C||Z<V&&g[Z-1]<g[Z+1]?(r=g[Z+1],m=r-X-N,r<_&&U.MarkNextChange(),_=r,U.AddModifiedElement(r+1,m),X=Z+1-f):(r=g[Z-1]+1,m=r-X-N,r<_&&U.MarkNextChange(),_=r-1,U.AddOriginalElement(r,m+1),X=Z-1-f),z>=0&&(g=this.k[z],f=g[0],C=1,V=g.length-1)}while(--z>=-1);if(I=U.getReverseChanges(),F[0]){let Z=E[0]+1,J=w[0]+1;if(I!==null&&I.length>0){const ge=I[I.length-1];Z=Math.max(Z,ge.getOriginalEnd()),J=Math.max(J,ge.getModifiedEnd())}P=[new y.$su(Z,a-Z+1,J,L-J+1)]}else{U=new l,C=A,V=b,X=E[0]-w[0]-M,_=1073741824,z=$?this.m.length-1:this.m.length-2;do{const Z=X+p;Z===C||Z<V&&c[Z-1]>=c[Z+1]?(r=c[Z+1]-1,m=r-X-M,r>_&&U.MarkNextChange(),_=r+1,U.AddOriginalElement(r+1,m+1),X=Z+1-p):(r=c[Z-1],m=r-X-M,r>_&&U.MarkNextChange(),_=r,U.AddModifiedElement(r+1,m+1),X=Z-1-p),z>=0&&(c=this.m[z],p=c[0],C=1,V=c.length-1)}while(--z>=-1);P=U.getChanges()}return this.H(I,P)}y(f,d,e,N,p,A,b){let M=0,g=0,c=0,r=0,a=0,E=0;f--,e--,p[0]=0,A[0]=0,this.k=[],this.m=[];const m=d-f+(N-e),L=m+1,w=new Int32Array(L),$=new Int32Array(L),F=N-e,I=d-f,P=f-e,U=d-N,V=(I-F)%2===0;w[F]=f,$[I]=d,b[0]=!1;for(let X=1;X<=m/2+1;X++){let _=0,z=0;c=this.J(F-X,X,F,L),r=this.J(F+X,X,F,L);for(let J=c;J<=r;J+=2){J===c||J<r&&w[J-1]<w[J+1]?M=w[J+1]:M=w[J-1]+1,g=M-(J-F)-P;const ge=M;for(;M<d&&g<N&&this.p(M+1,g+1);)M++,g++;if(w[J]=M,M+g>_+z&&(_=M,z=g),!V&&Math.abs(J-I)<=X-1&&M>=$[J])return p[0]=M,A[0]=g,ge<=$[J]&&1447>0&&X<=1447+1?this.x(F,c,r,P,I,a,E,U,w,$,M,d,p,g,N,A,V,b):null}const Z=(_-f+(z-e)-X)/2;if(this.a!==null&&!this.a(_,Z))return b[0]=!0,p[0]=_,A[0]=z,Z>0&&1447>0&&X<=1447+1?this.x(F,c,r,P,I,a,E,U,w,$,M,d,p,g,N,A,V,b):(f++,e++,[new y.$su(f,d-f+1,e,N-e+1)]);a=this.J(I-X,X,I,L),E=this.J(I+X,X,I,L);for(let J=a;J<=E;J+=2){J===a||J<E&&$[J-1]>=$[J+1]?M=$[J+1]-1:M=$[J-1],g=M-(J-I)-U;const ge=M;for(;M>f&&g>e&&this.p(M,g);)M--,g--;if($[J]=M,V&&Math.abs(J-F)<=X&&M<=w[J])return p[0]=M,A[0]=g,ge>=w[J]&&1447>0&&X<=1447+1?this.x(F,c,r,P,I,a,E,U,w,$,M,d,p,g,N,A,V,b):null}if(X<=1447){let J=new Int32Array(r-c+2);J[0]=F-c+1,u.Copy2(w,c,J,1,r-c+1),this.k.push(J),J=new Int32Array(E-a+2),J[0]=I-a+1,u.Copy2($,a,J,1,E-a+1),this.m.push(J)}}return this.x(F,c,r,P,I,a,E,U,w,$,M,d,p,g,N,A,V,b)}z(f){for(let d=0;d<f.length;d++){const e=f[d],N=d<f.length-1?f[d+1].originalStart:this.f.length,p=d<f.length-1?f[d+1].modifiedStart:this.h.length,A=e.originalLength>0,b=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<p&&(!A||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!b||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const g=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!g)break;e.originalStart++,e.modifiedStart++}const M=[null];if(d<f.length-1&&this.I(f[d],f[d+1],M)){f[d]=M[0],f.splice(d+1,1),d--;continue}}for(let d=f.length-1;d>=0;d--){const e=f[d];let N=0,p=0;if(d>0){const r=f[d-1];N=r.originalStart+r.originalLength,p=r.modifiedStart+r.modifiedLength}const A=e.originalLength>0,b=e.modifiedLength>0;let M=0,g=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const a=e.originalStart-r,E=e.modifiedStart-r;if(a<N||E<p||A&&!this.s(a,a+e.originalLength)||b&&!this.u(E,E+e.modifiedLength))break;const L=(a===N&&E===p?5:0)+this.G(a,e.originalLength,E,e.modifiedLength);L>g&&(g=L,M=r)}e.originalStart-=M,e.modifiedStart-=M;const c=[null];if(d>0&&this.I(f[d-1],f[d],c)){f[d-1]=c[0],f.splice(d,1),d++;continue}}if(this.d)for(let d=1,e=f.length;d<e;d++){const N=f[d-1],p=f[d],A=p.originalStart-N.originalStart-N.originalLength,b=N.originalStart,M=p.originalStart+p.originalLength,g=M-b,c=N.modifiedStart,r=p.modifiedStart+p.modifiedLength,a=r-c;if(A<5&&g<20&&a<20){const E=this.A(b,g,c,a,A);if(E){const[m,L]=E;(m!==N.originalStart+N.originalLength||L!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=m-N.originalStart,N.modifiedLength=L-N.modifiedStart,p.originalStart=m+A,p.modifiedStart=L+A,p.originalLength=M-p.originalStart,p.modifiedLength=r-p.modifiedStart)}}}return f}A(f,d,e,N,p){if(d<p||N<p)return null;const A=f+d-p+1,b=e+N-p+1;let M=0,g=0,c=0;for(let r=f;r<A;r++)for(let a=e;a<b;a++){const E=this.B(r,a,p);E>0&&E>M&&(M=E,g=r,c=a)}return M>0?[g,c]:null}B(f,d,e){let N=0;for(let p=0;p<e;p++){if(!this.p(f+p,d+p))return 0;N+=this.e[f+p].length}return N}C(f){return f<=0||f>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[f])}D(f,d){if(this.C(f)||this.C(f-1))return!0;if(d>0){const e=f+d;if(this.C(e-1)||this.C(e))return!0}return!1}E(f){return f<=0||f>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[f])}F(f,d){if(this.E(f)||this.E(f-1))return!0;if(d>0){const e=f+d;if(this.E(e-1)||this.E(e))return!0}return!1}G(f,d,e,N){const p=this.D(f,d)?1:0,A=this.F(e,N)?1:0;return p+A}H(f,d){const e=[];if(f.length===0||d.length===0)return d.length>0?d:f;if(this.I(f[f.length-1],d[0],e)){const N=new Array(f.length+d.length-1);return u.Copy(f,0,N,0,f.length-1),N[f.length-1]=e[0],u.Copy(d,1,N,f.length,d.length-1),N}else{const N=new Array(f.length+d.length);return u.Copy(f,0,N,0,f.length),u.Copy(d,0,N,f.length,d.length),N}}I(f,d,e){if(v.Assert(f.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),v.Assert(f.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),f.originalStart+f.originalLength>=d.originalStart||f.modifiedStart+f.modifiedLength>=d.modifiedStart){const N=f.originalStart;let p=f.originalLength;const A=f.modifiedStart;let b=f.modifiedLength;return f.originalStart+f.originalLength>=d.originalStart&&(p=d.originalStart+d.originalLength-f.originalStart),f.modifiedStart+f.modifiedLength>=d.modifiedStart&&(b=d.modifiedStart+d.modifiedLength-f.modifiedStart),e[0]=new y.$su(N,p,A,b),!0}else return e[0]=null,!1}J(f,d,e,N){if(f>=0&&f<N)return f;const p=e,A=N-e-1,b=d%2===0;if(f<0){const M=p%2===0;return b===M?0:1}else{const M=A%2===0;return b===M?N-1:N-2}}}t.$vu=h}),re(le[22],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=void 0;function y(c){return typeof c=="string"}t.$ie=y;function k(c){return Array.isArray(c)&&c.every(r=>y(r))}t.$je=k;function i(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$ke=i;function o(c){const r=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof r}t.$le=o;function v(c){return typeof c=="number"&&!isNaN(c)}t.$me=v;function u(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$ne=u;function s(c){return c===!0||c===!1}t.$oe=s;function l(c){return typeof c>"u"}t.$pe=l;function h(c){return!R(c)}t.$qe=h;function R(c){return l(c)||c===null}t.$re=R;function f(c,r){if(!c)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}t.$se=f;function d(c){if(R(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$te=d;function e(...c){const r=[];for(let a=0;a<c.length;a++){const E=c[a];if(R(E))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);r.push(E)}return r}t.$ue=e;const N=Object.prototype.hasOwnProperty;function p(c){if(!i(c))return!1;for(const r in c)if(N.call(c,r))return!1;return!0}t.$ve=p;function A(c){return typeof c=="function"}t.$we=A;function b(...c){return c.length>0&&c.every(A)}t.$xe=b;function M(c,r){const a=Math.min(c.length,r.length);for(let E=0;E<a;E++)g(c[E],r[E])}t.$ye=M;function g(c,r){if(y(r)){if(typeof c!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(A(r)){try{if(c instanceof r)return}catch{}if(!R(c)&&c.constructor===r||r.length===1&&r.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$ze=g}),re(le[37],ue([0,1,22]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cj=t.$Bj=t.$Aj=void 0;const k=Object.create(null);function i(u,s){if((0,y.$ie)(s)){const l=k[s];if(l===void 0)throw new Error(`${u} references an unknown codicon: ${s}`);s=l}return k[u]=s,{id:u}}function o(){return k}t.$Aj=o;function v(){return Object.values(t.$Cj)}t.$Bj=v,t.$Cj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),re(le[12],ue([0,1,22]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Um=t.$Tm=t.$Sm=t.$Rm=t.$Qm=t.$Pm=t.$Om=t.$Nm=t.$Mm=t.$Lm=t.$Km=t.$Jm=void 0;function k(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const b=Array.isArray(A)?[]:{};return Object.entries(A).forEach(([M,g])=>{b[M]=g&&typeof g=="object"?k(g):g}),b}t.$Jm=k;function i(A){if(!A||typeof A!="object")return A;const b=[A];for(;b.length>0;){const M=b.shift();Object.freeze(M);for(const g in M)if(o.call(M,g)){const c=M[g];typeof c=="object"&&!Object.isFrozen(c)&&!(0,y.$le)(c)&&b.push(c)}}return A}t.$Km=i;const o=Object.prototype.hasOwnProperty;function v(A,b){return u(A,b,new Set)}t.$Lm=v;function u(A,b,M){if((0,y.$re)(A))return A;const g=b(A);if(typeof g<"u")return g;if(Array.isArray(A)){const c=[];for(const r of A)c.push(u(r,b,M));return c}if((0,y.$ke)(A)){if(M.has(A))throw new Error("Cannot clone recursive data-structure");M.add(A);const c={};for(const r in A)o.call(A,r)&&(c[r]=u(A[r],b,M));return M.delete(A),c}return A}function s(A,b,M=!0){return(0,y.$ke)(A)?((0,y.$ke)(b)&&Object.keys(b).forEach(g=>{g in A?M&&((0,y.$ke)(A[g])&&(0,y.$ke)(b[g])?s(A[g],b[g],M):A[g]=b[g]):A[g]=b[g]}),A):b}t.$Mm=s;function l(A,b){if(A===b)return!0;if(A==null||b===null||b===void 0||typeof A!=typeof b||typeof A!="object"||Array.isArray(A)!==Array.isArray(b))return!1;let M,g;if(Array.isArray(A)){if(A.length!==b.length)return!1;for(M=0;M<A.length;M++)if(!l(A[M],b[M]))return!1}else{const c=[];for(g in A)c.push(g);c.sort();const r=[];for(g in b)r.push(g);if(r.sort(),!l(c,r))return!1;for(M=0;M<c.length;M++)if(!l(A[c[M]],b[c[M]]))return!1}return!0}t.$Nm=l;function h(A){const b=new Set;return JSON.stringify(A,(M,g)=>{if((0,y.$ke)(g)||Array.isArray(g)){if(b.has(g))return"[Circular]";b.add(g)}return g})}t.$Om=h;function R(A,b){const M=Object.create(null);return!A||!b||Object.keys(b).forEach(c=>{const r=A[c],a=b[c];l(r,a)||(M[c]=a)}),M}t.$Pm=R;function f(A,b){const M=b.toLowerCase(),g=Object.keys(A).find(c=>c.toLowerCase()===M);return g?A[g]:A[b]}t.$Qm=f;function d(A,b){const M=Object.create(null);for(const[g,c]of Object.entries(A))b(g,c)&&(M[g]=c);return M}t.$Rm=d;function e(A){let b=[];for(;Object.prototype!==A;)b=b.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return b}t.$Sm=e;function N(A){const b=[];for(const M of e(A))typeof A[M]=="function"&&b.push(M);return b}t.$Tm=N;function p(A,b){const M=c=>function(){const r=Array.prototype.slice.call(arguments,0);return b(c,r)},g={};for(const c of A)g[c]=M(c);return g}t.$Um=p}),re(le[23],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kd=t.$jd=t.Constants=void 0;var y;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(y||(t.Constants=y={}));function k(o){return o<0?0:o>255?255:o|0}t.$jd=k;function i(o){return o<0?0:o>4294967295?4294967295:o|0}t.$kd=i}),re(le[13],ue([0,1,34,11]),function(x,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Se=t.$Re=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,o=/^\//,v=/^\/\//;function u(m,L){if(!m.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!i.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!o.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function s(m,L){return!m&&!L?"file":m}function l(m,L){switch(m){case"https":case"http":case"file":L?L[0]!==R&&(L=R+L):L=R;break}return L}const h="",R="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(L){return L instanceof d?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,w,$,F,I,P=!1){typeof L=="object"?(this.scheme=L.scheme||h,this.authority=L.authority||h,this.path=L.path||h,this.query=L.query||h,this.fragment=L.fragment||h):(this.scheme=s(L,P),this.authority=w||h,this.path=l(this.scheme,$||h),this.query=F||h,this.fragment=I||h,u(this,P))}get fsPath(){return g(this,!1)}with(L){if(!L)return this;let{scheme:w,authority:$,path:F,query:I,fragment:P}=L;return w===void 0?w=this.scheme:w===null&&(w=h),$===void 0?$=this.authority:$===null&&($=h),F===void 0?F=this.path:F===null&&(F=h),I===void 0?I=this.query:I===null&&(I=h),P===void 0?P=this.fragment:P===null&&(P=h),w===this.scheme&&$===this.authority&&F===this.path&&I===this.query&&P===this.fragment?this:new p(w,$,F,I,P)}static parse(L,w=!1){const $=f.exec(L);return $?new p($[2]||h,E($[4]||h),E($[5]||h),E($[7]||h),E($[9]||h),w):new p(h,h,h,h,h)}static file(L){let w=h;if(k.$d&&(L=L.replace(/\\/g,R)),L[0]===R&&L[1]===R){const $=L.indexOf(R,2);$===-1?(w=L.substring(2),L=R):(w=L.substring(2,$),L=L.substring($)||R)}return new p("file",w,L,h,h)}static from(L,w){return new p(L.scheme,L.authority,L.path,L.query,L.fragment,w)}static joinPath(L,...w){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return k.$d&&L.scheme==="file"?$=d.file(y.$4c.join(g(L,!0),...w)).path:$=y.$5c.join(L.path,...w),L.with({path:$})}toString(L=!1){return c(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof d)return L;{const w=new p(L);return w._formatted=L.external??null,w._fsPath=L._sep===N?L.fsPath??null:null,w}}else return L}}t.URI=d;function e(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}t.$Re=e;const N=k.$d?1:void 0;class p extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(L=!1){return L?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=N),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const A={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(m,L,w){let $,F=-1;for(let I=0;I<m.length;I++){const P=m.charCodeAt(I);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||L&&P===47||w&&P===91||w&&P===93||w&&P===58)F!==-1&&($+=encodeURIComponent(m.substring(F,I)),F=-1),$!==void 0&&($+=m.charAt(I));else{$===void 0&&($=m.substr(0,I));const U=A[P];U!==void 0?(F!==-1&&($+=encodeURIComponent(m.substring(F,I)),F=-1),$+=U):F===-1&&(F=I)}}return F!==-1&&($+=encodeURIComponent(m.substring(F))),$!==void 0?$:m}function M(m){let L;for(let w=0;w<m.length;w++){const $=m.charCodeAt(w);$===35||$===63?(L===void 0&&(L=m.substr(0,w)),L+=A[$]):L!==void 0&&(L+=m[w])}return L!==void 0?L:m}function g(m,L){let w;return m.authority&&m.path.length>1&&m.scheme==="file"?w=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?L?w=m.path.substr(1):w=m.path[1].toLowerCase()+m.path.substr(2):w=m.path,k.$d&&(w=w.replace(/\//g,"\\")),w}t.$Se=g;function c(m,L){const w=L?M:b;let $="",{scheme:F,authority:I,path:P,query:U,fragment:C}=m;if(F&&($+=F,$+=":"),(I||F==="file")&&($+=R,$+=R),I){let V=I.indexOf("@");if(V!==-1){const X=I.substr(0,V);I=I.substr(V+1),V=X.lastIndexOf(":"),V===-1?$+=w(X,!1,!1):($+=w(X.substr(0,V),!1,!1),$+=":",$+=w(X.substr(V+1),!1,!0)),$+="@"}I=I.toLowerCase(),V=I.lastIndexOf(":"),V===-1?$+=w(I,!1,!0):($+=w(I.substr(0,V),!1,!0),$+=I.substr(V))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const V=P.charCodeAt(1);V>=65&&V<=90&&(P=`/${String.fromCharCode(V+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const V=P.charCodeAt(0);V>=65&&V<=90&&(P=`${String.fromCharCode(V+32)}:${P.substr(2)}`)}$+=w(P,!0,!1)}return U&&($+="?",$+=w(U,!1,!1)),C&&($+="#",$+=L?C:b(C,!1,!1)),$}function r(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+r(m.substr(3)):m}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(m){return m.match(a)?m.replace(a,L=>r(L)):m}}),re(le[61],ue([0,1,3,8,7,12,11,5]),function(x,t,y,k,i,o,v,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const s="$initialize";let l=!1;function h(E){v.$j&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(E.message))}t.logOnceWebWorkerWarning=h;var R;(function(E){E[E.Request=0]="Request",E[E.Reply=1]="Reply",E[E.SubscribeEvent=2]="SubscribeEvent",E[E.Event=3]="Event",E[E.UnsubscribeEvent=4]="UnsubscribeEvent"})(R||(R={}));class f{constructor(m,L,w,$){this.vsWorker=m,this.req=L,this.method=w,this.args=$,this.type=0}}class d{constructor(m,L,w,$){this.vsWorker=m,this.seq=L,this.res=w,this.err=$,this.type=1}}class e{constructor(m,L,w,$){this.vsWorker=m,this.req=L,this.eventName=w,this.arg=$,this.type=2}}class N{constructor(m,L,w){this.vsWorker=m,this.req=L,this.event=w,this.type=3}}class p{constructor(m,L){this.vsWorker=m,this.req=L,this.type=4}}class A{constructor(m){this.a=-1,this.g=m,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(m){this.a=m}sendMessage(m,L){const w=String(++this.b);return new Promise(($,F)=>{this.c[w]={resolve:$,reject:F},this.o(new f(this.a,w,m,L))})}listen(m,L){let w=null;const $=new k.$ec({onWillAddFirstListener:()=>{w=String(++this.b),this.d.set(w,$),this.o(new e(this.a,w,m,L))},onDidRemoveLastListener:()=>{this.d.delete(w),this.o(new p(this.a,w)),w=null}});return $.event}handleMessage(m){!m||!m.vsWorker||this.a!==-1&&m.vsWorker!==this.a||this.h(m)}h(m){switch(m.type){case 1:return this.j(m);case 0:return this.k(m);case 2:return this.l(m);case 3:return this.m(m);case 4:return this.n(m)}}j(m){if(!this.c[m.seq]){console.warn("Got reply to unknown seq");return}const L=this.c[m.seq];if(delete this.c[m.seq],m.err){let w=m.err;m.err.$isError&&(w=new Error,w.name=m.err.name,w.message=m.err.message,w.stack=m.err.stack),L.reject(w);return}L.resolve(m.res)}k(m){const L=m.req;this.g.handleMessage(m.method,m.args).then($=>{this.o(new d(this.a,L,$,void 0))},$=>{$.detail instanceof Error&&($.detail=(0,y.$1)($.detail)),this.o(new d(this.a,L,void 0,(0,y.$1)($)))})}l(m){const L=m.req,w=this.g.handleEvent(m.eventName,m.arg)($=>{this.o(new N(this.a,L,$))});this.f.set(L,w)}m(m){if(!this.d.has(m.req)){console.warn("Got event for unknown req");return}this.d.get(m.req).fire(m.event)}n(m){if(!this.f.has(m.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(m.req).dispose(),this.f.delete(m.req)}o(m){const L=[];if(m.type===0)for(let w=0;w<m.args.length;w++)m.args[w]instanceof ArrayBuffer&&L.push(m.args[w]);else m.type===1&&m.res instanceof ArrayBuffer&&L.push(m.res);this.g.sendMessage(m,L)}}class b extends i.$lb{constructor(m,L,w){super();let $=null;this.a=this.B(m.create("vs/base/common/worker/simpleWorker",V=>{this.c.handleMessage(V)},V=>{$?.(V)})),this.c=new A({sendMessage:(V,X)=>{this.a.postMessage(V,X)},handleMessage:(V,X)=>{if(typeof w[V]!="function")return Promise.reject(new Error("Missing method "+V+" on main thread host."));try{return Promise.resolve(w[V].apply(w,X))}catch(_){return Promise.reject(_)}},handleEvent:(V,X)=>{if(g(V)){const _=w[V].call(w,X);if(typeof _!="function")throw new Error(`Missing dynamic event ${V} on main thread host.`);return _}if(M(V)){const _=w[V];if(typeof _!="function")throw new Error(`Missing event ${V} on main thread host.`);return _}throw new Error(`Malformed event name ${V}`)}}),this.c.setWorkerId(this.a.getId());let F=null;const I=globalThis.require;typeof I<"u"&&typeof I.getConfig=="function"?F=I.getConfig():typeof globalThis.requirejs<"u"&&(F=globalThis.requirejs.s.contexts._.config);const P=(0,o.$Tm)(w);this.b=this.c.sendMessage(s,[this.a.getId(),JSON.parse(JSON.stringify(F)),L,P]);const U=(V,X)=>this.g(V,X),C=(V,X)=>this.c.listen(V,X);this.f=new Promise((V,X)=>{$=X,this.b.then(_=>{V(c(_,U,C))},_=>{X(_),this.h("Worker failed to load "+L,_)})})}getProxyObject(){return this.f}g(m,L){return new Promise((w,$)=>{this.b.then(()=>{this.c.sendMessage(m,L).then(w,$)},$)})}h(m,L){console.error(m),console.info(L)}}t.SimpleWorkerClient=b;function M(E){return E[0]==="o"&&E[1]==="n"&&u.$Kd(E.charCodeAt(2))}function g(E){return/^onDynamic/.test(E)&&u.$Kd(E.charCodeAt(9))}function c(E,m,L){const w=I=>function(){const P=Array.prototype.slice.call(arguments,0);return m(I,P)},$=I=>function(P){return L(I,P)},F={};for(const I of E){if(g(I)){F[I]=$(I);continue}if(M(I)){F[I]=L(I,void 0);continue}F[I]=w(I)}return F}class r{constructor(m,L){this.a=L,this.b=null,this.c=new A({sendMessage:(w,$)=>{m(w,$)},handleMessage:(w,$)=>this.d(w,$),handleEvent:(w,$)=>this.f(w,$)})}onmessage(m){this.c.handleMessage(m)}d(m,L){if(m===s)return this.g(L[0],L[1],L[2],L[3]);if(!this.b||typeof this.b[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this.b[m].apply(this.b,L))}catch(w){return Promise.reject(w)}}f(m,L){if(!this.b)throw new Error("Missing requestHandler");if(g(m)){const w=this.b[m].call(this.b,L);if(typeof w!="function")throw new Error(`Missing dynamic event ${m} on request handler.`);return w}if(M(m)){const w=this.b[m];if(typeof w!="function")throw new Error(`Missing event ${m} on request handler.`);return w}throw new Error(`Malformed event name ${m}`)}g(m,L,w,$){this.c.setWorkerId(m);const P=c($,(U,C)=>this.c.sendMessage(U,C),(U,C)=>this.c.listen(U,C));return this.a?(this.b=this.a(P),Promise.resolve((0,o.$Tm)(this.b))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((U,C)=>{(globalThis.require||x)([w],X=>{if(this.b=X.create(P),!this.b){C(new Error("No RequestHandler!"));return}U((0,o.$Tm)(this.b))},C)}))}}t.SimpleWorkerServer=r;function a(E){return new r(E,null)}t.create=a}),re(le[24],ue([0,1,23]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$r=t.$0r=void 0;class k{constructor(u){const s=(0,y.$jd)(u);this.c=s,this.a=k.d(s),this.b=new Map}static d(u){const s=new Uint8Array(256);return s.fill(u),s}set(u,s){const l=(0,y.$jd)(s);u>=0&&u<256?this.a[u]=l:this.b.set(u,l)}get(u){return u>=0&&u<256?this.a[u]:this.b.get(u)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$0r=k;var i;(function(v){v[v.False=0]="False",v[v.True=1]="True"})(i||(i={}));class o{constructor(){this.a=new k(0)}add(u){this.a.set(u,1)}has(u){return this.a.get(u)===1}clear(){return this.a.clear()}}t.$$r=o}),re(le[6],ue([0,1,3]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tr=t.$Sr=void 0;class k{static addRange(v,u){let s=0;for(;s<u.length&&u[s].endExclusive<v.start;)s++;let l=s;for(;l<u.length&&u[l].start<=v.endExclusive;)l++;if(s===l)u.splice(s,0,v);else{const h=Math.min(v.start,u[s].start),R=Math.max(v.endExclusive,u[l-1].endExclusive);u.splice(s,l-s,new k(h,R))}}static tryCreate(v,u){if(!(v>u))return new k(v,u)}static ofLength(v){return new k(0,v)}constructor(v,u){if(this.start=v,this.endExclusive=u,v>u)throw new y.$bb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(v){return new k(this.start+v,this.endExclusive+v)}deltaStart(v){return new k(this.start+v,this.endExclusive)}deltaEnd(v){return new k(this.start,this.endExclusive+v)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(v){return this.start===v.start&&this.endExclusive===v.endExclusive}containsRange(v){return this.start<=v.start&&v.endExclusive<=this.endExclusive}contains(v){return this.start<=v&&v<this.endExclusive}join(v){return new k(Math.min(this.start,v.start),Math.max(this.endExclusive,v.endExclusive))}intersect(v){const u=Math.max(this.start,v.start),s=Math.min(this.endExclusive,v.endExclusive);if(u<=s)return new k(u,s)}slice(v){return v.slice(this.start,this.endExclusive)}clip(v){if(this.isEmpty)throw new y.$bb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,v))}clipCyclic(v){if(this.isEmpty)throw new y.$bb(`Invalid clipping range: ${this.toString()}`);return v<this.start?this.endExclusive-(this.start-v)%this.length:v>=this.endExclusive?this.start+(v-this.start)%this.length:v}}t.$Sr=k;class i{constructor(){this.a=[]}addRange(v){let u=0;for(;u<this.a.length&&this.a[u].endExclusive<v.start;)u++;let s=u;for(;s<this.a.length&&this.a[s].start<=v.endExclusive;)s++;if(u===s)this.a.splice(u,0,v);else{const l=Math.min(v.start,this.a[u].start),h=Math.max(v.endExclusive,this.a[s-1].endExclusive);this.a.splice(u,s-u,new k(l,h))}}toString(){return this.a.map(v=>v.toString()).join(", ")}intersectsStrict(v){let u=0;for(;u<this.a.length&&this.a[u].endExclusive<=v.start;)u++;return u<this.a.length&&this.a[u].start<v.endExclusive}intersectWithRange(v){const u=new i;for(const s of this.a){const l=s.intersect(v);l&&u.addRange(l)}return u}intersectWithRangeLength(v){return this.intersectWithRange(v).length}get length(){return this.a.reduce((v,u)=>v+u.length,0)}}t.$Tr=i}),re(le[4],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ur=void 0;class y{constructor(i,o){this.lineNumber=i,this.column=o}with(i=this.lineNumber,o=this.column){return i===this.lineNumber&&o===this.column?this:new y(i,o)}delta(i=0,o=0){return this.with(this.lineNumber+i,this.column+o)}equals(i){return y.equals(this,i)}static equals(i,o){return!i&&!o?!0:!!i&&!!o&&i.lineNumber===o.lineNumber&&i.column===o.column}isBefore(i){return y.isBefore(this,i)}static isBefore(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<o.column}isBeforeOrEqual(i){return y.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<=o.column}static compare(i,o){const v=i.lineNumber|0,u=o.lineNumber|0;if(v===u){const s=i.column|0,l=o.column|0;return s-l}return v-u}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new y(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.$Ur=y}),re(le[2],ue([0,1,4]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vr=void 0;class k{constructor(o,v,u,s){o>u||o===u&&v>s?(this.startLineNumber=u,this.startColumn=s,this.endLineNumber=o,this.endColumn=v):(this.startLineNumber=o,this.startColumn=v,this.endLineNumber=u,this.endColumn=s)}isEmpty(){return k.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return k.containsPosition(this,o)}static containsPosition(o,v){return!(v.lineNumber<o.startLineNumber||v.lineNumber>o.endLineNumber||v.lineNumber===o.startLineNumber&&v.column<o.startColumn||v.lineNumber===o.endLineNumber&&v.column>o.endColumn)}static strictContainsPosition(o,v){return!(v.lineNumber<o.startLineNumber||v.lineNumber>o.endLineNumber||v.lineNumber===o.startLineNumber&&v.column<=o.startColumn||v.lineNumber===o.endLineNumber&&v.column>=o.endColumn)}containsRange(o){return k.containsRange(this,o)}static containsRange(o,v){return!(v.startLineNumber<o.startLineNumber||v.endLineNumber<o.startLineNumber||v.startLineNumber>o.endLineNumber||v.endLineNumber>o.endLineNumber||v.startLineNumber===o.startLineNumber&&v.startColumn<o.startColumn||v.endLineNumber===o.endLineNumber&&v.endColumn>o.endColumn)}strictContainsRange(o){return k.strictContainsRange(this,o)}static strictContainsRange(o,v){return!(v.startLineNumber<o.startLineNumber||v.endLineNumber<o.startLineNumber||v.startLineNumber>o.endLineNumber||v.endLineNumber>o.endLineNumber||v.startLineNumber===o.startLineNumber&&v.startColumn<=o.startColumn||v.endLineNumber===o.endLineNumber&&v.endColumn>=o.endColumn)}plusRange(o){return k.plusRange(this,o)}static plusRange(o,v){let u,s,l,h;return v.startLineNumber<o.startLineNumber?(u=v.startLineNumber,s=v.startColumn):v.startLineNumber===o.startLineNumber?(u=v.startLineNumber,s=Math.min(v.startColumn,o.startColumn)):(u=o.startLineNumber,s=o.startColumn),v.endLineNumber>o.endLineNumber?(l=v.endLineNumber,h=v.endColumn):v.endLineNumber===o.endLineNumber?(l=v.endLineNumber,h=Math.max(v.endColumn,o.endColumn)):(l=o.endLineNumber,h=o.endColumn),new k(u,s,l,h)}intersectRanges(o){return k.intersectRanges(this,o)}static intersectRanges(o,v){let u=o.startLineNumber,s=o.startColumn,l=o.endLineNumber,h=o.endColumn;const R=v.startLineNumber,f=v.startColumn,d=v.endLineNumber,e=v.endColumn;return u<R?(u=R,s=f):u===R&&(s=Math.max(s,f)),l>d?(l=d,h=e):l===d&&(h=Math.min(h,e)),u>l||u===l&&s>h?null:new k(u,s,l,h)}equalsRange(o){return k.equalsRange(this,o)}static equalsRange(o,v){return!o&&!v?!0:!!o&&!!v&&o.startLineNumber===v.startLineNumber&&o.startColumn===v.startColumn&&o.endLineNumber===v.endLineNumber&&o.endColumn===v.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(o){return new y.$Ur(o.endLineNumber,o.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(o){return new y.$Ur(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,v){return new k(this.startLineNumber,this.startColumn,o,v)}setStartPosition(o,v){return new k(o,v,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(o){return new k(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return k.collapseToEnd(this)}static collapseToEnd(o){return new k(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new k(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,v=o){return new k(o.lineNumber,o.column,v.lineNumber,v.column)}static lift(o){return o?new k(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,v){return!(o.endLineNumber<v.startLineNumber||o.endLineNumber===v.startLineNumber&&o.endColumn<v.startColumn||v.endLineNumber<o.startLineNumber||v.endLineNumber===o.startLineNumber&&v.endColumn<o.startColumn)}static areIntersecting(o,v){return!(o.endLineNumber<v.startLineNumber||o.endLineNumber===v.startLineNumber&&o.endColumn<=v.startColumn||v.endLineNumber<o.startLineNumber||v.endLineNumber===o.startLineNumber&&v.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,v){if(o&&v){const l=o.startLineNumber|0,h=v.startLineNumber|0;if(l===h){const R=o.startColumn|0,f=v.startColumn|0;if(R===f){const d=o.endLineNumber|0,e=v.endLineNumber|0;if(d===e){const N=o.endColumn|0,p=v.endColumn|0;return N-p}return d-e}return R-f}return l-h}return(o?1:0)-(v?1:0)}static compareRangesUsingEnds(o,v){return o.endLineNumber===v.endLineNumber?o.endColumn===v.endColumn?o.startLineNumber===v.startLineNumber?o.startColumn-v.startColumn:o.startLineNumber-v.startLineNumber:o.endColumn-v.endColumn:o.endLineNumber-v.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.$Vr=k}),re(le[38],ue([0,1,2]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3r=void 0;class k{static insert(o,v){return{range:new y.$Vr(o.lineNumber,o.column,o.lineNumber,o.column),text:v,forceMoveMarkers:!0}}static delete(o){return{range:o,text:null}}static replace(o,v){return{range:o,text:v}}static replaceMove(o,v){return{range:o,text:v,forceMoveMarkers:!0}}}t.$3r=k}),re(le[14],ue([0,1,3,6,2]),function(x,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wr=void 0;class o{static fromRange(u){return new o(u.startLineNumber,u.endLineNumber)}static subtract(u,s){return s?u.startLineNumber<s.startLineNumber&&s.endLineNumberExclusive<u.endLineNumberExclusive?[new o(u.startLineNumber,s.startLineNumber),new o(s.endLineNumberExclusive,u.endLineNumberExclusive)]:s.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=s.endLineNumberExclusive?[]:s.endLineNumberExclusive<u.endLineNumberExclusive?[new o(Math.max(s.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new o(u.startLineNumber,Math.min(s.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let s=u[0];for(let l=1;l<u.length;l++)s=this.join(s,u[l]);return s}static join(u,s){if(u.length===0)return s;if(s.length===0)return u;const l=[];let h=0,R=0,f=null;for(;h<u.length||R<s.length;){let d=null;if(h<u.length&&R<s.length){const e=u[h],N=s[R];e.startLineNumber<N.startLineNumber?(d=e,h++):(d=N,R++)}else h<u.length?(d=u[h],h++):(d=s[R],R++);f===null?f=d:f.endLineNumberExclusive>=d.startLineNumber?f=new o(f.startLineNumber,Math.max(f.endLineNumberExclusive,d.endLineNumberExclusive)):(l.push(f),f=d)}return f!==null&&l.push(f),l}static ofLength(u,s){return new o(u,u+s)}static deserialize(u){return new o(u[0],u[1])}constructor(u,s){if(u>s)throw new y.$bb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${s}`);this.startLineNumber=u,this.endLineNumberExclusive=s}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new o(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new o(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new o(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const s=Math.max(this.startLineNumber,u.startLineNumber),l=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(s<=l)return new o(s,l)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new i.$Vr(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new i.$Vr(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const s=[];for(let l=this.startLineNumber;l<this.endLineNumberExclusive;l++)s.push(u(l));return s}forEach(u){for(let s=this.startLineNumber;s<this.endLineNumberExclusive;s++)u(s)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new k.$Sr(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Wr=o}),re(le[39],ue([0,1,4,2]),function(x,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4r=t.SelectionDirection=void 0;var i;(function(v){v[v.LTR=0]="LTR",v[v.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class o extends k.$Vr{constructor(u,s,l,h){super(u,s,l,h),this.selectionStartLineNumber=u,this.selectionStartColumn=s,this.positionLineNumber=l,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(u){return o.selectionsEqual(this,u)}static selectionsEqual(u,s){return u.selectionStartLineNumber===s.selectionStartLineNumber&&u.selectionStartColumn===s.selectionStartColumn&&u.positionLineNumber===s.positionLineNumber&&u.positionColumn===s.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(u,s){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,u,s):new o(u,s,this.startLineNumber,this.startColumn)}getPosition(){return new y.$Ur(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new y.$Ur(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(u,s){return this.getDirection()===0?new o(u,s,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,u,s)}static fromPositions(u,s=u){return new o(u.lineNumber,u.column,s.lineNumber,s.column)}static fromRange(u,s){return s===0?new o(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):new o(u.endLineNumber,u.endColumn,u.startLineNumber,u.startColumn)}static liftSelection(u){return new o(u.selectionStartLineNumber,u.selectionStartColumn,u.positionLineNumber,u.positionColumn)}static selectionsArrEqual(u,s){if(u&&!s||!u&&s)return!1;if(!u&&!s)return!0;if(u.length!==s.length)return!1;for(let l=0,h=u.length;l<h;l++)if(!this.selectionsEqual(u[l],s[l]))return!1;return!0}static isISelection(u){return u&&typeof u.selectionStartLineNumber=="number"&&typeof u.selectionStartColumn=="number"&&typeof u.positionLineNumber=="number"&&typeof u.positionColumn=="number"}static createWithDirection(u,s,l,h,R){return R===0?new o(u,s,l,h):new o(l,h,u,s)}}t.$4r=o}),re(le[40],ue([0,1,24]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$as=t.$_r=t.WordCharacterClass=void 0;var k;(function(v){v[v.Regular=0]="Regular",v[v.Whitespace=1]="Whitespace",v[v.WordSeparator=2]="WordSeparator"})(k||(t.WordCharacterClass=k={}));class i extends y.$0r{constructor(u){super(0);for(let s=0,l=u.length;s<l;s++)this.set(u.charCodeAt(s),2);this.set(32,1),this.set(9,1)}}t.$_r=i;function o(v){const u={};return s=>(u.hasOwnProperty(s)||(u[s]=v(s)),u[s])}t.$as=o(v=>new i(v))}),re(le[25],ue([0,1,17,7,18]),function(x,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rr=t.$Qr=t.$Pr=t.$Or=t.$Nr=void 0,t.$Nr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(R=""){let f="(-?\\d*\\.\\d\\w*)|([^";for(const d of t.$Nr)R.indexOf(d)>=0||(f+="\\"+d);return f+="\\s]+)",new RegExp(f,"g")}t.$Or=o();function v(R){let f=t.$Or;if(R&&R instanceof RegExp)if(R.global)f=R;else{let d="g";R.ignoreCase&&(d+="i"),R.multiline&&(d+="m"),R.unicode&&(d+="u"),f=new RegExp(R.source,d)}return f.lastIndex=0,f}t.$Pr=v;const u=new i.$ub;u.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function s(R){const f=u.unshift(R);return(0,k.$jb)(f)}t.$Qr=s;function l(R,f,d,e,N){if(N||(N=y.Iterable.first(u)),d.length>N.maxLen){let g=R-N.maxLen/2;return g<0?g=0:e+=g,d=d.substring(g,R+N.maxLen/2),l(R,f,d,e,N)}const p=Date.now(),A=R-1-e;let b=-1,M=null;for(let g=1;!(Date.now()-p>=N.timeBudget);g++){const c=A-N.windowSize*g;f.lastIndex=Math.max(0,c);const r=h(f,d,A,b);if(!r&&M||(M=r,c<=0))break;b=c}if(M){const g={word:M[0],startColumn:e+1+M.index,endColumn:e+1+M.index+M[0].length};return f.lastIndex=0,g}return null}t.$Rr=l;function h(R,f,d,e){let N;for(;N=R.exec(f);){const p=N.index||0;if(p<=d&&R.lastIndex>=d)return N;if(e>0&&p>e)return null}return null}}),re(le[9],ue([0,1,3,6]),function(x,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FY=t.$EY=t.$DY=t.$CY=void 0;class i{static trivial(l,h){return new i([new o(new k.$Sr(0,l.length),new k.$Sr(0,h.length))],!1)}static trivialTimedOut(l,h){return new i([new o(new k.$Sr(0,l.length),new k.$Sr(0,h.length))],!0)}constructor(l,h){this.diffs=l,this.hitTimeout=h}}t.$CY=i;class o{constructor(l,h){this.seq1Range=l,this.seq2Range=h}reverse(){return new o(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(l){return new o(this.seq1Range.join(l.seq1Range),this.seq2Range.join(l.seq2Range))}delta(l){return l===0?this:new o(this.seq1Range.delta(l),this.seq2Range.delta(l))}}t.$DY=o;class v{isValid(){return!0}}t.$EY=v,v.instance=new v;class u{constructor(l){if(this.c=l,this.a=Date.now(),this.b=!0,l<=0)throw new y.$bb("timeout must be positive")}isValid(){if(!(Date.now()-this.a<this.c)&&this.b){this.b=!1;debugger}return this.b}disable(){this.c=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.b=!0}}t.$FY=u}),re(le[41],ue([0,1,6,9]),function(x,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NY=t.$MY=t.$LY=t.$KY=t.$JY=t.$IY=void 0;function i(R,f,d){let e=d;return e=s(R,f,e),e=l(R,f,e),e}t.$IY=i;function o(R,f,d){const e=[];for(const N of d){const p=e[e.length-1];if(!p){e.push(N);continue}N.seq1Range.start-p.seq1Range.endExclusive<=2||N.seq2Range.start-p.seq2Range.endExclusive<=2?e[e.length-1]=new k.$DY(p.seq1Range.join(N.seq1Range),p.seq2Range.join(N.seq2Range)):e.push(N)}return e}t.$JY=o;function v(R,f,d){let e=d;if(e.length===0)return e;let N=0,p;do{p=!1;const A=[e[0]];for(let b=1;b<e.length;b++){let c=function(a,E){const m=new y.$Sr(g.seq1Range.endExclusive,M.seq1Range.start);return R.getText(m).replace(/\s/g,"").length<=4&&(a.seq1Range.length+a.seq2Range.length>5||E.seq1Range.length+E.seq2Range.length>5)};const M=e[b],g=A[A.length-1];c(g,M)?(p=!0,A[A.length-1]=A[A.length-1].join(M)):A.push(M)}e=A}while(N++<10&&p);return e}t.$KY=v;function u(R,f,d){let e=d;if(e.length===0)return e;let N=0,p;do{p=!1;const A=[e[0]];for(let b=1;b<e.length;b++){let c=function(a,E){const m=new y.$Sr(g.seq1Range.endExclusive,M.seq1Range.start);if(R.countLinesIn(m)>5||m.length>500)return!1;const w=R.getText(m).trim();if(w.length>20||w.split(/\r\n|\r|\n/).length>1)return!1;const $=R.countLinesIn(a.seq1Range),F=a.seq1Range.length,I=f.countLinesIn(a.seq2Range),P=a.seq2Range.length,U=R.countLinesIn(E.seq1Range),C=E.seq1Range.length,V=f.countLinesIn(E.seq2Range),X=E.seq2Range.length,_=2*40+50;function z(Z){return Math.min(Z,_)}return Math.pow(Math.pow(z($*40+F),1.5)+Math.pow(z(I*40+P),1.5),1.5)+Math.pow(Math.pow(z(U*40+C),1.5)+Math.pow(z(V*40+X),1.5),1.5)>(_**1.5)**1.5*1.3};const M=e[b],g=A[A.length-1];c(g,M)?(p=!0,A[A.length-1]=A[A.length-1].join(M)):A.push(M)}e=A}while(N++<10&&p);for(let A=0;A<e.length;A++){const b=e[A];let M=b.seq1Range,g=b.seq2Range;const c=R.extendToFullLines(b.seq1Range),r=R.getText(new y.$Sr(c.start,b.seq1Range.start));r.length>0&&r.trim().length<=3&&b.seq1Range.length+b.seq2Range.length>100&&(M=b.seq1Range.deltaStart(-r.length),g=b.seq2Range.deltaStart(-r.length));const a=R.getText(new y.$Sr(b.seq1Range.endExclusive,c.endExclusive));a.length>0&&a.trim().length<=3&&b.seq1Range.length+b.seq2Range.length>150&&(M=M.deltaEnd(a.length),g=g.deltaEnd(a.length)),e[A]=new k.$DY(M,g)}return e}t.$LY=u;function s(R,f,d){if(d.length===0)return d;const e=[];e.push(d[0]);for(let p=1;p<d.length;p++){const A=e[e.length-1];let b=d[p];if(b.seq1Range.isEmpty||b.seq2Range.isEmpty){const M=b.seq1Range.start-A.seq1Range.endExclusive;let g;for(g=1;g<=M&&!(R.getElement(b.seq1Range.start-g)!==R.getElement(b.seq1Range.endExclusive-g)||f.getElement(b.seq2Range.start-g)!==f.getElement(b.seq2Range.endExclusive-g));g++);if(g--,g===M){e[e.length-1]=new k.$DY(new y.$Sr(A.seq1Range.start,b.seq1Range.endExclusive-M),new y.$Sr(A.seq2Range.start,b.seq2Range.endExclusive-M));continue}b=b.delta(-g)}e.push(b)}const N=[];for(let p=0;p<e.length-1;p++){const A=e[p+1];let b=e[p];if(b.seq1Range.isEmpty||b.seq2Range.isEmpty){const M=A.seq1Range.start-b.seq1Range.endExclusive;let g;for(g=0;g<M&&!(R.getElement(b.seq1Range.start+g)!==R.getElement(b.seq1Range.endExclusive+g)||f.getElement(b.seq2Range.start+g)!==f.getElement(b.seq2Range.endExclusive+g));g++);if(g===M){e[p+1]=new k.$DY(new y.$Sr(b.seq1Range.start+M,A.seq1Range.endExclusive),new y.$Sr(b.seq2Range.start+M,A.seq2Range.endExclusive));continue}g>0&&(b=b.delta(g))}N.push(b)}return e.length>0&&N.push(e[e.length-1]),N}t.$MY=s;function l(R,f,d){if(!R.getBoundaryScore||!f.getBoundaryScore)return d;for(let e=0;e<d.length;e++){const N=e>0?d[e-1]:void 0,p=d[e],A=e+1<d.length?d[e+1]:void 0,b=new y.$Sr(N?N.seq1Range.start+1:0,A?A.seq1Range.endExclusive-1:R.length),M=new y.$Sr(N?N.seq2Range.start+1:0,A?A.seq2Range.endExclusive-1:f.length);p.seq1Range.isEmpty?d[e]=h(p,R,f,b,M):p.seq2Range.isEmpty&&(d[e]=h(p.reverse(),f,R,M,b).reverse())}return d}t.$NY=l;function h(R,f,d,e,N){let A=1;for(;R.seq1Range.start-A>=e.start&&R.seq2Range.start-A>=N.start&&d.isStronglyEqual(R.seq2Range.start-A,R.seq2Range.endExclusive-A)&&A<100;)A++;A--;let b=0;for(;R.seq1Range.start+b<e.endExclusive&&R.seq2Range.endExclusive+b<N.endExclusive&&d.isStronglyEqual(R.seq2Range.start+b,R.seq2Range.endExclusive+b)&&b<100;)b++;if(A===0&&b===0)return R;let M=0,g=-1;for(let c=-A;c<=b;c++){const r=R.seq2Range.start+c,a=R.seq2Range.endExclusive+c,E=R.seq1Range.start+c,m=f.getBoundaryScore(E)+d.getBoundaryScore(r)+d.getBoundaryScore(a);m>g&&(g=m,M=c)}return R.delta(M)}}),re(le[42],ue([0,1,6,9]),function(x,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OY=void 0;class i{compute(l,h,R=k.$EY.instance){if(l.length===0||h.length===0)return k.$CY.trivial(l,h);function f(c,r){for(;c<l.length&&r<h.length&&l.getElement(c)===h.getElement(r);)c++,r++;return c}let d=0;const e=new v;e.set(0,f(0,0));const N=new u;N.set(0,e.get(0)===0?null:new o(null,0,0,e.get(0)));let p=0;e:for(;;){if(d++,!R.isValid())return k.$CY.trivialTimedOut(l,h);const c=-Math.min(d,h.length+d%2),r=Math.min(d,l.length+d%2);for(p=c;p<=r;p+=2){const a=p===r?-1:e.get(p+1),E=p===c?-1:e.get(p-1)+1,m=Math.min(Math.max(a,E),l.length),L=m-p;if(m>l.length||L>h.length)continue;const w=f(m,L);e.set(p,w);const $=m===a?N.get(p+1):N.get(p-1);if(N.set(p,w!==m?new o($,m,L,w-m):$),e.get(p)===l.length&&e.get(p)-p===h.length)break e}}let A=N.get(p);const b=[];let M=l.length,g=h.length;for(;;){const c=A?A.x+A.length:0,r=A?A.y+A.length:0;if((c!==M||r!==g)&&b.push(new k.$DY(new y.$Sr(c,M),new y.$Sr(r,g))),!A)break;M=A.x,g=A.y,A=A.prev}return b.reverse(),new k.$CY(b,!1)}}t.$OY=i;class o{constructor(l,h,R,f){this.prev=l,this.x=h,this.y=R,this.length=f}}class v{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,h){if(l<0){if(l=-l-1,l>=this.b.length){const R=this.b;this.b=new Int32Array(R.length*2),this.b.set(R)}this.b[l]=h}else{if(l>=this.a.length){const R=this.a;this.a=new Int32Array(R.length*2),this.a.set(R)}this.a[l]=h}}}class u{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,h){l<0?(l=-l-1,this.b[l]=h):this.a[l]=h}}}),re(le[43],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GY=void 0;class y{constructor(i,o){this.width=i,this.height=o,this.a=[],this.a=new Array(i*o)}get(i,o){return this.a[i+o*this.width]}set(i,o,v){this.a[i+o*this.width]=v}}t.$GY=y}),re(le[44],ue([0,1,6,9,43]),function(x,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HY=void 0;class o{compute(u,s,l=k.$EY.instance,h){if(u.length===0||s.length===0)return k.$CY.trivial(u,s);const R=new i.$GY(u.length,s.length),f=new i.$GY(u.length,s.length),d=new i.$GY(u.length,s.length);for(let g=0;g<u.length;g++)for(let c=0;c<s.length;c++){if(!l.isValid())return k.$CY.trivialTimedOut(u,s);const r=g===0?0:R.get(g-1,c),a=c===0?0:R.get(g,c-1);let E;u.getElement(g)===s.getElement(c)?(g===0||c===0?E=0:E=R.get(g-1,c-1),g>0&&c>0&&f.get(g-1,c-1)===3&&(E+=d.get(g-1,c-1)),E+=h?h(g,c):1):E=-1;const m=Math.max(r,a,E);if(m===E){const L=g>0&&c>0?d.get(g-1,c-1):0;d.set(g,c,L+1),f.set(g,c,3)}else m===r?(d.set(g,c,0),f.set(g,c,1)):m===a&&(d.set(g,c,0),f.set(g,c,2));R.set(g,c,m)}const e=[];let N=u.length,p=s.length;function A(g,c){(g+1!==N||c+1!==p)&&e.push(new k.$DY(new y.$Sr(g+1,N),new y.$Sr(c+1,p))),N=g,p=c}let b=u.length-1,M=s.length-1;for(;b>=0&&M>=0;)f.get(b,M)===3?(A(b,M),b--,M--):f.get(b,M)===1?b--:M--;return A(-1,-1),e.reverse(),new k.$CY(e,!1)}}t.$HY=o}),re(le[26],ue([0,1,14]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2r=t.$1r=t.$Zr=t.$Yr=t.$Xr=void 0;class k{constructor(l,h,R){this.changes=l,this.moves=h,this.hitTimeout=R}}t.$Xr=k;class i{static inverse(l,h,R){const f=[];let d=1,e=1;for(const p of l){const A=new i(new y.$Wr(d,p.originalRange.startLineNumber),new y.$Wr(e,p.modifiedRange.startLineNumber),void 0);A.modifiedRange.isEmpty||f.push(A),d=p.originalRange.endLineNumberExclusive,e=p.modifiedRange.endLineNumberExclusive}const N=new i(new y.$Wr(d,h+1),new y.$Wr(e,R+1),void 0);return N.modifiedRange.isEmpty||f.push(N),f}constructor(l,h,R){this.originalRange=l,this.modifiedRange=h,this.innerChanges=R}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){return new i(this.modifiedRange,this.originalRange,this.innerChanges?.map(l=>l.flip()))}}t.$Yr=i;class o{constructor(l,h){this.originalRange=l,this.modifiedRange=h}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}t.$Zr=o;class v{constructor(l,h){this.original=l,this.modified=h}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new v(this.modified,this.original)}join(l){return new v(this.original.join(l.original),this.modified.join(l.modified))}}t.$1r=v;class u{constructor(l,h){this.lineRangeMapping=l,this.changes=h}flip(){return new u(this.lineRangeMapping.flip(),this.changes.map(l=>l.flip()))}}t.$2r=u}),re(le[45],ue([0,1,15,10,28,3,14,6,4,2,9,44,41,42,26]),function(x,t,y,k,i,o,v,u,s,l,h,R,f,d,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VY=t.$UY=t.$TY=t.$SY=t.$RY=t.$QY=t.$PY=void 0;class N{constructor(){this.f=new R.$HY,this.h=new d.$OY}computeDiff(j,H,K){if(j.length<=1&&(0,y.$$e)(j,H,(O,Q)=>O===Q))return new e.$Xr([],[],!1);if(j.length===1&&j[0].length===0||H.length===1&&H[0].length===0)return new e.$Xr([new e.$Yr(new v.$Wr(1,j.length+1),new v.$Wr(1,H.length+1),[new e.$Zr(new l.$Vr(1,1,j.length,j[0].length+1),new l.$Vr(1,1,H.length,H[0].length+1))])],[],!1);const G=K.maxComputationTimeMs===0?h.$EY.instance:new h.$FY(K.maxComputationTimeMs),ie=!K.ignoreTrimWhitespace,ae=new Map;function oe(O){let Q=ae.get(O);return Q===void 0&&(Q=ae.size,ae.set(O,Q)),Q}const fe=j.map(O=>oe(O.trim())),be=H.map(O=>oe(O.trim())),ve=new m(fe,j),we=new m(be,H),Me=(()=>ve.length+we.length<1700?this.f.compute(ve,we,G,(O,Q)=>j[O]===H[Q]?H[Q].length===0?.1:1+Math.log(1+H[Q].length):.99):this.h.compute(ve,we))();let Le=Me.diffs,Re=Me.hitTimeout;Le=(0,f.$IY)(ve,we,Le),Le=(0,f.$KY)(ve,we,Le);const pe=[],ne=O=>{if(ie)for(let Q=0;Q<O;Q++){const te=S+Q,ce=q+Q;if(j[te]!==H[ce]){const he=this.o(j,H,new h.$DY(new u.$Sr(te,te+1),new u.$Sr(ce,ce+1)),G,ie);for(const me of he.mappings)pe.push(me);he.hitTimeout&&(Re=!0)}}};let S=0,q=0;for(const O of Le){(0,k.$yb)(()=>O.seq1Range.start-S===O.seq2Range.start-q);const Q=O.seq1Range.start-S;ne(Q),S=O.seq1Range.endExclusive,q=O.seq2Range.endExclusive;const te=this.o(j,H,O,G,ie);te.hitTimeout&&(Re=!0);for(const ce of te.mappings)pe.push(ce)}ne(j.length-S);const T=r(pe,j,H);let B=[];return K.computeMoves&&(B=this.n(T,j,H,fe,be,G,ie)),(0,k.$yb)(()=>{function O(te,ce){if(te.lineNumber<1||te.lineNumber>ce.length)return!1;const he=ce[te.lineNumber-1];return!(te.column<1||te.column>he.length+1)}function Q(te,ce){return!(te.startLineNumber<1||te.startLineNumber>ce.length+1||te.endLineNumberExclusive<1||te.endLineNumberExclusive>ce.length+1)}for(const te of T){if(!te.innerChanges)return!1;for(const ce of te.innerChanges)if(!(O(ce.modifiedRange.getStartPosition(),H)&&O(ce.modifiedRange.getEndPosition(),H)&&O(ce.originalRange.getStartPosition(),j)&&O(ce.originalRange.getEndPosition(),j)))return!1;if(!Q(te.modifiedRange,H)||!Q(te.originalRange,j))return!1}return!0}),new e.$Xr(T,B,Re)}n(j,H,K,G,ie,ae,oe){const fe=[],be=j.filter(T=>T.modifiedRange.isEmpty&&T.originalRange.length>=3).map(T=>new ge(T.originalRange,H,T)),ve=new Set(j.filter(T=>T.originalRange.isEmpty&&T.modifiedRange.length>=3).map(T=>new ge(T.modifiedRange,K,T))),we=new Set;for(const T of be){let B=-1,O;for(const Q of ve){const te=T.computeSimilarity(Q);te>B&&(B=te,O=Q)}if(B>.9&&O&&(ve.delete(O),fe.push(new e.$1r(T.range,O.range)),we.add(T.source),we.add(O.source)),!ae.isValid())return[]}const Me=new i.$G;for(const T of j)if(!we.has(T))for(let B=T.originalRange.startLineNumber;B<T.originalRange.endLineNumberExclusive-2;B++){const O=`${G[B-1]}:${G[B+1-1]}:${G[B+2-1]}`;Me.add(O,{range:new v.$Wr(B,B+3)})}const Le=[];j.sort((0,y.$Lf)(T=>T.modifiedRange.startLineNumber,y.$Nf));for(const T of j){if(we.has(T))continue;let B=[];for(let O=T.modifiedRange.startLineNumber;O<T.modifiedRange.endLineNumberExclusive-2;O++){const Q=`${ie[O-1]}:${ie[O+1-1]}:${ie[O+2-1]}`,te=new v.$Wr(O,O+3),ce=[];Me.forEach(Q,({range:he})=>{for(const $e of B)if($e.originalLineRange.endLineNumberExclusive+1===he.endLineNumberExclusive&&$e.modifiedLineRange.endLineNumberExclusive+1===te.endLineNumberExclusive){$e.originalLineRange=new v.$Wr($e.originalLineRange.startLineNumber,he.endLineNumberExclusive),$e.modifiedLineRange=new v.$Wr($e.modifiedLineRange.startLineNumber,te.endLineNumberExclusive),ce.push($e);return}const me={modifiedLineRange:te,originalLineRange:he};Le.push(me),ce.push(me)}),B=ce}if(!ae.isValid())return[]}Le.sort((0,y.$Pf)((0,y.$Lf)(T=>T.modifiedLineRange.length,y.$Nf)));const Re=new b,pe=new b;for(const T of Le){const B=T.modifiedLineRange.startLineNumber-T.originalLineRange.startLineNumber,O=Re.subtractFrom(T.modifiedLineRange),Q=pe.subtractFrom(T.originalLineRange).map(ce=>ce.delta(B)),te=A(O,Q);for(const ce of te){if(ce.length<3)continue;const he=ce,me=ce.delta(-B);fe.push(new e.$1r(me,he)),Re.addRange(he),pe.addRange(me)}}if(fe.sort((0,y.$Lf)(T=>T.original.startLineNumber,y.$Nf)),fe.length===0)return[];let ne=[fe[0]];for(let T=1;T<fe.length;T++){const B=ne[ne.length-1],O=fe[T],Q=O.original.startLineNumber-B.original.endLineNumberExclusive,te=O.modified.startLineNumber-B.modified.endLineNumberExclusive;if(Q>=0&&te>=0&&Q+te<=2){ne[ne.length-1]=B.join(O);continue}O.original.toOffsetRange().slice(H).map(me=>me.trim()).join(`
`).length<=10||ne.push(O)}const S=p.createOfSorted(j,T=>T.originalRange.endLineNumberExclusive,y.$Nf);return ne=ne.filter(T=>{const B=S.findLastItemBeforeOrEqual(T.original.startLineNumber)||new e.$Yr(new v.$Wr(1,1),new v.$Wr(1,1),[]),O=T.modified.startLineNumber-B.modifiedRange.endLineNumberExclusive,Q=T.original.startLineNumber-B.originalRange.endLineNumberExclusive;return O!==Q}),ne.map(T=>{const B=this.o(H,K,new h.$DY(T.original.toOffsetRange(),T.modified.toOffsetRange()),ae,oe),O=r(B.mappings,H,K,!0);return new e.$2r(T,O)})}o(j,H,K,G,ie){const ae=new w(j,K.seq1Range,ie),oe=new w(H,K.seq2Range,ie),fe=ae.length+oe.length<500?this.f.compute(ae,oe,G):this.h.compute(ae,oe,G);let be=fe.diffs;return be=(0,f.$IY)(ae,oe,be),be=g(ae,oe,be),be=(0,f.$JY)(ae,oe,be),be=(0,f.$LY)(ae,oe,be),{mappings:be.map(we=>new e.$Zr(ae.translateRange(we.seq1Range),oe.translateRange(we.seq2Range))),hitTimeout:fe.hitTimeout}}}t.$PY=N;class p{static create(j,H,K){return j.sort((G,ie)=>K(H(G),H(ie))),new p(j,H,K)}static createOfSorted(j,H,K){return new p(j,H,K)}constructor(j,H,K){this.o=j,this.p=H,this.q=K,this.f=0,this.h=void 0,this.n=!1}findLastItemBeforeOrEqual(j){if(this.n&&y.CompareResult.isLessThan(this.q(j,this.h)))throw new o.$bb;for(this.h=j,this.n=!0;this.f<this.o.length&&y.CompareResult.isLessThanOrEqual(this.q(this.p(this.o[this.f]),j));)this.f++;return this.f===0?void 0:this.o[this.f-1]}}function A(n,j){const H=[];let K=0,G=0;for(;K<n.length&&G<j.length;){const ie=n[K],ae=j[G],oe=ie.intersect(ae);oe&&!oe.isEmpty&&H.push(oe),ie.endLineNumberExclusive<ae.endLineNumberExclusive?K++:G++}return H}class b{constructor(){this.f=[]}addRange(j){const H=M(this.f.findIndex(G=>G.endLineNumberExclusive>=j.startLineNumber),this.f.length),K=(0,y.$rf)(this.f,G=>G.startLineNumber<=j.endLineNumberExclusive)+1;if(H===K)this.f.splice(H,0,j);else if(H===K-1){const G=this.f[H];this.f[H]=G.join(j)}else{const G=this.f[H].join(this.f[K-1]).join(j);this.f.splice(H,K-H,G)}}intersects(j){for(const H of this.f)if(H.intersectsStrict(j))return!0;return!1}subtractFrom(j){const H=M(this.f.findIndex(ae=>ae.endLineNumberExclusive>=j.startLineNumber),this.f.length),K=(0,y.$rf)(this.f,ae=>ae.startLineNumber<=j.endLineNumberExclusive)+1;if(H===K)return[j];const G=[];let ie=j.startLineNumber;for(let ae=H;ae<K;ae++){const oe=this.f[ae];oe.startLineNumber>ie&&G.push(new v.$Wr(ie,oe.startLineNumber)),ie=oe.endLineNumberExclusive}return ie<j.endLineNumberExclusive&&G.push(new v.$Wr(ie,j.endLineNumberExclusive)),G}}function M(n,j){return n===-1?j:n}function g(n,j,H){const K=[];let G;function ie(){if(!G)return;const oe=G.s1Range.length-G.deleted,fe=G.s2Range.length-G.added;Math.max(G.deleted,G.added)+(G.count-1)>oe&&K.push(new h.$DY(G.s1Range,G.s2Range)),G=void 0}for(const oe of H){let fe=function(Le,Re){if(!G||!G.s1Range.containsRange(Le)||!G.s2Range.containsRange(Re))if(G&&!(G.s1Range.endExclusive<Le.start&&G.s2Range.endExclusive<Re.start)){const S=u.$Sr.tryCreate(G.s1Range.endExclusive,Le.start),q=u.$Sr.tryCreate(G.s2Range.endExclusive,Re.start);G.deleted+=S?.length??0,G.added+=q?.length??0,G.s1Range=G.s1Range.join(Le),G.s2Range=G.s2Range.join(Re)}else ie(),G={added:0,deleted:0,count:0,s1Range:Le,s2Range:Re};const pe=Le.intersect(oe.seq1Range),ne=Re.intersect(oe.seq2Range);G.count++,G.deleted+=pe?.length??0,G.added+=ne?.length??0};const be=n.findWordContaining(oe.seq1Range.start-1),ve=j.findWordContaining(oe.seq2Range.start-1),we=n.findWordContaining(oe.seq1Range.endExclusive),Me=j.findWordContaining(oe.seq2Range.endExclusive);be&&we&&ve&&Me&&be.equals(we)&&ve.equals(Me)?fe(be,ve):(be&&ve&&fe(be,ve),we&&Me&&fe(we,Me))}return ie(),c(H,K)}function c(n,j){const H=[];for(;n.length>0||j.length>0;){const K=n[0],G=j[0];let ie;K&&(!G||K.seq1Range.start<G.seq1Range.start)?ie=n.shift():ie=j.shift(),H.length>0&&H[H.length-1].seq1Range.endExclusive>=ie.seq1Range.start?H[H.length-1]=H[H.length-1].join(ie):H.push(ie)}return H}function r(n,j,H,K=!1){const G=[];for(const ie of E(n.map(ae=>a(ae,j,H)),(ae,oe)=>ae.originalRange.overlapOrTouch(oe.originalRange)||ae.modifiedRange.overlapOrTouch(oe.modifiedRange))){const ae=ie[0],oe=ie[ie.length-1];G.push(new e.$Yr(ae.originalRange.join(oe.originalRange),ae.modifiedRange.join(oe.modifiedRange),ie.map(fe=>fe.innerChanges[0])))}return(0,k.$yb)(()=>!K&&G.length>0&&G[0].originalRange.startLineNumber!==G[0].modifiedRange.startLineNumber?!1:(0,k.$zb)(G,(ie,ae)=>ae.originalRange.startLineNumber-ie.originalRange.endLineNumberExclusive===ae.modifiedRange.startLineNumber-ie.modifiedRange.endLineNumberExclusive&&ie.originalRange.endLineNumberExclusive<ae.originalRange.startLineNumber&&ie.modifiedRange.endLineNumberExclusive<ae.modifiedRange.startLineNumber)),G}t.$QY=r;function a(n,j,H){let K=0,G=0;n.modifiedRange.endColumn===1&&n.originalRange.endColumn===1&&n.originalRange.startLineNumber+K<=n.originalRange.endLineNumber&&n.modifiedRange.startLineNumber+K<=n.modifiedRange.endLineNumber&&(G=-1),n.modifiedRange.startColumn-1>=H[n.modifiedRange.startLineNumber-1].length&&n.originalRange.startColumn-1>=j[n.originalRange.startLineNumber-1].length&&n.originalRange.startLineNumber<=n.originalRange.endLineNumber+G&&n.modifiedRange.startLineNumber<=n.modifiedRange.endLineNumber+G&&(K=1);const ie=new v.$Wr(n.originalRange.startLineNumber+K,n.originalRange.endLineNumber+1+G),ae=new v.$Wr(n.modifiedRange.startLineNumber+K,n.modifiedRange.endLineNumber+1+G);return new e.$Yr(ie,ae,[n])}t.$RY=a;function*E(n,j){let H,K;for(const G of n)K!==void 0&&j(K,G)?H.push(G):(H&&(yield H),H=[G]),K=G;H&&(yield H)}class m{constructor(j,H){this.f=j,this.h=H}getElement(j){return this.f[j]}get length(){return this.f.length}getBoundaryScore(j){const H=j===0?0:L(this.h[j-1]),K=j===this.h.length?0:L(this.h[j]);return 1e3-(H+K)}getText(j){return this.h.slice(j.start,j.endExclusive).join(`
`)}isStronglyEqual(j,H){return this.h[j]===this.h[H]}}t.$SY=m;function L(n){let j=0;for(;j<n.length&&(n.charCodeAt(j)===32||n.charCodeAt(j)===9);)j++;return j}class w{constructor(j,H,K){this.lines=j,this.considerWhitespaceChanges=K,this.f=[],this.h=[],this.n=[];let G=!1;H.start>0&&H.endExclusive>=j.length&&(H=new u.$Sr(H.start-1,H.endExclusive),G=!0),this.lineRange=H;for(let ie=this.lineRange.start;ie<this.lineRange.endExclusive;ie++){let ae=j[ie],oe=0;if(G)oe=ae.length,ae="",G=!1;else if(!K){const fe=ae.trimStart();oe=ae.length-fe.length,ae=fe.trimEnd()}this.n.push(oe);for(let fe=0;fe<ae.length;fe++)this.f.push(ae.charCodeAt(fe));ie<j.length-1&&(this.f.push(`
`.charCodeAt(0)),this.h[ie-this.lineRange.start]=this.f.length)}this.n.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new u.$Sr(0,this.length))}getText(j){return this.f.slice(j.start,j.endExclusive).map(H=>String.fromCharCode(H)).join("")}getElement(j){return this.f[j]}get length(){return this.f.length}getBoundaryScore(j){const H=_(j>0?this.f[j-1]:-1),K=_(j<this.f.length?this.f[j]:-1);if(H===6&&K===7)return 0;let G=0;return H!==K&&(G+=10,K===1&&(G+=1)),G+=X(H),G+=X(K),G}translateOffset(j){if(this.lineRange.isEmpty)return new s.$Ur(this.lineRange.start+1,1);let H=0,K=this.h.length;for(;H<K;){const ie=Math.floor((H+K)/2);this.h[ie]>j?K=ie:H=ie+1}const G=H===0?0:this.h[H-1];return new s.$Ur(this.lineRange.start+H+1,j-G+1+this.n[H])}translateRange(j){return l.$Vr.fromPositions(this.translateOffset(j.start),this.translateOffset(j.endExclusive))}findWordContaining(j){if(j<0||j>=this.f.length||!U(this.f[j]))return;let H=j;for(;H>0&&U(this.f[H-1]);)H--;let K=j;for(;K<this.f.length&&U(this.f[K]);)K++;return new u.$Sr(H,K)}countLinesIn(j){return this.translateOffset(j.endExclusive).lineNumber-this.translateOffset(j.start).lineNumber}isStronglyEqual(j,H){return this.f[j]===this.f[H]}extendToFullLines(j){const H=F(this.h,G=>G<=j.start)??0,K=P(this.h,G=>j.endExclusive<=G)??this.f.length;return new u.$Sr(H,K)}}t.$TY=w;function $(n,j){let H=0,K=n.length;for(;H<K;){const G=Math.floor((H+K)/2);j(n[G])?H=G+1:K=G}return H-1}function F(n,j){const H=$(n,j);return H===-1?void 0:n[H]}t.$UY=F;function I(n,j){let H=0,K=n.length;for(;H<K;){const G=Math.floor((H+K)/2);j(n[G])?K=G:H=G+1}return H}function P(n,j){const H=I(n,j);return H===n.length?void 0:n[H]}t.$VY=P;function U(n){return n>=97&&n<=122||n>=65&&n<=90||n>=48&&n<=57}var C;(function(n){n[n.WordLower=0]="WordLower",n[n.WordUpper=1]="WordUpper",n[n.WordNumber=2]="WordNumber",n[n.End=3]="End",n[n.Other=4]="Other",n[n.Space=5]="Space",n[n.LineBreakCR=6]="LineBreakCR",n[n.LineBreakLF=7]="LineBreakLF"})(C||(C={}));const V={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function X(n){return V[n]}function _(n){return n===10?7:n===13?6:z(n)?5:n>=97&&n<=122?0:n>=65&&n<=90?1:n>=48&&n<=57?2:n===-1?3:4}function z(n){return n===32||n===9}const Z=new Map;function J(n){let j=Z.get(n);return j===void 0&&(j=Z.size,Z.set(n,j)),j}class ge{constructor(j,H,K){this.range=j,this.lines=H,this.source=K,this.h=[];let G=0;for(let ie=j.startLineNumber-1;ie<j.endLineNumberExclusive-1;ie++){const ae=H[ie];for(let fe=0;fe<ae.length;fe++){G++;const be=ae[fe],ve=J(be);this.h[ve]=(this.h[ve]||0)+1}G++;const oe=J(`
`);this.h[oe]=(this.h[oe]||0)+1}this.f=G}computeSimilarity(j){let H=0;const K=Math.max(this.h.length,j.h.length);for(let G=0;G<K;G++)H+=Math.abs((this.h[G]??0)-(j.h[G]??0));return 1-H/(this.f+j.f)}}}),re(le[27],ue([0,1,21,26,5,2,10,14]),function(x,t,y,k,i,o,v,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xu=t.$wu=void 0;const s=3;class l{computeDiff(c,r,a){const m=new p(c,r,{maxComputationTime:a.maxComputationTimeMs,shouldIgnoreTrimWhitespace:a.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),L=[];let w=null;for(const $ of m.changes){let F;$.originalEndLineNumber===0?F=new u.$Wr($.originalStartLineNumber+1,$.originalStartLineNumber+1):F=new u.$Wr($.originalStartLineNumber,$.originalEndLineNumber+1);let I;$.modifiedEndLineNumber===0?I=new u.$Wr($.modifiedStartLineNumber+1,$.modifiedStartLineNumber+1):I=new u.$Wr($.modifiedStartLineNumber,$.modifiedEndLineNumber+1);let P=new k.$Yr(F,I,$.charChanges?.map(U=>new k.$Zr(new o.$Vr(U.originalStartLineNumber,U.originalStartColumn,U.originalEndLineNumber,U.originalEndColumn),new o.$Vr(U.modifiedStartLineNumber,U.modifiedStartColumn,U.modifiedEndLineNumber,U.modifiedEndColumn))));w&&(w.modifiedRange.endLineNumberExclusive===P.modifiedRange.startLineNumber||w.originalRange.endLineNumberExclusive===P.originalRange.startLineNumber)&&(P=new k.$Yr(w.originalRange.join(P.originalRange),w.modifiedRange.join(P.modifiedRange),w.innerChanges&&P.innerChanges?w.innerChanges.concat(P.innerChanges):void 0),L.pop()),L.push(P),w=P}return(0,v.$yb)(()=>(0,v.$zb)(L,($,F)=>F.originalRange.startLineNumber-$.originalRange.endLineNumberExclusive===F.modifiedRange.startLineNumber-$.modifiedRange.endLineNumberExclusive&&$.originalRange.endLineNumberExclusive<F.originalRange.startLineNumber&&$.modifiedRange.endLineNumberExclusive<F.modifiedRange.startLineNumber)),new k.$Xr(L,[],m.quitEarly)}}t.$wu=l;function h(g,c,r,a){return new y.$vu(g,c,r).ComputeDiff(a)}class R{constructor(c){const r=[],a=[];for(let E=0,m=c.length;E<m;E++)r[E]=A(c[E],1),a[E]=b(c[E],1);this.lines=c,this.a=r,this.b=a}getElements(){const c=[];for(let r=0,a=this.lines.length;r<a;r++)c[r]=this.lines[r].substring(this.a[r]-1,this.b[r]-1);return c}getStrictElement(c){return this.lines[c]}getStartLineNumber(c){return c+1}getEndLineNumber(c){return c+1}createCharSequence(c,r,a){const E=[],m=[],L=[];let w=0;for(let $=r;$<=a;$++){const F=this.lines[$],I=c?this.a[$]:1,P=c?this.b[$]:F.length+1;for(let U=I;U<P;U++)E[w]=F.charCodeAt(U-1),m[w]=$+1,L[w]=U,w++;!c&&$<a&&(E[w]=10,m[w]=$+1,L[w]=F.length+1,w++)}return new f(E,m,L)}}class f{constructor(c,r,a){this.a=c,this.b=r,this.d=a}toString(){return"["+this.a.map((c,r)=>(c===10?"\\n":String.fromCharCode(c))+`-(${this.b[r]},${this.d[r]})`).join(", ")+"]"}e(c,r){if(c<0||c>=r.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(c){return c>0&&c===this.b.length?this.getEndLineNumber(c-1):(this.e(c,this.b),this.b[c])}getEndLineNumber(c){return c===-1?this.getStartLineNumber(c+1):(this.e(c,this.b),this.a[c]===10?this.b[c]+1:this.b[c])}getStartColumn(c){return c>0&&c===this.d.length?this.getEndColumn(c-1):(this.e(c,this.d),this.d[c])}getEndColumn(c){return c===-1?this.getStartColumn(c+1):(this.e(c,this.d),this.a[c]===10?1:this.d[c]+1)}}class d{constructor(c,r,a,E,m,L,w,$){this.originalStartLineNumber=c,this.originalStartColumn=r,this.originalEndLineNumber=a,this.originalEndColumn=E,this.modifiedStartLineNumber=m,this.modifiedStartColumn=L,this.modifiedEndLineNumber=w,this.modifiedEndColumn=$}static createFromDiffChange(c,r,a){const E=r.getStartLineNumber(c.originalStart),m=r.getStartColumn(c.originalStart),L=r.getEndLineNumber(c.originalStart+c.originalLength-1),w=r.getEndColumn(c.originalStart+c.originalLength-1),$=a.getStartLineNumber(c.modifiedStart),F=a.getStartColumn(c.modifiedStart),I=a.getEndLineNumber(c.modifiedStart+c.modifiedLength-1),P=a.getEndColumn(c.modifiedStart+c.modifiedLength-1);return new d(E,m,L,w,$,F,I,P)}}function e(g){if(g.length<=1)return g;const c=[g[0]];let r=c[0];for(let a=1,E=g.length;a<E;a++){const m=g[a],L=m.originalStart-(r.originalStart+r.originalLength),w=m.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(L,w)<s?(r.originalLength=m.originalStart+m.originalLength-r.originalStart,r.modifiedLength=m.modifiedStart+m.modifiedLength-r.modifiedStart):(c.push(m),r=m)}return c}class N{constructor(c,r,a,E,m){this.originalStartLineNumber=c,this.originalEndLineNumber=r,this.modifiedStartLineNumber=a,this.modifiedEndLineNumber=E,this.charChanges=m}static createFromDiffResult(c,r,a,E,m,L,w){let $,F,I,P,U;if(r.originalLength===0?($=a.getStartLineNumber(r.originalStart)-1,F=0):($=a.getStartLineNumber(r.originalStart),F=a.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(I=E.getStartLineNumber(r.modifiedStart)-1,P=0):(I=E.getStartLineNumber(r.modifiedStart),P=E.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),L&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&m()){const C=a.createCharSequence(c,r.originalStart,r.originalStart+r.originalLength-1),V=E.createCharSequence(c,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(C.getElements().length>0&&V.getElements().length>0){let X=h(C,V,m,!0).changes;w&&(X=e(X)),U=[];for(let _=0,z=X.length;_<z;_++)U.push(d.createFromDiffChange(X[_],C,V))}}return new N($,F,I,P,U)}}class p{constructor(c,r,a){this.a=a.shouldComputeCharChanges,this.b=a.shouldPostProcessCharChanges,this.d=a.shouldIgnoreTrimWhitespace,this.e=a.shouldMakePrettyDiff,this.f=c,this.g=r,this.h=new R(c),this.j=new R(r),this.k=M(a.maxComputationTime),this.l=M(a.maxComputationTime===0?0:Math.min(a.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const c=h(this.h,this.j,this.k,this.e),r=c.changes,a=c.quitEarly;if(this.d){const w=[];for(let $=0,F=r.length;$<F;$++)w.push(N.createFromDiffResult(this.d,r[$],this.h,this.j,this.l,this.a,this.b));return{quitEarly:a,changes:w}}const E=[];let m=0,L=0;for(let w=-1,$=r.length;w<$;w++){const F=w+1<$?r[w+1]:null,I=F?F.originalStart:this.f.length,P=F?F.modifiedStart:this.g.length;for(;m<I&&L<P;){const U=this.f[m],C=this.g[L];if(U!==C){{let V=A(U,1),X=A(C,1);for(;V>1&&X>1;){const _=U.charCodeAt(V-2),z=C.charCodeAt(X-2);if(_!==z)break;V--,X--}(V>1||X>1)&&this.m(E,m+1,1,V,L+1,1,X)}{let V=b(U,1),X=b(C,1);const _=U.length+1,z=C.length+1;for(;V<_&&X<z;){const Z=U.charCodeAt(V-1),J=U.charCodeAt(X-1);if(Z!==J)break;V++,X++}(V<_||X<z)&&this.m(E,m+1,V,_,L+1,X,z)}}m++,L++}F&&(E.push(N.createFromDiffResult(this.d,F,this.h,this.j,this.l,this.a,this.b)),m+=F.originalLength,L+=F.modifiedLength)}return{quitEarly:a,changes:E}}m(c,r,a,E,m,L,w){if(this.n(c,r,a,E,m,L,w))return;let $;this.a&&($=[new d(r,a,r,E,m,L,m,w)]),c.push(new N(r,r,m,m,$))}n(c,r,a,E,m,L,w){const $=c.length;if($===0)return!1;const F=c[$-1];return F.originalEndLineNumber===0||F.modifiedEndLineNumber===0?!1:F.originalEndLineNumber===r&&F.modifiedEndLineNumber===m?(this.a&&F.charChanges&&F.charChanges.push(new d(r,a,r,E,m,L,m,w)),!0):F.originalEndLineNumber+1===r&&F.modifiedEndLineNumber+1===m?(F.originalEndLineNumber=r,F.modifiedEndLineNumber=m,this.a&&F.charChanges&&F.charChanges.push(new d(r,a,r,E,m,L,m,w)),!0):!1}}t.$xu=p;function A(g,c){const r=i.$Ad(g);return r===-1?c:r+1}function b(g,c){const r=i.$Cd(g);return r===-1?c:r+2}function M(g){if(g===0)return()=>!0;const c=Date.now();return()=>Date.now()-c<g}}),re(le[46],ue([0,1,27,45]),function(x,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WY=void 0,t.$WY={getLegacy:()=>new y.$wu,getAdvanced:()=>new k.$PY}}),re(le[47],ue([0,1,29]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XY=void 0;function k(f){const d=[];for(const e of f){const N=Number(e);(N||N===0&&e.replace(/\s/g,"")!=="")&&d.push(N)}return d}function i(f,d,e,N){return{red:f/255,blue:e/255,green:d/255,alpha:N}}function o(f,d){const e=d.index,N=d[0].length;if(!e)return;const p=f.positionAt(e);return{startLineNumber:p.lineNumber,startColumn:p.column,endLineNumber:p.lineNumber,endColumn:p.column+N}}function v(f,d){if(!f)return;const e=y.$es.Format.CSS.parseHex(d);if(e)return{range:f,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function u(f,d,e){if(!f||d.length!==1)return;const p=d[0].values(),A=k(p);return{range:f,color:i(A[0],A[1],A[2],e?A[3]:1)}}function s(f,d,e){if(!f||d.length!==1)return;const p=d[0].values(),A=k(p),b=new y.$es(new y.$cs(A[0],A[1]/100,A[2]/100,e?A[3]:1));return{range:f,color:i(b.rgba.r,b.rgba.g,b.rgba.b,b.rgba.a)}}function l(f,d){return typeof f=="string"?[...f.matchAll(d)]:f.findMatches(d)}function h(f){const d=[],N=l(f,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(N.length>0)for(const p of N){const A=p.filter(c=>c!==void 0),b=A[1],M=A[2];if(!M)continue;let g;if(b==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;g=u(o(f,p),l(M,c),!1)}else if(b==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=u(o(f,p),l(M,c),!0)}else if(b==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;g=s(o(f,p),l(M,c),!1)}else if(b==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=s(o(f,p),l(M,c),!0)}else b==="#"&&(g=v(o(f,p),b+M));g&&d.push(g)}return d}function R(f){return!f||typeof f.getValue!="function"||typeof f.positionAt!="function"?[]:h(f)}t.$XY=R}),re(le[48],ue([0,1,24]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yY=t.$xY=t.$wY=t.State=void 0;var k;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(k||(t.State=k={}));class i{constructor(e,N,p){const A=new Uint8Array(e*N);for(let b=0,M=e*N;b<M;b++)A[b]=p;this.a=A,this.rows=e,this.cols=N}get(e,N){return this.a[e*this.cols+N]}set(e,N,p){this.a[e*this.cols+N]=p}}class o{constructor(e){let N=0,p=0;for(let b=0,M=e.length;b<M;b++){const[g,c,r]=e[b];c>N&&(N=c),g>p&&(p=g),r>p&&(p=r)}N++,p++;const A=new i(p,N,0);for(let b=0,M=e.length;b<M;b++){const[g,c,r]=e[b];A.set(g,c,r)}this.a=A,this.b=N}nextState(e,N){return N<0||N>=this.b?0:this.a.get(e,N)}}t.$wY=o;let v=null;function u(){return v===null&&(v=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),v}var s;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(s||(s={}));let l=null;function h(){if(l===null){l=new y.$0r(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<d.length;N++)l.set(d.charCodeAt(N),1);const e=".,;:";for(let N=0;N<e.length;N++)l.set(e.charCodeAt(N),2)}return l}class R{static a(e,N,p,A,b){let M=b-1;do{const g=N.charCodeAt(M);if(e.get(g)!==2)break;M--}while(M>A);if(A>0){const g=N.charCodeAt(A-1),c=N.charCodeAt(M);(g===40&&c===41||g===91&&c===93||g===123&&c===125)&&M--}return{range:{startLineNumber:p,startColumn:A+1,endLineNumber:p,endColumn:M+2},url:N.substring(A,M+1)}}static computeLinks(e,N=u()){const p=h(),A=[];for(let b=1,M=e.getLineCount();b<=M;b++){const g=e.getLineContent(b),c=g.length;let r=0,a=0,E=0,m=1,L=!1,w=!1,$=!1,F=!1;for(;r<c;){let I=!1;const P=g.charCodeAt(r);if(m===13){let U;switch(P){case 40:L=!0,U=0;break;case 41:U=L?0:1;break;case 91:$=!0,w=!0,U=0;break;case 93:$=!1,U=w?0:1;break;case 123:F=!0,U=0;break;case 125:U=F?0:1;break;case 39:case 34:case 96:E===P?U=1:E===39||E===34||E===96?U=0:U=1;break;case 42:U=E===42?1:0;break;case 124:U=E===124?1:0;break;case 32:U=$?0:1;break;default:U=p.get(P)}U===1&&(A.push(R.a(p,g,b,a,r)),I=!0)}else if(m===12){let U;P===91?(w=!0,U=0):U=p.get(P),U===1?I=!0:m=13}else m=N.nextState(m,P),m===0&&(I=!0);I&&(m=1,L=!1,w=!1,F=!1,a=r+1,E=P),r++}m===13&&A.push(R.a(p,g,b,a,c))}return A}}t.$xY=R;function f(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:R.computeLinks(d)}t.$yY=f}),re(le[49],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zY=void 0;class y{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,o,v,u,s){if(i&&o){const l=this.a(o,s);if(l)return{range:i,value:l}}if(v&&u){const l=this.a(u,s);if(l)return{range:v,value:l}}return null}a(i,o){const v=this.b(i,o);return v!==null?v:this.d(i,o)}b(i,o){const v=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let u=Number(i);const s=parseFloat(i);return!isNaN(u)&&!isNaN(s)&&u===s?u===0&&!o?null:(u=Math.floor(u*v),u+=o?v:-v,String(u/v)):null}d(i,o){return this.e(this.c,i,o)}e(i,o,v){let u=null;for(let s=0,l=i.length;u===null&&s<l;s++)u=this.f(i[s],o,v);return u}f(i,o,v){let u=i.indexOf(o);return u>=0?(u+=v?1:-1,u<0?u=i.length-1:u%=i.length,i[u]):null}}t.$zY=y,y.INSTANCE=new y}),re(le[50],ue([0,1,12]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9t=t.$8t=t.$7t=t.$6t=t.ModelConstants=t.PositionAffinity=t.$5t=t.TrackedRangeStickiness=t.$4t=t.$3t=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var k;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(k||(t.OverviewRulerLane=k={}));var i;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var o;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var v;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var u;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(u||(t.EndOfLinePreference=u={}));var s;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(s||(t.DefaultEndOfLine=s={}));var l;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(l||(t.EndOfLineSequence=l={}));class h{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,y.$Nm)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}t.$3t=h;class R{constructor(c,r){this._findMatchBrand=void 0,this.range=c,this.matches=r}}t.$4t=R;var f;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(f||(t.TrackedRangeStickiness=f={}));function d(g){return g&&typeof g.read=="function"}t.$5t=d;var e;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var N;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(N||(t.ModelConstants=N={}));class p{constructor(c,r,a,E,m,L){this.identifier=c,this.range=r,this.text=a,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=m,this._isTracked=L}}t.$6t=p;class A{constructor(c,r,a){this.regex=c,this.wordSeparators=r,this.simpleSearch=a}}t.$7t=A;class b{constructor(c,r,a){this.reverseEdits=c,this.changes=r,this.trimAutoWhitespaceLineNumbers=a}}t.$8t=b;function M(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}t.$9t=M}),re(le[51],ue([0,1,15,23]),function(x,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cu=t.$Bu=t.$Au=void 0;class i{constructor(s){this.a=s,this.b=new Uint32Array(s.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(s,l){s=(0,k.$kd)(s);const h=this.a,R=this.b,f=l.length;return f===0?!1:(this.a=new Uint32Array(h.length+f),this.a.set(h.subarray(0,s),0),this.a.set(h.subarray(s),s+f),this.a.set(l,s),s-1<this.c[0]&&(this.c[0]=s-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}setValue(s,l){return s=(0,k.$kd)(s),l=(0,k.$kd)(l),this.a[s]===l?!1:(this.a[s]=l,s-1<this.c[0]&&(this.c[0]=s-1),!0)}removeValues(s,l){s=(0,k.$kd)(s),l=(0,k.$kd)(l);const h=this.a,R=this.b;if(s>=h.length)return!1;const f=h.length-s;return l>=f&&(l=f),l===0?!1:(this.a=new Uint32Array(h.length-l),this.a.set(h.subarray(0,s),0),this.a.set(h.subarray(s+l),s),this.b=new Uint32Array(this.a.length),s-1<this.c[0]&&(this.c[0]=s-1),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(s){return s<0?0:(s=(0,k.$kd)(s),this.d(s))}d(s){if(s<=this.c[0])return this.b[s];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),s>=this.a.length&&(s=this.a.length-1);for(let h=l;h<=s;h++)this.b[h]=this.b[h-1]+this.a[h];return this.c[0]=Math.max(this.c[0],s),this.b[s]}getIndexOf(s){s=Math.floor(s),this.getTotalSum();let l=0,h=this.a.length-1,R=0,f=0,d=0;for(;l<=h;)if(R=l+(h-l)/2|0,f=this.b[R],d=f-this.a[R],s<d)h=R-1;else if(s>=f)l=R+1;else break;return new v(R,s-d)}}t.$Au=i;class o{constructor(s){this.a=s,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(s){return this.g(),s===0?0:this.d[s-1]}getIndexOf(s){this.g();const l=this.e[s],h=l>0?this.d[l-1]:0;return new v(l,s-h)}removeValues(s,l){this.a.splice(s,l),this.f(s)}insertValues(s,l){this.a=(0,y.$Af)(this.a,s,l),this.f(s)}f(s){this.b=!1,this.c=Math.min(this.c,s-1)}g(){if(!this.b){for(let s=this.c+1,l=this.a.length;s<l;s++){const h=this.a[s],R=s>0?this.d[s-1]:0;this.d[s]=R+h;for(let f=0;f<h;f++)this.e[R+f]=s}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(s,l){this.a[s]!==l&&(this.a[s]=l,this.f(s))}}t.$Bu=o;class v{constructor(s,l){this.index=s,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=s,this.remainder=l}}t.$Cu=v}),re(le[52],ue([0,1,5,4,51]),function(x,t,y,k,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Du=void 0;class o{constructor(u,s,l,h){this.d=u,this.f=s,this.g=l,this.h=h,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(u){u.eol&&u.eol!==this.g&&(this.g=u.eol,this.j=null);const s=u.changes;for(const l of s)this.o(l.range),this.p(new k.$Ur(l.range.startLineNumber,l.range.startColumn),l.text);this.h=u.versionId,this.k=null}l(){if(!this.j){const u=this.g.length,s=this.f.length,l=new Uint32Array(s);for(let h=0;h<s;h++)l[h]=this.f[h].length+u;this.j=new i.$Au(l)}}n(u,s){this.f[u]=s,this.j&&this.j.setValue(u,this.f[u].length+this.g.length)}o(u){if(u.startLineNumber===u.endLineNumber){if(u.startColumn===u.endColumn)return;this.n(u.startLineNumber-1,this.f[u.startLineNumber-1].substring(0,u.startColumn-1)+this.f[u.startLineNumber-1].substring(u.endColumn-1));return}this.n(u.startLineNumber-1,this.f[u.startLineNumber-1].substring(0,u.startColumn-1)+this.f[u.endLineNumber-1].substring(u.endColumn-1)),this.f.splice(u.startLineNumber,u.endLineNumber-u.startLineNumber),this.j&&this.j.removeValues(u.startLineNumber,u.endLineNumber-u.startLineNumber)}p(u,s){if(s.length===0)return;const l=(0,y.$zd)(s);if(l.length===1){this.n(u.lineNumber-1,this.f[u.lineNumber-1].substring(0,u.column-1)+l[0]+this.f[u.lineNumber-1].substring(u.column-1));return}l[l.length-1]+=this.f[u.lineNumber-1].substring(u.column-1),this.n(u.lineNumber-1,this.f[u.lineNumber-1].substring(0,u.column-1)+l[0]);const h=new Uint32Array(l.length-1);for(let R=1;R<l.length;R++)this.f.splice(u.lineNumber+R-1,0,l[R]),h[R-1]=l[R].length+this.g.length;this.j&&this.j.insertValues(u.lineNumber,h)}}t.$Du=o}),re(le[53],ue([0,1,5,40,4,2,50]),function(x,t,y,k,i,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cC=t.$bC=t.$aC=t.$_B=t.$$B=t.$0B=void 0;const u=999;class s{constructor(b,M,g,c){this.searchString=b,this.isRegex=M,this.matchCase=g,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=l(this.searchString):b=this.searchString.indexOf(`
`)>=0;let M=null;try{M=y.$xd(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!M)return null;let g=!this.isRegex&&!b;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new v.$7t(M,this.wordSeparators?(0,k.$as)(this.wordSeparators):null,g?this.searchString:null)}}t.$0B=s;function l(A){if(!A||A.length===0)return!1;for(let b=0,M=A.length;b<M;b++){const g=A.charCodeAt(b);if(g===10)return!0;if(g===92){if(b++,b>=M)break;const c=A.charCodeAt(b);if(c===110||c===114||c===87)return!0}}return!1}t.$$B=l;function h(A,b,M){if(!M)return new v.$4t(A,null);const g=[];for(let c=0,r=b.length;c<r;c++)g[c]=b[c];return new v.$4t(A,g)}t.$_B=h;class R{constructor(b){const M=[];let g=0;for(let c=0,r=b.length;c<r;c++)b.charCodeAt(c)===10&&(M[g++]=c);this.a=M}findLineFeedCountBeforeOffset(b){const M=this.a;let g=0,c=M.length-1;if(c===-1||b<=M[0])return 0;for(;g<c;){const r=g+((c-g)/2>>0);M[r]>=b?c=r-1:M[r+1]>=b?(g=r,c=r):g=r+1}return g+1}}class f{static findMatches(b,M,g,c,r){const a=M.parseSearchRequest();return a?a.regex.multiline?this.b(b,g,new p(a.wordSeparators,a.regex),c,r):this.c(b,g,a,c,r):[]}static a(b,M,g,c,r,a){let E,m=0;c?(m=c.findLineFeedCountBeforeOffset(r),E=M+r+m):E=M+r;let L;if(c){const I=c.findLineFeedCountBeforeOffset(r+a.length)-m;L=E+a.length+I}else L=E+a.length;const w=b.getPositionAt(E),$=b.getPositionAt(L);return new o.$Vr(w.lineNumber,w.column,$.lineNumber,$.column)}static b(b,M,g,c,r){const a=b.getOffsetAt(M.getStartPosition()),E=b.getValueInRange(M,1),m=b.getEOL()===`\r
`?new R(E):null,L=[];let w=0,$;for(g.reset(0);$=g.next(E);)if(L[w++]=h(this.a(b,a,E,m,$.index,$[0]),$,c),w>=r)return L;return L}static c(b,M,g,c,r){const a=[];let E=0;if(M.startLineNumber===M.endLineNumber){const L=b.getLineContent(M.startLineNumber).substring(M.startColumn-1,M.endColumn-1);return E=this.d(g,L,M.startLineNumber,M.startColumn-1,E,a,c,r),a}const m=b.getLineContent(M.startLineNumber).substring(M.startColumn-1);E=this.d(g,m,M.startLineNumber,M.startColumn-1,E,a,c,r);for(let L=M.startLineNumber+1;L<M.endLineNumber&&E<r;L++)E=this.d(g,b.getLineContent(L),L,0,E,a,c,r);if(E<r){const L=b.getLineContent(M.endLineNumber).substring(0,M.endColumn-1);E=this.d(g,L,M.endLineNumber,0,E,a,c,r)}return a}static d(b,M,g,c,r,a,E,m){const L=b.wordSeparators;if(!E&&b.simpleSearch){const F=b.simpleSearch,I=F.length,P=M.length;let U=-I;for(;(U=M.indexOf(F,U+I))!==-1;)if((!L||N(L,M,P,U,I))&&(a[r++]=new v.$4t(new o.$Vr(g,U+1+c,g,U+1+I+c),null),r>=m))return r;return r}const w=new p(b.wordSeparators,b.regex);let $;w.reset(0);do if($=w.next(M),$&&(a[r++]=h(new o.$Vr(g,$.index+1+c,g,$.index+1+$[0].length+c),$,E),r>=m))return r;while($);return r}static findNextMatch(b,M,g,c){const r=M.parseSearchRequest();if(!r)return null;const a=new p(r.wordSeparators,r.regex);return r.regex.multiline?this.e(b,g,a,c):this.f(b,g,a,c)}static e(b,M,g,c){const r=new i.$Ur(M.lineNumber,1),a=b.getOffsetAt(r),E=b.getLineCount(),m=b.getValueInRange(new o.$Vr(r.lineNumber,r.column,E,b.getLineMaxColumn(E)),1),L=b.getEOL()===`\r
`?new R(m):null;g.reset(M.column-1);const w=g.next(m);return w?h(this.a(b,a,m,L,w.index,w[0]),w,c):M.lineNumber!==1||M.column!==1?this.e(b,new i.$Ur(1,1),g,c):null}static f(b,M,g,c){const r=b.getLineCount(),a=M.lineNumber,E=b.getLineContent(a),m=this.g(g,E,a,M.column,c);if(m)return m;for(let L=1;L<=r;L++){const w=(a+L-1)%r,$=b.getLineContent(w+1),F=this.g(g,$,w+1,1,c);if(F)return F}return null}static g(b,M,g,c,r){b.reset(c-1);const a=b.next(M);return a?h(new o.$Vr(g,a.index+1,g,a.index+1+a[0].length),a,r):null}static findPreviousMatch(b,M,g,c){const r=M.parseSearchRequest();if(!r)return null;const a=new p(r.wordSeparators,r.regex);return r.regex.multiline?this.h(b,g,a,c):this.j(b,g,a,c)}static h(b,M,g,c){const r=this.b(b,new o.$Vr(1,1,M.lineNumber,M.column),g,c,10*u);if(r.length>0)return r[r.length-1];const a=b.getLineCount();return M.lineNumber!==a||M.column!==b.getLineMaxColumn(a)?this.h(b,new i.$Ur(a,b.getLineMaxColumn(a)),g,c):null}static j(b,M,g,c){const r=b.getLineCount(),a=M.lineNumber,E=b.getLineContent(a).substring(0,M.column-1),m=this.k(g,E,a,c);if(m)return m;for(let L=1;L<=r;L++){const w=(r+a-L-1)%r,$=b.getLineContent(w+1),F=this.k(g,$,w+1,c);if(F)return F}return null}static k(b,M,g,c){let r=null,a;for(b.reset(0);a=b.next(M);)r=h(new o.$Vr(g,a.index+1,g,a.index+1+a[0].length),a,c);return r}}t.$aC=f;function d(A,b,M,g,c){if(g===0)return!0;const r=b.charCodeAt(g-1);if(A.get(r)!==0||r===13||r===10)return!0;if(c>0){const a=b.charCodeAt(g);if(A.get(a)!==0)return!0}return!1}function e(A,b,M,g,c){if(g+c===M)return!0;const r=b.charCodeAt(g+c);if(A.get(r)!==0||r===13||r===10)return!0;if(c>0){const a=b.charCodeAt(g+c-1);if(A.get(a)!==0)return!0}return!1}function N(A,b,M,g,c){return d(A,b,M,g,c)&&e(A,b,M,g,c)}t.$bC=N;class p{constructor(b,M){this._wordSeparators=b,this.a=M,this.b=-1,this.c=0}reset(b){this.a.lastIndex=b,this.b=-1,this.c=0}next(b){const M=b.length;let g;do{if(this.b+this.c===M||(g=this.a.exec(b),!g))return null;const c=g.index,r=g[0].length;if(c===this.b&&r===this.c){if(r===0){y.$Sd(b,M,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=r,!this._wordSeparators||N(this._wordSeparators,b,M,c,r))return g}while(g);return null}}t.$cC=p}),re(le[54],ue([0,1,2,53,5,10,25]),function(x,t,y,k,i,o,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$vY=void 0;class u{static computeUnicodeHighlights(e,N,p){const A=p?p.startLineNumber:1,b=p?p.endLineNumber:e.getLineCount(),M=new h(N),g=M.getCandidateCodePoints();let c;g==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${s(Array.from(g))}`,"g");const r=new k.$cC(null,c),a=[];let E=!1,m,L=0,w=0,$=0;e:for(let F=A,I=b;F<=I;F++){const P=e.getLineContent(F),U=P.length;r.reset(0);do if(m=r.next(P),m){let C=m.index,V=m.index+m[0].length;if(C>0){const Z=P.charCodeAt(C-1);i.$Pd(Z)&&C--}if(V+1<U){const Z=P.charCodeAt(V-1);i.$Pd(Z)&&V++}const X=P.substring(C,V);let _=(0,v.$Rr)(C+1,v.$Or,P,0);_&&_.endColumn<=C+1&&(_=null);const z=M.shouldHighlightNonBasicASCII(X,_?_.word:null);if(z!==0){z===3?L++:z===2?w++:z===1?$++:(0,o.$wb)(z);const Z=1e3;if(a.length>=Z){E=!0;break e}a.push(new y.$Vr(F,C+1,F,V+1))}}while(m)}return{ranges:a,hasMore:E,ambiguousCharacterCount:L,invisibleCharacterCount:w,nonBasicAsciiCharacterCount:$}}static computeUnicodeHighlightReason(e,N){const p=new h(N);switch(p.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const b=e.codePointAt(0),M=p.ambiguousCharacters.getPrimaryConfusable(b),g=i.$ge.getLocales().filter(c=>!i.$ge.getInstance(new Set([...N.allowedLocales,c])).isAmbiguous(b));return{kind:0,confusableWith:String.fromCodePoint(M),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}t.$vY=u;function s(d,e){return`[${i.$pd(d.map(p=>String.fromCodePoint(p)).join(""))}]`}var l;(function(d){d[d.Ambiguous=0]="Ambiguous",d[d.Invisible=1]="Invisible",d[d.NonBasicAscii=2]="NonBasicAscii"})(l||(t.UnicodeHighlighterReasonKind=l={}));class h{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.$ge.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const N of i.$he.codePoints)R(String.fromCodePoint(N))||e.add(N);if(this.b.ambiguousCharacters)for(const N of this.ambiguousCharacters.getConfusableCodePoints())e.add(N);for(const N of this.a)e.delete(N);return e}shouldHighlightNonBasicASCII(e,N){const p=e.codePointAt(0);if(this.a.has(p))return 0;if(this.b.nonBasicASCII)return 1;let A=!1,b=!1;if(N)for(const M of N){const g=M.codePointAt(0),c=i.$1d(M);A=A||c,!c&&!this.ambiguousCharacters.isAmbiguous(g)&&!i.$he.isInvisibleCharacter(g)&&(b=!0)}return!A&&b?0:this.b.invisibleCharacters&&!R(e)&&i.$he.isInvisibleCharacter(p)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(p)?3:0}}function R(d){return d===" "||d===`
`||d==="	"}var f;(function(d){d[d.None=0]="None",d[d.NonBasicASCII=1]="NonBasicASCII",d[d.Invisible=2]="Invisible",d[d.Ambiguous=3]="Ambiguous"})(f||(f={}))}),re(le[55],ue([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var y;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(y||(t.AccessibilitySupport=y={}));var k;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(k||(t.CodeActionTriggerType=k={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var o;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var v;(function(n){n[n.Deprecated=1]="Deprecated"})(v||(t.CompletionItemTag=v={}));var u;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u||(t.CompletionTriggerKind=u={}));var s;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(s||(t.ContentWidgetPositionPreference=s={}));var l;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(l||(t.CursorChangeReason=l={}));var h;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var R;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(R||(t.DocumentHighlightKind=R={}));var f;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(f||(t.EditorAutoIndentStrategy=f={}));var d;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=8]="autoClosingDelete",n[n.autoClosingOvertype=9]="autoClosingOvertype",n[n.autoClosingQuotes=10]="autoClosingQuotes",n[n.autoIndent=11]="autoIndent",n[n.automaticLayout=12]="automaticLayout",n[n.autoSurround=13]="autoSurround",n[n.bracketPairColorization=14]="bracketPairColorization",n[n.guides=15]="guides",n[n.codeLens=16]="codeLens",n[n.codeLensFontFamily=17]="codeLensFontFamily",n[n.codeLensFontSize=18]="codeLensFontSize",n[n.colorDecorators=19]="colorDecorators",n[n.colorDecoratorsLimit=20]="colorDecoratorsLimit",n[n.columnSelection=21]="columnSelection",n[n.comments=22]="comments",n[n.contextmenu=23]="contextmenu",n[n.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",n[n.cursorBlinking=25]="cursorBlinking",n[n.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",n[n.cursorStyle=27]="cursorStyle",n[n.cursorSurroundingLines=28]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",n[n.cursorWidth=30]="cursorWidth",n[n.disableLayerHinting=31]="disableLayerHinting",n[n.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",n[n.domReadOnly=33]="domReadOnly",n[n.dragAndDrop=34]="dragAndDrop",n[n.dropIntoEditor=35]="dropIntoEditor",n[n.emptySelectionClipboard=36]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",n[n.extraEditorClassName=38]="extraEditorClassName",n[n.fastScrollSensitivity=39]="fastScrollSensitivity",n[n.find=40]="find",n[n.fixedOverflowWidgets=41]="fixedOverflowWidgets",n[n.folding=42]="folding",n[n.foldingStrategy=43]="foldingStrategy",n[n.foldingHighlight=44]="foldingHighlight",n[n.foldingImportsByDefault=45]="foldingImportsByDefault",n[n.foldingMaximumRegions=46]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=48]="fontFamily",n[n.fontInfo=49]="fontInfo",n[n.fontLigatures=50]="fontLigatures",n[n.fontSize=51]="fontSize",n[n.fontWeight=52]="fontWeight",n[n.fontVariations=53]="fontVariations",n[n.formatOnPaste=54]="formatOnPaste",n[n.formatOnType=55]="formatOnType",n[n.glyphMargin=56]="glyphMargin",n[n.gotoLocation=57]="gotoLocation",n[n.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",n[n.hover=59]="hover",n[n.inDiffEditor=60]="inDiffEditor",n[n.inlineSuggest=61]="inlineSuggest",n[n.letterSpacing=62]="letterSpacing",n[n.lightbulb=63]="lightbulb",n[n.lineDecorationsWidth=64]="lineDecorationsWidth",n[n.lineHeight=65]="lineHeight",n[n.lineNumbers=66]="lineNumbers",n[n.lineNumbersMinChars=67]="lineNumbersMinChars",n[n.linkedEditing=68]="linkedEditing",n[n.links=69]="links",n[n.matchBrackets=70]="matchBrackets",n[n.minimap=71]="minimap",n[n.mouseStyle=72]="mouseStyle",n[n.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=74]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",n[n.multiCursorModifier=76]="multiCursorModifier",n[n.multiCursorPaste=77]="multiCursorPaste",n[n.multiCursorLimit=78]="multiCursorLimit",n[n.occurrencesHighlight=79]="occurrencesHighlight",n[n.overviewRulerBorder=80]="overviewRulerBorder",n[n.overviewRulerLanes=81]="overviewRulerLanes",n[n.padding=82]="padding",n[n.pasteAs=83]="pasteAs",n[n.parameterHints=84]="parameterHints",n[n.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",n[n.quickSuggestions=87]="quickSuggestions",n[n.quickSuggestionsDelay=88]="quickSuggestionsDelay",n[n.readOnly=89]="readOnly",n[n.readOnlyMessage=90]="readOnlyMessage",n[n.renameOnType=91]="renameOnType",n[n.renderControlCharacters=92]="renderControlCharacters",n[n.renderFinalNewline=93]="renderFinalNewline",n[n.renderLineHighlight=94]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=96]="renderValidationDecorations",n[n.renderWhitespace=97]="renderWhitespace",n[n.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",n[n.roundedSelection=99]="roundedSelection",n[n.rulers=100]="rulers",n[n.scrollbar=101]="scrollbar",n[n.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=103]="scrollBeyondLastLine",n[n.scrollPredominantAxis=104]="scrollPredominantAxis",n[n.selectionClipboard=105]="selectionClipboard",n[n.selectionHighlight=106]="selectionHighlight",n[n.selectOnLineNumbers=107]="selectOnLineNumbers",n[n.showFoldingControls=108]="showFoldingControls",n[n.showUnused=109]="showUnused",n[n.snippetSuggestions=110]="snippetSuggestions",n[n.smartSelect=111]="smartSelect",n[n.smoothScrolling=112]="smoothScrolling",n[n.stickyScroll=113]="stickyScroll",n[n.stickyTabStops=114]="stickyTabStops",n[n.stopRenderingLineAfter=115]="stopRenderingLineAfter",n[n.suggest=116]="suggest",n[n.suggestFontSize=117]="suggestFontSize",n[n.suggestLineHeight=118]="suggestLineHeight",n[n.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",n[n.suggestSelection=120]="suggestSelection",n[n.tabCompletion=121]="tabCompletion",n[n.tabIndex=122]="tabIndex",n[n.unicodeHighlighting=123]="unicodeHighlighting",n[n.unusualLineTerminators=124]="unusualLineTerminators",n[n.useShadowDOM=125]="useShadowDOM",n[n.useTabStops=126]="useTabStops",n[n.wordBreak=127]="wordBreak",n[n.wordSeparators=128]="wordSeparators",n[n.wordWrap=129]="wordWrap",n[n.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=132]="wordWrapColumn",n[n.wordWrapOverride1=133]="wordWrapOverride1",n[n.wordWrapOverride2=134]="wordWrapOverride2",n[n.wrappingIndent=135]="wrappingIndent",n[n.wrappingStrategy=136]="wrappingStrategy",n[n.showDeprecated=137]="showDeprecated",n[n.inlayHints=138]="inlayHints",n[n.editorClassName=139]="editorClassName",n[n.pixelRatio=140]="pixelRatio",n[n.tabFocusMode=141]="tabFocusMode",n[n.layoutInfo=142]="layoutInfo",n[n.wrappingInfo=143]="wrappingInfo",n[n.defaultColorDecorators=144]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(d||(t.EditorOption=d={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var N;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(N||(t.EndOfLineSequence=N={}));var p;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(p||(t.GlyphMarginLane=p={}));var A;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(A||(t.IndentAction=A={}));var b;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(b||(t.InjectedTextCursorStops=b={}));var M;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(M||(t.InlayHintKind=M={}));var g;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(g||(t.InlineCompletionTriggerKind=g={}));var c;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(c||(t.KeyCode=c={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var E;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(E||(t.MinimapPosition=E={}));var m;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(m||(t.MouseTargetType=m={}));var L;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(L||(t.OverlayWidgetPositionPreference=L={}));var w;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(w||(t.OverviewRulerLane=w={}));var $;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})($||(t.PositionAffinity=$={}));var F;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(F||(t.RenderLineNumbersType=F={}));var I;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(I||(t.RenderMinimap=I={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P||(t.ScrollType=P={}));var U;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(U||(t.ScrollbarVisibility=U={}));var C;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(C||(t.SelectionDirection=C={}));var V;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(V||(t.SignatureHelpTriggerKind=V={}));var X;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(X||(t.SymbolKind=X={}));var _;(function(n){n[n.Deprecated=1]="Deprecated"})(_||(t.SymbolTag=_={}));var z;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(z||(t.TextEditorCursorBlinkingStyle=z={}));var Z;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(Z||(t.TextEditorCursorStyle=Z={}));var J;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(J||(t.TrackedRangeStickiness=J={}));var ge;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(ge||(t.WrappingIndent=ge={}))}),re(le[56],ue([0,1,8,7]),function(x,t,y,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ls=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new y.$ec,this.onDidChange=this.c.event,this.d=null}handleChange(u){this.c.fire({changedLanguages:u,changedColorMap:!1})}register(u,s){return this.a.set(u,s),this.handleChange([u]),(0,k.$jb)(()=>{this.a.get(u)===s&&(this.a.delete(u),this.handleChange([u]))})}get(u){return this.a.get(u)||null}registerFactory(u,s){this.b.get(u)?.dispose();const l=new o(this,u,s);return this.b.set(u,l),(0,k.$jb)(()=>{const h=this.b.get(u);!h||h!==l||(this.b.delete(u),h.dispose())})}async getOrCreate(u){const s=this.get(u);if(s)return s;const l=this.b.get(u);return!l||l.isResolved?null:(await l.resolve(),this.get(u))}isResolved(u){if(this.get(u))return!0;const l=this.b.get(u);return!!(!l||l.isResolved)}setColorMap(u){this.d=u,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$ls=i;class o extends k.$lb{get isResolved(){return this.c}constructor(u,s,l){super(),this.f=u,this.g=s,this.h=l,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const u=await this.h.tokenizationSupport;this.c=!0,u&&!this.a&&this.B(this.f.register(this.g,u))}}}),re(le[57],ue([62,63]),function(x,t){return x.create("vs/editor/common/languages",t)}),re(le[58],ue([0,1,37,13,38,2,56,57]),function(x,t,y,k,i,o,v,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$Ds=t.$Cs=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$Bs=t.$As=t.SymbolKinds=t.SymbolTag=t.$zs=t.$ys=t.SymbolKind=t.$xs=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$ws=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$vs=t.$us=t.$ts=void 0;class s{constructor(z,Z,J){this.offset=z,this.type=Z,this.language=J,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$ts=s;class l{constructor(z,Z){this.tokens=z,this.endState=Z,this._tokenizationResultBrand=void 0}}t.$us=l;class h{constructor(z,Z){this.tokens=z,this.endState=Z,this._encodedTokenizationResultBrand=void 0}}t.$vs=h;var R;(function(_){_[_.Method=0]="Method",_[_.Function=1]="Function",_[_.Constructor=2]="Constructor",_[_.Field=3]="Field",_[_.Variable=4]="Variable",_[_.Class=5]="Class",_[_.Struct=6]="Struct",_[_.Interface=7]="Interface",_[_.Module=8]="Module",_[_.Property=9]="Property",_[_.Event=10]="Event",_[_.Operator=11]="Operator",_[_.Unit=12]="Unit",_[_.Value=13]="Value",_[_.Constant=14]="Constant",_[_.Enum=15]="Enum",_[_.EnumMember=16]="EnumMember",_[_.Keyword=17]="Keyword",_[_.Text=18]="Text",_[_.Color=19]="Color",_[_.File=20]="File",_[_.Reference=21]="Reference",_[_.Customcolor=22]="Customcolor",_[_.Folder=23]="Folder",_[_.TypeParameter=24]="TypeParameter",_[_.User=25]="User",_[_.Issue=26]="Issue",_[_.Snippet=27]="Snippet"})(R||(t.CompletionItemKind=R={}));var f;(function(_){const z=new Map;z.set(0,y.$Cj.symbolMethod),z.set(1,y.$Cj.symbolFunction),z.set(2,y.$Cj.symbolConstructor),z.set(3,y.$Cj.symbolField),z.set(4,y.$Cj.symbolVariable),z.set(5,y.$Cj.symbolClass),z.set(6,y.$Cj.symbolStruct),z.set(7,y.$Cj.symbolInterface),z.set(8,y.$Cj.symbolModule),z.set(9,y.$Cj.symbolProperty),z.set(10,y.$Cj.symbolEvent),z.set(11,y.$Cj.symbolOperator),z.set(12,y.$Cj.symbolUnit),z.set(13,y.$Cj.symbolValue),z.set(15,y.$Cj.symbolEnum),z.set(14,y.$Cj.symbolConstant),z.set(15,y.$Cj.symbolEnum),z.set(16,y.$Cj.symbolEnumMember),z.set(17,y.$Cj.symbolKeyword),z.set(27,y.$Cj.symbolSnippet),z.set(18,y.$Cj.symbolText),z.set(19,y.$Cj.symbolColor),z.set(20,y.$Cj.symbolFile),z.set(21,y.$Cj.symbolReference),z.set(22,y.$Cj.symbolCustomColor),z.set(23,y.$Cj.symbolFolder),z.set(24,y.$Cj.symbolTypeParameter),z.set(25,y.$Cj.account),z.set(26,y.$Cj.issues);function Z(n){let j=z.get(n);return j||(console.info("No codicon found for CompletionItemKind "+n),j=y.$Cj.symbolProperty),j}_.toIcon=Z;const J=new Map;J.set("method",0),J.set("function",1),J.set("constructor",2),J.set("field",3),J.set("variable",4),J.set("class",5),J.set("struct",6),J.set("interface",7),J.set("module",8),J.set("property",9),J.set("event",10),J.set("operator",11),J.set("unit",12),J.set("value",13),J.set("constant",14),J.set("enum",15),J.set("enum-member",16),J.set("enumMember",16),J.set("keyword",17),J.set("snippet",27),J.set("text",18),J.set("color",19),J.set("file",20),J.set("reference",21),J.set("customcolor",22),J.set("folder",23),J.set("type-parameter",24),J.set("typeParameter",24),J.set("account",25),J.set("issue",26);function ge(n,j){let H=J.get(n);return typeof H>"u"&&!j&&(H=9),H}_.fromString=ge})(f||(t.CompletionItemKinds=f={}));var d;(function(_){_[_.Deprecated=1]="Deprecated"})(d||(t.CompletionItemTag=d={}));var e;(function(_){_[_.None=0]="None",_[_.KeepWhitespace=1]="KeepWhitespace",_[_.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var N;(function(_){_[_.Invoke=0]="Invoke",_[_.TriggerCharacter=1]="TriggerCharacter",_[_.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(N||(t.CompletionTriggerKind=N={}));var p;(function(_){_[_.Automatic=0]="Automatic",_[_.Explicit=1]="Explicit"})(p||(t.InlineCompletionTriggerKind=p={}));class A{constructor(z,Z,J,ge){this.range=z,this.text=Z,this.completionKind=J,this.isSnippetText=ge}equals(z){return o.$Vr.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}t.$ws=A;var b;(function(_){_[_.Invoke=1]="Invoke",_[_.Auto=2]="Auto"})(b||(t.CodeActionTriggerType=b={}));var M;(function(_){_[_.Invoke=1]="Invoke",_[_.TriggerCharacter=2]="TriggerCharacter",_[_.ContentChange=3]="ContentChange"})(M||(t.SignatureHelpTriggerKind=M={}));var g;(function(_){_[_.Text=0]="Text",_[_.Read=1]="Read",_[_.Write=2]="Write"})(g||(t.DocumentHighlightKind=g={}));function c(_){return _&&k.URI.isUri(_.uri)&&o.$Vr.isIRange(_.range)&&(o.$Vr.isIRange(_.originSelectionRange)||o.$Vr.isIRange(_.targetSelectionRange))}t.$xs=c;var r;(function(_){_[_.File=0]="File",_[_.Module=1]="Module",_[_.Namespace=2]="Namespace",_[_.Package=3]="Package",_[_.Class=4]="Class",_[_.Method=5]="Method",_[_.Property=6]="Property",_[_.Field=7]="Field",_[_.Constructor=8]="Constructor",_[_.Enum=9]="Enum",_[_.Interface=10]="Interface",_[_.Function=11]="Function",_[_.Variable=12]="Variable",_[_.Constant=13]="Constant",_[_.String=14]="String",_[_.Number=15]="Number",_[_.Boolean=16]="Boolean",_[_.Array=17]="Array",_[_.Object=18]="Object",_[_.Key=19]="Key",_[_.Null=20]="Null",_[_.EnumMember=21]="EnumMember",_[_.Struct=22]="Struct",_[_.Event=23]="Event",_[_.Operator=24]="Operator",_[_.TypeParameter=25]="TypeParameter"})(r||(t.SymbolKind=r={})),t.$ys={[17]:(0,u.localize)(0,null),[16]:(0,u.localize)(1,null),[4]:(0,u.localize)(2,null),[13]:(0,u.localize)(3,null),[8]:(0,u.localize)(4,null),[9]:(0,u.localize)(5,null),[21]:(0,u.localize)(6,null),[23]:(0,u.localize)(7,null),[7]:(0,u.localize)(8,null),[0]:(0,u.localize)(9,null),[11]:(0,u.localize)(10,null),[10]:(0,u.localize)(11,null),[19]:(0,u.localize)(12,null),[5]:(0,u.localize)(13,null),[1]:(0,u.localize)(14,null),[2]:(0,u.localize)(15,null),[20]:(0,u.localize)(16,null),[15]:(0,u.localize)(17,null),[18]:(0,u.localize)(18,null),[24]:(0,u.localize)(19,null),[3]:(0,u.localize)(20,null),[6]:(0,u.localize)(21,null),[14]:(0,u.localize)(22,null),[22]:(0,u.localize)(23,null),[25]:(0,u.localize)(24,null),[12]:(0,u.localize)(25,null)};function a(_,z){return(0,u.localize)(26,null,_,t.$ys[z])}t.$zs=a;var E;(function(_){_[_.Deprecated=1]="Deprecated"})(E||(t.SymbolTag=E={}));var m;(function(_){const z=new Map;z.set(0,y.$Cj.symbolFile),z.set(1,y.$Cj.symbolModule),z.set(2,y.$Cj.symbolNamespace),z.set(3,y.$Cj.symbolPackage),z.set(4,y.$Cj.symbolClass),z.set(5,y.$Cj.symbolMethod),z.set(6,y.$Cj.symbolProperty),z.set(7,y.$Cj.symbolField),z.set(8,y.$Cj.symbolConstructor),z.set(9,y.$Cj.symbolEnum),z.set(10,y.$Cj.symbolInterface),z.set(11,y.$Cj.symbolFunction),z.set(12,y.$Cj.symbolVariable),z.set(13,y.$Cj.symbolConstant),z.set(14,y.$Cj.symbolString),z.set(15,y.$Cj.symbolNumber),z.set(16,y.$Cj.symbolBoolean),z.set(17,y.$Cj.symbolArray),z.set(18,y.$Cj.symbolObject),z.set(19,y.$Cj.symbolKey),z.set(20,y.$Cj.symbolNull),z.set(21,y.$Cj.symbolEnumMember),z.set(22,y.$Cj.symbolStruct),z.set(23,y.$Cj.symbolEvent),z.set(24,y.$Cj.symbolOperator),z.set(25,y.$Cj.symbolTypeParameter);function Z(J){let ge=z.get(J);return ge||(console.info("No codicon found for SymbolKind "+J),ge=y.$Cj.symbolProperty),ge}_.toIcon=Z})(m||(t.SymbolKinds=m={}));class L{static asEditOperation(z){return i.$3r.replace(o.$Vr.lift(z.range),z.text)}}t.$As=L;class w{static fromValue(z){switch(z){case"comment":return w.Comment;case"imports":return w.Imports;case"region":return w.Region}return new w(z)}constructor(z){this.value=z}}t.$Bs=w,w.Comment=new w("comment"),w.Imports=new w("imports"),w.Region=new w("region");var $;(function(_){function z(Z){return!Z||typeof Z!="object"?!1:typeof Z.id=="string"&&typeof Z.title=="string"}_.is=z})($||(t.Command=$={}));var F;(function(_){_[_.Collapsed=0]="Collapsed",_[_.Expanded=1]="Expanded"})(F||(t.CommentThreadCollapsibleState=F={}));var I;(function(_){_[_.Unresolved=0]="Unresolved",_[_.Resolved=1]="Resolved"})(I||(t.CommentThreadState=I={}));var P;(function(_){_[_.Editing=0]="Editing",_[_.Preview=1]="Preview"})(P||(t.CommentMode=P={}));var U;(function(_){_[_.Published=0]="Published",_[_.Draft=1]="Draft"})(U||(t.CommentState=U={}));var C;(function(_){_[_.Type=1]="Type",_[_.Parameter=2]="Parameter"})(C||(t.InlayHintKind=C={}));class V{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$Cs=V,t.$Ds=new v.$ls;var X;(function(_){_[_.None=0]="None",_[_.Option=1]="Option",_[_.Default=2]="Default",_[_.Preferred=3]="Preferred"})(X||(t.ExternalUriOpenerPriority=X={}))}),re(le[59],ue([0,1,20,8,31,13,4,2,39,58,55]),function(x,t,y,k,i,o,v,u,s,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BY=t.$AY=void 0;class R{static chord(e,N){return(0,i.$nq)(e,N)}}t.$AY=R,R.CtrlCmd=2048,R.Shift=1024,R.Alt=512,R.WinCtrl=256;function f(){return{editor:void 0,languages:void 0,CancellationTokenSource:y.$oc,Emitter:k.$ec,KeyCode:h.KeyCode,KeyMod:R,Position:v.$Ur,Range:u.$Vr,Selection:s.$4r,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:o.URI,Token:l.$ts}}t.$BY=f}),re(le[64],ue([0,1,21,13,4,2,52,25,48,49,59,19,54,27,46,12,3,47]),function(x,t,y,k,i,o,v,u,s,l,h,R,f,d,e,N,p,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class b extends v.$Du{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const a=[];for(let E=0;E<this.f.length;E++){const m=this.f[E],L=this.offsetAt(new i.$Ur(E+1,1)),w=m.matchAll(r);for(const $ of w)($.index||$.index===0)&&($.index=$.index+L),a.push($)}return a}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,a){const E=(0,u.$Rr)(r.column,(0,u.$Pr)(a),this.f[r.lineNumber-1],0);return E?new o.$Vr(r.lineNumber,E.startColumn,r.lineNumber,E.endColumn):null}getWordUntilPosition(r,a){const E=this.getWordAtPosition(r,a);return E?{word:this.f[r.lineNumber-1].substring(E.startColumn-1,r.column-1),startColumn:E.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const a=this.f,E=this.q.bind(this);let m=0,L="",w=0,$=[];return{*[Symbol.iterator](){for(;;)if(w<$.length){const F=L.substring($[w].start,$[w].end);w+=1,yield F}else if(m<a.length)L=a[m],$=E(L,r),w=0,m+=1;else break}}}getLineWords(r,a){const E=this.f[r-1],m=this.q(E,a),L=[];for(const w of m)L.push({word:E.substring(w.start,w.end),startColumn:w.start+1,endColumn:w.end+1});return L}q(r,a){const E=[];let m;for(a.lastIndex=0;(m=a.exec(r))&&m[0].length!==0;)E.push({start:m.index,end:m.index+m[0].length});return E}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const a=this.g,E=r.startLineNumber-1,m=r.endLineNumber-1,L=[];L.push(this.f[E].substring(r.startColumn-1));for(let w=E+1;w<m;w++)L.push(this.f[w]);return L.push(this.f[m].substring(0,r.endColumn-1)),L.join(a)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const a=this.j.getIndexOf(r),E=this.f[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,E)}}r(r){const a=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),E=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return a.lineNumber!==r.startLineNumber||a.column!==r.startColumn||E.lineNumber!==r.endLineNumber||E.column!==r.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:E.lineNumber,endColumn:E.column}:r}s(r){if(!i.$Ur.isIPosition(r))throw new Error("bad position");let{lineNumber:a,column:E}=r,m=!1;if(a<1)a=1,E=1,m=!0;else if(a>this.f.length)a=this.f.length,E=this.f[a-1].length+1,m=!0;else{const L=this.f[a-1].length+1;E<1?(E=1,m=!0):E>L&&(E=L,m=!0)}return m?{lineNumber:a,column:E}:r}}class M{constructor(r,a){this.d=r,this.f=Object.create(null),this.g=a,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(a=>r.push(this.f[a])),r}acceptNewModel(r){this.f[r.url]=new b(k.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,a){if(!this.f[r])return;this.f[r].onEvents(a)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,a,E){const m=this.j(r);return m?f.$vY.computeUnicodeHighlights(m,a,E):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,a,E,m){const L=this.j(r),w=this.j(a);return!L||!w?null:M.l(L,w,E,m)}static l(r,a,E,m){const L=m==="advanced"?e.$WY.getAdvanced():e.$WY.getLegacy(),w=r.getLinesContent(),$=a.getLinesContent(),F=L.computeDiff(w,$,E),I=F.changes.length>0?!1:this.n(r,a);function P(U){return U.map(C=>[C.originalRange.startLineNumber,C.originalRange.endLineNumberExclusive,C.modifiedRange.startLineNumber,C.modifiedRange.endLineNumberExclusive,C.innerChanges?.map(V=>[V.originalRange.startLineNumber,V.originalRange.startColumn,V.originalRange.endLineNumber,V.originalRange.endColumn,V.modifiedRange.startLineNumber,V.modifiedRange.startColumn,V.modifiedRange.endLineNumber,V.modifiedRange.endColumn])])}return{identical:I,quitEarly:F.hitTimeout,changes:P(F.changes),moves:F.moves.map(U=>[U.lineRangeMapping.original.startLineNumber,U.lineRangeMapping.original.endLineNumberExclusive,U.lineRangeMapping.modified.startLineNumber,U.lineRangeMapping.modified.endLineNumberExclusive,P(U.changes)])}}static n(r,a){const E=r.getLineCount(),m=a.getLineCount();if(E!==m)return!1;for(let L=1;L<=E;L++){const w=r.getLineContent(L),$=a.getLineContent(L);if(w!==$)return!1}return!0}async computeDirtyDiff(r,a,E){const m=this.j(r),L=this.j(a);if(!m||!L)return null;const w=m.getLinesContent(),$=L.getLinesContent();return new d.$xu(w,$,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:E,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(r,a,E){const m=this.j(r);if(!m)return a;const L=[];let w;a=a.slice(0).sort(($,F)=>{if($.range&&F.range)return o.$Vr.compareRangesUsingStarts($.range,F.range);const I=$.range?0:1,P=F.range?0:1;return I-P});for(let{range:$,text:F,eol:I}of a){if(typeof I=="number"&&(w=I),o.$Vr.isEmpty($)&&!F)continue;const P=m.getValueInRange($);if(F=F.replace(/\r\n|\n|\r/g,m.eol),P===F)continue;if(Math.max(F.length,P.length)>M.o){L.push({range:$,text:F});continue}const U=(0,y.$uu)(P,F,E),C=m.offsetAt(o.$Vr.lift($).getStartPosition());for(const V of U){const X=m.positionAt(C+V.originalStart),_=m.positionAt(C+V.originalStart+V.originalLength),z={text:F.substr(V.modifiedStart,V.modifiedLength),range:{startLineNumber:X.lineNumber,startColumn:X.column,endLineNumber:_.lineNumber,endColumn:_.column}};m.getValueInRange(z.range)!==z.text&&L.push(z)}}return typeof w=="number"&&L.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeHumanReadableDiff(r,a,E){const m=this.j(r);if(!m)return a;const L=[];let w;a=a.slice(0).sort(($,F)=>{if($.range&&F.range)return o.$Vr.compareRangesUsingStarts($.range,F.range);const I=$.range?0:1,P=F.range?0:1;return I-P});for(let{range:$,text:F,eol:I}of a){let _=function(Z,J){return new i.$Ur(Z.lineNumber+J.lineNumber-1,J.lineNumber===1?Z.column+J.column-1:J.column)},z=function(Z,J){const ge=[];for(let n=J.startLineNumber;n<=J.endLineNumber;n++){const j=Z[n-1];n===J.startLineNumber&&n===J.endLineNumber?ge.push(j.substring(J.startColumn-1,J.endColumn-1)):n===J.startLineNumber?ge.push(j.substring(J.startColumn-1)):n===J.endLineNumber?ge.push(j.substring(0,J.endColumn-1)):ge.push(j)}return ge};if(typeof I=="number"&&(w=I),o.$Vr.isEmpty($)&&!F)continue;const P=m.getValueInRange($);if(F=F.replace(/\r\n|\n|\r/g,m.eol),P===F)continue;if(Math.max(F.length,P.length)>M.o){L.push({range:$,text:F});continue}const U=P.split(/\r\n|\n|\r/),C=F.split(/\r\n|\n|\r/),V=e.$WY.getAdvanced().computeDiff(U,C,E),X=o.$Vr.lift($).getStartPosition();for(const Z of V.changes)if(Z.innerChanges)for(const J of Z.innerChanges)L.push({range:o.$Vr.fromPositions(_(X,J.originalRange.getStartPosition()),_(X,J.originalRange.getEndPosition())),text:z(C,J.modifiedRange).join(m.eol)});else throw new p.$bb("The experimental diff algorithm always produces inner changes")}return typeof w=="number"&&L.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeLinks(r){const a=this.j(r);return a?(0,s.$yY)(a):null}async computeDefaultDocumentColors(r){const a=this.j(r);return a?(0,A.$XY)(a):null}async textualSuggest(r,a,E,m){const L=new R.$ac,w=new RegExp(E,m),$=new Set;e:for(const F of r){const I=this.j(F);if(I){for(const P of I.words(w))if(!(P===a||!isNaN(Number(P)))&&($.add(P),$.size>M.p))break e}}return{words:Array.from($),duration:L.elapsed()}}async computeWordRanges(r,a,E,m){const L=this.j(r);if(!L)return Object.create(null);const w=new RegExp(E,m),$=Object.create(null);for(let F=a.startLineNumber;F<a.endLineNumber;F++){const I=L.getLineWords(F,w);for(const P of I){if(!isNaN(Number(P.word)))continue;let U=$[P.word];U||(U=[],$[P.word]=U),U.push({startLineNumber:F,startColumn:P.startColumn,endLineNumber:F,endColumn:P.endColumn})}}return $}async navigateValueSet(r,a,E,m,L){const w=this.j(r);if(!w)return null;const $=new RegExp(m,L);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const F=w.getValueInRange(a),I=w.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},$);if(!I)return null;const P=w.getValueInRange(I);return l.$zY.INSTANCE.navigateValueSet(a,F,I,P,E)}loadForeignModule(r,a,E){const m=($,F)=>this.d.fhr($,F),w={host:(0,N.$Um)(E,m),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(w,a),Promise.resolve((0,N.$Tm)(this.h))):new Promise(($,F)=>{x([r],I=>{this.h=I.create(w,a),$((0,N.$Tm)(this.h))},F)})}fmr(r,a){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,a))}catch(E){return Promise.reject(E)}}}t.EditorSimpleWorker=M,M.o=1e5,M.p=1e4;function g(c){return new M(c,null)}t.create=g,typeof importScripts=="function"&&(globalThis.monaco=(0,h.$BY)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
