"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","os","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/mime","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/json","vs/base/common/glob","path","net","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","vs/server/node/server.main"],be=function(le){for(var e=[],v=0,R=le.length;v<R;v++)e[v]=we[le[v]];return e};define(we[95],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class v{static get(){const r=new Map,S=new Map,I=new Map,P=new Map;function b(l,d){l.has(d.detail)||l.set(d.detail,-d.timestamp)}function $(l,d){const m=l.get(d.detail);m&&(m>=0||l.set(d.detail,m+d.timestamp))}let A=[];typeof le=="function"&&typeof le.getStats=="function"&&(A=le.getStats().slice(0).sort((l,d)=>l.timestamp-d.timestamp));for(const l of A)switch(l.type){case 10:b(r,l);break;case 11:case 12:$(r,l);break;case 21:b(S,l);break;case 22:$(S,l);break;case 33:b(I,l);break;case 34:$(I,l);break;case 31:b(P,l);break;case 32:$(P,l);break}let E=0;I.forEach(l=>E+=l);function w(l){const d=[];return l.forEach((m,c)=>d.push([c,m])),d}return{amdLoad:w(r),amdInvoke:w(S),nodeRequire:w(I),nodeEval:w(P),nodeRequireTotal:E}}static toMarkdownTable(r,S){let I="";const P=[];return r.forEach((b,$)=>{P[$]=b.length}),S.forEach(b=>{b.forEach(($,A)=>{typeof $>"u"&&($=b[A]="-");const E=$.toString().length;P[A]=Math.max(E,P[A])})}),r.forEach((b,$)=>{I+=`| ${b+" ".repeat(P[$]-b.toString().length)} `}),I+=`|
`,r.forEach((b,$)=>{I+=`| ${"-".repeat(P[$])} `}),I+=`|
`,S.forEach(b=>{b.forEach(($,A)=>{typeof $<"u"&&(I+=`| ${$+" ".repeat(P[A]-$.toString().length)} `)}),I+=`|
`}),I}}e.$S=v}),define(we[73],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function v(I){return(P,b,$)=>{let A=null,E=null;if(typeof $.value=="function"?(A="value",E=$.value):typeof $.get=="function"&&(A="get",E=$.get),!E)throw new Error("not supported");$[A]=I(E,b)}}function R(I,P,b){let $=null,A=null;if(typeof b.value=="function"?($="value",A=b.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&($="get",A=b.get),!A)throw new Error("not supported");const E=`$memoize$${P}`;b[$]=function(...w){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,w)}),this[E]}}e.$Tg=R;function r(I,P,b){return v(($,A)=>{const E=`$debounce$${A}`,w=`$debounce$result$${A}`;return function(...l){this[w]||(this[w]=b?b():void 0),clearTimeout(this[E]),P&&(this[w]=P(this[w],...l),l=[this[w]]),this[E]=setTimeout(()=>{$.apply(this,l),this[w]=b?b():void 0},I)}})}e.$Ug=r;function S(I,P,b){return v(($,A)=>{const E=`$throttle$timer$${A}`,w=`$throttle$result$${A}`,l=`$throttle$lastRun$${A}`,d=`$throttle$pending$${A}`;return function(...m){if(this[w]||(this[w]=b?b():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),P&&(this[w]=P(this[w],...m)),this[d])return;const c=this[l]+I;c<=Date.now()?(this[l]=Date.now(),$.apply(this,[this[w]]),this[w]=b?b():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[l]=Date.now(),$.apply(this,[this[w]]),this[w]=b?b():void 0},c-Date.now()))}})}e.$Vg=S}),define(we[11],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class v{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?y.isErrorNoTelemetry(i)?new y(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(a=>{a(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=v,e.$V=new v;function R(t){e.$V.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=R;function r(t){if(!t||typeof t!="object")return!1;const i=t;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$X=r;function S(t){$(t)||e.$V.onUnexpectedError(t)}e.$Y=S;function I(t){$(t)||e.$V.onUnexpectedExternalError(t)}e.$Z=I;function P(t){if(t instanceof Error){const{name:i,message:a}=t,s=t.stacktrace||t.stack;return{$isError:!0,name:i,message:a,stack:s,noTelemetry:y.isErrorNoTelemetry(t)}}return t}e.$1=P;const b="Canceled";function $(t){return t instanceof A?!0:t instanceof Error&&t.name===b&&t.message===b}e.$2=$;class A extends Error{constructor(){super(b),this.name=this.message}}e.$3=A;function E(){const t=new Error(b);return t.name=t.message,t}e.$4=E;function w(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$5=w;function l(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$6=l;function d(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=d;function m(t){const i=new Error(`${t} has been disposed`);return i.name="DISPOSED",i}e.$8=m;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$9=c;class u extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=u;class h extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=h;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=g;class y extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof y)return i;const a=new y;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=y;class p extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.$bb=p}),define(we[18],be([1,0,11]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.CompareResult=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.top=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=void 0;function R(F,z=0){return F[F.length-(1+z)]}e.$9e=R;function r(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$0e=r;function S(F,z,j=(B,Q)=>B===Q){if(F===z)return!0;if(!F||!z||F.length!==z.length)return!1;for(let B=0,Q=F.length;B<Q;B++)if(!j(F[B],z[B]))return!1;return!0}e.$$e=S;function I(F,z){const j=F.length-1;z<j&&(F[z]=F[j]),F.pop()}e.$_e=I;function P(F,z,j){return b(F.length,B=>j(F[B],z))}e.$af=P;function b(F,z){let j=0,B=F-1;for(;j<=B;){const Q=(j+B)/2|0,de=z(Q);if(de<0)j=Q+1;else if(de>0)B=Q-1;else return Q}return-(j+1)}e.$bf=b;function $(F,z){let j=0,B=F.length;if(B===0)return 0;for(;j<B;){const Q=Math.floor((j+B)/2);z(F[Q])?B=Q:j=Q+1}return j}e.$cf=$;function A(F,z,j){if(F=F|0,F>=z.length)throw new TypeError("invalid index");const B=z[Math.floor(z.length*Math.random())],Q=[],de=[],Ee=[];for(const Pe of z){const Re=j(Pe,B);Re<0?Q.push(Pe):Re>0?de.push(Pe):Ee.push(Pe)}return F<Q.length?A(F,Q,j):F<Q.length+Ee.length?Ee[0]:A(F-(Q.length+Ee.length),de,j)}e.$df=A;function E(F,z){const j=[];let B;for(const Q of F.slice(0).sort(z))!B||z(B[0],Q)!==0?(B=[Q],j.push(B)):B.push(Q);return j}e.$ef=E;function w(F,z,j){const B=[];function Q(Pe,Re,Fe){if(Re===0&&Fe.length===0)return;const $e=B[B.length-1];$e&&$e.start+$e.deleteCount===Pe?($e.deleteCount+=Re,$e.toInsert.push(...Fe)):B.push({start:Pe,deleteCount:Re,toInsert:Fe})}let de=0,Ee=0;for(;;){if(de===F.length){Q(de,0,z.slice(Ee));break}if(Ee===z.length){Q(de,F.length-de,[]);break}const Pe=F[de],Re=z[Ee],Fe=j(Pe,Re);Fe===0?(de+=1,Ee+=1):Fe<0?(Q(de,1,[]),de+=1):Fe>0&&(Q(de,0,[Re]),Ee+=1)}return B}e.$ff=w;function l(F,z,j){const B=w(F,z,j),Q=[],de=[];for(const Ee of B)Q.push(...F.slice(Ee.start,Ee.start+Ee.deleteCount)),de.push(...Ee.toInsert);return{removed:Q,added:de}}e.$gf=l;function d(F,z,j){if(j===0)return[];const B=F.slice(0,j).sort(z);return c(F,z,B,j,F.length),B}e.top=d;function m(F,z,j,B,Q){return j===0?Promise.resolve([]):new Promise((de,Ee)=>{(async()=>{const Pe=F.length,Re=F.slice(0,j).sort(z);for(let Fe=j,$e=Math.min(j+B,Pe);Fe<Pe;Fe=$e,$e=Math.min($e+B,Pe)){if(Fe>j&&await new Promise(ke=>setTimeout(ke)),Q&&Q.isCancellationRequested)throw new v.$3;c(F,z,Re,Fe,$e)}return Re})().then(de,Ee)})}e.$if=m;function c(F,z,j,B,Q){for(const de=j.length;B<Q;B++){const Ee=F[B];if(z(Ee,j[de-1])<0){j.pop();const Pe=$(j,Re=>z(Ee,Re)<0);j.splice(Pe,0,Ee)}}}function u(F){return F.filter(z=>!!z)}e.$jf=u;function h(F){let z=0;for(let j=0;j<F.length;j++)F[j]&&(F[z]=F[j],z+=1);F.length=z}e.$kf=h;function g(F,z,j){F.splice(j,0,F.splice(z,1)[0])}e.$lf=g;function y(F){return!Array.isArray(F)||F.length===0}e.$mf=y;function p(F){return Array.isArray(F)&&F.length>0}e.$nf=p;function t(F,z=j=>j){const j=new Set;return F.filter(B=>{const Q=z(B);return j.has(Q)?!1:(j.add(Q),!0)})}e.$of=t;function i(F){const z=new Set;return j=>{const B=F(j);return z.has(B)?!1:(z.add(B),!0)}}e.$pf=i;function a(F,z){const j=s(F,z);if(j!==-1)return F[j]}e.$qf=a;function s(F,z){for(let j=F.length-1;j>=0;j--){const B=F[j];if(z(B))return j}return-1}e.$rf=s;function n(F,z){return F.length>0?F[0]:z}e.$sf=n;function o(F,z){return F.length>0?F[F.length-1]:z}e.$tf=o;function f(F,z,j=(B,Q)=>B===Q){let B=0;for(let Q=0,de=Math.min(F.length,z.length);Q<de&&j(F[Q],z[Q]);Q++)B++;return B}e.$uf=f;function k(F){return[].concat(...F)}e.$vf=k;function D(F,z){let j=typeof z=="number"?F:0;typeof z=="number"?j=F:(j=0,z=F);const B=[];if(j<=z)for(let Q=j;Q<z;Q++)B.push(Q);else for(let Q=j;Q>z;Q--)B.push(Q);return B}e.$wf=D;function C(F,z,j){return F.reduce((B,Q)=>(B[z(Q)]=j?j(Q):Q,B),Object.create(null))}e.$xf=C;function L(F,z){return F.push(z),()=>U(F,z)}e.$yf=L;function U(F,z){const j=F.indexOf(z);if(j>-1)return F.splice(j,1),z}e.$zf=U;function x(F,z,j){const B=F.slice(0,z),Q=F.slice(z);return B.concat(j,Q)}e.$Af=x;function ae(F,z){let j;if(typeof z=="number"){let B=z;j=()=>{const Q=Math.sin(B++)*179426549;return Q-Math.floor(Q)}}else j=Math.random;for(let B=F.length-1;B>0;B-=1){const Q=Math.floor(j()*(B+1)),de=F[B];F[B]=F[Q],F[Q]=de}}e.$Bf=ae;function W(F,z){const j=F.indexOf(z);j>-1&&(F.splice(j,1),F.unshift(z))}e.$Cf=W;function te(F,z){const j=F.indexOf(z);j>-1&&(F.splice(j,1),F.push(z))}e.$Df=te;function ue(F,z){for(const j of z)F.push(j)}e.$Ef=ue;function Z(F,z){return Array.isArray(F)?F.map(z):z(F)}e.$Ff=Z;function he(F){return Array.isArray(F)?F:[F]}e.$Gf=he;function V(F){return F[Math.floor(Math.random()*F.length)]}e.$Hf=V;function se(F,z){for(const j of F){const B=z(j);if(B!==void 0)return B}}e.$If=se;function K(F,z,j){const B=H(F,z),Q=F.length,de=j.length;F.length=Q+de;for(let Ee=Q-1;Ee>=B;Ee--)F[Ee+de]=F[Ee];for(let Ee=0;Ee<de;Ee++)F[Ee+B]=j[Ee]}e.$Jf=K;function Y(F,z,j,B){const Q=H(F,z),de=F.splice(Q,j);return K(F,Q,B),de}e.$Kf=Y;function H(F,z){return z<0?Math.max(z+F.length,0):Math.min(z,F.length)}var _;(function(F){function z(de){return de<0}F.isLessThan=z;function j(de){return de<=0}F.isLessThanOrEqual=j;function B(de){return de>0}F.isGreaterThan=B;function Q(de){return de===0}F.isNeitherLessOrGreaterThan=Q,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function ge(F,z){return(j,B)=>z(F(j),F(B))}e.$Lf=ge;function ne(...F){return(z,j)=>{for(const B of F){const Q=B(z,j);if(!_.isNeitherLessOrGreaterThan(Q))return Q}return _.neitherLessOrGreaterThan}}e.$Mf=ne;const q=(F,z)=>F-z;e.$Nf=q;const X=(F,z)=>(0,e.$Nf)(F?1:0,z?1:0);e.$Of=X;function O(F){return(z,j)=>-F(z,j)}e.$Pf=O;function N(F,z){if(F.length===0)return;let j=F[0];for(let B=1;B<F.length;B++){const Q=F[B];z(Q,j)>0&&(j=Q)}return j}e.$Qf=N;function J(F,z){if(F.length===0)return;let j=F[0];for(let B=1;B<F.length;B++){const Q=F[B];z(Q,j)>=0&&(j=Q)}return j}e.$Rf=J;function ie(F,z){return N(F,(j,B)=>-z(j,B))}e.$Sf=ie;function re(F,z){if(F.length===0)return-1;let j=0;for(let B=1;B<F.length;B++){const Q=F[B];z(Q,F[j])>0&&(j=B)}return j}e.$Tf=re;class ee{constructor(z){this.f=z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(z){let j=this.c;for(;j<this.f.length&&z(this.f[j]);)j++;const B=j===this.c?null:this.f.slice(this.c,j);return this.c=j,B}takeFromEndWhile(z){let j=this.d;for(;j>=0&&z(this.f[j]);)j--;const B=j===this.d?null:this.f.slice(j+1,this.d+1);return this.d=j,B}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const z=this.f[this.c];return this.c++,z}removeLast(){const z=this.f[this.d];return this.d--,z}takeCount(z){const j=this.f.slice(this.c,this.c+z);return this.c+=z,j}}e.$Uf=ee;class oe{constructor(z){this.iterate=z}forEach(z){this.iterate(j=>(z(j),!0))}toArray(){const z=[];return this.iterate(j=>(z.push(j),!0)),z}filter(z){return new oe(j=>this.iterate(B=>z(B)?j(B):!0))}map(z){return new oe(j=>this.iterate(B=>j(z(B))))}some(z){let j=!1;return this.iterate(B=>(j=z(B),!j)),j}findFirst(z){let j;return this.iterate(B=>z(B)?(j=B,!1):!0),j}findLast(z){let j;return this.iterate(B=>(z(B)&&(j=B),!0)),j}findLastMaxBy(z){let j,B=!0;return this.iterate(Q=>((B||_.isGreaterThan(z(Q,j)))&&(B=!1,j=Q),!0)),j}}e.$Vf=oe,oe.empty=new oe(F=>{})}),define(we[96],be([1,0,11]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zb=e.$yb=e.$xb=e.$wb=e.ok=void 0;function R(b,$){if(!b)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}e.ok=R;function r(b,$="Unreachable"){throw new Error($)}e.$wb=r;function S(b){if(!b)throw new v.$bb("Assertion Failed")}e.$xb=S;function I(b){if(!b()){debugger;b(),(0,v.$Y)(new v.$bb("Assertion Failed"))}}e.$yb=I;function P(b,$){let A=0;for(;A<b.length-1;){const E=b[A],w=b[A+1];if(!$(E,w))return!1;A++}return!0}e.$zb=P}),define(we[74],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function v(R){const r=this;let S=!1,I;return function(){return S||(S=!0,I=R.apply(r,arguments)),I}}e.$cb=v}),define(we[47],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function r(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}R.is=r;const S=Object.freeze([]);function I(){return S}R.empty=I;function*P(y){yield y}R.single=P;function b(y){return r(y)?y:P(y)}R.wrap=b;function $(y){return y||S}R.from=$;function A(y){return!y||y[Symbol.iterator]().next().done===!0}R.isEmpty=A;function E(y){return y[Symbol.iterator]().next().value}R.first=E;function w(y,p){for(const t of y)if(p(t))return!0;return!1}R.some=w;function l(y,p){for(const t of y)if(p(t))return t}R.find=l;function*d(y,p){for(const t of y)p(t)&&(yield t)}R.filter=d;function*m(y,p){let t=0;for(const i of y)yield p(i,t++)}R.map=m;function*c(...y){for(const p of y)for(const t of p)yield t}R.concat=c;function u(y,p,t){let i=t;for(const a of y)i=p(i,a);return i}R.reduce=u;function*h(y,p,t=y.length){for(p<0&&(p+=y.length),t<0?t+=y.length:t>y.length&&(t=y.length);p<t;p++)yield y[p]}R.slice=h;function g(y,p=Number.POSITIVE_INFINITY){const t=[];if(p===0)return[t,y];const i=y[Symbol.iterator]();for(let a=0;a<p;a++){const s=i.next();if(s.done)return[t,R.empty()];t.push(s.value)}return[t,{[Symbol.iterator](){return i}}]}R.consume=g})(v||(e.Iterable=v={}))}),define(we[75],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S||(e.ParseOptions=S={}));function I(t,i=!1){let a=0;const s=t.length;let n="",o=0,f=16,k=0;function D(te){let ue=0,Z=0;for(;ue<te;){const he=t.charCodeAt(a);if(he>=48&&he<=57)Z=Z*16+he-48;else if(he>=65&&he<=70)Z=Z*16+he-65+10;else if(he>=97&&he<=102)Z=Z*16+he-97+10;else break;a++,ue++}return ue<te&&(Z=-1),Z}function C(te){a=te,n="",o=0,f=16,k=0}function L(){const te=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&$(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&$(t.charCodeAt(a)))for(a++;a<t.length&&$(t.charCodeAt(a));)a++;else return k=3,t.substring(te,a);let ue=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&$(t.charCodeAt(a))){for(a++;a<t.length&&$(t.charCodeAt(a));)a++;ue=a}else k=3;return t.substring(te,ue)}function U(){let te="",ue=a;for(;;){if(a>=s){te+=t.substring(ue,a),k=2;break}const Z=t.charCodeAt(a);if(Z===34){te+=t.substring(ue,a),a++;break}if(Z===92){if(te+=t.substring(ue,a),a++,a>=s){k=2;break}switch(t.charCodeAt(a++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const V=D(4);V>=0?te+=String.fromCharCode(V):k=4;break}default:k=5}ue=a;continue}if(Z>=0&&Z<=31)if(b(Z)){te+=t.substring(ue,a),k=2;break}else k=6;a++}return te}function x(){if(n="",k=0,o=a,a>=s)return o=s,f=17;let te=t.charCodeAt(a);if(P(te)){do a++,n+=String.fromCharCode(te),te=t.charCodeAt(a);while(P(te));return f=15}if(b(te))return a++,n+=String.fromCharCode(te),te===13&&t.charCodeAt(a)===10&&(a++,n+=`
`),f=14;switch(te){case 123:return a++,f=1;case 125:return a++,f=2;case 91:return a++,f=3;case 93:return a++,f=4;case 58:return a++,f=6;case 44:return a++,f=5;case 34:return a++,n=U(),f=10;case 47:{const ue=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<s&&!b(t.charCodeAt(a));)a++;return n=t.substring(ue,a),f=12}if(t.charCodeAt(a+1)===42){a+=2;const Z=s-1;let he=!1;for(;a<Z;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,he=!0;break}a++}return he||(a++,k=1),n=t.substring(ue,a),f=13}return n+=String.fromCharCode(te),a++,f=16}case 45:if(n+=String.fromCharCode(te),a++,a===s||!$(t.charCodeAt(a)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=L(),f=11;default:for(;a<s&&ae(te);)a++,te=t.charCodeAt(a);if(o!==a){switch(n=t.substring(o,a),n){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return n+=String.fromCharCode(te),a++,f=16}}function ae(te){if(P(te)||b(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let te;do te=x();while(te>=12&&te<=15);return te}return{setPosition:C,getPosition:()=>a,scan:i?W:x,getToken:()=>f,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>a-o,getTokenError:()=>k}}e.$xm=I;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function E(t,i){const a=[],s=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function k(D,C,L,U){o.value=D,o.offset=C,o.length=L,o.type=U,o.colonOffset=void 0,n=o}try{g(t,{onObjectBegin:(D,C)=>{if(i<=D)throw s;n=void 0,f=i>D,a.push("")},onObjectProperty:(D,C,L)=>{if(i<C||(k(D,C,L,"property"),a[a.length-1]=D,i<=C+L))throw s},onObjectEnd:(D,C)=>{if(i<=D)throw s;n=void 0,a.pop()},onArrayBegin:(D,C)=>{if(i<=D)throw s;n=void 0,a.push(0)},onArrayEnd:(D,C)=>{if(i<=D)throw s;n=void 0,a.pop()},onLiteralValue:(D,C,L)=>{if(i<C||(k(D,C,L,p(D)),i<=C+L))throw s},onSeparator:(D,C,L)=>{if(i<=C)throw s;if(D===":"&&n&&n.type==="property")n.colonOffset=C,f=!1,n=void 0;else if(D===","){const U=a[a.length-1];typeof U=="number"?a[a.length-1]=U+1:(f=!0,a[a.length-1]=""),n=void 0}}})}catch(D){if(D!==s)throw D}return{path:a,previousNode:n,isAtPropertyKey:f,matches:D=>{let C=0;for(let L=0;C<D.length&&L<a.length;L++)if(D[C]===a[L]||D[C]==="*")C++;else if(D[C]!=="**")return!1;return C===D.length}}}e.$ym=E;function w(t,i=[],a=S.DEFAULT){let s=null,n=[];const o=[];function f(D){Array.isArray(n)?n.push(D):s!==null&&(n[s]=D)}return g(t,{onObjectBegin:()=>{const D={};f(D),o.push(n),n=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const D=[];f(D),o.push(n),n=D,s=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:f,onError:(D,C,L)=>{i.push({error:D,offset:C,length:L})}},a),n[0]}e.$zm=w;function l(t,i=[],a=S.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(D){s.type==="property"&&(s.length=D-s.offset,s=s.parent)}function o(D){return s.children.push(D),D}g(t,{onObjectBegin:D=>{s=o({type:"object",offset:D,length:-1,parent:s,children:[]})},onObjectProperty:(D,C,L)=>{s=o({type:"property",offset:C,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:D,offset:C,length:L,parent:s})},onObjectEnd:(D,C)=>{s.length=D+C-s.offset,s=s.parent,n(D+C)},onArrayBegin:(D,C)=>{s=o({type:"array",offset:D,length:-1,parent:s,children:[]})},onArrayEnd:(D,C)=>{s.length=D+C-s.offset,s=s.parent,n(D+C)},onLiteralValue:(D,C,L)=>{o({type:p(D),offset:C,length:L,parent:s,value:D}),n(C+L)},onSeparator:(D,C,L)=>{s.type==="property"&&(D===":"?s.colonOffset=C:D===","&&n(C))},onError:(D,C,L)=>{i.push({error:D,offset:C,length:L})}},a);const k=s.children[0];return k&&delete k.parent,k}e.$Am=l;function d(t,i){if(!t)return;let a=t;for(const s of i)if(typeof s=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let n=!1;for(const o of a.children)if(Array.isArray(o.children)&&o.children[0].value===s){a=o.children[1],n=!0;break}if(!n)return}else{const n=s;if(a.type!=="array"||n<0||!Array.isArray(a.children)||n>=a.children.length)return;a=a.children[n]}return a}e.$Bm=d;function m(t){if(!t.parent||!t.parent.children)return[];const i=m(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;i.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&i.push(a)}return i}e.$Cm=m;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const i=Object.create(null);for(const a of t.children){const s=a.children[1];s&&(i[a.children[0].value]=c(s))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Dm=c;function u(t,i,a=!1){return i>=t.offset&&i<t.offset+t.length||a&&i===t.offset+t.length}e.$Em=u;function h(t,i,a=!1){if(u(t,i,a)){const s=t.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=i;n++){const o=h(s[n],i,a);if(o)return o}return t}}e.$Fm=h;function g(t,i,a=S.DEFAULT){const s=I(t,!1);function n(ge){return ge?()=>ge(s.getTokenOffset(),s.getTokenLength()):()=>!0}function o(ge){return ge?ne=>ge(ne,s.getTokenOffset(),s.getTokenLength()):()=>!0}const f=n(i.onObjectBegin),k=o(i.onObjectProperty),D=n(i.onObjectEnd),C=n(i.onArrayBegin),L=n(i.onArrayEnd),U=o(i.onLiteralValue),x=o(i.onSeparator),ae=n(i.onComment),W=o(i.onError),te=a&&a.disallowComments,ue=a&&a.allowTrailingComma;function Z(){for(;;){const ge=s.scan();switch(s.getTokenError()){case 4:he(14);break;case 5:he(15);break;case 3:he(13);break;case 1:te||he(11);break;case 2:he(12);break;case 6:he(16);break}switch(ge){case 12:case 13:te?he(10):ae();break;case 16:he(1);break;case 15:case 14:break;default:return ge}}}function he(ge,ne=[],q=[]){if(W(ge),ne.length+q.length>0){let X=s.getToken();for(;X!==17;){if(ne.indexOf(X)!==-1){Z();break}else if(q.indexOf(X)!==-1)break;X=Z()}}}function V(ge){const ne=s.getTokenValue();return ge?U(ne):k(ne),Z(),!0}function se(){switch(s.getToken()){case 11:{let ge=0;try{ge=JSON.parse(s.getTokenValue()),typeof ge!="number"&&(he(2),ge=0)}catch{he(2)}U(ge);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return Z(),!0}function K(){return s.getToken()!==10?(he(3,[],[2,5]),!1):(V(!1),s.getToken()===6?(x(":"),Z(),_()||he(4,[],[2,5])):he(5,[],[2,5]),!0)}function Y(){f(),Z();let ge=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ge||he(4,[],[]),x(","),Z(),s.getToken()===2&&ue)break}else ge&&he(6,[],[]);K()||he(4,[],[2,5]),ge=!0}return D(),s.getToken()!==2?he(7,[2],[]):Z(),!0}function H(){C(),Z();let ge=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ge||he(4,[],[]),x(","),Z(),s.getToken()===4&&ue)break}else ge&&he(6,[],[]);_()||he(4,[],[4,5]),ge=!0}return L(),s.getToken()!==4?he(8,[4],[]):Z(),!0}function _(){switch(s.getToken()){case 3:return H();case 1:return Y();case 10:return V(!0);default:return se()}}return Z(),s.getToken()===17?a.allowEmptyContent?!0:(he(4,[],[]),!1):_()?(s.getToken()!==17&&he(9,[],[]),!0):(he(4,[],[]),!1)}e.$Gm=g;function y(t,i){const a=I(t),s=[];let n,o=0,f;do switch(f=a.getPosition(),n=a.scan(),n){case 12:case 13:case 17:o!==f&&s.push(t.substring(o,f)),i!==void 0&&s.push(a.getTokenValue().replace(/[^\r\n]/g,i)),o=a.getPosition();break}while(n!==17);return s.join("")}e.$Hm=y;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Im=p}),define(we[97],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class v{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=v}),define(we[2],be([1,0,74,47]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const r=!1;let S=null;function I(o){S=o}if(e.$db=I,r){const o="__is_disposable_tracked__";I(new class{trackDisposable(f){const k=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[o]||console.log(k)},3e3)}setParent(f,k){if(f&&f!==h.None)try{f[o]=!0}catch{}}markAsDisposed(f){if(f&&f!==h.None)try{f[o]=!0}catch{}}markAsSingleton(f){}})}function P(o){return S?.trackDisposable(o),o}function b(o){S?.markAsDisposed(o)}function $(o,f){S?.setParent(o,f)}function A(o,f){if(S)for(const k of o)S.setParent(k,f)}function E(o){return S?.markAsSingleton(o),o}e.$eb=E;function w(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.$fb=w;function l(o){if(R.Iterable.is(o)){const f=[];for(const k of o)if(k)try{k.dispose()}catch(D){f.push(D)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.$gb=l;function d(o){for(const f of o)w(f)&&f.dispose();return[]}e.$hb=d;function m(...o){const f=c(()=>l(o));return A(o,f),f}e.$ib=m;function c(o){const f=P({dispose:(0,v.$cb)(()=>{b(f),o()})});return f}e.$jb=c;class u{constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return $(f,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(f),f}}e.$kb=u,u.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this.q=new u,P(this),$(this.q,this)}dispose(){b(this),this.q.dispose()}B(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(f)}}e.$lb=h,h.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(f){this.b||f===this.a||(this.a?.dispose(),f&&$(f,this),this.a=f)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const f=this.a;return this.a=void 0,f&&$(f,null),f}}e.$mb=g;class y{constructor(f){this.b=f,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=y;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(f){let k=f;return this.unset=()=>k=void 0,this.isset=()=>k!==void 0,this.dispose=()=>{k&&(k(),k=void 0,b(this))},this}}e.$ob=p;class t{constructor(){this.a=new Map}acquire(f,...k){let D=this.a.get(f);D||(D={counter:0,object:this.b(f,...k)},this.a.set(f,D));const{object:C}=D,L=(0,v.$cb)(()=>{--D.counter===0&&(this.c(f,D.object),this.a.delete(f))});return D.counter++,{object:C,dispose:L}}}e.$pb=t;class i{constructor(f){this.a=f}async acquire(f,...k){const D=this.a.acquire(f,...k);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(C){throw D.dispose(),C}}}e.$qb=i;class a{constructor(f){this.object=f}dispose(){}}e.$rb=a;function s(o){const f=new u;try{o(f)}finally{f.dispose()}}e.$sb=s;class n{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(f){return this.a.has(f)}get(f){return this.a.get(f)}set(f,k,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(f)?.dispose(),this.a.set(f,k)}deleteAndDispose(f){this.a.get(f)?.dispose(),this.a.delete(f)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=n}),define(we[98],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ub=void 0;class v{constructor(S){this.element=S,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let S=this.a;for(;S!==v.Undefined;){const I=S.next;S.prev=v.Undefined,S.next=v.Undefined,S=I}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(S){return this.d(S,!1)}push(S){return this.d(S,!0)}d(S,I){const P=new v(S);if(this.a===v.Undefined)this.a=P,this.b=P;else if(I){const $=this.b;this.b=P,P.prev=$,$.next=P}else{const $=this.a;this.a=P,P.next=$,$.prev=P}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(P))}}shift(){if(this.a!==v.Undefined){const S=this.a.element;return this.e(this.a),S}}pop(){if(this.b!==v.Undefined){const S=this.b.element;return this.e(this.b),S}}e(S){if(S.prev!==v.Undefined&&S.next!==v.Undefined){const I=S.prev;I.next=S.next,S.next.prev=I}else S.prev===v.Undefined&&S.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):S.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):S.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let S=this.a;for(;S!==v.Undefined;)yield S.element,S=S.next}}e.$ub=R}),define(we[28],be([1,0]),function(le,e){"use strict";var v,R,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function S(m,c,u){let h=m.get(c);return h===void 0&&(h=u,m.set(c,h)),h}e.$ki=S;function I(m){const c=[];return m.forEach((u,h)=>{c.push(`${h} => ${u}`)}),`Map(${m.size}) {${c.join(", ")}}`}e.$li=I;function P(m){const c=[];return m.forEach(u=>{c.push(u)}),`Set(${m.size}) {${c.join(", ")}}`}e.$mi=P;class b{constructor(c,u){this.uri=c,this.value=u}}class ${constructor(c,u){this[v]="ResourceMap",c instanceof $?(this.b=new Map(c.b),this.c=u??$.a):(this.b=new Map,this.c=c??$.a)}set(c,u){return this.b.set(this.c(c),new b(c,u)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,u){typeof u<"u"&&(c=c.bind(u));for(const[h,g]of this.b)c(g.value,g.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$ni=$,$.a=m=>m.toString();class A{constructor(c,u){this[R]="ResourceSet",!c||typeof c=="function"?this.a=new $(c):(this.a=new $(u),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,u){this.a.forEach((h,g)=>c.call(u,g,g,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=A;var E;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class w{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,u=0){const h=this.a.get(c);if(h)return u!==0&&this.j(h,u),h.value}set(c,u,h=0){let g=this.a.get(c);if(g)g.value=u,h!==0&&this.j(g,h);else{switch(g={key:c,value:u,next:void 0,previous:void 0},h){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(c,g),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const u=this.a.get(c);if(u)return this.a.delete(c),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,u){const h=this.e;let g=this.b;for(;g;){if(u?c.bind(u)(g.value,g.key,this):c(g.value,g.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const c=this,u=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const y={value:h.key,done:!1};return h=h.next,y}else return{value:void 0,done:!0}}};return g}values(){const c=this,u=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const y={value:h.value,done:!1};return h=h.next,y}else return{value:void 0,done:!0}}};return g}entries(){const c=this,u=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const y={value:[h.key,h.value],done:!1};return h=h.next,y}else return{value:void 0,done:!0}}};return g}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let u=this.b,h=this.size;for(;u&&h>c;)this.a.delete(u.key),u=u.next,h--;this.b=u,this.d=h,u&&(u.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const u=c.next,h=c.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}c.next=void 0,c.previous=void 0,this.e++}j(c,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(c===this.b)return;const h=c.next,g=c.previous;c===this.c?(g.next=void 0,this.c=g):(h.previous=g,g.next=h),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(u===2){if(c===this.c)return;const h=c.next,g=c.previous;c===this.b?(h.previous=void 0,this.b=h):(h.previous=g,g.next=h),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((u,h)=>{c.push([h,u])}),c}fromJSON(c){this.clear();for(const[u,h]of c)this.set(u,h)}}e.$pi=w;class l extends w{constructor(c,u=1){super(),this.k=c,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,u=2){return super.get(c,u)}peek(c){return super.get(c,0)}set(c,u){return super.set(c,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=l;class d{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let u=this.a.get(c)||0;return u===0?!1:(u--,u===0?this.a.delete(c):this.a.set(c,u),!0)}has(c){return this.a.has(c)}}e.$ri=d}),function(le,e){typeof define=="function"&&define.amd?define(we[142],be([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(re,ee){for(var oe=0;oe<ee.length;oe++){var F=ee[oe];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(re,F.key,F)}}function v(re,ee,oe){return ee&&e(re.prototype,ee),oe&&e(re,oe),Object.defineProperty(re,"prototype",{writable:!1}),re}function R(re,ee){if(re){if(typeof re=="string")return r(re,ee);var oe=Object.prototype.toString.call(re).slice(8,-1);if(oe==="Object"&&re.constructor&&(oe=re.constructor.name),oe==="Map"||oe==="Set")return Array.from(re);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return r(re,ee)}}function r(re,ee){(ee==null||ee>re.length)&&(ee=re.length);for(var oe=0,F=new Array(ee);oe<ee;oe++)F[oe]=re[oe];return F}function S(re,ee){var oe=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(oe)return(oe=oe.call(re)).next.bind(oe);if(Array.isArray(re)||(oe=R(re))||ee&&re&&typeof re.length=="number"){oe&&(re=oe);var F=0;return function(){return F>=re.length?{done:!0}:{done:!1,value:re[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=I();function P(re){le.defaults=re}var b=/[&<>"']/,$=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(ee){return w[ee]};function d(re,ee){if(ee){if(b.test(re))return re.replace($,l)}else if(A.test(re))return re.replace(E,l);return re}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(re){return re.replace(m,function(ee,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var u=/(^|[^\[])\^/g;function h(re,ee){re=typeof re=="string"?re:re.source,ee=ee||"";var oe={replace:function(z,j){return j=j.source||j,j=j.replace(u,"$1"),re=re.replace(z,j),oe},getRegex:function(){return new RegExp(re,ee)}};return oe}var g=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(re,ee,oe){if(re){var F;try{F=decodeURIComponent(c(oe)).replace(g,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}ee&&!y.test(oe)&&(oe=n(ee,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},i=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(re,ee){t[" "+re]||(i.test(re)?t[" "+re]=re+"/":t[" "+re]=D(re,"/",!0)),re=t[" "+re];var oe=re.indexOf(":")===-1;return ee.substring(0,2)==="//"?oe?ee:re.replace(a,"$1")+ee:ee.charAt(0)==="/"?oe?ee:re.replace(s,"$1")+ee:re+ee}var o={exec:function(){}};function f(re){for(var ee=1,oe,F;ee<arguments.length;ee++){oe=arguments[ee];for(F in oe)Object.prototype.hasOwnProperty.call(oe,F)&&(re[F]=oe[F])}return re}function k(re,ee){var oe=re.replace(/\|/g,function(j,B,Q){for(var de=!1,Ee=B;--Ee>=0&&Q[Ee]==="\\";)de=!de;return de?"|":" |"}),F=oe.split(/ \|/),z=0;if(F[0].trim()||F.shift(),F.length>0&&!F[F.length-1].trim()&&F.pop(),F.length>ee)F.splice(ee);else for(;F.length<ee;)F.push("");for(;z<F.length;z++)F[z]=F[z].trim().replace(/\\\|/g,"|");return F}function D(re,ee,oe){var F=re.length;if(F===0)return"";for(var z=0;z<F;){var j=re.charAt(F-z-1);if(j===ee&&!oe)z++;else if(j!==ee&&oe)z++;else break}return re.slice(0,F-z)}function C(re,ee){if(re.indexOf(ee[1])===-1)return-1;for(var oe=re.length,F=0,z=0;z<oe;z++)if(re[z]==="\\")z++;else if(re[z]===ee[0])F++;else if(re[z]===ee[1]&&(F--,F<0))return z;return-1}function L(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function U(re,ee){if(ee<1)return"";for(var oe="";ee>1;)ee&1&&(oe+=re),ee>>=1,re+=re;return oe+re}function x(re,ee,oe,F){var z=ee.href,j=ee.title?d(ee.title):null,B=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){F.state.inLink=!0;var Q={type:"link",raw:oe,href:z,title:j,text:B,tokens:F.inlineTokens(B)};return F.state.inLink=!1,Q}return{type:"image",raw:oe,href:z,title:j,text:d(B)}}function ae(re,ee){var oe=re.match(/^(\s+)(?:```)/);if(oe===null)return ee;var F=oe[1];return ee.split(`
`).map(function(z){var j=z.match(/^\s+/);if(j===null)return z;var B=j[0];return B.length>=F.length?z.slice(F.length):z}).join(`
`)}var W=function(){function re(oe){this.options=oe||le.defaults}var ee=re.prototype;return ee.space=function(F){var z=this.rules.block.newline.exec(F);if(z&&z[0].length>0)return{type:"space",raw:z[0]}},ee.code=function(F){var z=this.rules.block.code.exec(F);if(z){var j=z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:z[0],codeBlockStyle:"indented",text:this.options.pedantic?j:D(j,`
`)}}},ee.fences=function(F){var z=this.rules.block.fences.exec(F);if(z){var j=z[0],B=ae(j,z[3]||"");return{type:"code",raw:j,lang:z[2]?z[2].trim():z[2],text:B}}},ee.heading=function(F){var z=this.rules.block.heading.exec(F);if(z){var j=z[2].trim();if(/#$/.test(j)){var B=D(j,"#");(this.options.pedantic||!B||/ $/.test(B))&&(j=B.trim())}return{type:"heading",raw:z[0],depth:z[1].length,text:j,tokens:this.lexer.inline(j)}}},ee.hr=function(F){var z=this.rules.block.hr.exec(F);if(z)return{type:"hr",raw:z[0]}},ee.blockquote=function(F){var z=this.rules.block.blockquote.exec(F);if(z){var j=z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:z[0],tokens:this.lexer.blockTokens(j,[]),text:j}}},ee.list=function(F){var z=this.rules.block.list.exec(F);if(z){var j,B,Q,de,Ee,Pe,Re,Fe,$e,ke,ye,Te,ze=z[1].trim(),xe=ze.length>1,qe={type:"list",raw:"",ordered:xe,start:xe?+ze.slice(0,-1):"",loose:!1,items:[]};ze=xe?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=xe?ze:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");F&&(Te=!1,!(!(z=Ze.exec(F))||this.rules.block.hr.test(F)));){if(j=z[0],F=F.substring(j.length),Fe=z[2].split(`
`,1)[0],$e=F.split(`
`,1)[0],this.options.pedantic?(de=2,ye=Fe.trimLeft()):(de=z[2].search(/[^ ]/),de=de>4?1:de,ye=Fe.slice(de),de+=z[1].length),Pe=!1,!Fe&&/^ *$/.test($e)&&(j+=$e+`
`,F=F.substring($e.length+1),Te=!0),!Te)for(var Ye=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),me=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),De=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");F&&(ke=F.split(`
`,1)[0],Fe=ke,this.options.pedantic&&(Fe=Fe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(me.test(Fe)||De.test(Fe)||Ye.test(Fe)||tt.test(F)));){if(Fe.search(/[^ ]/)>=de||!Fe.trim())ye+=`
`+Fe.slice(de);else if(!Pe)ye+=`
`+Fe;else break;!Pe&&!Fe.trim()&&(Pe=!0),j+=ke+`
`,F=F.substring(ke.length+1)}qe.loose||(Re?qe.loose=!0:/\n *\n *$/.test(j)&&(Re=!0)),this.options.gfm&&(B=/^\[[ xX]\] /.exec(ye),B&&(Q=B[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:j,task:!!B,checked:Q,loose:!1,text:ye}),qe.raw+=j}qe.items[qe.items.length-1].raw=j.trimRight(),qe.items[qe.items.length-1].text=ye.trimRight(),qe.raw=qe.raw.trimRight();var Ae=qe.items.length;for(Ee=0;Ee<Ae;Ee++){this.lexer.state.top=!1,qe.items[Ee].tokens=this.lexer.blockTokens(qe.items[Ee].text,[]);var Ne=qe.items[Ee].tokens.filter(function(Me){return Me.type==="space"}),Be=Ne.every(function(Me){for(var He=Me.raw.split(""),Ge=0,Je=S(He),Ve;!(Ve=Je()).done;){var et=Ve.value;if(et===`
`&&(Ge+=1),Ge>1)return!0}return!1});!qe.loose&&Ne.length&&Be&&(qe.loose=!0,qe.items[Ee].loose=!0)}return qe}},ee.html=function(F){var z=this.rules.block.html.exec(F);if(z){var j={type:"html",raw:z[0],pre:!this.options.sanitizer&&(z[1]==="pre"||z[1]==="script"||z[1]==="style"),text:z[0]};if(this.options.sanitize){var B=this.options.sanitizer?this.options.sanitizer(z[0]):d(z[0]);j.type="paragraph",j.text=B,j.tokens=this.lexer.inline(B)}return j}},ee.def=function(F){var z=this.rules.block.def.exec(F);if(z){z[3]&&(z[3]=z[3].substring(1,z[3].length-1));var j=z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:j,raw:z[0],href:z[2],title:z[3]}}},ee.table=function(F){var z=this.rules.block.table.exec(F);if(z){var j={type:"table",header:k(z[1]).map(function(Re){return{text:Re}}),align:z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:z[3]&&z[3].trim()?z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(j.header.length===j.align.length){j.raw=z[0];var B=j.align.length,Q,de,Ee,Pe;for(Q=0;Q<B;Q++)/^ *-+: *$/.test(j.align[Q])?j.align[Q]="right":/^ *:-+: *$/.test(j.align[Q])?j.align[Q]="center":/^ *:-+ *$/.test(j.align[Q])?j.align[Q]="left":j.align[Q]=null;for(B=j.rows.length,Q=0;Q<B;Q++)j.rows[Q]=k(j.rows[Q],j.header.length).map(function(Re){return{text:Re}});for(B=j.header.length,de=0;de<B;de++)j.header[de].tokens=this.lexer.inline(j.header[de].text);for(B=j.rows.length,de=0;de<B;de++)for(Pe=j.rows[de],Ee=0;Ee<Pe.length;Ee++)Pe[Ee].tokens=this.lexer.inline(Pe[Ee].text);return j}}},ee.lheading=function(F){var z=this.rules.block.lheading.exec(F);if(z)return{type:"heading",raw:z[0],depth:z[2].charAt(0)==="="?1:2,text:z[1],tokens:this.lexer.inline(z[1])}},ee.paragraph=function(F){var z=this.rules.block.paragraph.exec(F);if(z){var j=z[1].charAt(z[1].length-1)===`
`?z[1].slice(0,-1):z[1];return{type:"paragraph",raw:z[0],text:j,tokens:this.lexer.inline(j)}}},ee.text=function(F){var z=this.rules.block.text.exec(F);if(z)return{type:"text",raw:z[0],text:z[0],tokens:this.lexer.inline(z[0])}},ee.escape=function(F){var z=this.rules.inline.escape.exec(F);if(z)return{type:"escape",raw:z[0],text:d(z[1])}},ee.tag=function(F){var z=this.rules.inline.tag.exec(F);if(z)return!this.lexer.state.inLink&&/^<a /i.test(z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):d(z[0]):z[0]}},ee.link=function(F){var z=this.rules.inline.link.exec(F);if(z){var j=z[2].trim();if(!this.options.pedantic&&/^</.test(j)){if(!/>$/.test(j))return;var B=D(j.slice(0,-1),"\\");if((j.length-B.length)%2===0)return}else{var Q=C(z[2],"()");if(Q>-1){var de=z[0].indexOf("!")===0?5:4,Ee=de+z[1].length+Q;z[2]=z[2].substring(0,Q),z[0]=z[0].substring(0,Ee).trim(),z[3]=""}}var Pe=z[2],Re="";if(this.options.pedantic){var Fe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);Fe&&(Pe=Fe[1],Re=Fe[3])}else Re=z[3]?z[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(j)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),x(z,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Re&&Re.replace(this.rules.inline._escapes,"$1")},z[0],this.lexer)}},ee.reflink=function(F,z){var j;if((j=this.rules.inline.reflink.exec(F))||(j=this.rules.inline.nolink.exec(F))){var B=(j[2]||j[1]).replace(/\s+/g," ");if(B=z[B.toLowerCase()],!B||!B.href){var Q=j[0].charAt(0);return{type:"text",raw:Q,text:Q}}return x(j,B,j[0],this.lexer)}},ee.emStrong=function(F,z,j){j===void 0&&(j="");var B=this.rules.inline.emStrong.lDelim.exec(F);if(B&&!(B[3]&&j.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Q=B[1]||B[2]||"";if(!Q||Q&&(j===""||this.rules.inline.punctuation.exec(j))){var de=B[0].length-1,Ee,Pe,Re=de,Fe=0,$e=B[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,z=z.slice(-1*F.length+de);(B=$e.exec(z))!=null;)if(Ee=B[1]||B[2]||B[3]||B[4]||B[5]||B[6],!!Ee){if(Pe=Ee.length,B[3]||B[4]){Re+=Pe;continue}else if((B[5]||B[6])&&de%3&&!((de+Pe)%3)){Fe+=Pe;continue}if(Re-=Pe,!(Re>0)){if(Pe=Math.min(Pe,Pe+Re+Fe),Math.min(de,Pe)%2){var ke=F.slice(1,de+B.index+Pe);return{type:"em",raw:F.slice(0,de+B.index+Pe+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var ye=F.slice(2,de+B.index+Pe-1);return{type:"strong",raw:F.slice(0,de+B.index+Pe+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},ee.codespan=function(F){var z=this.rules.inline.code.exec(F);if(z){var j=z[2].replace(/\n/g," "),B=/[^ ]/.test(j),Q=/^ /.test(j)&&/ $/.test(j);return B&&Q&&(j=j.substring(1,j.length-1)),j=d(j,!0),{type:"codespan",raw:z[0],text:j}}},ee.br=function(F){var z=this.rules.inline.br.exec(F);if(z)return{type:"br",raw:z[0]}},ee.del=function(F){var z=this.rules.inline.del.exec(F);if(z)return{type:"del",raw:z[0],text:z[2],tokens:this.lexer.inlineTokens(z[2])}},ee.autolink=function(F,z){var j=this.rules.inline.autolink.exec(F);if(j){var B,Q;return j[2]==="@"?(B=d(this.options.mangle?z(j[1]):j[1]),Q="mailto:"+B):(B=d(j[1]),Q=B),{type:"link",raw:j[0],text:B,href:Q,tokens:[{type:"text",raw:B,text:B}]}}},ee.url=function(F,z){var j;if(j=this.rules.inline.url.exec(F)){var B,Q;if(j[2]==="@")B=d(this.options.mangle?z(j[0]):j[0]),Q="mailto:"+B;else{var de;do de=j[0],j[0]=this.rules.inline._backpedal.exec(j[0])[0];while(de!==j[0]);B=d(j[0]),j[1]==="www."?Q="http://"+B:Q=B}return{type:"link",raw:j[0],text:B,href:Q,tokens:[{type:"text",raw:B,text:B}]}}},ee.inlineText=function(F,z){var j=this.rules.inline.text.exec(F);if(j){var B;return this.lexer.state.inRawBlock?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(j[0]):d(j[0]):j[0]:B=d(this.options.smartypants?z(j[0]):j[0]),{type:"text",raw:j[0],text:B}}},re}(),te={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};te._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,te._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,te.def=h(te.def).replace("label",te._label).replace("title",te._title).getRegex(),te.bullet=/(?:[*+-]|\d{1,9}[.)])/,te.listItemStart=h(/^( *)(bull) */).replace("bull",te.bullet).getRegex(),te.list=h(te.list).replace(/bull/g,te.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+te.def.source+")").getRegex(),te._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",te._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,te.html=h(te.html,"i").replace("comment",te._comment).replace("tag",te._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),te.paragraph=h(te._paragraph).replace("hr",te.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",te._tag).getRegex(),te.blockquote=h(te.blockquote).replace("paragraph",te.paragraph).getRegex(),te.normal=f({},te),te.gfm=f({},te.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),te.gfm.table=h(te.gfm.table).replace("hr",te.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",te._tag).getRegex(),te.gfm.paragraph=h(te._paragraph).replace("hr",te.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",te.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",te._tag).getRegex(),te.pedantic=f({},te.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",te._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:h(te.normal._paragraph).replace("hr",te.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",te.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=h(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=h(te._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=h(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=h(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=h(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=h(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=h(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=h(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=h(ue.reflink).replace("label",ue._label).replace("ref",te._label).getRegex(),ue.nolink=h(ue.nolink).replace("ref",te._label).getRegex(),ue.reflinkSearch=h(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=f({},ue),ue.pedantic=f({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=f({},ue.normal,{escape:h(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=h(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=f({},ue.gfm,{br:h(ue.br).replace("{2,}","*").getRegex(),text:h(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Z(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function he(re){var ee="",oe,F,z=re.length;for(oe=0;oe<z;oe++)F=re.charCodeAt(oe),Math.random()>.5&&(F="x"+F.toString(16)),ee+="&#"+F+";";return ee}var V=function(){function re(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||le.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:te.normal,inline:ue.normal};this.options.pedantic?(F.block=te.pedantic,F.inline=ue.pedantic):this.options.gfm&&(F.block=te.gfm,this.options.breaks?F.inline=ue.breaks:F.inline=ue.gfm),this.tokenizer.rules=F}re.lex=function(F,z){var j=new re(z);return j.lex(F)},re.lexInline=function(F,z){var j=new re(z);return j.inlineTokens(F)};var ee=re.prototype;return ee.lex=function(F){F=F.replace(/\r\n|\r/g,`
`),this.blockTokens(F,this.tokens);for(var z;z=this.inlineQueue.shift();)this.inlineTokens(z.src,z.tokens);return this.tokens},ee.blockTokens=function(F,z){var j=this;z===void 0&&(z=[]),this.options.pedantic?F=F.replace(/\t/g,"    ").replace(/^ +$/gm,""):F=F.replace(/^( *)(\t+)/gm,function(Re,Fe,$e){return Fe+"    ".repeat($e.length)});for(var B,Q,de,Ee;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Re){return(B=Re.call({lexer:j},F,z))?(F=F.substring(B.raw.length),z.push(B),!0):!1}))){if(B=this.tokenizer.space(F)){F=F.substring(B.raw.length),B.raw.length===1&&z.length>0?z[z.length-1].raw+=`
`:z.push(B);continue}if(B=this.tokenizer.code(F)){F=F.substring(B.raw.length),Q=z[z.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+B.raw,Q.text+=`
`+B.text,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):z.push(B);continue}if(B=this.tokenizer.fences(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.heading(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.hr(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.blockquote(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.list(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.html(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.def(F)){F=F.substring(B.raw.length),Q=z[z.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+B.raw,Q.text+=`
`+B.raw,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):this.tokens.links[B.tag]||(this.tokens.links[B.tag]={href:B.href,title:B.title});continue}if(B=this.tokenizer.table(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.lheading(F)){F=F.substring(B.raw.length),z.push(B);continue}if(de=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var Re=1/0,Fe=F.slice(1),$e=void 0;j.options.extensions.startBlock.forEach(function(ke){$e=ke.call({lexer:this},Fe),typeof $e=="number"&&$e>=0&&(Re=Math.min(Re,$e))}),Re<1/0&&Re>=0&&(de=F.substring(0,Re+1))}(),this.state.top&&(B=this.tokenizer.paragraph(de))){Q=z[z.length-1],Ee&&Q.type==="paragraph"?(Q.raw+=`
`+B.raw,Q.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):z.push(B),Ee=de.length!==F.length,F=F.substring(B.raw.length);continue}if(B=this.tokenizer.text(F)){F=F.substring(B.raw.length),Q=z[z.length-1],Q&&Q.type==="text"?(Q.raw+=`
`+B.raw,Q.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):z.push(B);continue}if(F){var Pe="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,z},ee.inline=function(F,z){return z===void 0&&(z=[]),this.inlineQueue.push({src:F,tokens:z}),z},ee.inlineTokens=function(F,z){var j=this;z===void 0&&(z=[]);var B,Q,de,Ee=F,Pe,Re,Fe;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)$e.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Pe.index)+"["+U("a",Pe[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Pe.index)+"["+U("a",Pe[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Pe.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(Re||(Fe=""),Re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(B=ye.call({lexer:j},F,z))?(F=F.substring(B.raw.length),z.push(B),!0):!1}))){if(B=this.tokenizer.escape(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.tag(F)){F=F.substring(B.raw.length),Q=z[z.length-1],Q&&B.type==="text"&&Q.type==="text"?(Q.raw+=B.raw,Q.text+=B.text):z.push(B);continue}if(B=this.tokenizer.link(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(B.raw.length),Q=z[z.length-1],Q&&B.type==="text"&&Q.type==="text"?(Q.raw+=B.raw,Q.text+=B.text):z.push(B);continue}if(B=this.tokenizer.emStrong(F,Ee,Fe)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.codespan(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.br(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.del(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.autolink(F,he)){F=F.substring(B.raw.length),z.push(B);continue}if(!this.state.inLink&&(B=this.tokenizer.url(F,he))){F=F.substring(B.raw.length),z.push(B);continue}if(de=F,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Te=F.slice(1),ze=void 0;j.options.extensions.startInline.forEach(function(xe){ze=xe.call({lexer:this},Te),typeof ze=="number"&&ze>=0&&(ye=Math.min(ye,ze))}),ye<1/0&&ye>=0&&(de=F.substring(0,ye+1))}(),B=this.tokenizer.inlineText(de,Z)){F=F.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(Fe=B.raw.slice(-1)),Re=!0,Q=z[z.length-1],Q&&Q.type==="text"?(Q.raw+=B.raw,Q.text+=B.text):z.push(B);continue}if(F){var ke="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return z},v(re,null,[{key:"rules",get:function(){return{block:te,inline:ue}}}]),re}(),se=function(){function re(oe){this.options=oe||le.defaults}var ee=re.prototype;return ee.code=function(F,z,j){var B=(z||"").match(/\S*/)[0];if(this.options.highlight){var Q=this.options.highlight(F,B);Q!=null&&Q!==F&&(j=!0,F=Q)}return F=F.replace(/\n$/,"")+`
`,B?'<pre><code class="'+this.options.langPrefix+d(B,!0)+'">'+(j?F:d(F,!0))+`</code></pre>
`:"<pre><code>"+(j?F:d(F,!0))+`</code></pre>
`},ee.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},ee.html=function(F){return F},ee.heading=function(F,z,j,B){if(this.options.headerIds){var Q=this.options.headerPrefix+B.slug(j);return"<h"+z+' id="'+Q+'">'+F+"</h"+z+`>
`}return"<h"+z+">"+F+"</h"+z+`>
`},ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ee.list=function(F,z,j){var B=z?"ol":"ul",Q=z&&j!==1?' start="'+j+'"':"";return"<"+B+Q+`>
`+F+"</"+B+`>
`},ee.listitem=function(F){return"<li>"+F+`</li>
`},ee.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ee.paragraph=function(F){return"<p>"+F+`</p>
`},ee.table=function(F,z){return z&&(z="<tbody>"+z+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+z+`</table>
`},ee.tablerow=function(F){return`<tr>
`+F+`</tr>
`},ee.tablecell=function(F,z){var j=z.header?"th":"td",B=z.align?"<"+j+' align="'+z.align+'">':"<"+j+">";return B+F+("</"+j+`>
`)},ee.strong=function(F){return"<strong>"+F+"</strong>"},ee.em=function(F){return"<em>"+F+"</em>"},ee.codespan=function(F){return"<code>"+F+"</code>"},ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},ee.del=function(F){return"<del>"+F+"</del>"},ee.link=function(F,z,j){if(F=p(this.options.sanitize,this.options.baseUrl,F),F===null)return j;var B='<a href="'+d(F)+'"';return z&&(B+=' title="'+z+'"'),B+=">"+j+"</a>",B},ee.image=function(F,z,j){if(F=p(this.options.sanitize,this.options.baseUrl,F),F===null)return j;var B='<img src="'+F+'" alt="'+j+'"';return z&&(B+=' title="'+z+'"'),B+=this.options.xhtml?"/>":">",B},ee.text=function(F){return F},re}(),K=function(){function re(){}var ee=re.prototype;return ee.strong=function(F){return F},ee.em=function(F){return F},ee.codespan=function(F){return F},ee.del=function(F){return F},ee.html=function(F){return F},ee.text=function(F){return F},ee.link=function(F,z,j){return""+j},ee.image=function(F,z,j){return""+j},ee.br=function(){return""},re}(),Y=function(){function re(){this.seen={}}var ee=re.prototype;return ee.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ee.getNextSafeSlug=function(F,z){var j=F,B=0;if(this.seen.hasOwnProperty(j)){B=this.seen[F];do B++,j=F+"-"+B;while(this.seen.hasOwnProperty(j))}return z||(this.seen[F]=B,this.seen[j]=0),j},ee.slug=function(F,z){z===void 0&&(z={});var j=this.serialize(F);return this.getNextSafeSlug(j,z.dryrun)},re}(),H=function(){function re(oe){this.options=oe||le.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new Y}re.parse=function(F,z){var j=new re(z);return j.parse(F)},re.parseInline=function(F,z){var j=new re(z);return j.parseInline(F)};var ee=re.prototype;return ee.parse=function(F,z){z===void 0&&(z=!0);var j="",B,Q,de,Ee,Pe,Re,Fe,$e,ke,ye,Te,ze,xe,qe,Ze,Ye,tt,me,De,Ae=F.length;for(B=0;B<Ae;B++){if(ye=F[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(De=this.options.extensions.renderers[ye.type].call({parser:this},ye),De!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){j+=De||"";continue}switch(ye.type){case"space":continue;case"hr":{j+=this.renderer.hr();continue}case"heading":{j+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,c(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{j+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for($e="",Fe="",Ee=ye.header.length,Q=0;Q<Ee;Q++)Fe+=this.renderer.tablecell(this.parseInline(ye.header[Q].tokens),{header:!0,align:ye.align[Q]});for($e+=this.renderer.tablerow(Fe),ke="",Ee=ye.rows.length,Q=0;Q<Ee;Q++){for(Re=ye.rows[Q],Fe="",Pe=Re.length,de=0;de<Pe;de++)Fe+=this.renderer.tablecell(this.parseInline(Re[de].tokens),{header:!1,align:ye.align[de]});ke+=this.renderer.tablerow(Fe)}j+=this.renderer.table($e,ke);continue}case"blockquote":{ke=this.parse(ye.tokens),j+=this.renderer.blockquote(ke);continue}case"list":{for(Te=ye.ordered,ze=ye.start,xe=ye.loose,Ee=ye.items.length,ke="",Q=0;Q<Ee;Q++)Ze=ye.items[Q],Ye=Ze.checked,tt=Ze.task,qe="",Ze.task&&(me=this.renderer.checkbox(Ye),xe?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=me+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=me+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:me}):qe+=me),qe+=this.parse(Ze.tokens,xe),ke+=this.renderer.listitem(qe,tt,Ye);j+=this.renderer.list(ke,Te,ze);continue}case"html":{j+=this.renderer.html(ye.text);continue}case"paragraph":{j+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ke=ye.tokens?this.parseInline(ye.tokens):ye.text;B+1<Ae&&F[B+1].type==="text";)ye=F[++B],ke+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);j+=z?this.renderer.paragraph(ke):ke;continue}default:{var Ne='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return j},ee.parseInline=function(F,z){z=z||this.renderer;var j="",B,Q,de,Ee=F.length;for(B=0;B<Ee;B++){if(Q=F[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(de=this.options.extensions.renderers[Q.type].call({parser:this},Q),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Q.type))){j+=de||"";continue}switch(Q.type){case"escape":{j+=z.text(Q.text);break}case"html":{j+=z.html(Q.text);break}case"link":{j+=z.link(Q.href,Q.title,this.parseInline(Q.tokens,z));break}case"image":{j+=z.image(Q.href,Q.title,Q.text);break}case"strong":{j+=z.strong(this.parseInline(Q.tokens,z));break}case"em":{j+=z.em(this.parseInline(Q.tokens,z));break}case"codespan":{j+=z.codespan(Q.text);break}case"br":{j+=z.br();break}case"del":{j+=z.del(this.parseInline(Q.tokens,z));break}case"text":{j+=z.text(Q.text);break}default:{var Pe='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return j},re}();function _(re,ee,oe){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof ee=="function"&&(oe=ee,ee=null),ee=f({},_.defaults,ee||{}),L(ee),oe){var F=ee.highlight,z;try{z=V.lex(re,ee)}catch(Ee){return oe(Ee)}var j=function(Pe){var Re;if(!Pe)try{ee.walkTokens&&_.walkTokens(z,ee.walkTokens),Re=H.parse(z,ee)}catch(Fe){Pe=Fe}return ee.highlight=F,Pe?oe(Pe):oe(null,Re)};if(!F||F.length<3||(delete ee.highlight,!z.length))return j();var B=0;_.walkTokens(z,function(Ee){Ee.type==="code"&&(B++,setTimeout(function(){F(Ee.text,Ee.lang,function(Pe,Re){if(Pe)return j(Pe);Re!=null&&Re!==Ee.text&&(Ee.text=Re,Ee.escaped=!0),B--,B===0&&j()})},0))}),B===0&&j();return}function Q(Ee){if(Ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+d(Ee.message+"",!0)+"</pre>";throw Ee}try{var de=V.lex(re,ee);if(ee.walkTokens){if(ee.async)return Promise.all(_.walkTokens(de,ee.walkTokens)).then(function(){return H.parse(de,ee)}).catch(Q);_.walkTokens(de,ee.walkTokens)}return H.parse(de,ee)}catch(Ee){Q(Ee)}}_.options=_.setOptions=function(re){return f(_.defaults,re),P(_.defaults),_},_.getDefaults=I,_.defaults=le.defaults,_.use=function(){for(var re=arguments.length,ee=new Array(re),oe=0;oe<re;oe++)ee[oe]=arguments[oe];var F=f.apply(void 0,[{}].concat(ee)),z=_.defaults.extensions||{renderers:{},childTokens:{}},j;ee.forEach(function(B){if(B.extensions&&(j=!0,B.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ee=z.renderers?z.renderers[de.name]:null;Ee?z.renderers[de.name]=function(){for(var Pe=arguments.length,Re=new Array(Pe),Fe=0;Fe<Pe;Fe++)Re[Fe]=arguments[Fe];var $e=de.renderer.apply(this,Re);return $e===!1&&($e=Ee.apply(this,Re)),$e}:z.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");z[de.level]?z[de.level].unshift(de.tokenizer):z[de.level]=[de.tokenizer],de.start&&(de.level==="block"?z.startBlock?z.startBlock.push(de.start):z.startBlock=[de.start]:de.level==="inline"&&(z.startInline?z.startInline.push(de.start):z.startInline=[de.start]))}de.childTokens&&(z.childTokens[de.name]=de.childTokens)})),B.renderer&&function(){var de=_.defaults.renderer||new se,Ee=function(Fe){var $e=de[Fe];de[Fe]=function(){for(var ke=arguments.length,ye=new Array(ke),Te=0;Te<ke;Te++)ye[Te]=arguments[Te];var ze=B.renderer[Fe].apply(de,ye);return ze===!1&&(ze=$e.apply(de,ye)),ze}};for(var Pe in B.renderer)Ee(Pe);F.renderer=de}(),B.tokenizer&&function(){var de=_.defaults.tokenizer||new W,Ee=function(Fe){var $e=de[Fe];de[Fe]=function(){for(var ke=arguments.length,ye=new Array(ke),Te=0;Te<ke;Te++)ye[Te]=arguments[Te];var ze=B.tokenizer[Fe].apply(de,ye);return ze===!1&&(ze=$e.apply(de,ye)),ze}};for(var Pe in B.tokenizer)Ee(Pe);F.tokenizer=de}(),B.walkTokens){var Q=_.defaults.walkTokens;F.walkTokens=function(de){var Ee=[];return Ee.push(B.walkTokens.call(this,de)),Q&&(Ee=Ee.concat(Q.call(this,de))),Ee}}j&&(F.extensions=z),_.setOptions(F)})},_.walkTokens=function(re,ee){for(var oe=[],F=function(){var Q=j.value;switch(oe=oe.concat(ee.call(_,Q)),Q.type){case"table":{for(var de=S(Q.header),Ee;!(Ee=de()).done;){var Pe=Ee.value;oe=oe.concat(_.walkTokens(Pe.tokens,ee))}for(var Re=S(Q.rows),Fe;!(Fe=Re()).done;)for(var $e=Fe.value,ke=S($e),ye;!(ye=ke()).done;){var Te=ye.value;oe=oe.concat(_.walkTokens(Te.tokens,ee))}break}case"list":{oe=oe.concat(_.walkTokens(Q.items,ee));break}default:_.defaults.extensions&&_.defaults.extensions.childTokens&&_.defaults.extensions.childTokens[Q.type]?_.defaults.extensions.childTokens[Q.type].forEach(function(ze){oe=oe.concat(_.walkTokens(Q[ze],ee))}):Q.tokens&&(oe=oe.concat(_.walkTokens(Q.tokens,ee)))}},z=S(re),j;!(j=z()).done;)F();return oe},_.parseInline=function(re,ee){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");ee=f({},_.defaults,ee||{}),L(ee);try{var oe=V.lexInline(re,ee);return ee.walkTokens&&_.walkTokens(oe,ee.walkTokens),H.parseInline(oe,ee)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+d(F.message+"",!0)+"</pre>";throw F}},_.Parser=H,_.parser=H.parse,_.Renderer=se,_.TextRenderer=K,_.Lexer=V,_.lexer=V.lex,_.Tokenizer=W,_.Slugger=Y,_.parse=_;var ge=_.options,ne=_.setOptions,q=_.use,X=_.walkTokens,O=_.parseInline,N=_,J=H.parse,ie=V.lex;le.Lexer=V,le.Parser=H,le.Renderer=se,le.Slugger=Y,le.TextRenderer=K,le.Tokenizer=W,le.getDefaults=I,le.lexer=ie,le.marked=_,le.options=ge,le.parse=N,le.parseInline=O,le.parser=J,le.setOptions=ne,le.use=q,le.walkTokens=X,Object.defineProperty(le,"__esModule",{value:!0})}),define(we[99],be([1,0,28]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=e.$9k=e.$8k=void 0;const R=new v.$qi(1e4);function r($){return b($,"NFC",R)}e.$8k=r;const S=new v.$qi(1e4);function I($){return b($,"NFD",S)}e.$9k=I;const P=/[^\u0000-\u0080]/;function b($,A,E){if(!$)return $;const w=E.get($);if(w)return w;let l;return P.test($)?l=$.normalize(A):l=$,E.set($,l),l}e.$0k=function(){const $=/[\u0300-\u036f]/g;return function(A){return I(A).replace($,"")}}()}),define(we[143],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=e.$xl=e.rot=e.$vl=void 0;function v(P,b,$){return Math.min(Math.max(P,b),$)}e.$vl=v;function R(P,b){return(b+P%b)%b}e.rot=R;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$xl=r;class S{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$yl=S;class I{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const $=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zl=I}),function(){function le(r){const S=[];typeof r=="number"&&S.push("code/timeOrigin",r);function I(b){S.push(b,Date.now())}function P(){const b=[];for(let $=0;$<S.length;$+=2)b.push({name:S[$],startTime:S[$+1]});return b}return{mark:I,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const I of performance.getEntriesByType("mark"))S.push({name:I.name,startTime:Math.round(r+I.startTime)});return S}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function v(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(we[3],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$b=e.$a=void 0,e.$a="en";let v=!1,R=!1,r=!1,S=!1,I=!1,P=!1,b=!1,$=!1,A=!1,E=!1,w,l=e.$a,d=e.$a,m,c;e.$b=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$b.vscode<"u"&&typeof e.$b.vscode.process<"u"?u=e.$b.vscode.process:typeof process<"u"&&(u=process);const h=typeof u?.versions?.electron=="string",g=h&&u?.type==="renderer";if(typeof navigator=="object"&&!g){c=navigator.userAgent,v=c.indexOf("Windows")>=0,R=c.indexOf("Macintosh")>=0,$=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,r=c.indexOf("Linux")>=0,E=c?.indexOf("Mobi")>=0,P=!0,w=e.$a,l=w,d=navigator.language;const f=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),k=f&&f.getAttribute("data-settings");if(k)try{const D=JSON.parse(k),C=D.availableLanguages["*"];w=D.locale,d=D.osLocale,l=C||e.$a,m=D._translationsConfigFile}catch{}}else if(typeof u=="object"){v=u.platform==="win32",R=u.platform==="darwin",r=u.platform==="linux",S=r&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,b=h,A=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$a,l=e.$a;const f=u.env.VSCODE_NLS_CONFIG;if(f)try{const k=JSON.parse(f),D=k.availableLanguages["*"];w=k.locale,d=k.osLocale,l=D||e.$a,m=k._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var y;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(y||(e.Platform=y={}));function p(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$c=p;let t=0;R?t=1:v?t=3:r&&(t=2),e.$d=v,e.$e=R,e.$f=r,e.$g=S,e.$h=I,e.$i=b,e.$j=P,e.$k=P&&typeof e.$b.importScripts=="function",e.$l=$,e.$m=E,e.$n=A,e.$o=t,e.$p=c,e.$q=l;var i;(function(f){function k(){return e.$q}f.value=k;function D(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}f.isDefaultVariant=D;function C(){return e.$q==="en"}f.isDefault=C})(i||(e.Language=i={})),e.$r=w,e.$s=d,e.$t=m,e.$u=typeof e.$b.postMessage=="function"&&!e.$b.importScripts,e.$v=(()=>{if(e.$u){const f=[];e.$b.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let C=0,L=f.length;C<L;C++){const U=f[C];if(U.id===D.data.vscodeScheduleAsyncWork){f.splice(C,1),U.callback();return}}});let k=0;return D=>{const C=++k;f.push({id:C,callback:D}),e.$b.postMessage({vscodeScheduleAsyncWork:C},"*")}}return f=>setTimeout(f)})();var a;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=R||$?2:v?1:3;let s=!0,n=!1;function o(){if(!n){n=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,s=new Uint16Array(f.buffer)[0]===(2<<8)+1}return s}e.$x=o,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0)}),define(we[29],be([1,0,3]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.env=e.cwd=void 0;let R;if(typeof v.$b.vscode<"u"&&typeof v.$b.vscode.process<"u"){const r=v.$b.vscode.process;R={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return v.$d?"win32":v.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$2c=R.platform,e.$3c=R.arch}),define(we[7],be([1,0,29]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=e.sep=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=void 0;const R=65,r=97,S=90,I=122,P=46,b=47,$=92,A=58,E=63;class w extends Error{constructor(i,a,s){let n;typeof a=="string"&&a.indexOf("not ")===0?(n="must not be",a=a.replace(/^not /,"")):n="must be";const o=i.indexOf(".")!==-1?"property":"argument";let f=`The "${i}" ${o} ${n} of type ${a}`;f+=`. Received type ${typeof s}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function l(t,i){if(t===null||typeof t!="object")throw new w(i,"Object",t)}function d(t,i){if(typeof t!="string")throw new w(i,"string",t)}const m=v.$2c==="win32";function c(t){return t===b||t===$}function u(t){return t===b}function h(t){return t>=R&&t<=S||t>=r&&t<=I}function g(t,i,a,s){let n="",o=0,f=-1,k=0,D=0;for(let C=0;C<=t.length;++C){if(C<t.length)D=t.charCodeAt(C);else{if(s(D))break;D=b}if(s(D)){if(!(f===C-1||k===1))if(k===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const L=n.lastIndexOf(a);L===-1?(n="",o=0):(n=n.slice(0,L),o=n.length-1-n.lastIndexOf(a)),f=C,k=0;continue}else if(n.length!==0){n="",o=0,f=C,k=0;continue}}i&&(n+=n.length>0?`${a}..`:"..",o=2)}else n.length>0?n+=`${a}${t.slice(f+1,C)}`:n=t.slice(f+1,C),o=C-f-1;f=C,k=0}else D===P&&k!==-1?++k:k=-1}return n}function y(t,i){l(i,"pathObject");const a=i.dir||i.root,s=i.base||`${i.name||""}${i.ext||""}`;return a?a===i.root?`${a}${s}`:`${a}${t}${s}`:s}e.$4c={resolve(...t){let i="",a="",s=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],d(o,"path"),o.length===0)continue}else i.length===0?o=v.cwd():(o=v.env[`=${i}`]||v.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==i.toLowerCase()&&o.charCodeAt(2)===$)&&(o=`${i}\\`));const f=o.length;let k=0,D="",C=!1;const L=o.charCodeAt(0);if(f===1)c(L)&&(k=1,C=!0);else if(c(L))if(C=!0,c(o.charCodeAt(1))){let U=2,x=U;for(;U<f&&!c(o.charCodeAt(U));)U++;if(U<f&&U!==x){const ae=o.slice(x,U);for(x=U;U<f&&c(o.charCodeAt(U));)U++;if(U<f&&U!==x){for(x=U;U<f&&!c(o.charCodeAt(U));)U++;(U===f||U!==x)&&(D=`\\\\${ae}\\${o.slice(x,U)}`,k=U)}}}else k=1;else h(L)&&o.charCodeAt(1)===A&&(D=o.slice(0,2),k=2,f>2&&c(o.charCodeAt(2))&&(C=!0,k=3));if(D.length>0)if(i.length>0){if(D.toLowerCase()!==i.toLowerCase())continue}else i=D;if(s){if(i.length>0)break}else if(a=`${o.slice(k)}\\${a}`,s=C,C&&i.length>0)break}return a=g(a,!s,"\\",c),s?`${i}\\${a}`:`${i}${a}`||"."},normalize(t){d(t,"path");const i=t.length;if(i===0)return".";let a=0,s,n=!1;const o=t.charCodeAt(0);if(i===1)return u(o)?"\\":t;if(c(o))if(n=!0,c(t.charCodeAt(1))){let k=2,D=k;for(;k<i&&!c(t.charCodeAt(k));)k++;if(k<i&&k!==D){const C=t.slice(D,k);for(D=k;k<i&&c(t.charCodeAt(k));)k++;if(k<i&&k!==D){for(D=k;k<i&&!c(t.charCodeAt(k));)k++;if(k===i)return`\\\\${C}\\${t.slice(D)}\\`;k!==D&&(s=`\\\\${C}\\${t.slice(D,k)}`,a=k)}}}else a=1;else h(o)&&t.charCodeAt(1)===A&&(s=t.slice(0,2),a=2,i>2&&c(t.charCodeAt(2))&&(n=!0,a=3));let f=a<i?g(t.slice(a),!n,"\\",c):"";return f.length===0&&!n&&(f="."),f.length>0&&c(t.charCodeAt(i-1))&&(f+="\\"),s===void 0?n?`\\${f}`:f:n?`${s}\\${f}`:`${s}${f}`},isAbsolute(t){d(t,"path");const i=t.length;if(i===0)return!1;const a=t.charCodeAt(0);return c(a)||i>2&&h(a)&&t.charCodeAt(1)===A&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let i,a;for(let o=0;o<t.length;++o){const f=t[o];d(f,"path"),f.length>0&&(i===void 0?i=a=f:i+=`\\${f}`)}if(i===void 0)return".";let s=!0,n=0;if(typeof a=="string"&&c(a.charCodeAt(0))){++n;const o=a.length;o>1&&c(a.charCodeAt(1))&&(++n,o>2&&(c(a.charCodeAt(2))?++n:s=!1))}if(s){for(;n<i.length&&c(i.charCodeAt(n));)n++;n>=2&&(i=`\\${i.slice(n)}`)}return e.$4c.normalize(i)},relative(t,i){if(d(t,"from"),d(i,"to"),t===i)return"";const a=e.$4c.resolve(t),s=e.$4c.resolve(i);if(a===s||(t=a.toLowerCase(),i=s.toLowerCase(),t===i))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===$;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===$;)o--;const f=o-n;let k=0;for(;k<i.length&&i.charCodeAt(k)===$;)k++;let D=i.length;for(;D-1>k&&i.charCodeAt(D-1)===$;)D--;const C=D-k,L=f<C?f:C;let U=-1,x=0;for(;x<L;x++){const W=t.charCodeAt(n+x);if(W!==i.charCodeAt(k+x))break;W===$&&(U=x)}if(x!==L){if(U===-1)return s}else{if(C>L){if(i.charCodeAt(k+x)===$)return s.slice(k+x+1);if(x===2)return s.slice(k+x)}f>L&&(t.charCodeAt(n+x)===$?U=x:x===2&&(U=3)),U===-1&&(U=0)}let ae="";for(x=n+U+1;x<=o;++x)(x===o||t.charCodeAt(x)===$)&&(ae+=ae.length===0?"..":"\\..");return k+=U,ae.length>0?`${ae}${s.slice(k,D)}`:(s.charCodeAt(k)===$&&++k,s.slice(k,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const i=e.$4c.resolve(t);if(i.length<=2)return t;if(i.charCodeAt(0)===$){if(i.charCodeAt(1)===$){const a=i.charCodeAt(2);if(a!==E&&a!==P)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(h(i.charCodeAt(0))&&i.charCodeAt(1)===A&&i.charCodeAt(2)===$)return`\\\\?\\${i}`;return t},dirname(t){d(t,"path");const i=t.length;if(i===0)return".";let a=-1,s=0;const n=t.charCodeAt(0);if(i===1)return c(n)?t:".";if(c(n)){if(a=s=1,c(t.charCodeAt(1))){let k=2,D=k;for(;k<i&&!c(t.charCodeAt(k));)k++;if(k<i&&k!==D){for(D=k;k<i&&c(t.charCodeAt(k));)k++;if(k<i&&k!==D){for(D=k;k<i&&!c(t.charCodeAt(k));)k++;if(k===i)return t;k!==D&&(a=s=k+1)}}}}else h(n)&&t.charCodeAt(1)===A&&(a=i>2&&c(t.charCodeAt(2))?3:2,s=a);let o=-1,f=!0;for(let k=i-1;k>=s;--k)if(c(t.charCodeAt(k))){if(!f){o=k;break}}else f=!1;if(o===-1){if(a===-1)return".";o=a}return t.slice(0,o)},basename(t,i){i!==void 0&&d(i,"ext"),d(t,"path");let a=0,s=-1,n=!0,o;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(a=2),i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let f=i.length-1,k=-1;for(o=t.length-1;o>=a;--o){const D=t.charCodeAt(o);if(c(D)){if(!n){a=o+1;break}}else k===-1&&(n=!1,k=o+1),f>=0&&(D===i.charCodeAt(f)?--f===-1&&(s=o):(f=-1,s=k))}return a===s?s=k:s===-1&&(s=t.length),t.slice(a,s)}for(o=t.length-1;o>=a;--o)if(c(t.charCodeAt(o))){if(!n){a=o+1;break}}else s===-1&&(n=!1,s=o+1);return s===-1?"":t.slice(a,s)},extname(t){d(t,"path");let i=0,a=-1,s=0,n=-1,o=!0,f=0;t.length>=2&&t.charCodeAt(1)===A&&h(t.charCodeAt(0))&&(i=s=2);for(let k=t.length-1;k>=i;--k){const D=t.charCodeAt(k);if(c(D)){if(!o){s=k+1;break}continue}n===-1&&(o=!1,n=k+1),D===P?a===-1?a=k:f!==1&&(f=1):a!==-1&&(f=-1)}return a===-1||n===-1||f===0||f===1&&a===n-1&&a===s+1?"":t.slice(a,n)},format:y.bind(null,"\\"),parse(t){d(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const a=t.length;let s=0,n=t.charCodeAt(0);if(a===1)return c(n)?(i.root=i.dir=t,i):(i.base=i.name=t,i);if(c(n)){if(s=1,c(t.charCodeAt(1))){let U=2,x=U;for(;U<a&&!c(t.charCodeAt(U));)U++;if(U<a&&U!==x){for(x=U;U<a&&c(t.charCodeAt(U));)U++;if(U<a&&U!==x){for(x=U;U<a&&!c(t.charCodeAt(U));)U++;U===a?s=U:U!==x&&(s=U+1)}}}}else if(h(n)&&t.charCodeAt(1)===A){if(a<=2)return i.root=i.dir=t,i;if(s=2,c(t.charCodeAt(2))){if(a===3)return i.root=i.dir=t,i;s=3}}s>0&&(i.root=t.slice(0,s));let o=-1,f=s,k=-1,D=!0,C=t.length-1,L=0;for(;C>=s;--C){if(n=t.charCodeAt(C),c(n)){if(!D){f=C+1;break}continue}k===-1&&(D=!1,k=C+1),n===P?o===-1?o=C:L!==1&&(L=1):o!==-1&&(L=-1)}return k!==-1&&(o===-1||L===0||L===1&&o===k-1&&o===f+1?i.base=i.name=t.slice(f,k):(i.name=t.slice(f,o),i.base=t.slice(f,k),i.ext=t.slice(o,k))),f>0&&f!==s?i.dir=t.slice(0,f-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(m){const t=/\\/g;return()=>{const i=v.cwd().replace(t,"/");return i.slice(i.indexOf("/"))}}return()=>v.cwd()})();e.$5c={resolve(...t){let i="",a=!1;for(let s=t.length-1;s>=-1&&!a;s--){const n=s>=0?t[s]:p();d(n,"path"),n.length!==0&&(i=`${n}/${i}`,a=n.charCodeAt(0)===b)}return i=g(i,!a,"/",u),a?`/${i}`:i.length>0?i:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===b,a=t.charCodeAt(t.length-1)===b;return t=g(t,!i,"/",u),t.length===0?i?"/":a?"./":".":(a&&(t+="/"),i?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let i;for(let a=0;a<t.length;++a){const s=t[a];d(s,"path"),s.length>0&&(i===void 0?i=s:i+=`/${s}`)}return i===void 0?".":e.$5c.normalize(i)},relative(t,i){if(d(t,"from"),d(i,"to"),t===i||(t=e.$5c.resolve(t),i=e.$5c.resolve(i),t===i))return"";const a=1,s=t.length,n=s-a,o=1,f=i.length-o,k=n<f?n:f;let D=-1,C=0;for(;C<k;C++){const U=t.charCodeAt(a+C);if(U!==i.charCodeAt(o+C))break;U===b&&(D=C)}if(C===k)if(f>k){if(i.charCodeAt(o+C)===b)return i.slice(o+C+1);if(C===0)return i.slice(o+C)}else n>k&&(t.charCodeAt(a+C)===b?D=C:C===0&&(D=0));let L="";for(C=a+D+1;C<=s;++C)(C===s||t.charCodeAt(C)===b)&&(L+=L.length===0?"..":"/..");return`${L}${i.slice(o+D)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===b;let a=-1,s=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===b){if(!s){a=n;break}}else s=!1;return a===-1?i?"/":".":i&&a===1?"//":t.slice(0,a)},basename(t,i){i!==void 0&&d(i,"ext"),d(t,"path");let a=0,s=-1,n=!0,o;if(i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let f=i.length-1,k=-1;for(o=t.length-1;o>=0;--o){const D=t.charCodeAt(o);if(D===b){if(!n){a=o+1;break}}else k===-1&&(n=!1,k=o+1),f>=0&&(D===i.charCodeAt(f)?--f===-1&&(s=o):(f=-1,s=k))}return a===s?s=k:s===-1&&(s=t.length),t.slice(a,s)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===b){if(!n){a=o+1;break}}else s===-1&&(n=!1,s=o+1);return s===-1?"":t.slice(a,s)},extname(t){d(t,"path");let i=-1,a=0,s=-1,n=!0,o=0;for(let f=t.length-1;f>=0;--f){const k=t.charCodeAt(f);if(k===b){if(!n){a=f+1;break}continue}s===-1&&(n=!1,s=f+1),k===P?i===-1?i=f:o!==1&&(o=1):i!==-1&&(o=-1)}return i===-1||s===-1||o===0||o===1&&i===s-1&&i===a+1?"":t.slice(i,s)},format:y.bind(null,"/"),parse(t){d(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const a=t.charCodeAt(0)===b;let s;a?(i.root="/",s=1):s=0;let n=-1,o=0,f=-1,k=!0,D=t.length-1,C=0;for(;D>=s;--D){const L=t.charCodeAt(D);if(L===b){if(!k){o=D+1;break}continue}f===-1&&(k=!1,f=D+1),L===P?n===-1?n=D:C!==1&&(C=1):n!==-1&&(C=-1)}if(f!==-1){const L=o===0&&a?1:o;n===-1||C===0||C===1&&n===f-1&&n===o+1?i.base=i.name=t.slice(L,f):(i.name=t.slice(L,n),i.base=t.slice(L,f),i.ext=t.slice(n,f))}return o>0?i.dir=t.slice(0,o-1):a&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$5c.win32=e.$4c.win32=e.$4c,e.$5c.posix=e.$4c.posix=e.$5c,e.$6c=m?e.$4c.normalize:e.$5c.normalize,e.$7c=m?e.$4c.isAbsolute:e.$5c.isAbsolute,e.$8c=m?e.$4c.join:e.$5c.join,e.$9c=m?e.$4c.resolve:e.$5c.resolve,e.$0c=m?e.$4c.relative:e.$5c.relative,e.$$c=m?e.$4c.dirname:e.$5c.dirname,e.$_c=m?e.$4c.basename:e.$5c.basename,e.$ad=m?e.$4c.extname:e.$5c.extname,e.$bd=m?e.$4c.format:e.$5c.format,e.$cd=m?e.$4c.parse:e.$5c.parse,e.$dd=m?e.$4c.toNamespacedPath:e.$5c.toNamespacedPath,e.sep=m?e.$4c.sep:e.$5c.sep,e.$fd=m?e.$4c.delimiter:e.$5c.delimiter}),define(we[58],be([1,0,7]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=void 0,e.$zr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},r={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(A){const E=(0,v.$ad)(A),w=R[E.toLowerCase()];return w!==void 0?w:I(A)}e.$Ar=S;function I(A){const E=(0,v.$ad)(A);return r[E.toLowerCase()]}e.$Br=I;function P(A){for(const E in r)if(r[E]===A)return E}e.$Cr=P;const b=/^(.+)\/(.+?)(;.+)?$/;function $(A,E){const w=b.exec(A);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:E?void 0:A}e.$Dr=$}),define(we[59],be([1,0,3]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.TerminateResponseCode=e.Source=void 0;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R||(e.Source=R={}));var r;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function S(P,...b){const $=b.reduce((w,l)=>(w[l]=!0,w),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(P).filter(w=>!$[w]).forEach(w=>{for(let l=0;l<A.length;l++)if(w.search(A[l])!==-1){delete P[w];break}})}e.$gl=S;function I(P){P&&(delete P.DEBUG,v.$e&&delete P.DYLD_LIBRARY_PATH,v.$f&&delete P.LD_PRELOAD)}e.$hl=I}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var R in v)(typeof exports=="object"?exports:le)[R]=v[R]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function v(R){if(e[R])return e[R].exports;var r=e[R]={i:R,l:!1,exports:{}};return le[R].call(r.exports,r,r.exports,v),r.l=!0,r.exports}return v.m=le,v.c=e,v.d=function(R,r,S){v.o(R,r)||Object.defineProperty(R,r,{enumerable:!0,get:S})},v.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},v.t=function(R,r){if(1&r&&(R=v(R)),8&r||4&r&&typeof R=="object"&&R&&R.__esModule)return R;var S=Object.create(null);if(v.r(S),Object.defineProperty(S,"default",{enumerable:!0,value:R}),2&r&&typeof R!="string")for(var I in R)v.d(S,I,function(P){return R[P]}.bind(null,I));return S},v.n=function(R){var r=R&&R.__esModule?function(){return R.default}:function(){return R};return v.d(r,"a",r),r},v.o=function(R,r){return Object.prototype.hasOwnProperty.call(R,r)},v.p="",v(v.s=0)}([function(le,e,v){(function(R){var r;e=le.exports=q,r=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var $e=Array.prototype.slice.call(arguments,0);$e.unshift("SEMVER"),console.log.apply(console,$e)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var S=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],b=e.src=[],$=0,A=$++;b[A]="0|[1-9]\\d*";var E=$++;b[E]="[0-9]+";var w=$++;b[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=$++;b[l]="("+b[A]+")\\.("+b[A]+")\\.("+b[A]+")";var d=$++;b[d]="("+b[E]+")\\.("+b[E]+")\\.("+b[E]+")";var m=$++;b[m]="(?:"+b[A]+"|"+b[w]+")";var c=$++;b[c]="(?:"+b[E]+"|"+b[w]+")";var u=$++;b[u]="(?:-("+b[m]+"(?:\\."+b[m]+")*))";var h=$++;b[h]="(?:-?("+b[c]+"(?:\\."+b[c]+")*))";var g=$++;b[g]="[0-9A-Za-z-]+";var y=$++;b[y]="(?:\\+("+b[g]+"(?:\\."+b[g]+")*))";var p=$++,t="v?"+b[l]+b[u]+"?"+b[y]+"?";b[p]="^"+t+"$";var i="[v=\\s]*"+b[d]+b[h]+"?"+b[y]+"?",a=$++;b[a]="^"+i+"$";var s=$++;b[s]="((?:<|>)?=?)";var n=$++;b[n]=b[E]+"|x|X|\\*";var o=$++;b[o]=b[A]+"|x|X|\\*";var f=$++;b[f]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[u]+")?"+b[y]+"?)?)?";var k=$++;b[k]="[v=\\s]*("+b[n]+")(?:\\.("+b[n]+")(?:\\.("+b[n]+")(?:"+b[h]+")?"+b[y]+"?)?)?";var D=$++;b[D]="^"+b[s]+"\\s*"+b[f]+"$";var C=$++;b[C]="^"+b[s]+"\\s*"+b[k]+"$";var L=$++;b[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=$++;b[U]="(?:~>?)";var x=$++;b[x]="(\\s*)"+b[U]+"\\s+",P[x]=new RegExp(b[x],"g");var ae=$++;b[ae]="^"+b[U]+b[f]+"$";var W=$++;b[W]="^"+b[U]+b[k]+"$";var te=$++;b[te]="(?:\\^)";var ue=$++;b[ue]="(\\s*)"+b[te]+"\\s+",P[ue]=new RegExp(b[ue],"g");var Z=$++;b[Z]="^"+b[te]+b[f]+"$";var he=$++;b[he]="^"+b[te]+b[k]+"$";var V=$++;b[V]="^"+b[s]+"\\s*("+i+")$|^$";var se=$++;b[se]="^"+b[s]+"\\s*("+t+")$|^$";var K=$++;b[K]="(\\s*)"+b[s]+"\\s*("+i+"|"+b[f]+")",P[K]=new RegExp(b[K],"g");var Y=$++;b[Y]="^\\s*("+b[f]+")\\s+-\\s+("+b[f]+")\\s*$";var H=$++;b[H]="^\\s*("+b[k]+")\\s+-\\s+("+b[k]+")\\s*$";var _=$++;b[_]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)r(ge,b[ge]),P[ge]||(P[ge]=new RegExp(b[ge]));function ne($e,ke){if($e instanceof q)return $e;if(typeof $e!="string"||$e.length>S||!(ke?P[a]:P[p]).test($e))return null;try{return new q($e,ke)}catch{return null}}function q($e,ke){if($e instanceof q){if($e.loose===ke)return $e;$e=$e.version}else if(typeof $e!="string")throw new TypeError("Invalid Version: "+$e);if($e.length>S)throw new TypeError("version is longer than "+S+" characters");if(!(this instanceof q))return new q($e,ke);r("SemVer",$e,ke),this.loose=ke;var ye=$e.trim().match(ke?P[a]:P[p]);if(!ye)throw new TypeError("Invalid Version: "+$e);if(this.raw=$e,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Te){if(/^[0-9]+$/.test(Te)){var ze=+Te;if(ze>=0&&ze<I)return ze}return Te}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ne,e.valid=function($e,ke){var ye=ne($e,ke);return ye?ye.version:null},e.clean=function($e,ke){var ye=ne($e.trim().replace(/^[=v]+/,""),ke);return ye?ye.version:null},e.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function($e){return r("SemVer.compare",this.version,this.loose,$e),$e instanceof q||($e=new q($e,this.loose)),this.compareMain($e)||this.comparePre($e)},q.prototype.compareMain=function($e){return $e instanceof q||($e=new q($e,this.loose)),O(this.major,$e.major)||O(this.minor,$e.minor)||O(this.patch,$e.patch)},q.prototype.comparePre=function($e){if($e instanceof q||($e=new q($e,this.loose)),this.prerelease.length&&!$e.prerelease.length)return-1;if(!this.prerelease.length&&$e.prerelease.length)return 1;if(!this.prerelease.length&&!$e.prerelease.length)return 0;var ke=0;do{var ye=this.prerelease[ke],Te=$e.prerelease[ke];if(r("prerelease compare",ke,ye,Te),ye===void 0&&Te===void 0)return 0;if(Te===void 0)return 1;if(ye===void 0)return-1;if(ye!==Te)return O(ye,Te)}while(++ke)},q.prototype.inc=function($e,ke){switch($e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+$e)}return this.format(),this.raw=this.version,this},e.inc=function($e,ke,ye,Te){typeof ye=="string"&&(Te=ye,ye=void 0);try{return new q($e,ye).inc(ke,Te).version}catch{return null}},e.diff=function($e,ke){if(re($e,ke))return null;var ye=ne($e),Te=ne(ke);if(ye.prerelease.length||Te.prerelease.length){for(var ze in ye)if((ze==="major"||ze==="minor"||ze==="patch")&&ye[ze]!==Te[ze])return"pre"+ze;return"prerelease"}for(var ze in ye)if((ze==="major"||ze==="minor"||ze==="patch")&&ye[ze]!==Te[ze])return ze},e.compareIdentifiers=O;var X=/^[0-9]+$/;function O($e,ke){var ye=X.test($e),Te=X.test(ke);return ye&&Te&&($e=+$e,ke=+ke),ye&&!Te?-1:Te&&!ye?1:$e<ke?-1:$e>ke?1:0}function N($e,ke,ye){return new q($e,ye).compare(new q(ke,ye))}function J($e,ke,ye){return N($e,ke,ye)>0}function ie($e,ke,ye){return N($e,ke,ye)<0}function re($e,ke,ye){return N($e,ke,ye)===0}function ee($e,ke,ye){return N($e,ke,ye)!==0}function oe($e,ke,ye){return N($e,ke,ye)>=0}function F($e,ke,ye){return N($e,ke,ye)<=0}function z($e,ke,ye,Te){var ze;switch(ke){case"===":typeof $e=="object"&&($e=$e.version),typeof ye=="object"&&(ye=ye.version),ze=$e===ye;break;case"!==":typeof $e=="object"&&($e=$e.version),typeof ye=="object"&&(ye=ye.version),ze=$e!==ye;break;case"":case"=":case"==":ze=re($e,ye,Te);break;case"!=":ze=ee($e,ye,Te);break;case">":ze=J($e,ye,Te);break;case">=":ze=oe($e,ye,Te);break;case"<":ze=ie($e,ye,Te);break;case"<=":ze=F($e,ye,Te);break;default:throw new TypeError("Invalid operator: "+ke)}return ze}function j($e,ke){if($e instanceof j){if($e.loose===ke)return $e;$e=$e.value}if(!(this instanceof j))return new j($e,ke);r("comparator",$e,ke),this.loose=ke,this.parse($e),this.semver===B?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function($e,ke){return O(ke,$e)},e.major=function($e,ke){return new q($e,ke).major},e.minor=function($e,ke){return new q($e,ke).minor},e.patch=function($e,ke){return new q($e,ke).patch},e.compare=N,e.compareLoose=function($e,ke){return N($e,ke,!0)},e.rcompare=function($e,ke,ye){return N(ke,$e,ye)},e.sort=function($e,ke){return $e.sort(function(ye,Te){return e.compare(ye,Te,ke)})},e.rsort=function($e,ke){return $e.sort(function(ye,Te){return e.rcompare(ye,Te,ke)})},e.gt=J,e.lt=ie,e.eq=re,e.neq=ee,e.gte=oe,e.lte=F,e.cmp=z,e.Comparator=j;var B={};function Q($e,ke){if($e instanceof Q)return $e.loose===ke?$e:new Q($e.raw,ke);if($e instanceof j)return new Q($e.value,ke);if(!(this instanceof Q))return new Q($e,ke);if(this.loose=ke,this.raw=$e,this.set=$e.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$e);this.format()}function de($e){return!$e||$e.toLowerCase()==="x"||$e==="*"}function Ee($e,ke,ye,Te,ze,xe,qe,Ze,Ye,tt,me,De,Ae){return((ke=de(ye)?"":de(Te)?">="+ye+".0.0":de(ze)?">="+ye+"."+Te+".0":">="+ke)+" "+(Ze=de(Ye)?"":de(tt)?"<"+(+Ye+1)+".0.0":de(me)?"<"+Ye+"."+(+tt+1)+".0":De?"<="+Ye+"."+tt+"."+me+"-"+De:"<="+Ze)).trim()}function Pe($e,ke){for(var ye=0;ye<$e.length;ye++)if(!$e[ye].test(ke))return!1;if(ke.prerelease.length){for(ye=0;ye<$e.length;ye++)if(r($e[ye].semver),$e[ye].semver!==B&&$e[ye].semver.prerelease.length>0){var Te=$e[ye].semver;if(Te.major===ke.major&&Te.minor===ke.minor&&Te.patch===ke.patch)return!0}return!1}return!0}function Re($e,ke,ye){try{ke=new Q(ke,ye)}catch{return!1}return ke.test($e)}function Fe($e,ke,ye,Te){var ze,xe,qe,Ze,Ye;switch($e=new q($e,Te),ke=new Q(ke,Te),ye){case">":ze=J,xe=F,qe=ie,Ze=">",Ye=">=";break;case"<":ze=ie,xe=oe,qe=J,Ze="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re($e,ke,Te))return!1;for(var tt=0;tt<ke.set.length;++tt){var me=ke.set[tt],De=null,Ae=null;if(me.forEach(function(Ne){Ne.semver===B&&(Ne=new j(">=0.0.0")),De=De||Ne,Ae=Ae||Ne,ze(Ne.semver,De.semver,Te)?De=Ne:qe(Ne.semver,Ae.semver,Te)&&(Ae=Ne)}),De.operator===Ze||De.operator===Ye||(!Ae.operator||Ae.operator===Ze)&&xe($e,Ae.semver)||Ae.operator===Ye&&qe($e,Ae.semver))return!1}return!0}j.prototype.parse=function($e){var ke=this.loose?P[V]:P[se],ye=$e.match(ke);if(!ye)throw new TypeError("Invalid comparator: "+$e);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new q(ye[2],this.loose):this.semver=B},j.prototype.toString=function(){return this.value},j.prototype.test=function($e){return r("Comparator.test",$e,this.loose),this.semver===B||(typeof $e=="string"&&($e=new q($e,this.loose)),z($e,this.operator,this.semver,this.loose))},j.prototype.intersects=function($e,ke){if(!($e instanceof j))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new Q($e.value,ke),Re(this.value,ye,ke);if($e.operator==="")return ye=new Q(this.value,ke),Re($e.semver,ye,ke);var Te=!(this.operator!==">="&&this.operator!==">"||$e.operator!==">="&&$e.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||$e.operator!=="<="&&$e.operator!=="<"),xe=this.semver.version===$e.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||$e.operator!==">="&&$e.operator!=="<="),Ze=z(this.semver,"<",$e.semver,ke)&&(this.operator===">="||this.operator===">")&&($e.operator==="<="||$e.operator==="<"),Ye=z(this.semver,">",$e.semver,ke)&&(this.operator==="<="||this.operator==="<")&&($e.operator===">="||$e.operator===">");return Te||ze||xe&&qe||Ze||Ye},e.Range=Q,Q.prototype.format=function(){return this.range=this.set.map(function($e){return $e.join(" ").trim()}).join("||").trim(),this.range},Q.prototype.toString=function(){return this.range},Q.prototype.parseRange=function($e){var ke=this.loose;$e=$e.trim(),r("range",$e,ke);var ye=ke?P[H]:P[Y];$e=$e.replace(ye,Ee),r("hyphen replace",$e),$e=$e.replace(P[K],"$1$2$3"),r("comparator trim",$e,P[K]),$e=($e=($e=$e.replace(P[x],"$1~")).replace(P[ue],"$1^")).split(/\s+/).join(" ");var Te=ke?P[V]:P[se],ze=$e.split(" ").map(function(xe){return function(qe,Ze){return r("comp",qe),qe=function(Ye,tt){return Ye.trim().split(/\s+/).map(function(me){return function(De,Ae){r("caret",De,Ae);var Ne=Ae?P[he]:P[Z];return De.replace(Ne,function(Be,Me,He,Ge,Je){var Ve;return r("caret",De,Be,Me,He,Ge,Je),de(Me)?Ve="":de(He)?Ve=">="+Me+".0.0 <"+(+Me+1)+".0.0":de(Ge)?Ve=Me==="0"?">="+Me+"."+He+".0 <"+Me+"."+(+He+1)+".0":">="+Me+"."+He+".0 <"+(+Me+1)+".0.0":Je?(r("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),Ve=Me==="0"?He==="0"?">="+Me+"."+He+"."+Ge+Je+" <"+Me+"."+He+"."+(+Ge+1):">="+Me+"."+He+"."+Ge+Je+" <"+Me+"."+(+He+1)+".0":">="+Me+"."+He+"."+Ge+Je+" <"+(+Me+1)+".0.0"):(r("no pr"),Ve=Me==="0"?He==="0"?">="+Me+"."+He+"."+Ge+" <"+Me+"."+He+"."+(+Ge+1):">="+Me+"."+He+"."+Ge+" <"+Me+"."+(+He+1)+".0":">="+Me+"."+He+"."+Ge+" <"+(+Me+1)+".0.0"),r("caret return",Ve),Ve})}(me,tt)}).join(" ")}(qe,Ze),r("caret",qe),qe=function(Ye,tt){return Ye.trim().split(/\s+/).map(function(me){return function(De,Ae){var Ne=Ae?P[W]:P[ae];return De.replace(Ne,function(Be,Me,He,Ge,Je){var Ve;return r("tilde",De,Be,Me,He,Ge,Je),de(Me)?Ve="":de(He)?Ve=">="+Me+".0.0 <"+(+Me+1)+".0.0":de(Ge)?Ve=">="+Me+"."+He+".0 <"+Me+"."+(+He+1)+".0":Je?(r("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),Ve=">="+Me+"."+He+"."+Ge+Je+" <"+Me+"."+(+He+1)+".0"):Ve=">="+Me+"."+He+"."+Ge+" <"+Me+"."+(+He+1)+".0",r("tilde return",Ve),Ve})}(me,tt)}).join(" ")}(qe,Ze),r("tildes",qe),qe=function(Ye,tt){return r("replaceXRanges",Ye,tt),Ye.split(/\s+/).map(function(me){return function(De,Ae){De=De.trim();var Ne=Ae?P[C]:P[D];return De.replace(Ne,function(Be,Me,He,Ge,Je,Ve){r("xRange",De,Be,Me,He,Ge,Je,Ve);var et=de(He),Xe=et||de(Ge),ot=Xe||de(Je);return Me==="="&&ot&&(Me=""),et?Be=Me===">"||Me==="<"?"<0.0.0":"*":Me&&ot?(Xe&&(Ge=0),ot&&(Je=0),Me===">"?(Me=">=",Xe?(He=+He+1,Ge=0,Je=0):ot&&(Ge=+Ge+1,Je=0)):Me==="<="&&(Me="<",Xe?He=+He+1:Ge=+Ge+1),Be=Me+He+"."+Ge+"."+Je):Xe?Be=">="+He+".0.0 <"+(+He+1)+".0.0":ot&&(Be=">="+He+"."+Ge+".0 <"+He+"."+(+Ge+1)+".0"),r("xRange return",Be),Be})}(me,tt)}).join(" ")}(qe,Ze),r("xrange",qe),qe=function(Ye,tt){return r("replaceStars",Ye,tt),Ye.trim().replace(P[_],"")}(qe,Ze),r("stars",qe),qe}(xe,ke)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(xe){return!!xe.match(Te)})),ze=ze.map(function(xe){return new j(xe,ke)})},Q.prototype.intersects=function($e,ke){if(!($e instanceof Q))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Te){return $e.set.some(function(ze){return ze.every(function(xe){return Te.intersects(xe,ke)})})})})},e.toComparators=function($e,ke){return new Q($e,ke).set.map(function(ye){return ye.map(function(Te){return Te.value}).join(" ").trim().split(" ")})},Q.prototype.test=function($e){if(!$e)return!1;typeof $e=="string"&&($e=new q($e,this.loose));for(var ke=0;ke<this.set.length;ke++)if(Pe(this.set[ke],$e))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function($e,ke,ye){var Te=null,ze=null;try{var xe=new Q(ke,ye)}catch{return null}return $e.forEach(function(qe){xe.test(qe)&&(Te&&ze.compare(qe)!==-1||(ze=new q(Te=qe,ye)))}),Te},e.minSatisfying=function($e,ke,ye){var Te=null,ze=null;try{var xe=new Q(ke,ye)}catch{return null}return $e.forEach(function(qe){xe.test(qe)&&(Te&&ze.compare(qe)!==1||(ze=new q(Te=qe,ye)))}),Te},e.validRange=function($e,ke){try{return new Q($e,ke).range||"*"}catch{return null}},e.ltr=function($e,ke,ye){return Fe($e,ke,"<",ye)},e.gtr=function($e,ke,ye){return Fe($e,ke,">",ye)},e.outside=Fe,e.prerelease=function($e,ke){var ye=ne($e,ke);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function($e,ke,ye){return $e=new Q($e,ye),ke=new Q(ke,ye),$e.intersects(ke)},e.coerce=function($e){if($e instanceof q)return $e;if(typeof $e!="string")return null;var ke=$e.match(P[L]);return ke==null?null:ne((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,v(1))},function(le,e){var v,R,r=le.exports={};function S(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function P(c){if(v===setTimeout)return setTimeout(c,0);if((v===S||!v)&&setTimeout)return v=setTimeout,setTimeout(c,0);try{return v(c,0)}catch{try{return v.call(null,c,0)}catch{return v.call(this,c,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:S}catch{v=S}try{R=typeof clearTimeout=="function"?clearTimeout:I}catch{R=I}})();var b,$=[],A=!1,E=-1;function w(){A&&b&&(A=!1,b.length?$=b.concat($):E=-1,$.length&&l())}function l(){if(!A){var c=P(w);A=!0;for(var u=$.length;u;){for(b=$,$=[];++E<u;)b&&b[E].run();E=-1,u=$.length}b=null,A=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===I||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}(c)}}function d(c,u){this.fun=c,this.array=u}function m(){}r.nextTick=function(c){var u=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)u[h-1]=arguments[h];$.push(new d(c,u)),$.length!==1||A||P(l)},d.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=m,r.addListener=m,r.once=m,r.off=m,r.removeListener=m,r.removeAllListeners=m,r.emit=m,r.prependListener=m,r.prependOnceListener=m,r.listeners=function(c){return[]},r.binding=function(c){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(c){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(we[144],be([1,0]),function(le,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class R{constructor(P,b,$){this.level=P,this.key=b,this.value=$,this.forward=[]}}const r=void 0;class S{constructor(P,b=2**16){this.comparator=P,this[v]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new R(this.c,r,r)}get size(){return this.f}clear(){this.e=new R(this.c,r,r)}has(P){return!!S.g(this,P,this.comparator)}get(P){return S.g(this,P,this.comparator)?.value}set(P,b){return S.h(this,P,b,this.comparator)&&(this.f+=1),this}delete(P){const b=S.k(this,P,this.comparator);return b&&(this.f-=1),b}forEach(P,b){let $=this.e.forward[0];for(;$;)P.call(b,$.value,$.key,this),$=$.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",b=this.e.forward[0];for(;b;)P+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return P}static g(P,b,$){let A=P.e;for(let E=P.d-1;E>=0;E--)for(;A.forward[E]&&$(A.forward[E].key,b)<0;)A=A.forward[E];if(A=A.forward[0],A&&$(A.key,b)===0)return A}static h(P,b,$,A){const E=[];let w=P.e;for(let l=P.d-1;l>=0;l--){for(;w.forward[l]&&A(w.forward[l].key,b)<0;)w=w.forward[l];E[l]=w}if(w=w.forward[0],w&&A(w.key,b)===0)return w.value=$,!1;{const l=S.j(P);if(l>P.d){for(let d=P.d;d<l;d++)E[d]=P.e;P.d=l}w=new R(l,b,$);for(let d=0;d<l;d++)w.forward[d]=E[d].forward[d],E[d].forward[d]=w;return!0}}static j(P,b=.5){let $=1;for(;Math.random()<b&&$<P.c;)$+=1;return $}static k(P,b,$){const A=[];let E=P.e;for(let w=P.d-1;w>=0;w--){for(;E.forward[w]&&$(E.forward[w].key,b)<0;)E=E.forward[w];A[w]=E}if(E=E.forward[0],!E||$(E.key,b)!==0)return!1;for(let w=0;w<P.d&&A[w].forward[w]===E;w++)A[w].forward[w]=E.forward[w];for(;P.d>0&&P.e.forward[P.d-1]===r;)P.d-=1;return!0}}e.$gr=S}),define(we[60],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=void 0;const v=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(S){return new R(S)}constructor(S){this.c=v&&S===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ac=R}),define(we[5],be([1,0,11,74,2,98,60]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.Event=void 0;const P=!1,b=!1;var $;(function(D){D.None=()=>r.$lb.None;function C(oe){if(b){const{onDidAddListener:F}=oe,z=d.create();let j=0;oe.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),z.print()),F?.()}}}function L(oe,F){return V(oe,()=>{},0,void 0,!0,void 0,F)}D.defer=L;function U(oe){return(F,z=null,j)=>{let B=!1,Q;return Q=oe(de=>{if(!B)return Q?Q.dispose():B=!0,F.call(z,de)},null,j),B&&Q.dispose(),Q}}D.once=U;function x(oe,F,z){return he((j,B=null,Q)=>oe(de=>j.call(B,F(de)),null,Q),z)}D.map=x;function ae(oe,F,z){return he((j,B=null,Q)=>oe(de=>{F(de),j.call(B,de)},null,Q),z)}D.forEach=ae;function W(oe,F,z){return he((j,B=null,Q)=>oe(de=>F(de)&&j.call(B,de),null,Q),z)}D.filter=W;function te(oe){return oe}D.signal=te;function ue(...oe){return(F,z=null,j)=>(0,r.$ib)(...oe.map(B=>B(Q=>F.call(z,Q),null,j)))}D.any=ue;function Z(oe,F,z,j){let B=z;return x(oe,Q=>(B=F(B,Q),B),j)}D.reduce=Z;function he(oe,F){let z;const j={onWillAddFirstListener(){z=oe(B.fire,B)},onDidRemoveLastListener(){z?.dispose()}};F||C(j);const B=new g(j);return F?.add(B),B.event}function V(oe,F,z=100,j=!1,B=!1,Q,de){let Ee,Pe,Re,Fe=0,$e;const ke={leakWarningThreshold:Q,onWillAddFirstListener(){Ee=oe(Te=>{Fe++,Pe=F(Pe,Te),j&&!Re&&(ye.fire(Pe),Pe=void 0),$e=()=>{const ze=Pe;Pe=void 0,Re=void 0,(!j||Fe>1)&&ye.fire(ze),Fe=0},typeof z=="number"?(clearTimeout(Re),Re=setTimeout($e,z)):Re===void 0&&(Re=0,queueMicrotask($e))})},onWillRemoveListener(){B&&Fe>0&&$e?.()},onDidRemoveLastListener(){$e=void 0,Ee.dispose()}};de||C(ke);const ye=new g(ke);return de?.add(ye),ye.event}D.debounce=V;function se(oe,F=0,z){return D.debounce(oe,(j,B)=>j?(j.push(B),j):[B],F,void 0,!0,void 0,z)}D.accumulate=se;function K(oe,F=(j,B)=>j===B,z){let j=!0,B;return W(oe,Q=>{const de=j||!F(Q,B);return j=!1,B=Q,de},z)}D.latch=K;function Y(oe,F,z){return[D.filter(oe,F,z),D.filter(oe,j=>!F(j),z)]}D.split=Y;function H(oe,F=!1,z=[]){let j=z.slice(),B=oe(Ee=>{j?j.push(Ee):de.fire(Ee)});const Q=()=>{j?.forEach(Ee=>de.fire(Ee)),j=null},de=new g({onWillAddFirstListener(){B||(B=oe(Ee=>de.fire(Ee)))},onDidAddFirstListener(){j&&(F?setTimeout(Q):Q())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return de.event}D.buffer=H;class _{constructor(F){this.event=F,this.d=new r.$kb}map(F){return new _(x(this.event,F,this.d))}forEach(F){return new _(ae(this.event,F,this.d))}filter(F){return new _(W(this.event,F,this.d))}reduce(F,z){return new _(Z(this.event,F,z,this.d))}latch(){return new _(K(this.event,void 0,this.d))}debounce(F,z=100,j=!1,B=!1,Q){return new _(V(this.event,F,z,j,B,Q,this.d))}on(F,z,j){return this.event(F,z,j)}once(F,z,j){return U(this.event)(F,z,j)}dispose(){this.d.dispose()}}function ge(oe){return new _(oe)}D.chain=ge;function ne(oe,F,z=j=>j){const j=(...Ee)=>de.fire(z(...Ee)),B=()=>oe.on(F,j),Q=()=>oe.removeListener(F,j),de=new g({onWillAddFirstListener:B,onDidRemoveLastListener:Q});return de.event}D.fromNodeEventEmitter=ne;function q(oe,F,z=j=>j){const j=(...Ee)=>de.fire(z(...Ee)),B=()=>oe.addEventListener(F,j),Q=()=>oe.removeEventListener(F,j),de=new g({onWillAddFirstListener:B,onDidRemoveLastListener:Q});return de.event}D.fromDOMEventEmitter=q;function X(oe){return new Promise(F=>U(oe)(F))}D.toPromise=X;function O(oe){const F=new g;return oe.then(z=>{F.fire(z)},()=>{F.fire(void 0)}).finally(()=>{F.dispose()}),F.event}D.fromPromise=O;function N(oe,F){return F(void 0),oe(z=>F(z))}D.runAndSubscribe=N;function J(oe,F){let z=null;function j(Q){z?.dispose(),z=new r.$kb,F(Q,z)}j(void 0);const B=oe(Q=>j(Q));return(0,r.$jb)(()=>{B.dispose(),z?.dispose()})}D.runAndSubscribeWithStore=J;class ie{constructor(F,z){this._observable=F,this.d=0,this.f=!1;const j={onWillAddFirstListener:()=>{F.addObserver(this)},onDidRemoveLastListener:()=>{F.removeObserver(this)}};z||C(j),this.emitter=new g(j),z&&z.add(this.emitter)}beginUpdate(F){this.d++}handlePossibleChange(F){}handleChange(F,z){this.f=!0}endUpdate(F){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function re(oe,F){return new ie(oe,F).emitter.event}D.fromObservable=re;function ee(oe){return F=>{let z=0,j=!1;const B={beginUpdate(){z++},endUpdate(){z--,z===0&&(oe.reportChanges(),j&&(j=!1,F()))},handlePossibleChange(){},handleChange(){j=!0}};return oe.addObserver(B),oe.reportChanges(),{dispose(){oe.removeObserver(B)}}}}D.fromObservableLight=ee})($||(e.Event=$={}));class A{constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${A.d++}`,A.all.add(this)}start(C){this.f=new I.$ac,this.listenerCount=C}stop(){if(this.f){const C=this.f.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this.f=void 0}}}e.$cc=A,A.all=new Set,A.d=0;let E=-1;function w(D){const C=E;return E=D,{dispose(){E=C}}}e.$dc=w;class l{constructor(C,L=Math.random().toString(18).slice(2,5)){this.threshold=C,this.name=L,this.f=0}dispose(){this.d?.clear()}check(C,L){const U=this.threshold;if(U<=0||L<U)return;this.d||(this.d=new Map);const x=this.d.get(C.value)||0;if(this.d.set(C.value,x+1),this.f-=1,this.f<=0){this.f=U*.5;let ae,W=0;for(const[te,ue]of this.d)(!ae||W<ue)&&(ae=te,W=ue);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${W}):`),console.warn(ae)}return()=>{const ae=this.d.get(C.value)||0;this.d.set(C.value,ae-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class c{constructor(C){this.value=C,this.id=m++}}const u=2,h=(D,C)=>{if(D instanceof c)C(D);else for(let L=0;L<D.length;L++){const U=D[L];U&&C(U)}};class g{constructor(C){this.u=0,this.d=C,this.f=E>0||this.d?.leakWarningThreshold?new l(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new A(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(P){const C=this.q;queueMicrotask(()=>{h(C,L=>L.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??(this.m=(C,L,U)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$lb.None;if(this.j)return r.$lb.None;L&&(C=C.bind(L));const x=new c(C);let ae,W;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(x.stack=d.create(),ae=this.f.check(x.stack,this.u+1)),P&&(x.stack=W??d.create()),this.q?this.q instanceof c?(this.t??(this.t=new p),this.q=[this.q,x]):this.q.push(x):(this.d?.onWillAddFirstListener?.(this),this.q=x,this.d?.onDidAddFirstListener?.(this)),this.u++;const te=(0,r.$jb)(()=>{ae?.(),this.v(x)});return U instanceof r.$kb?U.add(te):Array.isArray(U)&&U.push(te),te}),this.m}v(C){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const L=this.q,U=L.indexOf(C);if(U===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,L[U]=void 0;const x=this.t.current===this;if(this.u*u<=L.length){let ae=0;for(let W=0;W<L.length;W++)L[W]?L[ae++]=L[W]:x&&(this.t.end--,ae<this.t.i&&this.t.i--);L.length=ae}}w(C,L){if(!C)return;const U=this.d?.onListenerError||v.$Y;if(!U){C.value(L);return}try{C.value(L)}catch(x){U(x)}}x(C){const L=C.current.q;for(;C.i<C.end;)this.w(L[C.i++],C.value);C.reset()}fire(C){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof c)this.w(this.q,C);else{const L=this.t;L.enqueue(this,C,this.q.length),this.x(L)}this.g?.stop()}hasListeners(){return this.u>0}}e.$ec=g;const y=()=>new p;e.$fc=y;class p{constructor(){this.i=-1,this.end=0}enqueue(C,L,U){this.i=0,this.end=U,this.current=C,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends g{async fireAsync(C,L,U){if(this.q)for(this.h||(this.h=new S.$ub),h(this.q,x=>this.h.push([x.value,C]));this.h.size>0&&!L.isCancellationRequested;){const[x,ae]=this.h.shift(),W=[],te={...ae,token:L,waitUntil:ue=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");U&&(ue=U(ue,x)),W.push(ue)}};try{x(te)}catch(ue){(0,v.$Y)(ue);continue}Object.freeze(W),await Promise.allSettled(W).then(ue=>{for(const Z of ue)Z.status==="rejected"&&(0,v.$Y)(Z.reason)})}}}e.$gc=t;class i extends g{get isPaused(){return this.h!==0}constructor(C){super(C),this.h=0,this.s=new S.$ub,this.y=C?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const C=Array.from(this.s);this.s.clear(),super.fire(this.y(C))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(C){this.u&&(this.h!==0?this.s.push(C):super.fire(C))}}e.$hc=i;class a extends i{constructor(C){super(C),this.k=C.delay??100}fire(C){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(C)}}e.$ic=a;class s extends g{constructor(C){super(C),this.h=[],this.k=C?.merge}fire(C){this.hasListeners()&&(this.h.push(C),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}e.$jc=s;class n{constructor(){this.f=!1,this.g=[],this.d=new g({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(C){const L={event:C,listener:null};this.g.push(L),this.f&&this.k(L);const U=()=>{this.f&&this.m(L);const x=this.g.indexOf(L);this.g.splice(x,1)};return(0,r.$jb)((0,R.$cb)(U))}h(){this.f=!0,this.g.forEach(C=>this.k(C))}j(){this.f=!1,this.g.forEach(C=>this.m(C))}k(C){C.listener=C.event(L=>this.d.fire(L))}m(C){C.listener&&C.listener.dispose(),C.listener=null}dispose(){this.d.dispose()}}e.$kc=n;class o{constructor(C,L,U,x){this.d=new r.$kb;const ae=this.d.add(new n),W=this.d.add(new r.$tb);function te(ue){W.set(ue,ae.add(x(ue)))}for(const ue of C)te(ue);this.d.add(L(ue=>{te(ue)})),this.d.add(U(ue=>{W.deleteAndDispose(ue)})),this.event=ae.event}dispose(){this.d.dispose()}}e.$lc=o;class f{constructor(){this.d=[]}wrapEvent(C){return(L,U,x)=>C(ae=>{const W=this.d[this.d.length-1];W?W.push(()=>L.call(U,ae)):L.call(U,ae)},void 0,x)}bufferEvents(C){const L=[];this.d.push(L);const U=C();return this.d.pop(),L.forEach(x=>x()),U}}e.$mc=f;class k{constructor(){this.d=!1,this.f=$.None,this.g=r.$lb.None,this.h=new g({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(C){this.f=C,this.d&&(this.g.dispose(),this.g=C(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$nc=k}),define(we[20],be([1,0,5]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oc=e.CancellationToken=void 0;const R=Object.freeze(function(P,b){const $=setTimeout(P.bind(b),0);return{dispose(){clearTimeout($)}}});var r;(function(P){function b($){return $===P.None||$===P.Cancelled||$ instanceof S?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}P.isCancellationToken=b,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(r||(e.CancellationToken=r={}));class S{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new v.$ec),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(b){this.a=void 0,this.b=void 0,this.b=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new S),this.a}cancel(){this.a?this.a instanceof S&&this.a.cancel():this.a=r.Cancelled}dispose(b=!1){b&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof S&&this.a.dispose():this.a=r.None}}e.$oc=I}),define(we[145],be([1,0,20]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=e.$hd=e.$gd=void 0;class R{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new v.$oc,b=this.b(P.token);return this.a={promise:b,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$gd=R;class r{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const b=JSON.stringify(P);return this.b!==b&&(this.b=b,this.a=this.c(P)),this.a}}e.$hd=r;class S{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const b=this.b(P);return this.a.set(P,b),b}}e.$id=S}),define(we[48],be([1,0,11,2]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function r(y){const p=y;return p?typeof p.read=="function":!1}e.$pc=r;function S(y){const p=y;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.$qc=S;function I(y){const p=y;return p?S(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.$rc=I;function P(y,p){return new b(y,p)}e.$sc=P;class b{constructor(p,t){this.e=p,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(t=>t(p))}h(p){this.c.error.length===0?(0,v.$Y)(p):this.c.error.slice(0).forEach(t=>t(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,t){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(p,t){if(this.a.destroyed)return;let i;switch(p){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const a=i.indexOf(t);a>=0&&i.splice(a,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(y,p){const t=[];let i;for(;(i=y.read())!==null;)t.push(i);return p(t)}e.$tc=$;function A(y,p,t){const i=[];let a;for(;(a=y.read())!==null&&i.length<t;)i.push(a);return a===null&&i.length>0?p(i):{read:()=>{if(i.length>0)return i.shift();if(typeof a<"u"){const s=a;return a=void 0,s}return y.read()}}}e.$uc=A;function E(y,p){return new Promise((t,i)=>{const a=[];w(y,{onData:s=>{p&&a.push(s)},onError:s=>{p?i(s):t(void 0)},onEnd:()=>{t(p?p(a):void 0)}})})}e.$vc=E;function w(y,p,t){y.on("error",i=>{t?.isCancellationRequested||p.onError(i)}),y.on("end",()=>{t?.isCancellationRequested||p.onEnd()}),y.on("data",i=>{t?.isCancellationRequested||p.onData(i)})}e.$wc=w;function l(y,p){return new Promise((t,i)=>{const a=new R.$kb,s=[],n=k=>{if(s.push(k),s.length>p)return a.dispose(),y.pause(),t({stream:y,buffer:s,ended:!1})},o=k=>i(k),f=()=>t({stream:y,buffer:s,ended:!0});a.add((0,R.$jb)(()=>y.removeListener("error",o))),y.on("error",o),a.add((0,R.$jb)(()=>y.removeListener("end",f))),y.on("end",f),a.add((0,R.$jb)(()=>y.removeListener("data",n))),y.on("data",n)})}e.$xc=l;function d(y,p){const t=P(p);return t.end(y),t}e.$yc=d;function m(){const y=P(()=>{throw new Error("not supported")});return y.end(),y}e.$zc=m;function c(y){let p=!1;return{read:()=>p?null:(p=!0,y)}}e.$Ac=c;function u(y,p,t){const i=P(t);return w(y,{onData:a=>i.write(p.data(a)),onError:a=>i.error(p.error?p.error(a):a),onEnd:()=>i.end()}),i}e.$Bc=u;function h(y,p,t){let i=!1;return{read:()=>{const a=p.read();return i?a:(i=!0,a!==null?t([y,a]):y)}}}e.$Cc=h;function g(y,p,t){let i=!1;const a=P(t);return w(p,{onData:s=>i?a.write(s):(i=!0,a.write(t([y,s]))),onError:s=>a.error(s),onEnd:()=>{i||(i=!0,a.write(y)),a.end()}}),a}e.$Dc=g}),define(we[15],be([1,0,97,48]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=void 0;const r=typeof Buffer<"u",S=new v.$T(()=>new Uint8Array(256));let I,P;class b{static alloc(L){return r?new b(Buffer.allocUnsafe(L)):new b(new Uint8Array(L))}static wrap(L){return r&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new b(L)}static fromString(L,U){return!(U?.dontUseNodeBuffer||!1)&&r?new b(Buffer.from(L)):(I||(I=new TextEncoder),new b(I.encode(L)))}static fromByteArray(L){const U=b.alloc(L.length);for(let x=0,ae=L.length;x<ae;x++)U.buffer[x]=L[x];return U}static concat(L,U){if(typeof U>"u"){U=0;for(let W=0,te=L.length;W<te;W++)U+=L[W].byteLength}const x=b.alloc(U);let ae=0;for(let W=0,te=L.length;W<te;W++){const ue=L[W];x.set(ue,ae),ae+=ue.byteLength}return x}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=b.alloc(this.byteLength);return L.set(this),L}toString(){return r?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(L,U){return new b(this.buffer.subarray(L,U))}set(L,U){if(L instanceof b)this.buffer.set(L.buffer,U);else if(L instanceof Uint8Array)this.buffer.set(L,U);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),U);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return w(this.buffer,L)}writeUInt32BE(L,U){l(this.buffer,L,U)}readUInt32LE(L){return d(this.buffer,L)}writeUInt32LE(L,U){m(this.buffer,L,U)}readUInt8(L){return c(this.buffer,L)}writeUInt8(L,U){u(this.buffer,L,U)}indexOf(L,U=0){return $(this.buffer,L instanceof b?L.buffer:L,U)}}e.$Ec=b;function $(C,L,U=0){const x=L.byteLength,ae=C.byteLength;if(x===0)return 0;if(x===1)return C.indexOf(L[0]);if(x>ae-U)return-1;const W=S.value;W.fill(L.length);for(let he=0;he<L.length;he++)W[L[he]]=L.length-he-1;let te=U+L.length-1,ue=te,Z=-1;for(;te<ae;)if(C[te]===L[ue]){if(ue===0){Z=te;break}te--,ue--}else te+=Math.max(L.length-ue,W[C[te]]),ue=L.length-1;return Z}e.$Fc=$;function A(C,L){return C[L+0]<<0>>>0|C[L+1]<<8>>>0}e.$Gc=A;function E(C,L,U){C[U+0]=L&255,L=L>>>8,C[U+1]=L&255}e.$Hc=E;function w(C,L){return C[L]*2**24+C[L+1]*2**16+C[L+2]*2**8+C[L+3]}e.$Ic=w;function l(C,L,U){C[U+3]=L,L=L>>>8,C[U+2]=L,L=L>>>8,C[U+1]=L,L=L>>>8,C[U]=L}e.$Jc=l;function d(C,L){return C[L+0]<<0>>>0|C[L+1]<<8>>>0|C[L+2]<<16>>>0|C[L+3]<<24>>>0}e.$Kc=d;function m(C,L,U){C[U+0]=L&255,L=L>>>8,C[U+1]=L&255,L=L>>>8,C[U+2]=L&255,L=L>>>8,C[U+3]=L&255}e.$Lc=m;function c(C,L){return C[L]}e.$Mc=c;function u(C,L,U){C[U]=L}e.$Nc=u;function h(C){return R.$tc(C,L=>b.concat(L))}e.$Oc=h;function g(C){return R.$Ac(C)}e.$Pc=g;function y(C){return R.$vc(C,L=>b.concat(L))}e.$Qc=y;async function p(C){return C.ended?b.concat(C.buffer):b.concat([...C.buffer,await y(C.stream)])}e.$Rc=p;function t(C){return R.$yc(C,L=>b.concat(L))}e.$Sc=t;function i(C){return R.$Bc(C,{data:L=>typeof L=="string"?b.fromString(L):b.wrap(L)},L=>b.concat(L))}e.$Tc=i;function a(C){return R.$sc(L=>b.concat(L),C)}e.$Uc=a;function s(C,L){return R.$Cc(C,L,U=>b.concat(U))}e.$Vc=s;function n(C,L){return R.$Dc(C,L,U=>b.concat(U))}e.$Wc=n;function o(C){let L=0,U=0,x=0;const ae=new Uint8Array(Math.floor(C.length/4*3)),W=ue=>{switch(U){case 3:ae[x++]=L|ue,U=0;break;case 2:ae[x++]=L|ue>>>2,L=ue<<6,U=3;break;case 1:ae[x++]=L|ue>>>4,L=ue<<4,U=2;break;default:L=ue<<2,U=1}};for(let ue=0;ue<C.length;ue++){const Z=C.charCodeAt(ue);if(Z>=65&&Z<=90)W(Z-65);else if(Z>=97&&Z<=122)W(Z-97+26);else if(Z>=48&&Z<=57)W(Z-48+52);else if(Z===43||Z===45)W(62);else if(Z===47||Z===95)W(63);else{if(Z===61)break;throw new SyntaxError(`Unexpected base64 character ${C[ue]}`)}}const te=x;for(;U>0;)W(0);return b.wrap(ae).slice(0,te)}e.$Xc=o;const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:C},L=!0,U=!1){const x=U?k:f;let ae="";const W=C.byteLength%3;let te=0;for(;te<C.byteLength-W;te+=3){const ue=C[te+0],Z=C[te+1],he=C[te+2];ae+=x[ue>>>2],ae+=x[(ue<<4|Z>>>4)&63],ae+=x[(Z<<2|he>>>6)&63],ae+=x[he&63]}if(W===1){const ue=C[te+0];ae+=x[ue>>>2],ae+=x[ue<<4&63],L&&(ae+="==")}else if(W===2){const ue=C[te+0],Z=C[te+1];ae+=x[ue>>>2],ae+=x[(ue<<4|Z>>>4)&63],ae+=x[Z<<2&63],L&&(ae+="=")}return ae}e.$Yc=D}),define(we[17],be([1,0,145,97]),function(le,e,v,R){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.GraphemeBreakType=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=void 0;function S(me){return!me||typeof me!="string"?!0:me.trim().length===0}e.$ld=S;const I=/{(\d+)}/g;function P(me,...De){return De.length===0?me:me.replace(I,function(Ae,Ne){const Be=parseInt(Ne,10);return isNaN(Be)||Be<0||Be>=De.length?Ae:De[Be]})}e.$md=P;const b=/{([^}]+)}/g;function $(me,De){return me.replace(b,(Ae,Ne)=>De[Ne]??Ae)}e.$nd=$;function A(me){return me.replace(/[<>&]/g,function(De){switch(De){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return De}})}e.$od=A;function E(me){return me.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$pd=E;function w(me,De){let Ae=0;const Ne=De.charCodeAt(0);for(let Be=me.length-1;Be>=0;Be--)me.charCodeAt(Be)===Ne&&Ae++;return Ae}e.$qd=w;function l(me,De,Ae="\u2026"){return me.length<=De?me:`${me.substr(0,De)}${Ae}`}e.$rd=l;function d(me,De=" "){const Ae=m(me,De);return c(Ae,De)}e.$sd=d;function m(me,De){if(!me||!De)return me;const Ae=De.length;if(Ae===0||me.length===0)return me;let Ne=0;for(;me.indexOf(De,Ne)===Ne;)Ne=Ne+Ae;return me.substring(Ne)}e.$td=m;function c(me,De){if(!me||!De)return me;const Ae=De.length,Ne=me.length;if(Ae===0||Ne===0)return me;let Be=Ne,Me=-1;for(;Me=me.lastIndexOf(De,Be-1),!(Me===-1||Me+Ae!==Be);){if(Me===0)return"";Be=Me}return me.substring(0,Be)}e.$ud=c;function u(me){return me.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$vd=u;function h(me){return me.replace(/\*/g,"")}e.$wd=h;function g(me,De,Ae={}){if(!me)throw new Error("Cannot create regex from empty string");De||(me=E(me)),Ae.wholeWord&&(/\B/.test(me.charAt(0))||(me="\\b"+me),/\B/.test(me.charAt(me.length-1))||(me=me+"\\b"));let Ne="";return Ae.global&&(Ne+="g"),Ae.matchCase||(Ne+="i"),Ae.multiline&&(Ne+="m"),Ae.unicode&&(Ne+="u"),new RegExp(me,Ne)}e.$xd=g;function y(me){return me.source==="^"||me.source==="^$"||me.source==="$"||me.source==="^\\s*$"?!1:!!(me.exec("")&&me.lastIndex===0)}e.$yd=y;function p(me){return me.split(/\r\n|\r|\n/)}e.$zd=p;function t(me){for(let De=0,Ae=me.length;De<Ae;De++){const Ne=me.charCodeAt(De);if(Ne!==32&&Ne!==9)return De}return-1}e.$Ad=t;function i(me,De=0,Ae=me.length){for(let Ne=De;Ne<Ae;Ne++){const Be=me.charCodeAt(Ne);if(Be!==32&&Be!==9)return me.substring(De,Ne)}return me.substring(De,Ae)}e.$Bd=i;function a(me,De=me.length-1){for(let Ae=De;Ae>=0;Ae--){const Ne=me.charCodeAt(Ae);if(Ne!==32&&Ne!==9)return Ae}return-1}e.$Cd=a;function s(me,De,Ae){const Ne=[];let Be=0;for(const Me of me.matchAll(De)){if(Ne.push(me.slice(Be,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Be=Me.index+Me[0].length,Ne.push(Ae(Me[0],...Me.slice(1),Me.index,me,Me.groups))}return Ne.push(me.slice(Be)),Promise.all(Ne).then(Me=>Me.join(""))}e.$Dd=s;function n(me,De){return me<De?-1:me>De?1:0}e.$Ed=n;function o(me,De,Ae=0,Ne=me.length,Be=0,Me=De.length){for(;Ae<Ne&&Be<Me;Ae++,Be++){const Je=me.charCodeAt(Ae),Ve=De.charCodeAt(Be);if(Je<Ve)return-1;if(Je>Ve)return 1}const He=Ne-Ae,Ge=Me-Be;return He<Ge?-1:He>Ge?1:0}e.$Fd=o;function f(me,De){return k(me,De,0,me.length,0,De.length)}e.$Gd=f;function k(me,De,Ae=0,Ne=me.length,Be=0,Me=De.length){for(;Ae<Ne&&Be<Me;Ae++,Be++){let Je=me.charCodeAt(Ae),Ve=De.charCodeAt(Be);if(Je===Ve)continue;if(Je>=128||Ve>=128)return o(me.toLowerCase(),De.toLowerCase(),Ae,Ne,Be,Me);C(Je)&&(Je-=32),C(Ve)&&(Ve-=32);const et=Je-Ve;if(et!==0)return et}const He=Ne-Ae,Ge=Me-Be;return He<Ge?-1:He>Ge?1:0}e.$Hd=k;function D(me){return me>=48&&me<=57}e.$Id=D;function C(me){return me>=97&&me<=122}e.$Jd=C;function L(me){return me>=65&&me<=90}e.$Kd=L;function U(me,De){return me.length===De.length&&k(me,De)===0}e.$Ld=U;function x(me,De){const Ae=De.length;return De.length>me.length?!1:k(me,De,0,Ae)===0}e.$Md=x;function ae(me,De){const Ae=Math.min(me.length,De.length);let Ne;for(Ne=0;Ne<Ae;Ne++)if(me.charCodeAt(Ne)!==De.charCodeAt(Ne))return Ne;return Ae}e.$Nd=ae;function W(me,De){const Ae=Math.min(me.length,De.length);let Ne;const Be=me.length-1,Me=De.length-1;for(Ne=0;Ne<Ae;Ne++)if(me.charCodeAt(Be-Ne)!==De.charCodeAt(Me-Ne))return Ne;return Ae}e.$Od=W;function te(me){return 55296<=me&&me<=56319}e.$Pd=te;function ue(me){return 56320<=me&&me<=57343}e.$Qd=ue;function Z(me,De){return(me-55296<<10)+(De-56320)+65536}e.$Rd=Z;function he(me,De,Ae){const Ne=me.charCodeAt(Ae);if(te(Ne)&&Ae+1<De){const Be=me.charCodeAt(Ae+1);if(ue(Be))return Z(Ne,Be)}return Ne}e.$Sd=he;function V(me,De){const Ae=me.charCodeAt(De-1);if(ue(Ae)&&De>1){const Ne=me.charCodeAt(De-2);if(te(Ne))return Z(Ne,Ae)}return Ae}class se{get offset(){return this.e}constructor(De,Ae=0){this.c=De,this.d=De.length,this.e=Ae}setOffset(De){this.e=De}prevCodePoint(){const De=V(this.c,this.e);return this.e-=De>=65536?2:1,De}nextCodePoint(){const De=he(this.c,this.d,this.e);return this.e+=De>=65536?2:1,De}eol(){return this.e>=this.d}}e.$Td=se;class K{get offset(){return this.c.offset}constructor(De,Ae=0){this.c=new se(De,Ae)}nextGraphemeLength(){const De=ye.getInstance(),Ae=this.c,Ne=Ae.offset;let Be=De.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const Me=Ae.offset,He=De.getGraphemeBreakType(Ae.nextCodePoint());if($e(Be,He)){Ae.setOffset(Me);break}Be=He}return Ae.offset-Ne}prevGraphemeLength(){const De=ye.getInstance(),Ae=this.c,Ne=Ae.offset;let Be=De.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const Me=Ae.offset,He=De.getGraphemeBreakType(Ae.prevCodePoint());if($e(He,Be)){Ae.setOffset(Me);break}Be=He}return Ne-Ae.offset}eol(){return this.c.eol()}}e.$Ud=K;function Y(me,De){return new K(me,De).nextGraphemeLength()}e.$Vd=Y;function H(me,De){return new K(me,De).prevGraphemeLength()}e.$Wd=H;function _(me,De){De>0&&ue(me.charCodeAt(De))&&De--;const Ae=De+Y(me,De);return[Ae-H(me,Ae),Ae]}e.$Xd=_;function ge(me){const De=new K(me);let Ae=0;for(;!De.eol();)Ae++,De.nextGraphemeLength();return Ae}e.$Yd=ge;let ne;function q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function X(me){return ne||(ne=q()),ne.test(me)}e.$Zd=X;const O=/^[\t\n\r\x20-\x7E]*$/;function N(me){return O.test(me)}e.$1d=N,e.$2d=/[\u2028\u2029]/;function J(me){return e.$2d.test(me)}e.$3d=J;function ie(me){return me>=11904&&me<=55215||me>=63744&&me<=64255||me>=65281&&me<=65374}e.$4d=ie;function re(me){return me>=127462&&me<=127487||me===8986||me===8987||me===9200||me===9203||me>=9728&&me<=10175||me===11088||me===11093||me>=127744&&me<=128591||me>=128640&&me<=128764||me>=128992&&me<=129008||me>=129280&&me<=129535||me>=129648&&me<=129782}e.$5d=re;function ee(me,De){if(me.length<De)return me;const Ae=/\b/g;let Ne=0;for(;Ae.test(me)&&!(me.length-Ae.lastIndex<De);)Ne=Ae.lastIndex,Ae.lastIndex+=1;return me.substring(Ne).replace(/^\s/,"")}e.$6d=ee;const oe=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,F=/\x1b\].*?\x07/g;function z(me){return me&&(me=me.replace(oe,"").replace(F,"")),me}e.$7d=z,e.$8d=String.fromCharCode(65279);function j(me){return!!(me&&me.length>0&&me.charCodeAt(0)===65279)}e.$9d=j;function B(me){return j(me)?me.substr(1):me}e.$0d=B;function Q(me,De){if(!me||!De||me.length<De.length)return!1;const Ae=De.length,Ne=me.toLowerCase();let Be=0,Me=-1;for(;Be<Ae;){const He=Ne.indexOf(De[Be],Me+1);if(He<0)return!1;Me=He,Be++}return!0}e.$$d=Q;function de(me,De=!1){return me?(De&&(me=me.replace(/\\./g,"")),me.toLowerCase()!==me):!1}e.$_d=de;function Ee(me){return me.charAt(0).toUpperCase()+me.slice(1)}e.$ae=Ee;function Pe(me,De=1){if(De===0)return"";let Ae=-1;do Ae=me.indexOf(`
`,Ae+1),De--;while(De>0&&Ae>=0);return Ae===-1?me:(me[Ae-1]==="\r"&&Ae--,me.substr(0,Ae))}e.$be=Pe;function Re(me){return me=me%(2*26),me<26?String.fromCharCode(97+me):String.fromCharCode(65+me-26)}e.$ce=Re;function Fe(me){return ye.getInstance().getGraphemeBreakType(me)}e.$de=Fe;function $e(me,De){return me===0?De!==5&&De!==7:me===2&&De===3?!1:me===4||me===2||me===3||De===4||De===2||De===3?!0:!(me===8&&(De===8||De===9||De===11||De===12)||(me===11||me===9)&&(De===9||De===10)||(me===12||me===10)&&De===10||De===5||De===13||De===7||me===1||me===13&&De===14||me===6&&De===6)}var ke;(function(me){me[me.Other=0]="Other",me[me.Prepend=1]="Prepend",me[me.CR=2]="CR",me[me.LF=3]="LF",me[me.Control=4]="Control",me[me.Extend=5]="Extend",me[me.Regional_Indicator=6]="Regional_Indicator",me[me.SpacingMark=7]="SpacingMark",me[me.L=8]="L",me[me.V=9]="V",me[me.T=10]="T",me[me.LV=11]="LV",me[me.LVT=12]="LVT",me[me.ZWJ=13]="ZWJ",me[me.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(e.GraphemeBreakType=ke={}));class ye{static getInstance(){return ye.c||(ye.c=new ye),ye.c}constructor(){this.d=Te()}getGraphemeBreakType(De){if(De<32)return De===10?3:De===13?2:4;if(De<127)return 0;const Ae=this.d,Ne=Ae.length/3;let Be=1;for(;Be<=Ne;)if(De<Ae[3*Be])Be=2*Be;else if(De>Ae[3*Be+1])Be=2*Be+1;else return Ae[3*Be+2];return 0}}ye.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(me,De){if(me===0)return 0;const Ae=xe(me,De);if(Ae!==void 0)return Ae;const Ne=new se(De,me);return Ne.prevCodePoint(),Ne.offset}e.$ee=ze;function xe(me,De){const Ae=new se(De,me);let Ne=Ae.prevCodePoint();for(;qe(Ne)||Ne===65039||Ne===8419;){if(Ae.offset===0)return;Ne=Ae.prevCodePoint()}if(!re(Ne))return;let Be=Ae.offset;return Be>0&&Ae.prevCodePoint()===8205&&(Be=Ae.offset),Be}function qe(me){return 127995<=me&&me<=127999}var Ze;(function(me){me[me.zwj=8205]="zwj",me[me.emojiVariantSelector=65039]="emojiVariantSelector",me[me.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.$fe="\xA0";class Ye{static getInstance(De){return r.d.get(Array.from(De))}static getLocales(){return r.e.value}constructor(De){this.f=De}isAmbiguous(De){return this.f.has(De)}getPrimaryConfusable(De){return this.f.get(De)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ge=Ye,r=Ye,Ye.c=new R.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ye.d=new v.$hd(me=>{function De(Ve){const et=new Map;for(let Xe=0;Xe<Ve.length;Xe+=2)et.set(Ve[Xe],Ve[Xe+1]);return et}function Ae(Ve,et){const Xe=new Map(Ve);for(const[ot,ft]of et)Xe.set(ot,ft);return Xe}function Ne(Ve,et){if(!Ve)return et;const Xe=new Map;for(const[ot,ft]of Ve)et.has(ot)&&Xe.set(ot,ft);return Xe}const Be=r.c.value;let Me=me.filter(Ve=>!Ve.startsWith("_")&&Ve in Be);Me.length===0&&(Me=["_default"]);let He;for(const Ve of Me){const et=De(Be[Ve]);He=Ne(He,et)}const Ge=De(Be._common),Je=Ae(Ge,He);return new r(Je)}),Ye.e=new R.$T(()=>Object.keys(r.c.value).filter(me=>!me.startsWith("_")));class tt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(tt.c())),this.d}static isInvisibleCharacter(De){return tt.e().has(De)}static get codePoints(){return tt.e()}}e.$he=tt,tt.d=void 0}),define(we[146],be([1,0,28,17]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.FuzzyScore=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.or=void 0;function r(...j){return function(B,Q){for(let de=0,Ee=j.length;de<Ee;de++){const Pe=j[de](B,Q);if(Pe)return Pe}return null}}e.or=r,e.$kj=S.bind(void 0,!1),e.$lj=S.bind(void 0,!0);function S(j,B,Q){if(!Q||Q.length<B.length)return null;let de;return j?de=R.$Md(Q,B):de=Q.indexOf(B)===0,de?B.length>0?[{start:0,end:B.length}]:[]:null}function I(j,B){const Q=B.toLowerCase().indexOf(j.toLowerCase());return Q===-1?null:[{start:Q,end:Q+j.length}]}e.$mj=I;function P(j,B){return b(j.toLowerCase(),B.toLowerCase(),0,0)}e.$nj=P;function b(j,B,Q,de){if(Q===j.length)return[];if(de===B.length)return null;if(j[Q]===B[de]){let Ee=null;return(Ee=b(j,B,Q+1,de+1))?u({start:de,end:de+1},Ee):null}return b(j,B,Q,de+1)}function $(j){return 97<=j&&j<=122}function A(j){return 65<=j&&j<=90}e.$oj=A;function E(j){return 48<=j&&j<=57}function w(j){return j===32||j===9||j===10||j===13}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(j=>l.add(j.charCodeAt(0)));function d(j){return w(j)||l.has(j)}function m(j,B){return j===B||d(j)&&d(B)}function c(j){return $(j)||A(j)||E(j)}function u(j,B){return B.length===0?B=[j]:j.end===B[0].start?B[0].start=j.start:B.unshift(j),B}function h(j,B){for(let Q=B;Q<j.length;Q++){const de=j.charCodeAt(Q);if(A(de)||E(de)||Q>0&&!c(j.charCodeAt(Q-1)))return Q}return j.length}function g(j,B,Q,de){if(Q===j.length)return[];if(de===B.length)return null;if(j[Q]!==B[de].toLowerCase())return null;{let Ee=null,Pe=de+1;for(Ee=g(j,B,Q+1,de+1);!Ee&&(Pe=h(B,Pe))<B.length;)Ee=g(j,B,Q+1,Pe),Pe++;return Ee===null?null:u({start:de,end:de+1},Ee)}}function y(j){let B=0,Q=0,de=0,Ee=0,Pe=0;for(let ye=0;ye<j.length;ye++)Pe=j.charCodeAt(ye),A(Pe)&&B++,$(Pe)&&Q++,c(Pe)&&de++,E(Pe)&&Ee++;const Re=B/j.length,Fe=Q/j.length,$e=de/j.length,ke=Ee/j.length;return{upperPercent:Re,lowerPercent:Fe,alphaPercent:$e,numericPercent:ke}}function p(j){const{upperPercent:B,lowerPercent:Q}=j;return Q===0&&B>.6}function t(j){const{upperPercent:B,lowerPercent:Q,alphaPercent:de,numericPercent:Ee}=j;return Q>.2&&B<.8&&de>.6&&Ee<.2}function i(j){let B=0,Q=0,de=0,Ee=0;for(let Pe=0;Pe<j.length;Pe++)de=j.charCodeAt(Pe),A(de)&&B++,$(de)&&Q++,w(de)&&Ee++;return(B===0||Q===0)&&Ee===0?j.length<=30:B<=5}function a(j,B){if(!B||(B=B.trim(),B.length===0)||!i(j)||B.length>60)return null;const Q=y(B);if(!t(Q)){if(!p(Q))return null;B=B.toLowerCase()}let de=null,Ee=0;for(j=j.toLowerCase();Ee<B.length&&(de=g(j,B,0,Ee))===null;)Ee=h(B,Ee+1);return de}e.$pj=a;function s(j,B,Q=!1){if(!B||B.length===0)return null;let de=null,Ee=0;for(j=j.toLowerCase(),B=B.toLowerCase();Ee<B.length&&(de=n(j,B,0,Ee,Q))===null;)Ee=o(B,Ee+1);return de}e.$qj=s;function n(j,B,Q,de,Ee){if(Q===j.length)return[];if(de===B.length)return null;if(m(j.charCodeAt(Q),B.charCodeAt(de))){let Pe=null,Re=de+1;if(Pe=n(j,B,Q+1,de+1,Ee),!Ee)for(;!Pe&&(Re=o(B,Re))<B.length;)Pe=n(j,B,Q+1,Re,Ee),Re++;return Pe?j.charCodeAt(Q)!==B.charCodeAt(de)?Pe:u({start:de,end:de+1},Pe):null}else return null}function o(j,B){for(let Q=B;Q<j.length;Q++)if(d(j.charCodeAt(Q))||Q>0&&d(j.charCodeAt(Q-1)))return Q;return j.length}const f=r(e.$lj,a,I),k=r(e.$lj,a,P),D=new v.$qi(1e4);function C(j,B,Q=!1){if(typeof j!="string"||typeof B!="string")return null;let de=D.get(j);de||(de=new RegExp(R.$vd(j),"i"),D.set(j,de));const Ee=de.exec(B);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Q?k(j,B):f(j,B)}e.$rj=C;function L(j,B){const Q=J(j,j.toLowerCase(),0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?x(Q):null}e.$sj=L;function U(j,B,Q,de,Ee,Pe){const Re=Math.min(13,j.length);for(;Q<Re;Q++){const Fe=J(j,B,Q,de,Ee,Pe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Fe)return Fe}return[0,Pe]}e.$tj=U;function x(j){if(typeof j>"u")return[];const B=[],Q=j[1];for(let de=j.length-1;de>1;de--){const Ee=j[de]+Q,Pe=B[B.length-1];Pe&&Pe.end===Ee?Pe.end=Ee+1:B.push({start:Ee,end:Ee+1})}return B}e.$uj=x;const ae=128;function W(){const j=[],B=[];for(let Q=0;Q<=ae;Q++)B[Q]=0;for(let Q=0;Q<=ae;Q++)j.push(B.slice(0));return j}function te(j){const B=[];for(let Q=0;Q<=j;Q++)B[Q]=0;return B}const ue=te(2*ae),Z=te(2*ae),he=W(),V=W(),se=W(),K=!1;function Y(j,B,Q,de,Ee){function Pe(Fe,$e,ke=" "){for(;Fe.length<$e;)Fe=ke+Fe;return Fe}let Re=` |   |${de.split("").map(Fe=>Pe(Fe,3)).join("|")}
`;for(let Fe=0;Fe<=Q;Fe++)Fe===0?Re+=" |":Re+=`${B[Fe-1]}|`,Re+=j[Fe].slice(0,Ee+1).map($e=>Pe($e.toString(),3)).join("|")+`
`;return Re}function H(j,B,Q,de){j=j.substr(B),Q=Q.substr(de),console.log(Y(V,j,j.length,Q,Q.length)),console.log(Y(se,j,j.length,Q,Q.length)),console.log(Y(he,j,j.length,Q,Q.length))}function _(j,B){if(B<0||B>=j.length)return!1;const Q=j.codePointAt(B);switch(Q){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$5d(Q)}}function ge(j,B){if(B<0||B>=j.length)return!1;switch(j.charCodeAt(B)){case 32:case 9:return!0;default:return!1}}function ne(j,B,Q){return B[j]!==Q[j]}function q(j,B,Q,de,Ee,Pe,Re=!1){for(;B<Q&&Ee<Pe;)j[B]===de[Ee]&&(Re&&(ue[B]=Ee),B+=1),Ee+=1;return B===Q}e.$vj=q;var X;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(X||(X={}));var O;(function(j){j.Default=[-100,0];function B(Q){return!Q||Q.length===2&&Q[0]===-100&&Q[1]===0}j.isDefault=B})(O||(e.FuzzyScore=O={}));class N{constructor(B,Q){this.firstMatchCanBeWeak=B,this.boostFullMatch=Q}}e.$wj=N,N.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function J(j,B,Q,de,Ee,Pe,Re=N.default){const Fe=j.length>ae?ae:j.length,$e=de.length>ae?ae:de.length;if(Q>=Fe||Pe>=$e||Fe-Q>$e-Pe||!q(B,Q,Fe,Ee,Pe,$e,!0))return;ie(Fe,$e,Q,Pe,B,Ee);let ke=1,ye=1,Te=Q,ze=Pe;const xe=[!1];for(ke=1,Te=Q;Te<Fe;ke++,Te++){const me=ue[Te],De=Z[Te],Ae=Te+1<Fe?Z[Te+1]:$e;for(ye=me-Pe+1,ze=me;ze<Ae;ye++,ze++){let Ne=Number.MIN_SAFE_INTEGER,Be=!1;ze<=De&&(Ne=re(j,B,Te,Q,de,Ee,ze,$e,Pe,he[ke-1][ye-1]===0,xe));let Me=0;Ne!==Number.MAX_SAFE_INTEGER&&(Be=!0,Me=Ne+V[ke-1][ye-1]);const He=ze>me,Ge=He?V[ke][ye-1]+(he[ke][ye-1]>0?-5:0):0,Je=ze>me+1&&he[ke][ye-1]>0,Ve=Je?V[ke][ye-2]+(he[ke][ye-2]>0?-5:0):0;if(Je&&(!He||Ve>=Ge)&&(!Be||Ve>=Me))V[ke][ye]=Ve,se[ke][ye]=3,he[ke][ye]=0;else if(He&&(!Be||Ge>=Me))V[ke][ye]=Ge,se[ke][ye]=2,he[ke][ye]=0;else if(Be)V[ke][ye]=Me,se[ke][ye]=1,he[ke][ye]=he[ke-1][ye-1]+1;else throw new Error("not possible")}}if(K&&H(j,Q,de,Pe),!xe[0]&&!Re.firstMatchCanBeWeak)return;ke--,ye--;const qe=[V[ke][ye],Pe];let Ze=0,Ye=0;for(;ke>=1;){let me=ye;do{const De=se[ke][me];if(De===3)me=me-2;else if(De===2)me=me-1;else break}while(me>=1);Ze>1&&B[Q+ke-1]===Ee[Pe+ye-1]&&!ne(me+Pe-1,de,Ee)&&Ze+1>he[ke][me]&&(me=ye),me===ye?Ze++:Ze=1,Ye||(Ye=me),ke--,ye=me-1,qe.push(ye)}$e===Fe&&Re.boostFullMatch&&(qe[0]+=2);const tt=Ye-Fe;return qe[0]-=tt,qe}e.$xj=J;function ie(j,B,Q,de,Ee,Pe){let Re=j-1,Fe=B-1;for(;Re>=Q&&Fe>=de;)Ee[Re]===Pe[Fe]&&(Z[Re]=Fe,Re--),Fe--}function re(j,B,Q,de,Ee,Pe,Re,Fe,$e,ke,ye){if(B[Q]!==Pe[Re])return Number.MIN_SAFE_INTEGER;let Te=1,ze=!1;return Re===Q-de?Te=j[Q]===Ee[Re]?7:5:ne(Re,Ee,Pe)&&(Re===0||!ne(Re-1,Ee,Pe))?(Te=j[Q]===Ee[Re]?7:5,ze=!0):_(Pe,Re)&&(Re===0||!_(Pe,Re-1))?Te=5:(_(Pe,Re-1)||ge(Pe,Re-1))&&(Te=5,ze=!0),Te>1&&Q===de&&(ye[0]=!0),ze||(ze=ne(Re,Ee,Pe)||_(Pe,Re-1)||ge(Pe,Re-1)),Q===de?Re>$e&&(Te-=ze?3:5):ke?Te+=ze?2:0:Te+=ze?0:1,Re+1===Fe&&(Te-=ze?3:5),Te}function ee(j,B,Q,de,Ee,Pe,Re){return F(j,B,Q,de,Ee,Pe,!0,Re)}e.$yj=ee;function oe(j,B,Q,de,Ee,Pe,Re){return F(j,B,Q,de,Ee,Pe,!1,Re)}e.$zj=oe;function F(j,B,Q,de,Ee,Pe,Re,Fe){let $e=J(j,B,Q,de,Ee,Pe,Fe);if($e&&!Re)return $e;if(j.length>=3){const ke=Math.min(7,j.length-1);for(let ye=Q+1;ye<ke;ye++){const Te=z(j,ye);if(Te){const ze=J(Te,Te.toLowerCase(),Q,de,Ee,Pe,Fe);ze&&(ze[0]-=3,(!$e||ze[0]>$e[0])&&($e=ze))}}}return $e}function z(j,B){if(B+1>=j.length)return;const Q=j[B],de=j[B+1];if(Q!==de)return j.slice(0,B)+de+Q+j.slice(B+2)}}),define(we[61],be([1,0,17]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0;function R(u){return r(u,0)}e.$di=R;function r(u,h){switch(typeof u){case"object":return u===null?S(349,h):Array.isArray(u)?b(u,h):$(u,h);case"string":return P(u,h);case"boolean":return I(u,h);case"number":return S(u,h);case"undefined":return S(937,h);default:return S(617,h)}}e.$ei=r;function S(u,h){return(h<<5)-h+u|0}e.$fi=S;function I(u,h){return S(u?433:863,h)}function P(u,h){h=S(149417,h);for(let g=0,y=u.length;g<y;g++)h=S(u.charCodeAt(g),h);return h}e.$gi=P;function b(u,h){return h=S(104579,h),u.reduce((g,y)=>r(y,g),h)}function $(u,h){return h=S(181387,h),Object.keys(u).sort().reduce((g,y)=>(g=P(y,g),r(u[y],g)),h)}class A{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=r(h,this.g),this.g}}e.$hi=A;var E;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function w(u,h,g=32){const y=g-h,p=~((1<<y)-1);return(u<<h|(p&u)>>>y)>>>0}function l(u,h=0,g=u.byteLength,y=0){for(let p=0;p<g;p++)u[h+p]=y}function d(u,h,g="0"){for(;u.length<h;)u=g+u;return u}function m(u,h=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(g=>g.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),h/4)}e.$ii=m;class c{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const g=h.length;if(g===0)return;const y=this.p;let p=this.r,t=this.u,i,a;for(t!==0?(i=t,a=-1,t=0):(i=h.charCodeAt(0),a=0);;){let s=i;if(v.$Pd(i))if(a+1<g){const n=h.charCodeAt(a+1);v.$Qd(n)?(a++,s=v.$Rd(i,n)):s=65533}else{t=i;break}else v.$Qd(i)&&(s=65533);if(p=this.w(y,p,s),a++,a<g)i=h.charCodeAt(a);else break}this.r=p,this.u=t}w(h,g,y){return y<128?h[g++]=y:y<2048?(h[g++]=192|(y&1984)>>>6,h[g++]=128|(y&63)>>>0):y<65536?(h[g++]=224|(y&61440)>>>12,h[g++]=128|(y&4032)>>>6,h[g++]=128|(y&63)>>>0):(h[g++]=240|(y&1835008)>>>18,h[g++]=128|(y&258048)>>>12,h[g++]=128|(y&4032)>>>6,h[g++]=128|(y&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=c.g,g=this.q;for(let f=0;f<64;f+=4)h.setUint32(f,g.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)h.setUint32(f,w(h.getUint32(f-12,!1)^h.getUint32(f-32,!1)^h.getUint32(f-56,!1)^h.getUint32(f-64,!1),1),!1);let y=this.h,p=this.l,t=this.m,i=this.n,a=this.o,s,n,o;for(let f=0;f<80;f++)f<20?(s=p&t|~p&i,n=1518500249):f<40?(s=p^t^i,n=1859775393):f<60?(s=p&t|p&i|t&i,n=2400959708):(s=p^t^i,n=3395469782),o=w(y,5)+s+a+n+h.getUint32(f*4,!1)&4294967295,a=i,i=t,t=w(p,30),p=y,y=o;this.h=this.h+y&4294967295,this.l=this.l+p&4294967295,this.m=this.m+t&4294967295,this.n=this.n+i&4294967295,this.o=this.o+a&4294967295}}e.$ji=c,c.g=new DataView(new ArrayBuffer(320))}),define(we[62],be([1,0,17]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(R||(R={})),function(r){const S="error",I="warning",P="warn",b="info",$="ignore";function A(w){return w?v.$Ld(S,w)?r.Error:v.$Ld(I,w)||v.$Ld(P,w)?r.Warning:v.$Ld(b,w)?r.Info:r.Ignore:r.Ignore}r.fromValue=A;function E(w){switch(w){case r.Error:return S;case r.Warning:return I;case r.Info:return b;default:return $}}r.toString=E}(R||(R={})),e.default=R}),define(we[147],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=void 0,e.$bc=Symbol("MicrotaskDelay")}),define(we[63],be([1,0,18,17]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class r{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const d=l.charCodeAt(0),m=this.b.charCodeAt(this.c);return d-m}value(){return this.b[this.c]}}e.$rh=r;class S{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,R.$Fd)(l,this.b,0,l.length,this.c,this.d):(0,R.$Hd)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=S;class I{constructor(l=!0,d=!0){this.f=l,this.g=d}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let d=l.length-1;d>=0;d--,this.c--){const m=this.b.charCodeAt(d);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,R.$Fd)(l,this.b,0,l.length,this.d,this.e):(0,R.$Hd)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=I;var P;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(P||(P={}));class b{constructor(l,d){this.f=l,this.g=d,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,R.$Gd)(l,this.c.scheme);if(this.d[this.e]===2)return(0,R.$Gd)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,R.$Ed)(l,this.c.query);if(this.d[this.e]===5)return(0,R.$Ed)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=b;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(A||(A={}));class E{static forUris(l=()=>!1,d=()=>!1){return new E(new b(l,d))}static forPaths(l=!1){return new E(new I(void 0,!l))}static forStrings(){return new E(new r)}static forConfigKeys(){return new E(new S)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,d){if(d){const m=d.slice(0);(0,v.$Bf)(m);for(const c of m)this.set(c,l)}else{const m=l.slice(0);(0,v.$Bf)(m);for(const c of m)this.set(c[0],c[1])}}set(l,d){const m=this.b.reset(l);let c;this.c||(this.c=new $,this.c.segment=m.value());const u=[];for(c=this.c;;){const g=m.cmp(c.segment);if(g>0)c.left||(c.left=new $,c.left.segment=m.value()),u.push([-1,c]),c=c.left;else if(g<0)c.right||(c.right=new $,c.right.segment=m.value()),u.push([1,c]),c=c.right;else if(m.hasNext())m.next(),c.mid||(c.mid=new $,c.mid.segment=m.value()),u.push([0,c]),c=c.mid;else break}const h=c.value;c.value=d,c.key=l;for(let g=u.length-1;g>=0;g--){const y=u[g][1];y.updateHeight();const p=y.balanceFactor();if(p<-1||p>1){const t=u[g][0],i=u[g+1][0];if(t===1&&i===1)u[g][1]=y.rotateLeft();else if(t===-1&&i===-1)u[g][1]=y.rotateRight();else if(t===1&&i===-1)y.right=u[g+1][1]=u[g+1][1].rotateRight(),u[g][1]=y.rotateLeft();else if(t===-1&&i===1)y.left=u[g+1][1]=u[g+1][1].rotateLeft(),u[g][1]=y.rotateRight();else throw new Error;if(g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}return h}get(l){return this.d(l)?.value}d(l){const d=this.b.reset(l);let m=this.c;for(;m;){const c=d.cmp(m.segment);if(c>0)m=m.left;else if(c<0)m=m.right;else if(d.hasNext())d.next(),m=m.mid;else break}return m}has(l){const d=this.d(l);return!(d?.value===void 0&&d?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,d){const m=this.b.reset(l),c=[];let u=this.c;for(;u;){const h=m.cmp(u.segment);if(h>0)c.push([-1,u]),u=u.left;else if(h<0)c.push([1,u]),u=u.right;else if(m.hasNext())m.next(),c.push([0,u]),u=u.mid;else break}if(u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const h=this.f(u.right);if(h.key){const{key:g,value:y,segment:p}=h;this.e(h.key,!1),u.key=g,u.value=y,u.segment=p}}else{const h=u.left??u.right;if(c.length>0){const[g,y]=c[c.length-1];switch(g){case-1:y.left=h;break;case 0:y.mid=h;break;case 1:y.right=h;break}}else this.c=h}for(let h=c.length-1;h>=0;h--){const g=c[h][1];g.updateHeight();const y=g.balanceFactor();if(y>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),c[h][1]=g.rotateLeft()):y<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),c[h][1]=g.rotateRight()),h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this.c=c[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const d=this.b.reset(l);let m=this.c,c;for(;m;){const u=d.cmp(m.segment);if(u>0)m=m.left;else if(u<0)m=m.right;else if(d.hasNext())d.next(),c=m.value||c,m=m.mid;else break}return m&&m.value||c}findSuperstr(l){return this.g(l,!1)}g(l,d){const m=this.b.reset(l);let c=this.c;for(;c;){const u=m.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(m.hasNext())m.next(),c=c.mid;else return c.mid?this.h(c.mid):d?c.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[d,m]of this)l(m,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const d=[];return this.j(l,d),d[Symbol.iterator]()}j(l,d){l&&(l.left&&this.j(l.left,d),l.value&&d.push([l.key,l.value]),l.mid&&this.j(l.mid,d),l.right&&this.j(l.right,d))}_isBalanced(){const l=d=>{if(!d)return!0;const m=d.balanceFactor();return m<-1||m>1?!1:l(d.left)&&l(d.right)};return l(this.c)}}e.$vh=E}),define(we[8],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;function v(p){return typeof p=="string"}e.$ie=v;function R(p){return Array.isArray(p)&&p.every(t=>v(t))}e.$je=R;function r(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.$ke=r;function S(p){const t=Object.getPrototypeOf(Uint8Array);return typeof p=="object"&&p instanceof t}e.$le=S;function I(p){return typeof p=="number"&&!isNaN(p)}e.$me=I;function P(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.$ne=P;function b(p){return p===!0||p===!1}e.$oe=b;function $(p){return typeof p>"u"}e.$pe=$;function A(p){return!E(p)}e.$qe=A;function E(p){return $(p)||p===null}e.$re=E;function w(p,t){if(!p)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$se=w;function l(p){if(E(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.$te=l;function d(...p){const t=[];for(let i=0;i<p.length;i++){const a=p[i];if(E(a))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(a)}return t}e.$ue=d;const m=Object.prototype.hasOwnProperty;function c(p){if(!r(p))return!1;for(const t in p)if(m.call(p,t))return!1;return!0}e.$ve=c;function u(p){return typeof p=="function"}e.$we=u;function h(...p){return p.length>0&&p.every(u)}e.$xe=h;function g(p,t){const i=Math.min(p.length,t.length);for(let a=0;a<i;a++)y(p[a],t[a])}e.$ye=g;function y(p,t){if(v(t)){if(typeof p!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(p instanceof t)return}catch{}if(!E(p)&&p.constructor===t||t.length===1&&t.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$ze=y}),define(we[49],be([1,0,8]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=e.$Aj=void 0;const R=Object.create(null);function r(P,b){if((0,v.$ie)(b)){const $=R[b];if($===void 0)throw new Error(`${P} references an unknown codicon: ${b}`);b=$}return R[P]=b,{id:P}}function S(){return R}e.$Aj=S;function I(){return Object.values(e.$Cj)}e.$Bj=I,e.$Cj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(we[38],be([1,0,7,3,17,8]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function I(o){return o===47||o===92}e.$Ae=I;function P(o){return o.replace(/[\\/]/g,v.$5c.sep)}e.$Be=P;function b(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Ce=b;function $(o,f=v.$5c.sep){if(!o)return"";const k=o.length,D=o.charCodeAt(0);if(I(D)){if(I(o.charCodeAt(1))&&!I(o.charCodeAt(2))){let L=3;const U=L;for(;L<k&&!I(o.charCodeAt(L));L++);if(U!==L&&!I(o.charCodeAt(L+1))){for(L+=1;L<k;L++)if(I(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,f)}}return f}else if(u(D)&&o.charCodeAt(1)===58)return I(o.charCodeAt(2))?o.slice(0,2)+f:o.slice(0,2);let C=o.indexOf("://");if(C!==-1){for(C+=3;C<k;C++)if(I(o.charCodeAt(C)))return o.slice(0,C+1)}return""}e.$De=$;function A(o){if(!R.$d||!o||o.length<5)return!1;let f=o.charCodeAt(0);if(f!==92||(f=o.charCodeAt(1),f!==92))return!1;let k=2;const D=k;for(;k<o.length&&(f=o.charCodeAt(k),f!==92);k++);return!(D===k||(f=o.charCodeAt(k+1),isNaN(f)||f===92))}e.$Ee=A;const E=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,f=R.$d){const k=f?E:w;return!(!o||o.length===0||/^\s+$/.test(o)||(k.lastIndex=0,k.test(o))||f&&l.test(o)||o==="."||o===".."||f&&o[o.length-1]==="."||f&&o.length!==o.trim().length||o.length>255)}e.$Fe=d;function m(o,f,k){const D=o===f;return!k||D?D:!o||!f?!1:(0,r.$Ld)(o,f)}e.$Ge=m;function c(o,f,k,D=v.sep){if(o===f)return!0;if(!o||!f||f.length>o.length)return!1;if(k){if(!(0,r.$Md)(o,f))return!1;if(f.length===o.length)return!0;let L=f.length;return f.charAt(f.length-1)===D&&L--,o.charAt(L)===D}return f.charAt(f.length-1)!==D&&(f+=D),o.indexOf(f)===0}e.$He=c;function u(o){return o>=65&&o<=90||o>=97&&o<=122}e.$Ie=u;function h(o,f){return R.$d&&o.endsWith(":")&&(o+=v.sep),(0,v.$7c)(o)||(o=(0,v.$8c)(f,o)),o=(0,v.$6c)(o),R.$d?(o=(0,r.$ud)(o,v.sep),o.endsWith(":")&&(o+=v.sep)):(o=(0,r.$ud)(o,v.sep),o||(o=v.sep)),o}e.$Je=h;function g(o){const f=(0,v.$6c)(o);return R.$d?o.length>3?!1:y(f)&&(o.length===2||f.charCodeAt(2)===92):f===v.$5c.sep}e.$Ke=g;function y(o,f=R.$d){return f?u(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$Le=y;function p(o,f=R.$d){return y(o,f)?o[0]:void 0}e.$Me=p;function t(o,f,k){return f.length>o.length?-1:o===f?0:(k&&(o=o.toLowerCase(),f=f.toLowerCase()),o.indexOf(f))}e.$Ne=t;function i(o){const f=o.split(":");let k,D,C;for(const L of f){const U=Number(L);(0,S.$me)(U)?D===void 0?D=U:C===void 0&&(C=U):k=k?[k,L].join(":"):L}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:D!==void 0?D:void 0,column:C!==void 0?C:D!==void 0?1:void 0}}e.$Oe=i;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,f,k=8){let D="";for(let L=0;L<k;L++){let U;L===0&&R.$d&&!f&&(k===3||k===4)?U=s:U=a,D+=U.charAt(Math.floor(Math.random()*U.length))}let C;return f?C=`${f}-${D}`:C=D,o?(0,v.$8c)(o,C):C}e.$Pe=n}),define(we[22],be([1,0,8]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=void 0;function R(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const h=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,y])=>{h[g]=y&&typeof y=="object"?R(y):y}),h}e.$Jm=R;function r(u){if(!u||typeof u!="object")return u;const h=[u];for(;h.length>0;){const g=h.shift();Object.freeze(g);for(const y in g)if(S.call(g,y)){const p=g[y];typeof p=="object"&&!Object.isFrozen(p)&&!(0,v.$le)(p)&&h.push(p)}}return u}e.$Km=r;const S=Object.prototype.hasOwnProperty;function I(u,h){return P(u,h,new Set)}e.$Lm=I;function P(u,h,g){if((0,v.$re)(u))return u;const y=h(u);if(typeof y<"u")return y;if(Array.isArray(u)){const p=[];for(const t of u)p.push(P(t,h,g));return p}if((0,v.$ke)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const p={};for(const t in u)S.call(u,t)&&(p[t]=P(u[t],h,g));return g.delete(u),p}return u}function b(u,h,g=!0){return(0,v.$ke)(u)?((0,v.$ke)(h)&&Object.keys(h).forEach(y=>{y in u?g&&((0,v.$ke)(u[y])&&(0,v.$ke)(h[y])?b(u[y],h[y],g):u[y]=h[y]):u[y]=h[y]}),u):h}e.$Mm=b;function $(u,h){if(u===h)return!0;if(u==null||h===null||h===void 0||typeof u!=typeof h||typeof u!="object"||Array.isArray(u)!==Array.isArray(h))return!1;let g,y;if(Array.isArray(u)){if(u.length!==h.length)return!1;for(g=0;g<u.length;g++)if(!$(u[g],h[g]))return!1}else{const p=[];for(y in u)p.push(y);p.sort();const t=[];for(y in h)t.push(y);if(t.sort(),!$(p,t))return!1;for(g=0;g<p.length;g++)if(!$(u[p[g]],h[p[g]]))return!1}return!0}e.$Nm=$;function A(u){const h=new Set;return JSON.stringify(u,(g,y)=>{if((0,v.$ke)(y)||Array.isArray(y)){if(h.has(y))return"[Circular]";h.add(y)}return y})}e.$Om=A;function E(u,h){const g=Object.create(null);return!u||!h||Object.keys(h).forEach(p=>{const t=u[p],i=h[p];$(t,i)||(g[p]=i)}),g}e.$Pm=E;function w(u,h){const g=h.toLowerCase(),y=Object.keys(u).find(p=>p.toLowerCase()===g);return y?u[y]:u[h]}e.$Qm=w;function l(u,h){const g=Object.create(null);for(const[y,p]of Object.entries(u))h(y,p)&&(g[y]=p);return g}e.$Rm=l;function d(u){let h=[];for(;Object.prototype!==u;)h=h.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return h}e.$Sm=d;function m(u){const h=[];for(const g of d(u))typeof u[g]=="function"&&h.push(g);return h}e.$Tm=m;function c(u,h){const g=p=>function(){const t=Array.prototype.slice.call(arguments,0);return h(p,t)},y={};for(const p of u)y[p]=g(p);return y}e.$Um=c}),define(we[100],be([1,0,49]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Dj=e.ThemeColor=void 0;var R;(function(I){function P(b){return b&&typeof b=="object"&&typeof b.id=="string"}I.isThemeColor=P})(R||(e.ThemeColor=R={}));function r(I){return{id:I}}e.$Dj=r;var S;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function b(h){const g=P.exec(h.id);if(!g)return b(v.$Cj.error);const[,y,p]=g,t=["codicon","codicon-"+y];return p&&t.push("codicon-modifier-"+p.substring(1)),t}I.asClassNameArray=b;function $(h){return b(h).join(" ")}I.asClassName=$;function A(h){return"."+b(h).join(".")}I.asCSSSelector=A;function E(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||R.isThemeColor(h.color))}I.isThemeIcon=E;const w=new RegExp(`^\\$\\((${I.iconNameExpression}(?:${I.iconModifierExpression})?)\\)$`);function l(h){const g=w.exec(h);if(!g)return;const[,y]=g;return{id:y}}I.fromString=l;function d(h){return{id:h}}I.fromId=d;function m(h,g){let y=h.id;const p=y.lastIndexOf("~");return p!==-1&&(y=y.substring(0,p)),g&&(y=`${y}~${g}`),{id:y}}I.modify=m;function c(h){const g=h.id.lastIndexOf("~");if(g!==-1)return h.id.substring(g+1)}I.getModifier=c;function u(h,g){return h.id===g.id&&h.color?.id===g.color?.id}I.isEqual=u})(S||(e.ThemeIcon=S={}))}),define(we[148],be([1,0,146,17,100]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=void 0;const S="$(",I=new RegExp(`\\$\\(${r.ThemeIcon.iconNameExpression}(?:${r.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${I.source}`,"g");function b(u){return u.replace(P,(h,g)=>g?h:`\\${h}`)}e.$Ej=b;const $=new RegExp(`\\\\${I.source}`,"g");function A(u){return u.replace($,h=>`\\${h}`)}e.$Fj=A;const E=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function w(u){return u.indexOf(S)===-1?u:u.replace(E,(h,g,y,p)=>y?h:g||p||"")}e.$Gj=w;function l(u){return u?u.replace(/\$\((.*?)\)/g,(h,g)=>` ${g} `).trim():""}e.$Hj=l;const d=new RegExp(`\\$\\(${r.ThemeIcon.iconNameCharacter}+\\)`,"g");function m(u){d.lastIndex=0;let h="";const g=[];let y=0;for(;;){const p=d.lastIndex,t=d.exec(u),i=u.substring(p,t?.index);if(i.length>0){h+=i;for(let a=0;a<i.length;a++)g.push(y)}if(!t)break;y+=t[0].length}return{text:h,iconOffsets:g}}e.$Ij=m;function c(u,h,g=!1){const{text:y,iconOffsets:p}=h;if(!p||p.length===0)return(0,v.$rj)(u,y,g);const t=(0,R.$td)(y," "),i=y.length-t.length,a=(0,v.$rj)(u,t,g);if(a)for(const s of a){const n=p[s.start+i]+i;s.start+=n,s.end+=n}return a}e.$Jj=c}),define(we[4],be([1,0,7,3]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,S=/^\//,I=/^\/\//;function P(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!r.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(s,n){return!s&&!n?"file":s}function $(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==E&&(n=E+n):n=E;break}return n}const A="",E="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(n){return n instanceof l?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,f,k,D,C=!1){typeof n=="object"?(this.scheme=n.scheme||A,this.authority=n.authority||A,this.path=n.path||A,this.query=n.query||A,this.fragment=n.fragment||A):(this.scheme=b(n,C),this.authority=o||A,this.path=$(this.scheme,f||A),this.query=k||A,this.fragment=D||A,P(this,C))}get fsPath(){return y(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:f,path:k,query:D,fragment:C}=n;return o===void 0?o=this.scheme:o===null&&(o=A),f===void 0?f=this.authority:f===null&&(f=A),k===void 0?k=this.path:k===null&&(k=A),D===void 0?D=this.query:D===null&&(D=A),C===void 0?C=this.fragment:C===null&&(C=A),o===this.scheme&&f===this.authority&&k===this.path&&D===this.query&&C===this.fragment?this:new c(o,f,k,D,C)}static parse(n,o=!1){const f=w.exec(n);return f?new c(f[2]||A,a(f[4]||A),a(f[5]||A),a(f[7]||A),a(f[9]||A),o):new c(A,A,A,A,A)}static file(n){let o=A;if(R.$d&&(n=n.replace(/\\/g,E)),n[0]===E&&n[1]===E){const f=n.indexOf(E,2);f===-1?(o=n.substring(2),n=E):(o=n.substring(2,f),n=n.substring(f)||E)}return new c("file",o,n,A,A)}static from(n,o){return new c(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return R.$d&&n.scheme==="file"?f=l.file(v.$4c.join(y(n,!0),...o)).path:f=v.$5c.join(n.path,...o),n.with({path:f})}toString(n=!1){return p(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof l)return n;{const o=new c(n);return o._formatted=n.external??null,o._fsPath=n._sep===m?n.fsPath??null:null,o}}else return n}}e.URI=l;function d(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$Re=d;const m=R.$d?1:void 0;class c extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(n=!1){return n?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(s,n,o){let f,k=-1;for(let D=0;D<s.length;D++){const C=s.charCodeAt(D);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||n&&C===47||o&&C===91||o&&C===93||o&&C===58)k!==-1&&(f+=encodeURIComponent(s.substring(k,D)),k=-1),f!==void 0&&(f+=s.charAt(D));else{f===void 0&&(f=s.substr(0,D));const L=u[C];L!==void 0?(k!==-1&&(f+=encodeURIComponent(s.substring(k,D)),k=-1),f+=L):k===-1&&(k=D)}}return k!==-1&&(f+=encodeURIComponent(s.substring(k))),f!==void 0?f:s}function g(s){let n;for(let o=0;o<s.length;o++){const f=s.charCodeAt(o);f===35||f===63?(n===void 0&&(n=s.substr(0,o)),n+=u[f]):n!==void 0&&(n+=s[o])}return n!==void 0?n:s}function y(s,n){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,R.$d&&(o=o.replace(/\//g,"\\")),o}e.$Se=y;function p(s,n){const o=n?g:h;let f="",{scheme:k,authority:D,path:C,query:L,fragment:U}=s;if(k&&(f+=k,f+=":"),(D||k==="file")&&(f+=E,f+=E),D){let x=D.indexOf("@");if(x!==-1){const ae=D.substr(0,x);D=D.substr(x+1),x=ae.lastIndexOf(":"),x===-1?f+=o(ae,!1,!1):(f+=o(ae.substr(0,x),!1,!1),f+=":",f+=o(ae.substr(x+1),!1,!0)),f+="@"}D=D.toLowerCase(),x=D.lastIndexOf(":"),x===-1?f+=o(D,!1,!0):(f+=o(D.substr(0,x),!1,!0),f+=D.substr(x))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const x=C.charCodeAt(1);x>=65&&x<=90&&(C=`/${String.fromCharCode(x+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const x=C.charCodeAt(0);x>=65&&x<=90&&(C=`${String.fromCharCode(x+32)}:${C.substr(2)}`)}f+=o(C,!0,!1)}return L&&(f+="?",f+=o(L,!1,!1)),U&&(f+="#",f+=n?U:h(U,!1,!1)),f}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(s){return s.match(i)?s.replace(i,n=>t(n)):s}}),define(we[149],be([1,0,4]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Hp=e.$Gp=e.$Fp=void 0;function R($){const A=$;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$Fp=R;function r($){const A=[];let E;try{const w=JSON.parse($.arguments),l=w[w.length-1];l&&l.__$stack&&(w.pop(),E=l.__$stack),A.push(...w)}catch{A.push("Unable to log remote console arguments",$.arguments)}return{args:A,stack:E}}e.$Gp=r;function S($){if(typeof $!="string")return S(r($).stack);const A=$;if(A){const E=I(A),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(w&&w.length===4)return{uri:v.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$Hp=S;function I($){if(!$)return $;const A=$.indexOf(`
`);return A===-1?$:$.substring(0,A)}function P($,A){const{args:E,stack:w}=r($),l=typeof E[0]=="string"&&E.length===1;let d=I(w);d&&(d=`(${d.trim()})`);let m=[];if(typeof E[0]=="string"?d&&l?m=[`%c[${A}] %c${E[0]} %c${d}`,b("blue"),b(""),b("grey")]:m=[`%c[${A}] %c${E[0]}`,b("blue"),b(""),...E.slice(1)]:m=[`%c[${A}]%`,b("blue"),...E],d&&!l&&m.push(d),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,m)}e.log=P;function b($){return`color: ${$}`}}),define(we[50],be([1,0,15,4]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function r(b){return JSON.stringify(b,I)}e.$Wg=r;function S(b){let $=JSON.parse(b);return $=P($),$}e.$Xg=S;function I(b,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function P(b,$=0){if(!b||$>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return R.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 16:return new Date(b.source)}if(b instanceof v.$Ec||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let A=0;A<b.length;++A)b[A]=P(b[A],$+1);else for(const A in b)Object.hasOwnProperty.call(b,A)&&(b[A]=P(b[A],$+1))}return b}e.$Yg=P}),define(we[13],be([1,0,11,3,4]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var S;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(S||(e.Schemas=S={})),e.$Te="vscode-tkn",e.$Ue="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${S.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${S.vscodeRemoteResource}`}set(A,E,w){this.a[A]=E,this.b[A]=w}setConnectionToken(A,E){this.c[A]=E}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(c){return v.$Y(c),A}const E=A.authority;let w=this.a[E];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const l=this.b[E],d=this.c[E];let m=`path=${encodeURIComponent(A.path)}`;return typeof d=="string"&&(m+=`&${e.$Ue}=${encodeURIComponent(d)}`),r.URI.from({scheme:R.$j?this.d:S.vscodeRemoteResource,authority:`${w}:${l}`,path:R.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:m})}}e.$Ve=new I,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(A){const E=this.b(A,le);return this.uriToBrowserUri(E)}uriToBrowserUri(A){return A.scheme===S.vscodeRemote?e.$Ve.rewrite(A):A.scheme===S.file&&(R.$h||R.$k&&R.$b.origin===`${S.vscodeFileResource}://${P.a}`)?A.with({scheme:S.vscodeFileResource,authority:A.authority||P.a,query:null,fragment:null}):A}asFileUri(A){const E=this.b(A,le);return this.uriToFileUri(E)}uriToFileUri(A){return A.scheme===S.vscodeFileResource?A.with({scheme:S.file,authority:A.authority!==P.a?A.authority:null,query:null,fragment:null}):A}b(A,E){return r.URI.isUri(A)?A:r.URI.parse(E.toUrl(A))}}P.a="vscode-app",e.$1e=new P;var b;(function($){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(A.get("3"));const E="vscode-coi";function w(d){let m;typeof d=="string"?m=new URL(d).searchParams:d instanceof URL?m=d.searchParams:r.URI.isUri(d)&&(m=new URL(d.toString(!0)).searchParams);const c=m?.get(E);if(c)return A.get(c)}$.getHeadersFromQuery=w;function l(d,m,c){if(!globalThis.crossOriginIsolated)return;const u=m&&c?"3":c?"2":"1";d instanceof URLSearchParams?d.set(E,u):d[E]=u}$.addSearchParam=l})(b||(e.COI=b={}))}),define(we[150],be([1,0,95,13,3,4]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=void 0;class I{constructor(w,l,d){this.id=w,this.dependencies=l,this.callback=d}}class P{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,l,d)=>{typeof w!="string"&&(d=l,l=w,w=null),(typeof l!="object"||!Array.isArray(l))&&(d=l,l=null),this.c.push(new I(w,l,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const l=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!l)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(w){return new Promise((l,d)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const c=()=>{m.removeEventListener("load",u),m.removeEventListener("error",h)},u=g=>{c(),l(this.c.pop())},h=g=>{c(),d(g)};m.addEventListener("load",u),m.addEventListener("error",h),this.f&&(w=this.f.createScriptURL(w)),m.setAttribute("src",w),document.getElementsByTagName("head")[0].appendChild(m)})}i(w){return new Promise((l,d)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),l(this.c.pop())}catch(m){d(m)}})}async j(w){try{const l=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,c=S.URI.parse(w).fsPath,u=l.readFileSync(c).toString(),h=m.wrap(u.replace(/^#!.*/,""));return new d.Script(h).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}P.INSTANCE=new P;const b=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function A(E,w,l){if(v.$R){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[E]&&(E=$[E]);const d=`${E}/${w}`;if(b.has(d))return b.get(d);let m;if(/^\w[\w\d+.-]*:\/\//.test(d))m=d;else{const g=`${l&&!r.$j?R.$Ye:R.$Xe}/${d}`;m=R.$1e.asBrowserUri(g).toString(!0)}const c=P.INSTANCE.load(m);return b.set(d,c),c}else return await new Promise((d,m)=>{le([E],d,m)})}e.$3C=A}),define(we[19],be([1,0,38,13,7,3,17,4]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.DataUri=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function b(l){return(0,P.$Se)(l,!0)}e.$Wf=b;class ${constructor(d){this.a=d}compare(d,m,c=!1){return d===m?0:(0,I.$Ed)(this.getComparisonKey(d,c),this.getComparisonKey(m,c))}isEqual(d,m,c=!1){return d===m?!0:!d||!m?!1:this.getComparisonKey(d,c)===this.getComparisonKey(m,c)}getComparisonKey(d,m=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,m,c=!1){if(d.scheme===m.scheme){if(d.scheme===R.Schemas.file)return v.$He(b(d),b(m),this.a(d))&&d.query===m.query&&(c||d.fragment===m.fragment);if((0,e.$bg)(d.authority,m.authority))return v.$He(d.path,m.path,this.a(d),"/")&&d.query===m.query&&(c||d.fragment===m.fragment)}return!1}joinPath(d,...m){return P.URI.joinPath(d,...m)}basenameOrAuthority(d){return(0,e.$6f)(d)||d.authority}basename(d){return r.$5c.basename(d.path)}extname(d){return r.$5c.extname(d.path)}dirname(d){if(d.path.length===0)return d;let m;return d.scheme===R.Schemas.file?m=P.URI.file(r.$$c(b(d))).path:(m=r.$5c.dirname(d.path),d.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),m="/")),d.with({path:m})}normalizePath(d){if(!d.path.length)return d;let m;return d.scheme===R.Schemas.file?m=P.URI.file(r.$6c(b(d))).path:m=r.$5c.normalize(d.path),d.with({path:m})}relativePath(d,m){if(d.scheme!==m.scheme||!(0,e.$bg)(d.authority,m.authority))return;if(d.scheme===R.Schemas.file){const h=r.$0c(b(d),b(m));return S.$d?v.$Be(h):h}let c=d.path||"/";const u=m.path||"/";if(this.a(d)){let h=0;for(const g=Math.min(c.length,u.length);h<g&&!(c.charCodeAt(h)!==u.charCodeAt(h)&&c.charAt(h).toLowerCase()!==u.charAt(h).toLowerCase());h++);c=u.substr(0,h)+c.substr(h)}return r.$5c.relative(c,u)}resolvePath(d,m){if(d.scheme===R.Schemas.file){const c=P.URI.file(r.$9c(b(d),m));return d.with({authority:c.authority,path:c.path})}return m=v.$Ce(m),d.with({path:r.$5c.resolve(d.path,m)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,m){return d===m||d!==void 0&&m!==void 0&&(0,I.$Ld)(d,m)}hasTrailingPathSeparator(d,m=r.sep){if(d.scheme===R.Schemas.file){const c=b(d);return c.length>v.$De(c).length&&c[c.length-1]===m}else{const c=d.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,m=r.sep){return(0,e.$cg)(d,m)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,m=r.sep){let c=!1;if(d.scheme===R.Schemas.file){const u=b(d);c=u!==void 0&&u.length===v.$De(u).length&&u[u.length-1]===m}else{m="/";const u=d.path;c=u.length===1&&u.charCodeAt(u.length-1)===47}return!c&&!(0,e.$cg)(d,m)?d.with({path:d.path+"/"}):d}}e.$Xf=$,e.$Yf=new $(()=>!1),e.$Zf=new $(l=>l.scheme===R.Schemas.file?!S.$f:!0),e.$1f=new $(l=>!0),e.$2f=e.$Yf.isEqual.bind(e.$Yf),e.$3f=e.$Yf.isEqualOrParent.bind(e.$Yf),e.$4f=e.$Yf.getComparisonKey.bind(e.$Yf),e.$5f=e.$Yf.basenameOrAuthority.bind(e.$Yf),e.$6f=e.$Yf.basename.bind(e.$Yf),e.$7f=e.$Yf.extname.bind(e.$Yf),e.$8f=e.$Yf.dirname.bind(e.$Yf),e.$9f=e.$Yf.joinPath.bind(e.$Yf),e.$0f=e.$Yf.normalizePath.bind(e.$Yf),e.$$f=e.$Yf.relativePath.bind(e.$Yf),e.$_f=e.$Yf.resolvePath.bind(e.$Yf),e.$ag=e.$Yf.isAbsolutePath.bind(e.$Yf),e.$bg=e.$Yf.isEqualAuthority.bind(e.$Yf),e.$cg=e.$Yf.hasTrailingPathSeparator.bind(e.$Yf),e.$dg=e.$Yf.removeTrailingPathSeparator.bind(e.$Yf),e.$eg=e.$Yf.addTrailingPathSeparator.bind(e.$Yf);function A(l,d){const m=[];for(let c=0;c<l.length;c++){const u=d(l[c]);l.some((h,g)=>g===c?!1:(0,e.$3f)(u,d(h)))||m.push(l[c])}return m}e.$fg=A;var E;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function d(m){const c=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(g=>{const[y,p]=g.split(":");y&&p&&c.set(y,p)});const h=m.path.substring(0,m.path.indexOf(";"));return h&&c.set(l.META_DATA_MIME,h),c}l.parseMetaData=d})(E||(e.DataUri=E={}));function w(l,d,m){if(d){let c=l.path;return c&&c[0]!==r.$5c.sep&&(c=r.$5c.sep+c),l.with({scheme:m,authority:d,path:c})}return l.with({scheme:m})}e.$gg=w}),define(we[14],be([1,0,20,11,5,2,19,3,147]),function(le,e,v,R,r,S,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function $(O){return!!O&&typeof O.then=="function"}e.$hg=$;function A(O){const N=new v.$oc,J=O(N.token),ie=new Promise((re,ee)=>{const oe=N.token.onCancellationRequested(()=>{oe.dispose(),N.dispose(),ee(new R.$3)});Promise.resolve(J).then(F=>{oe.dispose(),N.dispose(),re(F)},F=>{oe.dispose(),N.dispose(),ee(F)})});return new class{cancel(){N.cancel()}then(re,ee){return ie.then(re,ee)}catch(re){return this.then(void 0,re)}finally(re){return ie.finally(re)}}}e.$ig=A;function E(O,N,J){return new Promise((ie,re)=>{const ee=N.onCancellationRequested(()=>{ee.dispose(),ie(J)});O.then(ie,re).finally(()=>ee.dispose())})}e.$jg=E;function w(O,N){return new Promise((J,ie)=>{const re=N.onCancellationRequested(()=>{re.dispose(),ie(new R.$3)});O.then(J,ie).finally(()=>re.dispose())})}e.$kg=w;async function l(O){let N=-1;const J=O.map((ie,re)=>ie.then(ee=>(N=re,ee)));try{return await Promise.race(J)}finally{O.forEach((ie,re)=>{re!==N&&ie.cancel()})}}e.$lg=l;function d(O,N,J){let ie;const re=setTimeout(()=>{ie?.(void 0),J?.()},N);return Promise.race([O.finally(()=>clearTimeout(re)),new Promise(ee=>ie=ee)])}e.$mg=d;function m(O){return new Promise((N,J)=>{const ie=O();$(ie)?ie.then(N,J):N(ie)})}e.$ng=m;class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(N){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=N,!this.b){const J=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(J,J).then(ie)})}return new Promise((J,ie)=>{this.b.then(J,ie)})}return this.a=N(),new Promise((J,ie)=>{this.a.then(re=>{this.a=null,J(re)},re=>{this.a=null,ie(re)})})}dispose(){this.f=!0}}e.$og=c;class u{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.$pg=u;class h{constructor(){this.a=new Map}queue(N,J){const re=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.a.get(N)===re&&this.a.delete(N)});return this.a.set(N,re),re}}e.$qg=h;const g=(O,N)=>{let J=!0;const ie=setTimeout(()=>{J=!1,N()},O);return{isTriggered:()=>J,dispose:()=>{clearTimeout(ie),J=!1}}},y=O=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,O())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class p{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,J=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((re,ee)=>{this.d=re,this.f=ee}).then(()=>{if(this.b=null,this.d=null,this.g){const re=this.g;return this.g=null,re()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=J===b.$bc?y(ie):g(J,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$rg=p;class t{constructor(N){this.a=new p(N),this.b=new c}trigger(N,J){return this.a.trigger(()=>this.b.queue(N),J)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$sg=t;class i{constructor(){this.a=!1,this.b=new Promise((N,J)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$tg=i;class a extends i{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.$ug=a;function s(O,N){return N?new Promise((J,ie)=>{const re=setTimeout(()=>{ee.dispose(),J()},O),ee=N.onCancellationRequested(()=>{clearTimeout(re),ee.dispose(),ie(new R.$3)})}):A(J=>s(O,J))}e.$vg=s;function n(O,N=0){const J=setTimeout(O,N);return(0,S.$jb)(()=>clearTimeout(J))}e.$wg=n;function o(O){const N=[];let J=0;const ie=O.length;function re(){return J<ie?O[J++]():null}function ee(oe){oe!=null&&N.push(oe);const F=re();return F?F.then(ee):Promise.resolve(N)}return Promise.resolve(null).then(ee)}e.$xg=o;function f(O,N=ie=>!!ie,J=null){let ie=0;const re=O.length,ee=()=>{if(ie>=re)return Promise.resolve(J);const oe=O[ie++];return Promise.resolve(oe()).then(z=>N(z)?Promise.resolve(z):ee())};return ee()}e.$yg=f;function k(O,N=ie=>!!ie,J=null){if(O.length===0)return Promise.resolve(J);let ie=O.length;const re=()=>{ie=-1;for(const ee of O)ee.cancel?.()};return new Promise((ee,oe)=>{for(const F of O)F.then(z=>{--ie>=0&&N(z)?(re(),ee(z)):ie===0&&ee(J)}).catch(z=>{--ie>=0&&(re(),oe(z))})})}e.$zg=k;class D{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new r.$ec}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((J,ie)=>{this.f.push({factory:N,c:J,e:ie}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const J=N.factory();J.then(N.c,N.e),J.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Ag=D;class C extends D{constructor(){super(1)}}e.$Bg=C;class L{constructor(){this.a=new se,this.b=0}queue(N){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,N())):this.a.run(this.b++,N())}}e.$Cg=L;class U{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const N=new H;return this.b.add(N),N.p}d(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,J=I.$Yf){const ie=J.getComparisonKey(N);let re=this.a.get(ie);return re||(re=new C,r.Event.once(re.onDrained)(()=>{re?.dispose(),this.a.delete(ie),this.f()}),this.a.set(ie,re)),re}f(){this.d()&&this.g()}g(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.g()}}e.$Dg=U;class x{constructor(N,J){this.a=-1,typeof N=="function"&&typeof J=="number"&&this.setIfNotSet(N,J)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,J){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},J)}setIfNotSet(N,J){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},J))}}e.$Eg=x;class ae{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,J){this.cancel(),this.a=setInterval(()=>{N()},J)}}e.$Fg=ae;class W{constructor(N,J){this.b=-1,this.a=N,this.d=J,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=W;class te{constructor(N,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.a=N,this.b=J,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=te;class ue extends W{constructor(N,J){super(N,J),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.$Ig=ue;class Z extends S.$lb{constructor(N,J){super(),this.g=N,this.h=J,this.a=[],this.b=this.B(new S.$mb),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const J of N)this.a.push(J);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=Z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=O=>{(0,P.$v)(()=>{if(N)return;const J=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,J-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.$Kg=(O,N)=>{const J=requestIdleCallback(O,typeof N=="number"?{timeout:N}:void 0);let ie=!1;return{dispose(){ie||(ie=!0,cancelIdleCallback(J))}}}}();class he{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(J){this.g=J}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=he;async function V(O,N,J){let ie;for(let re=0;re<J;re++)try{return await O()}catch(ee){ie=ee,await s(N)}throw ie}e.$Mg=V;class se{isRunning(N){return typeof N=="number"?this.a?.taskId===N:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(N,J,ie){return this.a={taskId:N,cancel:()=>ie?.(),promise:J},J.then(()=>this.d(N),()=>this.d(N)),J}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}queue(N){if(this.b)this.b.run=N;else{let J,ie;const re=new Promise((ee,oe)=>{J=ee,ie=oe});this.b={run:N,promise:re,promiseResolve:J,promiseReject:ie}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=se;class K{constructor(N,J=()=>Date.now()){this.d=N,this.f=J,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.$Og=K;var Y;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(Y||(Y={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((N,J)=>{this.a=N,this.b=J})}complete(N){return new Promise(J=>{this.a(N),this.d={outcome:0,value:N},J()})}error(N){return new Promise(J=>{this.b(N),this.d={outcome:1,value:N},J()})}cancel(){return this.error(new R.$3)}}e.$Pg=H;var _;(function(O){async function N(ie){let re;const ee=await Promise.all(ie.map(oe=>oe.then(F=>F,F=>{re||(re=F)})));if(typeof re<"u")throw re;return ee}O.settled=N;function J(ie){return new Promise(async(re,ee)=>{try{await ie(re,ee)}catch(oe){ee(oe)}})}O.withAsyncBody=J})(_||(e.Promises=_={}));var ge;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(ge||(ge={}));class ne{static fromArray(N){return new ne(J=>{J.emitMany(N)})}static fromPromise(N){return new ne(async J=>{J.emitMany(await N)})}static fromPromises(N){return new ne(async J=>{await Promise.all(N.map(async ie=>J.emitOne(await ie)))})}static merge(N){return new ne(async J=>{await Promise.all(N.map(async ie=>{for await(const re of ie)J.emitOne(re)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new r.$ec,queueMicrotask(async()=>{const J={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(N(J)),this.j()}catch(ie){this.k(ie)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(N,J){return new ne(async ie=>{for await(const re of N)ie.emitOne(J(re))})}map(N){return ne.map(this,N)}static filter(N,J){return new ne(async ie=>{for await(const re of N)J(re)&&ie.emitOne(re)})}filter(N){return ne.filter(this,N)}static coalesce(N){return ne.filter(N,J=>!!J)}coalesce(){return ne.coalesce(this)}static async toPromise(N){const J=[];for await(const ie of N)J.push(ie);return J}toPromise(){return ne.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}e.$Qg=ne,ne.EMPTY=ne.fromArray([]);class q extends ne{constructor(N,J){super(J),this.l=N}cancel(){this.l.cancel()}}e.$Rg=q;function X(O){const N=new v.$oc,J=O(N.token);return new q(N,async ie=>{const re=N.token.onCancellationRequested(()=>{re.dispose(),N.dispose(),ie.reject(new R.$3)});try{for await(const ee of J){if(N.token.isCancellationRequested)return;ie.emitOne(ee)}re.dispose(),N.dispose()}catch(ee){re.dispose(),N.dispose(),ie.reject(ee)}})}e.$Sg=X}),define(we[76],be([1,0,18,14,38,28,7,3,17]),function(le,e,v,R,r,S,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function $(){return Object.create(null)}e.$_i=$,e.$aj="**",e.$bj="/";const A="[/\\\\]",E="[^/\\\\]",w=/\//g;function l(se,K){switch(se){case 0:return"";case 1:return`${E}*?`;default:return`(?:${A}|${E}+${A}${K?`|${A}${E}+`:""})*?`}}function d(se,K){if(!se)return[];const Y=[];let H=!1,_=!1,ge="";for(const ne of se){switch(ne){case K:if(!H&&!_){Y.push(ge),ge="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":_=!0;break;case"]":_=!1;break}ge+=ne}return ge&&Y.push(ge),Y}e.$cj=d;function m(se){if(!se)return"";let K="";const Y=d(se,e.$bj);if(Y.every(H=>H===e.$aj))K=".*";else{let H=!1;Y.forEach((_,ge)=>{if(_===e.$aj){if(H)return;K+=l(2,ge===Y.length-1)}else{let ne=!1,q="",X=!1,O="";for(const N of _){if(N!=="}"&&ne){q+=N;continue}if(X&&(N!=="]"||!O)){let J;N==="-"?J=N:(N==="^"||N==="!")&&!O?J="^":N===e.$bj?J="":J=(0,b.$pd)(N),O+=J;continue}switch(N){case"{":ne=!0;continue;case"[":X=!0;continue;case"}":{const ie=`(?:${d(q,",").map(re=>m(re)).join("|")})`;K+=ie,ne=!1,q="";break}case"]":{K+="["+O+"]",X=!1,O="";break}case"?":K+=E;continue;case"*":K+=l(1);continue;default:K+=(0,b.$pd)(N)}}ge<Y.length-1&&(Y[ge+1]!==e.$aj||ge+2<Y.length)&&(K+=A)}H=_===e.$aj})}return K}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.$qi(1e4),i=function(){return!1},a=function(){return null};function s(se,K){if(!se)return a;let Y;typeof se!="string"?Y=se.pattern:Y=se,Y=Y.trim();const H=`${Y}_${!!K.trimForExclusions}`;let _=t.get(H);if(_)return n(_,se);let ge;return c.test(Y)?_=f(Y.substr(4),Y):(ge=u.exec(o(Y,K)))?_=k(ge[1],Y):(K.trimForExclusions?g:h).test(Y)?_=D(Y,K):(ge=y.exec(o(Y,K)))?_=C(ge[1].substr(1),Y,!0):(ge=p.exec(o(Y,K)))?_=C(ge[1],Y,!1):_=L(Y),t.set(H,_),n(_,se)}function n(se,K){if(typeof K=="string")return se;const Y=function(H,_){return(0,r.$He)(H,K.base,!P.$f)?se((0,b.$td)(H.substr(K.base.length),I.sep),_):null};return Y.allBasenames=se.allBasenames,Y.allPaths=se.allPaths,Y.basenames=se.basenames,Y.patterns=se.patterns,Y}function o(se,K){return K.trimForExclusions&&se.endsWith("/**")?se.substr(0,se.length-2):se}function f(se,K){return function(Y,H){return typeof Y=="string"&&Y.endsWith(se)?K:null}}function k(se,K){const Y=`/${se}`,H=`\\${se}`,_=function(ne,q){return typeof ne!="string"?null:q?q===se?K:null:ne===se||ne.endsWith(Y)||ne.endsWith(H)?K:null},ge=[se];return _.basenames=ge,_.patterns=[K],_.allBasenames=ge,_}function D(se,K){const Y=he(se.slice(1,-1).split(",").map(q=>s(q,K)).filter(q=>q!==a),se),H=Y.length;if(!H)return a;if(H===1)return Y[0];const _=function(q,X){for(let O=0,N=Y.length;O<N;O++)if(Y[O](q,X))return se;return null},ge=Y.find(q=>!!q.allBasenames);ge&&(_.allBasenames=ge.allBasenames);const ne=Y.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return ne.length&&(_.allPaths=ne),_}function C(se,K,Y){const H=I.sep===I.$5c.sep,_=H?se:se.replace(w,I.sep),ge=I.sep+_,ne=I.$5c.sep+se;let q;return Y?q=function(X,O){return typeof X=="string"&&(X===_||X.endsWith(ge)||!H&&(X===se||X.endsWith(ne)))?K:null}:q=function(X,O){return typeof X=="string"&&(X===_||!H&&X===se)?K:null},q.allPaths=[(Y?"*/":"./")+se],q}function L(se){try{const K=new RegExp(`^${m(se)}$`);return function(Y){return K.lastIndex=0,typeof Y=="string"&&K.test(Y)?se:null}}catch{return a}}function U(se,K,Y){return!se||typeof K!="string"?!1:x(se)(K,void 0,Y)}e.$dj=U;function x(se,K={}){if(!se)return i;if(typeof se=="string"||ae(se)){const Y=s(se,K);if(Y===a)return i;const H=function(_,ge){return!!Y(_,ge)};return Y.allBasenames&&(H.allBasenames=Y.allBasenames),Y.allPaths&&(H.allPaths=Y.allPaths),H}return ue(se,K)}e.$ej=x;function ae(se){const K=se;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}e.$fj=ae;function W(se){return se.allBasenames||[]}e.$gj=W;function te(se){return se.allPaths||[]}e.$hj=te;function ue(se,K){const Y=he(Object.getOwnPropertyNames(se).map(q=>Z(q,se[q],K)).filter(q=>q!==a)),H=Y.length;if(!H)return a;if(!Y.some(q=>!!q.requiresSiblings)){if(H===1)return Y[0];const q=function(N,J){let ie;for(let re=0,ee=Y.length;re<ee;re++){const oe=Y[re](N,J);if(typeof oe=="string")return oe;(0,R.$hg)(oe)&&(ie||(ie=[]),ie.push(oe))}return ie?(async()=>{for(const re of ie){const ee=await re;if(typeof ee=="string")return ee}return null})():null},X=Y.find(N=>!!N.allBasenames);X&&(q.allBasenames=X.allBasenames);const O=Y.reduce((N,J)=>J.allPaths?N.concat(J.allPaths):N,[]);return O.length&&(q.allPaths=O),q}const _=function(q,X,O){let N,J;for(let ie=0,re=Y.length;ie<re;ie++){const ee=Y[ie];ee.requiresSiblings&&O&&(X||(X=(0,I.$_c)(q)),N||(N=X.substr(0,X.length-(0,I.$ad)(q).length)));const oe=ee(q,X,N,O);if(typeof oe=="string")return oe;(0,R.$hg)(oe)&&(J||(J=[]),J.push(oe))}return J?(async()=>{for(const ie of J){const re=await ie;if(typeof re=="string")return re}return null})():null},ge=Y.find(q=>!!q.allBasenames);ge&&(_.allBasenames=ge.allBasenames);const ne=Y.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return ne.length&&(_.allPaths=ne),_}function Z(se,K,Y){if(K===!1)return a;const H=s(se,Y);if(H===a)return a;if(typeof K=="boolean")return H;if(K){const _=K.when;if(typeof _=="string"){const ge=(ne,q,X,O)=>{if(!O||!H(ne,q))return null;const N=_.replace("$(basename)",()=>X),J=O(N);return(0,R.$hg)(J)?J.then(ie=>ie?se:null):J?se:null};return ge.requiresSiblings=!0,ge}}return H}function he(se,K){const Y=se.filter(q=>!!q.basenames);if(Y.length<2)return se;const H=Y.reduce((q,X)=>{const O=X.basenames;return O?q.concat(O):q},[]);let _;if(K){_=[];for(let q=0,X=H.length;q<X;q++)_.push(K)}else _=Y.reduce((q,X)=>{const O=X.patterns;return O?q.concat(O):q},[]);const ge=function(q,X){if(typeof q!="string")return null;if(!X){let N;for(N=q.length;N>0;N--){const J=q.charCodeAt(N-1);if(J===47||J===92)break}X=q.substr(N)}const O=H.indexOf(X);return O!==-1?_[O]:null};ge.basenames=H,ge.patterns=_,ge.allBasenames=H;const ne=se.filter(q=>!q.basenames);return ne.push(ge),ne}function V(se,K){return(0,v.$$e)(se,K,(Y,H)=>typeof Y=="string"&&typeof H=="string"?Y===H:typeof Y!="string"&&typeof H!="string"?Y.base===H.base&&Y.pattern===H.pattern:!1)}e.$ij=V}),define(we[101],be([1,0,11,148,19,17,4]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class b{constructor(u="",h=!1){if(this.value=u,typeof this.value!="string")throw(0,v.$5)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(u,h=0){return this.value+=w(this.supportThemeIcons?(0,R.$Ej)(u):u).replace(/([ \t]+)/g,(g,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,h){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(u,h,g){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(u),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(u,h){const g=new RegExp((0,S.$pd)(h),"g");return u.replace(g,(y,p)=>u.charAt(p-1)!=="\\"?`\\${y}`:y)}}e.$Kj=b;function $(c){return A(c)?!c.value:Array.isArray(c)?c.every($):!0}e.$Lj=$;function A(c){return c instanceof b?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.$Mj=A;function E(c,u){return c===u?!0:!c||!u?!1:c.value===u.value&&c.isTrusted===u.isTrusted&&c.supportThemeIcons===u.supportThemeIcons&&c.supportHtml===u.supportHtml&&(c.baseUri===u.baseUri||!!c.baseUri&&!!u.baseUri&&(0,r.$2f)(I.URI.from(c.baseUri),I.URI.from(u.baseUri)))}e.$Nj=E;function w(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Oj=w;function l(c){return c.replace(/"/g,"&quot;")}e.$Pj=l;function d(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Qj=d;function m(c){const u=[],h=c.split("|").map(y=>y.trim());c=h[0];const g=h[1];if(g){const y=/height=(\d+)/.exec(g),p=/width=(\d+)/.exec(g),t=y?y[1]:"",i=p?p[1]:"",a=isFinite(parseInt(i)),s=isFinite(parseInt(t));a&&u.push(`width="${i}"`),s&&u.push(`height="${t}"`)}return{href:c,dimensions:u}}e.$Rj=m}),define(we[151],be([1,0,18,38,7,3,19,17]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dA=e.$cA=e.$bA=e.$aA=e.$_z=e.$$z=e.$0z=e.$9z=e.$8z=e.$7z=void 0;function b(s,n){const{os:o,tildify:f,relative:k}=n;if(k){const L=$(s,k,o);if(typeof L=="string")return L}let D=s.fsPath;if(o===1&&!S.$d?D=D.replace(/\//g,"\\"):o!==1&&S.$d&&(D=D.replace(/\\/g,"/")),o!==1&&f?.userHome){const L=f.userHome.fsPath;let U;s.scheme!==f.userHome.scheme&&s.path.startsWith(r.$5c.sep)?U=f.userHome.with({path:s.path}).fsPath:U=s.fsPath,D=w(U,L,o)}return(o===1?r.$4c:r.$5c).normalize(A(D,o===1))}e.$7z=b;function $(s,n,o){const f=o===1?r.$4c:r.$5c,k=o===3?I.$Yf:I.$1f,D=n.getWorkspace(),C=(0,v.$sf)(D.folders);if(!C)return;s.scheme!==C.uri.scheme&&s.path.startsWith(r.$5c.sep)&&(s=C.uri.with({path:s.path}));const L=n.getWorkspaceFolder(s);if(!L)return;let U;if(k.isEqual(L.uri,s)?U="":U=k.relativePath(L.uri,s)??"",U&&(U=f.normalize(U)),D.folders.length>1&&!n.noPrefix){const x=L.name?L.name:k.basenameOrAuthority(L.uri);U=U?`${x} \u2022 ${U}`:x}return U}function A(s,n=S.$d){return(0,R.$Le)(s,n)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$8z=A;let E=Object.create(null);function w(s,n,o=S.OS){if(o===1||!s||!n)return s;let f=E.original===n?E.normalized:void 0;f||(f=n,S.$d&&(f=(0,R.$Be)(f)),f=`${(0,P.$ud)(f,r.$5c.sep)}${r.$5c.sep}`,E={original:n,normalized:f});let k=s;return S.$d&&(k=(0,R.$Be)(k)),(o===3?k.startsWith(f):(0,P.$Md)(k,f))?`~/${k.substr(f.length)}`:s}e.$9z=w;function l(s,n){return s.replace(/^~($|\/|\\)/,`${n}$1`)}e.$0z=l;const d="\u2026",m="\\\\",c="~";function u(s,n=r.sep){const o=new Array(s.length);let f=!1;for(let k=0;k<s.length;k++){const D=s[k];if(D===""){o[k]=`.${n}`;continue}if(!D){o[k]=D;continue}f=!0;let C="",L=D;L.indexOf(m)===0?(C=L.substr(0,L.indexOf(m)+m.length),L=L.substr(L.indexOf(m)+m.length)):L.indexOf(n)===0?(C=L.substr(0,L.indexOf(n)+n.length),L=L.substr(L.indexOf(n)+n.length)):L.indexOf(c)===0&&(C=L.substr(0,L.indexOf(c)+c.length),L=L.substr(L.indexOf(c)+c.length));const U=L.split(n);for(let x=1;f&&x<=U.length;x++)for(let ae=U.length-x;f&&ae>=0;ae--){f=!1;let W=U.slice(ae,ae+x).join(n);for(let te=0;!f&&te<s.length;te++)if(te!==k&&s[te]&&s[te].indexOf(W)>-1){const ue=ae+x===U.length,Z=ae>0&&s[te].indexOf(n)>-1?n+W:W,he=s[te].endsWith(Z);f=!ue||he}if(!f){let te="";(U[0].endsWith(":")||C!=="")&&(ae===1&&(ae=0,x++,W=U[0]+n+W),ae>0&&(te=U[0]+n),te=C+te),ae>0&&(te=te+d+n),te=te+W,ae+x<U.length&&(te=te+n+d),o[k]=te}}f&&(o[k]=D)}return o}e.$$z=u;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function g(s,n=Object.create(null)){const o=[];let f=!1,k="";for(const D of s)if(D==="$"||f&&D==="{")k&&o.push({value:k,type:h.TEXT}),k="",f=!0;else if(D==="}"&&f){const C=n[k];if(typeof C=="string")C.length&&o.push({value:C,type:h.VARIABLE});else if(C){const L=o[o.length-1];(!L||L.type!==h.SEPARATOR)&&o.push({value:C.label,type:h.SEPARATOR})}k="",f=!1}else k+=D;return k&&!f&&o.push({value:k,type:h.TEXT}),o.filter((D,C)=>{if(D.type===h.SEPARATOR){const L=o[C-1],U=o[C+1];return[L,U].every(x=>x&&(x.type===h.VARIABLE||x.type===h.TEXT)&&x.value.length>0)}return!0}).map(D=>D.value).join("")}e.$_z=g;function y(s,n){return S.$e||n?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.$e?"&":"&&"):s.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$aA=y;function p(s,n){return S.$e||n?s.replace(/\(&&\w\)|&&/g,""):S.$d?s.replace(/&&|&/g,o=>o==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$bA=p;function t(s){return s.replace(/&/g,"&&")}e.$cA=t;function i(s){if(s.endsWith("]")){const n=s.lastIndexOf(" [",s.length-2);if(n!==-1){const o=a(s.substring(0,n));return{name:o.name,parentPath:o.parentPath+s.substring(n)}}}return a(s)}e.$dA=i;function a(s){const n=s.indexOf("/")!==-1?r.$5c:r.$4c,o=n.basename(s),f=n.dirname(s);return o.length?{name:o,parentPath:f}:{name:f,parentPath:""}}}),define(we[51],be([1,0,15,4]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=void 0;function r(E){return E.toJSON()}class S{constructor(w){this.a=w}transformIncoming(w){const l=this.a.transformIncoming(w);return l===w?w:r(R.URI.from(l))}transformOutgoing(w){const l=this.a.transformOutgoing(w);return l===w?w:r(R.URI.from(l))}transformOutgoingURI(w){const l=this.a.transformOutgoing(w);return l===w?w:R.URI.from(l)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$pm=S,e.$qm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function I(E,w,l){if(!E||l>200)return null;if(typeof E=="object"){if(E instanceof R.URI)return w.transformOutgoing(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const m=I(E[d],w,l+1);m!==null&&(E[d]=m)}}return null}function P(E,w){const l=I(E,w,0);return l===null?E:l}e.$rm=P;function b(E,w,l,d){if(!E||d>200)return null;if(typeof E=="object"){if(E.$mid===1)return l?R.URI.revive(w.transformIncoming(E)):w.transformIncoming(E);if(E instanceof v.$Ec)return null;for(const m in E)if(Object.hasOwnProperty.call(E,m)){const c=b(E[m],w,l,d+1);c!==null&&(E[m]=c)}}return null}function $(E,w){const l=b(E,w,!1,0);return l===null?E:l}e.$sm=$;function A(E,w){const l=b(E,w,!0,0);return l===null?E:l}e.$tm=A}),define(we[23],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(r){return v.test(r)}e.$2e=R,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(P){for(let b=0;b<P.length;b++)P[b]=Math.floor(Math.random()*256);return P};const S=new Uint8Array(16),I=[];for(let P=0;P<256;P++)I.push(P.toString(16).padStart(2,"0"));return function(){r(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let b=0,$="";return $+=I[S[b++]],$+=I[S[b++]],$+=I[S[b++]],$+=I[S[b++]],$+="-",$+=I[S[b++]],$+=I[S[b++]],$+="-",$+=I[S[b++]],$+=I[S[b++]],$+="-",$+=I[S[b++]],$+=I[S[b++]],$+="-",$+=I[S[b++]],$+=I[S[b++]],$+=I[S[b++]],$+=I[S[b++]],$+=I[S[b++]],$+=I[S[b++]],$}}()}),define(we[152],be([1,0,18,47,23]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0;function S(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}e.$fs=S;function I(E,w,l){const d={id:(0,r.$3e)(),name:E,uri:w,data:l};return{asString:async()=>"",asFile:()=>d,value:void 0}}e.$gs=I;class P{constructor(){this.a=new Map}get size(){let w=0;for(const l of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const l=[...this.a.keys()];return R.Iterable.some(this,([d,m])=>m.asFile())&&l.push("files"),A(b(w),l)}get(w){return this.a.get(this.b(w))?.[0]}append(w,l){const d=this.a.get(w);d?d.push(l):this.a.set(this.b(w),[l])}replace(w,l){this.a.set(this.b(w),[l])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,l]of this.a)for(const d of l)yield[w,d]}b(w){return b(w)}}e.$hs=P;function b(E){return E.toLowerCase()}function $(E,w){return A(b(E),w.map(b))}e.$is=$;function A(E,w){if(E==="*/*")return w.length>0;if(w.includes(E))return!0;const l=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!l)return!1;const[d,m,c]=l;return c==="*"?w.some(u=>u.startsWith(m+"/")):!1}e.$js=Object.freeze({create:E=>(0,v.$of)(E.map(w=>w.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$js.split(E).filter(w=>!w.startsWith("#"))})}),function(){"use strict";function le(e,v,R){function r(l){return new Promise(d=>v.exists(l,d))}function S(l){return new Promise((d,m)=>{const c=new Date;v.utimes(l,c,c,u=>u?m(u):d())})}function I(l){return new Promise((d,m)=>v.mkdir(l,{recursive:!0},c=>c&&c.code!=="EEXIST"?m(c):d(l)))}function P(l){return new Promise((d,m)=>v.rm(l,{recursive:!0,force:!0,maxRetries:3},c=>c?m(c):d()))}function b(l){return new Promise((d,m)=>v.readFile(l,"utf8",(c,u)=>c?m(c):d(u)))}function $(l,d){return new Promise((m,c)=>v.writeFile(l,d,"utf8",u=>u?c(u):m()))}async function A(l){const d=e.join(l,"languagepacks.json");try{return JSON.parse(await b(d))}catch{}}function E(l,d){try{for(;d;){if(l[d])return d;{const m=d.lastIndexOf("-");if(m>0)d=d.substring(0,m);else return}}}catch(m){console.error("Resolving language pack configuration failed.",m)}}function w(l,d,m,c,u){const h=function(y){return R.mark("code/didGenerateNls"),Promise.resolve({locale:y,osLocale:u,availableLanguages:{}})};if(R.mark("code/willGenerateNls"),c==="pseudo")return Promise.resolve({locale:c,osLocale:u,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:c,osLocale:u,availableLanguages:{}});if(c&&(c==="en"||c==="en-us"))return Promise.resolve({locale:c,osLocale:u,availableLanguages:{}});const g=c;try{return l?A(d).then(y=>{if(!y)return h(g);const p=E(y,c);if(!p)return h(g);c=p;const t=y[c];let i;return!t||typeof t.hash!="string"||!t.translations||typeof(i=t.translations.vscode)!="string"?h(g):r(i).then(a=>{if(!a)return h(g);const s=t.hash+"."+c,n=e.join(d,"clp",s),o=e.join(n,l),f=e.join(n,"tcf.json"),k=e.join(n,"corrupted.info"),D={locale:g,osLocale:u,availableLanguages:{"*":c},_languagePackId:s,_translationsConfigFile:f,_cacheRoot:n,_resolvedLanguagePackCoreLocation:o,_corruptedFile:k};return r(k).then(C=>{let L;return C?L=P(n):L=Promise.resolve(void 0),L.then(()=>r(o).then(U=>U?(S(o).catch(()=>{}),R.mark("code/didGenerateNls"),D):I(o).then(()=>Promise.all([b(m),b(i)])).then(x=>{const ae=JSON.parse(x[0]),W=JSON.parse(x[1]).contents,te=Object.keys(ae.bundles),ue=[];for(const Z of te){const he=ae.bundles[Z],V=Object.create(null);for(const se of he){const K=ae.keys[se],Y=ae.messages[se],H=W[se];let _;if(H){_=[];for(let ge=0;ge<K.length;ge++){const ne=K[ge],q=typeof ne=="string"?ne:ne.key;let X=H[q];X===void 0&&(X=Y[ge]),_.push(X)}}else _=Y;V[se]=_}ue.push($(e.join(o,Z.replace(/\//g,"!")+".nls.json"),JSON.stringify(V)))}return ue.push($(f,JSON.stringify(t.translations))),Promise.all(ue)}).then(()=>(R.mark("code/didGenerateNls"),D)).catch(x=>(console.error("Generating translation files failed.",x),h(c)))))})})}):h(g)}catch(y){return console.error("Generating translation files failed.",y),h(c)}}return{getNLSConfiguration:w}}if(typeof define=="function")define(we[153],be([77,30,41]),function(e,v,R){return le(e,v,R)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("fs"),R=require("../common/performance");module.exports=le(e,v,R)}else throw new Error("Unknown context")}(),define(we[154],be([1,0,26]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(I){const P=I.replace(/\-/g,":").toLowerCase();return!R.has(P)}function S(){const I=(0,v.networkInterfaces)();for(const P in I){const b=I[P];if(b){for(const{mac:$}of b)if(r($))return $}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$um=S}),define(we[102],be([1,0,26,63,23,154]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0,e.$vm=new class{c($){return this.a||(this.a=R.$vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,A=0;const E=(0,v.networkInterfaces)();for(const w in E){const l=E[w];if(l)for(const{mac:d,internal:m}of l)m||(A+=1,this.c(d.toUpperCase())&&($+=1))}this.b=A>0?$/A:0}return this.b}};let I;async function P($){return I||(I=(async()=>await b($)||r.$3e())()),I}e.$wm=P;async function b($){try{const A=await new Promise((w,l)=>{le(["crypto"],w,l)}),E=(0,S.$um)();return A.createHash("sha256").update(E,"utf8").digest("hex")}catch(A){$(A);return}}}),define(we[155],be([1,0,30,295,296,3]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=void 0;async function I(P){if(S.$e||S.$d)return;let b;for(const $ of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{b=await(0,R.open)($,v.constants.R_OK);break}catch{}if(!b){P("Unable to retrieve release information from known identifier paths.");return}try{const $=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),A={id:"unknown"};for await(const E of(0,r.createInterface)({input:b.createReadStream(),crlfDelay:1/0})){if(!E.includes("="))continue;const w=E.split("=")[0].toUpperCase().trim();if($.has(w)){const l=E.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?A.id=l:w==="ID_LIKE"?A.id_like=l:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(A.version_id=l)}}return A}catch($){P($)}}e.$4e=I}),define(we[21],be([1,0,30,26,297,14,38,99,7,3,19,4]),function(le,e,v,R,r,S,I,P,b,$,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(Z){Z[Z.UNLINK=0]="UNLINK",Z[Z.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function l(Z,he=w.UNLINK,V){if((0,I.$Ke)(Z))throw new Error("rimraf - will refuse to recursively delete root");return he===w.UNLINK?m(Z):d(Z,V)}async function d(Z,he=(0,I.$Pe)((0,R.tmpdir)())){try{try{await v.promises.rename(Z,he)}catch(V){return V.code==="ENOENT"?void 0:m(Z)}m(he).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function m(Z){return(0,r.promisify)(v.rm)(Z,{recursive:!0,force:!0,maxRetries:3})}function c(Z){if((0,I.$Ke)(Z))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(Z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function u(Z,he){return y(await(he?h(Z):(0,r.promisify)(v.readdir)(Z)))}async function h(Z){try{return await(0,r.promisify)(v.readdir)(Z,{withFileTypes:!0})}catch(se){console.warn("[node.js fs] readdir with filetypes failed with error: ",se)}const he=[],V=await u(Z);for(const se of V){let K=!1,Y=!1,H=!1;try{const _=await e.Promises.lstat((0,b.$8c)(Z,se));K=_.isFile(),Y=_.isDirectory(),H=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}he.push({name:se,isFile:()=>K,isDirectory:()=>Y,isSymbolicLink:()=>H})}return he}function g(Z){return y(v.readdirSync(Z))}e.readdirSync=g;function y(Z){return Z.map(he=>typeof he=="string"?$.$e?(0,P.$8k)(he):he:(he.name=$.$e?(0,P.$8k)(he.name):he.name,he))}async function p(Z){const he=await u(Z),V=[];for(const se of he)await i.existsDirectory((0,b.$8c)(Z,se))&&V.push(se);return V}function t(Z,he=1e3){return new Promise(V=>{let se=!1;const K=setInterval(()=>{se||(se=!0,v.access(Z,Y=>{se=!1,Y&&(clearInterval(K),V(void 0))}))},he)})}e.whenDeleted=t;var i;(function(Z){async function he(K){let Y;try{if(Y=await e.Promises.lstat(K),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if($.$d&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw _}throw H}}Z.stat=he;async function V(K){try{const{stat:Y,symbolicLink:H}=await Z.stat(K);return Y.isFile()&&H?.dangling!==!0}catch{}return!1}Z.existsFile=V;async function se(K){try{const{stat:Y,symbolicLink:H}=await Z.stat(K);return Y.isDirectory()&&H?.dangling!==!0}catch{}return!1}Z.existsDirectory=se})(i||(e.SymlinkSupport=i={}));const a=new S.$Dg;function s(Z,he,V){return a.queueFor(E.URI.file(Z),A.$Zf).queue(()=>{const se=D(V);return new Promise((K,Y)=>f(Z,he,se,H=>H?Y(H):K()))})}let n=!0;function o(Z){n=Z}e.configureFlushOnWrite=o;function f(Z,he,V,se){if(!n)return v.writeFile(Z,he,{mode:V.mode,flag:V.flag},se);v.open(Z,V.flag,V.mode,(K,Y)=>{if(K)return se(K);v.writeFile(Y,he,H=>{if(H)return v.close(Y,()=>se(H));v.fdatasync(Y,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),o(!1)),v.close(Y,ge=>se(ge))))})})}function k(Z,he,V){const se=D(V);if(!n)return v.writeFileSync(Z,he,{mode:se.mode,flag:se.flag});const K=v.openSync(Z,se.flag,se.mode);try{v.writeFileSync(K,he);try{v.fdatasyncSync(K)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),o(!1)}}finally{v.closeSync(K)}}e.writeFileSync=k;function D(Z){return Z?{mode:typeof Z.mode=="number"?Z.mode:438,flag:typeof Z.flag=="string"?Z.flag:"w"}:{mode:438,flag:"w"}}async function C(Z,he,V=6e4){if(Z!==he)try{$.$d&&typeof V=="number"?await L(Z,he,Date.now(),V):await(0,r.promisify)(v.rename)(Z,he)}catch(se){if(Z.toLowerCase()!==he.toLowerCase()&&se.code==="EXDEV"||Z.endsWith("."))await U(Z,he,{preserveSymlinks:!1}),await l(Z,w.MOVE);else throw se}}async function L(Z,he,V,se,K=0){try{return await(0,r.promisify)(v.rename)(Z,he)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-V>=se)throw console.error(`[node.js fs] rename failed after ${K} retries with error: ${Y}`),Y;if(K===0){let H=!1;try{const{stat:_}=await i.stat(he);_.isFile()||(H=!0)}catch{}if(H)throw Y}return await(0,S.$vg)(Math.min(100,K*10)),L(Z,he,V,se,K+1)}}async function U(Z,he,V){return ae(Z,he,{root:{source:Z,target:he},options:V,handledSourcePaths:new Set})}const x=511;async function ae(Z,he,V){if(V.handledSourcePaths.has(Z))return;V.handledSourcePaths.add(Z);const{stat:se,symbolicLink:K}=await i.stat(Z);if(K){if(V.options.preserveSymlinks)try{return await ue(Z,he,V)}catch(Y){console.warn("[node.js fs] copy of symlink failed: ",Y)}if(K.dangling)return}return se.isDirectory()?W(Z,he,se.mode&x,V):te(Z,he,se.mode&x)}async function W(Z,he,V,se){await e.Promises.mkdir(he,{recursive:!0,mode:V});const K=await u(Z);for(const Y of K)await ae((0,b.$8c)(Z,Y),(0,b.$8c)(he,Y),se)}async function te(Z,he,V){await e.Promises.copyFile(Z,he),await e.Promises.chmod(he,V)}async function ue(Z,he,V){let se=await e.Promises.readlink(Z);(0,I.$He)(se,V.root.source,!$.$f)&&(se=(0,b.$8c)(V.root.target,se.substr(V.root.source.length+1))),await e.Promises.symlink(se,he)}e.Promises=new class{get access(){return(0,r.promisify)(v.access)}get stat(){return(0,r.promisify)(v.stat)}get lstat(){return(0,r.promisify)(v.lstat)}get utimes(){return(0,r.promisify)(v.utimes)}get read(){return(Z,he,V,se,K)=>new Promise((Y,H)=>{v.read(Z,he,V,se,K,(_,ge,ne)=>_?H(_):Y({bytesRead:ge,buffer:ne}))})}get readFile(){return(0,r.promisify)(v.readFile)}get write(){return(Z,he,V,se,K)=>new Promise((Y,H)=>{v.write(Z,he,V,se,K,(_,ge,ne)=>_?H(_):Y({bytesWritten:ge,buffer:ne}))})}get appendFile(){return(0,r.promisify)(v.appendFile)}get fdatasync(){return(0,r.promisify)(v.fdatasync)}get truncate(){return(0,r.promisify)(v.truncate)}get copyFile(){return(0,r.promisify)(v.copyFile)}get open(){return(0,r.promisify)(v.open)}get close(){return(0,r.promisify)(v.close)}get symlink(){return(0,r.promisify)(v.symlink)}get readlink(){return(0,r.promisify)(v.readlink)}get chmod(){return(0,r.promisify)(v.chmod)}get mkdir(){return(0,r.promisify)(v.mkdir)}get unlink(){return(0,r.promisify)(v.unlink)}get rmdir(){return(0,r.promisify)(v.rmdir)}get realpath(){return(0,r.promisify)(v.realpath)}async exists(Z){try{return await e.Promises.access(Z),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return p}get writeFile(){return s}get rm(){return l}get rename(){return C}get copy(){return U}}}),define(we[156],be([1,0,30,7,3,17,21]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.$Np=e.$Mp=void 0;function P(w){if(r.$f)return w;const l=(0,R.$$c)(w);if(w===l)return w;const d=((0,R.$_c)(w)||w).toLowerCase();try{const c=(0,I.readdirSync)(l).filter(u=>u.toLowerCase()===d);if(c.length===1){const u=P(l);if(u)return(0,R.$8c)(u,c[0])}else if(c.length>1){const u=c.indexOf(d);if(u>=0){const h=P(l);if(h)return(0,R.$8c)(h,c[u])}}}catch{}return null}e.$Mp=P;async function b(w){if(r.$f)return w;const l=(0,R.$$c)(w);if(w===l)return w;const d=((0,R.$_c)(w)||w).toLowerCase();try{const c=(await I.Promises.readdir(l)).filter(u=>u.toLowerCase()===d);if(c.length===1){const u=await b(l);if(u)return(0,R.$8c)(u,c[0])}else if(c.length>1){const u=c.indexOf(d);if(u>=0){const h=await b(l);if(h)return(0,R.$8c)(h,c[u])}}}catch{}return null}e.$Np=b;async function $(w){try{return await I.Promises.realpath(w)}catch{const d=E(w);return await I.Promises.access(d,v.constants.R_OK),d}}e.$Op=$;function A(w){try{return v.realpathSync(w)}catch{const d=E(w);return v.accessSync(d,v.constants.R_OK),d}}e.$Pp=A;function E(w){return(0,S.$ud)((0,R.$6c)(w),R.sep)}}),define(we[157],be([1,0,78]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7e=e.$6e=e.$5e=void 0;function R(P,b,$,A=1){let E=!1;return new Promise(w=>{const l=setTimeout(()=>{if(!E)return E=!0,w(0)},$);r(P,b,A,d=>{if(!E)return E=!0,clearTimeout(l),w(d)})})}e.$5e=R;function r(P,b,$,A){if(b===0)return A(0);const E=new v.Socket;E.once("connect",()=>(I(E),r(P+$,b-1,$,A))),E.once("data",()=>{}),E.once("error",w=>(I(E),w.code!=="ECONNREFUSED"?r(P+$,b-1,$,A):A(P))),E.connect(P,"127.0.0.1")}e.$6e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function S(P,b,$,A="127.0.0.1"){let E=!1,w,l=1;const d=v.createServer({pauseOnConnect:!0});function m(c,u){E||(E=!0,d.removeAllListeners(),d.close(),w&&clearTimeout(w),u(c))}return new Promise(c=>{w=setTimeout(()=>{m(0,c)},$),d.on("listening",()=>{m(P,c)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&l<b?(P++,l++,d.listen(P,A)):m(0,c)}),d.on("close",()=>{m(0,c)}),d.listen(P,A)})}e.$7e=S;function I(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(b){console.error(b)}}}),define(we[103],be([1,0,26,7,21]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=void 0;const S=/^\d+$/,I=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var b;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(b||(b={}));let $;switch(process.arch){case"ia32":$=1;break;case"arm":case"arm64":$=2;break;default:$=0;break}let A;process.env.PROCESSOR_ARCHITEW6432?A=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?A=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?A=1:A=0;class E{constructor(p,t,i){this.exePath=p,this.displayName=t,this.a=i}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:y=!1}={}){return y?$===0?process.env["ProgramFiles(x86)"]||null:A===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function l({useAlternateBitness:y=!1,findPreview:p=!1}={}){const t=w({useAlternateBitness:y});if(!t)return null;const i=R.$8c(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(i))return null;let a=-1,s=null;for(const f of await r.Promises.readdir(i)){let k=-1;if(p){const C=f.indexOf("-");if(C<0)continue;const L=f.substring(0,C);if(!S.test(L)||f.substring(C+1)!=="preview")continue;k=parseInt(L,10)}else{if(!S.test(f))continue;k=parseInt(f,10)}if(k<=a)continue;const D=R.$8c(i,f,"pwsh.exe");await r.SymlinkSupport.existsFile(D)&&(s=D,a=k)}if(!s)return null;const n=t.includes("x86")?" (x86)":"",o=p?" Preview":"";return new E(s,`PowerShell${o}${n}`,!0)}async function d({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const p=R.$8c(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(p))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=y?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const a of await r.Promises.readdir(p))if(t.test(a)){const s=R.$8c(p,a,"pwsh.exe");return new E(s,i)}return null}function m(){const y=R.$8c(v.homedir(),".dotnet","tools","pwsh.exe");return new E(y,".NET Core PowerShell Global Tool")}function c(){const y=R.$8c(process.env.windir,$===1&&A!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(y,"Windows PowerShell",!0)}async function*u(){let y=await l();y&&(yield y),y=await l({useAlternateBitness:!0}),y&&(yield y),y=await d(),y&&(yield y),y=m(),y&&(yield y),y=await l({findPreview:!0}),y&&(yield y),y=await d({findPreview:!0}),y&&(yield y),y=await l({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=c(),y&&(yield y)}async function*h(){for await(const y of u())await y.exists()&&(yield y)}e.$el=h;async function g(){for await(const y of h())return y;return null}e.$fl=g}),define(we[104],be([1,0,7,3,29,59,8,21]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$jl=e.$il=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return S.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return S.TerminateResponseCode}});function b(E=r.env){return E.comspec||"cmd.exe"}e.$il=b;function $(E){let w=[],l=!1;const d=function(m){if(l){w.push(m);return}(!E.send(m,u=>{if(u&&console.error(u),l=!1,w.length>0){const h=w.slice(0);w=[],h.forEach(g=>d(g))}})||R.$d)&&(l=!0)};return{send:d}}e.$jl=$;var A;(function(E){async function w(l,d,m){if(v.$7c(l))return l;if(d===void 0&&(d=r.cwd()),v.$$c(l)!=="."||(m===void 0&&I.$ie(r.env.PATH)&&(m=r.env.PATH.split(v.$fd)),m===void 0||m.length===0))return v.$8c(d,l);async function u(h){if(await P.Promises.exists(h)){let g;try{g=await P.Promises.stat(h)}catch(y){y.message.startsWith("EACCES")&&(g=await P.Promises.lstat(h))}return g?!g.isDirectory():!1}return!1}for(const h of m){let g;if(v.$7c(h)?g=v.$8c(h,l):g=v.$8c(d,h,l),await u(g))return g;let y=g+".com";if(await u(y)||(y=g+".exe",await u(y)))return y}return v.$8c(d,l)}E.findExecutable=w})(A||(e.win32=A={}))}),define(we[105],be([1,0,52,13]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;function r(I){return new Promise((P,b)=>{let $;const A=new Map;function E(l,d,m,c,u){const h=A.get(d);if(l===I||h){const g={name:w(m),cmd:m,pid:l,ppid:d,load:c,mem:u};A.set(l,g),l===I&&($=g),h&&(h.children||(h.children=[]),h.children.push(g),h.children.length>1&&(h.children=h.children.sort((y,p)=>y.pid-p.pid)))}}function w(l){const d=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(c.exec(l))return"electron-crash-reporter";if(u.exec(l))return"winpty-agent";if(h.exec(l))return"conpty-agent";let y=g.exec(l);if(y&&y.length===2)return y[1]==="renderer"?"window":y[1]==="utility"?d.exec(l)?"utility-network-service":"utility-process":y[1]==="extensionHost"?"extension-host":y[1];const p=/[a-zA-Z-]+\.js/g;let t="";do y=p.exec(l),y&&(t+=y+" ");while(y);return t&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${t})`:m.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,m)=>{le(["@vscode/windows-process-tree"],d,m)}).then(d=>{d.getProcessList(I,m=>{if(!m){b(new Error(`Root process ${I} not found`));return}d.getProcessCpuUsage(m,c=>{const u=new Map;c.forEach(h=>{const g=l(h.commandLine||"");u.set(h.pid,{name:w(g),cmd:g,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),$=u.get(I),$?(u.forEach(h=>{const g=u.get(h.ppid);g&&(g.children||(g.children=[]),g.children.push(h))}),u.forEach(h=>{h.children&&(h.children=h.children.sort((g,y)=>g.pid-y.pid))}),P($)):b(new Error(`Root process ${I} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let l=function(){let d=[$];const m=[];for(;d.length;){const u=d.shift();u&&(m.push(u.pid),u.children&&(d=d.concat(u.children)))}let c=JSON.stringify(R.$1e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+m.join(" "),(0,v.exec)(c,{},(u,h,g)=>{if(u||g)b(u||new Error(g.toString()));else{const y=h.toString().split(`
`);for(let p=0;p<m.length;p++){const t=A.get(m[p]);t.load=parseFloat(y[p])}if(!$){b(new Error(`Root process ${I} not found`));return}P($)}})};(0,v.exec)("which ps",{},(d,m,c)=>{if(d||c)if(process.platform!=="linux")b(d||new Error(c.toString()));else{const u=JSON.stringify(R.$1e.asFileUri("vs/base/node/ps.sh").fsPath);(0,v.exec)(u,{},(h,g,y)=>{h||y?b(h||new Error(y.toString())):(S(g,E),l())})}else{const u=m.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${u} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,y,p)=>{g||p&&!p.includes("screen size is bogus")?b(g||new Error(p.toString())):(S(y,E),process.platform==="linux"?l():$?P($):b(new Error(`Root process ${I} not found`)))})}})}})}e.$kr=r;function S(I,P){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,$=I.toString().split(`
`);for(const A of $){const E=b.exec(A.trim());E&&E.length===6&&P(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(we[106],be([1,0,26,3,103,104]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=void 0;async function I(E,w){return E===1?R.$d?A():S.$il(w):b(E,w)}e.$kl=I;let P=null;function b(E,w){if(R.$f&&E===2||R.$e&&E===3)return"/bin/bash";if(!P){let l;if(R.$d)l="/bin/bash";else{if(l=w.SHELL,!l)try{l=(0,v.userInfo)().shell}catch{}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}P=l}return P}let $=null;async function A(){return $||($=(await(0,r.$fl)()).exePath),$}}),function(){function le(){function e(){return process.uncHostAllowlist}function v(b){const $=new Set;if(Array.isArray(b))for(const A of b)typeof A=="string"&&$.add(A);return Array.from($)}function R(){const b=e();return b?Array.from(b):[]}function r(b){if(process.platform!=="win32")return;const $=e();if($)if(typeof b=="string")$.add(b.toLowerCase());else for(const A of v(b))r(A)}function S(b){if(typeof b!="string")return;const $=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let A;for(const E of $){if(b.indexOf(E)!==0)continue;const l=b.indexOf("\\",E.length);if(l===-1)continue;const d=b.substring(E.length,l);if(d){A=d;break}}return A}function I(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:r,getUNCHost:S,disableUNCAccessRestrictions:I,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return le()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=le():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Le=this&&this.__decorate||function(le,e,v,R){var r=arguments.length,S=r<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(le,e,v,R);else for(var P=le.length-1;P>=0;P--)(I=le[P])&&(S=(r<3?I(S):r>3?I(e,v,S):I(e,v))||S);return r>3&&S&&Object.defineProperty(e,v,S),S};define(we[42],be([1,0,18,14,15,20,73,11,5,2,50,17,8]),function(le,e,v,R,r,S,I,P,b,$,A,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.ProxyChannel=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.RequestInitiator=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=void 0;var l;(function(K){K[K.Promise=100]="Promise",K[K.PromiseCancel=101]="PromiseCancel",K[K.EventListen=102]="EventListen",K[K.EventDispose=103]="EventDispose"})(l||(l={}));function d(K){switch(K){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(K){K[K.Initialize=200]="Initialize",K[K.PromiseSuccess=201]="PromiseSuccess",K[K.PromiseError=202]="PromiseError",K[K.PromiseErrorObj=203]="PromiseErrorObj",K[K.EventFire=204]="EventFire"})(m||(m={}));function c(K){switch(K){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(K){K[K.Uninitialized=0]="Uninitialized",K[K.Idle=1]="Idle"})(u||(u={}));function h(K){let Y=0;for(let H=0;;H+=7){const _=K.read(1);if(Y|=(_.buffer[0]&127)<<H,!(_.buffer[0]&128))return Y}}const g=a(0);function y(K,Y){if(Y===0){K.write(g);return}let H=0;for(let ge=Y;ge!==0;ge=ge>>>7)H++;const _=r.$Ec.alloc(H);for(let ge=0;Y!==0;ge++)_.buffer[ge]=Y&127,Y=Y>>>7,Y>0&&(_.buffer[ge]|=128);K.write(_)}class p{constructor(Y){this.b=Y,this.a=0}read(Y){const H=this.b.slice(this.a,this.a+Y);return this.a+=H.byteLength,H}}e.$Zg=p;class t{constructor(){this.a=[]}get buffer(){return r.$Ec.concat(this.a)}write(Y){this.a.push(Y)}}e.$1g=t;var i;(function(K){K[K.Undefined=0]="Undefined",K[K.String=1]="String",K[K.Buffer=2]="Buffer",K[K.VSBuffer=3]="VSBuffer",K[K.Array=4]="Array",K[K.Object=5]="Object",K[K.Int=6]="Int"})(i||(i={}));function a(K){const Y=r.$Ec.alloc(1);return Y.writeUInt8(K,0),Y}const s={Undefined:a(i.Undefined),String:a(i.String),Buffer:a(i.Buffer),VSBuffer:a(i.VSBuffer),Array:a(i.Array),Object:a(i.Object),Uint:a(i.Int)},n=typeof Buffer<"u";function o(K,Y){if(typeof Y>"u")K.write(s.Undefined);else if(typeof Y=="string"){const H=r.$Ec.fromString(Y);K.write(s.String),y(K,H.byteLength),K.write(H)}else if(n&&Buffer.isBuffer(Y)){const H=r.$Ec.wrap(Y);K.write(s.Buffer),y(K,H.byteLength),K.write(H)}else if(Y instanceof r.$Ec)K.write(s.VSBuffer),y(K,Y.byteLength),K.write(Y);else if(Array.isArray(Y)){K.write(s.Array),y(K,Y.length);for(const H of Y)o(K,H)}else if(typeof Y=="number"&&(Y|0)===Y)K.write(s.Uint),y(K,Y);else{const H=r.$Ec.fromString(JSON.stringify(Y));K.write(s.Object),y(K,H.byteLength),K.write(H)}}e.$2g=o;function f(K){switch(K.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return K.read(h(K)).toString();case i.Buffer:return K.read(h(K)).buffer;case i.VSBuffer:return K.read(h(K));case i.Array:{const H=h(K),_=[];for(let ge=0;ge<H;ge++)_.push(f(K));return _}case i.Object:return JSON.parse(K.read(h(K)).toString());case i.Int:return h(K)}}e.$3g=f;class k{constructor(Y,H,_=null,ge=1e3){this.h=Y,this.j=H,this.k=_,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:200})}registerChannel(Y,H){this.b.set(Y,H),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const H=this.o([Y.type]);this.k?.logOutgoing(H,0,1,c(Y.type));return}case 201:case 202:case 204:case 203:{const H=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(H,Y.id,1,c(Y.type),Y.data);return}}}o(Y,H=void 0){const _=new t;return o(_,Y),o(_,H),this.p(_.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const H=new p(Y),_=f(H),ge=f(H),ne=_[0];switch(ne){case 100:return this.k?.logIncoming(Y.byteLength,_[1],1,`${d(ne)}: ${_[2]}.${_[3]}`,ge),this.s({type:ne,id:_[1],channelName:_[2],name:_[3],arg:ge});case 102:return this.k?.logIncoming(Y.byteLength,_[1],1,`${d(ne)}: ${_[2]}.${_[3]}`,ge),this.t({type:ne,id:_[1],channelName:_[2],name:_[3],arg:ge});case 101:return this.k?.logIncoming(Y.byteLength,_[1],1,`${d(ne)}`),this.u({type:ne,id:_[1]});case 103:return this.k?.logIncoming(Y.byteLength,_[1],1,`${d(ne)}`),this.u({type:ne,id:_[1]})}}s(Y){const H=this.b.get(Y.channelName);if(!H){this.v(Y);return}const _=new S.$oc;let ge;try{ge=H.call(this.j,Y.name,Y.arg,_.token)}catch(X){ge=Promise.reject(X)}const ne=Y.id;ge.then(X=>{this.m({id:ne,data:X,type:201}),this.d.delete(Y.id)},X=>{X instanceof Error?this.m({id:ne,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.m({id:ne,data:X,type:203}),this.d.delete(Y.id)});const q=(0,$.$jb)(()=>_.cancel());this.d.set(Y.id,q)}t(Y){const H=this.b.get(Y.channelName);if(!H){this.v(Y);return}const _=Y.id,ne=H.listen(this.j,Y.name,Y.arg)(q=>this.m({id:_,data:q,type:204}));this.d.set(Y.id,ne)}u(Y){const H=this.d.get(Y.id);H&&(H.dispose(),this.d.delete(Y.id))}v(Y){let H=this.g.get(Y.channelName);H||(H=[],this.g.set(Y.channelName,H));const _=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:Y,timeoutTimer:_})}w(Y){const H=this.g.get(Y);if(H){for(const _ of H)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.s(_.request);break;case 102:this.t(_.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$gb)(this.d.values()),this.d.clear()}}e.$4g=k;var D;(function(K){K[K.LocalSide=0]="LocalSide",K[K.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class C{constructor(Y,H=null){this.l=Y,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$ec,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=H}getChannel(Y){const H=this;return{call(_,ge,ne){return H.a?Promise.reject(new P.$3):H.m(Y,_,ge,ne)},listen(_,ge){return H.a?b.Event.None:H.o(Y,_,ge)}}}m(Y,H,_,ge=S.CancellationToken.None){const ne=this.g++,X={id:ne,type:100,channelName:Y,name:H,arg:_};if(ge.isCancellationRequested)return Promise.reject(new P.$3);let O;return new Promise((J,ie)=>{if(ge.isCancellationRequested)return ie(new P.$3);const re=()=>{const z=j=>{switch(j.type){case 201:this.f.delete(ne),J(j.data);break;case 202:{this.f.delete(ne);const B=new Error(j.data.message);B.stack=Array.isArray(j.data.stack)?j.data.stack.join(`
`):j.data.stack,B.name=j.data.name,ie(B);break}case 203:this.f.delete(ne),ie(j.data);break}};this.f.set(ne,z),this.p(X)};let ee=null;this.b===u.Idle?re():(ee=(0,R.$ig)(z=>this.u()),ee.then(()=>{ee=null,re()}));const oe=()=>{ee?(ee.cancel(),ee=null):this.p({id:ne,type:101}),ie(new P.$3)},F=ge.onCancellationRequested(oe);O=(0,$.$ib)((0,$.$jb)(oe),F),this.d.add(O)}).finally(()=>{this.d.delete(O)})}o(Y,H,_){const ge=this.g++,q={id:ge,type:102,channelName:Y,name:H,arg:_};let X=null;const O=new b.$ec({onWillAddFirstListener:()=>{X=(0,R.$ig)(J=>this.u()),X.then(()=>{X=null,this.d.add(O),this.p(q)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(O),this.p({id:ge,type:103}))}}),N=J=>O.fire(J.data);return this.f.set(ge,N),O.event}p(Y){switch(Y.type){case 100:case 102:{const H=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(H,Y.id,0,`${d(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const H=this.q([Y.type,Y.id]);this.j?.logOutgoing(H,Y.id,0,d(Y.type));return}}}q(Y,H=void 0){const _=new t;return o(_,Y),o(_,H),this.r(_.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const H=new p(Y),_=f(H),ge=f(H),ne=_[0];switch(ne){case 200:return this.j?.logIncoming(Y.byteLength,0,0,c(ne)),this.t({type:_[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,_[1],0,c(ne),ge),this.t({type:_[0],id:_[1],data:ge})}}t(Y){if(Y.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$gb)(this.d.values()),this.d.clear()}}e.$5g=C,Le([I.$Tg],C.prototype,"onDidInitializePromise",null);class L{get connections(){const Y=[];return this.f.forEach(H=>Y.push(H)),Y}constructor(Y){this.a=new Map,this.f=new Set,this.g=new b.$ec,this.onDidAddConnection=this.g.event,this.h=new b.$ec,this.onDidRemoveConnection=this.h.event,Y(({protocol:H,onDidClientDisconnect:_})=>{b.Event.once(H.onMessage)(ne=>{const q=new p(ne),X=f(q),O=new k(H,X),N=new C(H);this.a.forEach((ie,re)=>O.registerChannel(re,ie));const J={channelServer:O,channelClient:N,ctx:X};this.f.add(J),this.g.fire(J),_(()=>{O.dispose(),N.dispose(),this.f.delete(J),this.h.fire(J)})})})}getChannel(Y,H){const _=this;return{call(ge,ne,q){let X;if((0,w.$we)(H)){const N=(0,v.$Hf)(_.connections.filter(H));X=N?Promise.resolve(N):b.Event.toPromise(b.Event.filter(_.onDidAddConnection,H))}else X=H.routeCall(_,ge,ne);const O=X.then(N=>N.channelClient.getChannel(Y));return x(O).call(ge,ne,q)},listen(ge,ne){if((0,w.$we)(H))return _.j(Y,H,ge,ne);const q=H.routeEvent(_,ge,ne).then(X=>X.channelClient.getChannel(Y));return x(q).listen(ge,ne)}}}j(Y,H,_,ge){const ne=this;let q=new $.$kb;const X=new b.$ec({onWillAddFirstListener:()=>{q=new $.$kb;const O=new b.$kc,N=new Map,J=re=>{const oe=re.channelClient.getChannel(Y).listen(_,ge),F=O.add(oe);N.set(re,F)},ie=re=>{const ee=N.get(re);ee&&(ee.dispose(),N.delete(re))};ne.connections.filter(H).forEach(J),b.Event.filter(ne.onDidAddConnection,H)(J,void 0,q),ne.onDidRemoveConnection(ie,void 0,q),O.event(X.fire,X,q),q.add(O)},onDidRemoveLastListener:()=>{q.dispose()}});return X.event}registerChannel(Y,H){this.a.set(Y,H),this.f.forEach(_=>{_.channelServer.registerChannel(Y,H)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$6g=L;class U{constructor(Y,H,_=null){const ge=new t;o(ge,H),Y.send(ge.buffer),this.a=new C(Y,_),this.d=new k(Y,H,_)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,H){this.d.registerChannel(Y,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$7g=U;function x(K){return{call(Y,H,_){return K.then(ge=>ge.call(Y,H,_))},listen(Y,H){const _=new b.$nc;return K.then(ge=>_.input=ge.listen(Y,H)),_.event}}}e.$8g=x;function ae(K){let Y=!1;return{call(H,_,ge){return Y?K.call(H,_,ge):(0,R.$vg)(0).then(()=>Y=!0).then(()=>K.call(H,_,ge))},listen(H,_){if(Y)return K.listen(H,_);const ge=new b.$nc;return(0,R.$vg)(0).then(()=>Y=!0).then(()=>ge.input=K.listen(H,_)),ge.event}}}e.$9g=ae;class W{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const H of Y.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await b.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$0g=W;var te;(function(K){function Y(ne,q){const X=ne,O=q&&q.disableMarshalling,N=new Map;for(const J in X)_(J)&&N.set(J,b.Event.buffer(X[J],!0));return new class{listen(J,ie,re){const ee=N.get(ie);if(ee)return ee;if(ge(ie)){const oe=X[ie];if(typeof oe=="function")return oe.call(X,re)}throw new P.$ab(`Event not found: ${ie}`)}call(J,ie,re){const ee=X[ie];if(typeof ee=="function"){if(!O&&Array.isArray(re))for(let oe=0;oe<re.length;oe++)re[oe]=(0,A.$Yg)(re[oe]);return ee.apply(X,re)}throw new P.$ab(`Method not found: ${ie}`)}}}K.fromService=Y;function H(ne,q){const X=q&&q.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return q?.properties?.has(N)?q.properties.get(N):ge(N)?function(J){return ne.listen(N,J)}:_(N)?ne.listen(N):async function(...J){let ie;q&&!(0,w.$re)(q.context)?ie=[q.context,...J]:ie=J;const re=await ne.call(N,ie);return X?re:(0,A.$Yg)(re)};throw new P.$ab(`Property not found: ${String(N)}`)}})}K.toService=H;function _(ne){return ne[0]==="o"&&ne[1]==="n"&&E.$Kd(ne.charCodeAt(2))}function ge(ne){return/^onDynamic/.test(ne)&&E.$Kd(ne.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Z(K){if(Array.isArray(K))return K;if(K&&typeof K=="object"&&typeof K.toString=="function"){const Y=K.toString();if(Y!=="[object Object]")return Y}return K}function he(K){return Array.isArray(K)?K.map(Z):Z(K)}function V(K,Y,H,_,ge,ne,q){q=he(q);const X=ue[ge],O=X[_%X.length];let N=[`%c[${K}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(ne)?(N=N.concat(q),N.push(")")):N.push(q),console.log.apply(console,N)}class se{constructor(Y,H){this.d=Y,this.f=H,this.a=0,this.b=0}logOutgoing(Y,H,_,ge,ne){this.b+=Y,V(this.d,this.b,Y,H,_,ge,ne)}logIncoming(Y,H,_,ge,ne){this.a+=Y,V(this.f,this.a,Y,H,_,ge,ne)}}e.$$g=se}),define(we[107],be([1,0,15,5,2,42]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.$ah=e.ProtocolConstants=e.$_g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var P;(function(s){s.enableDiagnostics=!1,s.records=[];const n=new WeakMap;let o=0;function f(D,C){if(!n.has(D)){const L=String(++o);n.set(D,L)}return n.get(D)}function k(D,C,L,U){if(!s.enableDiagnostics)return;const x=f(D,C);if(U instanceof v.$Ec||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const ae=v.$Ec.alloc(U.byteLength);ae.set(U),s.records.push({timestamp:Date.now(),id:x,label:C,type:L,buff:ae})}else s.records.push({timestamp:Date.now(),id:x,label:C,type:L,data:U})}s.traceSocketEvent=k})(P||(e.SocketDiagnostics=P={}));var b;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let $=null;function A(){return $||($=v.$Ec.alloc(0)),$}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return A();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const C=this.a[0];return o&&(this.a.shift(),this.b-=n),C}if(this.a[0].byteLength>n){const C=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),C}const f=v.$Ec.alloc(n);let k=0,D=0;for(;n>0;){const C=this.a[D];if(C.byteLength>n){const L=C.slice(0,n);f.set(L,k),k+=n,o&&(this.a[D]=C.slice(n),this.b-=n),n-=n}else f.set(C,k),k+=C.byteLength,o?(this.a.shift(),this.b-=C.byteLength):D++,n-=C.byteLength}return f}}e.$_g=E;var w;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(w||(w={}));function l(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class m{constructor(n,o,f,k){this.type=n,this.id=o,this.ack=f,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends r.$lb{constructor(n){super(),this.f=this.B(new R.$ec),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new E,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,k=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new m(f,k,D,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=v.$Ec.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(o,n.data)}g(n,o){const f=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,f}h(){const n=v.$Ec.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends r.$lb{constructor(n){super(),this.f=new R.$ec,this.onMessage=this.f.event,this.g=new R.$ec,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new u(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$ah=h;class g extends S.$7g{static fromSocket(n,o){return new g(new h(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,f=null){super(n,o,f),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$bh=g;class y{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$ec({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$ch=y;class p{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,f=this.a;for(;f;)n[o++]=f.data,f=f.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new p(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<i.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=i.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+i.a)*1e3;let f=0;for(let k=0;k<i.a;k++)n-this.c[k]<=o&&f++;return 1-f/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;class a{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new y,this.onControlMessage=this.u.event,this.v=new y,this.onMessage=this.v.event,this.w=new y,this.onDidDispose=this.w.event,this.x=new y,this.onSocketClose=this.x.event,this.y=new y,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??i.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$kb,this.o=n.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,A());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,A());this.p.write(n)}sendResume(){const n=new m(8,0,0,A());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new r.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,A());this.p.write(n);const o=this.b.toArray();for(let f=0,k=o.length;f<k;f++)this.p.write(o[f]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new m(6,0,0,A())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let f=0,k=o.length;f<k;f++)this.p.write(o[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const f=new m(1,o,this.h,n);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(n){const o=new m(2,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,f=Date.now()-this.q.lastReadTime,k=Date.now()-this.n;if(o>=2e4&&f>=2e4&&k>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:f});return}const D=Math.max(2e4-o,2e4-f,2e4-k,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,A());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,A());this.p.write(n)}}e.$dh=a}),define(we[108],be([1,0,52,14,15,20,149,11,5,2,22,104,59,42]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=void 0;class d extends l.$4g{constructor(u){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",h=>r.$Ec.wrap(Buffer.from(h,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Jp=d;class m{constructor(u,h){this.i=u,this.j=h,this.c=new Set,this.g=new Map,this.h=new b.$ec,this.onDidProcessExit=this.h.event;const g=h&&h.timeout?h.timeout:6e4;this.b=new R.$rg(g),this.d=null,this.f=null}getChannel(u){const h=this;return{call(g,y,p){return h.k(u,g,y,p)},listen(g,y){return h.l(u,g,y)}}}k(u,h,g,y=S.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(P.$4());this.b.cancel();const p=this.n(u),t=(0,R.$ig)(s=>p.call(h,g,s)),i=y.onCancellationRequested(()=>t.cancel()),a=(0,$.$jb)(()=>t.cancel());return this.c.add(a),t.finally(()=>{i.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,h,g){if(!this.b)return b.Event.None;this.b.cancel();let y;const p=new b.$ec({onWillAddFirstListener:()=>{y=this.n(u).listen(h,g)(p.fire,p),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return p.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,A.$Jm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,w.$hl)(h.env),this.d=(0,v.fork)(this.i,u,h);const g=new b.$ec;b.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,I.$Fp)(n)){(0,I.log)(n,`IPC Library: ${this.j.serverName}`);return}g.fire(r.$Ec.wrap(Buffer.from(n,"base64")))});const p=this.j.useQueue?(0,E.$jl)(this.d):this.d,t=n=>this.d&&this.d.connected&&p.send(n.buffer.toString("base64")),i=g.event,a={send:t,onMessage:i};this.f=new l.$5g(a);const s=()=>this.o();process.once("exit",s),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",s),this.c.forEach(f=>(0,$.$gb)(f)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(u){let h=this.g.get(u);return h||(h=this.m.getChannel(u),this.g.set(u,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Kp=m}),define(we[158],be([1,0,14,5,2,50,8]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.StorageState=e.$Io=e.StorageHint=void 0;var P;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function b(w){const l=w;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$Io=b;var $;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})($||(e.StorageState=$={}));class A extends r.$lb{constructor(l,d=Object.create(null)){super(),this.m=l,this.n=d,this.b=this.B(new R.$hc),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=new v.$sg(A.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(l=>this.r(l)))}r(l){this.b.pause();try{l.changed?.forEach((d,m)=>this.s(m,d)),l.deleted?.forEach(d=>this.s(d,void 0))}finally{this.b.resume()}}s(l,d){if(this.c===$.Closed)return;let m=!1;(0,I.$re)(d)?m=this.f.delete(l):this.f.get(l)!==d&&(this.f.set(l,d),m=!0),m&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.n.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(l,d){const m=this.f.get(l);return(0,I.$re)(m)?d:m}getBoolean(l,d){const m=this.get(l);return(0,I.$re)(m)?d:m==="true"}getNumber(l,d){const m=this.get(l);return(0,I.$re)(m)?d:parseInt(m,10)}getObject(l,d){const m=this.get(l);return(0,I.$re)(m)?d:(0,S.$Xg)(m)}async set(l,d,m=!1){if(this.c===$.Closed)return;if((0,I.$re)(d))return this.delete(l,m);const c=(0,I.$ke)(d)||Array.isArray(d)?(0,S.$Wg)(d):String(d);if(this.f.get(l)!==c)return this.f.set(l,c),this.j.set(l,c),this.h.delete(l),this.b.fire({key:l,external:m}),this.w()}async delete(l,d=!1){if(!(this.c===$.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:d}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=$.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(l).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(l){if(this.u)return this.w(l)}async w(l){return this.g.trigger(()=>this.v(),l)}async whenFlushed(){if(this.u)return new Promise(l=>this.l.push(l))}isInMemory(){return this.n.hint===P.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Jo=A,A.a=100;class E{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((d,m)=>this.a.set(m,d)),l.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.$Ko=E}),define(we[109],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0;class v{constructor(r,S){this.lineNumber=r,this.column=S}with(r=this.lineNumber,S=this.column){return r===this.lineNumber&&S===this.column?this:new v(r,S)}delta(r=0,S=0){return this.with(this.lineNumber+r,this.column+S)}equals(r){return v.equals(this,r)}static equals(r,S){return!r&&!S?!0:!!r&&!!S&&r.lineNumber===S.lineNumber&&r.column===S.column}isBefore(r){return v.isBefore(this,r)}static isBefore(r,S){return r.lineNumber<S.lineNumber?!0:S.lineNumber<r.lineNumber?!1:r.column<S.column}isBeforeOrEqual(r){return v.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,S){return r.lineNumber<S.lineNumber?!0:S.lineNumber<r.lineNumber?!1:r.column<=S.column}static compare(r,S){const I=r.lineNumber|0,P=S.lineNumber|0;if(I===P){const b=r.column|0,$=S.column|0;return b-$}return I-P}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new v(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}e.$Ur=v}),define(we[43],be([1,0,109]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=void 0;class R{constructor(S,I,P,b){S>P||S===P&&I>b?(this.startLineNumber=P,this.startColumn=b,this.endLineNumber=S,this.endColumn=I):(this.startLineNumber=S,this.startColumn=I,this.endLineNumber=P,this.endColumn=b)}isEmpty(){return R.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return R.containsPosition(this,S)}static containsPosition(S,I){return!(I.lineNumber<S.startLineNumber||I.lineNumber>S.endLineNumber||I.lineNumber===S.startLineNumber&&I.column<S.startColumn||I.lineNumber===S.endLineNumber&&I.column>S.endColumn)}static strictContainsPosition(S,I){return!(I.lineNumber<S.startLineNumber||I.lineNumber>S.endLineNumber||I.lineNumber===S.startLineNumber&&I.column<=S.startColumn||I.lineNumber===S.endLineNumber&&I.column>=S.endColumn)}containsRange(S){return R.containsRange(this,S)}static containsRange(S,I){return!(I.startLineNumber<S.startLineNumber||I.endLineNumber<S.startLineNumber||I.startLineNumber>S.endLineNumber||I.endLineNumber>S.endLineNumber||I.startLineNumber===S.startLineNumber&&I.startColumn<S.startColumn||I.endLineNumber===S.endLineNumber&&I.endColumn>S.endColumn)}strictContainsRange(S){return R.strictContainsRange(this,S)}static strictContainsRange(S,I){return!(I.startLineNumber<S.startLineNumber||I.endLineNumber<S.startLineNumber||I.startLineNumber>S.endLineNumber||I.endLineNumber>S.endLineNumber||I.startLineNumber===S.startLineNumber&&I.startColumn<=S.startColumn||I.endLineNumber===S.endLineNumber&&I.endColumn>=S.endColumn)}plusRange(S){return R.plusRange(this,S)}static plusRange(S,I){let P,b,$,A;return I.startLineNumber<S.startLineNumber?(P=I.startLineNumber,b=I.startColumn):I.startLineNumber===S.startLineNumber?(P=I.startLineNumber,b=Math.min(I.startColumn,S.startColumn)):(P=S.startLineNumber,b=S.startColumn),I.endLineNumber>S.endLineNumber?($=I.endLineNumber,A=I.endColumn):I.endLineNumber===S.endLineNumber?($=I.endLineNumber,A=Math.max(I.endColumn,S.endColumn)):($=S.endLineNumber,A=S.endColumn),new R(P,b,$,A)}intersectRanges(S){return R.intersectRanges(this,S)}static intersectRanges(S,I){let P=S.startLineNumber,b=S.startColumn,$=S.endLineNumber,A=S.endColumn;const E=I.startLineNumber,w=I.startColumn,l=I.endLineNumber,d=I.endColumn;return P<E?(P=E,b=w):P===E&&(b=Math.max(b,w)),$>l?($=l,A=d):$===l&&(A=Math.min(A,d)),P>$||P===$&&b>A?null:new R(P,b,$,A)}equalsRange(S){return R.equalsRange(this,S)}static equalsRange(S,I){return!S&&!I?!0:!!S&&!!I&&S.startLineNumber===I.startLineNumber&&S.startColumn===I.startColumn&&S.endLineNumber===I.endLineNumber&&S.endColumn===I.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(S){return new v.$Ur(S.endLineNumber,S.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(S){return new v.$Ur(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,I){return new R(this.startLineNumber,this.startColumn,S,I)}setStartPosition(S,I){return new R(S,I,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(S){return new R(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(S){return new R(S.endLineNumber,S.endColumn,S.endLineNumber,S.endColumn)}delta(S){return new R(this.startLineNumber+S,this.startColumn,this.endLineNumber+S,this.endColumn)}static fromPositions(S,I=S){return new R(S.lineNumber,S.column,I.lineNumber,I.column)}static lift(S){return S?new R(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,I){return!(S.endLineNumber<I.startLineNumber||S.endLineNumber===I.startLineNumber&&S.endColumn<I.startColumn||I.endLineNumber<S.startLineNumber||I.endLineNumber===S.startLineNumber&&I.endColumn<S.startColumn)}static areIntersecting(S,I){return!(S.endLineNumber<I.startLineNumber||S.endLineNumber===I.startLineNumber&&S.endColumn<=I.startColumn||I.endLineNumber<S.startLineNumber||I.endLineNumber===S.startLineNumber&&I.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,I){if(S&&I){const $=S.startLineNumber|0,A=I.startLineNumber|0;if($===A){const E=S.startColumn|0,w=I.startColumn|0;if(E===w){const l=S.endLineNumber|0,d=I.endLineNumber|0;if(l===d){const m=S.endColumn|0,c=I.endColumn|0;return m-c}return l-d}return E-w}return $-A}return(S?1:0)-(I?1:0)}static compareRangesUsingEnds(S,I){return S.endLineNumber===I.endLineNumber?S.endColumn===I.endColumn?S.startLineNumber===I.startLineNumber?S.startColumn-I.startColumn:S.startLineNumber-I.startLineNumber:S.endColumn-I.endColumn:S.endLineNumber-I.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}toJSON(){return this}}e.$Vr=R}),define(we[159],be([1,0,43]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;class R{static insert(S,I){return{range:new v.$Vr(S.lineNumber,S.column,S.lineNumber,S.column),text:I,forceMoveMarkers:!0}}static delete(S){return{range:S,text:null}}static replace(S,I){return{range:S,text:I}}static replaceMove(S,I){return{range:S,text:I,forceMoveMarkers:!0}}}e.$3r=R}),define(we[160],be([1,0,5,2]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new v.$ec,this.onDidChange=this.c.event,this.d=null}handleChange(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,b){return this.a.set(P,b),this.handleChange([P]),(0,R.$jb)(()=>{this.a.get(P)===b&&(this.a.delete(P),this.handleChange([P]))})}get(P){return this.a.get(P)||null}registerFactory(P,b){this.b.get(P)?.dispose();const $=new S(this,P,b);return this.b.set(P,$),(0,R.$jb)(()=>{const A=this.b.get(P);!A||A!==$||(this.b.delete(P),A.dispose())})}async getOrCreate(P){const b=this.get(P);if(b)return b;const $=this.b.get(P);return!$||$.isResolved?null:(await $.resolve(),this.get(P))}isResolved(P){if(this.get(P))return!0;const $=this.b.get(P);return!!(!$||$.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ls=r;class S extends R.$lb{get isResolved(){return this.c}constructor(P,b,$){super(),this.f=P,this.g=b,this.h=$,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await this.h.tokenizationSupport;this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(we[161],be([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(we[162],be([1,0,5,2,161]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class S extends R.$lb{constructor(w,l="",d="",m=!0,c){super(),this.h=this.B(new v.$ec),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=l,this.u=d,this.w=m,this.C=c}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,l){this.C&&await this.C(w)}}e.$7h=S;class I extends R.$lb{constructor(){super(...arguments),this.f=this.B(new v.$ec),this.onWillRun=this.f.event,this.k=this.B(new v.$ec),this.onDidRun=this.k.event}async run(w,l){if(!w.enabled)return;this.f.fire({action:w});let d;try{await this.l(w,l)}catch(m){d=m}this.k.fire({action:w,error:d})}async l(w,l){await w.run(l)}}e.$8h=I;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let l=[];for(const d of w)d.length&&(l.length?l=[...l,new P,...d]:l=d);return l}async run(){}}e.$9h=P,P.ID="vs.actions.separator";class b{get actions(){return this.a}constructor(w,l,d,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=l,this.class=m,this.a=d}async run(){}}e.$0h=b;class $ extends S{constructor(){super($.ID,r.localize(0,null),void 0,!1)}}e.$$h=$,$.ID="vs.actions.empty";function A(E){return{id:E.id,label:E.label,class:void 0,enabled:E.enabled??!0,checked:E.checked??!1,run:async()=>E.run(),tooltip:E.label}}e.$_h=A}),define(we[163],be([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(we[164],be([1,0,163]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=void 0;const R=60,r=R*60,S=r*24,I=S*7,P=S*30,b=S*365;function $(E,w,l,d){typeof E!="number"&&(E=E.getTime());const m=Math.round((new Date().getTime()-E)/1e3);if(m<-30)return(0,v.localize)(0,null,$(new Date().getTime()+m*1e3,!1));if(!d&&m<30)return(0,v.localize)(1,null);let c;return m<R?(c=m,w?c===1?l?(0,v.localize)(2,null,c):(0,v.localize)(3,null,c):l?(0,v.localize)(4,null,c):(0,v.localize)(5,null,c):c===1?l?(0,v.localize)(6,null,c):(0,v.localize)(7,null,c):l?(0,v.localize)(8,null,c):(0,v.localize)(9,null,c)):m<r?(c=Math.floor(m/R),w?c===1?l?(0,v.localize)(10,null,c):(0,v.localize)(11,null,c):l?(0,v.localize)(12,null,c):(0,v.localize)(13,null,c):c===1?l?(0,v.localize)(14,null,c):(0,v.localize)(15,null,c):l?(0,v.localize)(16,null,c):(0,v.localize)(17,null,c)):m<S?(c=Math.floor(m/r),w?c===1?l?(0,v.localize)(18,null,c):(0,v.localize)(19,null,c):l?(0,v.localize)(20,null,c):(0,v.localize)(21,null,c):c===1?l?(0,v.localize)(22,null,c):(0,v.localize)(23,null,c):l?(0,v.localize)(24,null,c):(0,v.localize)(25,null,c)):m<I?(c=Math.floor(m/S),w?c===1?(0,v.localize)(26,null,c):(0,v.localize)(27,null,c):c===1?(0,v.localize)(28,null,c):(0,v.localize)(29,null,c)):m<P?(c=Math.floor(m/I),w?c===1?l?(0,v.localize)(30,null,c):(0,v.localize)(31,null,c):l?(0,v.localize)(32,null,c):(0,v.localize)(33,null,c):c===1?l?(0,v.localize)(34,null,c):(0,v.localize)(35,null,c):l?(0,v.localize)(36,null,c):(0,v.localize)(37,null,c)):m<b?(c=Math.floor(m/P),w?c===1?l?(0,v.localize)(38,null,c):(0,v.localize)(39,null,c):l?(0,v.localize)(40,null,c):(0,v.localize)(41,null,c):c===1?l?(0,v.localize)(42,null,c):(0,v.localize)(43,null,c):l?(0,v.localize)(44,null,c):(0,v.localize)(45,null,c)):(c=Math.floor(m/b),w?c===1?l?(0,v.localize)(46,null,c):(0,v.localize)(47,null,c):l?(0,v.localize)(48,null,c):(0,v.localize)(49,null,c):c===1?l?(0,v.localize)(50,null,c):(0,v.localize)(51,null,c):l?(0,v.localize)(52,null,c):(0,v.localize)(53,null,c))}e.$Tl=$;function A(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ul=A}),define(we[165],be([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(we[39],be([1,0,18,8,165]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function S(E,w){return w&&(E.stack||E.stacktrace)?r.localize(0,null,P(E),I(E.stack)||I(E.stacktrace)):P(E)}function I(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?r.localize(1,null,E.message):E.message||r.localize(2,null)}function b(E=null,w=!1){if(!E)return r.localize(3,null);if(Array.isArray(E)){const l=v.$jf(E),d=b(l[0],w);return l.length>1?r.localize(4,null,d,l.length):d}if(R.$ie(E))return E;if(E.detail){const l=E.detail;if(l.error)return S(l.error,w);if(l.exception)return S(l.exception,w)}return E.stack?S(E,w):E.message?E.message:r.localize(5,null)}e.$ai=b;function $(E){const w=E;return w instanceof Error&&Array.isArray(w.actions)}e.$bi=$;function A(E,w){let l;return typeof E=="string"?l=new Error(E):l=E,l.actions=w,l}e.$ci=A}),define(we[166],be([9,10]),function(le,e){return le.create("vs/base/common/jsonErrorMessages",e)}),define(we[167],be([1,0,166]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;function R(r){switch(r){case 1:return(0,v.localize)(0,null);case 2:return(0,v.localize)(1,null);case 3:return(0,v.localize)(2,null);case 4:return(0,v.localize)(3,null);case 5:return(0,v.localize)(4,null);case 6:return(0,v.localize)(5,null);case 7:return(0,v.localize)(6,null);case 8:return(0,v.localize)(7,null);case 9:return(0,v.localize)(8,null);default:return""}}e.$ep=R}),define(we[168],be([9,10]),function(le,e){return le.create("vs/base/node/zip",e)}),define(we[169],be([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(we[170],be([1,0,49,4,159,43,160,169]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Ds=e.$Cs=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Bs=e.$As=e.SymbolKinds=e.SymbolTag=e.$zs=e.$ys=e.SymbolKind=e.$xs=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$ws=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$vs=e.$us=e.$ts=void 0;class b{constructor(te,ue,Z){this.offset=te,this.type=ue,this.language=Z,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ts=b;class ${constructor(te,ue){this.tokens=te,this.endState=ue,this._tokenizationResultBrand=void 0}}e.$us=$;class A{constructor(te,ue){this.tokens=te,this.endState=ue,this._encodedTokenizationResultBrand=void 0}}e.$vs=A;var E;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(E||(e.CompletionItemKind=E={}));var w;(function(W){const te=new Map;te.set(0,v.$Cj.symbolMethod),te.set(1,v.$Cj.symbolFunction),te.set(2,v.$Cj.symbolConstructor),te.set(3,v.$Cj.symbolField),te.set(4,v.$Cj.symbolVariable),te.set(5,v.$Cj.symbolClass),te.set(6,v.$Cj.symbolStruct),te.set(7,v.$Cj.symbolInterface),te.set(8,v.$Cj.symbolModule),te.set(9,v.$Cj.symbolProperty),te.set(10,v.$Cj.symbolEvent),te.set(11,v.$Cj.symbolOperator),te.set(12,v.$Cj.symbolUnit),te.set(13,v.$Cj.symbolValue),te.set(15,v.$Cj.symbolEnum),te.set(14,v.$Cj.symbolConstant),te.set(15,v.$Cj.symbolEnum),te.set(16,v.$Cj.symbolEnumMember),te.set(17,v.$Cj.symbolKeyword),te.set(27,v.$Cj.symbolSnippet),te.set(18,v.$Cj.symbolText),te.set(19,v.$Cj.symbolColor),te.set(20,v.$Cj.symbolFile),te.set(21,v.$Cj.symbolReference),te.set(22,v.$Cj.symbolCustomColor),te.set(23,v.$Cj.symbolFolder),te.set(24,v.$Cj.symbolTypeParameter),te.set(25,v.$Cj.account),te.set(26,v.$Cj.issues);function ue(V){let se=te.get(V);return se||(console.info("No codicon found for CompletionItemKind "+V),se=v.$Cj.symbolProperty),se}W.toIcon=ue;const Z=new Map;Z.set("method",0),Z.set("function",1),Z.set("constructor",2),Z.set("field",3),Z.set("variable",4),Z.set("class",5),Z.set("struct",6),Z.set("interface",7),Z.set("module",8),Z.set("property",9),Z.set("event",10),Z.set("operator",11),Z.set("unit",12),Z.set("value",13),Z.set("constant",14),Z.set("enum",15),Z.set("enum-member",16),Z.set("enumMember",16),Z.set("keyword",17),Z.set("snippet",27),Z.set("text",18),Z.set("color",19),Z.set("file",20),Z.set("reference",21),Z.set("customcolor",22),Z.set("folder",23),Z.set("type-parameter",24),Z.set("typeParameter",24),Z.set("account",25),Z.set("issue",26);function he(V,se){let K=Z.get(V);return typeof K>"u"&&!se&&(K=9),K}W.fromString=he})(w||(e.CompletionItemKinds=w={}));var l;(function(W){W[W.Deprecated=1]="Deprecated"})(l||(e.CompletionItemTag=l={}));var d;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(d||(e.CompletionItemInsertTextRule=d={}));var m;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var c;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(c||(e.InlineCompletionTriggerKind=c={}));class u{constructor(te,ue,Z,he){this.range=te,this.text=ue,this.completionKind=Z,this.isSnippetText=he}equals(te){return S.$Vr.lift(this.range).equalsRange(te.range)&&this.text===te.text&&this.completionKind===te.completionKind&&this.isSnippetText===te.isSnippetText}}e.$ws=u;var h;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(h||(e.CodeActionTriggerType=h={}));var g;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(g||(e.SignatureHelpTriggerKind=g={}));var y;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(y||(e.DocumentHighlightKind=y={}));function p(W){return W&&R.URI.isUri(W.uri)&&S.$Vr.isIRange(W.range)&&(S.$Vr.isIRange(W.originSelectionRange)||S.$Vr.isIRange(W.targetSelectionRange))}e.$xs=p;var t;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$ys={[17]:(0,P.localize)(0,null),[16]:(0,P.localize)(1,null),[4]:(0,P.localize)(2,null),[13]:(0,P.localize)(3,null),[8]:(0,P.localize)(4,null),[9]:(0,P.localize)(5,null),[21]:(0,P.localize)(6,null),[23]:(0,P.localize)(7,null),[7]:(0,P.localize)(8,null),[0]:(0,P.localize)(9,null),[11]:(0,P.localize)(10,null),[10]:(0,P.localize)(11,null),[19]:(0,P.localize)(12,null),[5]:(0,P.localize)(13,null),[1]:(0,P.localize)(14,null),[2]:(0,P.localize)(15,null),[20]:(0,P.localize)(16,null),[15]:(0,P.localize)(17,null),[18]:(0,P.localize)(18,null),[24]:(0,P.localize)(19,null),[3]:(0,P.localize)(20,null),[6]:(0,P.localize)(21,null),[14]:(0,P.localize)(22,null),[22]:(0,P.localize)(23,null),[25]:(0,P.localize)(24,null),[12]:(0,P.localize)(25,null)};function i(W,te){return(0,P.localize)(26,null,W,e.$ys[te])}e.$zs=i;var a;(function(W){W[W.Deprecated=1]="Deprecated"})(a||(e.SymbolTag=a={}));var s;(function(W){const te=new Map;te.set(0,v.$Cj.symbolFile),te.set(1,v.$Cj.symbolModule),te.set(2,v.$Cj.symbolNamespace),te.set(3,v.$Cj.symbolPackage),te.set(4,v.$Cj.symbolClass),te.set(5,v.$Cj.symbolMethod),te.set(6,v.$Cj.symbolProperty),te.set(7,v.$Cj.symbolField),te.set(8,v.$Cj.symbolConstructor),te.set(9,v.$Cj.symbolEnum),te.set(10,v.$Cj.symbolInterface),te.set(11,v.$Cj.symbolFunction),te.set(12,v.$Cj.symbolVariable),te.set(13,v.$Cj.symbolConstant),te.set(14,v.$Cj.symbolString),te.set(15,v.$Cj.symbolNumber),te.set(16,v.$Cj.symbolBoolean),te.set(17,v.$Cj.symbolArray),te.set(18,v.$Cj.symbolObject),te.set(19,v.$Cj.symbolKey),te.set(20,v.$Cj.symbolNull),te.set(21,v.$Cj.symbolEnumMember),te.set(22,v.$Cj.symbolStruct),te.set(23,v.$Cj.symbolEvent),te.set(24,v.$Cj.symbolOperator),te.set(25,v.$Cj.symbolTypeParameter);function ue(Z){let he=te.get(Z);return he||(console.info("No codicon found for SymbolKind "+Z),he=v.$Cj.symbolProperty),he}W.toIcon=ue})(s||(e.SymbolKinds=s={}));class n{static asEditOperation(te){return r.$3r.replace(S.$Vr.lift(te.range),te.text)}}e.$As=n;class o{static fromValue(te){switch(te){case"comment":return o.Comment;case"imports":return o.Imports;case"region":return o.Region}return new o(te)}constructor(te){this.value=te}}e.$Bs=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var f;(function(W){function te(ue){return!ue||typeof ue!="object"?!1:typeof ue.id=="string"&&typeof ue.title=="string"}W.is=te})(f||(e.Command=f={}));var k;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var D;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(D||(e.CommentThreadState=D={}));var C;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(C||(e.CommentMode=C={}));var L;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(L||(e.CommentState=L={}));var U;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(U||(e.InlayHintKind=U={}));class x{constructor(te){this.b=te,this.a=null}dispose(){this.a&&this.a.then(te=>{te&&te.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Cs=x,e.$Ds=new I.$ls;var ae;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(ae||(e.ExternalUriOpenerPriority=ae={}))}),define(we[171],be([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[172],be([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(we[173],be([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(we[174],be([9,10]),function(le,e){return le.create("vs/platform/environment/node/argv",e)}),define(we[175],be([9,10]),function(le,e){return le.create("vs/platform/environment/node/argvHelper",e)}),define(we[176],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[177],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[178],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(we[179],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(we[180],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(we[181],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[182],be([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[183],be([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[184],be([9,10]),function(le,e){return le.create("vs/platform/files/common/fileService",e)}),define(we[185],be([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(we[186],be([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(we[187],be([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[188],be([9,10]),function(le,e){return le.create("vs/platform/languagePacks/common/languagePacks",e)}),define(we[189],be([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(we[190],be([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(we[191],be([9,10]),function(le,e){return le.create("vs/platform/shell/node/shellEnv",e)}),define(we[192],be([9,10]),function(le,e){return le.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[193],be([9,10]),function(le,e){return le.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[194],be([9,10]),function(le,e){return le.create("vs/platform/terminal/common/terminalProfiles",e)}),define(we[195],be([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(we[196],be([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(we[197],be([9,10]),function(le,e){return le.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(we[198],be([9,10]),function(le,e){return le.create("vs/server/node/serverEnvironmentService",e)}),define(we[199],be([9,10]),function(le,e){return le.create("vs/server/node/serverServices",e)}),define(we[200],be([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(we[201],be([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(we[202],be([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[203],be([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(we[204],be([1,0,11,173]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var r;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(r||(e.TokenType=r={}));function S(...$){switch($.length){case 1:return(0,R.localize)(0,null,$[0]);case 2:return(0,R.localize)(1,null,$[0],$[1]);case 3:return(0,R.localize)(2,null,$[0],$[1],$[2]);default:return}}const I=(0,R.localize)(3,null),P=(0,R.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,v.$6)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(S("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(S("&&"));break;case 124:this.h(124)?this.k(16):this.l(S("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const E=this.d,w=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:w};this.g.push({offset:E,lexeme:w,additionalInfo:A}),this.f.push(l)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const E=this.c.substring(this.d,this.e),w=b.b.get(E);w?this.k(w):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,E=!1,w=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(P);return}const d=this.c.charCodeAt(A);if(E)E=!1;else if(d===47&&!w){A++;break}else d===91?w=!0:d===92?E=!0:d===93&&(w=!1);A++}for(;A<this.c.length&&b.a.has(this.c.charCodeAt(A));)A++;this.e=A;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=b,b.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0))),b.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(we[205],be([1,0,5,2]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=void 0;class r{constructor(){this.a=new v.$ec,this.b=new v.$ec,this.c=new v.$ec,this.d=new v.$ec}call(P,b,$){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:$[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:$[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:$[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:$[0],port:$[1],subId:$[2]}))}throw new Error("Method not implemented.")}listen(P,b,$){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$un=r,r.ChannelName="extensionhostdebugservice";class S extends R.$lb{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,b,$){this.b.call("attach",[P,b,$])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,b){this.b.call("terminate",[P,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,b){return this.b.call("openExtensionDevelopmentHostWindow",[P,b])}}e.$vn=S}),define(we[206],be([1,0,4]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=void 0;class R{constructor(I){this.a=I}listen(I,P,b){throw new Error("Invalid listen")}call(I,P,b){switch(P){case"download":return this.a.download(v.URI.revive(b[0]),v.URI.revive(b[1]))}throw new Error("Invalid call")}}e.$xn=R;class r{constructor(I,P){this.a=I,this.b=P}async download(I,P){const b=this.b();b&&(I=b.transformOutgoingURI(I),P=b.transformOutgoingURI(P)),await this.a.call("download",[I,P])}}e.$yn=r}),define(we[207],be([1,0,164,73,13,7,29,19,4]),function(le,e,v,R,r,S,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=/^([^.]+\..+):(.+)$/;class ${get appRoot(){return(0,S.$$c)(r.$1e.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,S.$8c)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,P.$9f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$9f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,v.$Ul)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.$8c)(this.userDataPath,"logs",l)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$9f)(b.URI.file((0,S.$8c)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$9f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$9f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$9f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=I.env.VSCODE_PORTABLE;return l?b.URI.file((0,S.$8c)(l,"argv.json")):(0,P.$9f)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,S.$8c)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,S.$9c)(l):(0,S.$6c)((0,S.$8c)(r.$1e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?b.URI.file((0,S.$9c)(l)):b.URI.file((0,S.$8c)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,S.$9c)(l);const d=I.env.VSCODE_EXTENSIONS;if(d)return d;const m=I.env.VSCODE_PORTABLE;return m?(0,S.$8c)(m,"extensions"):(0,P.$9f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,S.$6c)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?b.URI.parse(l):b.URI.file((0,S.$6c)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return A(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$Vl.test(l))}get extensionLogLevel(){const l=[];for(const d of this.args.log||[]){const m=e.$Vl.exec(d);m&&m[1]&&m[2]&&l.push([m[1],m[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,P.$9f)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=I.env.VSCODE_PORTABLE;return l?b.URI.file((0,S.$8c)(l,"policy.json")):(0,P.$9f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,d,m){this.a=l,this.b=d,this.c=m,this.editSessionId=this.args.editSessionId}}e.$Wl=$,Le([R.$Tg],$.prototype,"appRoot",null),Le([R.$Tg],$.prototype,"userHome",null),Le([R.$Tg],$.prototype,"userDataPath",null),Le([R.$Tg],$.prototype,"appSettingsHome",null),Le([R.$Tg],$.prototype,"tmpDir",null),Le([R.$Tg],$.prototype,"cacheHome",null),Le([R.$Tg],$.prototype,"stateResource",null),Le([R.$Tg],$.prototype,"userRoamingDataHome",null),Le([R.$Tg],$.prototype,"userDataSyncHome",null),Le([R.$Tg],$.prototype,"sync",null),Le([R.$Tg],$.prototype,"machineSettingsResource",null),Le([R.$Tg],$.prototype,"workspaceStorageHome",null),Le([R.$Tg],$.prototype,"localHistoryHome",null),Le([R.$Tg],$.prototype,"keyboardLayoutResource",null),Le([R.$Tg],$.prototype,"argvResource",null),Le([R.$Tg],$.prototype,"isExtensionDevelopment",null),Le([R.$Tg],$.prototype,"untitledWorkspacesHome",null),Le([R.$Tg],$.prototype,"builtinExtensionsPath",null),Le([R.$Tg],$.prototype,"extensionsPath",null),Le([R.$Tg],$.prototype,"extensionDevelopmentLocationURI",null),Le([R.$Tg],$.prototype,"extensionDevelopmentKind",null),Le([R.$Tg],$.prototype,"extensionTestsLocationURI",null),Le([R.$Tg],$.prototype,"debugExtensionHost",null),Le([R.$Tg],$.prototype,"logLevel",null),Le([R.$Tg],$.prototype,"extensionLogLevel",null),Le([R.$Tg],$.prototype,"serviceMachineIdResource",null),Le([R.$Tg],$.prototype,"disableTelemetry",null),Le([R.$Tg],$.prototype,"disableWorkspaceTrust",null),Le([R.$Tg],$.prototype,"disableKeytar",null),Le([R.$Tg],$.prototype,"policyFile",null);function A(w,l){return E(w["inspect-extensions"],w["inspect-brk-extensions"],5870,l,w.debugId,w.extensionEnvironment)}e.$Xl=A;function E(w,l,d,m,c,u){const g=Number(l||w)||(m?null:d),y=g?!!l:!1;let p;if(u)try{p=JSON.parse(u)}catch{}return{port:g,break:y,debugId:c,env:p}}e.$Yl=E}),define(we[64],be([1,0,298,3,174]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=void 0;const S={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$ll=["tunnel","serve-web"],e.$ml={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,c,u=I){const h=m.find(o=>o.length>0&&o[0]!=="-"),g={},y=["_"],p=[],t={};let i;for(const o in c){const f=c[o];f.type==="subcommand"?o===h&&(i=f):(f.alias&&(g[o]=f.alias),f.type==="string"||f.type==="string[]"?(y.push(o),f.deprecates&&y.push(...f.deprecates)):f.type==="boolean"&&(p.push(o),f.deprecates&&p.push(...f.deprecates)),f.global&&(t[o]=f))}if(i&&h){const o=t;for(const C in i.options)o[C]=i.options[C];const f=m.filter(C=>C!==h),k=u.getSubcommandReporter?u.getSubcommandReporter(h):void 0,D=P(f,o,k);return{[h]:D,_:[]}}const a=v(m,{string:y,boolean:p,alias:g}),s={},n=a;s._=a._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in c){const f=c[o];if(f.type==="subcommand")continue;f.alias&&delete n[f.alias];let k=n[o];if(f.deprecates)for(const D of f.deprecates)n.hasOwnProperty(D)&&(k||(k=n[D],k&&u.onDeprecatedOption(D,f.deprecationMessage||(0,r.localize)(37,null,o))),delete n[D]);if(typeof k<"u"){if(f.type==="string[]"){if(Array.isArray(k)||(k=[k]),!f.allowEmptyValue){const D=k.filter(C=>C.length>0);D.length!==k.length&&(u.onEmptyValue(o),k=D.length>0?D:void 0)}}else f.type==="string"&&(Array.isArray(k)?(k=k.pop(),u.onMultipleValues(o,k)):!k&&!f.allowEmptyValue&&(u.onEmptyValue(o),k=void 0));s[o]=k,f.deprecationMessage&&u.onDeprecatedOption(o,f.deprecationMessage)}delete n[o]}for(const o in n)u.onUnknownOption(o);return s}e.$nl=P;function b(m,c){let u="";return c.args&&(Array.isArray(c.args)?u=` <${c.args.join("> <")}>`:u=` <${c.args}>`),c.alias?`-${c.alias} --${m}${u}`:`--${m}${u}`}function $(m,c){const u=[];for(const h in m){const g=m[h],y=b(h,g);u.push([y,g.description])}return A(u,c)}e.$ol=$;function A(m,c){const h=m.reduce((p,t)=>Math.max(p,t[0].length),12)+2+1;if(c-h<25)return m.reduce((p,t)=>p.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const g=c-h-1,y=[];for(const p of m){const t=p[0],i=w(p[1],g),a=E(h-t.length-2);y.push("  "+t+a+i[0]);for(let s=1;s<i.length;s++)y.push(E(h)+i[s])}return y}function E(m){return" ".repeat(m)}function w(m,c){const u=[];for(;m.length;){const h=m.length<c?m.length:m.lastIndexOf(" ",c),g=m.slice(0,h).trim();m=m.slice(h),u.push(g)}return u}function l(m,c,u,h,g){const y=process.stdout.isTTY&&process.stdout.columns||80,p=g?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",t=[`${m} ${u}`];t.push(""),t.push(`${(0,r.localize)(39,null)}: ${c} [${(0,r.localize)(40,null)}]${p}`),t.push(""),g?.noPipe!==!0&&(R.$d?t.push((0,r.localize)(41,null,c)):t.push((0,r.localize)(42,null,c)),t.push(""));const i={},a=[];for(const s in h){const n=h[s];if(n.type==="subcommand")n.description&&a.push({command:s,description:n.description});else if(n.description&&n.cat){let o=i[n.cat];o||(i[n.cat]=o={}),o[s]=n}}for(const s in i){const n=s,o=i[n];o&&(t.push(S[n]),t.push(...$(o,y)),t.push(""))}return a.length&&(t.push((0,r.localize)(43,null)),t.push(...A(a.map(s=>[s.command,s.description]),y)),t.push("")),t.join(`
`)}e.$pl=l;function d(m,c){return`${m||(0,r.localize)(44,null)}
${c||(0,r.localize)(45,null)}
${process.arch}`}e.$ql=d}),define(we[208],be([1,0,299,175,64]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=e.$sl=e.$rl=void 0;function S(E,w){const l=(g,y)=>{console.warn((0,R.localize)(0,null,g,y))},d=g=>{console.warn((0,R.localize)(1,null,g))},m=(g,y)=>{console.warn((0,R.localize)(2,null,g,y))},c=g=>({onUnknownOption:y=>{r.$ll.includes(g)||console.warn((0,R.localize)(3,null,y,g))},onMultipleValues:l,onEmptyValue:d,onDeprecatedOption:m,getSubcommandReporter:r.$ll.includes(g)?c:void 0}),u={onUnknownOption:g=>{console.warn((0,R.localize)(4,null,g))},onMultipleValues:l,onEmptyValue:d,onDeprecatedOption:m,getSubcommandReporter:c},h=(0,r.$nl)(E,r.$ml,w?u:void 0);return h.goto&&h._.forEach(g=>v(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(g),(0,R.localize)(5,null))),h}function I(E){const w=E.findIndex(l=>!/^-/.test(l));if(w>-1)return[...E.slice(0,w),...E.slice(w+1)]}function P(E){let[,...w]=E;process.env.VSCODE_DEV&&(w=I(w)||[]);const l=!A(process.env);return S(w,l)}e.$rl=P;function b(E){let[,,...w]=E;return process.env.VSCODE_DEV&&(w=I(w)||[]),S(w,!0)}e.$sl=b;function $(E,...w){const l=E.indexOf("--");return l===-1?E.push(...w):E.splice(l,0,...w),E}e.$tl=$;function A(E){return E.VSCODE_CLI==="1"}e.$ul=A}),function(){"use strict";function le(e,v,R){function r(I,P){const b=S(I,P),$=[b];return e.isAbsolute(b)||$.unshift(R),e.resolve(...$)}function S(I,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let $=process.env.VSCODE_APPDATA;if($)return e.join($,P);const A=I["user-data-dir"];if(A)return A;switch(process.platform){case"win32":if($=process.env.APPDATA,!$){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");$=e.join(E,"AppData","Roaming")}break;case"darwin":$=e.join(v.homedir(),"Library","Application Support");break;case"linux":$=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join($,P)}return{getUserDataPath:r}}if(typeof define=="function")define(we[209],be([77,26,29]),function(e,v,R){return le(e,v,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("os");module.exports=le(e,v,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[110],be([1,0,26,207,209]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=void 0;class S extends R.$Wl{constructor($,A){super($,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,r.getUserDataPath)($,A.nameShort)},A)}}e.$Zl=S;function I(b,$){return(0,R.$Yl)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,$,b.extensionEnvironment)}e.$1l=I;function P(b,$){return(0,R.$Yl)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,$,b.extensionEnvironment)}e.$2l=P}),define(we[210],be([1,0,8,179]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=void 0;function r(I,P,b){try{S(I,P,b)}catch($){console.error($?.message??$)}return I}e.$fp=r;function S(I,P,b){const $=(A,E,w)=>{const l=A[E];if((0,v.$ie)(l)){const d=l,m=d.length;if(m>1&&d[0]==="%"&&d[m-1]==="%"){const c=d.substr(1,m-2);let u=P[c];u===void 0&&b&&(u=b[c]);const h=typeof u=="string"?u:u?.message,g=b?.[c],y=typeof g=="string"?g:g?.message;if(!h){y||console.warn(`[${I.name}]: ${(0,R.localize)(0,null,c)}`);return}if(w&&(E==="title"||E==="category")&&y&&y!==h){const p={value:h,original:y};A[E]=p}else A[E]=h}}else if((0,v.$ke)(l))for(const d in l)l.hasOwnProperty(d)&&(d==="commands"?$(l,d,!0):$(l,d,w));else if(Array.isArray(l))for(let d=0;d<l.length;d++)$(l,d,w)};for(const A in I)I.hasOwnProperty(A)&&$(I,A)}}),define(we[79],be([1,0,19,62,183,53]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function b(u){return u=u.trim(),u==="*"||I.test(u)}e.$uo=b;function $(u){if(!b(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=u.match(I);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$vo=$;function A(u){if(!u)return null;const h=u.majorBase,g=u.majorMustEqual,y=u.minorBase;let p=u.minorMustEqual;const t=u.patchBase;let i=u.patchMustEqual;u.hasCaret&&(h===0||(p=!1),i=!1);let a=0;if(u.preRelease){const s=P.exec(u.preRelease);if(s){const[,n,o,f]=s;a=Date.UTC(Number(n),Number(o)-1,Number(f))}}return{majorBase:h,majorMustEqual:g,minorBase:y,minorMustEqual:p,patchBase:t,patchMustEqual:i,isMinimum:u.hasGreaterEquals,notBefore:a}}e.$wo=A;function E(u,h,g){let y;typeof u=="string"?y=A($(u)):y=u;let p;h instanceof Date?p=h.getTime():typeof h=="string"&&(p=new Date(h).getTime());let t;if(typeof g=="string"?t=A($(g)):t=g,!y||!t)return!1;const i=y.majorBase,a=y.minorBase,s=y.patchBase;let n=t.majorBase,o=t.minorBase,f=t.patchBase;const k=t.notBefore;let D=t.majorMustEqual,C=t.minorMustEqual,L=t.patchMustEqual;return t.isMinimum?i>n?!0:i<n?!1:a>o?!0:a<o||p&&p<k?!1:s>=f:(i===1&&n===0&&(!D||!C||!L)&&(n=1,o=0,f=0,D=!0,C=!1,L=!1),i<n?!1:i>n?!D:a<o?!1:a>o?!C:s<f?!1:s>f?!L:!(p&&p<k))}e.$xo=E;function w(u,h,g,y,p){const t=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return t.push([R.default.Error,r.localize(0,null)]),t;if(typeof y.name!="string")return t.push([R.default.Error,r.localize(1,null,"name")]),t;if(typeof y.version!="string")return t.push([R.default.Error,r.localize(2,null,"version")]),t;if(!y.engines)return t.push([R.default.Error,r.localize(3,null,"engines")]),t;if(typeof y.engines.vscode!="string")return t.push([R.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof y.extensionDependencies<"u"&&!c(y.extensionDependencies))return t.push([R.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof y.activationEvents<"u"){if(!c(y.activationEvents))return t.push([R.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof y.main>"u"&&typeof y.browser>"u")return t.push([R.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&t.push([R.default.Warning,r.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return t.push([R.default.Error,r.localize(9,null,"main")]),t;{const s=(0,v.$9f)(g,y.main);(0,v.$3f)(s,g)||t.push([R.default.Warning,r.localize(10,null,s.path,g.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return t.push([R.default.Error,r.localize(11,null,"browser")]),t;{const s=(0,v.$9f)(g,y.browser);(0,v.$3f)(s,g)||t.push([R.default.Warning,r.localize(12,null,s.path,g.path)])}}if(!S.valid(y.version))return t.push([R.default.Error,r.localize(13,null)]),t;const i=[];if(!l(u,h,y,p,i))for(const s of i)t.push([R.default.Error,s]);return t}e.$yo=w;function l(u,h,g,y,p){return y||typeof g.main>"u"&&typeof g.browser>"u"?!0:m(u,h,g.engines.vscode,p)}e.$zo=l;function d(u,h,g){return u==="*"||m(h,g,u)}e.$Ao=d;function m(u,h,g,y=[]){const p=A($(g));if(!p)return y.push(r.localize(14,null,g)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return y.push(r.localize(15,null,g)),!1}else if(!p.majorMustEqual)return y.push(r.localize(16,null,g)),!1;return E(u,h,p)?!0:(y.push(r.localize(17,null,u,g)),!1)}function c(u){if(!Array.isArray(u))return!1;for(let h=0,g=u.length;h<g;h++)if(typeof u[h]!="string")return!1;return!0}}),define(we[211],be([1,0,15,23]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;async function r(S,I,P){let b=P&&P.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const A=(await I.readFile(S.serviceMachineIdResource)).value.toString();b=(0,R.$2e)(A)?A:null}catch{b=null}if(!b){b=(0,R.$3e)();try{await I.writeFile(S.serviceMachineIdResource,v.$Ec.fromString(b))}catch{}}return P?.store("storage.serviceMachineId",b,-1,1),b}e.$To=r}),define(we[65],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class v{constructor(r,S=[],I=!1){this.ctor=r,this.staticArguments=S,this.supportsDelayedInstantiation=I}}e.$mh=v}),define(we[212],be([1,0,65]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.InstantiationType=void 0;const R=[];var r;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function S(P,b,$){b instanceof v.$mh||(b=new v.$mh(b,[],!!$)),R.push([P,b])}e.$er=S;function I(){return R}e.$fr=I}),define(we[213],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0;class v{constructor(S,I){this.key=S,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$Vp=v;class R{constructor(S){this.b=S,this.a=new Map}roots(){const S=[];for(const I of this.a.values())I.outgoing.size===0&&S.push(I);return S}insertEdge(S,I){const P=this.lookupOrInsertNode(S),b=this.lookupOrInsertNode(I);P.outgoing.set(b.key,b),b.incoming.set(P.key,P)}removeNode(S){const I=this.b(S);this.a.delete(I);for(const P of this.a.values())P.outgoing.delete(I),P.incoming.delete(I)}lookupOrInsertNode(S){const I=this.b(S);let P=this.a.get(I);return P||(P=new v(I,S),this.a.set(I,P)),P}lookup(S){return this.a.get(this.b(S))}isEmpty(){return this.a.size===0}toString(){const S=[];for(const[I,P]of this.a)S.push(`${I}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return S.join(`
`)}findCycleSlow(){for(const[S,I]of this.a){const P=new Set([S]),b=this.c(I,P);if(b)return b}}c(S,I){for(const[P,b]of S.outgoing){if(I.has(P))return[...I,P].join(" -> ");I.add(P);const $=this.c(b,I);if($)return $;I.delete(P)}}}e.$Wp=R}),define(we[6],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var v;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function P(b){return b[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=P})(v||(e._util=v={})),e.$oh=r("instantiationService");function R(I,P,b){P[v.DI_TARGET]===P?P[v.DI_DEPENDENCIES].push({id:I,index:b}):(P[v.DI_DEPENDENCIES]=[{id:I,index:b}],P[v.DI_TARGET]=P)}function r(I){if(v.serviceIds.has(I))return v.serviceIds.get(I);const P=function(b,$,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,b,A)};return P.toString=()=>I,v.serviceIds.set(I,P),P}e.$ph=r;function S(I){return I}e.$qh=S}),define(we[24],be([1,0,8,4,6]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,r.$ph)("configurationService");function S(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof R.URI)}e.$Wh=S;function I(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof R.URI)}e.$Xh=I;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function b(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=b;function $(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$Zh=$;function A(u,h){const g=Object.create(null);for(const y in u)E(g,y,u[y],h);return g}e.$1h=A;function E(u,h,g,y){const p=h.split("."),t=p.pop();let i=u;for(let a=0;a<p.length;a++){const s=p[a];let n=i[s];switch(typeof n){case"undefined":n=i[s]=Object.create(null);break;case"object":break;default:y(`Ignoring ${h} as ${p.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[t]=g}catch{y(`Ignoring ${h} as ${p.join(".")} is ${JSON.stringify(i)}`)}else y(`Ignoring ${h} as ${p.join(".")} is ${JSON.stringify(i)}`)}e.$2h=E;function w(u,h){const g=h.split(".");l(u,g)}e.$3h=w;function l(u,h){const g=h.shift();if(h.length===0){delete u[g];return}if(Object.keys(u).indexOf(g)!==-1){const y=u[g];typeof y=="object"&&!Array.isArray(y)&&(l(y,h),Object.keys(y).length===0&&delete u[g])}}function d(u,h,g){function y(i,a){let s=i;for(const n of a){if(typeof s!="object"||s===null)return;s=s[n]}return s}const p=h.split("."),t=y(u,p);return typeof t>"u"?g:t}e.$4h=d;function m(u,h,g){Object.keys(h).forEach(y=>{y!=="__proto__"&&(y in u?v.$ke(u[y])&&v.$ke(h[y])?m(u[y],h[y],g):g&&(u[y]=h[y]):u[y]=h[y])})}e.$5h=m;function c(u){return u.replace(/[\[\]]/g,"")}e.$6h=c}),define(we[66],be([1,0,3,17,204,6,172,11]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",v.$e),b.set("isLinux",v.$f),b.set("isWindows",v.$d),b.set("isWeb",v.$j),b.set("isMacNative",v.$e&&!v.$j),b.set("isEdge",v.$B),b.set("isFirefox",v.$z),b.set("isChrome",v.$y),b.set("isSafari",v.$A);function $(X,O){if(b.get(X)!==void 0)throw(0,P.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(X,O)}e.$ti=$;const A=Object.prototype.hasOwnProperty;var E;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const w={regexParsingWithErrorRecovery:!0},l=(0,I.localize)(0,null),d=(0,I.localize)(1,null),m=(0,I.localize)(2,null),c=(0,I.localize)(3,null),u=(0,I.localize)(4,null),h=(0,I.localize)(5,null),g=(0,I.localize)(6,null),y=(0,I.localize)(7,null);class p{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=w){this.k=O,this.d=new r.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const J=this.D(),ie=J.type===17?h:void 0;throw this.h.push({message:u,offset:J.offset,lexeme:r.$si.getLexeme(J),additionalInfo:ie}),p.c}return N}catch(N){if(N!==p.c)throw N;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const N=this.o();O.push(N)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const N=this.s();O.push(N)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,c),N?.negate()}case 17:return this.z(),U.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,c),N}case 17:{const N=O.lexeme;if(this.z(),this.y(9)){const ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ie.type!==10)throw this.B("REGEX",ie);const re=ie.lexeme,ee=re.lastIndexOf("/"),oe=ee===re.length-1?void 0:this.w(re.substring(ee+1));let F;try{F=new RegExp(re.substring(1,ee),oe)}catch{throw this.B("REGEX",ie)}return Z.create(N,F)}switch(ie.type){case 10:case 19:{const re=[ie.lexeme];this.z();let ee=this.D(),oe=0;for(let Q=0;Q<ie.lexeme.length;Q++)ie.lexeme.charCodeAt(Q)===40?oe++:ie.lexeme.charCodeAt(Q)===41&&oe--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Q=0;Q<ee.lexeme.length;Q++)ee.lexeme.charCodeAt(Q)===40?oe++:ie.lexeme.charCodeAt(Q)===41&&oe--}if(oe<0)break;re.push(r.$si.getLexeme(ee)),this.z(),ee=this.D()}const F=re.join(""),z=F.lastIndexOf("/"),j=z===F.length-1?void 0:this.w(F.substring(z+1));let B;try{B=new RegExp(F.substring(1,z),j)}catch{throw this.B("REGEX",ie)}return t.regex(N,B)}case 18:{const re=ie.lexeme;this.z();let ee=null;if(!(0,R.$ld)(re)){const oe=re.indexOf("/"),F=re.lastIndexOf("/");if(oe!==F&&oe>=0){const z=re.slice(oe+1,F),j=re[F+1]==="i"?"i":"";try{ee=new RegExp(z,j)}catch{throw this.B("REGEX",ie)}}}if(ee===null)throw this.B("REGEX",ie);return Z.create(N,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const ie=this.u();return t.notIn(N,ie)}switch(this.D().type){case 3:{this.z();const ie=this.u();if(this.x().type===18)return t.equals(N,ie);switch(ie){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,ie)}}case 4:{this.z();const ie=this.u();if(this.x().type===18)return t.notEquals(N,ie);switch(ie){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,ie)}}case 5:return this.z(),te.create(N,this.u());case 6:return this.z(),ue.create(N,this.u());case 7:return this.z(),ae.create(N,this.u());case 8:return this.z(),W.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:g,offset:O.offset,lexeme:"",additionalInfo:y}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,N){if(this.C(O))return this.z();throw this.B(N,this.D())}B(O,N,J){const ie=(0,I.localize)(8,null,O,r.$si.getLexeme(N)),re=N.offset,ee=r.$si.getLexeme(N);return this.h.push({message:ie,offset:re,lexeme:ee,additionalInfo:J}),p.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=p,p.c=new Error;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(O){return f.create(O)}static equals(O,N){return k.create(O,N)}static notEquals(O,N){return L.create(O,N)}static regex(O,N){return Z.create(O,N)}static in(O,N){return D.create(O,N)}static notIn(O,N){return C.create(O,N)}static not(O){return U.create(O)}static and(...O){return se.create(O,null,!0)}static or(...O){return K.create(O,null,!0)}static greater(O,N){return ae.create(O,N)}static greaterEquals(O,N){return W.create(O,N)}static smaller(O,N){return te.create(O,N)}static smallerEquals(O,N){return ue.create(O,N)}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$vi=t,t.c=new p({regexParsingWithErrorRecovery:!1});function i(X){const O=new p({regexParsingWithErrorRecovery:!1});return X.map(N=>(O.parse(N),O.lexingErrors.length>0?O.lexingErrors.map(J=>({errorMessage:J.additionalInfo?(0,I.localize)(9,null,J.additionalInfo):(0,I.localize)(10,null),offset:J.offset,length:J.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(J=>({errorMessage:J.additionalInfo?`${J.message}. ${J.additionalInfo}`:J.message,offset:J.offset,length:J.lexeme.length})):[]))}e.$wi=i;function a(X,O){const N=X?X.substituteConstants():void 0,J=O?O.substituteConstants():void 0;return!N&&!J?!0:!N||!J?!1:N.equals(J)}e.$xi=a;function s(X,O){return X.cmp(O)}class n{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return o.INSTANCE}}e.$yi=n,n.INSTANCE=new n;class o{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$zi=o,o.INSTANCE=new o;class f{static create(O,N=null){const J=b.get(O);return typeof J=="boolean"?J?o.INSTANCE:n.INSTANCE:new f(O,N)}constructor(O,N){this.key=O,this.c=N,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:H(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=b.get(this.key);return typeof O=="boolean"?O?o.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=U.create(this.key,this)),this.c}}e.$Ai=f;class k{static create(O,N,J=null){if(typeof N=="boolean")return N?f.create(O,J):U.create(O,J);const ie=b.get(O);return typeof ie=="boolean"?N===(ie?"true":"false")?o.INSTANCE:n.INSTANCE:new k(O,N,J)}constructor(O,N,J){this.c=O,this.d=N,this.f=J,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:_(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=b.get(this.c);if(typeof O=="boolean"){const N=O?"true":"false";return this.d===N?o.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Bi=k;class D{static create(O,N){return new D(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:_(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const N=O.getValue(this.f),J=O.getValue(this.d);return Array.isArray(N)?N.includes(J):typeof J=="string"&&typeof N=="object"&&N!==null?A.call(N,J):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=C.create(this.d,this.f)),this.c}}e.$Ci=D;class C{static create(O,N){return new C(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=11,this.c=D.create(O,N)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=C;class L{static create(O,N,J=null){if(typeof N=="boolean")return N?U.create(O,J):f.create(O,J);const ie=b.get(O);return typeof ie=="boolean"?N===(ie?"true":"false")?n.INSTANCE:o.INSTANCE:new L(O,N,J)}constructor(O,N,J){this.c=O,this.d=N,this.f=J,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:_(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=b.get(this.c);if(typeof O=="boolean"){const N=O?"true":"false";return this.d===N?n.INSTANCE:o.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Ei=L;class U{static create(O,N=null){const J=b.get(O);return typeof J=="boolean"?J?n.INSTANCE:o.INSTANCE:new U(O,N)}constructor(O,N){this.c=O,this.d=N,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=b.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:o.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Fi=U;function x(X,O){if(typeof X=="string"){const N=parseFloat(X);isNaN(N)||(X=N)}return typeof X=="string"||typeof X=="number"?O(X):n.INSTANCE}class ae{static create(O,N,J=null){return x(N,ie=>new ae(O,ie,J))}constructor(O,N,J){this.c=O,this.d=N,this.f=J,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:_(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Gi=ae;class W{static create(O,N,J=null){return x(N,ie=>new W(O,ie,J))}constructor(O,N,J){this.c=O,this.d=N,this.f=J,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:_(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Hi=W;class te{static create(O,N,J=null){return x(N,ie=>new te(O,ie,J))}constructor(O,N,J){this.c=O,this.d=N,this.f=J,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:_(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Ii=te;class ue{static create(O,N,J=null){return x(N,ie=>new ue(O,ie,J))}constructor(O,N,J){this.c=O,this.d=N,this.f=J,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:_(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Ji=ue;class Z{static create(O,N){return new Z(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const N=this.f?this.f.source:"",J=O.f?O.f.source:"";return N<J?-1:N>J?1:0}equals(O){if(O.type===this.type){const N=this.f?this.f.source:"",J=O.f?O.f.source:"";return this.d===O.d&&N===J}return!1}substituteConstants(){return this}evaluate(O){const N=O.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=he.create(this)),this.c}}e.$Ki=Z;class he{static create(O){return new he(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new he(this.c.map(O))}negate(){return this.c}}e.$Li=he;function V(X){let O=null;for(let N=0,J=X.length;N<J;N++){const ie=X[N].substituteConstants();if(X[N]!==ie&&O===null){O=[];for(let re=0;re<N;re++)O[re]=X[re]}O!==null&&(O[N]=ie)}return O===null?X:O}class se{static create(O,N,J){return se.d(O,N,J)}constructor(O,N){this.expr=O,this.c=N,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let N=0,J=this.expr.length;N<J;N++){const ie=s(this.expr[N],O.expr[N]);if(ie!==0)return ie}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let N=0,J=this.expr.length;N<J;N++)if(!this.expr[N].equals(O.expr[N]))return!1;return!0}return!1}substituteConstants(){const O=V(this.expr);return O===this.expr?this:se.create(O,this.c,!1)}evaluate(O){for(let N=0,J=this.expr.length;N<J;N++)if(!this.expr[N].evaluate(O))return!1;return!0}static d(O,N,J){const ie=[];let re=!1;for(const ee of O)if(ee){if(ee.type===1){re=!0;continue}if(ee.type===0)return n.INSTANCE;if(ee.type===6){ie.push(...ee.expr);continue}ie.push(ee)}if(ie.length===0&&re)return o.INSTANCE;if(ie.length!==0){if(ie.length===1)return ie[0];ie.sort(s);for(let ee=1;ee<ie.length;ee++)ie[ee-1].equals(ie[ee])&&(ie.splice(ee,1),ee--);if(ie.length===1)return ie[0];for(;ie.length>1;){const ee=ie[ie.length-1];if(ee.type!==9)break;ie.pop();const oe=ie.pop(),F=ie.length===0,z=K.create(ee.expr.map(j=>se.create([j,oe],null,J)),null,F);z&&(ie.push(z),ie.sort(s))}if(ie.length===1)return ie[0];if(J){for(let ee=0;ee<ie.length;ee++)for(let oe=ee+1;oe<ie.length;oe++)if(ie[ee].negate().equals(ie[oe]))return n.INSTANCE;if(ie.length===1)return ie[0]}return new se(ie,N)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const N of this.expr)O.push(...N.keys());return O}map(O){return new se(this.expr.map(N=>N.map(O)),null)}negate(){if(!this.c){const O=[];for(const N of this.expr)O.push(N.negate());this.c=K.create(O,this,!0)}return this.c}}e.$Mi=se;class K{static create(O,N,J){return K.d(O,N,J)}constructor(O,N){this.expr=O,this.c=N,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let N=0,J=this.expr.length;N<J;N++){const ie=s(this.expr[N],O.expr[N]);if(ie!==0)return ie}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let N=0,J=this.expr.length;N<J;N++)if(!this.expr[N].equals(O.expr[N]))return!1;return!0}return!1}substituteConstants(){const O=V(this.expr);return O===this.expr?this:K.create(O,this.c,!1)}evaluate(O){for(let N=0,J=this.expr.length;N<J;N++)if(this.expr[N].evaluate(O))return!0;return!1}static d(O,N,J){let ie=[],re=!1;if(O){for(let ee=0,oe=O.length;ee<oe;ee++){const F=O[ee];if(F){if(F.type===0){re=!0;continue}if(F.type===1)return o.INSTANCE;if(F.type===9){ie=ie.concat(F.expr);continue}ie.push(F)}}if(ie.length===0&&re)return n.INSTANCE;ie.sort(s)}if(ie.length!==0){if(ie.length===1)return ie[0];for(let ee=1;ee<ie.length;ee++)ie[ee-1].equals(ie[ee])&&(ie.splice(ee,1),ee--);if(ie.length===1)return ie[0];if(J){for(let ee=0;ee<ie.length;ee++)for(let oe=ee+1;oe<ie.length;oe++)if(ie[ee].negate().equals(ie[oe]))return o.INSTANCE;if(ie.length===1)return ie[0]}return new K(ie,N)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const N of this.expr)O.push(...N.keys());return O}map(O){return new K(this.expr.map(N=>N.map(O)),null)}negate(){if(!this.c){const O=[];for(const N of this.expr)O.push(N.negate());for(;O.length>1;){const N=O.shift(),J=O.shift(),ie=[];for(const re of q(N))for(const ee of q(J))ie.push(se.create([re,ee],null,!1));O.unshift(K.create(ie,null,!1))}this.c=K.create(O,this,!0)}return this.c}}e.$Ni=K;class Y extends f{static all(){return Y.d.values()}constructor(O,N,J){super(O,null),this.f=N,typeof J=="object"?Y.d.push({...J,key:O}):J!==!0&&Y.d.push({key:O,description:J,type:N!=null?typeof N:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return k.create(this.key,O)}notEqualsTo(O){return L.create(this.key,O)}}e.$Oi=Y,Y.d=[],e.$Pi=(0,S.$ph)("contextKeyService");function H(X,O){return X<O?-1:X>O?1:0}function _(X,O,N,J){return X<N?-1:X>N?1:O<J?-1:O>J?1:0}function ge(X,O){if(X.type===0||O.type===1)return!0;if(X.type===9)return O.type===9?ne(X.expr,O.expr):!1;if(O.type===9){for(const N of O.expr)if(ge(X,N))return!0;return!1}if(X.type===6){if(O.type===6)return ne(O.expr,X.expr);for(const N of X.expr)if(ge(N,O))return!0;return!1}return X.equals(O)}e.$Qi=ge;function ne(X,O){let N=0,J=0;for(;N<X.length&&J<O.length;){const ie=X[N].cmp(O[J]);if(ie<0)return!1;ie===0&&N++,J++}return N===X.length}function q(X){return X.type===9?X.expr:[X]}}),define(we[80],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=void 0,e.$on=(0,v.$ph)("credentialsService"),e.$pn=(0,v.$ph)("credentialsMainService");class R{constructor(){this.a={}}async getPassword(S,I){return this.a[S]?.[I]??null}async setPassword(S,I,P){this.a[S]=this.a[S]??{},this.a[S][I]=P}async deletePassword(S,I){return this.a[S]?.[I]?(delete this.a[S][I],Object.keys(this.a[S]).length===0&&delete this.a[S],!0):!1}async findPassword(S){return JSON.stringify(this.a[S])??null}async findCredentials(S){const I=[];for(const P of Object.keys(this.a[S]||{}))I.push({account:P,password:this.a[S][P]});return I}async clear(){this.a={}}}e.$qn=R}),define(we[214],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.ID=void 0,e.ID="diagnosticsService",e.$7l=(0,v.$ph)(e.ID);function R(S){return!!S.hostName&&!!S.errorMessage}e.$8l=R;class r{async getPerformanceInfo(I,P){return{}}async getSystemInfo(I,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,P){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$9l=r}),define(we[81],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0,e.$wn=(0,v.$ph)("downloadService")}),define(we[25],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,v.$ph)("environmentService"),e.$xh=(0,v.$qh)(e.$wh)}),define(we[31],be([1,0,177,6]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Sn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0,e.$Fn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Gn=new RegExp(e.$Fn),e.$Hn="__web_extension",e.$In="skipWalkthrough",e.$Jn="extensionsSync",e.$Kn="dependecyOrPackExtensionInstall";function r(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Ln=r;function S(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Mn=S;function I(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Nn=I;function P(h,g){return g==="web"&&!h.includes("web")}e.$On=P;function b(h,g,y){return P(g,y)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===y?!0:$(y).includes(h)}e.$Pn=b;function $(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Qn=$;function A(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$Rn=A;var E;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var w;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var l;(function(h){h.Install="install",h.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var d;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$Sn=(0,R.$ph)("extensionGalleryService");var m;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var c;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class u extends Error{constructor(g,y){super(g),this.code=y,this.name=y}}e.$Tn=u,e.$Un=(0,R.$ph)("extensionManagementService"),e.$Vn="extensionsIdentifiers/disabled",e.$Wn="extensionsIdentifiers/enabled",e.$Xn=(0,R.$ph)("IGlobalExtensionEnablementService"),e.$Yn=(0,R.$ph)("IExtensionTipsService"),e.$Zn=(0,v.localize)(0,null),e.$1n={value:e.$Zn,original:"Extensions"},e.$2n={value:(0,v.localize)(1,null),original:"Preferences"}}),define(we[215],be([1,0,5,2,22,4,51,31]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=void 0;function b(c,u){return c?S.URI.revive(u?u.transformIncoming(c):c):void 0}function $(c,u){return u?u.transformOutgoingURI(c):c}function A(c,u){u=u||I.$qm;const h=c.manifest;return{...(0,I.$tm)({...c,manifest:void 0},u),manifest:h}}function E(c,u){return c?.profileLocation?(0,I.$tm)(c,u??I.$qm):c}function w(c,u){return u?(0,r.$Lm)(c,h=>h instanceof S.URI?u.transformOutgoingURI(h):void 0):c}class l{constructor(u,h){this.a=u,this.b=h,this.onInstallExtension=v.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=v.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=v.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=v.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,h){const g=this.b(u);switch(h){case"onInstallExtension":return v.Event.map(this.onInstallExtension,y=>({...y,profileLocation:y.profileLocation?$(y.profileLocation,g):y.profileLocation}));case"onDidInstallExtensions":return v.Event.map(this.onDidInstallExtensions,y=>y.map(p=>({...p,local:p.local?w(p.local,g):p.local,profileLocation:p.profileLocation?$(p.profileLocation,g):p.profileLocation})));case"onUninstallExtension":return v.Event.map(this.onUninstallExtension,y=>({...y,profileLocation:y.profileLocation?$(y.profileLocation,g):y.profileLocation}));case"onDidUninstallExtension":return v.Event.map(this.onDidUninstallExtension,y=>({...y,profileLocation:y.profileLocation?$(y.profileLocation,g):y.profileLocation}));case"onDidUpdateExtensionMetadata":return v.Event.map(this.onDidUpdateExtensionMetadata,y=>w(y,g))}throw new Error("Invalid listen")}async call(u,h,g){const y=this.b(u);switch(h){case"zip":{const p=A(g[0],y),t=await this.a.zip(p);return $(t,y)}case"unzip":return this.a.unzip(b(g[0],y));case"install":return this.a.install(b(g[0],y),E(g[1],y));case"installFromLocation":return this.a.installFromLocation(b(g[0],y),b(g[1],y));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(g[0],b(g[1],y),b(g[2],y));case"getManifest":return this.a.getManifest(b(g[0],y));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(g[0]);case"installFromGallery":return this.a.installFromGallery(g[0],E(g[1],y));case"installGalleryExtensions":{const p=g[0];return this.a.installGalleryExtensions(p.map(({extension:t,options:i})=>({extension:t,options:E(i,y)??{}})))}case"uninstall":return this.a.uninstall(A(g[0],y),E(g[1],y));case"reinstallFromGallery":return this.a.reinstallFromGallery(A(g[0],y));case"getInstalled":return(await this.a.getInstalled(g[0],b(g[1],y))).map(t=>w(t,y));case"toggleAppliationScope":{const p=await this.a.toggleAppliationScope(A(g[0],y),b(g[1],y));return w(p,y)}case"copyExtensions":return this.a.copyExtensions(b(g[0],y),b(g[1],y));case"updateMetadata":{const p=await this.a.updateMetadata(A(g[0],y),g[1],b(g[2],y));return w(p,y)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(g[0],g[1],g[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$2o=l;class d extends R.$lb{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.B(new v.$ec),this.f=this.B(new v.$ec),this.g=this.B(new v.$ec),this.h=this.B(new v.$ec),this.j=this.B(new v.$ec),this.B(this.k.listen("onInstallExtension")(h=>this.l(this.c,{...h,source:this.m(h.source)?S.URI.revive(h.source):h.source,profileLocation:S.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(h=>this.l(this.f,h.map(g=>({...g,local:g.local?A(g.local,null):g.local,source:this.m(g.source)?S.URI.revive(g.source):g.source,profileLocation:S.URI.revive(g.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(h=>this.l(this.g,{...h,profileLocation:S.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(h=>this.l(this.h,{...h,profileLocation:S.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(h=>this.j.fire(A(h,null))))}l(u,h){u.fire(h)}m(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(u){const h=await this.getTargetPlatform();return u.allTargetPlatforms.some(g=>(0,P.$Pn)(g,u.allTargetPlatforms,h))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(h=>S.URI.revive(h)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,h){return Promise.resolve(this.k.call("install",[u,h])).then(g=>A(g,null))}installFromLocation(u,h){return Promise.resolve(this.k.call("installFromLocation",[u,h])).then(g=>A(g,null))}async installExtensionsFromProfile(u,h,g){return(await this.k.call("installExtensionsFromProfile",[u,h,g])).map(p=>A(p,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,h){return Promise.resolve(this.k.call("installFromGallery",[u,h])).then(g=>A(g,null))}async installGalleryExtensions(u){return(await this.k.call("installGalleryExtensions",[u])).map(g=>({...g,local:g.local?A(g.local,null):g.local,source:this.m(g.source)?S.URI.revive(g.source):g.source,profileLocation:S.URI.revive(g.profileLocation)}))}uninstall(u,h){return Promise.resolve(this.k.call("uninstall",[u,h]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(h=>A(h,null))}getInstalled(u=null,h){return Promise.resolve(this.k.call("getInstalled",[u,h])).then(g=>g.map(y=>A(y,null)))}updateMetadata(u,h,g){return Promise.resolve(this.k.call("updateMetadata",[u,h,g])).then(y=>A(y,null))}toggleAppliationScope(u,h){return this.k.call("toggleAppliationScope",[u,h]).then(g=>A(g,null))}copyExtensions(u,h){return this.k.call("copyExtensions",[u,h])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,h,g){const y=await this.k.call("download",[u,h,g]);return S.URI.revive(y)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$3o=d;class m{constructor(u){this.a=u}listen(u,h){throw new Error("Invalid listen")}call(u,h,g){switch(h){case"getConfigBasedTips":return this.a.getConfigBasedTips(S.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$4o=m}),define(we[82],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=void 0,e.$Yo=(0,v.$ph)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((S,I)=>le(["node-vsce-sign"],async P=>S(P),I))),this.a}async verify(S,I,P){let b;try{b=await this.b()}catch{return!1}return b.verify(S,I,P)}}e.$Zo=R}),define(we[16],be([1,0,63,7,17,8,4,185,6,3,13]),function(le,e,v,R,r,S,I,P,b,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,b.$ph)("fileService");function E(H){return H.create===!0}e.$Tj=E;var w;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var l;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var d;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function m(H){return!!(H.capabilities&2)}e.$Uj=m;function c(H){return!!(H.capabilities&8)}e.$Vj=c;function u(H){return!!(H.capabilities&131072)}e.$Wj=u;function h(H){return!!(H.capabilities&4)}e.$Xj=h;function g(H){return!!(H.capabilities&16)}e.$Yj=g;function y(H){return m(H)?!!(H.capabilities&16384):!1}e.$Zj=y;function p(H){return m(H)?!!(H.capabilities&32768):!1}e.$1j=p;function t(H){return!!(H.capabilities&65536)}e.$2j=t;function i(H){return!!(H.capabilities&2048)}e.$3j=i;var a;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class s extends Error{static create(_,ge){const ne=new s(_.toString(),ge);return f(ne,ge),ne}constructor(_,ge){super(_),this.code=ge}}e.$4j=s;function n(H,_){return s.create(H,_)}e.$5j=n;function o(H){return H||n((0,P.localize)(0,null),a.Unknown)}e.$6j=o;function f(H,_){return H.name=_?`${_} (FileSystemError)`:"FileSystemError",H}e.$7j=f;function k(H){if(!H)return a.Unknown;if(H instanceof s)return H.code;const _=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!_)return a.Unknown;switch(_[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$8j=k;function D(H){if(H instanceof W)return H.fileOperationResult;switch(k(H)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$9j=D;var C;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class L{constructor(_,ge,ne){this.resource=_,this.operation=ge,this.target=ne}isOperation(_){return this.operation===_}}e.$0j=L;var U;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class x{constructor(_,ge){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const q of _){const X=ne.get(q.type);switch(X?X.push([q.resource,q]):ne.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,X]of ne)switch(q){case 1:this.a=v.$vh.forUris(()=>ge),this.a.fill(X);break;case 0:this.b=v.$vh.forUris(()=>ge),this.b.fill(X);break;case 2:this.c=v.$vh.forUris(()=>ge),this.c.fill(X);break}}contains(_,...ge){return this.d(_,{includeChildren:!1},...ge)}affects(_,...ge){return this.d(_,{includeChildren:!0},...ge)}d(_,ge,...ne){if(!_)return!1;const q=ne.length>0;return!!((!q||ne.includes(1))&&(this.a?.get(_)||ge.includeChildren&&this.a?.findSuperstr(_))||(!q||ne.includes(0))&&(this.b?.get(_)||ge.includeChildren&&this.b?.findSuperstr(_))||(!q||ne.includes(2))&&(this.c?.findSubstr(_)||ge.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=x;function ae(H,_,ge){return!H||!_||H===_||_.length>H.length?!1:(_.charAt(_.length-1)!==R.sep&&(_+=R.sep),ge?(0,r.$Md)(H,_):H.indexOf(_)===0)}e.$_j=ae;class W extends Error{constructor(_,ge,ne){super(_),this.fileOperationResult=ge,this.options=ne}}e.$ak=W;class te extends W{constructor(_,ge,ne,q){super(_,ge,q),this.fileOperationResult=ge,this.size=ne}}e.$bk=te;class ue extends W{constructor(_,ge,ne){super(_,2,ne),this.stat=ge}}e.$ck=ue;var Z;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var he;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(he||(e.FileKind=he={})),e.$kk="";function V(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$lk=V;async function se(H,_){if(!_.hasProvider(I.URI.from({scheme:H.scheme})))return new Promise(ge=>{const ne=_.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===H.scheme&&q.added&&(ne.dispose(),ge())})})}e.$mk=se;class K{static formatSize(_){return(0,S.$me)(_)||(_=0),_<K.KB?(0,P.localize)(1,null,_.toFixed(0)):_<K.MB?(0,P.localize)(2,null,(_/K.KB).toFixed(2)):_<K.GB?(0,P.localize)(3,null,(_/K.MB).toFixed(2)):_<K.TB?(0,P.localize)(4,null,(_/K.GB).toFixed(2)):(0,P.localize)(5,null,(_/K.TB).toFixed(2))}}e.$nk=K,K.KB=1024,K.MB=K.KB*K.KB,K.GB=K.MB*K.KB,K.TB=K.GB*K.KB;function Y(H){const _=typeof H=="string"||H?.scheme===A.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===A.Schemas.file?1024*K.MB:_?10*K.MB:$.$j?50*K.MB:1024*K.MB}e.$ok=Y}),define(we[216],be([1,0,15,39,11,5,2,48,4,23,16]),function(le,e,v,R,r,S,I,P,b,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0,e.$RM="localFilesystem";class E extends I.$lb{constructor(l,d){super(),this.a=l,this.b=d,this.onDidChangeCapabilities=S.Event.None,this.f=this.B(new S.$ec),this.onDidChangeFile=this.f.event,this.g=this.B(new S.$ec),this.onDidWatchError=this.g.event,this.h=(0,$.$3e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,d){const{buffer:m}=await this.a.call("readFile",[l,d]);return m}readFileStream(l,d,m){const c=(0,P.$sc)(h=>v.$Ec.concat(h.map(g=>v.$Ec.wrap(g))).buffer),u=this.a.listen("readFileStream",[l,d])(h=>{if(h instanceof v.$Ec)c.write(h.buffer);else{if(h==="end")c.end();else{let g;if(h instanceof Error)g=h;else{const y=h;g=(0,A.$5j)(y.message??(0,R.$ai)(y),y.code??A.FileSystemProviderErrorCode.Unknown)}c.error(g),c.end()}u.dispose()}});return m.onCancellationRequested(()=>{c.error((0,r.$4)()),c.end(),u.dispose()}),c}writeFile(l,d,m){return this.a.call("writeFile",[l,v.$Ec.wrap(d),m])}open(l,d){return this.a.call("open",[l,d])}close(l){return this.a.call("close",[l])}async read(l,d,m,c,u){const[h,g]=await this.a.call("read",[l,d,u]);return m.set(h.buffer.slice(0,g),c),g}write(l,d,m,c,u){return this.a.call("write",[l,d,v.$Ec.wrap(m),c,u])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,d){return this.a.call("delete",[l,d])}rename(l,d,m){return this.a.call("rename",[l,d,m])}copy(l,d,m){return this.a.call("copy",[l,d,m])}cloneFile(l,d){return this.a.call("cloneFile",[l,d])}i(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const d=l;this.f.fire(d.map(m=>({resource:b.URI.revive(m.resource),type:m.type})))}else{const d=l;this.g.fire(d)}}))}watch(l,d){const m=(0,$.$3e)();return this.a.call("watch",[this.h,m,l,d]),(0,I.$jb)(()=>this.a.call("unwatch",[this.h,m]))}}e.$SM=E}),define(we[111],be([1,0,15,11,186,16]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;async function I(A,E,w,l,d,m){let c;try{await P(A,E,w,l,d,m)}catch(u){c=u}finally{c&&d.errorTransformer&&(c=d.errorTransformer(c)),typeof c<"u"&&w.error(c),w.end()}}e.$up=I;async function P(A,E,w,l,d,m){b(m);const c=await A.open(E,{create:!1});try{b(m);let u=0,h=0,g=d&&typeof d.length=="number"?d.length:void 0,y=v.$Ec.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),p=d&&typeof d.position=="number"?d.position:0,t=0;do h=await A.read(c,p,y.buffer,t,y.byteLength-t),p+=h,t+=h,u+=h,typeof g=="number"&&(g-=h),t===y.byteLength&&(await w.write(l(y)),y=v.$Ec.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),t=0);while(h>0&&(typeof g!="number"||g>0)&&b(m)&&$(u,d));if(t>0){let i=t;typeof g=="number"&&(i=Math.min(t,g)),w.write(l(y.slice(0,i)))}}catch(u){throw(0,S.$6j)(u)}finally{await A.close(c)}}function b(A){if(A.isCancellationRequested)throw(0,R.$4)();return!0}function $(A,E){if(typeof E?.limits?.size=="number"&&A>E.limits.size)throw(0,S.$5j)((0,r.localize)(0,null),S.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(we[67],be([1,0,76,2,7,3,4,16]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0;function b(u){return u.recursive===!0}e.$wp=b;class $ extends R.$lb{constructor(h,g,y,p){super(),this.h=h,this.i=g,this.j=y,this.k=p,this.c=this.B(new R.$mb),this.f=void 0,this.g=0}m(){const h=new R.$kb;this.c.value=h,this.b=this.l(h),this.b.setVerboseLogging(this.j),h.add(this.b.onDidChangeFile(g=>this.h(g))),h.add(this.b.onDidLogMessage(g=>this.i(g))),h.add(this.b.onDidError(g=>this.n(g)))}n(h){this.k.restartOnError?this.g<$.a&&this.f?(this.r(`restarting watcher after error: ${h}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${h}`):this.r(h)}p(h){this.g++,this.m(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.j=h,await this.b?.setVerboseLogging(h)}r(h){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${h}`})}s(h){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$xp=$,$.a=5;class A extends ${constructor(h,g,y){super(h,g,y,{type:"node.js",restartOnError:!1})}}e.$yp=A;class E extends ${constructor(h,g,y){super(h,g,y,{type:"universal",restartOnError:!0})}}e.$zp=E;function w(u){return u.map(h=>({type:h.type,resource:I.URI.file(h.path)}))}e.$Ap=w;function l(u){const h=new c;for(const g of u)h.processEvent(g);return h.coalesce()}e.$Bp=l;function d(u,h){return typeof h=="string"&&!h.startsWith(v.$aj)&&!(0,r.$7c)(h)?{base:u,pattern:h}:h}e.$Cp=d;function m(u,h){const g=[];for(const y of h)g.push((0,v.$ej)(d(u,y)));return g}e.$Dp=m;class c{constructor(){this.a=new Set,this.b=new Map}c(h){return S.$f?h.path:h.path.toLowerCase()}processEvent(h){const g=this.b.get(this.c(h));let y=!1;if(g){const p=g.type,t=h.type;g.path!==h.path&&(h.type===2||h.type===1)?y=!0:p===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(g)):p===2&&t===1?g.type=0:p===1&&t===0||(g.type=t)}else y=!0;y&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],g=[];return Array.from(this.a).filter(y=>y.type!==2?(h.push(y),!1):!0).sort((y,p)=>y.path.length-p.path.length).filter(y=>g.some(p=>(0,P.$_j)(y.path,p,!S.$f))?!1:(g.push(y.path),!0)).concat(h)}}}),define(we[217],be([1,0,30,14,20,38,2,99,7,3,156,21,67]),function(le,e,v,R,r,S,I,P,b,$,A,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;class l extends I.$lb{constructor(c,u,h,g){super(),this.j=c,this.k=u,this.l=h,this.m=g,this.c=this.B(new R.$Jg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.k(y))),this.f=this.B(new R.$Ig(y=>this.u(y),l.b)),this.g=(0,w.$Dp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,w.$Dp)(this.j.path,this.j.includes):void 0,this.i=new r.$oc,this.ready=this.n()}async n(){try{const c=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await E.Promises.stat(c);this.B(await this.s(c,u.isDirectory()))}catch(c){c.code!=="ENOENT"?this.w(c):this.z(c)}}async r(c){let u=c.path;try{u=await E.Promises.realpath(c.path),c.path===u&&(u=await(0,A.$Np)(c.path)??c.path),c.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${u})`)}catch{}return u}async s(c,u){if($.$e&&(0,S.$He)(c,"/Volumes/",!0))return this.w(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$lb.None;const h=new r.$oc(this.i.token),g=new I.$kb;try{const y=(0,b.$_c)(c),p=(0,v.watch)(c);g.add((0,I.$jb)(()=>{p.removeAllListeners(),p.close()})),this.z(`Started watching: '${c}'`);const t=new Set;if(u)try{for(const a of await E.Promises.readdir(c))t.add(a)}catch(a){this.w(a)}const i=new Map;g.add((0,I.$jb)(()=>{for(const[,a]of i)a.dispose();i.clear()})),p.on("error",(a,s)=>{this.w(`Failed to watch ${c} for changes using fs.watch() (${a}, ${s})`),this.dispose()}),p.on("change",(a,s)=>{if(h.token.isCancellationRequested)return;this.z(`[raw] ["${a}"] ${s}`);let n="";if(s&&(n=s.toString(),$.$e&&(n=(0,P.$8k)(n))),!(!n||a!=="change"&&a!=="rename"))if(u)if(a==="rename"){i.get(n)?.dispose();const o=setTimeout(async()=>{if(i.delete(n),n===y&&!await E.Promises.exists(c)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.v((0,b.$8c)(c,n));if(h.token.isCancellationRequested)return;let k;f?t.has(n)?k=0:(k=1,t.add(n)):(t.delete(n),k=2),this.t({path:(0,b.$8c)(this.j.path,n),type:k})},l.a);i.set(n,(0,I.$jb)(()=>clearTimeout(o)))}else{let o;t.has(n)?o=0:(o=1,t.add(n)),this.t({path:(0,b.$8c)(this.j.path,n),type:o})}else if(a==="rename"||n!==y){const o=setTimeout(async()=>{const f=await E.Promises.exists(c);h.token.isCancellationRequested||(f?(this.t({path:this.j.path,type:0},!0),g.add(await this.s(c,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},l.a);g.clear(),g.add((0,I.$jb)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(y){await E.Promises.exists(c)&&!h.token.isCancellationRequested&&this.w(`Failed to watch ${c} for changes using fs.watch() (${y.toString()})`)}return(0,I.$jb)(()=>{h.dispose(!0),g.dispose()})}t(c,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!u&&this.g.some(h=>h(c.path))?this.m&&this.z(` >> ignored (excluded) ${c.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(h=>h(c.path))?this.m&&this.z(` >> ignored (not included) ${c.path}`):this.f.work(c))}u(c){const u=(0,w.$Bp)(c);if(u.length>0){if(this.m)for(const g of u)this.z(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(c){if($.$f)return E.Promises.exists(c);try{const u=(0,b.$_c)(c);return(await E.Promises.readdir((0,b.$$c)(c))).some(g=>g===u)}catch(u){return this.z(u),!1}}setVerboseLogging(c){this.m=c}w(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}y(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}z(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Qp=l,l.a=100,l.b=75;async function d(m,c,u,h,g=512){const y=await E.Promises.open(m,"r"),p=Buffer.allocUnsafe(g),t=new r.$oc(h);let i,a=!1;const s={path:m,excludes:[],recursive:!1},n=new l(s,o=>{(async()=>{for(const{type:f}of o)if(f===0){if(a)return;a=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:k}=await E.Promises.read(y,p,0,g,null);if(!k||t.token.isCancellationRequested)break;c(p.slice(0,k))}}catch(k){i=new Error(k),t.dispose(!0)}finally{a=!1}}})()});return await n.ready,u(),new Promise((o,f)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await E.Promises.close(y)}catch(k){i=new Error(k)}i?f(i):o()})})}e.$Rp=d}),define(we[218],be([1,0,5,76,2,3,217]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class P extends r.$lb{constructor(){super(...arguments),this.a=this.B(new v.$ec),this.onDidChangeFile=this.a.event,this.b=this.B(new v.$ec),this.onDidLogMessage=this.b.event,this.onDidError=v.Event.None,this.c=new Map,this.f=!1}async watch($){const A=this.i($),E=A.filter(l=>{const d=this.c.get(l.path);return d?!(0,R.$ij)(d.request.excludes,l.excludes)||!(0,R.$ij)(d.request.includes,l.includes):!0}),w=Array.from(this.c.values()).filter(({request:l})=>!A.find(d=>d.path===l.path&&(0,R.$ij)(d.excludes,l.excludes)&&(0,R.$ij)(d.includes,l.includes))).map(({request:l})=>l.path);E.length&&this.j(`Request to start watching: ${E.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"})`).join(",")}`),w.length&&this.j(`Request to stop watching: ${w.join(",")}`);for(const l of w)this.h(l);for(const l of E)this.g(l)}g($){const A=new I.$Qp($,w=>this.a.fire(w),w=>this.b.fire(w),this.f),E={request:$,instance:A};this.c.set($.path,E)}async stop(){for(const[$]of this.c)this.h($);this.c.clear()}h($){const A=this.c.get($);A&&(this.c.delete($),A.instance.dispose())}i($){const A=new Map;for(const E of $){const w=S.$f?E.path:E.path.toLowerCase();A.set(w,E)}return Array.from(A.values())}async setVerboseLogging($){this.f=$;for(const[,A]of this.c)A.instance.setVerboseLogging($)}j($){this.f&&this.b.fire({type:"trace",message:this.k($)})}k($,A){return A?`[File Watcher (node.js)] ${$} (path: ${A.request.path})`:`[File Watcher (node.js)] ${$}`}}e.$Sp=P}),define(we[219],be([1,0,67,218]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class r extends v.$yp{constructor(I,P,b){super(I,P,b),this.m()}l(){return new R.$Sp}}e.$Tp=r}),define(we[220],be([1,0,13,42,108,67]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class I extends S.$zp{constructor(b,$,A){super(b,$,A),this.m()}l(b){const $=b.add(new r.$Kp(v.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add($.onDidProcessExit(({code:A,signal:E})=>this.n(`terminated by itself with code ${A}, signal: ${E}`))),R.ProxyChannel.toService((0,R.$9g)($.getChannel("watcher")))}}e.$Lp=I}),define(we[83],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class v{constructor(...r){this.a=new Map;for(const[S,I]of r)this.set(S,I)}set(r,S){const I=this.a.get(r);return this.a.set(r,S),I}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$nh=v}),define(we[112],be([1,0,14,11,2,65,213,6,83,98]),function(le,e,v,R,r,S,I,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0;const A=!1;class E extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class w{constructor(c=new b.$nh,u=!1,h,g=A){this.f=c,this.g=u,this.h=h,this.i=g,this.o=new Set,this.f.set(P.$oh,this),this._globalGraph=g?h?._globalGraph??new I.$Wp(y=>y):void 0}createChild(c){return new w(c,this.g,this,this.i)}invokeFunction(c,...u){const h=d.traceInvocation(this.i,c);let g=!1;try{return c({get:p=>{if(g)throw(0,R.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(p,h);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...u)}finally{g=!0,h.stop()}}createInstance(c,...u){let h,g;return c instanceof S.$mh?(h=d.traceCreation(this.i,c.ctor),g=this.j(c.ctor,c.staticArguments.concat(u),h)):(h=d.traceCreation(this.i,c),g=this.j(c,u,h)),h.stop(),g}j(c,u=[],h){const g=P._util.getServiceDependencies(c).sort((t,i)=>t.index-i.index),y=[];for(const t of g){const i=this.m(t.id,h);i||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),y.push(i)}const p=g.length>0?g[0].index:u.length;if(u.length!==p){console.trace(`[createInstance] First service dependency of ${c.name} at position ${p+1} conflicts with ${u.length} static arguments`);const t=p-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,p)}return Reflect.construct(c,u.concat(y))}k(c,u){if(this.f.get(c)instanceof S.$mh)this.f.set(c,u);else if(this.h)this.h.k(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const u=this.f.get(c);return!u&&this.h?this.h.l(c):u}m(c,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const h=this.l(c);return h instanceof S.$mh?this.q(c,h,u.branch(c,!0)):(u.branch(c,!1),h)}q(c,u,h){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,u,h)}finally{this.o.delete(c)}}r(c,u,h){const g=new I.$Wp(t=>t.id.toString());let y=0;const p=[{id:c,desc:u,_trace:h}];for(;p.length;){const t=p.pop();if(g.lookupOrInsertNode(t),y++>1e3)throw new E(g);for(const i of P._util.getServiceDependencies(t.desc.ctor)){const a=this.l(i.id);if(a||this.u(`[createInstance] ${c} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(i.id)),a instanceof S.$mh){const s={id:i.id,desc:a,_trace:t._trace.branch(i.id,!0)};g.insertEdge(t,s),p.push(s)}}}for(;;){const t=g.roots();if(t.length===0){if(!g.isEmpty())throw new E(g);break}for(const{data:i}of t){if(this.l(i.id)instanceof S.$mh){const s=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,s)}g.removeNode(i)}}return this.l(c)}s(c,u,h=[],g,y){if(this.f.get(c)instanceof S.$mh)return this.t(c,u,h,g,y);if(this.h)return this.h.s(c,u,h,g,y);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(c,u,h=[],g,y){if(g){const p=new w(void 0,this.g,this,this.i);p.c=String(c);const t=new Map,i=new v.$Lg(()=>{const a=p.j(u,h,y);for(const[s,n]of t){const o=a[s];if(typeof o=="function")for(const f of n)o.apply(a,f)}return t.clear(),a});return new Proxy(Object.create(null),{get(a,s){if(!i.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let f=t.get(s);return f||(f=new $.$ub,t.set(s,f)),(D,C,L)=>{const U=f.push([D,C,L]);return(0,r.$jb)(U)}}if(s in a)return a[s];const n=i.value;let o=n[s];return typeof o!="function"||(o=o.bind(n),a[s]=o),o},set(a,s,n){return i.value[s]=n,!0},getPrototypeOf(a){return u.prototype}})}else return this.j(u,h,y)}u(c,u){if(u&&console.warn(c),this.g)throw new Error(c)}}e.$Xp=w;var l;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(l||(l={}));class d{static traceInvocation(c,u){return c?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(c,u){return c?new d(1,u.name):d.c}constructor(c,u){this.type=c,this.name=u,this.g=Date.now(),this.h=[]}branch(c,u){const h=new d(3,c.toString());return this.h.push([c,u,h]),h}stop(){const c=Date.now()-this.g;d.f+=c;let u=!1;function h(y,p){const t=[],i=new Array(y+1).join("	");for(const[a,s,n]of p.h)if(s&&n){u=!0,t.push(`${i}CREATES -> ${a}`);const o=h(y+1,n);o&&t.push(o)}else t.push(`${i}uses -> ${a}`);return t.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(c>2||u)&&d.all.add(g.join(`
`))}}e.$Yp=d,d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0}),define(we[221],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$Lz=void 0,e.$Lz=(0,v.$ph)("labelService");var R;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(R||(e.Verbosity=R={}))});var Ie=this&&this.__param||function(le,e){return function(v,R){e(v,R,le)}};define(we[84],be([1,0,20,2,3,188,31,6]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=e.$zq=void 0;function b(A){return A.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$zq=b,e.$Aq=(0,P.$ph)("languagePackService");let $=class extends R.$lb{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new v.$oc;setTimeout(()=>E.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const d=w.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(c=>c.startsWith("lp-"))).map(m=>{const c=m.properties.localizedLanguages?.[0],u=b(m);return{...this.f(u,c,m),extensionId:m.identifier.id,galleryExtension:m}});return d.push(this.f("en","English")),d}f(E,w,l){const d=w??E;let m;if(d!==E&&(m=`(${E})`),E.toLowerCase()===r.$q.toLowerCase()&&(m??(m=""),m+=(0,S.localize)(0,null)),l?.installCount){m??(m="");const c=l.installCount;let u;c>1e6?u=`${Math.floor(c/1e5)/10}M`:c>1e3?u=`${Math.floor(c/1e3)}K`:u=String(c),m+=` $(cloud-download) ${u}`}return{id:E,label:d,description:m}}};e.$Bq=$,e.$Bq=$=Le([Ie(0,I.$Sn)],$)}),define(we[12],be([1,0,39,5,61,2,28,3,19,8,4,66,6]),function(le,e,v,R,r,S,I,P,b,$,A,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,w.$ph)("logService"),e.$Si=(0,w.$ph)("loggerService");function l(){return new Date().toISOString()}function d(D){return(0,$.$me)(D)}e.$Ti=d;var m;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Ui=m.Info;function c(D,C,L){switch(C){case m.Trace:D.trace(L);break;case m.Debug:D.debug(L);break;case m.Info:D.info(L);break;case m.Warning:D.warn(L);break;case m.Error:D.error(L);break;case m.Off:break;default:throw new Error(`Invalid log level ${C}`)}}e.log=c;function u(D,C=!1){let L="";for(let U=0;U<D.length;U++){let x=D[U];if(x instanceof Error&&(x=(0,v.$ai)(x,C)),typeof x=="object")try{x=JSON.stringify(x)}catch{}L+=(U>0?" ":"")+x}return L}class h extends S.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new R.$ec),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==m.Off&&this.b<=C}}e.$Wi=h;class g extends h{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...L){this.f(m.Trace)&&this.g(m.Trace,u([C,...L],!0))}debug(C,...L){this.f(m.Debug)&&this.g(m.Debug,u([C,...L]))}info(C,...L){this.f(m.Info)&&this.g(m.Info,u([C,...L]))}warn(C,...L){this.f(m.Warning)&&this.g(m.Warning,u([C,...L]))}error(C,...L){if(this.f(m.Error))if(C instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=C.stack,this.g(m.Error,u(U))}else this.g(m.Error,u([C,...L]))}flush(){}}e.$Xi=g;class y extends h{constructor(C=e.$Ui){super(),this.setLevel(C),this.g=!P.$d}trace(C,...L){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,C,...L):console.log(`[main ${l()}]`,C,...L))}debug(C,...L){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,C,...L):console.log(`[main ${l()}]`,C,...L))}info(C,...L){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,C,...L):console.log(`[main ${l()}]`,C,...L))}warn(C,...L){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,C,...L):console.warn(`[main ${l()}]`,C,...L))}error(C,...L){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,C,...L):console.error(`[main ${l()}]`,C,...L))}dispose(){}flush(){}}e.$Yi=y;class p extends h{constructor(C=e.$Ui,L=!0){super(),this.g=L,this.setLevel(C)}trace(C,...L){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...L):console.log(C,...L))}debug(C,...L){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...L):console.log(C,...L))}info(C,...L){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...L):console.log(C,...L))}warn(C,...L){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...L):console.log(C,...L))}error(C,...L){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...L):console.error(C,...L))}dispose(){}flush(){}}e.$Zi=p;class t extends h{constructor(C,L=e.$Ui){super(),this.g=C,this.setLevel(L)}trace(C,...L){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(C),...L])}debug(C,...L){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(C),...L])}info(C,...L){this.f(m.Info)&&this.g.log(m.Info,[this.h(C),...L])}warn(C,...L){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(C),...L])}error(C,...L){this.f(m.Error)&&this.g.log(m.Error,[this.h(C),...L])}h(C){return typeof C=="string"?C:(0,v.$ai)(C,this.f(m.Trace))}dispose(){}flush(){}}e.$1i=t;class i extends h{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const L of this.g)L.setLevel(C);super.setLevel(C)}trace(C,...L){for(const U of this.g)U.trace(C,...L)}debug(C,...L){for(const U of this.g)U.debug(C,...L)}info(C,...L){for(const U of this.g)U.info(C,...L)}warn(C,...L){for(const U of this.g)U.warn(C,...L)}error(C,...L){for(const U of this.g)U.error(C,...L)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose()}}e.$2i=i;class a extends S.$lb{constructor(C,L,U){if(super(),this.h=C,this.j=L,this.b=new I.$ni,this.c=this.B(new R.$ec),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$ec),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$ec),this.onDidChangeVisibility=this.g.event,U)for(const x of U)this.b.set(x.resource,{logger:void 0,info:x})}k(C){return(0,$.$ie)(C)?[...this.b.values()].find(L=>L.info.id===C):this.b.get(C)}getLogger(C){return this.k(C)?.logger}createLogger(C,L){const U=this.l(C),x=(0,$.$ie)(C)?C:L?.id??(0,r.$di)(U.toString()).toString(16);let ae=this.b.get(U)?.logger;const W=L?.logLevel==="always"?m.Trace:L?.logLevel;ae||(ae=this.m(U,W??this.getLogLevel(U)??this.h,{...L,id:x}));const te={logger:ae,info:{resource:U,id:x,logLevel:W,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(te.info),this.b.set(U,te),ae}l(C){return(0,$.$ie)(C)?(0,b.$9f)(this.j,`${C}.log`):C}setLogLevel(C,L){if(A.URI.isUri(C)){const U=C,x=L,ae=this.b.get(U);ae&&x!==ae.info.logLevel&&(ae.info.logLevel=x===this.h?void 0:x,ae.logger?.setLevel(x),this.b.set(ae.info.resource,ae),this.f.fire([U,x]))}else{this.h=C;for(const[U,x]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&x.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,L){const U=this.k(C);U&&L!==!U.info.hidden&&(U.info.hidden=!L,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,L]))}getLogLevel(C){let L;return C&&(L=this.b.get(C)?.info.logLevel),L??this.h}registerLogger(C){const L=this.b.get(C.resource);L?L.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const L=this.b.get(C);L&&(L.logger&&L.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=a;class s{constructor(){this.onDidChangeLogLevel=new R.$ec().event}setLevel(C){}getLevel(){return m.Info}trace(C,...L){}debug(C,...L){}info(C,...L){}warn(C,...L){}error(C,...L){}critical(C,...L){}dispose(){}flush(){}}e.$4i=s;class n extends s{}e.$5i=n;function o(D){if(D.verbose)return m.Trace;if(typeof D.logLevel=="string"){const C=k(D.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Ui}e.$6i=o;function f(D){switch(D){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$7i=f;function k(D){switch(D){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$8i=k,e.$9i=new E.$Oi("logLevel",f(m.Info))}),define(we[222],be([1,0,80,5,2,12,3,14]),function(le,e,v,R,r,S,I,P){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0;let $=b=class extends r.$lb{constructor(E){super(),this.h=E,this.c=this.B(new R.$ec),this.onDidChangePassword=this.c.event,this.g=new P.$qg}async getPassword(E,w){this.h.trace("Going to get password from keytar:",E,w);let l;try{l=await this.i()}catch{return null}return await this.g.queue(E+w,()=>this.k(l,E,w))}async k(E,w,l){this.h.trace("Doing get password from keytar:",w,l);const d=await(0,P.$Mg)(()=>E.getPassword(w,l),50,3);if(!d)return this.h.trace("Did not get a password from keytar for account:",l),d;let m,c;try{const u=JSON.parse(d);m=u.content,c=u.hasNextChunk}catch{}if(!m||!c)return this.h.trace("Got password from keytar for account:",l),d;try{let u=1;for(;c;){const h=await(0,P.$Mg)(()=>E.getPassword(w,`${l}-${u}`),50,3),g=JSON.parse(h);m+=g.content,c=g.hasNextChunk,u++}return this.h.trace(`Got ${u}-chunked password from keytar for account:`,l),m}catch(u){return this.h.error(u),d}}async setPassword(E,w,l){this.h.trace("Going to set password using keytar:",E,w);let d;try{d=await this.i()}catch(m){throw this.j?.(m),m}await this.g.queue(E+w,()=>this.l(d,E,w,l)),this.c.fire({service:E,account:w})}async l(E,w,l,d){if(this.h.trace("Doing set password from keytar:",w,l),!I.$d){await(0,P.$Mg)(()=>E.setPassword(w,l,d),50,3),this.h.trace("Set password from keytar for account:",l);return}if(await this.m(E,w,l),d.length<=b.b){await(0,P.$Mg)(()=>E.setPassword(w,l,d),50,3),this.h.trace("Set password from keytar for account:",l);return}let m=0,c=0,u=!0;for(;u;){const h=d.substring(m,m+b.b);m+=b.b,u=d.length-m>0;const g={content:h,hasNextChunk:u};await(0,P.$Mg)(()=>E.setPassword(w,c?`${l}-${c}`:l,JSON.stringify(g)),50,3),c++}this.h.trace(`Set${c?` ${c}-chunked`:""} password from keytar for account:`,l)}async deletePassword(E,w){this.h.trace("Going to delete password using keytar:",E,w);let l;try{l=await this.i()}catch(m){throw this.j?.(m),m}const d=await this.g.queue(E+w,()=>this.m(l,E,w));return d&&this.c.fire({service:E,account:w}),d}async m(E,w,l){this.h.trace("Doing delete password from keytar:",w,l);const d=await E.getPassword(w,l);if(!d)return this.h.trace("Did not get a password to delete from keytar for account:",l),!1;let m,c;try{const h=JSON.parse(d);m=h.content,c=h.hasNextChunk}catch{}let u=0;if(m&&c)try{for(u++;c;){const h=`${l}-${u}`,g=await E.getPassword(w,h);await E.deletePassword(w,h),c=JSON.parse(g).hasNextChunk,u++}}catch(h){this.h.error(h)}return await E.deletePassword(w,l)?(this.h.trace(`Deleted${u?` ${u}-chunked`:""} password from keytar for account:`,l),!0):(this.h.trace(`Keytar failed to delete${u?` ${u}-chunked`:""} password for account:`,l),!1)}async findPassword(E){let w;try{w=await this.i()}catch{return null}return await w.findPassword(E)}async findCredentials(E){let w;try{w=await this.i()}catch{return[]}return await w.findCredentials(E)}clear(){return this.f instanceof v.$qn?this.f.clear():Promise.resolve()}};e.$rn=$,$.a=2500,$.b=b.a-100,e.$rn=$=b=Le([Ie(0,S.$Ri)],$)}),define(we[223],be([1,0,18,14,11,5,2,7,67,12]),function(le,e,v,R,r,S,I,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;class A extends I.$lb{constructor(w,l){super(),this.a=w,this.b=l,this.c=this.B(new S.$ec),this.onDidChangeFile=this.c.event,this.g=this.B(new S.$ec),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.$sg(0)),this.s=[],this.t=this.B(new R.$sg(0))}watch(w,l){return l.recursive||this.b?.watcher?.forceUniversal?this.l(w,l):this.u(w,l)}l(w,l){const d={path:this.C(w),excludes:l.excludes,includes:l.includes,recursive:l.recursive},m=(0,v.$yf)(this.j,d);return this.m(),(0,I.$jb)(()=>{m(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(w=>(0,r.$Y)(w))}n(){this.h||(this.h=this.B(this.p(l=>this.c.fire((0,b.$Ap)(l)),l=>this.z(l),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const l of this.j)(0,b.$wp)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const l of this.j)(0,b.$wp)(l)&&w.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(w,l){const d={path:this.C(w),excludes:l.excludes,includes:l.includes,recursive:!1},m=(0,v.$yf)(this.s,d);return this.v(),(0,I.$jb)(()=>{m(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(w=>(0,r.$Y)(w))}w(){return this.r||(this.r=this.B(this.y(w=>this.c.fire((0,b.$Ap)(w)),w=>this.z(w),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.r.watch(this.s)}z(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}C(w){return(0,P.$6c)(w.fsPath)}}e.$Ep=A}),define(we[113],be([1,0,18,14,15,20,5,61,47,2,63,13,41,19,48,184,16,111,12,11]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;let y=class extends $.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new I.$ec),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$ec),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$ec),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new I.$ec),this.onDidRunOperation=this.m.event,this.R=this.B(new I.$ec),this.onDidFilesChange=this.R.event,this.S=this.B(new I.$ec),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new R.$Dg)}registerProvider(t,i){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${t}`);const a=new $.$kb;return this.h.set(t,i),this.c.fire({added:!0,scheme:t,provider:i}),a.add(i.onDidChangeFile(s=>this.R.fire(new c.$$j(s,!this.O(i))))),typeof i.onDidWatchError=="function"&&a.add(i.onDidWatchError(s=>this.S.fire(new Error(s)))),a.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:t}))),(0,$.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:i}),this.h.delete(t),(0,$.$gb)(a)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const i=[];this.f.fire({scheme:t,join(a){i.push(a)}}),!this.h.has(t)&&await R.Promises.settled(i)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,i){const a=this.h.get(t.scheme);return!!(a&&a.capabilities&i)}listCapabilities(){return b.Iterable.map(this.h,([t,i])=>({scheme:t,capabilities:i.capabilities}))}async j(t){if(!(0,l.$ag)(t))throw new c.$ak((0,m.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const i=this.h.get(t.scheme);if(!i){const a=new g.$ab;throw a.message=(0,m.localize)(1,null,t.toString()),a}return i}async k(t){const i=await this.j(t);if((0,c.$Xj)(i)||(0,c.$Uj)(i)||(0,c.$Yj)(i))return i;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const i=await this.j(t);if((0,c.$Xj)(i)||(0,c.$Uj)(i))return i;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,i){try{return await this.n(t,i)}catch(a){throw(0,c.$8j)(a)===c.FileSystemProviderErrorCode.FileNotFound?new c.$ak((0,m.localize)(2,null,this.nb(t)),1):(0,c.$6j)(a)}}async n(t,i){const a=await this.j(t),s=this.O(a),n=i?.resolveTo,o=i?.resolveSingleChildDescendants,f=i?.resolveMetadata,k=await a.stat(t);let D;return this.p(a,t,k,void 0,!!f,(C,L)=>(D||(D=A.$vh.forUris(()=>!s),D.set(t,!0),n&&D.fill(!0,n)),D.get(C.resource)||D.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&o?L===1:!1))}async p(t,i,a,s,n,o){const{providerExtUri:f}=this.N(t),k={resource:i,name:f.basename(i),isFile:(a.type&c.FileType.File)!==0,isDirectory:(a.type&c.FileType.Directory)!==0,isSymbolicLink:(a.type&c.FileType.SymbolicLink)!==0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:!!((a.permissions??0)&c.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((a.permissions??0)&c.FilePermission.Locked),etag:(0,c.$lk)({mtime:a.mtime,size:a.size}),children:void 0};if(k.isDirectory&&o(k,s)){try{const D=await t.readdir(i),C=await R.Promises.settled(D.map(async([L,U])=>{try{const x=f.joinPath(i,L),ae=n?await t.stat(x):{type:U};return await this.p(t,x,ae,D.length,n,o)}catch(x){return this.b.trace(x),null}}));k.children=(0,v.$jf)(C)}catch(D){this.b.trace(D),k.children=[]}return k}return k}async resolveAll(t){return R.Promises.settled(t.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(a){return this.b.trace(a),{stat:void 0,success:!1}}}))}async stat(t){const i=await this.j(t),a=await i.stat(t);return this.p(i,t,a,void 0,!0,()=>!1)}async exists(t){const i=await this.j(t);try{return!!await i.stat(t)}catch{return!1}}async canCreateFile(t,i){try{await this.r(t,i)}catch(a){return a}return!0}async r(t,i){if(!i?.overwrite&&await this.exists(t))throw new c.$ak((0,m.localize)(3,null,this.nb(t)),3,i)}async createFile(t,i=r.$Ec.fromString(""),a){await this.r(t,a);const s=await this.writeFile(t,i);return this.m.fire(new c.$0j(t,0,s)),s}async writeFile(t,i,a){const s=this.lb(await this.l(t),t),{providerExtUri:n}=this.N(s);try{await this.s(s,t,a)||await this.P(s,n.dirname(t));let f;if((0,c.$Uj)(s)&&!(i instanceof r.$Ec))if((0,d.$qc)(i)){const k=await(0,d.$xc)(i,3);k.ended?f=r.$Ec.concat(k.buffer):f=k}else f=(0,d.$uc)(i,k=>r.$Ec.concat(k),3);else f=i;if(!(0,c.$Xj)(s)||(0,c.$Uj)(s)&&f instanceof r.$Ec)await this.cb(s,t,a,f);else{const k=f instanceof r.$Ec?(0,r.$Pc)(f):f;a?.atomic!==!1&&a?.atomic?.postfix?await this.Y(s,t,(0,l.$9f)((0,l.$8f)(t),`${(0,l.$6f)(t)}${a.atomic.postfix}`),a,k):await this.Z(s,t,a,k)}this.m.fire(new c.$0j(t,4))}catch(o){throw new c.$ak((0,m.localize)(4,null,this.nb(t),(0,c.$6j)(o).toString()),(0,c.$9j)(o),a)}return this.resolve(t,{resolveMetadata:!0})}async s(t,i,a){const s=!!a?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,m.localize)(5,null,this.nb(i)));if(!!a?.atomic){if(!(t.capabilities&32768))throw new Error((0,m.localize)(6,null,this.nb(i)));if(s)throw new Error((0,m.localize)(7,null,this.nb(i)))}let o;try{o=await t.stat(i)}catch{return}if(o.type&c.FileType.Directory)throw new c.$ak((0,m.localize)(8,null,this.nb(i)),0,a);if(this.mb(i,o),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==c.$kk&&typeof o.mtime=="number"&&typeof o.size=="number"&&a.mtime<o.mtime&&a.etag!==(0,c.$lk)({mtime:a.mtime,size:o.size}))throw new c.$ak((0,m.localize)(9,null),3,a);return o}async readFile(t,i,a){const s=await this.k(t);return i?.atomic?this.t(s,t,i,a):this.u(s,t,i,a)}async t(t,i,a,s){return new Promise((n,o)=>{this.X.queueFor(i,this.N(t).providerExtUri).queue(async()=>{try{const f=await this.u(t,i,a,s);n(f)}catch(f){o(f)}})})}async u(t,i,a,s){const n=await this.v(t,i,{...a,preferUnbuffered:!0},s);return{...n,value:await(0,r.$Qc)(n.value)}}async readFileStream(t,i,a){const s=await this.k(t);return this.v(s,t,i,a)}async v(t,i,a,s){const n=new S.$oc(s),o=this.F(i,a).then(k=>k,k=>{throw n.cancel(),k});let f;try{return typeof a?.etag=="string"&&a.etag!==c.$kk&&await o,a?.atomic&&(0,c.$Zj)(t)||!((0,c.$Xj)(t)||(0,c.$Yj)(t))||(0,c.$Uj)(t)&&a?.preferUnbuffered?f=this.D(t,i,a):(0,c.$Yj)(t)?f=this.z(t,i,n.token,a):f=this.C(t,i,n.token,a),{...await o,value:f}}catch(k){throw f&&await(0,d.$vc)(f),this.w(k,i,a)}}w(t,i,a){const s=(0,m.localize)(10,null,this.nb(i),(0,c.$6j)(t).toString());return t instanceof c.$ck?new c.$ck(s,t.stat,a):t instanceof c.$bk?new c.$bk(s,t.fileOperationResult,t.size,t.options):new c.$ak(s,(0,c.$9j)(t),a)}z(t,i,a,s=Object.create(null)){const n=t.readFileStream(i,s,a);return(0,d.$Bc)(n,{data:o=>o instanceof r.$Ec?o:r.$Ec.wrap(o),error:o=>this.w(o,i,s)},o=>r.$Ec.concat(o))}C(t,i,a,s=Object.create(null)){const n=(0,r.$Uc)();return(0,u.$up)(t,i,n,o=>o,{...s,bufferSize:this.a,errorTransformer:o=>this.w(o,i,s)},a),n}D(t,i,a){const s=(0,d.$sc)(n=>r.$Ec.concat(n));return(async()=>{try{let n;a?.atomic&&(0,c.$Zj)(t)?n=await t.readFile(i,{atomic:!0}):n=await t.readFile(i),typeof a?.position=="number"&&(n=n.slice(a.position)),typeof a?.length=="number"&&(n=n.slice(0,a.length)),this.G(i,n.byteLength,a),s.end(r.$Ec.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async F(t,i){const a=await this.resolve(t,{resolveMetadata:!0});if(a.isDirectory)throw new c.$ak((0,m.localize)(11,null,this.nb(t)),0,i);if(typeof i?.etag=="string"&&i.etag!==c.$kk&&i.etag===a.etag)throw new c.$ck((0,m.localize)(12,null),a,i);return this.G(t,a.size,i),a}G(t,i,a){if(typeof a?.limits?.size=="number"&&i>a.limits.size)throw new c.$bk((0,m.localize)(13,null,this.nb(t)),7,i,a)}async canMove(t,i,a){return this.H(t,i,"move",a)}async canCopy(t,i,a){return this.H(t,i,"copy",a)}async H(t,i,a,s){if(t.toString()!==i.toString())try{const n=a==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(i),i);await this.M(n,t,o,i,a,s)}catch(n){return n}return!0}async move(t,i,a){const s=this.lb(await this.l(t),t),n=this.lb(await this.l(i),i),o=await this.I(s,t,n,i,"move",!!a),f=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,o==="move"?2:3,f)),f}async copy(t,i,a){const s=await this.k(t),n=this.lb(await this.l(i),i),o=await this.I(s,t,n,i,"copy",!!a),f=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,o==="copy"?3:2,f)),f}async I(t,i,a,s,n,o){if(i.toString()===s.toString())return n;const{exists:f,isSameResourceWithDifferentPathCase:k}=await this.M(t,i,a,s,n,o);if(f&&!k&&o&&await this.del(s,{recursive:!0}),await this.P(a,this.N(a).providerExtUri.dirname(s)),n==="copy"){if(t===a&&(0,c.$Vj)(t))await t.copy(i,s,{overwrite:o});else{const D=await this.resolve(i);D.isDirectory?await this.L(t,D,a,s):await this.J(t,i,a,s)}return n}else return t===a?(await t.rename(i,s,{overwrite:o}),n):(await this.I(t,i,a,s,"copy",o),await this.del(i,{recursive:!0}),"copy")}async J(t,i,a,s){if((0,c.$Xj)(t)&&(0,c.$Xj)(a))return this.eb(t,i,a,s);if((0,c.$Xj)(t)&&(0,c.$Uj)(a))return this.kb(t,i,a,s);if((0,c.$Uj)(t)&&(0,c.$Xj)(a))return this.ib(t,i,a,s);if((0,c.$Uj)(t)&&(0,c.$Uj)(a))return this.gb(t,i,a,s)}async L(t,i,a,s){await a.mkdir(s),Array.isArray(i.children)&&await R.Promises.settled(i.children.map(async n=>{const o=this.N(a).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.L(t,await this.resolve(n.resource),a,o):this.J(t,n.resource,a,o)}))}async M(t,i,a,s,n,o){let f=!1;if(t===a){const{providerExtUri:D,isPathCaseSensitive:C}=this.N(t);if(C||(f=D.isEqual(i,s)),f&&n==="copy")throw new Error((0,m.localize)(14,null,this.nb(i),this.nb(s)));if(!f&&D.isEqualOrParent(s,i))throw new Error((0,m.localize)(15,null,this.nb(i),this.nb(s)))}const k=await this.exists(s);if(k&&!f){if(!o)throw new c.$ak((0,m.localize)(16,null,this.nb(i),this.nb(s)),4);if(t===a){const{providerExtUri:D}=this.N(t);if(D.isEqualOrParent(i,s))throw new Error((0,m.localize)(17,null,this.nb(i),this.nb(s)))}}return{exists:k,isSameResourceWithDifferentPathCase:f}}N(t){const i=this.O(t);return{providerExtUri:i?l.$Yf:l.$1f,isPathCaseSensitive:i}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const i=this.lb(await this.j(t),t);await this.P(i,t);const a=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,0,a)),a}async P(t,i){const a=[],{providerExtUri:s}=this.N(t);for(;!s.isEqual(i,s.dirname(i));)try{if(!((await t.stat(i)).type&c.FileType.Directory))throw new Error((0,m.localize)(18,null,this.nb(i)));break}catch(n){if((0,c.$8j)(n)!==c.FileSystemProviderErrorCode.FileNotFound)throw n;a.push(s.basename(i)),i=s.dirname(i)}for(let n=a.length-1;n>=0;n--){i=s.joinPath(i,a[n]);try{await t.mkdir(i)}catch(o){if((0,c.$8j)(o)!==c.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,i){try{await this.Q(t,i)}catch(a){return a}return!0}async Q(t,i){const a=this.lb(await this.j(t),t),s=!!i?.useTrash;if(s&&!(a.capabilities&4096))throw new Error((0,m.localize)(19,null,this.nb(t)));const n=i?.atomic;if(n&&!(a.capabilities&65536))throw new Error((0,m.localize)(20,null,this.nb(t)));if(s&&n)throw new Error((0,m.localize)(21,null,this.nb(t)));let o;try{o=await a.stat(t)}catch{}if(o)this.mb(t,o);else throw new c.$ak((0,m.localize)(22,null,this.nb(t)),1);if(!!!i?.recursive){const k=await this.resolve(t);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,m.localize)(23,null,this.nb(t)))}return a}async del(t,i){const a=await this.Q(t,i),s=!!i?.useTrash,n=!!i?.recursive,o=i?.atomic??!1;await a.delete(t,{recursive:n,useTrash:s,atomic:o}),this.m.fire(new c.$0j(t,1))}async cloneFile(t,i){const a=await this.j(t),s=this.lb(await this.l(i),i);if(a===s&&this.N(a).providerExtUri.isEqual(t,i))return;if(a===s&&(0,c.$Wj)(a))return a.cloneFile(t,i);await this.P(s,this.N(s).providerExtUri.dirname(i));const n=this.X.queueFor(t,this.N(a).providerExtUri);return a===s&&(0,c.$Vj)(a)?n.queue(()=>a.copy(t,i,{overwrite:!0})):n.queue(()=>this.J(a,t,s,i))}watch(t,i={recursive:!1,excludes:[]}){const a=new $.$kb;let s=!1,n=()=>{s=!0};return a.add((0,$.$jb)(()=>n())),(async()=>{try{const o=await this.W(t,i);s?(0,$.$gb)(o):n=()=>(0,$.$gb)(o)}catch(o){this.b.error(o)}})(),a}async W(t,i){const a=await this.j(t),s=(0,P.$di)([this.N(a).providerExtUri.getComparisonKey(t),i]);let n=this.U.get(s);return n||(n={count:0,disposable:a.watch(t,i)},this.U.set(s,n)),n.count+=1,(0,$.$jb)(()=>{n&&(n.count--,n.count===0&&((0,$.$gb)(n.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,$.$gb)(t.disposable);this.U.clear()}async Y(t,i,a,s,n){await this.Z(t,a,s,n);try{await t.rename(a,i,{overwrite:!0})}catch(o){try{await t.delete(a,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async Z(t,i,a,s){return this.X.queueFor(i,this.N(t).providerExtUri).queue(async()=>{const n=await t.open(i,{create:!0,unlock:a?.unlock??!1});try{(0,d.$qc)(s)||(0,d.$rc)(s)?await this.$(t,n,s):await this.ab(t,n,s)}catch(o){throw(0,c.$6j)(o)}finally{await t.close(n)}})}async $(t,i,a){let s=0,n;if((0,d.$rc)(a)){if(a.buffer.length>0){const o=r.$Ec.concat(a.buffer);await this.bb(t,i,o,o.byteLength,s,0),s+=o.byteLength}if(a.ended)return;n=a.stream}else n=a;return new Promise((o,f)=>{(0,d.$wc)(n,{onData:async k=>{n.pause();try{await this.bb(t,i,k,k.byteLength,s,0)}catch(D){return f(D)}s+=k.byteLength,setTimeout(()=>n.resume())},onError:k=>f(k),onEnd:()=>o()})})}async ab(t,i,a){let s=0,n;for(;(n=a.read())!==null;)await this.bb(t,i,n,n.byteLength,s,0),s+=n.byteLength}async bb(t,i,a,s,n,o){let f=0;for(;f<s;){const k=await t.write(i,n+f,a.buffer,o+f,s-f);f+=k}}async cb(t,i,a,s){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.db(t,i,a,s))}async db(t,i,a,s){let n;s instanceof r.$Ec?n=s:(0,d.$qc)(s)?n=await(0,r.$Qc)(s):(0,d.$rc)(s)?n=await(0,r.$Rc)(s):n=(0,r.$Oc)(s),await t.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1,atomic:a?.atomic??!1})}async eb(t,i,a,s){return this.X.queueFor(s,this.N(a).providerExtUri).queue(()=>this.fb(t,i,a,s))}async fb(t,i,a,s){let n,o;try{n=await t.open(i,{create:!1}),o=await a.open(s,{create:!0,unlock:!1});const f=r.$Ec.alloc(this.a);let k=0,D=0,C=0;do C=await t.read(n,k,f.buffer,D,f.byteLength-D),await this.bb(a,o,f,C,k,D),k+=C,D+=C,D===f.byteLength&&(D=0);while(C>0)}catch(f){throw(0,c.$6j)(f)}finally{await R.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?a.close(o):Promise.resolve()])}}async gb(t,i,a,s){return this.X.queueFor(s,this.N(a).providerExtUri).queue(()=>this.hb(t,i,a,s))}async hb(t,i,a,s){return a.writeFile(s,await t.readFile(i),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,i,a,s){return this.X.queueFor(s,this.N(a).providerExtUri).queue(()=>this.jb(t,i,a,s))}async jb(t,i,a,s){const n=await a.open(s,{create:!0,unlock:!1});try{const o=await t.readFile(i);await this.bb(a,n,r.$Ec.wrap(o),o.byteLength,0,0)}catch(o){throw(0,c.$6j)(o)}finally{await a.close(n)}}async kb(t,i,a,s){const n=await(0,r.$Qc)(this.C(t,i,S.CancellationToken.None));await this.cb(a,s,void 0,n)}lb(t,i){if(t.capabilities&2048)throw new c.$ak((0,m.localize)(24,null,this.nb(i)),6);return t}mb(t,i){if((i.permissions??0)&c.FilePermission.Readonly)throw new c.$ak((0,m.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};e.$vp=y,e.$vp=y=Le([Ie(0,h.$Ri)],y)}),define(we[68],be([1,0,30,300,14,28,15,5,38,2,7,3,19,48,21,187,16,111,223,39,220,219]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0,(()=>{try{(0,R.gracefulify)(v)}catch(i){console.error(`Error enabling graceful-fs: ${(0,g.$ai)(i)}`)}})();class t extends h.$Ep{constructor(a,s){super(a,s),this.onDidChangeCapabilities=P.Event.None,this.I=new S.$ni(n=>w.$Zf.getComparisonKey(n)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,E.$f&&(this.F|=1024)),this.F}async stat(a){try{const{stat:s,symbolicLink:n}=await d.SymlinkSupport.stat(this.C(a));return{type:this.H(s,n),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:c.FilePermission.Locked}}catch(s){throw this.ab(s)}}async G(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const s=await d.Promises.readdir(this.C(a),{withFileTypes:!0}),n=[];return await Promise.all(s.map(async o=>{try{let f;o.isSymbolicLink()?f=(await this.stat((0,w.$9f)(a,o.name))).type:f=this.H(o),n.push([o.name,f])}catch(f){this.a.trace(f)}})),n}catch(s){throw this.ab(s)}}H(a,s){let n;return s?.dangling?n=c.FileType.Unknown:a.isFile()?n=c.FileType.File:a.isDirectory()?n=c.FileType.Directory:n=c.FileType.Unknown,s&&(n|=c.FileType.SymbolicLink),n}async J(a){const s=this.C(a);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let n;for(;n=this.I.get(a);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await n.wait();const o=new r.$tg;return this.I.set(a,o),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,$.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.I.get(a)===o&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.I.delete(a)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),o.open()})}async readFile(a,s){let n;try{s?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(a)})`),n=await this.J(a));const o=this.C(a);return await d.Promises.readFile(o)}catch(o){throw this.ab(o)}finally{n?.dispose()}}L(a){t.D&&this.a.trace(a)}readFileStream(a,s,n){const o=(0,l.$sc)(f=>I.$Ec.concat(f.map(k=>I.$Ec.wrap(k))).buffer);return(0,u.$up)(this,a,o,f=>f.buffer,{...s,bufferSize:256*1024},n),o}async writeFile(a,s,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.M(a,(0,w.$9f)((0,w.$8f)(a),`${(0,w.$6f)(a)}${n.atomic.postfix}`),s,n):this.N(a,s,n)}async M(a,s,n,o){await this.N(s,n,o);try{await this.rename(s,a,{overwrite:!0})}catch(f){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw f}}async N(a,s,n){let o;try{const f=this.C(a);if(!n.create||!n.overwrite){if(await d.Promises.exists(f)){if(!n.overwrite)throw(0,c.$5j)((0,m.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,c.$5j)((0,m.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(a,{create:!0,unlock:n.unlock}),await this.write(o,0,s,0,s.byteLength)}catch(f){throw await this.bb(a,f)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(a){t.R=a}async open(a,s){const n=this.C(a);let o;(0,c.$Tj)(s)&&(o=await this.J(a));let f;try{if((0,c.$Tj)(s)&&s.unlock)try{const{stat:D}=await d.SymlinkSupport.stat(n);D.mode&128||await d.Promises.chmod(n,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let k;if((0,c.$Tj)(s)){if(E.$d)try{await d.Promises.truncate(n,0),k="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}k||(k="w")}else k="r";f=await d.Promises.open(n,k)}catch(k){throw o?.dispose(),(0,c.$Tj)(s)?await this.bb(a,k):this.ab(k)}if(this.O.set(f,0),(0,c.$Tj)(s)&&this.Q.set(f,a),o){const k=this.P.get(f);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${f} (${n})`),this.P.set(f,o),k&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${f} (${n})`),k.dispose())}return f}async close(a){const s=this.P.get(a);try{if(this.O.delete(a),this.Q.delete(a)&&t.R)try{await d.Promises.fdatasync(a)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await d.Promises.close(a)}catch(n){throw this.ab(n)}finally{s&&(this.P.get(a)===s&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.P.delete(a)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),s.dispose())}}async read(a,s,n,o,f){const k=this.S(a,s);let D=null;try{D=(await d.Promises.read(a,n,o,f,k)).bytesRead}catch(C){throw this.ab(C)}finally{this.U(a,k,D)}return D}S(a,s){return s===this.O.get(a)?null:s}U(a,s,n){const o=this.O.get(a);typeof o=="number"&&(typeof s=="number"||(typeof n=="number"?this.O.set(a,o+n):this.O.delete(a)))}async write(a,s,n,o,f){return(0,r.$Mg)(()=>this.W(a,s,n,o,f),100,3)}async W(a,s,n,o,f){const k=this.S(a,s);let D=null;try{D=(await d.Promises.write(a,n,o,f,k)).bytesWritten}catch(C){throw await this.bb(this.Q.get(a),C)}finally{this.U(a,k,D)}return D}async mkdir(a){try{await d.Promises.mkdir(this.C(a))}catch(s){throw this.ab(s)}}async delete(a,s){try{const n=this.C(a);if(s.recursive){let o;s?.atomic!==!1&&s.atomic.postfix&&(o=(0,A.$8c)((0,A.$$c)(n),`${(0,A.$_c)(n)}${s.atomic.postfix}`)),await d.Promises.rm(n,d.RimRafMode.MOVE,o)}else try{await d.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let f=!1;try{const{stat:k,symbolicLink:D}=await d.SymlinkSupport.stat(n);f=k.isDirectory()&&!D}catch{}if(f)await d.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.ab(n)}}async rename(a,s,n){const o=this.C(a),f=this.C(s);if(o!==f)try{await this.X(a,s,"move",n.overwrite),await d.Promises.rename(o,f)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,m.localize)(2,null,(0,A.$_c)(o),(0,A.$_c)((0,A.$$c)(f)),k.toString()))),this.ab(k)}}async copy(a,s,n){const o=this.C(a),f=this.C(s);if(o!==f)try{await this.X(a,s,"copy",n.overwrite),await d.Promises.copy(o,f,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,m.localize)(3,null,(0,A.$_c)(o),(0,A.$_c)((0,A.$$c)(f)),k.toString()))),this.ab(k)}}async X(a,s,n,o){const f=this.C(a),k=this.C(s);let D=!1;if(!!(this.capabilities&1024)||(D=(0,b.$Ge)(f,k,!0)),D){if(n==="copy")throw(0,c.$5j)((0,m.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const L=await this.G(a);if(!L)throw(0,c.$5j)((0,m.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const U=await this.G(s);if(U){if(!o)throw(0,c.$5j)((0,m.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);L.type&c.FileType.File&&U.type&c.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,s){return this.Y(a,s,!1)}async Y(a,s,n){const o=this.C(a),f=this.C(s),k=!!(this.capabilities&1024);if((0,b.$Ge)(o,f,!k))return;const D=new $.$kb;try{const[C,L]=await Promise.all([this.J(a),this.J(s)]);D.add(C),D.add(L),n&&await d.Promises.mkdir((0,A.$$c)(f),{recursive:!0}),await d.Promises.copyFile(o,f)}catch(C){if(C.code==="ENOENT"&&!n)return this.Y(a,s,!0);throw this.ab(C)}finally{D.dispose()}}p(a,s,n){return new y.$Lp(o=>a(o),o=>s(o),n)}y(a,s,n){return new p.$Tp(o=>a(o),o=>s(o),n)}ab(a){if(a instanceof c.$4j)return a;let s=a,n;switch(a.code){case"ENOENT":n=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=c.FileSystemProviderErrorCode.Unknown;break;default:n=c.FileSystemProviderErrorCode.Unknown}return(0,c.$5j)(s,n)}async bb(a,s){let n=this.ab(s);if(a&&n.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await d.SymlinkSupport.stat(this.C(a));o.mode&128||(n=(0,c.$5j)(s,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$Up=t,t.D=!1,t.R=!0}),define(we[224],be([1,0,5,68,2,15,48,20]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=void 0;class b extends r.$lb{constructor(E,w){super(),this.a=E,this.b=w,this.w=new Map,this.y=new Map}call(E,w,l){const d=this.c(E);switch(w){case"stat":return this.g(d,l[0]);case"readdir":return this.h(d,l[0]);case"open":return this.l(d,l[0],l[1]);case"close":return this.m(l[0]);case"read":return this.n(l[0],l[1],l[2]);case"readFile":return this.i(d,l[0],l[1]);case"write":return this.p(l[0],l[1],l[2],l[3],l[4]);case"writeFile":return this.k(d,l[0],l[1],l[2]);case"rename":return this.t(d,l[0],l[1],l[2]);case"copy":return this.u(d,l[0],l[1],l[2]);case"cloneFile":return this.v(d,l[0],l[1]);case"mkdir":return this.r(d,l[0]);case"delete":return this.s(d,l[0],l[1]);case"watch":return this.C(d,l[0],l[1],l[2],l[3]);case"unwatch":return this.D(l[0],l[1])}throw new Error(`IPC Command ${w} not found`)}listen(E,w,l){const d=this.c(E);switch(w){case"fileChange":return this.z(d,l[0]);case"readFileStream":return this.j(d,l[0],l[1])}throw new Error(`Unknown event ${w}`)}g(E,w){const l=this.f(E,w,!0);return this.a.stat(l)}h(E,w){const l=this.f(E,w);return this.a.readdir(l)}async i(E,w,l){const d=this.f(E,w,!0),m=await this.a.readFile(d,l);return S.$Ec.wrap(m)}j(E,w,l){const d=this.f(E,w,!0),m=new P.$oc,c=new v.$ec({onDidRemoveLastListener:()=>{m.cancel()}}),u=this.a.readFileStream(d,l,m.token);return(0,I.$wc)(u,{onData:h=>c.fire(S.$Ec.wrap(h)),onError:h=>c.fire(h),onEnd:()=>{c.fire("end"),c.dispose(),m.dispose()}}),c.event}k(E,w,l,d){const m=this.f(E,w);return this.a.writeFile(m,l.buffer,d)}l(E,w,l){const d=this.f(E,w,!0);return this.a.open(d,l)}m(E){return this.a.close(E)}async n(E,w,l){const d=S.$Ec.alloc(l),m=0,c=await this.a.read(E,w,d.buffer,m,l);return[d,c]}p(E,w,l,d,m){return this.a.write(E,w,l.buffer,d,m)}r(E,w){const l=this.f(E,w);return this.a.mkdir(l)}s(E,w,l){const d=this.f(E,w);return this.a.delete(d,l)}t(E,w,l,d){const m=this.f(E,w),c=this.f(E,l);return this.a.rename(m,c,d)}u(E,w,l,d){const m=this.f(E,w),c=this.f(E,l);return this.a.copy(m,c,d)}v(E,w,l){const d=this.f(E,w),m=this.f(E,l);return this.a.cloneFile(d,m)}z(E,w){const l=new v.$ec({onWillAddFirstListener:()=>{this.w.set(w,this.F(E,l))},onDidRemoveLastListener:()=>{(0,r.$gb)(this.w.get(w)),this.w.delete(w)}});return l.event}async C(E,w,l,d,m){const c=this.w.get(w);if(c){const u=this.f(E,d),h=c.watch(l,u,m);this.y.set(w+l,h)}}async D(E,w){const l=E+w,d=this.y.get(l);d&&((0,r.$gb)(d),this.y.delete(l))}dispose(){super.dispose();for(const[,E]of this.y)E.dispose();this.y.clear();for(const[,E]of this.w)E.dispose();this.w.clear()}}e.$qr=b;class $ extends r.$lb{constructor(E,w,l,d){super(),this.c=E,this.f=l,this.g=d,this.a=new Map,this.b=this.B(new R.$Up(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(w)}h(E){const w=this.B(new v.$ec);this.B(w.event(l=>{E.fire(l.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type})))})),this.B(this.b.onDidChangeFile(l=>w.fire(l))),this.B(this.b.onDidWatchError(l=>E.fire(l)))}i(E){}j(E){}watch(E,w,l){const d=this.j(this.g);return Array.isArray(d)&&(l.excludes=[...l.excludes,...d]),this.a.set(E,this.b.watch(w,l)),(0,r.$jb)(()=>{(0,r.$gb)(this.a.get(E)),this.a.delete(E)})}dispose(){super.dispose();for(const[,E]of this.a)E.dispose();this.a.clear()}}e.$rr=$}),define(we[114],be([1,0,4,5,12,2]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=void 0;class I extends r.$3i{constructor(E,w,l,d,m){super(w,l,d),this.n=E,this.p=m,this.B(m.listen("onDidChangeLogLevel",E)(c=>{(0,r.$Ti)(c)?super.setLogLevel(c):super.setLogLevel(v.URI.revive(c[0]),c[1])})),this.B(m.listen("onDidChangeVisibility",E)(([c,u])=>super.setVisibility(v.URI.revive(c),u))),this.B(m.listen("onDidChangeLoggers",E)(({added:c,removed:u})=>{for(const h of c)super.registerLogger({...h,resource:v.URI.revive(h.resource)});for(const h of u)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new r.$1i({log:(E,w)=>{this.p.call("consoleLog",[E,w])}})}registerLogger(E){super.registerLogger(E),this.p.call("registerLogger",[E,this.n])}deregisterLogger(E){super.deregisterLogger(E),this.p.call("deregisterLogger",[E,this.n])}setLogLevel(E,w){super.setLogLevel(E,w),this.p.call("setLogLevel",[E,w])}setVisibility(E,w){super.setVisibility(E,w),this.p.call("setVisibility",[this.l(E),w])}m(E,w,l){return new P(this.p,E,w,l,this.n)}static setLogLevel(E,w,l){return E.call("setLogLevel",[w,l])}}e.$Sq=I;class P extends r.$Xi{constructor(E,w,l,d,m){super(d?.logLevel==="always"),this.m=E,this.n=w,this.k=!1,this.l=[],this.setLevel(l),this.m.call("createLogger",[w,d,m]).then(()=>{this.r(this.l),this.k=!0})}g(E,w){const l=[[E,w]];this.k?this.r(l):this.l.push(...l)}r(E){this.m.call("log",[this.n,E])}}class b{constructor(E,w){this.a=E,this.b=w}listen(E,w){const l=this.b(E);switch(w){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(m=>this.c(m,l)),removed:[...d.removed].map(m=>this.c(m,l))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,d=>[l.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,d=>(0,r.$Ti)(d)?d:[l.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${w}`)}async call(E,w,l){const d=this.b(E);switch(w){case"setLogLevel":return(0,r.$Ti)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(v.URI.revive(d.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,d)))}throw new Error(`Call not found: ${w}`)}c(E,w){return{...E,resource:w.transformOutgoingURI(E.resource)}}}e.$Tq=b;class $ extends S.$lb{constructor(E,w){super(),w.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(l=>w.call("setLogLevel",[l]))),w.call("getRegisteredLoggers").then(l=>{for(const d of l)E.registerLogger({...d,resource:v.URI.revive(d.resource)})}),this.B(w.listen("onDidChangeVisibility")(([l,d])=>E.setVisibility(v.URI.revive(l),d))),this.B(w.listen("onDidChangeLoggers")(({added:l,removed:d})=>{for(const m of l)E.registerLogger({...m,resource:v.URI.revive(m.resource)});for(const m of d)E.deregisterLogger(m.resource)}))}}e.$Uq=$}),define(we[115],be([1,0,2,12]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0;class r extends v.$lb{constructor(I,P=[]){super(),this.a=new R.$2i([I,...P]),this.B(I.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...P){this.a.trace(I,...P)}debug(I,...P){this.a.debug(I,...P)}info(I,...P){this.a.info(I,...P)}warn(I,...P){this.a.warn(I,...P)}error(I,...P){this.a.error(I,...P)}flush(){this.a.flush()}}e.$$M=r}),define(we[225],be([1,0,16,12]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=void 0;var r;(function($){$[$.Trace=0]="Trace",$[$.Debug=1]="Debug",$[$.Info=2]="Info",$[$.Warning=3]="Warning",$[$.Error=4]="Error",$[$.Critical=5]="Critical",$[$.Off=6]="Off"})(r||(r={}));async function S($,A,E,w,l){try{const d=await new Promise((c,u)=>{le(["@vscode/spdlog"],c,u)});d.setFlushOn(r.Trace);const m=await d.createAsyncRotatingLogger($,A,E,w);return l?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(d){console.error(d)}return null}function I($,A,E){switch(A){case R.LogLevel.Trace:$.trace(E);break;case R.LogLevel.Debug:$.debug(E);break;case R.LogLevel.Info:$.info(E);break;case R.LogLevel.Warning:$.warn(E);break;case R.LogLevel.Error:$.error(E);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function P($,A){switch(A){case R.LogLevel.Trace:$.setLevel(r.Trace);break;case R.LogLevel.Debug:$.setLevel(r.Debug);break;case R.LogLevel.Info:$.setLevel(r.Info);break;case R.LogLevel.Warning:$.setLevel(r.Warning);break;case R.LogLevel.Error:$.setLevel(r.Error);break;case R.LogLevel.Off:$.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class b extends R.$Xi{constructor(A,E,w,l,d){super(),this.k=[],this.setLevel(d),this.l=this.n(A,E,w,l),this.B(this.onDidChangeLogLevel(m=>{this.m&&P(this.m,m)}))}async n(A,E,w,l){const d=w?6:1,m=30/d*v.$nk.MB,c=await S(A,E,m,d,l);if(c){this.m=c,P(this.m,this.getLevel());for(const{level:u,message:h}of this.k)I(this.m,u,h);this.k=[]}}g(A,E){this.m?I(this.m,A,E):this.getLevel()<=A&&this.k.push({level:A,message:E})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$ZM=b}),define(we[116],be([1,0,23,12,225]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=void 0;class S extends R.$3i{m(P,b,$){return new r.$ZM((0,v.$3e)(),P.fsPath,!$?.donotRotate,!!$?.donotUseFormatters,b)}}e.$1M=S}),define(we[226],be([1,0,62,189,6]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(S||(e.MarkerTag=S={}));var I;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(I||(e.MarkerSeverity=I={})),function(b){function $(d,m){return m-d}b.compare=$;const A=Object.create(null);A[b.Error]=(0,R.localize)(0,null),A[b.Warning]=(0,R.localize)(1,null),A[b.Info]=(0,R.localize)(2,null);function E(d){return A[d]||""}b.toString=E;function w(d){switch(d){case v.default.Error:return b.Error;case v.default.Warning:return b.Warning;case v.default.Info:return b.Info;case v.default.Ignore:return b.Hint}}b.fromSeverity=w;function l(d){switch(d){case b.Error:return v.default.Error;case b.Warning:return v.default.Warning;case b.Info:return v.default.Info;case b.Hint:return v.default.Ignore}}b.toSeverity=l}(I||(e.MarkerSeverity=I={}));var P;(function(b){const $="";function A(w){return E(w,!0)}b.makeKey=A;function E(w,l){const d=[$];return w.source?d.push(w.source.replace("\xA6","\\\xA6")):d.push($),w.code?typeof w.code=="string"?d.push(w.code.replace("\xA6","\\\xA6")):d.push(w.code.value.replace("\xA6","\\\xA6")):d.push($),w.severity!==void 0&&w.severity!==null?d.push(I.toString(w.severity)):d.push($),w.message&&l?d.push(w.message.replace("\xA6","\\\xA6")):d.push($),w.startLineNumber!==void 0&&w.startLineNumber!==null?d.push(w.startLineNumber.toString()):d.push($),w.startColumn!==void 0&&w.startColumn!==null?d.push(w.startColumn.toString()):d.push($),w.endLineNumber!==void 0&&w.endLineNumber!==null?d.push(w.endLineNumber.toString()):d.push($),w.endColumn!==void 0&&w.endColumn!==null?d.push(w.endColumn.toString()):d.push($),d.push($),d.join("\xA6")}b.makeKeyOptionalMessage=E})(P||(e.IMarkerData=P={})),e.$ss=(0,r.$ph)("markerService")}),define(we[69],be([1,0,5,47,2,6]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=void 0,e.$Xm=(0,S.$ph)("policy");class I extends r.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new v.$ec),this.onDidChange=this.h.event}async updatePolicyDefinitions($){const A=Object.keys(this.f).length;return this.f={...$,...this.f},A!==Object.keys(this.f).length&&await this.i($),R.Iterable.reduce(this.g.entries(),(E,[w,l])=>({...E,[w]:l}),{})}getPolicyValue($){return this.g.get($)}serialize(){return R.Iterable.reduce(Object.entries(this.f),($,[A,E])=>({...$,[A]:{definition:E,value:this.g.get(A)}}),{})}}e.$Ym=I;class P{constructor(){this.onDidChange=v.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Zm=P}),define(we[54],be([1,0,3,29]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof v.$b.vscode<"u"&&typeof v.$b.vscode.context<"u"){const S=v.$b.vscode.context.configuration();if(S)r=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const S=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:S.version})}Object.assign(r,{extensionsGallery:R.env.EXTENSIONS_GALLERY?JSON.parse(R.env.EXTENSIONS_GALLERY):r.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else r={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.82.0",sha256:"4fba41b4b764c3f5a6591d6d9a5bdc59b417f2d799071c889c2b54163f256282",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.82.2",commit:"2eba7af117ea58d45a6c6449ee4fe63c8d4d53aa",date:"2023-09-29T21:59:34.461Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(we[27],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,v.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"}),define(we[227],be([1,0,80,12,25,27,222]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0;let P=class extends I.$rn{constructor($,A,E){super($),this.p=A,this.r=E}async getSecretStoragePrefix(){return Promise.resolve(`${this.r.urlProtocol}-server`)}async i(){if(this.f)return this.f;if(this.p.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new v.$qn,this.f;try{this.f=await new Promise(($,A)=>{le(["keytar"],$,A)}),await this.f.findCredentials("test-keytar-loads")}catch($){this.h.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${$.message??$}`),this.f=new v.$qn}return this.f}};e.$sn=P,e.$sn=P=Le([Ie(0,R.$Ri),Ie(1,r.$xh),Ie(2,S.$0i)],P)}),define(we[35],be([1,0,96,8]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=void 0;class r{constructor(){this.a=new Map}add(I,P){v.ok(R.$ie(I)),v.ok(R.$ke(P)),v.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,P)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$Vm=new r}),define(we[228],be([1,0,5,35]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=void 0,e.$Wm={JSONContribution:"base.contributions.json"};function r(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class S{constructor(){this.b=new v.$ec,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,$){this.a[r(b)]=$,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const I=new S;R.$Vm.add(e.$Wm.JSONContribution,I)}),define(we[55],be([1,0,18,5,8,171,24,228,35]),function(le,e,v,R,r,S,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.ConfigurationScope=e.$1m=e.EditPresentationTypes=void 0;var $;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$1m={Configuration:"base.contributions.configuration"};var A;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m={properties:{},patternProperties:{}},e.$7m={properties:{},patternProperties:{}},e.$8m="vscode://schemas/settings/resourceLanguage",e.$9m="vscode://schemas/settings/configurationDefaults";const E=b.$Vm.as(P.$Wm.JSONContribution);class w{constructor(){this.h=new Set,this.i=new R.$ec,this.onDidSchemaChange=this.i.event,this.j=new R.$ec,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$8m,this.g),this.v()}registerConfiguration(t,i=!0){this.registerConfigurations([t],i)}registerConfigurations(t,i=!0){const a=new Set;this.n(t,i,a),E.registerSchema(e.$8m,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const i=new Set;this.o(t,i),E.registerSchema(e.$8m,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:t,remove:i}){const a=new Set;this.o(i,a),this.n(t,!1,a),E.registerSchema(e.$8m,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const i=new Set;this.k(t,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(t,i){const a=[];for(const{overrides:s,source:n}of t)for(const o in s)if(i.add(o),e.$$m.test(o)){const f=this.a.get(o),k=f?.valuesSources??new Map;if(n)for(const U of Object.keys(s[o]))k.set(U,n);const D={...f?.value||{},...s[o]};this.a.set(o,{source:n,value:D,valuesSources:k});const C=(0,I.$6h)(o),L={type:"object",default:D,description:S.localize(1,null,C),$ref:e.$8m,defaultDefaultValue:D,source:r.$ie(n)?void 0:n,defaultValueSource:n};a.push(...m(o)),this.d[o]=L,this.b.properties[o]=L}else{this.a.set(o,{value:s[o],source:n});const f=this.d[o];f&&(this.w(o,f),this.r(o,f))}this.m(a)}deregisterDefaultConfigurations(t){const i=new Set;this.l(t,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(t,i){for(const{overrides:a,source:s}of t)for(const n in a){const o=this.a.get(n),f=r.$ie(s)?s:s?.id,k=r.$ie(o?.source)?o?.source:o?.source?.id;if(f===k)if(i.add(n),this.a.delete(n),e.$$m.test(n))delete this.d[n],delete this.b.properties[n];else{const D=this.d[n];D&&(this.w(n,D),this.r(n,D))}}this.u()}deltaConfiguration(t){let i=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),i=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),i=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const i of t)this.h.add(i);this.u()}n(t,i,a){t.forEach(s=>{this.p(s,i,s.extensionInfo,s.restrictedProperties,void 0,a),this.c.push(s),this.q(s)})}o(t,i){const a=s=>{if(s.properties)for(const n in s.properties){i.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,s.properties[n])}s.allOf?.forEach(n=>a(n))};for(const s of t){a(s);const n=this.c.indexOf(s);n!==-1&&this.c.splice(n,1)}}p(t,i=!0,a,s,n=3,o){n=r.$re(t.scope)?n:t.scope;const f=t.properties;if(f)for(const D in f){const C=f[D];if(i&&g(D,C)){delete f[D];continue}if(C.source=a,C.defaultDefaultValue=f[D].default,this.w(D,C),e.$$m.test(D)?C.scope=void 0:(C.scope=r.$re(C.scope)?n:C.scope,C.restricted=r.$re(C.restricted)?!!s?.includes(D):C.restricted),f[D].hasOwnProperty("included")&&!f[D].included){this.f[D]=f[D],delete f[D];continue}else this.d[D]=f[D],f[D].policy?.name&&this.e.set(f[D].policy.name,D);!f[D].deprecationMessage&&f[D].markdownDeprecationMessage&&(f[D].deprecationMessage=f[D].markdownDeprecationMessage),o.add(D)}const k=t.allOf;if(k)for(const D of k)this.p(D,i,a,s,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const i=a=>{const s=a.properties;if(s)for(const o in s)this.r(o,s[o]);a.allOf?.forEach(i)};i(t)}r(t,i){switch(e.$2m.properties[t]=i,i.scope){case 1:e.$3m.properties[t]=i;break;case 2:e.$4m.properties[t]=i;break;case 6:e.$5m.properties[t]=i;break;case 3:e.$6m.properties[t]=i;break;case 4:e.$7m.properties[t]=i;break;case 5:e.$7m.properties[t]=i,this.g.properties[t]=i;break}}s(t,i){switch(delete e.$2m.properties[t],i.scope){case 1:delete e.$3m.properties[t];break;case 2:delete e.$4m.properties[t];break;case 6:delete e.$5m.properties[t];break;case 3:delete e.$6m.properties[t];break;case 4:case 5:delete e.$7m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const i=`[${t}]`,a={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.$8m};this.w(i,a),e.$2m.properties[i]=a,e.$3m.properties[i]=a,e.$4m.properties[i]=a,e.$5m.properties[i]=a,e.$6m.properties[i]=a,e.$7m.properties[i]=a}}v(){const t={type:"object",description:S.localize(4,null),errorMessage:S.localize(5,null),$ref:e.$8m};e.$2m.patternProperties[e.$0m]=t,e.$3m.patternProperties[e.$0m]=t,e.$4m.patternProperties[e.$0m]=t,e.$5m.patternProperties[e.$0m]=t,e.$6m.patternProperties[e.$0m]=t,e.$7m.patternProperties[e.$0m]=t,this.i.fire()}w(t,i){const a=this.a.get(t);let s=a?.value,n=a?.source;r.$pe(s)&&(s=i.defaultDefaultValue,n=void 0),r.$pe(s)&&(s=u(i.type)),i.default=s,i.defaultValueSource=n}}const l="\\[([^\\]]+)\\]",d=new RegExp(l,"g");e.$0m=`^(${l})+$`,e.$$m=new RegExp(e.$0m);function m(p){const t=[];if(e.$$m.test(p)){let i=d.exec(p);for(;i?.length;){const a=i[1].trim();a&&t.push(a),i=d.exec(p)}}return(0,v.$of)(t)}e.$_m=m;function c(p){return p.reduce((t,i)=>`${t}[${i}]`,"")}e.$an=c;function u(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$bn=u;const h=new w;b.$Vm.add(e.$1m.Configuration,h);function g(p,t){return p.trim()?e.$$m.test(p)?S.localize(7,null,p):h.getConfigurationProperties()[p]!==void 0?S.localize(8,null,p):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?S.localize(9,null,p,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:S.localize(6,null)}e.$cn=g;function y(){const p=[],t=h.getConfigurationProperties();for(const i of Object.keys(t))p.push([i,t[i].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.$dn=y}),define(we[117],be([1,0,18,5,75,2,28,22,8,4,24,55,35]),function(le,e,v,R,r,S,I,P,b,$,A,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=void 0;function l(i){return Object.isFrozen(i)?i:P.$Km(i)}class d{constructor(a={},s=[],n=[],o){this.b=a,this.c=s,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(s=>{if(s instanceof d)return s;const n=new m("");return n.parseRaw(s),n.configurationModel});this.f=a.reduce((s,n)=>n===s?n:s.merge(n),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,A.$4h)(this.contents,a):this.contents}inspect(a,s){const n=this.rawConfiguration.getValue(a),o=s?this.rawConfiguration.getOverrideValue(a,s):void 0,f=s?this.rawConfiguration.override(s).getValue(a):n;return{value:n,override:o,merged:f}}getOverrideValue(a,s){const n=this.i(s);return n?a?(0,A.$4h)(n,a):n:void 0}getKeysForOverrideIdentifier(a){const s=[];for(const n of this.overrides)n.identifiers.includes(a)&&s.push(...n.keys);return v.$of(s)}getAllOverrideIdentifiers(){const a=[];for(const s of this.overrides)a.push(...s.identifiers);return v.$of(a)}override(a){let s=this.a.get(a);return s||(s=this.g(a),this.a.set(a,s)),s}merge(...a){const s=P.$Jm(this.contents),n=P.$Jm(this.overrides),o=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const k of a)if(f.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(s,k.contents);for(const D of k.overrides){const[C]=n.filter(L=>v.$$e(L.identifiers,D.identifiers));C?(this.h(C.contents,D.contents),C.keys.push(...D.keys),C.keys=v.$of(C.keys)):n.push(P.$Jm(D))}for(const D of k.keys)o.indexOf(D)===-1&&o.push(D)}return new d(s,o,n,f.every(k=>k instanceof d)?void 0:f)}g(a){const s=this.i(a);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const n={};for(const o of v.$of([...Object.keys(this.contents),...Object.keys(s)])){let f=this.contents[o];const k=s[o];k&&(typeof f=="object"&&typeof k=="object"?(f=P.$Jm(f),this.h(f,k)):f=k),n[o]=f}return new d(n,this.keys,this.overrides)}h(a,s){for(const n of Object.keys(s)){if(n in a&&b.$ke(a[n])&&b.$ke(s[n])){this.h(a[n],s[n]);continue}a[n]=P.$Jm(s[n])}}i(a){let s=null,n=null;const o=f=>{f&&(n?this.h(n,f):n=P.$Jm(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===a?s=f.contents:f.identifiers.includes(a)&&o(f.contents);return o(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,s){this.j(a,s,!0)}setValue(a,s){this.j(a,s,!1)}removeValue(a){const s=this.keys.indexOf(a);s!==-1&&(this.keys.splice(s,1),(0,A.$3h)(this.contents,a),E.$$m.test(a)&&this.overrides.splice(this.overrides.findIndex(n=>v.$$e(n.identifiers,(0,E.$_m)(a))),1))}j(a,s,n){(0,A.$2h)(this.contents,a,s,o=>console.error(o)),n=n||this.keys.indexOf(a)===-1,n&&this.keys.push(a),E.$$m.test(a)&&this.overrides.push({identifiers:(0,E.$_m)(a),keys:Object.keys(this.contents[a]),contents:(0,A.$1h)(this.contents[a],o=>console.error(o))})}}e.$en=d;class m{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,s){if(!b.$re(a)){const n=this.g(a);this.parseRaw(n,s)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,s){this.a=a;const{contents:n,keys:o,overrides:f,restricted:k,hasExcludedProperties:D}=this.h(a,s);this.b=new d(n,o,f,D?[a]:void 0),this.c=k||[]}g(a){let s={},n=null,o=[];const f=[],k=[];function D(L){Array.isArray(o)?o.push(L):n!==null&&(o[n]=L)}const C={onObjectBegin:()=>{const L={};D(L),f.push(o),o=L,n=null},onObjectProperty:L=>{n=L},onObjectEnd:()=>{o=f.pop()},onArrayBegin:()=>{const L=[];D(L),f.push(o),o=L,n=null},onArrayEnd:()=>{o=f.pop()},onLiteralValue:D,onError:(L,U,x)=>{k.push({error:L,offset:U,length:x})}};if(a)try{r.$Gm(a,C),s=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return s}h(a,s){const n=w.$Vm.as(E.$1m.Configuration).getConfigurationProperties(),o=this.i(a,n,!0,s);a=o.raw;const f=(0,A.$1h)(a,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),k=Object.keys(a),D=this.j(a,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:f,keys:k,overrides:D,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(a,s,n,o){let f=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:f};const k={},D=[];for(const C in a)if(E.$$m.test(C)&&n){const L=this.i(a[C],s,!1,o);k[C]=L.raw,f=f||L.hasExcludedProperties,D.push(...L.restricted)}else{const L=s[C],U=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&D.push(C),!o.exclude?.includes(C)&&(o.include?.includes(C)||(U===void 0||o.scopes===void 0||o.scopes.includes(U))&&!(o.skipRestricted&&L?.restricted))?k[C]=a[C]:f=!0}return{raw:k,restricted:D,hasExcludedProperties:f}}j(a,s){const n=[];for(const o of Object.keys(a))if(E.$$m.test(o)){const f={};for(const k in a[o])f[k]=a[o][k];n.push({identifiers:(0,E.$_m)(o),keys:Object.keys(f),contents:(0,A.$1h)(f,s)})}return n}}e.$fn=m;class c extends S.$lb{constructor(a,s,n,o){super(),this.c=a,this.f=s,this.g=o,this.b=this.B(new R.$ec),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,f=>f.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&n.isEqual(f.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$gn=c;class u{constructor(a,s,n,o,f,k,D,C,L,U,x,ae,W){this.a=a,this.b=s,this.c=n,this.overrideIdentifiers=o,this.d=f,this.f=k,this.g=D,this.h=C,this.i=L,this.j=U,this.k=x,this.l=ae,this.m=W}get value(){return l(this.c)}n(a,s,n){const o=a.inspect(s,n);return{get value(){return l(o.value)},get override(){return l(o.override)},get merged(){return l(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(a,s,n,o,f=new d,k=new d,D=new I.$ni,C=new d,L=new I.$ni){this.c=a,this.d=s,this.f=n,this.g=o,this.h=f,this.i=k,this.j=D,this.l=C,this.m=L,this.a=null,this.b=new I.$ni,this.n=null}getValue(a,s,n){return this.q(a,s,n).getValue(a)}updateValue(a,s,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new d,this.m.set(n.resource,o))):o=this.l,s===void 0?o.removeValue(a):o.setValue(a,s),n.resource||(this.a=null)}inspect(a,s,n){const o=this.q(a,s,n),f=this.u(s.resource,n),k=s.resource?this.m.get(s.resource)||this.l:this.l,D=new Set;for(const C of o.overrides)for(const L of C.identifiers)o.getOverrideValue(a,L)!==void 0&&D.add(L);return new u(a,s,o.getValue(a),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,f||void 0,k)}keys(a){const s=this.u(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,s){this.j.set(a,s),this.b.delete(a)}deleteFolderConfiguration(a){this.p.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,s){const n=[];if(!s){const{added:o,updated:f,removed:k}=p(this.c,a);s=[...o,...f,...k]}for(const o of s)for(const f of(0,E.$_m)(o)){const k=this.c.getKeysForOverrideIdentifier(f),D=a.getKeysForOverrideIdentifier(f),C=[...D.filter(L=>k.indexOf(L)===-1),...k.filter(L=>D.indexOf(L)===-1),...k.filter(L=>!P.$Nm(this.c.override(f).getValue(L),a.override(f).getValue(L)))];n.push([f,C])}return this.updateDefaultConfiguration(a),{keys:s,overrides:n}}compareAndUpdatePolicyConfiguration(a){const{added:s,updated:n,removed:o}=p(this.d,a),f=[...s,...n,...o];return f.length&&this.updatePolicyConfiguration(a),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:s,updated:n,removed:o,overrides:f}=p(this.applicationConfiguration,a),k=[...s,...n,...o];return k.length&&this.updateApplicationConfiguration(a),{keys:k,overrides:f}}compareAndUpdateLocalUserConfiguration(a){const{added:s,updated:n,removed:o,overrides:f}=p(this.localUserConfiguration,a),k=[...s,...n,...o];return k.length&&this.updateLocalUserConfiguration(a),{keys:k,overrides:f}}compareAndUpdateRemoteUserConfiguration(a){const{added:s,updated:n,removed:o,overrides:f}=p(this.remoteUserConfiguration,a),k=[...s,...n,...o];return k.length&&this.updateRemoteUserConfiguration(a),{keys:k,overrides:f}}compareAndUpdateWorkspaceConfiguration(a){const{added:s,updated:n,removed:o,overrides:f}=p(this.workspaceConfiguration,a),k=[...s,...n,...o];return k.length&&this.updateWorkspaceConfiguration(a),{keys:k,overrides:f}}compareAndUpdateFolderConfiguration(a,s){const n=this.p.get(a),{added:o,updated:f,removed:k,overrides:D}=p(n,s),C=[...o,...f,...k];return(C.length||!n)&&this.updateFolderConfiguration(a,s),{keys:C,overrides:D}}compareAndDeleteFolderConfiguration(a){const s=this.p.get(a);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:n,updated:o,removed:f,overrides:k}=p(s,void 0);return{keys:[...n,...o,...f],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(a,s,n){let o=this.r(s,n);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(o=o.merge(this.d)),o}r({resource:a},s){let n=this.s();if(s&&a){const o=s.getFolder(a);o&&(n=this.t(o.uri)||n);const f=this.m.get(a);f&&(n=n.merge(f))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(a){let s=this.b.get(a);if(!s){const n=this.s(),o=this.j.get(a);o?(s=n.merge(o),this.b.set(a,s)):s=n}return s}u(a,s){if(s&&a){const n=s.getFolder(a);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,s)=>{const{contents:n,overrides:o,keys:f}=this.j.get(s);return a.push([s,{contents:n,overrides:o,keys:f}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(s=>a.add(s)),this.userConfiguration.keys.forEach(s=>a.add(s)),this.i.keys.forEach(s=>a.add(s)),this.j.forEach(s=>s.keys.forEach(n=>a.add(n))),[...a.values()]}v(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>a.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>a.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>a.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(n=>a.add(n))),[...a.values()]}w(a){const s=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(n=>s.add(n)),this.i.getKeysForOverrideIdentifier(a).forEach(n=>s.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(a).forEach(o=>s.add(o))),[...s.values()]}static parse(a){const s=this.x(a.defaults),n=this.x(a.policy),o=this.x(a.application),f=this.x(a.user),k=this.x(a.workspace),D=a.folders.reduce((C,L)=>(C.set($.URI.revive(L[0]),this.x(L[1])),C),new I.$ni);return new h(s,n,o,f,new d,k,D,new d,new I.$ni)}static x(a){return new d(a.contents,a.keys,a.overrides)}}e.$hn=h;function g(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const a=new Set,s=new Map;for(const o of i)o.keys.forEach(f=>a.add(f)),o.overrides.forEach(([f,k])=>{const D=(0,I.$ki)(s,f,new Set);k.forEach(C=>D.add(C))});const n=[];return s.forEach((o,f)=>n.push([f,[...o.values()]])),{keys:[...a.values()],overrides:n}}e.$in=g;class y{constructor(a,s,n,o){this.change=a,this.f=s,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const f of a.keys)this.affectedKeys.add(f);for(const[,f]of a.overrides)for(const k of f)this.affectedKeys.add(k);this.d=this.a;for(const f of this.affectedKeys)this.d+=f+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(a,s){const n=this.a+a,o=this.d.indexOf(n);if(o<0)return!1;const f=o+n.length;if(f>=this.d.length)return!1;const k=this.d.charCodeAt(f);if(k!==this.b&&k!==this.c)return!1;if(s){const D=this.previousConfiguration?this.previousConfiguration.getValue(a,s,this.f?.workspace):void 0,C=this.g.getValue(a,s,this.h);return!P.$Nm(D,C)}return!0}}e.$jn=y;function p(i,a){const{added:s,removed:n,updated:o}=t(a?.rawConfiguration,i?.rawConfiguration),f=[],k=i?.getAllOverrideIdentifiers()||[],D=a?.getAllOverrideIdentifiers()||[];if(a){const C=D.filter(L=>!k.includes(L));for(const L of C)f.push([L,a.getKeysForOverrideIdentifier(L)])}if(i){const C=k.filter(L=>!D.includes(L));for(const L of C)f.push([L,i.getKeysForOverrideIdentifier(L)])}if(a&&i){for(const C of k)if(D.includes(C)){const L=t({contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)},{contents:a.getOverrideValue(void 0,C)||{},keys:a.getKeysForOverrideIdentifier(C)});f.push([C,[...L.added,...L.removed,...L.updated]])}}return{added:s,removed:n,updated:o,overrides:f}}function t(i,a){const s=i?a?i.keys.filter(f=>a.keys.indexOf(f)===-1):[...i.keys]:[],n=a?i?a.keys.filter(f=>i.keys.indexOf(f)===-1):[...a.keys]:[],o=[];if(i&&a){for(const f of a.keys)if(i.keys.indexOf(f)!==-1){const k=(0,A.$4h)(a.contents,f),D=(0,A.$4h)(i.contents,f);P.$Nm(k,D)||o.push(f)}}return{added:s,removed:n,updated:o}}}),define(we[229],be([1,0,18,5,2,22,8,117,55,12,69,35]),function(le,e,v,R,r,S,I,P,b,$,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=void 0;class w extends r.$lb{constructor(){super(...arguments),this.a=this.B(new R.$ec),this.onDidChangeConfiguration=this.a.event,this.b=new P.$en}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Vm.as(b.$1m.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:u})=>this.c(Array.from(c),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,u){this.h(c,E.$Vm.as(b.$1m.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new P.$en;const c=E.$Vm.as(b.$1m.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,u){const h=this.f();for(const g of c){const y=h[g],p=u[g];y!==void 0?this.b.addValue(g,y):p?this.b.addValue(g,p.default):this.b.removeValue(g)}}}e.$kn=w;class l{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new P.$en}async initialize(){return this.configurationModel}}e.$ln=l;let d=class extends r.$lb{get configurationModel(){return this.b}constructor(c,u,h){super(),this.c=c,this.f=u,this.g=h,this.a=this.B(new R.$ec),this.onDidChangeConfiguration=this.a.event,this.b=new P.$en}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const u={},h=[],g=E.$Vm.as(b.$1m.Configuration).getConfigurationProperties();for(const y of c){const p=g[y];if(!p){h.push(y);continue}if(p.policy){if(p.type!=="string"&&p.type!=="number"){this.g.warn(`Policy ${p.policy.name} has unsupported type ${p.type}`);continue}h.push(y),u[p.policy.name]={type:p.type}}}return(0,I.$ve)(u)||await this.f.updatePolicyDefinitions(u),h}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const u=E.$Vm.as(b.$1m.Configuration).getPolicyConfigurations(),h=(0,v.$jf)(c.map(g=>u.get(g)));this.j(h,!0)}j(c,u){this.g.trace("PolicyConfiguration#update",c);const h=E.$Vm.as(b.$1m.Configuration).getConfigurationProperties(),g=[],y=this.b.isEmpty();for(const p of c){const t=h[p]?.policy?.name;if(t){const i=this.f.getPolicyValue(t);(y?i!==void 0:!(0,S.$Nm)(this.b.getValue(p),i))&&g.push([p,i])}else this.b.getValue(p)!==void 0&&g.push([p,void 0])}if(g.length){this.g.trace("PolicyConfiguration#changed",g);const p=this.b;this.b=new P.$en;for(const t of p.keys)this.b.setValue(t,p.getValue(t));for(const[t,i]of g)i===void 0?this.b.removeValue(t):this.b.setValue(t,i);u&&this.a.fire(this.b)}}};e.$mn=d,e.$mn=d=Le([Ie(1,A.$Xm),Ie(2,$.$Ri)],d)}),define(we[118],be([1,0,14,5,2,19,24,117,229,69]),function(le,e,v,R,r,S,I,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0;class A extends r.$lb{constructor(w,l,d,m){super(),this.i=w,this.h=this.B(new R.$ec),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$kn),this.c=d instanceof $.$Zm?new b.$ln:this.B(new b.$mn(this.b,d,m)),this.f=this.B(new P.$gn(this.i,{},S.$Zf,l)),this.a=new P.$hn(this.b.configurationModel,this.c.configurationModel,new P.$en,new P.$en),this.g=this.B(new v.$Gg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:u})=>this.k(c,u))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[w,l,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$hn(w,l,new P.$en,d)}getConfigurationData(){return this.a.toData()}getValue(w,l){const d=typeof w=="string"?w:void 0,m=(0,I.$Wh)(w)?w:(0,I.$Wh)(l)?l:{};return this.a.getValue(d,m,void 0)}updateValue(w,l,d,m){return Promise.reject(new Error("not supported"))}inspect(w){return this.a.inspect(w,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const w=await this.f.loadConfiguration();this.j(w)}j(w){const l=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(w);this.m(d,l,2)}k(w,l){const d=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(w,l);this.m(m,d,7)}l(w){const l=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(w);this.m(d,l,7)}m(w,l,d){const m=new P.$jn(w,{data:l},this.a);m.source=d,m.sourceConfig=this.n(d),this.h.fire(m)}n(w){switch(w){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$nn=A}),define(we[119],be([1,0,11,6]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,R.$ph)("remoteAuthorityResolverService");var r;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class S{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=S;class I{constructor(E,w){this.host=E,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=I;var P;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class b extends v.$ab{static isNotAvailable(E){return E instanceof b&&E._code===P.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof b&&E._code===P.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof b&&E._code===P.NoResolverFound}static isInvalidAuthority(E){return E instanceof b&&E._code===P.InvalidAuthority}static isHandled(E){return E instanceof b&&E.isHandled}constructor(E,w=P.Unknown,l){super(E),this._message=E,this._code=w,this._detail=l,this.isHandled=w===P.NotAvailable&&l===!0,Object.setPrototypeOf(this,b.prototype)}}e.$zk=b;function $(A){const E=A.indexOf("+");return E===-1?A:A.substring(0,E)}e.$Ak=$}),define(we[230],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=void 0,e.$aN=(0,v.$ph)("IRemoteExtensionsScannerService"),e.$bN="remoteExtensionsScanner"}),define(we[56],be([1,0,13]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function R($){return $.scheme===v.Schemas.vscodeRemote?$.authority:void 0}e.$Bk=R;function r($){if(!$)return;const A=$.indexOf("+");return A<0?$:$.substr(0,A)}e.$Ck=r;function S($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Dk=S;function I($){const{host:A,port:E}=b($);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:E}}e.$Ek=I;function P($,A){let{host:E,port:w}=b($);return typeof w>"u"&&(w=A),{host:E,port:w}}e.$Fk=P;function b($){const A=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const E=$.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const w=$.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:$,port:void 0}}}),define(we[40],be([1,0,17,6,56]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.TargetPlatform=e.ExtensionType=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=void 0,e.$Dl="extensions.user.cache",e.$El="extensions.builtin.cache",e.$Fl="undefined_publisher",e.$Gl=["ui","workspace","web"];function S(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$Hl=S,e.$Il=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(I||(e.ExtensionType=I={}));var P;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class b{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,u){if(typeof c>"u"||c===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof c=="string"||typeof u=="string"){const h=typeof c=="string"?c:c.value,g=typeof u=="string"?u:u.value;return v.$Ld(h,g)}return c._lower===u._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$Jl=b;class ${get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const u of c)this.add(u)}add(c){this.c.add(b.toKey(c))}delete(c){return this.c.delete(b.toKey(c))}has(c){return this.c.has(b.toKey(c))}}e.$Kl=$;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(b.toKey(c))}get(c){return this.c.get(b.toKey(c))}has(c){return this.c.has(b.toKey(c))}set(c,u){this.c.set(b.toKey(c),u)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Ll=A;function E(m){return w(m)}e.$Ml=E;function w(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$Nl=w;function l(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$Ol=l;function d(m,c){if(c){const u=`onResolveRemoteAuthority:${(0,r.$Ck)(c)}`;return!!m.activationEvents?.includes(u)}return!1}e.$Pl=d,e.$Ql=(0,R.$ph)("IBuiltinExtensionsScannerService")}),define(we[231],be([1,0,2,40,16]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;class S extends v.$lb{constructor(P,b,$,A,E){super(),this.a=P,this.b=b,this.c=$,this.f=E,this.B(A.onDidInstallExtensions(w=>this.g(w))),this.B(A.onDidUninstallExtension(w=>this.h(w)))}g(P){for(const b of P)b.local&&this.invalidate(b.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const b of this.a.profiles)this.c.extUri.isEqual(b.extensionsResource,P)&&await this.i(b);else await this.i(this.a.defaultProfile)}async i(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,R.$Dl))}catch(b){(0,r.$9j)(b)!==1&&this.f.error(b)}}}e.$op=S}),define(we[44],be([1,0,15,11,2,190,55,6,12,35]),function(le,e,v,R,r,S,I,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0,e.$Bo=(0,P.$ph)("requestService");class A{constructor(p){this.b=p}toJSON(){if(!this.a){const p=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?p[t]="*****":p[t]=this.b[t];this.a=p}return this.a}}class E extends r.$lb{constructor(p){super(),this.b=0,this.a=p.createLogger("network",{name:(0,S.localize)(0,null),when:b.$9i.isEqualTo((0,b.$7i)(b.LogLevel.Trace)).serialize()})}async c(p,t,i){const a=`${p} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new A(t.headers??{}));try{const s=await i();return this.a.trace(`${a} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${a} - error`,t.type,(0,R.$9)(s)),s}}}e.$Co=E;function w(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.$Do=w;function l(y){return y.res.statusCode===204}async function d(y){return l(y)?null:(await(0,v.$Qc)(y.stream)).toString()}e.$Eo=d;async function m(y){if(!w(y))throw new Error("Server returned "+y.res.statusCode);return d(y)}e.$Fo=m;async function c(y){if(!w(y))throw new Error("Server returned "+y.res.statusCode);if(l(y))return null;const t=(await(0,v.$Qc)(y.stream)).toString();try{return JSON.parse(t)}catch(i){throw i.message+=`:
`+t,i}}e.$Go=c;function u(y){g(y)}e.$Ho=u;let h;function g(y){const p=$.$Vm.as(I.$1m.Configuration),t=h;h={id:"http",order:15,title:(0,S.localize)(1,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,S.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,S.localize)(6,null),(0,S.localize)(7,null),(0,S.localize)(8,null),(0,S.localize)(9,null)],default:"override",description:(0,S.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(11,null),restricted:!0}}},p.updateConfigurations({add:[h],remove:t?[t]:[]})}g(1)}),define(we[232],be([1,0,20,13,16,44]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;let I=class{constructor(b,$){this.a=b,this.b=$}async download(b,$,A=v.CancellationToken.None){if(b.scheme===R.Schemas.file||b.scheme===R.Schemas.vscodeRemote){await this.b.copy(b,$);return}const E={type:"GET",url:b.toString(!0)},w=await this.a.request(E,A);if(w.res.statusCode===200)await this.b.writeFile($,w.stream);else{const l=await(0,S.$Fo)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${l}`)}}};e.$rN=I,e.$rN=I=Le([Ie(0,S.$Bo),Ie(1,r.$Sj)],I)}),define(we[233],be([1,0,15,20]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0;class r{constructor(P){this.a=P}listen(P,b){throw new Error("Invalid listen")}call(P,b,$,A=R.CancellationToken.None){switch(b){case"request":return this.a.request($[0],A).then(async({res:E,stream:w})=>{const l=await(0,v.$Qc)(w);return[{statusCode:E.statusCode,headers:E.headers},l]});case"resolveProxy":return this.a.resolveProxy($[0])}throw new Error("Invalid call")}}e.$Dq=r;class S{constructor(P){this.a=P}async request(P,b){const[$,A]=await this.a.call("request",[P],b);return{res:$,stream:(0,v.$Sc)(A)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$Eq=S}),define(we[234],be([1,0,85,8]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;function r(I,P){return I.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:I.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function S(I,P,b={}){const $=(0,v.parse)(I),A=b.proxyUrl||r($,P);if(!A)return null;const E=(0,v.parse)(A);if(!/^https?:$/.test(E.protocol||""))return null;const w={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,R.$oe)(b.strictSSL)?b.strictSSL:!0};return $.protocol==="http:"?new(await new Promise((l,d)=>{le(["http-proxy-agent"],l,d)}))(w):new(await new Promise((l,d)=>{le(["https-proxy-agent"],l,d)}))(w)}e.$Fq=S}),define(we[86],be([1,0,52,7,191,20,39,11,3,23,106,208,14,143]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0;let d;async function m(u,h,g,y){return g["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.$d?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$ul)(y)&&!g["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$ul)(y)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=w.Promises.withAsyncBody(async(p,t)=>{const i=new S.$oc;let a=1e4;const s=u.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(a=(0,l.$vl)(s,1,120)*1e3);const n=setTimeout(()=>{i.dispose(!0),t(new Error((0,r.localize)(0,null)))},a);try{p(await c(h,i.token))}catch(o){!(0,P.$2)(o)&&!i.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,I.$ai)(o)))):p({})}finally{clearTimeout(n),i.dispose()}})),d)}e.$Al=m;async function c(u,h){const g=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",g);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",y);const p=(0,$.$3e)().replace(/-/g,"").substr(0,12),t=new RegExp(p+"({.*})"+p),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",i);const a=await(0,A.$kl)(b.OS,i);return u.trace("getUnixShellEnvironment#shell",a),new Promise((s,n)=>{if(h.isCancellationRequested)return n(new P.$3);const o=(0,R.$_c)(a);let f,k;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(f=`& '${process.execPath}' ${D} -p '''${p}'' + JSON.stringify(process.env) + ''${p}'''`,k=["-Login","-Command"]):o==="nu"?(f=`^'${process.execPath}' ${D} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,k=["-i","-l","-c"]):(f=`'${process.execPath}' ${D} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,o==="tcsh"||o==="csh"?k=["-ic"]:k=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),f);const C=(0,v.spawn)(a,[...k,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});h.onCancellationRequested(()=>(C.kill(),n(new P.$3))),C.on("error",x=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,I.$ai)(x)),n(x)});const L=[];C.stdout.on("data",x=>L.push(x));const U=[];C.stderr.on("data",x=>U.push(x)),C.on("close",(x,ae)=>{const W=Buffer.concat(L).toString("utf8");u.trace("getUnixShellEnvironment#raw",W);const te=Buffer.concat(U).toString("utf8");if(te.trim()&&u.trace("getUnixShellEnvironment#stderr",te),x||ae)return n(new Error((0,r.localize)(2,null,x,ae)));const ue=t.exec(W),Z=ue?ue[1]:"{}";try{const he=JSON.parse(Z);g?he.ELECTRON_RUN_AS_NODE=g:delete he.ELECTRON_RUN_AS_NODE,y?he.ELECTRON_NO_ATTACH_CONSOLE=y:delete he.ELECTRON_NO_ATTACH_CONSOLE,delete he.VSCODE_RESOLVING_ENVIRONMENT,delete he.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",he),s(he)}catch(he){u.error("getUnixShellEnvironment#errorCaught",(0,I.$ai)(he)),n(he)}})})}}),define(we[235],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.$2M=void 0,e.$2M=(0,v.$ph)("stateReadService"),e.$3M=(0,v.$ph)("stateService")}),define(we[236],be([1,0,14,15,8,25,16,12]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=e.$4M=e.SaveStrategy=void 0;var b;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(b||(e.SaveStrategy=b={}));class ${constructor(l,d,m,c){this.f=l,this.g=m,this.h=c,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=d===0?void 0:new v.$sg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(l){l.fileOperationResult!==1&&this.g.error(l)}}getItem(l,d){const m=this.a[l];return(0,r.$re)(m)?d:m}setItem(l,d){this.setItems([{key:l,data:d}])}setItems(l){let d=!1;for(const{key:m,data:c}of l)this.a[m]!==c&&((0,r.$re)(c)?(0,r.$pe)(this.a[m])||(this.a[m]=void 0,d=!0):(this.a[m]=c,d=!0));d&&this.j()}removeItem(l){(0,r.$pe)(this.a[l])||(this.a[l]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const l=JSON.stringify(this.a,null,4);if(l!==this.b)try{await this.h.writeFile(this.f,R.$Ec.fromString(l),{atomic:{postfix:".vsctmp"}}),this.b=l}catch(d){this.g.error(d)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$4M=$;let A=class{constructor(l,d,m,c){this.a=new $(d.stateResource,l,m,c)}async init(){await this.a.init()}getItem(l,d){return this.a.getItem(l,d)}};e.$5M=A,e.$5M=A=Le([Ie(1,S.$wh),Ie(2,P.$Ri),Ie(3,I.$Sj)],A);class E extends A{setItem(l,d){this.a.setItem(l,d)}setItems(l){this.a.setItems(l)}removeItem(l){this.a.removeItem(l)}close(){return this.a.close()}}e.$6M=E}),define(we[120],be([1,0,3,29,23]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=void 0;function S(b){if(v.$o===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function I(b,$,A,E,w,l,d,m){const c=Object.create(null);c["common.machineId"]=l,c.sessionID=(0,r.$3e)()+Date.now(),c.commitHash=E,c.version=w,c["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,v.$c)(v.$o),c["common.nodePlatform"]=R.$2c,c["common.nodeArch"]=A,c["common.product"]=m||"desktop",d&&(c["common.msftInternal"]=d);let u=0;const h=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),v.$g&&(c["common.snap"]="true");const g=S($);return g&&(c["common.platformDetail"]=g),c}e.$3n=I;function P(b){const $=R.env.USERDNSDOMAIN;if(!$)return!1;const A=$.toLowerCase();return b.some(E=>A===E)}e.$4n=P}),define(we[237],be([1,0,18,11,2,22,16]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var P;(function($){function A(E,w){return E.callstack<w.callstack?-1:E.callstack>w.callstack?1:0}$.compare=A})(P||(e.ErrorEvent=P={}));class b{constructor(A,E=b.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new r.$kb,this.c=A,this.d=E;const w=R.$V.addListener(l=>this.j(l));this.h.add((0,r.$jb)(w)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(A){if(!A||A.code||(A.detail&&A.detail.stack&&(A=A.detail),R.$ab.isErrorNoTelemetry(A)||A instanceof I.$ak||typeof A?.message=="string"&&A.message.includes("Unable to read file")))return;const E=Array.isArray(A.stack)?A.stack.join(`
`):A.stack,w=A.message?A.message:(0,S.$Om)(A);E&&this.k({msg:w,callstack:E})}k(A){const E=(0,v.$af)(this.g,A,P.compare);E<0?(A.count=1,this.g.splice(~E,0,A)):(this.g[E].count||(this.g[E].count=0),this.g[E].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const A of this.g)this.c.publicLogError2("UnhandledError",A);this.g.length=0}}b.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=b}),define(we[238],be([1,0,2]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class R extends v.$lb{constructor(S,I){super(),this.a=S,this.b=I}async call(S,I,P){switch(I){case"updateTelemetryLevel":{const{telemetryLevel:b}=P;return this.a.updateInjectedTelemetryLevel(b)}case"logTelemetry":{const{eventName:b,data:$}=P;return this.b?this.b.log(b,$):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${I} not found`)}listen(S,I,P){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$wr=R}),define(we[32],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,v.$ph)("telemetryService"),e.$Wk=(0,v.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var R;(function(S){S[S.NONE=0]="NONE",S[S.CRASH=1]="CRASH",S[S.ERROR=2]="ERROR",S[S.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var r;(function(S){S.OFF="off",S.CRASH="crash",S.ERROR="error",S.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(we[239],be([1,0,26,14,75,13,7,3,4,102,21,105,214,16,27,32]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=e.$mr=e.$lr=void 0;const c=new Map;async function u(t,i){const a=`${t}::${i.join(":")}`,s=c.get(a);if(s)return s;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,f=new Map,k=2e4;function D(L,U,x,ae){const W=U.substring(L.length+1);return R.Promises.withAsyncBody(async te=>{let ue;try{ue=await A.Promises.readdir(U,{withFileTypes:!0})}catch{te();return}if(ae.count>=k){ae.count+=ue.length,ae.maxReached=!0,te();return}let Z=ue.length;if(Z===0){te();return}let he=ue;ae.count+ue.length>k&&(ae.maxReached=!0,Z=k-ae.count,he=ue.slice(0,Z)),ae.count+=ue.length;for(const V of he)if(V.isDirectory()){if(x.includes(V.name)||await D(L,(0,I.$8c)(U,V.name),x,ae),--Z===0){te();return}}else{const se=V.name.lastIndexOf(".");if(se>=0){const K=V.name.substring(se+1);K&&o.set(K,(o.get(K)??0)+1)}for(const K of n)K.relativePathPattern?.test(W)!==!1&&K.filePattern.test(V.name)&&f.set(K.tag,(f.get(K.tag)??0)+1);if(--Z===0){te();return}}})}const C=R.Promises.withAsyncBody(async L=>{const U={count:0,maxReached:!1};await D(t,t,i,U);const x=await y(t);L({configFiles:h(f),fileTypes:h(o),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:x})});return c.set(a,C),C}e.$lr=u;function h(t){return Array.from(t.entries(),([i,a])=>({name:i,count:a})).sort((i,a)=>a.count-i.count)}function g(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/l.$nk.GB).toFixed(2)}GB (${(v.freemem()/l.$nk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$vm.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.$mr=g;async function y(t){try{const i=new Map,a=(0,I.$8c)(t,".vscode","launch.json"),s=await A.Promises.readFile(a),n=[],o=(0,r.$zm)(s.toString(),n);if(n.length)return console.log(`Unable to parse ${a}`),[];if((0,r.$Im)(o)==="object"&&o.configurations)for(const f of o.configurations){const k=f.type;k&&(i.has(k)?i.set(k,i.get(k)+1):i.set(k,1))}return h(i)}catch{return[]}}e.$nr=y;let p=class{constructor(i,a){this.c=i,this.d=a}f(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}g(i){const a=[];a.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),a.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const s=v.cpus();return s&&s.length>0&&a.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),a.push(`Memory (System):  ${(v.totalmem()/l.$nk.GB).toFixed(2)}GB (${(v.freemem()/l.$nk.GB).toFixed(2)}GB free)`),P.$d||a.push(`Load (avg):       ${v.loadavg().map(n=>Math.round(n)).join(", ")}`),a.push(`VM:               ${Math.round($.$vm.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.j(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,E.$kr)(i.mainPID),this.k(i)]).then(async s=>{let[n,o]=s,f=this.m(i,n);return a.forEach(k=>{if((0,w.$8l)(k))f+=`
${k.errorMessage}`,o+=`
${k.errorMessage}`;else if(f+=`

Remote: ${k.hostName}`,k.processes&&(f+=`
${this.m(i,k.processes)}`),k.workspaceMetadata){o+=`
|  Remote: ${k.hostName}`;for(const D of Object.keys(k.workspaceMetadata)){const C=k.workspaceMetadata[D];let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),o+=`|    Folder (${D}): ${L}`,o+=this.h(C)}}}),{processInfo:f,workspaceInfo:o}})}async getSystemInfo(i,a){const{memory:s,vmHint:n,os:o,cpus:f}=g(),k={os:o,memory:s,cpus:f,vmHint:n,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return P.$d||(k.load=`${v.loadavg().map(D=>Math.round(D)).join(", ")}`),P.$f&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(i,a){const s=[];return(0,E.$kr)(i.mainPID).then(async n=>(s.push(""),s.push(this.g(i)),s.push(""),s.push(this.m(i,n)),i.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(i))),a.forEach(o=>{if((0,w.$8l)(o))s.push(`
${o.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${o.hostName}`),s.push(this.f(o.machineInfo)),o.processes&&s.push(this.m(i,o.processes)),o.workspaceMetadata)for(const f of Object.keys(o.workspaceMetadata)){const k=o.workspaceMetadata[f];let D=`${k.fileCount} files`;k.maxFilesReached&&(D=`more than ${D}`),s.push(`Folder (${f}): ${D}`),s.push(this.h(k))}}),s.push(""),s.push(""),s.join(`
`)))}h(i){const a=[];let n=0;const o=(C,L)=>{const U=` ${C}(${L})`;n+U.length>60?(a.push(f),f="|                 ",n=f.length):n+=U.length,f+=U};let f="|      File types:";const k=10,D=i.fileTypes.length>k?k:i.fileTypes.length;for(let C=0;C<D;C++){const L=i.fileTypes[C];o(L.name,L.count)}if(a.push(f),i.configFiles.length>=0&&(f="|      Conf files:",n=0,i.configFiles.forEach(C=>{o(C.name,C.count)}),a.push(f)),i.launchConfigFiles.length>0){let C="|      Launch Configs:";i.launchConfigFiles.forEach(L=>{const U=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`;C+=U}),a.push(C)}return a.join(`
`)}j(i){const a=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(a-s.length)}  ${i[s]}`).join(`
                  `)}k(i){const a=[],s=[];return i.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(a.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const f=b.URI.revive(o);if(f.scheme===S.Schemas.file){const k=f.fsPath;s.push(u(k,["node_modules",".git"]).then(D=>{let C=`${D.fileCount} files`;D.maxFilesReached&&(C=`more than ${C}`),a.push(`|    Folder (${(0,I.$_c)(k)}): ${C}`),a.push(this.h(D))}).catch(D=>{a.push(`|      Error: Unable to collect workspace stats for folder ${k} (${D.toString()})`)}))}else a.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(n=>a.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(i,a){const s=new Map;i.windows.forEach(o=>s.set(o.pid,`window [${o.id}] (${o.title})`)),i.pidToNames.forEach(({pid:o,name:f})=>s.set(o,f));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),a&&this.n(i.mainPID,s,n,a,0),n.join(`
`)}n(i,a,s,n,o){const f=o===0;let k;f?k=n.pid===i?`${this.d.applicationName} main`:"remote agent":a.has(n.pid)?k=a.get(n.pid):k=`${"  ".repeat(o)} ${n.name}`;const D=process.platform==="win32"?n.mem:v.totalmem()*(n.mem/100);s.push(`${n.load.toFixed(0).padStart(5," ")}	${(D/l.$nk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(n.children)&&n.children.forEach(C=>this.n(i,a,s,C,o+1))}async getWorkspaceFileExtensions(i){const a=new Set;for(const{uri:s}of i.folders){const n=b.URI.revive(s);if(n.scheme!==S.Schemas.file)continue;const o=n.fsPath;try{(await u(o,["node_modules",".git"])).fileTypes.forEach(k=>a.add(k.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const s=b.URI.revive(a);if(s.scheme!==S.Schemas.file)continue;const n=s.fsPath;try{const o=await u(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),o.fileTypes.forEach(f=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),o.launchConfigFiles.forEach(f=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),o.configFiles.forEach(f=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};e.$or=p,e.$or=p=Le([Ie(0,m.$Vk),Ie(1,d.$0i)],p)}),define(we[36],be([1,0,22,8,5,24,56,120,32]),function(le,e,v,R,r,S,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=void 0;class ${constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$5n=$;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$6n=A,e.$7n=new A;class E{async publicLog(n,o,f){}async publicLogError(n,o,f){}}e.$8n=E,e.$9n="telemetry",e.$0n="extensionTelemetryLog",e.$$n={log:()=>null,flush:()=>Promise.resolve(null)};function w(s,n){return r.Event.debounce(n.onDidChangeConfiguration,(f,k)=>{const D=f?new Set([...f.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:D}},1e3,!0)(f=>{f.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,S.$Yh)(f.source),configurationKeys:Array.from(f.affectedKeys)})})}e.$_n=w;function l(s,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!s.enableTelemetry||n.extensionTestsLocationURI)}e.$ao=l;function d(s,n){return!(n.isBuilt||n.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$bo=d;function m(s){const n=s.getValue(b.$3k),o=s.getValue(b.$4k);if(s.getValue(b.$5k)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$co=m;function c(s){const n={},o={},f={};g(s,f);for(let k in f){k=k.length>150?k.substr(k.length-149):k;const D=f[k];typeof D=="number"?o[k]=D:typeof D=="boolean"?o[k]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${D.length}`),n[k]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(n[k]=D)}return{properties:n,measurements:o}}e.$do=c;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(s){if(!s)return"none";const n=(0,I.$Ck)(s);return u.has(n)?n:"other"}e.$eo=h;function g(s,n,o=0,f){if(s)for(const k of Object.getOwnPropertyNames(s)){const D=s[k],C=f?f+k:k;Array.isArray(D)?n[C]=(0,v.$Om)(D):D instanceof Date?n[C]=D.toISOString():(0,R.$ke)(D)?o<2?g(D,n,o+1,C+"."):n[C]=(0,v.$Om)(D):n[C]=D}}function y(s,n){const o=s.msftInternalDomains||[],f=n.getValue("telemetry.internalTesting");return(0,P.$4n)(o)||f}e.$fo=y;function p(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$go=p;function t(s,n){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let o=s;const f=[];for(const L of n)for(;;){const U=L.exec(s);if(!U)break;f.push([U.index,L.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(o="";;){const L=D.exec(s);if(!L)break;const U=f.some(([x,ae])=>L.index<ae&&x<D.lastIndex);!k.test(L[0])&&!U&&(o+=s.substring(C,L.index)+"<REDACTED: user-file-path>",C=D.lastIndex)}return C<s.length&&(o+=s.substr(C)),o}function i(s){if(!s)return s;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(s))return`<REDACTED: ${o.label}>`;return s}function a(s,n){return(0,v.$Lm)(s,o=>{if(o instanceof $||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let f=o.replaceAll("%20"," ");f=t(f,n);for(const k of n)f=f.replace(k,"");return f=i(f),f}})}e.$ho=a}),define(we[37],be([1,0,17,31,40,3,4,11,29,36]),function(le,e,v,R,r,S,I,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=void 0;function A(a,s){return a.uuid&&s.uuid?a.uuid===s.uuid:a.id===s.id?!0:(0,v.$Gd)(a.id,s.id)===0}e.$io=A;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const n=s.manifest?s.manifest.version:s.version,o=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,n,o)}static parse(s){const n=E.exec(s);return n&&n[1]&&n[2]?new w({id:n[1]},n[2],n[4]||void 0):null}constructor(s,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?A(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$jo=w;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(a){const s=l.exec(a);return s&&s[1]?[c(s[1]),s[2]]:[c(a),void 0]}e.$ko=d;function m(a,s){return`${a}.${s}`}e.$lo=m;function c(a){return a.toLowerCase()}e.$mo=c;function u(a,s){return c(m(a??r.$Fl,s))}e.$no=u;function h(a,s){const n=[],o=f=>{for(const k of n)if(k.some(D=>A(s(D),s(f))))return k;return null};for(const f of a){const k=o(f);k?k.push(f):n.push([f])}return n}e.$oo=h;function g(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$po=g;function y(a){return{id:new $.$5n(a.identifier.id),name:new $.$5n(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$qo=y,e.$ro=new r.$Jl("pprice.better-merge");function p(a,s){const n=[],o=s.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const f=o.shift();if(f&&n.every(k=>!A(k.identifier,{id:f}))){const k=a.filter(D=>A(D.identifier,{id:f}));k.length===1&&(n.push(k[0]),o.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$so=p;async function t(a,s){if(!S.$f)return!1;let n;try{n=(await a.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await a.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){s.debug("Error while getting the os-release file.",(0,P.$9)(f))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(a,s){const n=await t(a,s),o=(0,R.$Nn)(n?"alpine":S.$o,b.$3c);return s.debug("ComputeTargetPlatform:",o),o}e.$to=i}),define(we[121],be([1,0,20,11,13,19,53,4,178,31,37,40]),function(le,e,v,R,r,S,I,P,b,$,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=void 0;const w=c=>(0,b.localize)(0,null,c),l=(0,b.localize)(1,null,"ms-dotnettools.csharp");function d(c,u){return u?`${c.publisher}.${c.name}@${c.version}`:`${c.publisher}.${c.name}`}let m=class{constructor(u,h,g){this.a=u,this.b=h,this.d=g}get f(){}async listExtensions(u,h,g){let y=await this.b.getInstalled(1,g);const p=E.$Il.map(i=>i.toLowerCase());if(h&&h!==""){if(p.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}y=y.filter(i=>i.manifest.categories?i.manifest.categories.map(s=>s.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),p.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,b.localize)(2,null,this.f)),y=y.sort((i,a)=>i.identifier.id.localeCompare(a.identifier.id));let t;for(const i of y)t!==i.identifier.id&&(t=i.identifier.id,this.a.info(d(i.manifest,u)))}async installExtensions(u,h,g,y){const p=[];try{const t=[];u.length&&this.a.info(this.f?(0,b.localize)(3,null,this.f):(0,b.localize)(4,null));const i=[];let a=[];const s=(o,f,k)=>{a.push({id:o,version:f!=="prerelease"?f:void 0,installOptions:{...g,isBuiltin:k,installPreReleaseVersion:f==="prerelease"||g.installPreReleaseVersion}})};for(const o of u)if(o instanceof P.URI)i.push({vsix:o,installOptions:g});else{const[f,k]=(0,A.$ko)(o);s(f,k,!1)}for(const o of h)if(o instanceof P.URI)i.push({vsix:o,installOptions:{...g,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[f,k]=(0,A.$ko)(o);s(f,k,!0)}const n=await this.b.getInstalled(1,g.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:o,installOptions:f})=>{try{const k=await this.g(o,f,y,n);k&&t.push(k)}catch(k){this.a.error(k),p.push(o.toString())}})),a.length&&(a=a.filter(({id:o,version:f})=>{const k=n.find(D=>(0,A.$io)(D.identifier,{id:o}));if(k){if(!y&&(!f||f==="prerelease"&&k.preRelease))return this.a.info((0,b.localize)(5,null,o,k.manifest.version,o)),!1;if(f&&k.manifest.version===f)return this.a.info((0,b.localize)(6,null,`${o}@${f}`)),!1}return!0}),a.length)){const o=await this.h(a);await Promise.all(a.map(async f=>{const k=o.get(f.id.toLowerCase());if(k)try{const D=await this.j(f,k,n);D&&t.push(D)}catch(D){this.a.error(D.message||D.stack||D),p.push(f.id)}else this.a.error(`${w(f.version?`${f.id}@${f.version}`:f.id)}
${l}`),p.push(f.id)}))}}catch(t){throw this.a.error((0,b.localize)(7,null,(0,R.$9)(t))),t}if(p.length)throw new Error((0,b.localize)(8,null,p.join(", ")))}async g(u,h,g,y){const p=await this.b.getManifest(u);if(!p)throw new Error("Invalid vsix");if(await this.l(p,g,h.profileLocation,y))try{return await this.b.install(u,h),this.a.info((0,b.localize)(9,null,(0,S.$6f)(u))),p}catch(i){if((0,R.$2)(i))return this.a.info((0,b.localize)(10,null,(0,S.$6f)(u))),null;throw i}return null}async h(u){const h=new Map,g=u.some(t=>t.installOptions.installPreReleaseVersion),y=await this.b.getTargetPlatform(),p=[];for(const t of u)$.$Gn.test(t.id)&&p.push({...t,preRelease:g});if(p.length){const t=await this.d.getExtensions(p,{targetPlatform:y},v.CancellationToken.None);for(const i of t)h.set(i.identifier.id.toLowerCase(),i)}return h}async j({id:u,version:h,installOptions:g},y,p){const t=await this.d.getManifest(y,v.CancellationToken.None);if(t&&!this.k(t))return null;const i=p.find(a=>(0,A.$io)(a.identifier,y.identifier));if(i){if(y.version===i.manifest.version)return this.a.info((0,b.localize)(11,null,h?`${u}@${h}`:u)),null;this.a.info((0,b.localize)(12,null,u,y.version))}try{g.isBuiltin?this.a.info(h?(0,b.localize)(13,null,u,h):(0,b.localize)(14,null,u)):this.a.info(h?(0,b.localize)(15,null,u,h):(0,b.localize)(16,null,u));const a=await this.b.installFromGallery(y,{...g,installGivenVersion:!!h});return this.a.info((0,b.localize)(17,null,u,a.manifest.version)),t}catch(a){if((0,R.$2)(a))return this.a.info((0,b.localize)(18,null,u)),null;throw a}}k(u){return!0}async l(u,h,g,y){if(!h){const p={id:(0,A.$no)(u.publisher,u.name)},t=y.find(i=>(0,A.$io)(p,i.identifier)&&(0,I.gt)(i.manifest.version,u.version));if(t)return this.a.info((0,b.localize)(19,null,t.identifier.id,t.manifest.version,u.version)),!1}return this.k(u)}async uninstallExtensions(u,h,g){const y=async t=>{if(t instanceof P.URI){const i=await this.b.getManifest(t);return d(i)}return t},p=[];for(const t of u){const i=await y(t),s=(await this.b.getInstalled(void 0,g)).filter(n=>(0,A.$io)(n.identifier,{id:i}));if(!s.length)throw new Error(`${this.m(i)}
${l}`);if(s.some(n=>n.type===0)){this.a.info((0,b.localize)(20,null,i));return}if(!h&&s.some(n=>n.isBuiltin)){this.a.info((0,b.localize)(21,null,i));return}this.a.info((0,b.localize)(22,null,i));for(const n of s)await this.b.uninstall(n,{profileLocation:g}),p.push(n);this.f?this.a.info((0,b.localize)(23,null,i,this.f)):this.a.info((0,b.localize)(24,null,i))}}async locateExtension(u){const h=await this.b.getInstalled();u.forEach(g=>{h.forEach(y=>{if(y.identifier.id===g&&y.location.scheme===r.Schemas.file){this.a.info(y.location.fsPath);return}})})}m(u){return this.f?(0,b.localize)(25,null,u,this.f):(0,b.localize)(26,null,u)}};e.$1o=m,e.$1o=m=Le([Ie(1,$.$Un),Ie(2,$.$Sn)],m)}),define(we[240],be([1,0,5,2,28,37,40]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;class P extends R.$lb{constructor($,A,E,w,l,d,m){super(),this.f=$,this.g=A,this.h=E,this.i=w,this.j=l,this.k=d,this.l=m,this.a=this.B(new v.$ec),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.$tb),this.m().then(null,c=>m.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles($=>this.p($.added))),this.B(this.i.onAddExtensions($=>this.r($))),this.B(this.i.onDidAddExtensions($=>this.s($))),this.B(this.i.onRemoveExtensions($=>this.t($))),this.B(this.i.onDidRemoveExtensions($=>this.u($))),this.B(this.k.onDidFilesChange($=>this.v($)))}async p($){try{$.length&&await Promise.all($.map(A=>(this.c.set(A.id,(0,R.$ib)(this.k.watch(this.j.extUri.dirname(A.extensionsResource)),this.k.watch(A.extensionsResource))),this.y(A.extensionsResource))))}catch(A){throw this.l.error(A),A}}async r($){for(const A of $.extensions)this.C(this.F(A.identifier,A.version),$.profileLocation)}async s($){for(const A of $.extensions){const E=this.F(A.identifier,A.version);$.error?this.D(E,$.profileLocation):this.C(E,$.profileLocation)}}async t($){for(const A of $.extensions)this.D(this.F(A.identifier,A.version),$.profileLocation)}async u($){const A=[],E=[];for(const w of $.extensions){const l=this.F(w.identifier,w.version);$.error?this.C(l,$.profileLocation):(this.D(l,$.profileLocation),this.b.has(l)||(this.l.debug("Extension is removed from all profiles",w.identifier.id,w.version),E.push(this.f.scanInstalledExtensionAtLocation(w.location).then(d=>{d?A.push(d):this.l.info("Extension not found at the location",w.location.toString())},d=>this.l.error(d)))))}try{await Promise.all(E),A.length&&await this.z(A)}catch(w){this.l.error(w)}}v($){for(const A of this.h.profiles)$.contains(A.extensionsResource,0,1)&&this.w(A.extensionsResource)}async w($){const A=[],E=[],w=await this.i.scanProfileExtensions($),l=new Set,d=new Set;for(const[m,c]of this.b)c.has($)&&d.add(m);for(const m of w){const c=this.F(m.identifier,m.version);l.add(c),d.has(c)||(A.push(m.identifier),this.C(c,$))}for(const m of d)if(!l.has(m)){const c=this.G(m);c&&(E.push(c.identifier),this.D(m,$))}(A.length||E.length)&&this.a.fire({added:A.length?{extensions:A,profileLocation:$}:void 0,removed:E.length?{extensions:E,profileLocation:$}:void 0})}async y($){const A=await this.i.scanProfileExtensions($);for(const E of A)this.C(this.F(E.identifier,E.version),$)}async z($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.F(E.identifier,E.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}C($,A){let E=this.b.get($);E||this.b.set($,E=new r.$oi(w=>this.j.extUri.getComparisonKey(w))),E.add(A)}D($,A){const E=this.b.get($);E&&E.delete(A),E?.size||this.b.delete($)}F($,A){return`${I.$Jl.toKey($.id)}@${A}`}G($){const[A,E]=(0,S.$ko)($);return E?{identifier:{id:A},version:E}:void 0}}e.$pp=P}),define(we[241],be([1,0,211,36]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0;async function r(S,I,P,b,$,A,E){const w={"X-Market-Client-Id":`VSCode ${S}`,"User-Agent":`VSCode ${S} (${I.nameShort})`};if((0,R.$ao)(I,P)&&(0,R.$co)(b)===3){const l=await(0,v.$To)(P,$,A);w["X-Market-User-Id"]=l,w["VSCode-SessionId"]=E.machineId||l}return w}e.$Uo=r}),define(we[122],be([1,0,87,18,14,2,13,7,21,25,31,37,12,84,4]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;let m=class extends l.$Bq{constructor(g,y,p,t){super(p),this.h=g,this.i=t,this.g=this.B(new c(y,t)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(g,y){const t=(await this.g.getLanguagePacks())[y];if(!t){this.i.warn(`No language pack found for ${y}`);return}const i=t.translations[g];return i?d.URI.file(i):void 0}async getInstalledLanguages(){const g=await this.g.getLanguagePacks(),y=Object.keys(g).map(p=>{const t=g[p];return{...this.f(p,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return y.push(this.f("en","English")),y.sort((p,t)=>p.label.localeCompare(t.label)),y}async j(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",g.identifier.id),await this.update())}async k(g){const y=await this.g.getLanguagePacks();Object.keys(y).some(p=>y[p]&&y[p].extensions.some(t=>(0,E.$io)(t.extensionIdentifier,g.identifier)))&&(this.i.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),p=await this.g.update(y);return!(0,R.$$e)(Object.keys(g),Object.keys(p))}};e.$Cq=m,e.$Cq=m=Le([Ie(0,A.$Un),Ie(1,$.$xh),Ie(2,A.$Sn),Ie(3,w.$Ri)],m);let c=class extends S.$lb{constructor(g,y){super(),this.i=y,this.c={},this.f=(0,P.$8c)(g.userDataPath,"languagepacks.json"),this.g=new r.$Bg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(g){return this.m(y=>{Object.keys(y).forEach(p=>delete y[p]),this.j(y,...g)}).then(()=>this.c)}j(g,...y){for(const p of y)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.k(g,p);Object.keys(g).forEach(p=>this.l(g[p]))}k(g,y){const p=y.identifier,t=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const i of t)if(y.location.scheme===I.Schemas.file&&u(i)){let a=g[i.languageId];a||(a={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},g[i.languageId]=a);const s=a.extensions.filter(n=>(0,E.$io)(n.extensionIdentifier,p))[0];s?s.version=y.manifest.version:a.extensions.push({extensionIdentifier:p,version:y.manifest.version});for(const n of i.translations)a.translations[n.id]=(0,P.$8c)(y.location.fsPath,n.path)}}l(g){if(g){const y=(0,v.createHash)("md5");for(const p of g.extensions)y.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);g.hash=y.digest("hex")}}m(g=()=>null){return this.g.queue(()=>{let y=null;return b.Promises.readFile(this.f,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch{return{}}}).then(p=>(y=g(p),p)).then(p=>{for(const i of Object.keys(p))p[i]||delete p[i];this.c=p,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),b.Promises.writeFile(this.f,t)}).then(()=>y,p=>this.i.error(p))})}};c=Le([Ie(0,$.$xh),Ie(1,w.$Ri)],c);function u(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const g of h.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(we[242],be([1,0,150,11,22,36]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function b(A,E,w){const l=await(0,v.$3C)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,v.$3C)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new l.AppInsightsCore,c=new d.PostChannel,u={instrumentationKey:A,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[c]]};if(w){u.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:w};u.extensionConfig[c.identifier]=h}return m.initialize(u,[]),m.addTelemetryInitializer(h=>{E&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),m}class ${constructor(E,w,l,d,m){this.e=E,this.f=w,this.g=l,this.h=m,this.c=I,this.d=P,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=b(this.a,this.e,this.h)),this.b.then(w=>{E(w)},w=>{(0,R.$Y)(w),console.error(w)})}}log(E,w){if(!this.a)return;w=(0,r.$Mm)(w,this.g),w=(0,S.$do)(w);const l=this.f+"/"+E;try{this.i(d=>{d.pluginVersionString=w?.properties.version??"Unknown",d.track({name:l,baseData:{name:l,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$XM=$}),define(we[243],be([1,0,2,22,3,17,192,24,55,54,27,35,32,36]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;let d=class{constructor(u,h,g){this.k=h,this.l=g,this.d={},this.i=new v.$kb,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,S.$pd)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,S.$pd)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(w.$3k)||y.affectsConfiguration(w.$5k)||y.affectsConfiguration(w.$4k))&&this.m()}))}setExperimentProperty(u,h){this.d[u]=h}m(){let u=(0,l.$co)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const g=h.usage?3:h.error?2:0;u=Math.min(u,g)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,h,g){this.g<h||(g=(0,R.$Mm)(g,this.d),g=(0,l.$ho)(g,this.j),g=(0,R.$Mm)(g,this.c),this.b.forEach(y=>y.log(u,g)))}publicLog(u,h){this.n(u,3,h)}publicLog2(u,h){this.publicLog(u,h)}publicLogError(u,h){this.h&&this.n(u,2,h)}publicLogError2(u,h){this.publicLogError(u,h)}};e.$Iq=d,d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$Iq=d=Le([Ie(1,P.$Vh),Ie(2,A.$0i)],d);function m(){const c=(0,I.localize)(0,null,$.default.nameLong),u=$.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",$.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=r.$j?"":(0,I.localize)(3,null),g=(0,I.localize)(4,null),y=(0,I.localize)(5,null),p=(0,I.localize)(6,null),t=(0,I.localize)(7,null),i=`
|       | ${g} | ${y} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,I.localize)(8,null);return`
${c} ${u} ${h}

&nbsp;

${t}
${i}

&nbsp;

${a}
`}E.$Vm.as(b.$1m.Configuration).registerConfiguration({id:w.$2k,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[w.$3k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Vm.as(b.$1m.Configuration).registerConfiguration({id:w.$2k,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[w.$5k]:{type:"boolean",markdownDescription:$.default.privacyStatementUrl?(0,I.localize)(16,null,$.default.nameLong,$.default.privacyStatementUrl):(0,I.localize)(15,null,$.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${w.$3k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[244],be([1,0,24,6,27,32,243,36]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=void 0;let b=class extends I.$Iq{constructor(A,E,w,l){super(A,w,l),this.o=E}publicLog(A,E){if(!(this.o<3))return super.publicLog(A,E)}publicLog2(A,E){return this.publicLog(A,E)}publicLogError(A,E){return this.o<2?Promise.resolve(void 0):super.publicLogError(A,E)}publicLogError2(A,E){return this.publicLogError(A,E)}async updateInjectedTelemetryLevel(A){if(A===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,A):A,this.o===0&&this.dispose()}};e.$tr=b,e.$tr=b=Le([Ie(2,v.$Vh),Ie(3,r.$0i)],b),e.$ur=new class extends P.$6n{async updateInjectedTelemetryLevel(){}},e.$vr=(0,R.$qh)(S.$Vk)}),define(we[245],be([1,0,15,20,246,242]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=void 0;async function I(A,E){const w=await E.request(A,R.CancellationToken.None),l=(await(0,v.$Qc)(w.stream)).toString(),d=w.res.statusCode??200;return{headers:w.res.headers,statusCode:d,responseData:l}}async function P(A){const E={method:A.type,headers:A.headers};return new Promise((l,d)=>{const m=r.request(A.url??"",E,c=>{c.on("data",function(u){l({headers:c.headers,statusCode:c.statusCode??200,responseData:u.toString()})}),c.on("error",function(u){d(u)})});m.write(A.data,c=>{c&&d(c)}),m.end()})}async function b(A,E,w){const l=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),d={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:l};try{const m=A?await I(d,A):await P(d);w(m.statusCode,m.headers,m.responseData)}catch{w(0,{})}}class $ extends S.$XM{constructor(E,w,l,d,m){const c={sendPOST:(u,h)=>{b(E,u,h)}};super(w,l,d,m,c)}}e.$YM=$}),define(we[247],be([1,0,11,237]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class r extends R.default{i(){(0,v.setUnexpectedErrorHandler)(P=>console.error(P));const I=[];process.on("unhandledRejection",(P,b)=>{I.push(b),setTimeout(()=>{const $=I.indexOf(b);$>=0&&b.catch(A=>{I.splice($,1),(0,v.$2)(A)||(console.warn(`rejected promise not handled within 1 second: ${A}`),A.stack&&console.warn(`stack trace: ${A.stack}`),P&&(0,v.$Y)(P))})},1e3)}),process.on("rejectionHandled",P=>{const b=I.indexOf(P);b>=0&&I.splice(b,1)}),process.on("uncaughtException",P=>{(0,v.$X)(P)||(0,v.$Y)(P)})}}e.default=r}),define(we[123],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var v;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(v||(e.EnvironmentVariableMutatorType=v={}))}),define(we[124],be([1,0,3,123]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;const r=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class S{constructor(A){this.collections=A,this.a=new Map,this.b=new Map,A.forEach((E,w)=>{this.d(E,w);const l=E.map.entries();let d=l.next();for(;!d.done;){const m=d.value[1],c=d.value[0];let u=this.a.get(c);if(u||(u=[],this.a.set(c,u)),u.length>0&&u[0].type===R.EnvironmentVariableMutatorType.Replace){d=l.next();continue}const h={extensionIdentifier:w,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};h.scope||delete h.scope,u.unshift(h),d=l.next()}})}async applyToProcessEnvironment(A,E,w){let l;v.$d&&(l={},Object.keys(A).forEach(d=>l[d.toLowerCase()]=d));for(const[d,m]of this.getVariableMap(E)){const c=v.$d&&l[d.toLowerCase()]||d;for(const u of m){const h=w?await w(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case R.EnvironmentVariableMutatorType.Append:A[c]=(A[c]||"")+h;break;case R.EnvironmentVariableMutatorType.Prepend:A[c]=h+(A[c]||"");break;case R.EnvironmentVariableMutatorType.Replace:A[c]=h;break}if(u.options?.applyAtShellIntegration??!1){const g=`VSCODE_ENV_${r.get(u.type)}`;A[g]=(A[g]?A[g]+":":"")+d+"="+this.c(h)}}}}c(A){return A.replaceAll(":","\\x3a")}diff(A,E){const w=new Map,l=new Map,d=new Map;if(A.getVariableMap(E).forEach((m,c)=>{const u=this.getVariableMap(E).get(c),h=P(m,u);h&&w.set(c,h)}),this.getVariableMap(E).forEach((m,c)=>{const u=A.getVariableMap(E).get(c),h=P(m,u);h&&d.set(c,h)}),this.getVariableMap(E).forEach((m,c)=>{const u=A.getVariableMap(E).get(c),h=b(m,u);h&&l.set(c,h)}),!(w.size===0&&l.size===0&&d.size===0))return{added:w,changed:l,removed:d}}getVariableMap(A){const E=new Map;for(const w of this.a.values()){const l=w.filter(d=>I(d,A));l.length>0&&E.set(l[0].variable,l)}return E}getDescriptionMap(A){const E=new Map;for(const w of this.b.values()){const l=w.filter(d=>I(d,A,!0));for(const d of l)E.set(d.extensionIdentifier,d.description)}return E}d(A,E){if(!A.descriptionMap)return;const w=A.descriptionMap.entries();let l=w.next();for(;!l.done;){const d=l.value[1],m=l.value[0];let c=this.b.get(m);c||(c=[],this.b.set(m,c));const u={extensionIdentifier:E,scope:d.scope,description:d.description};u.scope||delete u.scope,c.push(u),l=w.next()}}}e.$$q=S;function I($,A,E=!1){return $.scope?!!($.scope.workspaceFolder&&A?.workspaceFolder&&$.scope.workspaceFolder.index===A.workspaceFolder.index):E?A===$.scope:!0}function P($,A){if(!A)return $;const E=new Set;A.forEach(l=>E.add(l.extensionIdentifier));const w=[];return $.forEach(l=>{E.has(l.extensionIdentifier)||w.push(l)}),w.length===0?void 0:w}function b($,A){if(!A)return;const E=new Map;A.forEach(l=>E.set(l.extensionIdentifier,l));const w=[];return $.forEach(l=>{const d=E.get(l.extensionIdentifier);d&&(l.type!==d.type||l.value!==d.value||l.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&w.push(d)}),w.length===0?void 0:w}}),define(we[88],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=void 0;function v(b){return[...b.entries()]}e.$5q=v;function R(b){return b?[...b.entries()]:[]}e.$6q=R;function r(b){return new Map(b)}e.$7q=r;function S(b){return new Map(b??[])}e.$8q=S;function I(b){return Array.from(b.entries()).map($=>[$[0],v($[1].map),R($[1].descriptionMap)])}e.$9q=I;function P(b){return new Map(b.map($=>[$[0],{map:r($[1]),descriptionMap:S($[2])}]))}e.$0q=P}),define(we[248],be([1,0,14,20,5,2,12]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let P=class extends S.$lb{constructor($,A){super(),this.h=A,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$ec),this.onCreateRequest=this.g.event,this.b=$===void 0?15e3:$}createRequest($){return new Promise((A,E)=>{const w=++this.a;this.c.set(w,A),this.g.fire({requestId:w,...$});const l=new R.$oc;(0,v.$vg)(this.b,l.token).then(()=>E(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,S.$jb)(()=>l.cancel())])})}acceptReply($,A){const E=this.c.get($);E?(this.c.delete($),(0,S.$gb)(this.f.get($)||[]),this.f.delete($),E(A)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${$}`)}};e.$Vq=P,e.$Vq=P=Le([Ie(1,I.$Ri)],P)}),define(we[89],be([1,0,6,66,35]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=e.$Pq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Oq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Nq=void 0,e.$Nq=new R.$Oi("terminalTabFocusMode",!1,!0);var S;(function(p){p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(S||(e.TerminalSettingPrefix=S={}));var I;(function(p){p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsDefaultColor="terminal.integrated.tabs.defaultColor",p.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.TabStopWidth="terminal.integrated.tabStopWidth",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorStyleInactive="terminal.integrated.cursorStyleInactive",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.TabFocusMode="terminal.integrated.tabFocusMode",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.HideOnStartup="terminal.integrated.hideOnStartup",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies",p.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",p.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",p.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",p.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",p.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",p.EnableImages="terminal.integrated.enableImages",p.SmoothScrolling="terminal.integrated.smoothScrolling",p.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",p.FocusAfterRun="terminal.integrated.focusAfterRun",p.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",p.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",p.DevMode="terminal.integrated.developer.devMode"})(I||(e.TerminalSettingId=I={}));var P;(function(p){p.PowerShell="pwsh",p.Bash="bash",p.Fish="fish",p.Sh="sh",p.Csh="csh",p.Ksh="ksh",p.Zsh="zsh"})(P||(e.PosixShellType=P={}));var b;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(b||(e.WindowsShellType=b={}));var $;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})($||(e.TitleEventSource=$={}));var A;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.PtyHostWindow="ptyHostWindow",p.Logger="logger",p.Heartbeat="heartbeat"})(A||(e.TerminalIpcChannels=A={}));var E;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions",p.FailedShellIntegrationActivation="failedShellIntegrationActivation",p.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$Oq=(0,v.$ph)("ptyService");var w;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var l;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(l||(e.TerminalLocation=l={}));var d;(function(p){p.TerminalView="view",p.Editor="editor"})(d||(e.TerminalLocationString=d={}));var m;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var c;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(c||(e.FlowControlConstants=c={}));var u;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var h;(function(p){p[p.Off=0]="Off",p[p.FinalTerm=1]="FinalTerm",p[p.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var g;(function(p){p[p.Unknown=0]="Unknown",p[p.Shutdown=1]="Shutdown",p[p.Process=2]="Process",p[p.User=3]="User",p[p.Extension=4]="Extension"})(g||(e.TerminalExitReason=g={})),e.$Pq={Backend:"workbench.contributions.terminal.processBackend"};class y{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const i=this.b(t.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}r.$Vm.add(e.$Pq.Backend,new y),e.$Qq=(0,v.$ph)("localPtyService"),e.$Rq=(0,v.$ph)("terminalLogService")}),define(we[249],be([1,0,3]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=e.$AM=void 0;function R(I){let P=I;P.includes("\\")&&(P=P.replace(/\\/g,"\\\\"));const b=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return P=P.replace(b,""),`'${P}'`}e.$AM=R;function r(I,P,b){if(!I)return"";if(!P)return I;P.match(/[\/\\]$/)&&(P=P.slice(0,P.length-1));const $=I.replace(/\\/g,"/").toLowerCase(),A=P.replace(/\\/g,"/").toLowerCase();return $.includes(A)?`~${b}${I.slice(P.length+1)}`:I}e.$BM=r;function S(I){return I.match(/^['"].*['"]$/)&&(I=I.substring(1,I.length-1)),v.OS===1&&I&&I[1]===":"?I[0].toUpperCase()+I.substring(1):I}e.$CM=S}),define(we[250],be([1,0,49,4,194,100]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=e.$Wq=void 0;function I(w,l){const d=[{name:null,description:(0,r.localize)(0,null)}];return d.push(...w.map(m=>({name:m.profileName,description:P(m)}))),l&&d.push(...l.map(m=>({name:m.title,description:b(m)}))),{values:d.map(m=>m.name),markdownDescriptions:d.map(m=>m.description)}}e.$Wq=I;function P(w){let l=`$(${S.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:v.$Cj.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?l+=`
- args: "${w.args}"`:l+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(l+=`
- overrideName: ${w.overrideName}`),w.color&&(l+=`
- color: ${w.color}`),w.env&&(l+=`
- env: ${JSON.stringify(w.env)}`),l}function b(w){return`$(${S.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:v.$Cj.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function $(w,l){if(!w&&!l)return!0;if(typeof w=="string"&&typeof l=="string")return w===l;if(Array.isArray(w)&&Array.isArray(l)){if(w.length!==l.length)return!1;for(let d=0;d<w.length;d++)if(w[d]!==l[d])return!1;return!0}return!1}e.$Xq=$;function A(w,l){if(!w&&!l)return!0;if(!w||!l)return!1;if(S.ThemeIcon.isThemeIcon(w)&&S.ThemeIcon.isThemeIcon(l))return w.id===l.id&&w.color===l.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof l=="object"&&"light"in l&&"dark"in l){const d=w,m=l;if((R.URI.isUri(d.light)||E(d.light))&&(R.URI.isUri(d.dark)||E(d.dark))&&(R.URI.isUri(m.light)||E(m.light))&&(R.URI.isUri(m.dark)||E(m.dark)))return d.light.path===m.light.path&&d.dark.path===m.dark.path}if(R.URI.isUri(w)&&R.URI.isUri(l)||E(w)||E(l)){const d=w,m=l;return d.path===m.path&&d.scheme===m.scheme}return!1}e.$Yq=A;function E(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.$Zq=E}),define(we[251],be([1,0,49,3,193,55,35,250]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=e.$1q=void 0,e.$1q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$2q={type:"string",enum:Array.from((0,v.$Bj)(),c=>c.id),markdownEnumDescriptions:Array.from((0,v.$Bj)(),c=>`$(${c.id})`)};const b={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$2q},color:{description:(0,r.localize)(3,null),...e.$1q},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},$={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},A={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...b}};function E(c){const u=c===2?"linux":c===1?"osx":"windows";return(0,r.localize)(7,null,(0,R.$c)(c),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:E(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...b}},{type:"null"},$]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:E(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...b}},{type:"null"},$]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:E(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...b}},{type:"null"},$]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){I.$Vm.as(S.$1m.Configuration).registerConfiguration(w),m()}e.$3q=l;let d;function m(c,u){const h=I.$Vm.as(S.$1m.Configuration);let g;c&&(g=(0,P.$Wq)(c?.profiles,u));const y=d;d={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:c?.os===3?g?.values:void 0,markdownEnumDescriptions:c?.os===3?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:c?.os===2?g?.values:void 0,markdownEnumDescriptions:c?.os===2?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:c?.os===1?g?.values:void 0,markdownEnumDescriptions:c?.os===1?g?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[d],remove:y?[y]:[]})}e.$4q=m}),define(we[252],be([1,0,2,13,108,25,110]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;let P=class extends v.$lb{constructor($,A){super(),this.a=$,this.b=A}start(){const $={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},A=(0,I.$1l)(this.b.args,this.b.isBuilt);A&&(A.break&&A.port?$.debugBrk=A.port:!A.break&&A.port&&($.debug=A.port));const E=new r.$Kp(R.$1e.asFileUri("bootstrap-fork").fsPath,$),w=new v.$kb;return w.add(E),{client:E,store:w,onDidProcessExit:E.onDidProcessExit}}};e.$gN=P,e.$gN=P=Le([Ie(1,S.$wh)],P)}),define(we[253],be([1,0,26,13,22,7,3,29,17,8,21,123,88,124]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=void 0;function d(){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());let n=0;return s&&s.length===4&&(n=parseInt(s[3])),n}e.$_q=d;async function m(s,n,o,f=P.env,k=A.Promises.exists){if(S.$7c(s))return await k(s)?s:void 0;if(n===void 0&&(n=P.cwd()),S.$$c(s)!=="."){const U=S.$8c(n,s);return await k(U)?U:void 0}const C=(0,r.$Qm)(f,"PATH");if(o===void 0&&(0,$.$ie)(C)&&(o=C.split(S.$fd)),o===void 0||o.length===0){const U=S.$8c(n,s);return await k(U)?U:void 0}for(const U of o){let x;if(S.$7c(U)?x=S.$8c(U,s):x=S.$8c(n,U,s),await k(x))return x;if(I.$d){let ae=x+".com";if(await k(ae)||(ae=x+".exe",await k(ae)))return ae}}const L=S.$8c(n,s);return await k(L)?L:void 0}e.$ar=m;function c(s,n,o,f,k){const D=I.$d&&(!n.windowsEnableConpty||d()<18309);if(!n.shellIntegration.enabled||!s.executable||s.isFeatureTerminal||s.hideFromUser||s.ignoreShellIntegration||D)return;const C=s.args,L=P.$2c==="win32"?S.$_c(s.executable).toLowerCase():S.$_c(s.executable),U=S.$$c(R.$1e.asFileUri("").fsPath);let x;const ae={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(ae.VSCODE_NONCE=n.shellIntegration.nonce),I.$d){if(L==="pwsh.exe"||L==="powershell.exe")return!C||i(C)?x=g.get(h.WindowsPwsh):t(C)&&(x=g.get(h.WindowsPwshLogin)),x?(x=[...x],x[x.length-1]=(0,b.$md)(x[x.length-1],U,""),{newArgs:x,envMixin:ae}):void 0;f.warn(`Shell integration cannot be enabled for executable "${s.executable}" and args`,s.args);return}switch(L){case"bash":return!C||C.length===0?x=g.get(h.Bash):a(C)&&(ae.VSCODE_SHELL_LOGIN="1",u(n,ae),x=g.get(h.Bash)),x?(x=[...x],x[x.length-1]=(0,b.$md)(x[x.length-1],U),{newArgs:x,envMixin:ae}):void 0;case"fish":{const W=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",te=S.$8c(U,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return ae.XDG_DATA_DIRS=`${W}:${te}`,u(n,ae),{newArgs:void 0,envMixin:ae}}case"pwsh":return!C||i(C)?x=g.get(h.Pwsh):t(C)&&(x=g.get(h.PwshLogin)),x?(x=[...x],x[x.length-1]=(0,b.$md)(x[x.length-1],U,""),{newArgs:x,envMixin:ae}):void 0;case"zsh":{if(!C||C.length===0?x=g.get(h.Zsh):a(C)?(x=g.get(h.ZshLogin),u(n,ae)):(C===g.get(h.Zsh)||C===g.get(h.ZshLogin))&&(x=C),!x)return;x=[...x],x[x.length-1]=(0,b.$md)(x[x.length-1],U);let W;try{W=v.userInfo().username}catch{W="unknown"}const te=S.$8c(v.tmpdir(),`${W}-${k.applicationName}-zsh`);ae.ZDOTDIR=te;const ue=o?.ZDOTDIR??v.homedir()??"~";ae.USER_ZDOTDIR=ue;const Z=[];return Z.push({source:S.$8c(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:S.$8c(te,".zshrc")}),Z.push({source:S.$8c(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:S.$8c(te,".zprofile")}),Z.push({source:S.$8c(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:S.$8c(te,".zshenv")}),Z.push({source:S.$8c(U,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:S.$8c(te,".zlogin")}),{newArgs:x,envMixin:ae,filesToCopy:Z}}}f.warn(`Shell integration cannot be enabled for executable "${s.executable}" and args`,s.args)}e.$br=c;function u(s,n){if(I.$e&&s.environmentVariableCollections){const o=(0,w.$0q)(s.environmentVariableCollections),k=new l.$$q(o).getVariableMap({workspaceFolder:s.workspaceFolder}).get("PATH"),D=[];if(k)for(const C of k)C.type===E.EnvironmentVariableMutatorType.Prepend&&D.push(C.value);D.length>0&&(n.VSCODE_PATH_PREFIX=D.join(""))}}var h;(function(s){s.WindowsPwsh="windows-pwsh",s.WindowsPwshLogin="windows-pwsh-login",s.Pwsh="pwsh",s.PwshLogin="pwsh-login",s.Zsh="zsh",s.ZshLogin="zsh-login",s.Bash="bash"})(h||(h={}));const g=new Map;g.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(h.Zsh,["-i"]),g.set(h.ZshLogin,["-il"]),g.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const y=["-login","-l"],p=["-nol","-nologo"];function t(s){return typeof s=="string"?y.includes(s.toLowerCase()):s.length===1&&y.includes(s[0].toLowerCase())||s.length===2&&(y.includes(s[0].toLowerCase())||y.includes(s[1].toLowerCase()))&&(p.includes(s[0].toLowerCase())||p.includes(s[1].toLowerCase()))}function i(s){return typeof s=="string"?p.includes(s.toLowerCase()):s.length===0||s?.length===1&&p.includes(s[0].toLowerCase())}function a(s){return s==="string"&&y.includes(s.toLowerCase())||typeof s!="string"&&s.length===1&&y.includes(s[0].toLowerCase())}}),define(we[254],be([1,0,52,49,7,3,8,21,103,253,77]),function(le,e,v,R,r,S,I,P,b,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;let E,w=!0;function l(n,o,f,k,D=process.env,C,L,U,x){return C=C||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},S.$d?d(f,C,D,L,k.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:k.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:k.getValue("terminal.integrated.defaultProfile.windows"),x,U):i(C,L,f,n&&typeof n=="object"?{...n}:k.getValue(S.$f?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:k.getValue(S.$f?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),x,U,D)}e.$cr=l;async function d(n,o,f,k,D,C,L,U,x){const ae=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),W=`${process.env.windir}\\${ae?"Sysnative":"System32"}`;let te=!1;(0,$.$_q)()>=16299&&(te=!0),await h(U);const ue=new Map;if(n){ue.set("PowerShell",{source:"PowerShell",icon:R.$Cj.terminalPowershell,isAutoDetected:!0}),ue.set("Windows PowerShell",{path:`${W}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Cj.terminalPowershell,isAutoDetected:!0}),ue.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ue.set("Command Prompt",{path:`${W}\\cmd.exe`,icon:R.$Cj.terminalCmd,isAutoDetected:!0}),ue.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ue.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$Cj.terminalBash,isAutoDetected:!0});const he=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ue.set("Cmder",{path:`${W}\\cmd.exe`,args:["/K",he],requiresPath:process.env.CMDER_ROOT?he:{path:he,isUnsafe:!0},isAutoDetected:!0})}a(C,ue);const Z=await m(ue.entries(),L,o,f,k,x);if(n&&D)try{const he=await p(`${W}\\${te?"wsl":"bash"}.exe`,L);for(const V of he)(!C||!(V.profileName in C))&&Z.push(V)}catch{w&&(k?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return Z}async function m(n,o,f,k=process.env,D,C){const L=[];for(const[U,x]of n)L.push(c(U,x,o,f,k,D,C));return(await Promise.all(L)).filter(U=>!!U)}async function c(n,o,f,k,D=process.env,C,L){if(o===null)return;let U,x,ae;if("source"in o&&!("path"in o)){const Z=E?.get(o.source);if(!Z)return;U=Z.paths,x=o.args||Z.args,o.icon?ae=u(o.icon):Z.icon&&(ae=Z.icon)}else U=Array.isArray(o.path)?o.path:[o.path],x=S.$d||Array.isArray(o.args)?o.args:void 0,ae=u(o.icon);let W;if(L){const Z=U.map(V=>typeof V=="string"?V:V.path),he=await L(Z);W=new Array(U.length);for(let V=0;V<U.length;V++)typeof U[V]=="string"?W[V]=he[V]:W[V]={path:he[V],isUnsafe:!0}}else W=U.slice();let te;if(o.requiresPath){let Z;if((0,I.$ie)(o.requiresPath)?Z=o.requiresPath:(Z=o.requiresPath.path,o.requiresPath.isUnsafe&&(te=Z)),!await k.existsFile(Z))return}const ue=await s(n,f,W,k,D,x,o.env,o.overrideName,o.isAutoDetected,te);if(!ue){C?.debug("Terminal profile not validated",n,U);return}return ue.isAutoDetected=o.isAutoDetected,ue.icon=ae,ue.color=o.color,ue}function u(n){return typeof n=="string"?{id:n}:n}async function h(n){if(E&&!n)return;const[o,f]=await Promise.all([g(),n||y()]);E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),E.set("PowerShell",{profileName:"PowerShell",paths:f,icon:R.$Cj.terminalPowershell})}async function g(){const n=new Set,o=await(0,$.$ar)("git.exe");if(o){const D=(0,A.dirname)(o);n.add((0,A.resolve)(D,"../.."))}function f(D,C){C&&D.add(C)}f(n,process.env.ProgramW6432),f(n,process.env.ProgramFiles),f(n,process.env["ProgramFiles(X86)"]),f(n,`${process.env.LocalAppData}\\Program`);const k=[];for(const D of n)k.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return k.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),k}async function y(){const n=[];for await(const o of(0,b.$el)())n.push(o.exePath);return n}async function p(n,o){const f=[],k=await new Promise((L,U)=>{v.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(x,ae)=>{if(x)return U("Problem occurred when getting wsl distros");L(ae)})});if(!k)return[];const D=new RegExp(/[\r?\n]/),C=k.split(D).filter(L=>L.trim().length>0&&L!=="");for(const L of C){if(L===""||L.startsWith("docker-desktop"))continue;const U=`${L} (WSL)`,x={profileName:U,path:n,args:["-d",`${L}`],isDefault:U===o,icon:t(L),isAutoDetected:!1};f.push(x)}return f}function t(n){return n.includes("Ubuntu")?R.$Cj.terminalUbuntu:n.includes("Debian")?R.$Cj.terminalDebian:R.$Cj.terminalLinux}async function i(n,o,f,k,D,C,L,U){const x=new Map;if(f){const ae=(await n.readFile("/etc/shells")).toString(),W=(C||ae.split(`
`)).map(ue=>{const Z=ue.indexOf("#");return Z===-1?ue:ue.substring(0,Z)}).filter(ue=>ue.trim().length>0),te=new Map;for(const ue of W){let Z=(0,r.$_c)(ue),he=te.get(Z)||0;he++,he>1&&(Z=`${Z} (${he})`),te.set(Z,he),x.set(Z,{path:ue,isAutoDetected:!0})}}return a(k,x),await m(x.entries(),D,n,U,o,L)}function a(n,o){if(n)for(const[f,k]of Object.entries(n))k===null||typeof k!="object"||!("path"in k)&&!("source"in k)?o.delete(f):(k.icon=k.icon||o.get(f)?.icon,o.set(f,k))}async function s(n,o,f,k,D,C,L,U,x,ae){if(f.length===0)return Promise.resolve(void 0);const W=f.shift();if(W==="")return s(n,o,f,k,D,C,L,U,x);const te=typeof W!="string"&&W.isUnsafe,ue=typeof W=="string"?W:W.path,Z={profileName:n,path:ue,args:C,env:L,overrideName:U,isAutoDetected:x,isDefault:n===o,isUnsafePath:te,requiresUnsafePath:ae};if((0,r.$_c)(ue)===ue){const V=D.PATH?D.PATH.split(r.$fd):void 0,se=await(0,$.$ar)(ue,void 0,V,void 0,k.existsFile);return se?(Z.path=se,Z.isFromPath=!0,Z):s(n,o,f,k,D,C)}return await k.existsFile((0,r.$6c)(ue))?Z:s(n,o,f,k,D,C,L,U,x)}}),define(we[255],be([1,0,5,2,3,42,24,12,114,86,248,89,251,254,106,60]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;var c;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(c||(c={}));let u=class extends R.$lb{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.P()}constructor(g,y,p,t){super(),this.H=g,this.I=y,this.J=p,this.L=t,this.j=!1,this.k=0,this.l=!0,this.m=!1,this.r=this.B(new v.$ec),this.onPtyHostExit=this.r.event,this.s=this.B(new v.$ec),this.onPtyHostStart=this.s.event,this.t=this.B(new v.$ec),this.onPtyHostUnresponsive=this.t.event,this.u=this.B(new v.$ec),this.onPtyHostResponsive=this.u.event,this.v=this.B(new v.$ec),this.onPtyHostRequestResolveVariables=this.v.event,this.w=this.B(new v.$ec),this.onProcessData=this.w.event,this.y=this.B(new v.$ec),this.onProcessReady=this.y.event,this.z=this.B(new v.$ec),this.onProcessReplay=this.z.event,this.C=this.B(new v.$ec),this.onProcessOrphanQuestion=this.C.event,this.D=this.B(new v.$ec),this.onDidRequestDetach=this.D.event,this.F=this.B(new v.$ec),this.onDidChangeProperty=this.F.event,this.G=this.B(new v.$ec),this.onProcessExit=this.G.event,(0,w.$3q)(),this.B(this.H),this.B((0,R.$jb)(()=>this.Q())),this.i=this.B(new A.$Vq(void 0,this.J)),this.i.onCreateRequest(this.v.fire,this.v),this.H.onRequestConnection&&v.Event.once(this.H.onRequestConnection)(()=>this.h()),this.H.onWillShutdown?.(()=>this.j=!0)}get M(){return this.I.getValue("terminal.integrated.ignoreProcessNames")}async N(){return this.g?.refreshIgnoreProcessNames?.(this.M)}async O(){if(r.$d)return process.env;try{return await(0,$.$Al)(this.I,this.J,{_:[]},process.env)}catch(g){return this.J.error("ptyHost was unable to resolve shell environment",g),{}}}P(){const g=this.H.start(),y=g.client;this.J.getLevel()===P.LogLevel.Trace&&this.J.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),S.ProxyChannel.toService(y.getChannel(E.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.R()),this.R(!0),this.B(g.onDidProcessExit(i=>{this.r.fire(i.code),!this.j&&!this.m&&(this.k<=c.MaxRestarts?(this.J.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.k++,this.restartPtyHost()):this.J.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const t=S.ProxyChannel.toService(y.getChannel(E.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(i=>this.w.fire(i))),this.B(t.onProcessReady(i=>this.y.fire(i))),this.B(t.onProcessExit(i=>this.G.fire(i))),this.B(t.onDidChangeProperty(i=>this.F.fire(i))),this.B(t.onProcessReplay(i=>this.z.fire(i))),this.B(t.onProcessOrphanQuestion(i=>this.C.fire(i))),this.B(t.onDidRequestDetach(i=>this.D.fire(i))),this.B(new b.$Uq(this.L,y.getChannel(E.TerminalIpcChannels.Logger))),this.a=g,this.b=t,this.s.fire(),this.B(this.I.onDidChangeConfiguration(async i=>{i.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.N()})),this.N(),[g,t]}dispose(){this.m=!0,super.dispose()}async createProcess(g,y,p,t,i,a,s,n,o,f,k){const D=setTimeout(()=>this.W(),E.HeartbeatConstants.CreateProcessTimeout),C=await this.f.createProcess(g,y,p,t,i,a,s,n,o,f,k);return clearTimeout(D),C}updateTitle(g,y,p){return this.f.updateTitle(g,y,p)}updateIcon(g,y,p,t){return this.f.updateIcon(g,y,p,t)}attachToProcess(g){return this.f.attachToProcess(g)}detachFromProcess(g,y){return this.f.detachFromProcess(g,y)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(g){return this.f.start(g)}shutdown(g,y){return this.f.shutdown(g,y)}input(g,y){return this.f.input(g,y)}processBinary(g,y){return this.f.processBinary(g,y)}resize(g,y,p){return this.f.resize(g,y,p)}clearBuffer(g){return this.f.clearBuffer(g)}acknowledgeDataEvent(g,y){return this.f.acknowledgeDataEvent(g,y)}setUnicodeVersion(g,y){return this.f.setUnicodeVersion(g,y)}getInitialCwd(g){return this.f.getInitialCwd(g)}getCwd(g){return this.f.getCwd(g)}async getLatency(){const g=new m.$ac,y=await this.f.getLatency();return g.stop(),[{label:"ptyhostservice<->ptyhost",latency:g.elapsed()},...y]}orphanQuestionReply(g){return this.f.orphanQuestionReply(g)}installAutoReply(g,y){return this.f.installAutoReply(g,y)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(g){return this.f.uninstallAutoReply(g)}getDefaultSystemShell(g){return this.g?.getDefaultSystemShell(g)??(0,d.$kl)(g??r.OS,process.env)}async getProfiles(g,y,p,t=!1){const i=await this.O();return(0,l.$cr)(y,p,t,this.I,i,void 0,this.J,this.Y.bind(this,g))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(g,y){return this.f.getWslPath(g,y)}getRevivedPtyNewId(g,y){return this.f.getRevivedPtyNewId(g,y)}setTerminalLayoutInfo(g){return this.f.setTerminalLayoutInfo(g)}async getTerminalLayoutInfo(g){return this.g?.getTerminalLayoutInfo(g)}async requestDetachInstance(g,y){return this.f.requestDetachInstance(g,y)}async acceptDetachInstanceReply(g,y){return this.f.acceptDetachInstanceReply(g,y)}async freePortKillProcess(g){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(g)}async serializeTerminalState(g){return this.f.serializeTerminalState(g)}async reviveTerminalProcesses(g,y,p){return this.f.reviveTerminalProcesses(g,y,p)}async refreshProperty(g,y){return this.f.refreshProperty(g,y)}async updateProperty(g,y,p){return this.f.updateProperty(g,y,p)}async restartPtyHost(){this.Q(),this.l=!0,this.P()}Q(){this.f.shutdownAll(),this.c.store.dispose()}R(g){this.X(),this.n=setTimeout(()=>this.S(),g?E.HeartbeatConstants.ConnectingBeatInterval:E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier),this.l||(this.l=!0,this.u.fire())}S(){this.J.warn(`No ptyHost heartbeat after ${E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.n=void 0,this.p=setTimeout(()=>this.U(),E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.SecondWaitMultiplier)}U(){this.J.error(`No ptyHost heartbeat after ${(E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier+E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.p=void 0,this.l&&(this.l=!1,this.t.fire())}W(){this.X(),this.J.error(`No ptyHost response to createProcess after ${E.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.l&&(this.l=!1,this.t.fire())}X(){this.n&&(clearTimeout(this.n),this.n=void 0),this.p&&(clearTimeout(this.p),this.p=void 0)}Y(g,y){return this.i.createRequest({workspaceId:g,originalText:y})}async acceptPtyHostResolvedVariables(g,y){this.i.acceptReply(g,y)}};e.$dr=u,e.$dr=u=Le([Ie(1,I.$Vh),Ie(2,P.$Ri),Ie(3,P.$Si)],u)}),define(we[34],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=void 0,e.$pk=(0,v.$ph)("IUriIdentityService")}),define(we[125],be([1,0,34,212,16,19,144,5,2]),function(le,e,v,R,r,S,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class ${constructor(w){this.uri=w,this.time=$._clock++}touch(){return this.time=$._clock++,this}}$._clock=0;let A=class{constructor(w){this.g=w,this.c=new b.$kb,this.f=2**16;const l=new Map,d=m=>{let c=l.get(m.scheme);return c===void 0&&(c=w.hasProvider(m)&&!this.g.hasCapability(m,1024),l.set(m.scheme,c)),c};this.c.add(P.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(m=>{l.delete(m.scheme)})),this.extUri=new S.$Xf(d),this.d=new I.$gr((m,c)=>this.extUri.compare(m,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,S.$0f)(w));const l=this.d.get(w);return l?l.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new $(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((d,m)=>d[1].time<m[1].time?1:d[1].time>m[1].time?-1:0);$._clock=0,this.d.clear();const l=this.f*.5;for(let d=0;d<l;d++)this.d.set(w[d][0],w[d][1].touch())}};e.$hr=A,e.$hr=A=Le([Ie(0,r.$Sj)],A),(0,R.$er)(v.$pk,A,1)}),define(we[90],be([1,0,196,7,63,19,4,6,13]),function(le,e,v,R,r,S,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,P.$ph)("contextService");function $(s){const n=s;return typeof n?.id=="string"&&I.URI.isUri(n.uri)}e.$zh=$;function A(s){return typeof s?.id=="string"&&!$(s)&&!w(s)}e.$Ah=A,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function E(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,R.$_c)(s)}:n?e.$Bh:e.$Ch;const o=s;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$Dh=E;function w(s){const n=s;return typeof n?.id=="string"&&I.URI.isUri(n.configPath)}e.$Eh=w;function l(s){const n=s;if(n?.uri)return{id:n.id,uri:I.URI.revive(n.uri)};const o=s;if(o?.configPath)return{id:o.id,configPath:I.URI.revive(o.configPath)};if(s?.id)return{id:s.id}}e.$Fh=l;var d;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function m(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Gh=m;function c(s){const n=s;return!!(n&&typeof n=="object"&&I.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Hh=c;class u{constructor(n,o,f,k,D){this.h=n,this.j=f,this.k=k,this.l=D,this.c=r.$vh.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=r.$vh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=u;class h{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,S.$9f)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=h;function g(s){return new h({uri:s,index:0,name:(0,S.$5f)(s)},{uri:s.toString()})}e.$Kh=g,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,v.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function y(s,n){return S.$Zf.isEqualOrParent(s,n.untitledWorkspacesHome)}e.$Ph=y;function p(s){let n;return I.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===b.Schemas.tmp}e.$Qh=p,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Rh}e.$Sh=t;function i(s,n){return!y(s,n)&&!p(s)}e.$Th=i;function a(s){return(typeof s=="string"?(0,R.$ad)(s):(0,S.$7f)(s))===e.$Mh}e.$Uh=a}),define(we[33],be([1,0,61,5,2,19,4,195,25,16,6,12,90,28,34,14,23,17,8]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.ProfileResourceType=void 0;var g;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(g||(e.ProfileResourceType=g={}));function y(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&I.URI.isUri(n.location)&&I.URI.isUri(n.globalStorageHome)&&I.URI.isUri(n.settingsResource)&&I.URI.isUri(n.keybindingsResource)&&I.URI.isUri(n.tasksResource)&&I.URI.isUri(n.snippetsHome)&&I.URI.isUri(n.extensionsResource))}e.$qk=y,e.$rk=(0,A.$ph)("IUserDataProfilesService");function p(s,n){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:I.URI.revive(s.location).with({scheme:n}),globalStorageHome:I.URI.revive(s.globalStorageHome).with({scheme:n}),settingsResource:I.URI.revive(s.settingsResource).with({scheme:n}),keybindingsResource:I.URI.revive(s.keybindingsResource).with({scheme:n}),tasksResource:I.URI.revive(s.tasksResource).with({scheme:n}),snippetsHome:I.URI.revive(s.snippetsHome).with({scheme:n}),extensionsResource:I.URI.revive(s.extensionsResource).with({scheme:n}),cacheHome:I.URI.revive(s.cacheHome).with({scheme:n}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$sk=p;function t(s,n,o,f,k,D){return{id:s,name:n,location:o,isDefault:!1,shortName:k?.shortName,globalStorageHome:D&&k?.useDefaultFlags?.globalState?D.globalStorageHome:(0,S.$9f)(o,"globalStorage"),settingsResource:D&&k?.useDefaultFlags?.settings?D.settingsResource:(0,S.$9f)(o,"settings.json"),keybindingsResource:D&&k?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,S.$9f)(o,"keybindings.json"),tasksResource:D&&k?.useDefaultFlags?.tasks?D.tasksResource:(0,S.$9f)(o,"tasks.json"),snippetsHome:D&&k?.useDefaultFlags?.snippets?D.snippetsHome:(0,S.$9f)(o,"snippets"),extensionsResource:D&&k?.useDefaultFlags?.extensions?D.extensionsResource:(0,S.$9f)(o,"extensions.json"),cacheHome:(0,S.$9f)(f,s),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$tk=t;let i=class extends r.$lb{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(n,o,f,k){super(),this.n=n,this.r=o,this.s=f,this.t=k,this.f=!0,this.h=this.B(new R.$ec),this.onDidChangeProfiles=this.h.event,this.i=this.B(new R.$ec),this.onWillCreateProfile=this.i.event,this.j=this.B(new R.$ec),this.onWillRemoveProfile=this.j.event,this.k=this.B(new R.$ec),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new l.$ni,emptyWindows:new Map},this.profilesHome=(0,S.$9f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,S.$9f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(n){this.f!==n&&(this.u=void 0,this.f=n)}isEnabled(){return this.f}get v(){if(!this.u){const n=this.w(),o=[n];if(this.f)try{for(const D of this.J()){if(!D.name||!(0,h.$ie)(D.name)||!D.location){this.t.warn("Skipping the invalid stored profile",D.location||D.name);continue}o.push(t((0,S.$6f)(D.location),D.name,D.location,this.g,{shortName:D.shortName,useDefaultFlags:D.useDefaultFlags},n))}}catch(D){this.t.error(D)}const f=new l.$ni,k=new Map;if(o.length)try{const D=this.M();if(D.workspaces)for(const[C,L]of Object.entries(D.workspaces)){const U=I.URI.parse(C),x=o.find(ae=>ae.id===L);x&&f.set(U,x)}if(D.emptyWindows)for(const[C,L]of Object.entries(D.emptyWindows)){const U=o.find(x=>x.id===L);U&&k.set(C,U)}}catch(D){this.t.error(D)}this.u={profiles:o,workspaces:f,emptyWindows:k}}return this.u}w(){const n=t("__default__profile__",(0,P.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...n,extensionsResource:this.O()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",f=new RegExp(`${(0,u.$pd)(o)}\\s(\\d+)`);let k=0;for(const C of this.profiles){const L=f.exec(C.name),U=L?parseInt(L[1]):0;k=U>k?U:k}const D=`${o} ${k+1}`;return this.createProfile((0,v.$di)((0,c.$3e)()).toString(16),D,{transient:!0},n)}async createNamedProfile(n,o,f){return this.createProfile((0,v.$di)((0,c.$3e)()).toString(16),n,o,f)}async createProfile(n,o,f,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.y(n,o,f);return k&&await this.setProfileForWorkspace(k,D),D}async y(n,o,f){if(!(0,h.$ie)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.l.get(o);return k||(k=(async()=>{try{const D=this.profiles.find(U=>U.name===o||U.id===n);if(D)return D;const C=t(n,o,(0,S.$9f)(this.profilesHome,n),this.g,f,this.defaultProfile);await this.r.createFolder(C.location);const L=[];return this.i.fire({profile:C,join(U){L.push(U)}}),await m.Promises.settled(L),this.D([C],[],[]),C}finally{this.l.delete(o)}})(),this.l.set(o,k)),k}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(k=>k.id===n.id);if(!f)throw new Error(`Profile '${n.name}' does not exist`);return f=t(f.id,o.name??f.name,f.location,this.g,{shortName:o.shortName??f.shortName,transient:o.transient??f.isTransient,useDefaultFlags:o.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.D([],[],[f]),f}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(k=>k.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const f=[];this.j.fire({profile:o,join(k){f.push(k)}});try{await Promise.allSettled(f)}catch(k){this.t.error(k)}for(const k of[...this.v.emptyWindows.keys()])o.id===this.v.emptyWindows.get(k)?.id&&this.v.emptyWindows.delete(k);for(const k of[...this.v.workspaces.keys()])o.id===this.v.workspaces.get(k)?.id&&this.v.workspaces.delete(k);this.H(),this.D([],[o],[]);try{await this.r.del(o.cacheHome,{recursive:!0})}catch(k){(0,$.$9j)(k)!==1&&this.t.error(k)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(k=>k.id===o.id);if(!f)throw new Error(`Profile '${o.name}' does not exist`);this.G(n,f)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(n,void 0,o)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const n=await this.r.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(f=>!this.s.extUri.isEqual(f.location,o.resource))).map(o=>this.r.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.m.profiles.filter(o=>!this.C(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.z(n);return I.URI.isUri(o)?this.m.workspaces.get(o)??this.v.workspaces.get(o):this.m.emptyWindows.get(o)??this.v.emptyWindows.get(o)}z(n){return(0,w.$zh)(n)?n.uri:(0,w.$Eh)(n)?n.configPath:n.id}C(n){return!!([...this.m.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.m.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location)))}D(n,o,f){const k=[...this.profiles,...n],D=[];this.m.profiles=[];for(let C of k)C.isDefault||o.some(L=>C.id===L.id)||(C=f.find(L=>C.id===L.id)??C,C.isTransient?this.m.profiles.push(C):D.push({location:C.location,name:C.name,shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}));this.L(D),this.u=void 0,this.F(n,o,f)}F(n,o,f){this.h.fire({added:n,removed:o,updated:f,all:this.profiles})}G(n,o,f){f=o?.isTransient?!0:f,f||this.G(n,void 0,!0);const k=this.z(n),D=f?this.m:this.v;I.URI.isUri(k)?(D.workspaces.delete(k),o&&D.workspaces.set(k,o)):(D.emptyWindows.delete(k),o&&D.emptyWindows.set(k,o)),f||this.H()}H(){const n={};for(const[f,k]of this.v.workspaces.entries())n[f.toString()]=k.id;const o={};for(const[f,k]of this.v.emptyWindows.entries())o[f.toString()]=k.id;this.N({workspaces:n,emptyWindows:o}),this.u=void 0}I(n){const o={},f=this.w();if(n.workspaces)for(const[D,C]of Object.entries(n.workspaces)){const L=I.URI.parse(C);o[D]=this.s.extUri.isEqual(L,f.location)?f.id:this.s.extUri.basename(L)}const k={};if(n.emptyWindows)for(const[D,C]of Object.entries(n.emptyWindows)){const L=I.URI.parse(C);k[D]=this.s.extUri.isEqual(L,f.location)?f.id:this.s.extUri.basename(L)}return{workspaces:o,emptyWindows:k}}J(){return[]}L(n){throw new Error("not implemented")}M(){return{}}N(n){throw new Error("not implemented")}O(){}};e.$uk=i,i.b="userDataProfiles",i.c="profileAssociations",e.$uk=i=Le([Ie(0,b.$wh),Ie(1,$.$Sj),Ie(2,d.$pk),Ie(3,E.$Ri)],i);class a extends i{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(n){this.a=n}M(){return this.R}N(n){this.R=n}}e.$vk=a}),define(we[256],be([1,0,18,14,20,11,5,2,3,8,4,176,31,37,40,12,27,32,34,33]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=e.$0o=void 0;let y=class extends P.$lb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}get onDidUpdateExtensionMetadata(){return this.s.event}constructor(n,o,f,k,D,C){super(),this.u=n,this.v=o,this.w=f,this.y=k,this.z=D,this.C=C,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new I.$ec),this.m=this.B(new I.$ec),this.n=this.B(new I.$ec),this.p=this.B(new I.$ec),this.s=this.B(new I.$ec),this.t=[],this.B((0,P.$jb)(()=>{this.j.forEach(({task:L})=>L.cancel()),this.k.forEach(L=>L.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(f=>(0,w.$Pn)(f,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{const k=(await this.installGalleryExtensions([{extension:n,options:o}])).find(({identifier:D})=>(0,l.$io)(D,n.identifier));if(k?.local)return k?.local;throw k?.error?k.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(f){throw t(f)}}async installGalleryExtensions(n){if(!this.u.isEnabled())throw new w.$Tn(E.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=[],f=[];await Promise.allSettled(n.map(async({extension:k,options:D})=>{try{const C=await this.J(k,!!D?.installGivenVersion,!!D?.installPreReleaseVersion);f.push({...C,options:D})}catch(C){o.push({identifier:k.identifier,operation:2,source:k,error:C})}})),f.length&&o.push(...await this.D(f));for(const k of o)k.error&&(this.y.error("Failed to install extension.",k.identifier.id),this.y.error(k.error),k.source&&!A.URI.isUri(k.source)&&i(this.v,"extensionGallery:install",{extensionData:(0,l.$qo)(k.source),error:k.error}));return o}async uninstall(n,o={}){return this.y.trace("ExtensionManagementService#uninstall",n.identifier.id),this.M(n,o)}async toggleAppliationScope(n,o){if((0,d.$Ml)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let f=await this.updateMetadata(n,{isApplicationScoped:!1},this.C.defaultProfile.extensionsResource);this.w.extUri.isEqual(o,this.C.defaultProfile.extensionsResource)||(f=await this.X(n,this.C.defaultProfile.extensionsResource,o));for(const k of this.C.profiles){const D=(await this.getInstalled(1,k.extensionsResource)).find(C=>(0,l.$io)(C.identifier,n.identifier));D?this.s.fire(D):this.p.fire({identifier:n.identifier,profileLocation:k.extensionsResource})}return f}else{const f=this.w.extUri.isEqual(o,this.C.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.C.defaultProfile.extensionsResource):await this.X(n,o,this.C.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.m.fire([{identifier:f.identifier,operation:2,local:f,profileLocation:this.C.defaultProfile.extensionsResource,applicationScoped:!0}]),f}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.R(),this.h=n),this.g}registerParticipant(n){this.t.push(n)}async D(n){const o=[];return await Promise.allSettled(n.map(async f=>{try{const k=await this.F(f);o.push(...k)}catch(k){o.push({identifier:{id:(0,l.$no)(f.manifest.publisher,f.manifest.name)},operation:2,source:f.extension,error:k})}})),this.m.fire(o),o}async F({manifest:n,extension:o,options:f}){const k=f.isApplicationScoped||f.isBuiltin||(0,d.$Ml)(n),D={...f,installOnlyNewlyAddedFromExtensionPack:A.URI.isUri(o)?f.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:k,profileLocation:k?this.C.defaultProfile.extensionsResource:f.profileLocation??this.S()},C=te=>`${l.$jo.create(te).toString()}${D.profileLocation?`-${D.profileLocation.toString()}`:""}`;if(!A.URI.isUri(o)){const te=this.j.get(C(o));if(te)return this.y.info("Extensions is already requested to install",o.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const L=[],U=[],x=[],ae=this.U(n,o,D);A.URI.isUri(o)||this.j.set(C(o),{task:ae,waitingTasks:[]}),this.l.fire({identifier:ae.identifier,source:o,profileLocation:D.profileLocation}),this.y.info("Installing extension:",ae.identifier.id),L.push({task:ae,manifest:n});let W=!1;try{if(D.donotIncludePackAndDependencies)this.y.info("Installing the extension without checking dependencies and pack",ae.identifier.id);else try{const ue=await this.I(ae.identifier,n,!!D.installOnlyNewlyAddedFromExtensionPack,!!D.installPreReleaseVersion,D.profileLocation),Z=await this.getInstalled(void 0,D.profileLocation),he={...D,donotIncludePackAndDependencies:!0,context:{...D.context,[w.$Kn]:!0}};for(const{gallery:V,manifest:se}of(0,v.$of)(ue,({gallery:K})=>K.identifier.id)){W=W||!!se.extensionDependencies?.some(H=>(0,l.$io)({id:H},ae.identifier));const K=C(V),Y=this.j.get(K);if(Y){if(this.G(ae,Y.task)){const H=Y.task.identifier;this.y.info("Waiting for already requested installing extension",H.id,ae.identifier.id),Y.waitingTasks.push(ae),U.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,_=>_.some(ge=>(0,l.$io)(ge.identifier,H)))).then(_=>{if(this.y.info("Finished waiting for already requested installing extension",H.id,ae.identifier.id),!_.find(ne=>(0,l.$io)(ne.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!Z.some(({identifier:H})=>(0,l.$io)(H,V.identifier))){const H=this.U(se,V,he);this.j.set(K,{task:H,waitingTasks:[ae]}),this.l.fire({identifier:H.identifier,source:V,profileLocation:D.profileLocation}),this.y.info("Installing extension:",H.identifier.id,ae.identifier.id),L.push({task:H,manifest:se})}}}catch(ue){if(A.URI.isUri(ae.source))(0,v.$nf)(n.extensionDependencies)&&this.y.warn("Cannot install dependencies of extension:",ae.identifier.id,ue.message),(0,v.$nf)(n.extensionPack)&&this.y.warn("Cannot install packed extensions of extension:",ae.identifier.id,ue.message);else throw this.y.error("Error while preparing to install dependencies and extension packs of the extension:",ae.identifier.id),ue}const te=L.reduce((ue,{task:Z,manifest:he})=>(ue.set(Z.identifier.id.toLowerCase(),{task:Z,manifest:he}),ue),new Map);for(;te.size;){let ue;const Z=[...te.values()].filter(({manifest:he})=>!he.extensionDependencies?.some(V=>te.has(V.toLowerCase())));Z.length?ue=te.size===1?Z:Z.filter(({task:he})=>!(he===ae&&!W)):(this.y.info("Found extensions with circular dependencies",Z.map(({task:he})=>he.identifier.id)),ue=[...te.values()]),await this.H(ue.map(async({task:he})=>{const V=new Date().getTime();try{const se=await he.run();if(await this.H(this.t.map(K=>K.postInstall(se,he.source,D,r.CancellationToken.None))),!A.URI.isUri(he.source)){const K=he.operation===3,Y=K?void 0:(new Date().getTime()-he.source.lastUpdated)/1e3;if(i(this.v,K?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$qo)(he.source),verificationStatus:he.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:Y}),b.$j&&he.operation!==3)try{await this.u.reportStatistic(se.manifest.publisher,se.manifest.name,se.manifest.version,"install")}catch{}}x.push({local:se,identifier:he.identifier,operation:he.operation,source:he.source,context:he.options.context,profileLocation:he.profileLocation,applicationScoped:se.isApplicationScoped})}catch(se){throw A.URI.isUri(he.source)||i(this.v,he.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$qo)(he.source),verificationStatus:he.verificationStatus,duration:new Date().getTime()-V,error:se}),this.y.error("Error while installing the extension:",he.identifier.id),se}finally{te.delete(he.identifier.id.toLowerCase())}}))}return U.length&&await this.H(U),x.forEach(({identifier:ue})=>this.y.info("Extension installed successfully:",ue.id)),x}catch(te){if(L.forEach(({task:ue})=>ue.cancel()),x.length)try{const ue=await Promise.allSettled(x.map(({local:Z})=>this.W(Z,{versionOnly:!0,profileLocation:D.profileLocation}).run()));for(let Z=0;Z<ue.length;Z++){const he=ue[Z],{identifier:V}=x[Z];he.status==="fulfilled"?this.y.info("Rollback: Uninstalled extension",V.id):this.y.warn("Rollback: Error while uninstalling extension",V.id,(0,S.$9)(he.reason))}}catch(ue){this.y.warn("Error while rolling back extensions",(0,S.$9)(ue),x.map(({identifier:Z})=>Z.id))}return L.map(({task:ue})=>({identifier:ue.identifier,operation:2,source:ue.source,context:D.context,profileLocation:D.profileLocation,error:te}))}finally{for(const{task:te}of L)te.source&&!A.URI.isUri(te.source)&&this.j.delete(C(te.source))}}G(n,o){for(const[,{task:f,waitingTasks:k}]of this.j.entries())if(f===n&&(k.includes(o)||k.some(D=>this.G(D,o)))||f===o&&k[0]&&!this.G(n,k[0]))return!1;return!0}async H(n){const o=[],f=[],k=await Promise.allSettled(n);for(const D of k)D.status==="fulfilled"?o.push(D.value):f.push(D.reason);if(f.length)throw p(f);return o}async I(n,o,f,k,D){if(!this.u.isEnabled())return[];const C=await this.getInstalled(void 0,D),L=[],U=[],x=async(ae,W)=>{L.push(ae);const te=W.extensionDependencies||[],ue=[...te];if(W.extensionPack){const Z=f?C.find(he=>(0,l.$io)(he.identifier,ae)):void 0;for(const he of W.extensionPack)Z&&Z.manifest.extensionPack&&Z.manifest.extensionPack.some(V=>(0,l.$io)({id:V},{id:he}))||ue.every(V=>!(0,l.$io)({id:V},{id:he}))&&ue.push(he)}if(ue.length){const Z=ue.filter(he=>L.every(V=>!(0,l.$io)(V,{id:he})));if(Z.length){const he=await this.u.getExtensions(Z.map(V=>({id:V,preRelease:k})),r.CancellationToken.None);for(const V of he){if(L.find(Y=>(0,l.$io)(Y,V.identifier)))continue;const se=te.some(Y=>(0,l.$io)({id:Y},V.identifier));let K;try{K=await this.J(V,!1,k)}catch(Y){if(se)throw Y;this.y.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,S.$9)(Y));continue}U.push({gallery:K.extension,manifest:K.manifest}),await x(K.extension.identifier,K.manifest)}}}};return await x(n,o),U}async J(n,o,f){let k;const D=await this.getExtensionsControlManifest();if(D.malicious.some(U=>(0,l.$io)(n.identifier,U)))throw new w.$Tn(E.localize(1,null,n.identifier.id),w.ExtensionManagementErrorCode.Malicious);const C=D.deprecated[n.identifier.id.toLowerCase()];if(C?.extension?.autoMigrate){if(this.y.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${C.extension.id}' extension instead.`),k=(await this.u.getExtensions([{id:C.extension.id,preRelease:C.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},r.CancellationToken.None))[0],!k)throw new w.$Tn(E.localize(2,null,n.identifier.id,C.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const U=await this.getTargetPlatform();throw new w.$Tn(E.localize(3,null,n.identifier.id,this.z.nameLong,(0,w.$Ln)(U)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.L(n,o,f),!k)throw!f&&n.properties.isPreReleaseVersion&&(await this.u.getExtensions([n.identifier],r.CancellationToken.None))[0]?new w.$Tn(E.localize(4,null,n.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$Tn(E.localize(5,null,n.identifier.id,this.z.nameLong,this.z.version),w.ExtensionManagementErrorCode.Incompatible)}this.y.info("Getting Manifest...",k.identifier.id);const L=await this.u.getManifest(k,r.CancellationToken.None);if(L===null)throw new w.$Tn(`Missing manifest for extension ${k.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(L.version!==k.version)throw new w.$Tn(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:L}}async L(n,o,f){const k=await this.getTargetPlatform();let D=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==f&&(D=(await this.u.getExtensions([{...n.identifier,preRelease:f}],{targetPlatform:k,compatible:!0},r.CancellationToken.None))[0]||null),!D&&await this.u.isExtensionCompatible(n,f,k)&&(D=n),D||(o?D=(await this.u.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:k,compatible:!0},r.CancellationToken.None))[0]||null:D=await this.u.getCompatibleExtension(n,f,k)),D}async M(n,o){const f={...o,profileLocation:n.isApplicationScoped?this.C.defaultProfile.extensionsResource:o.profileLocation??this.S()},k=ae=>`${ae.id.toLowerCase()}${f.versionOnly?`-${n.manifest.version}`:""}${f.profileLocation?`@${f.profileLocation.toString()}`:""}`,D=this.k.get(k(n.identifier));if(D)return this.y.info("Extensions is already requested to uninstall",n.identifier.id),D.waitUntilTaskIsFinished();const C=ae=>{const W=this.W(ae,f);return this.k.set(k(W.extension.identifier),W),f.profileLocation?this.y.info("Uninstalling extension from the profile:",`${ae.identifier.id}@${ae.manifest.version}`,f.profileLocation.toString()):this.y.info("Uninstalling extension:",`${ae.identifier.id}@${ae.manifest.version}`),this.n.fire({identifier:ae.identifier,profileLocation:f.profileLocation,applicationScoped:ae.isApplicationScoped}),W},L=(ae,W)=>{W?f.profileLocation?this.y.error("Failed to uninstall extension from the profile:",`${ae.identifier.id}@${ae.manifest.version}`,f.profileLocation.toString(),W.message):this.y.error("Failed to uninstall extension:",`${ae.identifier.id}@${ae.manifest.version}`,W.message):f.profileLocation?this.y.info("Successfully uninstalled extension from the profile",`${ae.identifier.id}@${ae.manifest.version}`,f.profileLocation.toString()):this.y.info("Successfully uninstalled extension:",`${ae.identifier.id}@${ae.manifest.version}`),i(this.v,"extensionGallery:uninstall",{extensionData:(0,l.$po)(ae),error:W}),this.p.fire({identifier:ae.identifier,error:W?.code,profileLocation:f.profileLocation,applicationScoped:ae.isApplicationScoped})},U=[],x=[];try{U.push(C(n));const ae=await this.getInstalled(1,f.profileLocation);if(f.donotIncludePack)this.y.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const W=this.P(n,ae);for(const te of W)this.k.has(k(te.identifier))?this.y.info("Extensions is already requested to uninstall",te.identifier.id):U.push(C(te))}f.donotCheckDependents?this.y.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.N(U.map(W=>W.extension),ae,n),await this.H(U.map(async W=>{try{if(await W.run(),await this.H(this.t.map(te=>te.postUninstall(W.extension,f,r.CancellationToken.None))),W.extension.identifier.uuid)try{await this.u.reportStatistic(W.extension.manifest.publisher,W.extension.manifest.name,W.extension.manifest.version,"uninstall")}catch{}L(W.extension)}catch(te){const ue=te instanceof w.$Tn?te:new w.$Tn((0,S.$9)(te),w.ExtensionManagementErrorCode.Internal);throw L(W.extension,ue),ue}finally{x.push(W)}}))}catch(ae){const W=ae instanceof w.$Tn?ae:new w.$Tn((0,S.$9)(ae),w.ExtensionManagementErrorCode.Internal);for(const te of U){try{te.cancel()}catch{}x.includes(te)||L(te.extension,W)}throw W}finally{for(const ae of U)this.k.delete(k(ae.extension.identifier))||this.y.warn("Uninstallation task is not found in the cache",ae.extension.identifier.id)}}N(n,o,f){for(const k of n){const D=this.Q(k,o);if(D.length){const C=D.filter(L=>!n.some(U=>(0,l.$io)(U.identifier,L.identifier)));if(C.length)throw new Error(this.O(k,C,f))}}}O(n,o,f){return f===n?o.length===1?E.localize(6,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(7,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(8,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?E.localize(9,null,f.manifest.displayName||f.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(10,null,f.manifest.displayName||f.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(11,null,f.manifest.displayName||f.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}P(n,o,f=[]){if(f.indexOf(n)!==-1)return[];f.push(n);const k=n.manifest.extensionPack?n.manifest.extensionPack:[];if(k.length){const D=o.filter(L=>!L.isBuiltin&&k.some(U=>(0,l.$io)({id:U},L.identifier))),C=[];for(const L of D)C.push(...this.P(L,o,f));return[...D,...C]}return[]}Q(n,o){return o.filter(f=>f.manifest.extensionDependencies&&f.manifest.extensionDependencies.some(k=>(0,l.$io)({id:k},n.identifier)))}async R(){try{this.y.trace("ExtensionManagementService.refreshReportedCache");const n=await this.u.getExtensionsControlManifest();return this.y.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.y.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$0o=y,e.$0o=y=Le([Ie(0,w.$Sn),Ie(1,u.$Vk),Ie(2,h.$pk),Ie(3,m.$Ri),Ie(4,c.$0i),Ie(5,g.$rk)],y);function p(s){const n=Array.isArray(s)?s:[s];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((o,f)=>new Error(`${o.message}${o.message?",":""}${f instanceof Error?f.message:f}`),new Error(""))}e.$$o=p;function t(s){if(s instanceof w.$Tn)return s;const n=new w.$Tn(s.message,w.ExtensionManagementErrorCode.Internal);return n.stack=s.stack,n}e.$_o=t;function i(s,n,{extensionData:o,verificationStatus:f,duration:k,error:D,durationSinceUpdate:C}){let L,U;(0,$.$qe)(f)&&(f===!0?f="Verified":(f===!1||(L=w.ExtensionManagementErrorCode.Signature,U=f),f="Unverified")),D&&(D instanceof w.$Tn?(L=D.code,D.code===w.ExtensionManagementErrorCode.Signature&&(U=D.message)):L=w.ExtensionManagementErrorCode.Internal),s.publicLog(n,{...o,verificationStatus:f,success:!D,duration:k,errorcode:L,errorcodeDetail:U,durationSinceUpdate:C})}class a{constructor(){this.d=new R.$tg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.$ig)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.$ig)(n=>new Promise((o,f)=>{const k=n.onCancellationRequested(()=>{k.dispose(),f(new S.$3)})})),this.d.open()),this.g.cancel()}}e.$ap=a}),define(we[45],be([1,0,14,15,2,5,28,4,31,37,16,6,12,33,34,8,11,32]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class g extends Error{constructor(a,s){super(a),this.code=s}}e.$bp=g,e.$cp=(0,E.$ph)("IExtensionsProfileScannerService");let y=class extends r.$lb{constructor(a,s,n,o,f,k){super(),this.i=a,this.j=s,this.k=n,this.l=o,this.m=f,this.n=k,this.b=this.B(new S.$ec),this.onAddExtensions=this.b.event,this.c=this.B(new S.$ec),this.onDidAddExtensions=this.c.event,this.f=this.B(new S.$ec),this.onRemoveExtensions=this.f.event,this.g=this.B(new S.$ec),this.onDidRemoveExtensions=this.g.event,this.h=new I.$ni}scanProfileExtensions(a,s){return this.p(a,void 0,s)}async addExtensionsToProfile(a,s){const n=[],o=[];try{return await this.p(s,f=>{const k=[];for(const D of f)a.some(([C])=>(0,$.$io)(C.identifier,D.identifier)&&C.manifest.version!==D.version)?n.push(D):k.push(D);for(const[D,C]of a){const L=k.findIndex(x=>(0,$.$io)(x.identifier,D.identifier)&&x.version===D.manifest.version),U={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:C};L===-1?(o.push(U),k.push(U)):k.splice(L,1,U)}return o.length&&this.b.fire({extensions:o,profileLocation:s}),n.length&&this.f.fire({extensions:n,profileLocation:s}),k}),o.length&&this.c.fire({extensions:o,profileLocation:s}),n.length&&this.g.fire({extensions:n,profileLocation:s}),o}catch(f){throw o.length&&this.c.fire({extensions:o,error:f,profileLocation:s}),n.length&&this.g.fire({extensions:n,error:f,profileLocation:s}),f}}async updateMetadata(a,s){const n=[];return await this.p(s,o=>{const f=[];for(const k of o){const D=a.find(([C])=>(0,$.$io)(C.identifier,k.identifier)&&C.manifest.version===k.version);D&&(k.metadata={...k.metadata,...D[1]},n.push(k)),f.push(k)}return f}),n}async removeExtensionFromProfile(a,s){const n=[];try{await this.p(s,o=>{const f=[];for(const k of o)(0,$.$io)(k.identifier,a.identifier)?n.push(k):f.push(k);return n.length&&this.f.fire({extensions:n,profileLocation:s}),f}),n.length&&this.g.fire({extensions:n,profileLocation:s})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:s}),o}}async p(a,s,n){return this.w(a).queue(async()=>{let o=[],f;try{const k=await this.j.readFile(a);f=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,A.$9j)(k)!==1)throw k;if(this.l.extUri.isEqual(a,this.k.defaultProfile.extensionsResource)&&(f=await this.v()),!f&&n?.bailOutWhenFileNotFound)throw new g((0,c.$9)(k),"ERROR_PROFILE_NOT_FOUND")}if(f){Array.isArray(f)||this.r(a);let k=!1;for(const D of f){p(D)||this.r(a);let C;if((0,m.$ie)(D.relativeLocation)&&D.relativeLocation)C=this.t(D.relativeLocation);else if((0,m.$ie)(D.location))C=this.t(D.location),k=!0,D.relativeLocation=D.location,D.location=C.toJSON();else{C=P.URI.revive(D.location);const L=this.s(C);L&&(k=!0,D.relativeLocation=L)}o.push({identifier:D.identifier,location:C,version:D.version,metadata:D.metadata})}k&&await this.j.writeFile(a,R.$Ec.fromString(JSON.stringify(f)))}if(s){o=s(o);const k=o.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.s(D.location),metadata:D.metadata}));await this.j.writeFile(a,R.$Ec.fromString(JSON.stringify(k)))}return o})}r(a){const s=new g(`Invalid extensions content in ${a.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}s(a){return this.l.extUri.isEqual(this.l.extUri.dirname(a),this.i)?this.l.extUri.basename(a):void 0}t(a){return this.l.extUri.joinPath(this.i,a)}async v(){return this.u||(this.u=(async()=>{const a=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),s=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let n;try{n=(await this.j.readFile(a)).value.toString()}catch(f){if((0,A.$9j)(f)===1)return;throw f}this.n.info("Migrating extensions from old default profile location",a.toString());let o;try{const f=JSON.parse(n);Array.isArray(f)&&f.every(k=>p(k))?o=f:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.n.error(f)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,R.$Ec.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",a.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(f){if((0,A.$9j)(f)===3)this.n.info("Migration from old default profile location to new location is done by another window",a.toString(),this.k.defaultProfile.extensionsResource.toString());else throw f}try{await this.j.del(a)}catch(f){(0,A.$9j)(f)!==1&&this.n.error(f)}try{await this.j.del(s)}catch(f){(0,A.$9j)(f)!==1&&this.n.error(f)}return o})()),this.u}w(a){let s=this.h.get(a);return s||(s=new v.$Bg,this.h.set(a,s)),s}};e.$dp=y,e.$dp=y=Le([Ie(1,A.$Sj),Ie(2,l.$rk),Ie(3,d.$pk),Ie(4,u.$Vk),Ie(5,w.$Ri)],y);function p(i){return(0,m.$ke)(i)&&(0,b.$Rn)(i.identifier)&&(t(i.location)||(0,m.$ie)(i.location)&&i.location)&&((0,m.$pe)(i.relativeLocation)||(0,m.$ie)(i.relativeLocation))&&i.version&&(0,m.$ie)(i.version)}function t(i){return i?(0,m.$ie)(i.path)&&(0,m.$ie)(i.scheme):!1}}),define(we[57],be([1,0,18,14,22,15,11,75,167,2,13,7,3,19,53,62,8,4,180,25,37,40,79,16,6,12,27,5,50,45,33,34,210]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g,y,p,t,i,a,s,n,o,f,k,D,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.Translations=void 0;var U;(function(he){function V(se,K){if(se===K)return!0;const Y=Object.keys(se),H=new Set;for(const _ of Object.keys(K))H.add(_);if(Y.length!==H.size)return!1;for(const _ of Y){if(se[_]!==K[_])return!1;H.delete(_)}return H.size===0}he.equals=V})(U||(e.Translations=U={})),e.$gp=(0,a.$ph)("IExtensionsScannerService");let x=class extends $.$lb{constructor(V,se,K,Y,H,_,ge,ne,q,X,O,N){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=se,this.l=K,this.m=Y,this.n=H,this.r=_,this.s=ge,this.t=ne,this.u=q,this.v=X,this.w=O,this.y=N,this.g=this.B(new o.$ec),this.onDidChangeCache=this.g.event,this.h=(0,l.$9f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(te,this.m,this.h)),this.j=this.B(this.y.createInstance(te,this.m,this.h)),this.k=this.B(this.y.createInstance(W,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,y.$to)(this.s,this.t)),this.z}async scanAllExtensions(V,se,K){const[Y,H]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(se)]),_=K?await this.scanExtensionsUnderDevelopment(V,[...Y,...H]):[];return this.G(Y,H,_,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const se=[];se.push(this.H(!!V.useCache,V.language)),se.push(this.I(V.language,!!V.checkControlFile));const[K,Y]=await Promise.all(se);return this.F([...K,...Y],0,V,!1)}async scanUserExtensions(V){const se=V.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",se);const K=this.w.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,Y=await this.L(se,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,K),H=V.useCache&&!Y.devMode&&Y.excludeObsolete?this.j:this.k;let _;try{_=await H.scanExtensions(Y)}catch(ge){if(ge instanceof k.$bp&&ge.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),_=await H.scanExtensions(Y);else throw ge}return _=await this.F(_,1,V,!0),this.t.trace("Scanned user extensions:",_.length),_}async scanExtensionsUnderDevelopment(V,se){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const K=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(Y=>Y.scheme===A.Schemas.file).map(async Y=>{const H=await this.L(Y,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(H)).map(ge=>(ge.type=se.find(ne=>(0,y.$io)(ne.identifier,ge.identifier))?.type??ge.type,this.k.validate(ge,H)))}))).flat();return this.F(K,"development",V,!0)}return[]}async scanExistingExtension(V,se,K){const Y=await this.L(V,!1,se,!0,K.language,!0,void 0),H=await this.k.scanExtension(Y);return!H||!K.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(V,se,K){const Y=await this.L(V,!1,se,!0,K.language,!0,void 0),H=await this.k.scanOneOrMultipleExtensions(Y);return this.F(H,se,K,!0)}async scanMetadata(V){const se=(0,l.$9f)(V,"package.json"),K=(await this.s.readFile(se)).value.toString();return JSON.parse(K).__metadata}async updateMetadata(V,se){const K=(0,l.$9f)(V,"package.json"),Y=(await this.s.readFile(K)).value.toString(),H=JSON.parse(Y);se.isMachineScoped=se.isMachineScoped||void 0,se.isBuiltin=se.isBuiltin||void 0,H.__metadata={...H.__metadata,...se},await this.s.writeFile((0,l.$9f)(V,"package.json"),S.$Ec.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof k.$bp&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw V}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.r.addExtensionsToProfile(V.map(se=>[se,se.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,S.$Ec.fromString(JSON.stringify([])))}catch(se){(0,i.$9j)(se)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$9)(se))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.t.error(V)}finally{this.C=void 0}})()),this.C}async F(V,se,K,Y){return K.includeAllVersions||(V=this.G(se===0?V:void 0,se===1?V:void 0,se==="development"?V:void 0,await this.getTargetPlatform(),Y)),K.includeInvalid||(V=V.filter(H=>H.isValid)),V.sort((H,_)=>{const ge=E.$_c(H.location.fsPath),ne=E.$_c(_.location.fsPath);return ge<ne?-1:ge>ne?1:0})}G(V,se,K,Y,H){const _=(ne,q,X)=>{if(ne.isValid&&!q.isValid)return!1;if(ne.isValid===q.isValid){if(H&&d.gt(ne.manifest.version,q.manifest.version))return this.t.debug(`Skipping extension ${q.location.path} with lower version ${q.manifest.version} in favour of ${ne.location.path} with version ${ne.manifest.version}`),!1;if(d.eq(ne.manifest.version,q.manifest.version)){if(ne.type===0)return this.t.debug(`Skipping extension ${q.location.path} in favour of system extension ${ne.location.path} with same version`),!1;if(ne.targetPlatform===Y)return this.t.debug(`Skipping extension ${q.location.path} from different target platform ${q.targetPlatform}`),!1}}return X?this.t.warn(`Overwriting user extension ${ne.location.path} with ${q.location.path}.`):this.t.debug(`Overwriting user extension ${ne.location.path} with ${q.location.path}.`),!0},ge=new p.$Ll;return V?.forEach(ne=>{const q=ge.get(ne.identifier.id);(!q||_(q,ne,!1))&&ge.set(ne.identifier.id,ne)}),se?.forEach(ne=>{const q=ge.get(ne.identifier.id);if(!q&&V&&ne.type===0){this.t.debug(`Skipping obsolete system extension ${ne.location.path}.`);return}(!q||_(q,ne,!1))&&ge.set(ne.identifier.id,ne)}),K?.forEach(ne=>{const q=ge.get(ne.identifier.id);(!q||_(q,ne,!0))&&ge.set(ne.identifier.id,ne),ge.set(ne.identifier.id,ne)}),[...ge.values()]}async H(V,se){this.t.trace("Started scanning system extensions");const K=await this.L(this.systemExtensionsLocation,!1,0,!0,se,!0,void 0),H=await(V&&!K.devMode?this.i:this.k).scanExtensions(K);return this.t.trace("Scanned system extensions:",H.length),H}async I(V,se){const K=this.u.isBuilt?[]:this.v.builtInExtensions;if(!K?.length)return[];this.t.trace("Started scanning dev system extensions");const Y=se?await this.J():{},H=[],_=u.URI.file(E.$6c(E.$8c(A.$1e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ne of K){const q=Y[ne.name]||"marketplace";switch(q){case"disabled":break;case"marketplace":H.push((0,l.$9f)(_,ne.name));break;default:H.push(u.URI.file(q));break}}const ge=await Promise.all(H.map(async ne=>this.k.scanExtension(await this.L(ne,!1,0,!0,V,!0,void 0))));return this.t.trace("Scanned dev system extensions:",ge.length),(0,v.$jf)(ge)}async J(){try{const V=await this.s.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async L(V,se,K,Y,H,_,ge){const ne=await this.f(H??w.$q),q=await this.M(V),X=se&&!this.w.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,O=X?await this.M(X):void 0;return new ae(V,q,X,O,se,ge,K,Y,_,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,H,ne)}async M(V){try{const se=await this.s.stat(V);if(typeof se.mtime=="number")return se.mtime}catch{}}};e.$hp=x,e.$hp=x=Le([Ie(4,D.$rk),Ie(5,k.$cp),Ie(6,i.$Sj),Ie(7,s.$Ri),Ie(8,g.$wh),Ie(9,n.$0i),Ie(10,C.$pk),Ie(11,a.$oh)],x);class ae{constructor(V,se,K,Y,H,_,ge,ne,q,X,O,N,J,ie,re){this.location=V,this.mtime=se,this.applicationExtensionslocation=K,this.applicationExtensionslocationMtime=Y,this.profile=H,this.profileScanOptions=_,this.type=ge,this.excludeObsolete=ne,this.validate=q,this.productVersion=X,this.productDate=O,this.productCommit=N,this.devMode=J,this.language=ie,this.translations=re}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,se){return(0,l.$2f)(V.location,se.location)&&V.mtime===se.mtime&&(0,l.$2f)(V.applicationExtensionslocation,se.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===se.applicationExtensionslocationMtime&&V.profile===se.profile&&r.$Nm(V.profileScanOptions,se.profileScanOptions)&&V.type===se.type&&V.excludeObsolete===se.excludeObsolete&&V.validate===se.validate&&V.productVersion===se.productVersion&&V.productDate===se.productDate&&V.productCommit===se.productCommit&&V.devMode===se.devMode&&V.language===se.language&&U.equals(V.translations,se.translations)}}e.$ip=ae;let W=class extends $.$lb{constructor(V,se,K,Y,H){super(),this.f=V,this.g=se,this.h=K,this.i=Y,this.j=H}async scanExtensions(V){const se=V.profile?await this.l(V):await this.k(V);let K={};if(V.excludeObsolete&&V.type===1)try{const Y=(await this.i.readFile(this.f)).value.toString();K=JSON.parse(Y)}catch{}return(0,c.$ve)(K)?se:se.filter(Y=>!K[y.$jo.create(Y).toString()])}async k(V){const se=await this.i.resolve(V.location);if(!se.children?.length)return[];const K=await Promise.all(se.children.map(async Y=>{if(!Y.isDirectory||V.type===1&&(0,l.$6f)(Y.resource).indexOf(".")===0)return null;const H=new ae(Y.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(H)}));return(0,v.$jf)(K).sort((Y,H)=>Y.location.path<H.location.path?-1:1)}async l(V){let se=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){se=se.filter(Y=>!Y.metadata?.isApplicationScoped);const K=await this.m(V.applicationExtensionslocation,Y=>!!Y.metadata?.isBuiltin||!!Y.metadata?.isApplicationScoped,V);se.push(...K)}return se}async m(V,se,K){const Y=await this.g.scanProfileExtensions(V,K.profileScanOptions);if(!Y.length)return[];const H=await Promise.all(Y.map(async _=>{if(se(_)){const ge=new ae(_.location,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(ge,_.metadata)}return null}));return(0,v.$jf)(H)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,l.$9f)(V.location,"package.json"))){const se=await this.scanExtension(V);return se?[se]:[]}else return await this.scanExtensions(V)}catch(se){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,I.$9)(se)),[]}}async scanExtension(V,se){try{let K=await this.scanExtensionManifest(V.location);if(K){K.publisher||(K.publisher=p.$Fl),se=se??K.__metadata,delete K.__metadata;const Y=(0,y.$no)(K.publisher,K.name),H=se?.id?{id:Y,uuid:se.id}:{id:Y},_=se?.isSystem?0:V.type,ge=_===0||!!se?.isBuiltin;K=await this.n(V.location,K,ae.createNlsConfiguration(V));const ne={type:_,identifier:H,manifest:K,location:V.location,isBuiltin:ge,targetPlatform:se?.targetPlatform??"undefined",metadata:se,isValid:!0,validations:[]};return V.validate?this.validate(ne,V):ne}}catch(K){V.type!==0&&this.j.error(K)}return null}validate(V,se){let K=!0;const Y=(0,t.$yo)(se.productVersion,se.productDate,se.location,V.manifest,V.isBuiltin);for(const[H,_]of Y)H===m.default.Error&&(K=!1,this.j.error(this.u(se.location,_)));return V.isValid=K,V.validations=Y,V}async scanExtensionManifest(V){const se=(0,l.$9f)(V,"package.json");let K;try{K=(await this.i.readFile(se)).value.toString()}catch(H){return(0,i.$9j)(H)!==1&&this.j.error(this.u(V,(0,h.localize)(0,null,se.path,H.message))),null}let Y;try{Y=JSON.parse(K)}catch{const _=[];(0,P.$zm)(K,_);for(const ge of _)this.j.error(this.u(V,(0,h.localize)(1,null,se.path,ge.offset,ge.length,(0,b.$ep)(ge.error))));return null}return(0,P.$Im)(Y)!=="object"?(this.j.error(this.u(V,(0,h.localize)(2,null,se.path))),null):Y}async n(V,se,K){const Y=await this.r(V,se,K);if(Y)try{const H=[],_=await this.s(Y.default,H);if(H.length>0)return H.forEach(ne=>{this.j.error(this.u(V,(0,h.localize)(3,null,Y.default?.path,(0,b.$ep)(ne.error))))}),se;if((0,P.$Im)(Y)!=="object")return this.j.error(this.u(V,(0,h.localize)(4,null,Y.default?.path))),se;const ge=Y.values||Object.create(null);return(0,L.$fp)(se,ge,_)}catch{}return se}async r(V,se,K){const Y=(0,l.$9f)(V,"package.nls.json"),H=(q,X)=>{X.forEach(O=>{this.j.error(this.u(V,(0,h.localize)(5,null,q?.path,(0,b.$ep)(O.error))))})},_=q=>{this.j.error(this.u(V,(0,h.localize)(6,null,q?.path)))},ge=`${se.publisher}.${se.name}`,ne=K.translations[ge];if(ne)try{const q=u.URI.file(ne),X=(await this.i.readFile(q)).value.toString(),O=[],N=(0,P.$zm)(X,O);return O.length>0?(H(q,O),{values:void 0,default:Y}):(0,P.$Im)(N)!=="object"?(_(q),{values:void 0,default:Y}):{values:N.contents?N.contents.package:void 0,default:Y}}catch{return{values:void 0,default:Y}}else{if(!await this.i.exists(Y))return;let X;try{X=await this.t(V,K)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const O=(await this.i.readFile(X.localized)).value.toString(),N=[],J=(0,P.$zm)(O,N);return N.length>0?(H(X.localized,N),{values:void 0,default:X.original}):(0,P.$Im)(J)!=="object"?(_(X.localized),{values:void 0,default:X.original}):{values:J,default:X.original}}catch{return{values:void 0,default:X.original}}}}async s(V,se){if(V)try{const K=(await this.i.readFile(V)).value.toString();return(0,P.$zm)(K,se)}catch{}}t(V,se){return new Promise((K,Y)=>{const H=_=>{const ge=(0,l.$9f)(V,`package.nls.${_}.json`);this.i.exists(ge).then(ne=>{ne&&K({localized:ge,original:(0,l.$9f)(V,"package.nls.json")});const q=_.lastIndexOf("-");q===-1?K({localized:(0,l.$9f)(V,"package.nls.json"),original:null}):(_=_.substring(0,q),H(_))})};if(se.devMode||se.pseudo||!se.language)return K({localized:(0,l.$9f)(V,"package.nls.json"),original:null});H(se.language)})}u(V,se){return`[${V.path}]: ${se}`}};W=Le([Ie(1,k.$cp),Ie(2,C.$pk),Ie(3,i.$Sj),Ie(4,s.$Ri)],W);let te=class extends W{constructor(V,se,K,Y,H,_,ge){super(se,Y,H,_,ge),this.z=V,this.C=K,this.w=this.B(new R.$sg(3e3)),this.y=this.B(new o.$ec),this.onDidChangeCache=this.y.event}async scanExtensions(V){const se=this.H(V),K=await this.D(se);if(this.v=V,K&&K.input&&ae.equals(K.input,this.v))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.w.trigger(()=>this.G()),K.result.map(H=>(H.location=u.URI.revive(H.location),H));const Y=await super.scanExtensions(V);return await this.F(se,{input:V,result:Y}),Y}async D(V){try{const se=await this.i.readFile(V),K=JSON.parse(se.value.toString());return{result:K.result,input:(0,f.$Yg)(K.input)}}catch(se){this.j.debug("Error while reading the extension cache file:",V.path,(0,I.$9)(se))}return null}async F(V,se){try{await this.i.writeFile(V,S.$Ec.fromString(JSON.stringify(se)))}catch(K){this.j.debug("Error while writing the extension cache file:",V.path,(0,I.$9)(K))}}async G(){if(!this.v)return;const V=this.H(this.v),se=await this.D(V);if(!se)return;const K=se.result,Y=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!r.$Nm(Y,K))try{this.j.info("Invalidating Cache",K,Y),await this.i.del(V),this.y.fire()}catch(H){this.j.error(H)}}H(V){const se=this.I(V);return this.h.extUri.joinPath(se.cacheHome,V.type===0?p.$El:p.$Dl)}I(V){return V.type===0?this.C.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.z.extensionsResource)?this.z:this.C.profiles.find(se=>this.h.extUri.isEqual(V.location,se.extensionsResource))??this.z:this.C.defaultProfile}};te=Le([Ie(2,D.$rk),Ie(3,k.$cp),Ie(4,C.$pk),Ie(5,i.$Sj),Ie(6,s.$Ri)],te);function ue(he,V){const se=(0,y.$lo)(he.manifest.publisher,he.manifest.name);return{id:se,identifier:new p.$Jl(se),isBuiltin:he.type===0,isUserBuiltin:he.type===1&&he.isBuiltin,isUnderDevelopment:V,extensionLocation:he.location,uuid:he.identifier.uuid,targetPlatform:he.targetPlatform,...he.manifest}}e.$jp=ue;class Z extends x{constructor(V,se,K,Y,H,_,ge,ne,q,X,O,N){super(V,se,(0,l.$9f)(K,".vscode-oss-dev","extensions","control.json"),Y,H,_,ge,ne,q,X,O,N),this.N=(async()=>{if(w.$t)try{const J=await this.s.readFile(u.URI.file(w.$t));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}f(V){return this.N}}e.$kp=Z}),define(we[257],be([1,0,52,14,39,5,2,13,7,21,12,33]),function(le,e,v,R,r,S,I,P,b,$,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;let w=class extends I.$lb{constructor(d,m){super(),this.b=d,this.f=m,this.a=new R.$Ag(5)}async postUninstall(d){const m=this.g(d,"uninstall");m&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(m.script,"uninstall",m.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(c)}}));try{await $.Promises.rm(this.j(d))}catch(c){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(c)}}g(d,m){const c=`vscode:${m}`;if(d.location.scheme===P.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[c]=="string"){const u=d.manifest.scripts[c].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${c} should be a node script`),null):{script:(0,b.$8c)(d.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(d,m,c,u,h){return new Promise((g,y)=>{const p=this.i(d,m,c,h);let t;const i=a=>{t&&(clearTimeout(t),t=null),a?y(a):g(void 0)};p.on("error",a=>{i((0,r.$ai)(a)||"Unknown")}),p.on("exit",(a,s)=>{i(a?`post-${m} process exited with code ${a}`:void 0)}),u&&(t=setTimeout(()=>{t=null,p.kill(),y("timed out")},5e3))})}i(d,m,c,u){const h={silent:!0,execArgv:void 0},g=(0,v.fork)(d,[`--type=extension-post-${m}`,...c],h);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const y=S.Event.fromNodeEventEmitter(g.stdout,"data"),p=S.Event.fromNodeEventEmitter(g.stderr,"data");y(a=>this.f.info(u.identifier.id,u.manifest.version,`post-${m}`,a)),p(a=>this.f.error(u.identifier.id,u.manifest.version,`post-${m}`,a));const t=S.Event.any(S.Event.map(y,a=>({data:`%c${a}`,format:[""]})),S.Event.map(p,a=>({data:`%c${a}`,format:["color: red"]})));return S.Event.debounce(t,(a,s)=>a?{data:a.data+s.data,format:[...a.format,...s.format]}:{data:s.data,format:s.format},100)(a=>{console.group(u.identifier.id),console.log(a.data,...a.format),console.groupEnd()}),g}j(d){return(0,b.$8c)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$mp=w,e.$mp=w=Le([Ie(0,E.$rk),Ie(1,A.$Ri)],w)}),define(we[126],be([1,0,12,33,34,32,45,16,25,4]),function(le,e,v,R,r,S,I,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=void 0;let A=class extends I.$dp{constructor(w,l,d,m,c,u){super($.URI.file(w.extensionsPath),l,d,m,c,u)}};e.$0M=A,e.$0M=A=Le([Ie(0,b.$xh),Ie(1,P.$Sj),Ie(2,R.$rk),Ie(3,r.$pk),Ie(4,S.$Vk),Ie(5,v.$Ri)],A)}),define(we[258],be([1,0,14,5,2,41,8,158,6,33]),function(le,e,v,R,r,S,I,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$No=e.$Mo=e.$Lo=void 0,e.$Lo="__$__isNewStorageMarker",e.$Mo="__$__targetStorageMarker",e.$No=(0,b.$ph)("storageService");var A;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var E;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var w;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function l(h){const g=h.get(e.$Mo);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.$Oo=l;class d extends r.$lb{constructor(g={flushInterval:d.a}){super(),this.j=g,this.b=this.B(new R.$hc),this.c=this.B(new R.$hc),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$ec),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Gg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new r.$mb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(g,y,p){return R.Event.filter(this.b.event,t=>t.scope===g&&(y===void 0||t.key===y),p)}k(){this.i.value=(0,v.$Kg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,r.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,S.mark)("code/willInitStorage");try{await this.J()}finally{(0,S.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,y){const{key:p,external:t}=y;if(p===e.$Mo){switch(g){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:p,target:this.F(g)[p],external:t})}r(g){this.f.fire({reason:g})}get(g,y,p){return this.L(y)?.get(g,p)}getBoolean(g,y,p){return this.L(y)?.getBoolean(g,p)}getNumber(g,y,p){return this.L(y)?.getNumber(g,p)}getObject(g,y,p){return this.L(y)?.getObject(g,p)}storeAll(g,y){this.t(()=>{for(const p of g)this.store(p.key,p.value,p.scope,p.target,y)})}store(g,y,p,t,i=!1){if((0,I.$re)(y)){this.remove(g,p,i);return}this.t(()=>{this.u(g,p,t),this.L(p)?.set(g,y,i)})}remove(g,y,p=!1){this.t(()=>{this.u(g,y,void 0),this.L(y)?.delete(g,p)})}t(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,y){const p=[],t=this.F(g);for(const i of Object.keys(t))t[i]===y&&p.push(i);return p}u(g,y,p,t=!1){const i=this.F(y);typeof p=="number"?i[g]!==p&&(i[g]=p,this.L(y)?.set(e.$Mo,JSON.stringify(i),t)):typeof i[g]=="number"&&(delete i[g],this.L(y)?.set(e.$Mo,JSON.stringify(i),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(g){switch(g){case-1:return this.D;case 0:return this.z;default:return this.w}}G(g){const y=this.L(g);return y?l(y):Object.create(null)}isNew(g){return this.getBoolean(e.$Lo,g)===!0}async flush(g=A.NONE){this.f.fire({reason:g});const y=this.L(-1),p=this.L(0),t=this.L(1);switch(g){case A.NONE:await v.Promises.settled([y?.whenFlushed()??Promise.resolve(),p?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await v.Promises.settled([y?.flush(0)??Promise.resolve(),p?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,y=this.L(0)?.items??new Map,p=this.L(1)?.items??new Map;return u(g,y,p,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,y){return this.r(A.NONE),(0,$.$qk)(g)?this.N(g,y):this.O(g,y)}H(g,y){return!(g.id===y.id||m(y)&&m(g))}I(g,y,p){this.t(()=>{const t=new Set;for(const[i,a]of g)t.add(i),y.get(i)!==a&&this.n(p,{key:i,external:!0});for(const[i]of y.items)t.has(i)||this.n(p,{key:i,external:!0})})}}e.$Po=d,d.a=60*1e3;function m(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$Qo=m;class c extends d{constructor(){super(),this.p=this.B(new P.$Jo(new P.$Ko,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.$Jo(new P.$Ko,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.$Jo(new P.$Ko,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.B(this.P.onDidChangeStorage(g=>this.n(0,g))),this.B(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.$Ro=c;async function u(h,g,y,p,t,i){const a=U=>{try{return JSON.parse(U)}catch{return U}},s=new Map,n=new Map;h.forEach((U,x)=>{s.set(x,U),n.set(x,a(U))});const o=new Map,f=new Map;g.forEach((U,x)=>{o.set(x,U),f.set(x,a(U))});const k=new Map,D=new Map;y.forEach((U,x)=>{k.set(x,U),D.set(x,a(U))}),console.group(p!==t?`Storage: Application (path: ${p})`:`Storage: Application & Profile (path: ${p}, default profile)`);const C=[];if(s.forEach((U,x)=>{C.push({key:x,value:U})}),console.table(C),console.groupEnd(),console.log(n),p!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const U=[];o.forEach((x,ae)=>{U.push({key:ae,value:x})}),console.table(U),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${i})`);const L=[];k.forEach((U,x)=>{L.push({key:x,value:U})}),console.table(L),console.groupEnd(),console.log(D)}e.$So=u}),define(we[127],be([1,0,18,20,11,3,29,8,4,24,25,31,37,79,16,12,27,44,241,258,32,60]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=void 0;const t=S.$j?"web":(0,E.$Nn)(S.$o,I.$3c),i="X-Market-Search-Activity-Id";var a;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function s(...O){return String(O.reduce((N,J)=>N|J,0))}var n;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class C{constructor(N=D){this.d=N}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(N,J=this.d.pageSize){return new C({...this.d,pageNumber:N,pageSize:J})}withFilter(N,...J){const ie=[...this.d.criteria,...J.length?J.map(re=>({filterType:N,value:re})):[{filterType:N}]];return new C({...this.d,criteria:ie})}withSortBy(N){return new C({...this.d,sortBy:N})}withSortOrder(N){return new C({...this.d,sortOrder:N})}withFlags(...N){return new C({...this.d,flags:N.reduce((J,ie)=>J|ie,0)})}withAssetTypes(...N){return new C({...this.d,assetTypes:N})}withSource(N){return new C({...this.d,source:N})}get raw(){const{criteria:N,pageNumber:J,pageSize:ie,sortBy:re,sortOrder:ee,flags:oe,assetTypes:F}=this.d;return{filters:[{criteria:N,pageNumber:J,pageSize:ie,sortBy:re,sortOrder:ee}],assetTypes:F,flags:oe}}get searchText(){const N=this.d.criteria.filter(J=>J.filterType===n.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(N=>String(N.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function L(O,N){const J=(O||[]).filter(ie=>ie.statisticName===N)[0];return J?J.value:0}function U(O){const N="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(ie=>ie.assetType.indexOf(N)===0).reduce((ie,re)=>{const ee=W(O,re.assetType);return ee&&ie.push([re.assetType.substring(N.length),ee]),ie},[])}function x(O){if(O.properties){const N=O.properties.filter(re=>re.key===o.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=N.filter(re=>J.test(re.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return W(O,o.Repository)}function ae(O){return{uri:`${O.fallbackAssetUri}/${o.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${o.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function W(O,N){return O.files.filter(ie=>ie.assetType===N)[0]?{uri:`${O.assetUri}/${N}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${N}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function te(O,N){const J=O.properties?O.properties.filter(re=>re.key===N):[],ie=J.length>0&&J[0].value;return ie?ie.split(",").map(re=>(0,w.$mo)(re)):[]}function ue(O){const N=O.properties?O.properties.filter(J=>J.key===f.Engine):[];return N.length>0&&N[0].value||""}function Z(O){const N=O.properties?O.properties.filter(J=>J.key===f.PreRelease):[];return N.length>0&&N[0].value==="true"}function he(O){const N=O.properties?O.properties.filter(ie=>ie.key===f.LocalizedLanguages):[],J=N.length>0&&N[0].value||"";return J?J.split(","):[]}function V(O){return O.properties?.find(N=>N.key===f.SponsorLink)?.value}function se(O){return O.indexOf("preview")!==-1}function K(O){return O.targetPlatform?(0,E.$Mn)(O.targetPlatform):"undefined"}function Y(O){const N=(0,v.$of)(O.versions.map(K)),J=!!O.tags?.includes(E.$Hn),ie=N.indexOf("web");return J?ie===-1&&N.push("web"):ie!==-1&&N.splice(ie,1),N}function H(O,N){const J=(0,E.$Qn)(N);for(let ie=0;ie<O.length;ie++){const re=O[ie];if(re.version===O[ie-1]?.version){let ee=ie;const oe=K(re);if(oe===N)for(;ee>0&&O[ee-1].version===re.version;)ee--;else if(J.includes(oe))for(;ee>0&&O[ee-1].version===re.version&&K(O[ee-1])!==N;)ee--;ee!==ie&&(O.splice(ie,1),O.splice(ee,0,re))}}return O}e.$Vo=H;function _(O,N,J){O.telemetryData={index:N,querySource:J,queryActivityId:O.queryContext?.[i]}}function ge(O,N,J,ie){const re=O.versions[0],ee={manifest:W(N,o.Manifest),readme:W(N,o.Details),changelog:W(N,o.Changelog),license:W(N,o.License),repository:x(N),download:ae(N),icon:W(N,o.Icon),signature:W(N,o.Signature),coreTranslations:U(N)};return{identifier:{id:(0,w.$no)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:N.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(re),description:O.shortDescription||"",installCount:L(O.statistics,"install"),rating:L(O.statistics,"averagerating"),ratingCount:L(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:J,assets:ee,properties:{dependencies:te(N,f.Dependency),extensionPack:te(N,f.ExtensionPack),engine:ue(N),localizedLanguages:he(N),targetPlatform:K(N),isPreReleaseVersion:Z(N)},hasPreReleaseVersion:Z(re),hasReleaseVersion:!0,preview:se(O.flags),isSigned:!!ee.signature,queryContext:ie}}let ne=class{constructor(N,J,ie,re,ee,oe,F,z){this.k=J,this.l=ie,this.n=re,this.o=ee,this.q=oe,this.u=F,this.w=z;const j=F.extensionsGallery,B=j?.servicePPEUrl&&z.getValue("_extensionsGallery.enablePPE");this.d=B?j.servicePPEUrl:j?.serviceUrl,this.g=B?void 0:j?.searchUrl,this.h=j?.controlUrl,this.j=(0,h.$Uo)(F.version,F,this.n,this.w,this.q,N,this.o)}x(N=""){return`${this.d}${N}`}isEnabled(){return!!this.d}async getExtensions(N,J,ie){const re=R.CancellationToken.isCancellationToken(J)?{}:J,ee=R.CancellationToken.isCancellationToken(J)?J:ie,oe=[],F=[],z=[],j=[];let B=!0;for(const Ee of N){Ee.uuid?F.push(Ee.uuid):oe.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);z.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&j.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),B=B&&!!Ee.hasPreRelease&&!Pe}if(!F.length&&!oe.length)return[];let Q=new C().withPage(1,N.length);F.length&&(Q=Q.withFilter(n.ExtensionId,...F)),oe.length&&(Q=Q.withFilter(n.ExtensionName,...oe)),(re.queryAllVersions||B)&&(Q=Q.withFlags(Q.flags,a.IncludeVersions)),re.source&&(Q=Q.withSource(re.source));const{extensions:de}=await this.z(Q,{targetPlatform:re.targetPlatform??t,includePreRelease:z,versions:j,compatible:!!re.compatible},ee);return re.source&&de.forEach((Ee,Pe)=>_(Ee,Pe,re.source)),de}async getCompatibleExtension(N,J,ie){if((0,E.$On)(N.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(N,J,ie))return N;const re=new C().withFlags(a.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,N.identifier.uuid),{extensions:ee}=await this.z(re,{targetPlatform:ie,compatible:!0,includePreRelease:J},R.CancellationToken.None);return ee[0]||null}async isExtensionCompatible(N,J,ie){if(!(0,E.$Pn)(N.properties.targetPlatform,N.allTargetPlatforms,ie)||!J&&N.properties.isPreReleaseVersion)return!1;let re=N.properties.engine;if(!re){const ee=await this.getManifest(N,R.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");re=ee.engines.vscode}return(0,l.$Ao)(re,this.u.version,this.u.date)}async y(N,J,ie,re,ee){if(!(0,E.$Pn)(K(N),re,ee)||J!=="any"&&Z(N)!==(J==="prerelease"))return!1;if(ie)try{const oe=await this.E(N);if(!(0,l.$Ao)(oe,this.u.version,this.u.date))return!1}catch(oe){return this.l.error(`Error while getting the engine for the version ${N.version}.`,(0,r.$9)(oe)),!1}return!0}async query(N,J){let ie=N.text||"";const re=N.pageSize??50;let ee=new C().withPage(1,re);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(B,Q,de)=>(ee=ee.withFilter(n.Category,de||Q),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(B,Q,de)=>(ee=ee.withFilter(n.Tag,de||Q),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(n.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),ee=ee.withFilter(n.SearchText,ie)),ee=ee.withSortBy(0)):N.ids?ee=ee.withFilter(n.ExtensionId,...N.ids):N.names?ee=ee.withFilter(n.ExtensionName,...N.names):ee=ee.withSortBy(4),typeof N.sortBy=="number"&&(ee=ee.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(ee=ee.withSortOrder(N.sortOrder)),N.source&&(ee=ee.withSource(N.source));const oe=async(B,Q)=>{const{extensions:de,total:Ee}=await this.z(B,{targetPlatform:t,compatible:!1,includePreRelease:!!N.includePreRelease},Q);return de.forEach((Pe,Re)=>_(Pe,(B.pageNumber-1)*B.pageSize+Re,N.source)),{extensions:de,total:Ee}},{extensions:F,total:z}=await oe(ee,J),j=async(B,Q)=>{if(Q.isCancellationRequested)throw new r.$3;const{extensions:de}=await oe(ee.withPage(B+1),Q);return de};return{firstPage:F,total:z,pageSize:ee.pageSize,getPage:j}}async z(N,J,ie){const re=N.flags;N.flags&a.IncludeLatestVersionOnly&&N.flags&a.IncludeVersions&&(N=N.withFlags(N.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(N.flags&a.IncludeLatestVersionOnly)&&!(N.flags&a.IncludeVersions)&&(N=N.withFlags(N.flags,a.IncludeLatestVersionOnly)),J.versions?.length&&(N=N.withFlags(N.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),N=N.withFlags(N.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:ee,total:oe,context:F}=await this.B(N,ie);if(!(N.flags&a.IncludeLatestVersionOnly)){const Q=[];for(const de of ee){const Ee=await this.A(de,J,F);Ee&&Q.push(Ee)}return{extensions:Q,total:oe}}const j=[],B=new Map;for(let Q=0;Q<ee.length;Q++){const de=ee[Q],Ee={id:(0,w.$no)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Pe=(0,P.$oe)(J.includePreRelease)?J.includePreRelease:!!J.includePreRelease.find(Fe=>(0,w.$io)(Fe,Ee))?.includePreRelease;if(J.compatible&&(0,E.$On)(Y(de),J.targetPlatform))continue;const Re=await this.A(de,J,F);!Re||Re.properties.isPreReleaseVersion&&(!Pe||!Re.hasReleaseVersion)||!Re.properties.isPreReleaseVersion&&Re.properties.targetPlatform!==J.targetPlatform&&Re.hasPreReleaseVersion?B.set(de.extensionId,Q):j.push([Q,Re])}if(B.size){const Q=new p.$ac,de=new C().withFlags(re&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,B.size).withFilter(n.ExtensionId,...B.keys()),{extensions:Ee}=await this.z(de,J,ie);this.o.publicLog2("galleryService:additionalQuery",{duration:Q.elapsed(),count:B.size});for(const Pe of Ee){const Re=B.get(Pe.identifier.uuid);j.push([Re,Pe])}}return{extensions:j.sort((Q,de)=>Q[0]-de[0]).map(([,Q])=>Q),total:oe}}async A(N,J,ie){const re={id:(0,w.$no)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},ee=J.versions?.find(j=>(0,w.$io)(j,re))?.version,oe=(0,P.$oe)(J.includePreRelease)?J.includePreRelease:!!J.includePreRelease.find(j=>(0,w.$io)(j,re))?.includePreRelease,F=Y(N),z=H(N.versions,J.targetPlatform);if(J.compatible&&(0,E.$On)(F,J.targetPlatform))return null;for(let j=0;j<z.length;j++){const B=z[j];if(!(ee&&B.version!==ee)){if(await this.y(B,oe?"any":"release",J.compatible,F,J.targetPlatform))return ge(N,B,F,ie);if(ee&&B.version===ee)return null}}return ee||J.compatible?null:ge(N,N.versions[0],F)}async B(N,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,a.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,s(a.Unpublished));const ie=await this.j,re=JSON.stringify(N.raw),ee={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(re.length)},oe=new p.$ac;let F,z,j=0;try{if(F=await this.k.request({type:"POST",url:this.g&&N.criteria.some(Q=>Q.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:re,headers:ee},J),F.res.statusCode&&F.res.statusCode>=400&&F.res.statusCode<500)return{galleryExtensions:[],total:j};const B=await(0,u.$Go)(F);if(B){const Q=B.results[0],de=Q.extensions,Ee=Q.resultMetadata&&Q.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return j=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:j,context:{[i]:F.res.headers.activityid}}}return{galleryExtensions:[],total:j}}catch(B){throw z=B,B}finally{this.o.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(re.length),duration:oe.elapsed(),success:!!F&&(0,u.$Do)(F),responseBodySize:F?.res.headers["Content-Length"],statusCode:F?String(F.res.statusCode):void 0,errorCode:z?(0,r.$2)(z)?"canceled":(0,r.$9)(z).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(j)})}}async reportStatistic(N,J,ie,re){if(!this.isEnabled())return;const ee=S.$j?this.x(`/itemName/${N}.${J}/version/${ie}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${N}/extensions/${J}/${ie}/stats?statType=${re}`),oe=S.$j?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",z={...await this.j,Accept:oe};try{await this.k.request({type:"POST",url:ee,headers:z},R.CancellationToken.None)}catch{}}async download(N,J,ie){this.l.trace("ExtensionGalleryService#download",N.identifier.id);const re=(0,w.$qo)(N),ee=new Date().getTime(),oe=Q=>this.o.publicLog("galleryService:downloadVSIX",{...re,duration:Q}),F=ie===2?"install":ie===3?"update":"",z=F?{uri:`${N.assets.download.uri}${b.URI.parse(N.assets.download.uri).query?"&":"?"}${F}=true`,fallbackUri:`${N.assets.download.fallbackUri}${b.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${F}=true`}:N.assets.download,j=N.queryContext?.[i]?{[i]:N.queryContext[i]}:void 0,B=await this.D(z,j?{headers:j}:void 0);await this.q.writeFile(J,B.stream),oe(new Date().getTime()-ee)}async downloadSignatureArchive(N,J){if(!N.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",N.identifier.id);const ie=await this.D(N.assets.signature);await this.q.writeFile(J,ie.stream)}async getReadme(N,J){if(N.assets.readme){const ie=await this.D(N.assets.readme,{},J);return await(0,u.$Fo)(ie)||""}return""}async getManifest(N,J){if(N.assets.manifest){const ie=await this.D(N.assets.manifest,{},J),re=await(0,u.$Fo)(ie);return re?JSON.parse(re):null}return null}async C(N,J){const ie=W(N,o.Manifest);if(!ie)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},ee=await this.D(ie,{headers:re});return await(0,u.$Go)(ee)}async getCoreTranslation(N,J){const ie=N.assets.coreTranslations.filter(re=>re[0]===J.toUpperCase())[0];if(ie){const re=await this.D(ie[1]),ee=await(0,u.$Fo)(re);return ee?JSON.parse(ee):null}return null}async getChangelog(N,J){if(N.assets.changelog){const ie=await this.D(N.assets.changelog,{},J);return await(0,u.$Fo)(ie)||""}return""}async getAllCompatibleVersions(N,J,ie){let re=new C().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?re=re.withFilter(n.ExtensionId,N.identifier.uuid):re=re.withFilter(n.ExtensionName,N.identifier.id);const{galleryExtensions:ee}=await this.B(re,R.CancellationToken.None);if(!ee.length)return[];const oe=Y(ee[0]);if((0,E.$On)(oe,ie))return[];const F=[];await Promise.all(ee[0].versions.map(async B=>{try{await this.y(B,J?"any":"release",!0,oe,ie)&&F.push(B)}catch{}}));const z=[],j=new Set;for(const B of H(F,ie))j.has(B.version)||(j.add(B.version),z.push({version:B.version,date:B.lastUpdated,isPreReleaseVersion:Z(B)}));return z}async D(N,J={},ie=R.CancellationToken.None){const re=await this.j,ee={type:"GET"},oe={...re,...J.headers||{}};J={...J,...ee,headers:oe};const F=N.uri,z=N.fallbackUri,j={...J,url:F};try{const B=await this.k.request(j,ie);if(B.res.statusCode===200)return B;const Q=await(0,u.$Fo)(B);throw new Error(`Expected 200, got back ${B.res.statusCode} instead.

${Q}`)}catch(B){if((0,r.$2)(B))throw B;const Q=(0,r.$9)(B);this.o.publicLog2("galleryService:cdnFallback",{url:F,message:Q});const de={...J,url:z};return this.k.request(de,ie)}}async E(N){let J=ue(N);if(!J){const ie=await this.C(N,R.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");J=ie.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const N=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,u.$Go)(N),ie=[],re={},ee=[];if(J){for(const oe of J.malicious)ie.push({id:oe});if(J.migrateToPreRelease)for(const[oe,F]of Object.entries(J.migrateToPreRelease))(!F.engine||(0,l.$Ao)(F.engine,this.u.version,this.u.date))&&(re[oe.toLowerCase()]={disallowInstall:!0,extension:{id:F.id,displayName:F.displayName,autoMigrate:{storage:!!F.migrateStorage},preRelease:!0}});if(J.deprecated)for(const[oe,F]of Object.entries(J.deprecated))F&&(re[oe.toLowerCase()]=(0,P.$oe)(F)?{}:F);if(J.search)for(const oe of J.search)ee.push(oe)}return{malicious:ie,deprecated:re,search:ee}}};ne=Le([Ie(1,u.$Bo),Ie(2,m.$Ri),Ie(3,A.$wh),Ie(4,y.$Vk),Ie(5,d.$Sj),Ie(6,c.$0i),Ie(7,$.$Vh)],ne);let q=class extends ne{constructor(N,J,ie,re,ee,oe,F,z){super(N,J,ie,re,ee,oe,F,z)}};e.$Wo=q,e.$Wo=q=Le([Ie(0,g.$No),Ie(1,u.$Bo),Ie(2,m.$Ri),Ie(3,A.$wh),Ie(4,y.$Vk),Ie(5,d.$Sj),Ie(6,c.$0i),Ie(7,$.$Vh)],q);let X=class extends ne{constructor(N,J,ie,re,ee,oe,F){super(void 0,N,J,ie,re,ee,oe,F)}};e.$Xo=X,e.$Xo=X=Le([Ie(0,u.$Bo),Ie(1,m.$Ri),Ie(2,A.$wh),Ie(3,y.$Vk),Ie(4,d.$Sj),Ie(5,c.$0i),Ie(6,$.$Vh)],X)}),define(we[259],be([1,0,5,2,33,51]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=void 0;class I{constructor($,A){this.a=$,this.b=A}listen($,A){const E=this.b($);switch(A){case"onDidChangeProfiles":return v.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(l=>(0,S.$rm)({...l},E)),added:w.added.map(l=>(0,S.$rm)({...l},E)),removed:w.removed.map(l=>(0,S.$rm)({...l},E)),updated:w.updated.map(l=>(0,S.$rm)({...l},E))}))}throw new Error(`Invalid listen ${A}`)}async call($,A,E){const w=this.b($);switch(A){case"createProfile":{const l=await this.a.createProfile(E[0],E[1],E[2]);return(0,S.$rm)({...l},w)}case"updateProfile":{let l=(0,r.$sk)((0,S.$sm)(E[0],w),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,E[1]),(0,S.$rm)({...l},w)}case"removeProfile":{const l=(0,r.$sk)((0,S.$sm)(E[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${A}`)}}e.$eN=I;class P extends R.$lb{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor($,A,E){super(),this.profilesHome=A,this.f=E,this.a=[],this.b=this.B(new v.$ec),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=$.map(w=>(0,r.$sk)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const l=w.added.map(c=>(0,r.$sk)(c,this.profilesHome.scheme)),d=w.removed.map(c=>(0,r.$sk)(c,this.profilesHome.scheme)),m=w.updated.map(c=>(0,r.$sk)(c,this.profilesHome.scheme));this.a=w.all.map(c=>(0,r.$sk)(c,this.profilesHome.scheme)),this.b.fire({added:l,removed:d,updated:m,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement($){this.c=$}isEnabled(){return this.c}async createNamedProfile($,A,E){const w=await this.f.call("createNamedProfile",[$,A,E]);return(0,r.$sk)(w,this.profilesHome.scheme)}async createProfile($,A,E,w){const l=await this.f.call("createProfile",[$,A,E,w]);return(0,r.$sk)(l,this.profilesHome.scheme)}async createTransientProfile($){const A=await this.f.call("createTransientProfile",[$]);return(0,r.$sk)(A,this.profilesHome.scheme)}async setProfileForWorkspace($,A){await this.f.call("setProfileForWorkspace",[$,A])}removeProfile($){return this.f.call("removeProfile",[$])}async updateProfile($,A){const E=await this.f.call("updateProfile",[$,A]);return(0,r.$sk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$fN=P}),define(we[128],be([1,0,4,25,16,12,235,34,33,8,236]),function(le,e,v,R,r,S,I,P,b,$,A){"use strict";var E,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=e.$8M=e.$7M=void 0;let l=E=class extends b.$uk{constructor(u,h,g,y,p){super(g,y,h,p),this.P=u,this.Q=g}J(){return this.P.getItem(E.b,[]).map(h=>({...h,location:(0,$.$ie)(h.location)?this.s.extUri.joinPath(this.profilesHome,h.location):v.URI.revive(h.location)}))}M(){const u=this.P.getItem(E.c,{});return this.P.getItem(E.a,!1)?u:this.I(u)}O(){return this.s.extUri.joinPath(v.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$7M=l,l.a="profileAssociationsMigration",e.$7M=l=E=Le([Ie(0,I.$2M),Ie(1,P.$pk),Ie(2,R.$xh),Ie(3,r.$Sj),Ie(4,S.$Ri)],l);let d=w=class extends l{constructor(u,h,g,y,p){super(u,h,g,y,p),this.W=u}L(u){u.length?this.W.setItem(w.b,u.map(h=>({...h,location:this.s.extUri.basename(h.location)}))):this.W.removeItem(w.b)}J(){const u=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(u),this.W.setItem("userDataProfilesMigration",!0)),u}N(u){u.emptyWindows||u.workspaces?this.W.setItem(w.c,u):this.W.removeItem(w.c)}M(){const u="workspaceAndProfileInfo",h=this.W.getItem(u,void 0);if(h){this.W.removeItem(u);const y=h.reduce((p,{workspace:t,profile:i})=>(p[v.URI.revive(t).toString()]=v.URI.revive(i).toString(),p),{});this.W.setItem(w.c,{workspaces:y})}const g=super.M();return this.W.getItem(w.a,!1)||(this.N(g),this.W.setItem(w.a,!0)),g}};e.$8M=d,e.$8M=d=w=Le([Ie(0,I.$3M),Ie(1,P.$pk),Ie(2,R.$xh),Ie(3,r.$Sj),Ie(4,S.$Ri)],d);let m=class extends d{constructor(u,h,g,y){super(new A.$6M(0,h,y,g),u,h,g,y)}async init(){return await this.W.init(),super.init()}};e.$9M=m,e.$9M=m=Le([Ie(0,P.$pk),Ie(1,R.$xh),Ie(2,r.$Sj),Ie(3,S.$Ri)],m)}),define(we[129],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=void 0,e.$_l=(0,v.$ph)("extensionHostStatusService");class R{constructor(){this.a=new Map}setExitInfo(S,I){this.a.set(S,I)}getExitInfo(S){return this.a.get(S)||null}}e.$am=R}),define(we[260],be([1,0,5,14]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=void 0;function r(I){let P=0,b=0,$=0;I>=1e3&&($=Math.floor(I/1e3),I-=$*1e3),$>=60&&(b=Math.floor($/60),$-=b*60),b>=60&&(P=Math.floor(b/60),b-=P*60);const A=P?`${P}h`:"",E=b?`${b}m`:"",w=$?`${$}s`:"",l=I?`${I}ms`:"";return`${A}${E}${w}${l}`}class S{constructor(P,b,$,A){this.i=P,this.j=b,this.a=new v.$ec,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=$,this.protocol=A,this.e=!1,this.f=new R.$Hg(()=>{this.k(`The reconnection grace time of ${r(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new R.$Hg(()=>{this.k(`The reconnection short grace time of ${r(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${r(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(P){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${r(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this.a.fire(void 0)}acceptReconnection(P,b,$){this.d=P,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(b,$),this.protocol.endAcceptReconnection()}}e.$im=S}),define(we[91],be([1,0,30,13,7,153,54]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.InternalNLSConfiguration=e.$6k=void 0;const P=r.$8c(R.$1e.asFileUri("").fsPath,"nls.metadata.json"),b=new Map;function $(d){return new Promise(m=>v.exists(d,m))}function A(d,m){return $(P).then(c=>{if(!c||!I.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const u=`${d}||${m}`;let h=b.get(u);return h||(h=S.getNLSConfiguration(I.default.commit,m,P,d,d).then(g=>(E.is(g)&&(g._languagePackSupport=!0),g.locale!=="en"&&g.locale!=="en-us"&&Object.keys(g.availableLanguages).length===0&&b.delete(u),g)),b.set(u,h)),h})}e.$6k=A;var E;(function(d){function m(c){const u=c;return u&&typeof u._languagePackId=="string"}d.is=m})(E||(e.InternalNLSConfiguration=E={}));const w=async d=>{try{const m=l(await v.promises.readFile(d,"utf8"));return JSON.parse(m).locale}catch(m){return m.code!=="ENOENT"&&console.warn(m),"en"}};e.$7k=w;const l=d=>{const m=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return d.replace(m,(c,u,h,g,y)=>{if(g)return"";if(y){const p=y.length;return p>2&&y[p-1]===`
`?y[p-2]==="\r"?`\r
`:`
`:""}else return c})}}),define(we[130],be([1,0,19,4,25,45,57,16,6,12,27,34,33,91]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=void 0;let d=class extends I.$hp{constructor(c,u,h,g,y,p,t,i){super(R.URI.file(y.builtinExtensionsPath),R.URI.file(y.extensionsPath),(0,v.$9f)(y.userHome,".vscode-oss-dev","extensions","control.json"),c.defaultProfile,c,u,h,g,y,p,t,i),this.N=y}async f(c){const u=await(0,l.$6k)(c,this.N.userDataPath);if(l.InternalNLSConfiguration.is(u))try{const h=await this.s.readFile(R.URI.file(u._translationsConfigFile));return JSON.parse(h.value.toString())}catch{}return Object.create(null)}};e.$VM=d,e.$VM=d=Le([Ie(0,w.$rk),Ie(1,S.$cp),Ie(2,P.$Sj),Ie(3,$.$Ri),Ie(4,r.$xh),Ie(5,A.$0i),Ie(6,E.$pk),Ie(7,b.$oh)],d)}),define(we[261],be([1,0,262,30,7,23,13,21]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.ServerConnectionTokenType=void 0;const b=/^[0-9A-Za-z_-]+$/;var $;(function(c){c[c.None=0]="None",c[c.Optional=1]="Optional",c[c.Mandatory=2]="Mandatory"})($||(e.ServerConnectionTokenType=$={}));class A{constructor(){this.type=0}validate(u){return!0}}e.$jm=A;class E{constructor(u){this.value=u,this.type=2}validate(u){return u===this.value}}e.$km=E;class w{constructor(u){this.message=u}}e.$lm=w;async function l(c,u){const h=c["without-connection-token"],g=c["connection-token"],y=c["connection-token-file"];if(h)return typeof g<"u"||typeof y<"u"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new A;if(typeof y<"u"){if(typeof g<"u")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let p;try{p=R.readFileSync(y).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${y}'.`)}return b.test(p)?new E(p):new w(`The connection token defined in '${y} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof g<"u"?b.test(g)?new E(g):new w(`The connection token '${g} does not adhere to the characters 0-9, a-z, A-Z or -.`):new E(await u())}e.$mm=l;async function d(c){return l(c,async()=>{if(!c["user-data-dir"])return(0,S.$3e)();const h=r.$8c(c["user-data-dir"],"token");try{const p=(await P.Promises.readFile(h)).toString().replace(/\r?\n$/,"");if(b.test(p))return p}catch{}const g=(0,S.$3e)();try{await P.Promises.writeFile(h,g,{mode:384})}catch{}return g})}e.$nm=d;function m(c,u,h){if(c.validate(h.query[I.$Ue]))return!0;const g=v.parse(u.headers.cookie||"");return c.validate(g[I.$Te])}e.$om=m}),define(we[46],be([1,0,198,110,64,6,25,73]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=void 0,e.$3l={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:v.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:v.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:v.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:v.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:v.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:v.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:v.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:v.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:v.localize(8,null)},"user-data-dir":r.$ml["user-data-dir"],"enable-smoke-test-driver":r.$ml["enable-smoke-test-driver"],"disable-telemetry":r.$ml["disable-telemetry"],"disable-workspace-trust":r.$ml["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:r.$ml.log,logsPath:r.$ml.logsPath,"force-disable-user-env":r.$ml["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:v.localize(9,null)},"default-workspace":{type:"string",description:v.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":r.$ml["extensions-dir"],"extensions-download-dir":r.$ml["extensions-download-dir"],"builtin-extensions-dir":r.$ml["builtin-extensions-dir"],"install-extension":r.$ml["install-extension"],"install-builtin-extension":r.$ml["install-builtin-extension"],"uninstall-extension":r.$ml["uninstall-extension"],"list-extensions":r.$ml["list-extensions"],"locate-extension":r.$ml["locate-extension"],"show-versions":r.$ml["show-versions"],category:r.$ml.category,force:r.$ml.force,"do-not-sync":r.$ml["do-not-sync"],"pre-release":r.$ml["pre-release"],"start-server":{type:"boolean",cat:"e",description:v.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:r.$ml.help,version:r.$ml.version,"locate-shell-integration-path":r.$ml["locate-shell-integration-path"],compatibility:{type:"string"},_:r.$ml._},e.$4l=(0,S.$qh)(I.$wh);class b extends R.$Zl{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$5l=b,Le([P.$Tg],b.prototype,"userRoamingDataHome",null)}),define(we[263],be([1,0,301,246,264,26]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;class I extends v.AppInsightsCore{constructor(b){super(),this.a=b}track(b){const $=b.baseData||{};$.properties||($.properties={}),$.measurements||($.measurements={});try{const A=S.cpus();$.measurements.cores=A.length,$.properties["common.cpuModel"]=A[0].model}catch{}try{$.measurements.memoryFree=S.freemem(),$.measurements.memoryTotal=S.totalmem()}catch{}try{$.properties["common.shell"]=S.userInfo().shell,$.properties["common.release"]=S.release(),$.properties["common.arch"]=S.arch()}catch{}try{const A=(/^http:/.test(this.a)?r:R).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});A.on("error",()=>{}),A.write(JSON.stringify($)),A.end()}catch{}}}e.$WM=I}),define(we[265],be([1,0,30,21,77,85,262,87,38,58,3,12,46,7,13,23,27,44,20,4,15,8,91,56]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g,y,p,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.CacheControl=e.$jN=void 0;const a={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function s(x,ae,W,te){ae.writeHead(W,{"Content-Type":"text/plain"}),ae.end(te)}e.$jN=s;var n;(function(x){x[x.NO_CACHING=0]="NO_CACHING",x[x.ETAG=1]="ETAG",x[x.NO_EXPIRY=2]="NO_EXPIRY"})(n||(e.CacheControl=n={}));async function o(x,ae,W,te,ue,Z){try{const he=await R.Promises.stat(x);if(ae===1){const V=`W/"${[he.ino,he.size,he.mtime.getTime()].join("-")}"`;if(te.headers["if-none-match"]===V)return ue.writeHead(304),void ue.end();Z.Etag=V}else ae===2?Z["Cache-Control"]="public, max-age=31536000":ae===0&&(Z["Cache-Control"]="no-store");Z["Content-Type"]=a[(0,l.$ad)(x)]||(0,$.$Br)(x)||"text/plain",ue.writeHead(200,Z),(0,v.createReadStream)(x).pipe(ue)}catch(he){return he.code!=="ENOENT"?(W.error(he),console.error(he.toString())):console.error(`File not found: ${x}`),ue.writeHead(404,{"Content-Type":"text/plain"}),void ue.end("Not found")}}e.$kN=o;const f=(0,l.$$c)(d.$1e.asFileUri("").fsPath);let k=class{constructor(ae,W,te,ue,Z){this.f=ae,this.g=W,this.h=te,this.i=ue,this.j=Z,this.a=this.j.extensionsGallery?.resourceUrlTemplate?g.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const he=(0,i.$Dk)(Z);this.b=`${he}/static`,this.c=`${he}/callback`,this.d="/web-extension-resource"}async handle(ae,W,te){try{const ue=te.pathname;return ue.startsWith(this.b)&&ue.charCodeAt(this.b.length)===47?this.k(ae,W,te):ue==="/"?this.n(ae,W,te):ue===this.c?this.p(W):ue.startsWith(this.d)&&ue.charCodeAt(this.d.length)===47?this.m(ae,W,te):s(ae,W,404,"Not found.")}catch(ue){return this.h.error(ue),console.error(ue.toString()),s(ae,W,500,"Internal Server Error.")}}async k(ae,W,te){const ue=Object.create(null),he=decodeURIComponent(te.pathname).substring(this.b.length+1),V=(0,l.$8c)(f,he);return(0,b.$He)(V,f,!A.$f)?o(V,this.g.isBuilt?2:1,this.h,ae,W,ue):s(ae,W,400,"Bad request.")}l(ae){const W=ae.authority.indexOf(".");return W!==-1?ae.authority.substring(W+1):void 0}async m(ae,W,te){if(!this.a)return s(ae,W,500,"No extension gallery service configured.");const ue=decodeURIComponent(te.pathname),Z=(0,l.$6c)(ue.substring(this.d.length+1)),he=g.URI.parse(Z).with({scheme:this.a.scheme,authority:Z.substring(0,Z.indexOf("/")),path:Z.substring(Z.indexOf("/")+1)});if(this.l(this.a)!==this.l(he))return s(ae,W,403,"Request Forbidden");const V={},se=ne=>{const q=ae.headers[ne];q&&((0,p.$ie)(q)||q[0])?V[ne]=(0,p.$ie)(q)?q:q[0]:ne!==ne.toLowerCase()&&se(ne.toLowerCase())};se("X-Client-Name"),se("X-Client-Version"),se("X-Machine-Id"),se("X-Client-Commit");const K=await this.i.request({type:"GET",url:he.toString(!0),headers:V},h.CancellationToken.None),Y=K.res.statusCode||500;if(Y!==200){let ne=null;try{ne=await(0,u.$Fo)(K)}catch{}return s(ae,W,Y,ne||`Request failed with status ${Y}`)}const H=Object.create(null),_=ne=>{const q=K.res.headers[ne];q?H[ne]=q:ne!==ne.toLowerCase()&&_(ne.toLowerCase())};_("Cache-Control"),_("Content-Type"),W.writeHead(200,H);const ge=await(0,y.$Qc)(K.stream);return void W.end(ge.buffer)}async n(ae,W,te){const ue=te.query[d.$Ue];if(typeof ue=="string"){const oe=Object.create(null);oe["Set-Cookie"]=I.serialize(d.$Te,ue,{sameSite:"lax",maxAge:60*60*24*7});const F=Object.create(null);for(const j in te.query)j!==d.$Ue&&(F[j]=te.query[j]);const z=S.format({pathname:"/",query:F});return oe.Location=z,W.writeHead(302,oe),void W.end()}const Z=!this.g.isBuilt&&this.g.args["use-test-resolver"],he=Z?"test+test":"remote";if(!he)return s(ae,W,400,"Bad request.");function V(oe){return JSON.stringify(oe).replace(/"/g,"&quot;")}let se;this.g.args["enable-smoke-test-driver"]&&(se=!1);const K=oe=>oe&&g.URI.file(r.resolve(oe)).with({scheme:d.Schemas.vscodeRemote,authority:he}),Y=d.$1e.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,H=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,m.$3e)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,_=(0,e.$nN)((0,e.$pN)(ae)),ge=(0,e.$oN)((0,e.$pN)(ae)),ne={codeServerVersion:this.j.codeServerVersion,rootEndpoint:_,updateEndpoint:this.g.args["disable-update-check"]?void 0:_+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?_+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??_+"/proxy/{{port}}/",serviceWorker:{scope:ge+"/",path:_+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery};if(!this.g.isBuilt)try{const oe=JSON.parse((await R.Promises.readFile((0,l.$8c)(f,"product.overrides.json"))).toString());Object.assign(ne,oe)}catch{}const q={remoteAuthority:he,webviewEndpoint:ge+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:se,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:K(this.g.args["default-folder"]),workspaceUri:K(this.g.args["default-workspace"]),productConfiguration:ne,callbackRoute:this.c},X=this.g.args.locale||await(0,t.$7k)(this.g.argvResource.fsPath),O=await(0,t.$6k)(X,this.g.userDataPath),N=this.j.extensionsGallery?.nlsBaseUrl,J={WORKBENCH_WEB_CONFIGURATION:V(q),WORKBENCH_AUTH_SESSION:H?V(H):"",WORKBENCH_WEB_BASE_URL:ge+this.b,WORKBENCH_NLS_BASE_URL:ge+(N?`${N}${N.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:_,VS_BASE:ge,NLS_CONFIGURATION:V(O)};if(Z){const oe=[];for(const F of["vscode-test-resolver","github-authentication"]){const z=JSON.parse((await R.Promises.readFile(d.$1e.asFileUri(`${d.$We}/${F}/package.json`).fsPath)).toString());oe.push({extensionPath:F,packageJSON:z})}J.WORKBENCH_BUILTIN_EXTENSIONS=V(oe)}let ie;try{ie=(await R.Promises.readFile(Y)).toString().replace(/\{\{([^}]+)\}\}/g,(F,z)=>J[z]??"undefined")}catch{return W.writeHead(404,{"Content-Type":"text/plain"}),void W.end("Not found")}const ee={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(ie).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(ee["Set-Cookie"]=I.serialize(d.$Te,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),W.writeHead(200,ee),void W.end(ie)}o(ae){const W=/<script>([\s\S]+?)<\/script>/img,te=[];let ue;for(;ue=W.exec(ae);){const Z=P.createHash("sha256"),he=ue[1].replace(/\r\n/g,`
`),V=Z.update(Buffer.from(he)).digest().toString("base64");te.push(`'sha256-${V}'`)}return te}async p(ae){const W=d.$1e.asFileUri("vs/code/browser/workbench/callback.html").fsPath,te=(await R.Promises.readFile(W)).toString(),ue=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(te).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return ae.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":ue}),void ae.end(te)}};e.$lN=k,e.$lN=k=Le([Ie(1,w.$4l),Ie(2,E.$Ri),Ie(3,u.$Bo),Ie(4,c.$0i)],k);const D=(x,ae=!1)=>x.replace(/\/\/+/g,"/").replace(/\/+$/,ae?"/":"");e.$mN=D;const C=x=>{const ae=(x.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$mN)("./"+(ae>1?"../".repeat(ae-1):""))};e.$nN=C;const L=x=>{const ae=x.split("?",1)[0].split("/");return(0,e.$mN)("./"+ae[ae.length-1])};e.$oN=L;const U=x=>x.originalUrl||x.url;e.$pN=U}),define(we[266],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=void 0,e.$3L=(0,v.$ph)("IExtHostInitDataService")}),define(we[267],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=e.$ML=void 0,e.$ML=(0,v.$ph)("IExtHostRpcService");class R{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.dispose=S.dispose.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.$NL=R}),define(we[70],be([1,0,51]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;function R(S){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:S,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function r(S){return new v.$pm(R(S))}e.$ir=r}),define(we[268],be([1,0,3,41,4,70,51,105,239,7,19]),function(le,e,v,R,r,S,I,P,b,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class E{constructor(l,d,m,c){this.b=l,this.c=d,this.d=m,this.e=c}async call(l,d,m){switch(d){case"getEnvironmentData":{const c=m,u=(0,S.$ir)(c.remoteAuthority);let h=await this.f(c.profile);return h=(0,I.$rm)(h,u),h}case"getExtensionHostExitInfo":{const c=m;return this.e.getExitInfo(c.reconnectionToken)}case"getDiagnosticInfo":{const c=m,u={machineInfo:(0,b.$mr)()},h=c.includeProcesses?(0,P.$kr)(process.pid):Promise.resolve();let g=[];const y={};if(c.folders){const p=(0,S.$ir)("");g=c.folders.map(i=>r.URI.revive(p.transformIncoming(i))).filter(i=>i.scheme==="file").map(i=>(0,b.$lr)(i.fsPath,["node_modules",".git"]).then(a=>{y[(0,$.$_c)(i.fsPath)]=a}))}return Promise.all([h,...g]).then(([p,t])=>(u.processes=p||void 0,u.workspaceMetadata=c.folders?y:void 0,u))}}throw new Error(`IPC Command ${d} not found`)}listen(l,d,m){throw new Error("Not supported")}async f(l){return l&&!this.d.profiles.some(d=>d.id===l)&&await this.d.createProfile(l,l),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:r.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,A.$9f)(this.c.logsHome,`exthost${E.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:v.OS,arch:process.arch,marks:R.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(d=>({...d}))}}}}e.$pr=E,E.a=1}),define(we[269],be([1,0,4,70,68,7,224]),function(le,e,v,R,r,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class P extends I.$qr{constructor(A,E){super(new r.$Up(A),A),this.H=E,this.G=new Map,this.B(this.a)}c(A){let E=this.G.get(A.remoteAuthority);return E||(E=(0,R.$ir)(A.remoteAuthority),this.G.set(A.remoteAuthority,E)),E}f(A,E,w=!1){if(w&&E.path==="/vscode-resource"&&E.query){const l=JSON.parse(E.query).requestResourcePath;return v.URI.from({scheme:"file",path:l})}return v.URI.revive(A.transformIncoming(E))}F(A,E){return new b(A,E,this.b,this.H)}}e.$sr=P;class b extends I.$rr{constructor(A,E,w,l){super(A,E,w,l)}i(A){const E=A.args["file-watcher-polling"];if(E){const w=E.split(S.$fd),l=Number(w[0]);if(l>0)return{usePolling:w.length>1?w.slice(1):!0,pollingInterval:l}}}j(A){if(A.extensionsPath)return[S.$5c.join(A.extensionsPath,"**")]}}}),define(we[92],be([1,0,201,8,4,2,6,35,16,13,39,162,62]),function(le,e,v,R,r,S,I,P,b,$,A,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WE=e.$VE=e.$UE=e.EditorsOrder=e.$TE=e.CloseDirection=e.$SE=e.$RE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.EditorInputCapabilities=e.$IE=e.SaveReason=e.Verbosity=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=void 0,e.$wE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$xE={id:"default",displayName:(0,v.localize)(0,null),providerDisplayName:(0,v.localize)(1,null)},e.$yE="workbench.editor.sidebysideEditor",e.$zE="workbench.editors.textDiffEditor",e.$AE="workbench.editors.binaryResourceDiffEditor";var l;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(l||(e.EditorPaneSelectionChangeReason=l={}));var d;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function m(ne){const q=ne;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.$BE=m;function c(ne,q,X){for(const O of X.visibleEditorPanes)if(O.group.id===q&&ne.matches(O.input))return O.getViewState()}e.$CE=c;function u(ne){if(o(ne))return!1;const q=ne;return r.URI.isUri(q?.resource)}e.$DE=u;function h(ne){if(o(ne))return!1;const q=ne;return q?.original!==void 0&&q.modified!==void 0}e.$EE=h;function g(ne){if(o(ne)||h(ne))return!1;const q=ne;return q?.primary!==void 0&&q.secondary!==void 0}e.$FE=g;function y(ne){if(o(ne))return!1;const q=ne;return q?q.resource===void 0||q.resource.scheme===$.Schemas.untitled||q.forceUntitled===!0:!1}e.$GE=y;function p(ne){if(o(ne))return!1;const q=ne;return r.URI.isUri(q?.base?.resource)&&r.URI.isUri(q?.input1?.resource)&&r.URI.isUri(q?.input2?.resource)&&r.URI.isUri(q?.result?.resource)}e.$HE=p;var t;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var i;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class a{constructor(){this.a=new Map}registerSource(q,X){let O=this.a.get(q);return O||(O={source:q,label:X},this.a.set(q,O)),O.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$IE=new a;var s;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(s||(e.EditorInputCapabilities=s={}));class n extends S.$lb{}e.$JE=n;function o(ne){return ne instanceof n}e.$KE=o;function f(ne){const q=ne;return r.URI.isUri(q?.preferredResource)}function k(ne){const q=ne;return o(q?.primary)&&o(q?.secondary)}e.$LE=k;function D(ne){const q=ne;return o(q?.modified)&&o(q?.original)}e.$ME=D;function C(ne,q,X,O,N){return ge(O,[(0,E.$_h)({id:"workbench.action.openLargeFile",label:(0,v.localize)(2,null),run:()=>{const J={...X,limits:{size:Number.MAX_VALUE}};ne.openEditor(q,J)}}),(0,E.$_h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(3,null),run:()=>N.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$NE=C;function L(ne){return o(ne?.editor)}e.$OE=L;function U(ne){const q=ne;return L(ne)&&q?.group!==void 0}e.$PE=U;function x(ne){const q=ne;return typeof q?.groupId=="number"&&o(q.editor)}e.$QE=x;var ae;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(ae||(e.EditorCloseContext=ae={}));var W;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LOCKED=2]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=3]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=4]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=5]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=7]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=9]="EDITOR_PIN",ne[ne.EDITOR_STICKY=10]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=11]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(W||(e.GroupModelChangeKind=W={}));var te;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(te||(e.SideBySideEditor=te={}));class ue{getOriginalUri(q,X){if(!q)return;if(p(q))return e.$SE.getOriginalUri(q.result,X);if(X?.supportSideBySide){const{primary:N,secondary:J}=this.a(q);if(N&&J){if(X?.supportSideBySide===te.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:X.filterByScheme}),secondary:this.getOriginalUri(J,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===te.ANY)return this.getOriginalUri(N,{filterByScheme:X.filterByScheme})??this.getOriginalUri(J,{filterByScheme:X.filterByScheme});q=X.supportSideBySide===te.PRIMARY?N:J}}if(h(q)||g(q)||p(q))return;const O=f(q)?q.preferredResource:q.resource;return!O||!X||!X.filterByScheme?O:this.b(O,X.filterByScheme)}a(q){return k(q)||g(q)?{primary:q.primary,secondary:q.secondary}:D(q)||h(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,X){if(!q)return;if(p(q))return e.$SE.getCanonicalUri(q.result,X);if(X?.supportSideBySide){const{primary:N,secondary:J}=this.a(q);if(N&&J){if(X?.supportSideBySide===te.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:X.filterByScheme}),secondary:this.getCanonicalUri(J,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===te.ANY)return this.getCanonicalUri(N,{filterByScheme:X.filterByScheme})??this.getCanonicalUri(J,{filterByScheme:X.filterByScheme});q=X.supportSideBySide===te.PRIMARY?N:J}}if(h(q)||g(q)||p(q))return;const O=q.resource;return!O||!X||!X.filterByScheme?O:this.b(O,X.filterByScheme)}b(q,X){if(Array.isArray(X)){if(X.some(O=>q.scheme===O))return q}else if(X===q.scheme)return q}}var Z;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function he(ne,q,X,O){if(!ne.isSticky(q))return!1;switch(O.preventPinnedEditorClose){case"keyboardAndMouse":return X===Z.MOUSE||X===Z.KEYBOARD;case"mouse":return X===Z.MOUSE;case"keyboard":return X===Z.KEYBOARD}return!1}e.$RE=he,e.$SE=new ue;var V;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class se{constructor(){this.c=new Map,this.d=new Map}start(q){const X=this.a=q.get(I.$oh);for(const[O,N]of this.c)this.e(O,N,X);this.c.clear()}e(q,X,O){const N=O.createInstance(X);this.d.set(q,N)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,R.$te)(this.b)}registerEditorSerializer(q,X){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,X,this.a):this.c.set(q,X),(0,S.$jb)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}P.$Vm.add(e.$wE.EditorFactory,new se);async function K(ne,q,X){return!ne||!ne.length?[]:await Promise.all(ne.map(async O=>{const N=r.URI.revive(O.fileUri);if(!N){X.info("Cannot resolve the path because it is not valid.",O);return}if(!await q.canHandleResource(N)){X.info("Cannot resolve the path because it cannot be handled",O);return}let ie=O.exists,re=O.type;if(typeof ie!="boolean"||typeof re!="number")try{re=(await q.stat(N)).isDirectory?b.FileType.Directory:b.FileType.Unknown,ie=!0}catch(oe){X.error(oe),ie=!1}if(!ie&&O.openOnlyIfExists){X.info("Cannot resolve the path because it does not exist",O);return}if(re===b.FileType.Directory){X.info("Cannot resolve the path because it is a directory",O);return}const ee={...O.options,pinned:!0};return ie?{resource:N,options:ee}:{resource:N,options:ee,forceUntitled:!0}}))}e.$TE=K;var Y;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(Y||(e.EditorsOrder=Y={}));function H(ne){const q=ne;if(!q)return!1;const X=q;if(X.modified)return H(X.modified);const O=q;return!!(O.contributionsState&&O.viewState&&Array.isArray(O.cursorState))}e.$UE=H;function _(ne){return(0,A.$bi)(ne)}e.$VE=_;function ge(ne,q,X){const O=(0,A.$ci)(ne,q);return O.forceMessage=X?.forceMessage,O.forceSeverity=X?.forceSeverity,O.allowDialog=X?.allowDialog,O}e.$WE=ge}),define(we[131],be([1,0,15,76,47,58,13,7,3,66]),function(le,e,v,R,r,S,I,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UH=e.$TH=e.$SH=e.$RH=e.CellStatusbarAlignment=e.$QH=e.$PH=e.$OH=e.NotebookEditorPriority=e.$NH=e.$MH=e.$LH=e.$KH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$JH=e.$IH=e.$HH=e.$GH=e.CellKind=e.$FH=e.$EH=e.$DH=void 0,e.$DH="workbench.editor.notebook",e.$EH="workbench.editor.notebookTextDiffEditor",e.$FH="workbench.editor.interactive";var A;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(A||(e.CellKind=A={})),e.$GH=["application/json","application/javascript","text/html","image/svg+xml",S.$zr.latex,S.$zr.markdown,"image/png","image/jpeg",S.$zr.text],e.$HH=[S.$zr.latex,S.$zr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",S.$zr.text],e.$IH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$JH="_notAvailable";var E;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(E||(e.NotebookRunState=E={}));var w;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var l;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(l||(e.NotebookExecutionState=l={}));var d;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(d||(e.NotebookRendererMatch=d={}));var m;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var c;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var u;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var h;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(h||(e.CellEditType=h={}));var g;(function(Z){Z.scheme=I.Schemas.vscodeNotebookCell;const he=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${he.join("")}]+`),se=7;function K(q,X){const O=X.toString(se),J=`${O.length<he.length?he[O.length-1]:"z"}${O}s${(0,v.$Yc)(v.$Ec.fromString(q.scheme),!0,!0)}`;return q.with({scheme:Z.scheme,fragment:J})}Z.generate=K;function Y(q){if(q.scheme!==Z.scheme)return;const X=q.fragment.indexOf("s");if(X<0)return;const O=parseInt(q.fragment.substring(0,X).replace(V,""),se),N=(0,v.$Xc)(q.fragment.substring(X+1)).toString();if(!isNaN(O))return{handle:O,notebook:q.with({scheme:N,fragment:null})}}Z.parse=Y;function H(q,X){return q.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${X??""},${q.scheme!==I.Schemas.file?q.scheme:""}`})}Z.generateCellOutputUri=H;function _(q){if(q.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const X=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(q.fragment);if(!X)return;const O=X[1]&&X[1]!==""?X[1]:void 0,N=X[2];return{outputId:O,notebook:q.with({scheme:N||I.Schemas.file,fragment:null})}}Z.parseCellOutputUri=_;function ge(q,X,O){return Z.generate(q,X).with({scheme:O})}Z.generateCellPropertyUri=ge;function ne(q,X){if(q.scheme===X)return Z.parse(q.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=ne})(g||(e.CellUri=g={}));const y=Z=>b.$d?Z.replace(/\//g,"\\"):Z;class p{constructor(he=[],V=e.$GH){this.e=V,this.d=[...new Set(he)].map(se=>({pattern:se,matches:R.$ej(y(se))}))}sort(he){const V=new Map(r.Iterable.map(he,K=>[K,y(K)]));let se=[];for(const{matches:K}of this.d)for(const[Y,H]of V)if(K(H)){se.push(Y),V.delete(Y);break}return V.size&&(se=se.concat([...V.keys()].sort((K,Y)=>this.e.indexOf(K)-this.e.indexOf(Y)))),se}prioritize(he,V){const se=this.f(he);if(se===-1){this.d.unshift({pattern:he,matches:R.$ej(y(he))});return}const K=new Set(V.map(H=>this.f(H,se)));K.delete(-1);const Y=Array.from(K).sort();this.d.splice(se+1,0,...Y.map(H=>this.d[H]));for(let H=Y.length-1;H>=0;H--)this.d.splice(Y[H],1)}toArray(){return this.d.map(he=>he.pattern)}f(he,V=this.d.length){const se=y(he);for(let K=0;K<V;K++)if(this.d[K].matches(se))return K;return-1}}e.$KH=p;function t(Z,he,V,se=(K,Y)=>K===Y){const K=[];function Y(ge,ne,q){if(ne===0&&q.length===0)return;const X=K[K.length-1];X&&X.start+X.deleteCount===ge?(X.deleteCount+=ne,X.toInsert.push(...q)):K.push({start:ge,deleteCount:ne,toInsert:q})}let H=0,_=0;for(;;){if(H===Z.length){Y(H,0,he.slice(_));break}if(_===he.length){Y(H,Z.length-H,[]);break}const ge=Z[H],ne=he[_];if(se(ge,ne)){H+=1,_+=1;continue}V(ne)?(Y(H,1,[]),H+=1):(Y(H,0,[ne]),_+=1)}return K}e.$LH=t,e.$MH=new $.$Oi("notebookEditorCursorAtBoundary","none"),e.$NH=new $.$Oi("notebookEditorCursorAtLineBoundary","none");var i;(function(Z){Z.default="default",Z.option="option"})(i||(e.NotebookEditorPriority=i={}));function a(Z){const he=Z;return!!((typeof he.include=="string"||R.$fj(he.include))&&(typeof he.exclude=="string"||R.$fj(he.exclude)))}e.$OH=a;function s(Z,he,V){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(he)>=0||Z.viewType===he)return!0;if(Z.filenamePattern){const se=a(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,K=a(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(R.$dj(se,(0,P.$_c)(V.fsPath).toLowerCase()))return!(K&&R.$dj(K,(0,P.$_c)(V.fsPath).toLowerCase()))}return!1}e.$PH=s,e.$QH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var n;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(n||(e.CellStatusbarAlignment=n={}));class o{static create(he){return`${o.d}${he}`}static parse(he){if(he.startsWith(o.d))return he.substring(o.d.length)}}e.$RH=o,o.d="notebook/";function f(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}e.$SH=f;const k=new TextDecoder;function D(Z){const he=[];let V=!1;for(const H of Z)(he.length===0||V)&&(he.push(H),V=!0);let se=U(he);const K=v.$Ec.concat(he.map(H=>v.$Ec.wrap(H))),Y=ue(K);return se=se||Y.byteLength!==K.byteLength,{data:Y,didCompression:se}}e.$TH=D,e.$UH=`${String.fromCharCode(27)}[A`;const C=e.$UH.split("").map(Z=>Z.charCodeAt(0)),L=10;function U(Z){let he=!1;return Z.forEach((V,se)=>{if(se===0||V.length<e.$UH.length)return;const K=Z[se-1],Y=V.subarray(0,e.$UH.length);if(Y[0]===C[0]&&Y[1]===C[1]&&Y[2]===C[2]){const H=K.lastIndexOf(L);if(H===-1)return;he=!0,Z[se-1]=K.subarray(0,H),Z[se]=V.subarray(e.$UH.length)}}),he}function x(Z){let he=Z;do Z=he,he=Z.replace(/[^\n]\x08/gm,"");while(he.length<Z.length);return Z}function ae(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const he=Z.match(/^(.*)\r+/m)[1];let V=Z.match(/\r+(.*)$/m)[1];V=V+he.slice(V.length,he.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return Z}const W="\b".charCodeAt(0),te="\r".charCodeAt(0);function ue(Z){return!Z.buffer.includes(W)&&!Z.buffer.includes(te)?Z:v.$Ec.fromString(ae(x(k.decode(Z.buffer))))}});var Ft=this&&this.__classPrivateFieldSet||function(le,e,v,R,r){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!r)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?le!==e||!r:!e.has(le))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?r.call(le,v):r?r.value=v:e.set(le,v),v},it=this&&this.__classPrivateFieldGet||function(le,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?le!==e||!R:!e.has(le))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(le):R?R.value:e.get(le)};define(we[132],be([1,0,18,11,101,28,58,17,8,4,23,40,16,119,131]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d){"use strict";var m,c,u,h,g,y,p,t,i,a,s,n,o,f,k,D,C,L,U,x,ae,W,te,ue,Z,he;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$BL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.TestRunProfileKind=e.TestResultState=e.$iL=e.$hL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$gL=e.$fL=e.$eL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$dL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.ColorThemeKind=e.$0K=e.$9K=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$8K=e.DebugConsoleMode=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$2K=e.$1K=e.FileChangeType=e.$ZK=e.$YK=e.$XK=e.$WK=e.InlineCompletionTriggerKind=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.ConfigurationTarget=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$zK=e.ViewBadge=e.ProgressLocation=e.$yK=e.$xK=e.TaskScope=e.ShellQuoting=e.$wK=e.$vK=e.$uK=e.TaskPanelKind=e.TaskRevealKind=e.$tK=e.TerminalLocation=e.$sK=e.$rK=e.$qK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$pK=e.$oK=e.$nK=e.$mK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$lK=e.StatusBarAlignment=e.ViewColumn=e.$kK=e.$jK=e.$iK=e.$hK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$gK=e.$fK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.LanguageStatusSeverity=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.CodeActionTriggerKind=e.$5J=e.$4J=e.SymbolTag=e.SymbolKind=e.$3J=e.DocumentHighlightKind=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$XJ=e.$WJ=e.FileEditType=e.$VJ=e.$UJ=e.$TJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function V(T){return Object.assign(T,{apply:function(){const ce=arguments.length===1?[]:arguments[1];return Reflect.construct(T,ce,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(T,[]);{const[ce,...pe]=arguments;return Reflect.construct(T,pe,ce.constructor)}}})}var se;(function(T){T[T.Top=0]="Top",T[T.Bottom=1]="Bottom"})(se||(e.TerminalOutputAnchor=se={}));var K;(function(T){T[T.TerminalCommand=0]="TerminalCommand",T[T.Opener=1]="Opener",T[T.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let Y=i=class{static from(...M){let ce=M;return new i(function(){if(ce){for(const pe of ce)pe&&typeof pe.dispose=="function"&&pe.dispose();ce=void 0}})}constructor(M){m.set(this,void 0),Ft(this,m,M,"f")}dispose(){typeof it(this,m,"f")=="function"&&(it(this,m,"f").call(this),Ft(this,m,void 0,"f"))}};e.$MJ=Y,m=new WeakMap,e.$MJ=Y=i=Le([V],Y);let H=a=class{static Min(...M){if(M.length===0)throw new TypeError;let ce=M[0];for(let pe=1;pe<M.length;pe++){const je=M[pe];je.isBefore(ce)&&(ce=je)}return ce}static Max(...M){if(M.length===0)throw new TypeError;let ce=M[0];for(let pe=1;pe<M.length;pe++){const je=M[pe];je.isAfter(ce)&&(ce=je)}return ce}static isPosition(M){if(!M)return!1;if(M instanceof a)return!0;const{line:ce,character:pe}=M;return typeof ce=="number"&&typeof pe=="number"}static of(M){if(M instanceof a)return M;if(this.isPosition(M))return new a(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,ce){if(M<0)throw(0,R.$5)("line must be non-negative");if(ce<0)throw(0,R.$5)("character must be non-negative");this.c=M,this.e=ce}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,ce=0){if(M===null||ce===null)throw(0,R.$5)();let pe;return typeof M>"u"?pe=0:typeof M=="number"?pe=M:(pe=typeof M.lineDelta=="number"?M.lineDelta:0,ce=typeof M.characterDelta=="number"?M.characterDelta:0),pe===0&&ce===0?this:new a(this.line+pe,this.character+ce)}with(M,ce=this.character){if(M===null||ce===null)throw(0,R.$5)();let pe;return typeof M>"u"?pe=this.line:typeof M=="number"?pe=M:(pe=typeof M.line=="number"?M.line:this.line,ce=typeof M.character=="number"?M.character:this.character),pe===this.line&&ce===this.character?this:new a(pe,ce)}toJSON(){return{line:this.line,character:this.character}}};e.$NJ=H,e.$NJ=H=a=Le([V],H);let _=s=class{static isRange(M){return M instanceof s?!0:M?H.isPosition(M.start)&&H.isPosition(M.end):!1}static of(M){if(M instanceof s)return M;if(this.isRange(M))return new s(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,ce,pe,je){let Ke,_e;if(typeof M=="number"&&typeof ce=="number"&&typeof pe=="number"&&typeof je=="number"?(Ke=new H(M,ce),_e=new H(pe,je)):H.isPosition(M)&&H.isPosition(ce)&&(Ke=H.of(M),_e=H.of(ce)),!Ke||!_e)throw new Error("Invalid arguments");Ke.isBefore(_e)?(this.c=Ke,this.e=_e):(this.c=_e,this.e=Ke)}contains(M){return s.isRange(M)?this.contains(M.start)&&this.contains(M.end):H.isPosition(M)?!(H.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const ce=H.Max(M.start,this.c),pe=H.Min(M.end,this.e);if(!ce.isAfter(pe))return new s(ce,pe)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ce=H.Min(M.start,this.c),pe=H.Max(M.end,this.end);return new s(ce,pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,ce=this.end){if(M===null||ce===null)throw(0,R.$5)();let pe;return M?H.isPosition(M)?pe=M:(pe=M.start||this.start,ce=M.end||this.end):pe=this.start,pe.isEqual(this.c)&&ce.isEqual(this.end)?this:new s(pe,ce)}toJSON(){return[this.start,this.end]}};e.$OJ=_,e.$OJ=_=s=Le([V],_);let ge=n=class extends _{static isSelection(M){return M instanceof n?!0:M?_.isRange(M)&&H.isPosition(M.anchor)&&H.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,ce,pe,je){let Ke,_e;if(typeof M=="number"&&typeof ce=="number"&&typeof pe=="number"&&typeof je=="number"?(Ke=new H(M,ce),_e=new H(pe,je)):H.isPosition(M)&&H.isPosition(ce)&&(Ke=H.of(M),_e=H.of(ce)),!Ke||!_e)throw new Error("Invalid arguments");super(Ke,_e),this.f=Ke,this.g=_e}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$PJ=ge,e.$PJ=ge=n=Le([V],ge);const ne=T=>{if(typeof T!="string"||T.length===0||!/^[0-9A-Za-z_\-]+$/.test(T))throw(0,R.$5)("connectionToken")};class q{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ce,pe){if(typeof M!="string"||M.length===0)throw(0,R.$5)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,R.$5)("port");typeof pe<"u"&&ne(pe),this.host=M,this.port=Math.round(ce),this.connectionToken=pe}}e.$QJ=q;class X{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ce){this.makeConnection=M,this.connectionToken=ce,typeof ce<"u"&&ne(ce)}}e.$RJ=X;class O extends Error{static NotAvailable(M,ce){return new O(M,l.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(M){return new O(M,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,ce=l.RemoteAuthorityResolverErrorCode.Unknown,pe){super(M),this._message=M,this._code=ce,this._detail=pe,Object.setPrototypeOf(this,O.prototype)}}e.$SJ=O;var N;(function(T){T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(N||(e.EndOfLine=N={}));var J;(function(T){T[T.Replace=1]="Replace",T[T.Append=2]="Append",T[T.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let ie=o=class{static isTextEdit(M){return M instanceof o?!0:M?_.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ce){return new o(M,ce)}static insert(M,ce){return o.replace(new _(M,M),ce)}static delete(M){return o.replace(M,"")}static setEndOfLine(M){const ce=new o(new _(new H(0,0),new H(0,0)),"");return ce.newEol=M,ce}get range(){return this.c}set range(M){if(M&&!_.isRange(M))throw(0,R.$5)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,R.$5)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,R.$5)("newEol");this.f=M}constructor(M,ce){this.c=M,this.e=ce}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$TJ=ie,e.$TJ=ie=o=Le([V],ie);let re=f=class{static isNotebookCellEdit(M){return M instanceof f?!0:M?Ut.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,ce){return new f(M,ce)}static insertCells(M,ce){return new f(new Ut(M,M),ce)}static deleteCells(M){return new f(M,[])}static updateCellMetadata(M,ce){const pe=new f(new Ut(M,M),[]);return pe.newCellMetadata=ce,pe}static updateNotebookMetadata(M){const ce=new f(new Ut(0,0),[]);return ce.newNotebookMetadata=M,ce}constructor(M,ce){this.range=M,this.newCells=ce}};e.$UJ=re,e.$UJ=re=f=Le([V],re);class ee{static isSnippetTextEdit(M){return M instanceof ee?!0:M?_.isRange(M.range)&&z.isSnippetString(M.snippet):!1}static replace(M,ce){return new ee(M,ce)}static insert(M,ce){return ee.replace(new _(M,M),ce)}constructor(M,ce){this.range=M,this.snippet=ce}}e.$VJ=ee;var oe;(function(T){T[T.File=1]="File",T[T.Text=2]="Text",T[T.Cell=3]="Cell",T[T.CellReplace=5]="CellReplace",T[T.Snippet=6]="Snippet"})(oe||(e.FileEditType=oe={}));let F=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,ce,pe,je){this.c.push({_type:1,from:M,to:ce,options:pe,metadata:je})}createFile(M,ce,pe){this.c.push({_type:1,from:void 0,to:M,options:ce,metadata:pe})}deleteFile(M,ce,pe){this.c.push({_type:1,from:M,to:void 0,options:ce,metadata:pe})}e(M,ce,pe){this.c.push({_type:3,metadata:pe,uri:M,edit:{editType:5,metadata:ce},notebookMetadata:ce})}f(M,ce,pe,je){const Ke=ce.start,_e=ce.end;(Ke!==_e||pe.length>0)&&this.c.push({_type:5,uri:M,index:Ke,count:_e-Ke,cells:pe,metadata:je})}g(M,ce,pe,je){this.c.push({_type:3,metadata:je,uri:M,edit:{editType:3,index:ce,metadata:pe}})}replace(M,ce,pe,je){this.c.push({_type:2,uri:M,edit:new ie(ce,pe),metadata:je})}insert(M,ce,pe,je){this.replace(M,new _(ce,ce),pe,je)}delete(M,ce,pe){this.replace(M,ce,"",pe)}has(M){return this.c.some(ce=>ce._type===2&&ce.uri.toString()===M.toString())}set(M,ce){if(ce)for(const pe of ce){if(!pe)continue;let je,Ke;Array.isArray(pe)?(je=pe[0],Ke=pe[1]):je=pe,re.isNotebookCellEdit(je)?je.newCellMetadata?this.g(M,je.range.start,je.newCellMetadata,Ke):je.newNotebookMetadata?this.e(M,je.newNotebookMetadata,Ke):this.f(M,je.range,je.newCells,Ke):ee.isSnippetTextEdit(je)?this.c.push({_type:6,uri:M,range:je.range,edit:je.snippet,metadata:Ke}):this.c.push({_type:2,uri:M,edit:je,metadata:Ke})}else{for(let pe=0;pe<this.c.length;pe++){const je=this.c[pe];switch(je._type){case 2:case 6:case 3:case 5:je.uri.toString()===M.toString()&&(this.c[pe]=void 0);break}}(0,v.$kf)(this.c)}}get(M){const ce=[];for(const pe of this.c)pe._type===2&&pe.uri.toString()===M.toString()&&ce.push(pe.edit);return ce}entries(){const M=new S.$ni;for(const ce of this.c)if(ce._type===2){let pe=M.get(ce.uri);pe||(pe=[ce.uri,[]],M.set(ce.uri,pe)),pe[1].push(ce.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$WJ=F,e.$WJ=F=Le([V],F);let z=k=class{static isSnippetString(M){return M instanceof k?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=k.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ce=this.e++){if(typeof M=="function"){const pe=new k;pe.e=this.e,M(pe),this.e=pe.e,M=pe.value}else M=k.c(M);return this.value+="${",this.value+=ce,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ce=this.e++){const pe=M.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=pe,this.value+="|}",this}appendVariable(M,ce){if(typeof ce=="function"){const pe=new k;pe.e=this.e,ce(pe),this.e=pe.e,ce=pe.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};e.$XJ=z,e.$XJ=z=k=Le([V],z);var j;(function(T){T[T.Unnecessary=1]="Unnecessary",T[T.Deprecated=2]="Deprecated"})(j||(e.DiagnosticTag=j={}));var B;(function(T){T[T.Hint=3]="Hint",T[T.Information=2]="Information",T[T.Warning=1]="Warning",T[T.Error=0]="Error"})(B||(e.DiagnosticSeverity=B={}));let Q=D=class{static isLocation(M){return M instanceof D?!0:M?_.isRange(M.range)&&$.URI.isUri(M.uri):!1}constructor(M,ce){if(this.uri=M,ce)if(_.isRange(ce))this.range=_.of(ce);else if(H.isPosition(ce))this.range=new _(ce,ce);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$YJ=Q,e.$YJ=Q=D=Le([V],Q);let de=class{static is(M){return M?typeof M.message=="string"&&M.location&&_.isRange(M.location.range)&&$.URI.isUri(M.location.uri):!1}constructor(M,ce){this.location=M,this.message=ce}static isEqual(M,ce){return M===ce?!0:!M||!ce?!1:M.message===ce.message&&M.location.range.isEqual(ce.location.range)&&M.location.uri.toString()===ce.location.uri.toString()}};e.$ZJ=de,e.$ZJ=de=Le([V],de);let Ee=class{constructor(M,ce,pe=B.Error){if(!_.isRange(M))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=M,this.message=ce,this.severity=pe}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ce){return M===ce?!0:!M||!ce?!1:M.message===ce.message&&M.severity===ce.severity&&M.code===ce.code&&M.severity===ce.severity&&M.source===ce.source&&M.range.isEqual(ce.range)&&(0,v.$$e)(M.tags,ce.tags)&&(0,v.$$e)(M.relatedInformation,ce.relatedInformation,de.isEqual)}};e.$1J=Ee,e.$1J=Ee=Le([V],Ee);let Pe=class{constructor(M,ce){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ce}};e.$2J=Pe,e.$2J=Pe=Le([V],Pe);var Re;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(Re||(e.DocumentHighlightKind=Re={}));let Fe=class{constructor(M,ce=Re.Text){this.range=M,this.kind=ce}toJSON(){return{range:this.range,kind:Re[this.kind]}}};e.$3J=Fe,e.$3J=Fe=Le([V],Fe);var $e;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})($e||(e.SymbolKind=$e={}));var ke;(function(T){T[T.Deprecated=1]="Deprecated"})(ke||(e.SymbolTag=ke={}));let ye=C=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,ce,pe,je,Ke){this.name=M,this.kind=ce,this.containerName=Ke,typeof pe=="string"&&(this.containerName=pe),je instanceof Q?this.location=je:pe instanceof _&&(this.location=new Q(je,pe)),C.validate(this)}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};e.$4J=ye,e.$4J=ye=C=Le([V],ye);let Te=L=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(L.validate)}constructor(M,ce,pe,je,Ke){this.name=M,this.detail=ce,this.kind=pe,this.range=je,this.selectionRange=Ke,this.children=[],L.validate(this)}};e.$5J=Te,e.$5J=Te=L=Le([V],Te);var ze;(function(T){T[T.Invoke=1]="Invoke",T[T.Automatic=2]="Automatic"})(ze||(e.CodeActionTriggerKind=ze={}));let xe=class{constructor(M,ce){this.title=M,this.kind=ce}};e.$6J=xe,e.$6J=xe=Le([V],xe);let qe=U=class{constructor(M){this.value=M}append(M){return new U(this.value?this.value+U.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+U.c)}};e.$7J=qe,qe.c=".",e.$7J=qe=U=Le([V],qe);class Ze extends qe{constructor(M){super(M),this.value=M}}e.$8J=Ze,qe.Empty=new qe(""),qe.QuickFix=qe.Empty.append("quickfix"),qe.Refactor=qe.Empty.append("refactor"),qe.RefactorExtract=qe.Refactor.append("extract"),qe.RefactorInline=qe.Refactor.append("inline"),qe.RefactorMove=qe.Refactor.append("move"),qe.RefactorRewrite=qe.Refactor.append("rewrite"),qe.Source=qe.Empty.append("source"),qe.SourceOrganizeImports=qe.Source.append("organizeImports"),qe.SourceFixAll=qe.Source.append("fixAll"),qe.Notebook=qe.Empty.append("notebook");let Ye=class{constructor(M,ce){if(this.range=M,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$9J=Ye,e.$9J=Ye=Le([V],Ye);class tt{constructor(M,ce,pe,je,Ke,_e){this.kind=M,this.name=ce,this.detail=pe,this.uri=je,this.range=Ke,this.selectionRange=_e}}e.$0J=tt;class me{constructor(M,ce){this.fromRanges=ce,this.from=M}}e.$$J=me;class De{constructor(M,ce){this.fromRanges=ce,this.to=M}}e.$_J=De;var Ae;(function(T){T[T.Information=0]="Information",T[T.Warning=1]="Warning",T[T.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let Ne=class{constructor(M,ce){this.range=M,this.command=ce}get isResolved(){return!!this.command}};e.$aK=Ne,e.$aK=Ne=Le([V],Ne);let Be=x=class{static isMarkdownString(M){return M instanceof x?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,ce=!1){c.set(this,void 0),Ft(this,c,new r.$Kj(M,{supportThemeIcons:ce}),"f")}get value(){return it(this,c,"f").value}set value(M){it(this,c,"f").value=M}get isTrusted(){return it(this,c,"f").isTrusted}set isTrusted(M){it(this,c,"f").isTrusted=M}get supportThemeIcons(){return it(this,c,"f").supportThemeIcons}set supportThemeIcons(M){it(this,c,"f").supportThemeIcons=M}get supportHtml(){return it(this,c,"f").supportHtml}set supportHtml(M){it(this,c,"f").supportHtml=M}get baseUri(){return it(this,c,"f").baseUri}set baseUri(M){it(this,c,"f").baseUri=M}appendText(M){return it(this,c,"f").appendText(M),this}appendMarkdown(M){return it(this,c,"f").appendMarkdown(M),this}appendCodeblock(M,ce){return it(this,c,"f").appendCodeblock(ce??"",M),this}};e.$bK=Be,c=new WeakMap,e.$bK=Be=x=Le([V],Be);let Me=class{constructor(M,ce){this.label=M,this.documentation=ce}};e.$cK=Me,e.$cK=Me=Le([V],Me);let He=class{constructor(M,ce){this.label=M,this.documentation=ce,this.parameters=[]}};e.$dK=He,e.$dK=He=Le([V],He);let Ge=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$eK=Ge,e.$eK=Ge=Le([V],Ge);var Je;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(Je||(e.SignatureHelpTriggerKind=Je={}));var Ve;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(Ve||(e.InlayHintKind=Ve={}));let et=class{constructor(M){this.value=M}};e.$fK=et,e.$fK=et=Le([V],et);let Xe=class{constructor(M,ce,pe){this.position=M,this.label=ce,this.kind=pe}};e.$gK=Xe,e.$gK=Xe=Le([V],Xe);var ot;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ot||(e.CompletionTriggerKind=ot={}));var ft;(function(T){T[T.Text=0]="Text",T[T.Method=1]="Method",T[T.Function=2]="Function",T[T.Constructor=3]="Constructor",T[T.Field=4]="Field",T[T.Variable=5]="Variable",T[T.Class=6]="Class",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Unit=10]="Unit",T[T.Value=11]="Value",T[T.Enum=12]="Enum",T[T.Keyword=13]="Keyword",T[T.Snippet=14]="Snippet",T[T.Color=15]="Color",T[T.File=16]="File",T[T.Reference=17]="Reference",T[T.Folder=18]="Folder",T[T.EnumMember=19]="EnumMember",T[T.Constant=20]="Constant",T[T.Struct=21]="Struct",T[T.Event=22]="Event",T[T.Operator=23]="Operator",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue"})(ft||(e.CompletionItemKind=ft={}));var rt;(function(T){T[T.Deprecated=1]="Deprecated"})(rt||(e.CompletionItemTag=rt={}));let Mt=class{constructor(M,ce){this.label=M,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$hK=Mt,e.$hK=Mt=Le([V],Mt);let $t=class{constructor(M=[],ce=!1){this.items=M,this.isIncomplete=ce}};e.$iK=$t,e.$iK=$t=Le([V],$t);let Ct=class{constructor(M,ce,pe){this.insertText=M,this.range=ce,this.command=pe}};e.$jK=Ct,e.$jK=Ct=Le([V],Ct);let mt=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.$kK=mt,e.$kK=mt=Le([V],mt);var wt;(function(T){T[T.Active=-1]="Active",T[T.Beside=-2]="Beside",T[T.One=1]="One",T[T.Two=2]="Two",T[T.Three=3]="Three",T[T.Four=4]="Four",T[T.Five=5]="Five",T[T.Six=6]="Six",T[T.Seven=7]="Seven",T[T.Eight=8]="Eight",T[T.Nine=9]="Nine"})(wt||(e.ViewColumn=wt={}));var vt;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Tt(T,M){return`${E.$Jl.toKey(T)}.${M}`}e.$lK=Tt;var Pt;(function(T){T[T.Off=0]="Off",T[T.On=1]="On",T[T.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Et;(function(T){T[T.Manual=1]="Manual",T[T.AfterDelay=2]="AfterDelay",T[T.FocusOut=3]="FocusOut"})(Et||(e.TextDocumentSaveReason=Et={}));var jt;(function(T){T[T.Default=0]="Default",T[T.InCenter=1]="InCenter",T[T.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",T[T.AtTop=3]="AtTop"})(jt||(e.TextEditorRevealType=jt={}));var It;(function(T){T[T.Keyboard=1]="Keyboard",T[T.Mouse=2]="Mouse",T[T.Command=3]="Command"})(It||(e.TextEditorSelectionChangeKind=It={}));var bt;(function(T){T[T.Undo=1]="Undo",T[T.Redo=2]="Redo"})(bt||(e.TextDocumentChangeReason=bt={}));var At;(function(T){T[T.OpenOpen=0]="OpenOpen",T[T.ClosedClosed=1]="ClosedClosed",T[T.OpenClosed=2]="OpenClosed",T[T.ClosedOpen=3]="ClosedOpen"})(At||(e.DecorationRangeBehavior=At={})),function(T){function M(ce){switch(ce){case"keyboard":return T.Keyboard;case"mouse":return T.Mouse;case"api":return T.Command}}T.fromValue=M}(It||(e.TextEditorSelectionChangeKind=It={}));let Lt=class{constructor(M,ce){if(ce&&!$.URI.isUri(ce))throw(0,R.$5)("target");if(!_.isRange(M)||M.isEmpty)throw(0,R.$5)("range");this.range=M,this.target=ce}};e.$mK=Lt,e.$mK=Lt=Le([V],Lt);let st=class{constructor(M,ce,pe,je){this.red=M,this.green=ce,this.blue=pe,this.alpha=je}};e.$nK=st,e.$nK=st=Le([V],st);let pt=class{constructor(M,ce){if(ce&&!(ce instanceof st))throw(0,R.$5)("color");if(!_.isRange(M)||M.isEmpty)throw(0,R.$5)("range");this.range=M,this.color=ce}};e.$oK=pt,e.$oK=pt=Le([V],pt);let gt=class{constructor(M){if(!M||typeof M!="string")throw(0,R.$5)("label");this.label=M}};e.$pK=gt,e.$pK=gt=Le([V],gt);var ut;(function(T){T[T.RGB=0]="RGB",T[T.HEX=1]="HEX",T[T.HSL=2]="HSL"})(ut||(e.ColorFormat=ut={}));var zt;(function(T){T[T.Error=0]="Error",T[T.Warning=1]="Warning",T[T.Information=2]="Information"})(zt||(e.SourceControlInputBoxValidationType=zt={}));var Rt;(function(T){T[T.Unknown=0]="Unknown",T[T.Shutdown=1]="Shutdown",T[T.Process=2]="Process",T[T.User=3]="User",T[T.Extension=4]="Extension"})(Rt||(e.TerminalExitReason=Rt={}));class Bt{constructor(M,ce,pe){if(this.startIndex=M,this.length=ce,this.tooltip=pe,typeof M!="number"||M<0)throw(0,R.$5)("startIndex");if(typeof ce!="number"||ce<1)throw(0,R.$5)("length");if(pe!==void 0&&typeof pe!="string")throw(0,R.$5)("tooltip")}}e.$qK=Bt;class ve{constructor(M){this.uri=M}}e.$rK=ve;class Se{constructor(M){this.terminalCommand=M}}e.$sK=Se;var fe;(function(T){T[T.Panel=1]="Panel",T[T.Editor=2]="Editor"})(fe||(e.TerminalLocation=fe={}));class G{constructor(M){if(this.options=M,typeof M!="object")throw(0,R.$5)("options")}}e.$tK=G;var Ce;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(Ce||(e.TaskRevealKind=Ce={}));var Oe;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(Oe||(e.TaskPanelKind=Oe={}));let We=ae=class{static from(M){switch(M){case"clean":return ae.Clean;case"build":return ae.Build;case"rebuild":return ae.Rebuild;case"test":return ae.Test;default:return}}constructor(M,ce){if(this.label=ce,typeof M!="string"||typeof ce!="string")throw(0,R.$5)("name");this.c=M}get id(){return this.c}};e.$uK=We,We.Clean=new ae("clean","Clean"),We.Build=new ae("build","Build"),We.Rebuild=new ae("rebuild","Rebuild"),We.Test=new ae("test","Test"),e.$uK=We=ae=Le([V],We);function Ue(T){let M="";for(let ce=0;ce<T.length;ce++)M+=T[ce].replace(/,/g,",,")+",";return M}let Qe=class{constructor(M,ce,pe){if(typeof M!="string")throw(0,R.$5)("process");this.e=[],this.c=M,ce!==void 0&&(Array.isArray(ce)?(this.e=ce,this.f=pe):this.f=ce)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,R.$5)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const ce of this.e)M.push(ce);return Ue(M)}};e.$vK=Qe,e.$vK=Qe=Le([V],Qe);let at=class{constructor(M,ce,pe){if(this.f=[],Array.isArray(ce)){if(!M)throw(0,R.$5)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,R.$5)("command");this.e=M,this.f=ce,this.g=pe}else{if(typeof M!="string")throw(0,R.$5)("commandLine");this.c=M,this.g=ce}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,R.$5)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,R.$5)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ce of this.f)M.push(typeof ce=="string"?ce:ce.value);return Ue(M)}};e.$wK=at,e.$wK=at=Le([V],at);var kt;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(kt||(e.ShellQuoting=kt={}));var dt;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace"})(dt||(e.TaskScope=dt={}));class ct{constructor(M){this.c=M}computeId(){return"customExecution"+(0,A.$3e)()}set callback(M){this.c=M}get callback(){return this.c}}e.$xK=ct;let lt=W=class{constructor(M,ce,pe,je,Ke,_e){this.j=!1,this.k=this.definition=M;let nt;typeof ce=="string"?(this.m=this.name=ce,this.t=this.source=pe,this.execution=je,nt=Ke,this.j=!0):ce===dt.Global||ce===dt.Workspace?(this.target=ce,this.m=this.name=pe,this.t=this.source=je,this.execution=Ke,nt=_e):(this.target=ce,this.m=this.name=pe,this.t=this.source=je,this.execution=Ke,nt=_e),typeof nt=="string"?(this.o=[nt],this.q=!0):Array.isArray(nt)?(this.o=nt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(M){this.h=M}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Qe?this.k={type:W.e,id:this.n.computeId()}:this.n instanceof at?this.k={type:W.f,id:this.n.computeId()}:this.n instanceof ct?this.k={type:W.c,id:this.n.computeId()}:this.k={type:W.g,id:(0,A.$3e)()}}get definition(){return this.k}set definition(M){if(M==null)throw(0,R.$5)("Kind can't be undefined or null");this.y(),this.k=M}get scope(){return this.l}set target(M){this.y(),this.l=M}get name(){return this.m}set name(M){if(typeof M!="string")throw(0,R.$5)("name");this.y(),this.m=M}get execution(){return this.n}set execution(M){M===null&&(M=void 0),this.y(),this.n=M;const ce=this.k.type;(W.g===ce||W.e===ce||W.f===ce||W.c===ce)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(M){if(Array.isArray(M))this.y(),this.o=M,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.y(),this.r=M}get source(){return this.t}set source(M){if(typeof M!="string"||M.length===0)throw(0,R.$5)("source must be a string of length > 0");this.y(),this.t=M}get group(){return this.u}set group(M){M===null&&(M=void 0),this.y(),this.u=M}get detail(){return this.x}set detail(M){M===null&&(M=void 0),this.x=M}get presentationOptions(){return this.v}set presentationOptions(M){M==null&&(M=Object.create(null)),this.y(),this.v=M}get runOptions(){return this.w}set runOptions(M){M==null&&(M=Object.create(null)),this.y(),this.w=M}};e.$yK=lt,lt.c="customExecution",lt.e="process",lt.f="shell",lt.g="$empty",e.$yK=lt=W=Le([V],lt);var Rn;(function(T){T[T.SourceControl=1]="SourceControl",T[T.Window=10]="Window",T[T.Notification=15]="Notification"})(Rn||(e.ProgressLocation=Rn={}));var On;(function(T){function M(ce){const pe=ce;return(0,b.$me)(pe.value)?pe.tooltip&&!(0,b.$ie)(pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",pe.value),!1)}T.isViewBadge=M})(On||(e.ViewBadge=On={}));let Qt=te=class{static isTreeItem(M,ce){const pe=M;if(pe.checkboxState!==void 0){const je=(0,b.$me)(pe.checkboxState)?pe.checkboxState:(0,b.$ke)(pe.checkboxState)&&(0,b.$me)(pe.checkboxState.state)?pe.checkboxState.state:void 0,Ke=!(0,b.$me)(pe.checkboxState)&&(0,b.$ke)(pe.checkboxState)?pe.checkboxState.tooltip:void 0;if(je===void 0||je!==Jt.Checked&&je!==Jt.Unchecked||Ke!==void 0&&!(0,b.$ie)(Ke))return console.log("INVALID tree item, invalid checkboxState",pe.checkboxState),!1}if(M instanceof te)return!0;if(pe.label!==void 0&&!(0,b.$ie)(pe.label)&&!pe.label?.label)return console.log("INVALID tree item, invalid label",pe.label),!1;if(pe.id!==void 0&&!(0,b.$ie)(pe.id))return console.log("INVALID tree item, invalid id",pe.id),!1;if(pe.iconPath!==void 0&&!(0,b.$ie)(pe.iconPath)&&!$.URI.isUri(pe.iconPath)&&(!pe.iconPath||!(0,b.$ie)(pe.iconPath.id))){const je=pe.iconPath;if(!je||!(0,b.$ie)(je.light)&&!$.URI.isUri(je.light)&&!(0,b.$ie)(je.dark)&&!$.URI.isUri(je.dark))return console.log("INVALID tree item, invalid iconPath",pe.iconPath),!1}return pe.description!==void 0&&!(0,b.$ie)(pe.description)&&typeof pe.description!="boolean"?(console.log("INVALID tree item, invalid description",pe.description),!1):pe.resourceUri!==void 0&&!$.URI.isUri(pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",pe.resourceUri),!1):pe.tooltip!==void 0&&!(0,b.$ie)(pe.tooltip)&&!(pe.tooltip instanceof Be)?(console.log("INVALID tree item, invalid tooltip",pe.tooltip),!1):pe.command!==void 0&&!pe.command.command?(console.log("INVALID tree item, invalid command",pe.command),!1):pe.collapsibleState!==void 0&&pe.collapsibleState<Wt.None&&pe.collapsibleState>Wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",pe.collapsibleState),!1):pe.contextValue!==void 0&&!(0,b.$ie)(pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",pe.contextValue),!1):pe.accessibilityInformation!==void 0&&!pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",pe.accessibilityInformation),!1):!0}constructor(M,ce=Wt.None){this.collapsibleState=ce,$.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.$zK=Qt,e.$zK=Qt=te=Le([V],Qt);var Wt;(function(T){T[T.None=0]="None",T[T.Collapsed=1]="Collapsed",T[T.Expanded=2]="Expanded"})(Wt||(e.TreeItemCollapsibleState=Wt={}));var Jt;(function(T){T[T.Unchecked=0]="Unchecked",T[T.Checked=1]="Checked"})(Jt||(e.TreeItemCheckboxState=Jt={}));let Gt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.$AK=Gt,e.$AK=Gt=Le([V],Gt);class Nn extends Gt{}e.$BK=Nn;class $i extends Nn{constructor(M){super(""),u.set(this,void 0),Ft(this,u,M,"f")}asFile(){return it(this,u,"f")}}e.$CK=$i,u=new WeakMap;class wi{constructor(M,ce,pe,je){this.name=M,this.uri=ce,this._itemId=pe,this.c=je}data(){return this.c()}}e.$DK=wi;let xt=class{constructor(M){h.add(this),g.set(this,new Map);for(const[ce,pe]of M??[]){const je=it(this,g,"f").get(it(this,h,"m",y).call(this,ce));je?je.push(pe):it(this,g,"f").set(it(this,h,"m",y).call(this,ce),[pe])}}get(M){return it(this,g,"f").get(it(this,h,"m",y).call(this,M))?.[0]}set(M,ce){it(this,g,"f").set(it(this,h,"m",y).call(this,M),[ce])}forEach(M,ce){for(const[pe,je]of it(this,g,"f"))for(const Ke of je)M.call(ce,Ke,pe,this)}*[(g=new WeakMap,h=new WeakSet,Symbol.iterator)](){for(const[M,ce]of it(this,g,"f"))for(const pe of ce)yield[M,pe]}};e.$EK=xt,y=function(M){return M.toLowerCase()},e.$EK=xt=Le([V],xt);let _t=class{constructor(M){this.insertText=M}};e.$FK=_t,e.$FK=_t=Le([V],_t);let en=class{constructor(M,ce){this.label=ce,this.insertText=M}};e.$GK=en,e.$GK=en=Le([V],en);let Ot=class{constructor(M,ce){this.id=M,this.color=ce}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.$HK=Ot,e.$HK=Ot=Le([V],Ot),Ot.File=new Ot("file"),Ot.Folder=new Ot("folder");let tn=class{constructor(M){this.id=M}};e.$IK=tn,e.$IK=tn=Le([V],tn);var Fn;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.WorkspaceFolder=3]="WorkspaceFolder"})(Fn||(e.ConfigurationTarget=Fn={}));let nn=class{get base(){return this.c}set base(M){this.c=M,this.e=$.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,ce){if(typeof M!="string"&&(!M||!$.URI.isUri(M)&&!$.URI.isUri(M.uri)))throw(0,R.$5)("base");if(typeof ce!="string")throw(0,R.$5)("pattern");typeof M=="string"?this.baseUri=$.URI.file(M):$.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=ce}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$JK=nn,e.$JK=nn=Le([V],nn);const Mn=new WeakMap;function bi(T,M){Mn.set(T,M)}e.$KK=bi;let qt=class{constructor(M,ce,pe,je){this.enabled=typeof M=="boolean"?M:!0,typeof ce=="string"&&(this.condition=ce),typeof pe=="string"&&(this.hitCondition=pe),typeof je=="string"&&(this.logMessage=je)}get id(){return this.c||(this.c=Mn.get(this)??(0,A.$3e)()),this.c}};e.$LK=qt,e.$LK=qt=Le([V],qt);let sn=class extends qt{constructor(M,ce,pe,je,Ke){if(super(ce,pe,je,Ke),M===null)throw(0,R.$5)("location");this.location=M}};e.$MK=sn,e.$MK=sn=Le([V],sn);let rn=class extends qt{constructor(M,ce,pe,je,Ke){super(ce,pe,je,Ke),this.functionName=M}};e.$NK=rn,e.$NK=rn=Le([V],rn);let on=class extends qt{constructor(M,ce,pe,je,Ke,_e,nt){if(super(je,Ke,_e,nt),!ce)throw(0,R.$5)("dataId");this.label=M,this.dataId=ce,this.canPersist=pe}};e.$OK=on,e.$OK=on=Le([V],on);let an=class{constructor(M,ce,pe){this.command=M,this.args=ce||[],this.options=pe}};e.$PK=an,e.$PK=an=Le([V],an);let cn=class{constructor(M,ce){this.port=M,this.host=ce}};e.$QK=cn,e.$QK=cn=Le([V],cn);let ln=class{constructor(M){this.path=M}};e.$RK=ln,e.$RK=ln=Le([V],ln);let un=class{constructor(M){this.implementation=M}};e.$SK=un,e.$SK=un=Le([V],un);let hn=class{constructor(M,ce,pe){this.session=M,this.threadId=ce,this.frameId=pe}};e.$TK=hn,e.$TK=hn=Le([V],hn);let fn=class{constructor(M,ce){this.session=M,this.threadId=ce}};e.$UK=fn,e.$UK=fn=Le([V],fn);let dn=class{constructor(M,ce){this.range=M,this.expression=ce}};e.$VK=dn,e.$VK=dn=Le([V],dn);var Tn;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(Tn||(e.InlineCompletionTriggerKind=Tn={}));let mn=class{constructor(M,ce){this.range=M,this.text=ce}};e.$WK=mn,e.$WK=mn=Le([V],mn);let gn=class{constructor(M,ce,pe=!0){this.range=M,this.variableName=ce,this.caseSensitiveLookup=pe}};e.$XK=gn,e.$XK=gn=Le([V],gn);let $n=class{constructor(M,ce){this.range=M,this.expression=ce}};e.$YK=$n,e.$YK=$n=Le([V],$n);let wn=class{constructor(M,ce){this.frameId=M,this.stoppedLocation=ce}};e.$ZK=wn,e.$ZK=wn=Le([V],wn);var jn;(function(T){T[T.Changed=1]="Changed",T[T.Created=2]="Created",T[T.Deleted=3]="Deleted"})(jn||(e.FileChangeType=jn={}));let bn=ue=class extends Error{static FileExists(M){return new ue(M,w.FileSystemProviderErrorCode.FileExists,ue.FileExists)}static FileNotFound(M){return new ue(M,w.FileSystemProviderErrorCode.FileNotFound,ue.FileNotFound)}static FileNotADirectory(M){return new ue(M,w.FileSystemProviderErrorCode.FileNotADirectory,ue.FileNotADirectory)}static FileIsADirectory(M){return new ue(M,w.FileSystemProviderErrorCode.FileIsADirectory,ue.FileIsADirectory)}static NoPermissions(M){return new ue(M,w.FileSystemProviderErrorCode.NoPermissions,ue.NoPermissions)}static Unavailable(M){return new ue(M,w.FileSystemProviderErrorCode.Unavailable,ue.Unavailable)}constructor(M,ce=w.FileSystemProviderErrorCode.Unknown,pe){super($.URI.isUri(M)?M.toString(!0):M),this.code=pe?.name??"Unknown",(0,w.$7j)(this,ce),Object.setPrototypeOf(this,ue.prototype),typeof Error.captureStackTrace=="function"&&typeof pe=="function"&&Error.captureStackTrace(this,pe)}};e.$1K=bn,e.$1K=bn=ue=Le([V],bn);let pn=class{constructor(M,ce,pe){this.start=M,this.end=ce,this.kind=pe}};e.$2K=pn,e.$2K=pn=Le([V],pn);var Un;(function(T){T[T.Comment=1]="Comment",T[T.Imports=2]="Imports",T[T.Region=3]="Region"})(Un||(e.FoldingRangeKind=Un={}));var zn;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(zn||(e.CommentThreadCollapsibleState=zn={}));var Bn;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(Bn||(e.CommentMode=Bn={}));var qn;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(qn||(e.CommentState=qn={}));var Hn;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(Hn||(e.CommentThreadState=Hn={}));class pi{constructor(M,ce=[]){this.tokenTypes=M,this.tokenModifiers=ce}}e.$3K=pi;function yi(T){return typeof T>"u"||(0,b.$je)(T)}class yn{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,M){this.l=!0;for(let ce=0,pe=M.tokenTypes.length;ce<pe;ce++)this.j.set(M.tokenTypes[ce],ce);for(let ce=0,pe=M.tokenModifiers.length;ce<pe;ce++)this.k.set(M.tokenModifiers[ce],ce)}}push(M,ce,pe,je,Ke){if(typeof M=="number"&&typeof ce=="number"&&typeof pe=="number"&&typeof je=="number"&&(typeof Ke=="number"||typeof Ke>"u"))return typeof Ke>"u"&&(Ke=0),this.n(M,ce,pe,je,Ke);if(_.isRange(M)&&typeof ce=="string"&&yi(pe))return this.m(M,ce,pe);throw(0,R.$5)()}m(M,ce,pe){if(!this.l)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ce))throw new Error("`tokenType` is not in the provided legend");const je=M.start.line,Ke=M.start.character,_e=M.end.character-M.start.character,nt=this.j.get(ce);let ht=0;if(pe)for(const yt of pe){if(!this.k.has(yt))throw new Error("`tokenModifier` is not in the provided legend");const Dt=this.k.get(yt);ht|=1<<Dt>>>0}this.n(je,Ke,_e,nt,ht)}n(M,ce,pe,je,Ke){if(this.f&&(M<this.c||M===this.c&&ce<this.e)){this.f=!1;const ht=this.g.length/5|0;let yt=0,Dt=0;for(let St=0;St<ht;St++){let Nt=this.g[5*St],Vt=this.g[5*St+1];Nt===0?(Nt=yt,Vt+=Dt):Nt+=yt,this.g[5*St]=Nt,this.g[5*St+1]=Vt,yt=Nt,Dt=Vt}}let _e=M,nt=ce;this.f&&this.h>0&&(_e-=this.c,_e===0&&(nt-=this.e)),this.g[this.h++]=_e,this.g[this.h++]=nt,this.g[this.h++]=pe,this.g[this.h++]=je,this.g[this.h++]=Ke,this.c=M,this.e=ce}static o(M){const ce=[],pe=M.length/5|0;for(let nt=0;nt<pe;nt++)ce[nt]=nt;ce.sort((nt,ht)=>{const yt=M[5*nt],Dt=M[5*ht];if(yt===Dt){const St=M[5*nt+1],Nt=M[5*ht+1];return St-Nt}return yt-Dt});const je=new Uint32Array(M.length);let Ke=0,_e=0;for(let nt=0;nt<pe;nt++){const ht=5*ce[nt],yt=M[ht+0],Dt=M[ht+1],St=M[ht+2],Nt=M[ht+3],Vt=M[ht+4],gi=yt-Ke,qi=gi===0?Dt-_e:Dt,Kt=5*nt;je[Kt+0]=gi,je[Kt+1]=qi,je[Kt+2]=St,je[Kt+3]=Nt,je[Kt+4]=Vt,Ke=yt,_e=Dt}return je}build(M){return this.f?new vn(new Uint32Array(this.g),M):new vn(yn.o(this.g),M)}}e.$4K=yn;class vn{constructor(M,ce){this.resultId=ce,this.data=M}}e.$5K=vn;class vi{constructor(M,ce,pe){this.start=M,this.deleteCount=ce,this.data=pe}}e.$6K=vi;class Ei{constructor(M,ce){this.resultId=ce,this.edits=M}}e.$7K=Ei;var Wn;(function(T){T[T.Separate=0]="Separate",T[T.MergeWithParent=1]="MergeWithParent"})(Wn||(e.DebugConsoleMode=Wn={}));let Yt=class{constructor(){}};e.$8K=Yt,Yt.Back={iconPath:new Ot("arrow-left")},e.$8K=Yt=Le([V],Yt);var Vn;(function(T){T[T.Separator=-1]="Separator",T[T.Default=0]="Default"})(Vn||(e.QuickPickItemKind=Vn={}));var Kn;(function(T){T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(Kn||(e.InputBoxValidationSeverity=Kn={}));var Jn;(function(T){T[T.UI=1]="UI",T[T.Workspace=2]="Workspace"})(Jn||(e.ExtensionKind=Jn={}));class ki{static validate(M){if(typeof M.badge=="string"){let ce=(0,P.$Vd)(M.badge,0);if(ce<M.badge.length&&(ce+=(0,P.$Vd)(M.badge,ce)),M.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!Ot.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,ce,pe){this.badge=M,this.tooltip=ce,this.color=pe}}e.$9K=ki;let En=class{constructor(M){this.kind=M}};e.$0K=En,e.$0K=En=Le([V],En);var Gn;(function(T){T[T.Light=1]="Light",T[T.Dark=2]="Dark",T[T.HighContrast=3]="HighContrast",T[T.HighContrastLight=4]="HighContrastLight"})(Gn||(e.ColorThemeKind=Gn={}));class Ut{static isNotebookRange(M){return M instanceof Ut?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,ce){if(M<0)throw(0,R.$5)("start must be positive");if(ce<0)throw(0,R.$5)("end must be positive");M<=ce?(this.c=M,this.e=ce):(this.c=ce,this.e=M)}with(M){let ce=this.c,pe=this.e;return M.start!==void 0&&(ce=M.start),M.end!==void 0&&(pe=M.end),ce===this.c&&pe===this.e?this:new Ut(ce,pe)}}e.$$K=Ut;class Xt{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ce=>Xt.isNotebookCellData(ce))}static isNotebookCellData(M){return!0}constructor(M,ce,pe,je,Ke,_e,nt){this.kind=M,this.value=ce,this.languageId=pe,this.mime=je,this.outputs=Ke??[],this.metadata=_e,this.executionSummary=nt,Xt.validate(this)}}e.$_K=Xt;class Di{constructor(M){this.cells=M}}e.$aL=Di;class Yn{static isNotebookCellOutputItem(M){return M instanceof p?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ce={name:M.name,message:M.message,stack:M.stack};return p.json(ce,"application/vnd.code.notebook.error")}static stdout(M){return p.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return p.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ce="application/octet-stream"){return new p(M,ce)}static text(M,ce=I.$zr.text){const pe=it(p,p,"f",t).encode(String(M));return new p(pe,ce)}static json(M,ce="text/x-json"){const pe=JSON.stringify(M,void 0,"	");return p.text(pe,ce)}constructor(M,ce){this.data=M,this.mime=ce;const pe=(0,I.$Dr)(ce,!0);if(!pe)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=pe}}e.$bL=Yn,p=Yn,t={value:new TextEncoder};class Zt{static isNotebookCellOutput(M){return M instanceof Zt?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,ce=!1){const pe=new Set,je=new Set;for(let Ke=0;Ke<M.length;Ke++){const _e=M[Ke],nt=(0,I.$Dr)(_e.mime);if(!pe.has(nt)||(0,d.$SH)(nt)){pe.add(nt);continue}je.add(Ke),ce&&console.warn(`DUPLICATED mime type '${_e.mime}' will be dropped`)}return je.size===0?M:M.filter((Ke,_e)=>!je.has(_e))}constructor(M,ce,pe){this.items=Zt.ensureUniqueMimeTypes(M,!0),typeof ce=="string"?(this.id=ce,this.metadata=pe):(this.id=(0,A.$3e)(),this.metadata=ce??pe)}}e.$cL=Zt;var Xn;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(Xn||(e.NotebookCellKind=Xn={}));var Zn;(function(T){T[T.Idle=1]="Idle",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(Zn||(e.NotebookCellExecutionState=Zn={}));var Qn;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(Qn||(e.NotebookCellStatusBarAlignment=Qn={}));var xn;(function(T){T[T.Default=0]="Default",T[T.InCenter=1]="InCenter",T[T.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",T[T.AtTop=3]="AtTop"})(xn||(e.NotebookEditorRevealType=xn={}));class Si{constructor(M,ce){this.text=M,this.alignment=ce}}e.$dL=Si;var _n;(function(T){T[T.Default=1]="Default",T[T.Preferred=2]="Preferred"})(_n||(e.NotebookControllerAffinity=_n={}));var ei;(function(T){T[T.Default=1]="Default",T[T.Preferred=2]="Preferred",T[T.Hidden=-1]="Hidden"})(ei||(e.NotebookControllerAffinity2=ei={}));class Ci{constructor(M,ce=[]){this.uri=M,this.provides=(0,v.$Gf)(ce)}}e.$eL=Ci;class Pi{constructor(M){this.label=M}}e.$fL=Pi;let kn=class{constructor(M,ce){this.label=M,this.timestamp=ce}};e.$gL=kn,e.$gL=kn=Le([V],kn);var ti;(function(T){T[T.Production=1]="Production",T[T.Development=2]="Development",T[T.Test=3]="Test"})(ti||(e.ExtensionMode=ti={}));var ni;(function(T){T[T.Node=1]="Node",T[T.Webworker=2]="Webworker"})(ni||(e.ExtensionRuntime=ni={}));var ii;(function(T){T[T.Other=0]="Other",T[T.Comment=1]="Comment",T[T.String=2]="String",T[T.RegEx=3]="RegEx"})(ii||(e.StandardTokenType=ii={}));class Ii{constructor(M,ce){this.ranges=M,this.wordPattern=ce}}e.$hL=Ii;class Ai{constructor(M){this.c=M}get autoForwardAction(){return this.c}}e.$iL=Ai;var si;(function(T){T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(si||(e.TestResultState=si={}));var ri;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(ri||(e.TestRunProfileKind=ri={}));let Dn=class{constructor(M=void 0,ce=void 0,pe=void 0,je=!1){this.include=M,this.exclude=ce,this.profile=pe,this.continuous=je}};e.$jL=Dn,e.$jL=Dn=Le([V],Dn);let Sn=Z=class{static diff(M,ce,pe){const je=new Z(M);return je.expectedOutput=ce,je.actualOutput=pe,je}constructor(M){this.message=M}};e.$kL=Sn,e.$kL=Sn=Z=Le([V],Sn);let Cn=class{constructor(M){this.id=M}};e.$lL=Cn,e.$lL=Cn=Le([V],Cn);let Ht=class{constructor(M,ce){this.covered=M,this.total=ce}};e.$mL=Ht,e.$mL=Ht=Le([V],Ht);let Pn=he=class{static fromDetails(M,ce){const pe=new Ht(0,0),je=new Ht(0,0),Ke=new Ht(0,0);for(const nt of ce)if("branches"in nt){pe.total+=1,pe.covered+=nt.executionCount>0?1:0;for(const ht of nt.branches)je.total+=1,je.covered+=ht.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=nt.executionCount>0?1:0;const _e=new he(M,pe,je.total>0?je:void 0,Ke.total>0?Ke:void 0);return _e.detailedCoverage=ce,_e}constructor(M,ce,pe,je){this.uri=M,this.statementCoverage=ce,this.branchCoverage=pe,this.functionCoverage=je}};e.$nL=Pn,e.$nL=Pn=he=Le([V],Pn);let In=class{constructor(M,ce,pe=[]){this.executionCount=M,this.location=ce,this.branches=pe}};e.$oL=In,e.$oL=In=Le([V],In);let An=class{constructor(M,ce){this.executionCount=M,this.location=ce}};e.$pL=An,e.$pL=An=Le([V],An);let Ln=class{constructor(M,ce){this.executionCount=M,this.location=ce}};e.$qL=Ln,e.$qL=Ln=Le([V],Ln);var oi;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(oi||(e.ExternalUriOpenerPriority=oi={}));var ai;(function(T){T[T.Untrusted=0]="Untrusted",T[T.Trusted=1]="Trusted",T[T.Unspecified=2]="Unspecified"})(ai||(e.WorkspaceTrustState=ai={}));var ci;(function(T){T[T.Notify=1]="Notify",T[T.OpenBrowser=2]="OpenBrowser",T[T.OpenPreview=3]="OpenPreview",T[T.Silent=4]="Silent",T[T.Ignore=5]="Ignore",T[T.OpenBrowserOnce=6]="OpenBrowserOnce"})(ci||(e.PortAutoForwardAction=ci={}));class Li{constructor(M,ce,pe,je,Ke,_e){this.kind=M,this.name=ce,this.detail=pe,this.uri=je,this.range=Ke,this.selectionRange=_e}}e.$rL=Li;class Ri{constructor(M){this.uri=M}}e.$sL=Ri;class Oi{constructor(M,ce){this.original=M,this.modified=ce}}e.$tL=Oi;class Ni{constructor(M,ce,pe,je){this.base=M,this.input1=ce,this.input2=pe,this.result=je}}e.$uL=Ni;class Fi{constructor(M,ce){this.uri=M,this.viewType=ce}}e.$vL=Fi;class Mi{constructor(M){this.viewType=M}}e.$wL=Mi;class Ti{constructor(M,ce){this.uri=M,this.notebookType=ce}}e.$xL=Ti;class ji{constructor(M,ce,pe){this.original=M,this.modified=ce,this.notebookType=pe}}e.$yL=ji;class Ui{constructor(){}}e.$zL=Ui;class zi{constructor(M,ce){this.uri=M,this.inputBoxUri=ce}}e.$AL=zi;var li;(function(T){T[T.Up=1]="Up",T[T.Down=2]="Down"})(li||(e.InteractiveSessionVoteDirection=li={}));var ui;(function(T){T[T.Action=1]="Action",T[T.Toolbar=2]="Toolbar"})(ui||(e.InteractiveSessionCopyKind=ui={}));var hi;(function(T){T[T.Unhelpful=0]="Unhelpful",T[T.Helpful=1]="Helpful",T[T.Undone=2]="Undone",T[T.Accepted=3]="Accepted"})(hi||(e.InteractiveEditorResponseFeedbackKind=hi={}));var fi;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.Assistant=2]="Assistant",T[T.Function=3]="Function"})(fi||(e.ChatMessageRole=fi={}));var di;(function(T){T[T.Short=1]="Short",T[T.Medium=2]="Medium",T[T.Full=3]="Full"})(di||(e.ChatVariableLevel=di={}));class Bi{constructor(M,ce){this.role=M,this.content=ce}}e.$BL=Bi;var mi;(function(T){T[T.SymbolInformation=1]="SymbolInformation",T[T.CommandInformation=2]="CommandInformation",T[T.SearchInformation=3]="SearchInformation",T[T.SettingInformation=4]="SettingInformation"})(mi||(e.RelatedInformationType=mi={}))}),define(we[270],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=void 0,e.$dM=(0,v.$ph)("environmentVariableService")}),define(we[271],be([1,0,7,4,59,3,249,8]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=void 0;function b(p,t){if(t)if(S.$d)for(const i in t){let a=i;for(const n in p)if(i.toLowerCase()===n.toLowerCase()){a=n;break}const s=t[i];s!==void 0&&$(p,a,s)}else Object.keys(t).forEach(i=>{const a=t[i];a!==void 0&&$(p,i,a)})}e.$EM=b;function $(p,t,i){typeof i=="string"?p[t]=i:delete p[t]}function A(p,t,i,a){p.TERM_PROGRAM="vscode",t&&(p.TERM_PROGRAM_VERSION=t),l(p,a)&&(p.LANG=d(i)),p.COLORTERM="truecolor"}e.$FM=A;function E(p,t){if(t)for(const i of Object.keys(t)){const a=t[i];a!=null&&(p[i]=a)}}async function w(p,t){return await Promise.all(Object.entries(t).map(async([i,a])=>{if(typeof a=="string")try{t[i]=await p(a)}catch{t[i]=a}})),t}function l(p,t){if(t==="on")return!0;if(t==="auto"){const i=p.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.$GM=l;function d(p){const t=p?p.split("-"):[],i=t.length;if(i===0)return"en_US.UTF-8";if(i===1){const a={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in a&&t.push(a[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.$HM=d;async function m(p,t,i,a,s,n){if(p.cwd){const f=typeof p.cwd=="object"?p.cwd.fsPath:p.cwd,k=await c(f,i);return(0,I.$CM)(k||f)}let o;return!p.ignoreConfigurationCwd&&s&&(i&&(s=await c(s,i,n)),s&&(v.$7c(s)?o=s:a&&(o=v.$8c(a.fsPath,s)))),o||(o=a?a.fsPath:t||""),(0,I.$CM)(o)}e.$IM=m;async function c(p,t,i){if(t)try{return await t(p)}catch(a){i?.error("Could not resolve terminal cwd",a);return}return p}function u(p,t,i){if(i)return a=>i.resolveWithEnvironment(t,p,a)}e.$JM=u;async function h(p,t,i,a,s,n){const o={};if(p.strictEnv)E(o,p.env);else{E(o,n);const f={...t};i&&(f&&await w(i,f),p.env&&await w(i,p.env)),(0,r.$gl)(o,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),b(o,f),b(o,p.env),A(o,a,S.$q,s)}return o}e.$KM=h;async function g(p,t,i,a,s,n,o=S.$d){let f;if((0,P.$ie)(p)?f=p:(f=p.fsPath,o&&n!==1?f=f.replace(/\\/g,"/"):!o&&n===1&&(f=f.replace(/\//g,"\\"))),!t)return f;const k=f.includes(" "),D=f.includes("(")||f.includes(")"),C=v.$_c(t,".exe"),L=C==="pwsh"||i==="pwsh"||C==="powershell"||i==="powershell";if(L&&(k||f.includes("'")))return`& '${f.replace(/'/g,"''")}'`;if(D&&L)return`& '${f}'`;if(n===1){if(a!==void 0)return a==="gitbash"?(0,I.$AM)(f.replace(/\\/g,"/")):a==="wsl"?s?.getWslPath(f,"win-to-unix")||f:k?`"${f}"`:f;const U=t.toLowerCase();return U.includes("wsl")||U.includes("bash.exe")&&!U.toLowerCase().includes("git")?s?.getWslPath(f,"win-to-unix")||f:k?`"${f}"`:f}return(0,I.$AM)(f)}e.$LM=g;function y(p,t,i){const a=typeof p=="string"?R.URI.parse(p):p;let s=a?t.getWorkspaceFolder(a)??void 0:void 0;if(!s){const n=i.getLastActiveWorkspaceRoot();s=n?t.getWorkspaceFolder(n)??void 0:void 0}return s}e.$MM=y}),define(we[71],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xI=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(S){S.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var R;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class r{static fromExtHostTestItem(I,P,b=I.parent){if(I._isRoot)return new r([P]);const $=[I.id];for(let A=b;A&&A.id!==P;A=A.parent)$.push(A.id);return $.push(P),new r($.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const P=I.indexOf("\0");return P===-1?I:I.slice(0,P)}static fromString(I){return new r(I.split("\0"))}static join(I,P){return new r([...I.path,P])}static joinToString(I,P){return I.toString()+"\0"+P}static parentId(I){const P=I.lastIndexOf("\0");return P===-1?void 0:I.slice(0,P)}static localId(I){const P=I.lastIndexOf("\0");return P===-1?I:I.slice(P+1)}static isChild(I,P){return P.startsWith(I)&&P[I.length]==="\0"}static compare(I,P){return I===P?0:r.isChild(I,P)?2:r.isChild(P,I)?3:1}constructor(I,P=I.length){if(this.path=I,this.d=P,I.length===0||P<1)throw new Error("cannot create test with empty path")}get rootId(){return new r(this.path,1)}get parentId(){return this.d>1?new r(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new r(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new r(this.path,I)}compare(I){if(typeof I=="string")return r.compare(this.toString(),I);for(let P=0;P<I.d&&P<this.d;P++)if(I.path[P]!==this.path[P])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.$xI=r}),define(we[93],be([1,0,4,43,71]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$DI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$CI=e.$BI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$AI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$zI=e.$yI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var S;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(S||(e.TestResultState=S={}));var I;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(I||(e.ExtTestRunProfileKind=I={}));var P;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(P||(e.TestRunProfileBitset=P={})),e.$yI=[2,4,8,16,32,64];const b=k=>"runId"in k;e.$zI=b;var $;(function(k){k.serialize=D=>({range:D.range.toJSON(),uri:D.uri.toJSON()}),k.deserialize=D=>({range:R.$Vr.lift(D.range),uri:v.URI.revive(D.uri)})})($||(e.IRichLocation=$={}));var A;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(A||(e.TestMessageType=A={}));var E;(function(k){k.serialize=D=>({message:D.message,type:0,expected:D.expected,actual:D.actual,contextValue:D.contextValue,location:D.location&&$.serialize(D.location)}),k.deserialize=D=>({message:D.message,type:0,expected:D.expected,actual:D.actual,contextValue:D.contextValue,location:D.location&&$.deserialize(D.location)})})(E||(e.ITestErrorMessage=E={}));const w=(k,D)=>`${D?"s":"e"}${k}`;e.$AI=w;var l;(function(k){k.serialize=D=>({message:D.message,type:1,offset:D.offset,length:D.length,location:D.location&&$.serialize(D.location)}),k.deserialize=D=>({message:D.message,type:1,offset:D.offset,length:D.length,location:D.location&&$.deserialize(D.location)})})(l||(e.ITestOutputMessage=l={}));var d;(function(k){k.serialize=D=>D.type===0?E.serialize(D):l.serialize(D),k.deserialize=D=>D.type===0?E.deserialize(D):l.deserialize(D)})(d||(e.ITestMessage=d={}));var m;(function(k){k.serializeWithoutMessages=D=>({state:D.state,duration:D.duration,messages:[]}),k.serialize=D=>({state:D.state,duration:D.duration,messages:D.messages.map(d.serialize)}),k.deserialize=D=>({state:D.state,duration:D.duration,messages:D.messages.map(d.deserialize)})})(m||(e.ITestTaskState=m={}));const c="\0",u=(k,D)=>k+c+D;e.$BI=u;const h=k=>{const D=k.indexOf(c);return{ctrlId:k.slice(0,D),tagId:k.slice(D+1)}};e.$CI=h;var g;(function(k){k.serialize=D=>({extId:D.extId,label:D.label,tags:D.tags,busy:D.busy,children:void 0,uri:D.uri?.toJSON(),range:D.range?.toJSON()||null,description:D.description,error:D.error,sortText:D.sortText}),k.deserialize=D=>({extId:D.extId,label:D.label,tags:D.tags,busy:D.busy,children:void 0,uri:D.uri?v.URI.revive(D.uri):void 0,range:D.range?R.$Vr.lift(D.range):null,description:D.description,error:D.error,sortText:D.sortText})})(g||(e.ITestItem=g={}));var y;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(y||(e.TestItemExpandState=y={}));var p;(function(k){k.serialize=D=>({expand:D.expand,item:g.serialize(D.item)}),k.deserialize=D=>({controllerId:r.$xI.root(D.item.extId),expand:D.expand,item:g.deserialize(D.item)})})(p||(e.InternalTestItem=p={}));var t;(function(k){k.serialize=D=>{let C;return D.item&&(C={},D.item.label!==void 0&&(C.label=D.item.label),D.item.tags!==void 0&&(C.tags=D.item.tags),D.item.busy!==void 0&&(C.busy=D.item.busy),D.item.uri!==void 0&&(C.uri=D.item.uri?.toJSON()),D.item.range!==void 0&&(C.range=D.item.range?.toJSON()),D.item.description!==void 0&&(C.description=D.item.description),D.item.error!==void 0&&(C.error=D.item.error),D.item.sortText!==void 0&&(C.sortText=D.item.sortText)),{extId:D.extId,expand:D.expand,item:C}},k.deserialize=D=>{let C;return D.item&&(C={},D.item.label!==void 0&&(C.label=D.item.label),D.item.tags!==void 0&&(C.tags=D.item.tags),D.item.busy!==void 0&&(C.busy=D.item.busy),D.item.range!==void 0&&(C.range=D.item.range?R.$Vr.lift(D.item.range):null),D.item.description!==void 0&&(C.description=D.item.description),D.item.error!==void 0&&(C.error=D.item.error),D.item.sortText!==void 0&&(C.sortText=D.item.sortText)),{extId:D.extId,expand:D.expand,item:C}}})(t||(e.ITestItemUpdate=t={}));const i=(k,D)=>{D.expand!==void 0&&(k.expand=D.expand),D.item!==void 0&&(k.item=k.item?Object.assign(k.item,D.item):D.item)};e.$DI=i;var a;(function(k){k.serializeWithoutMessages=D=>({...p.serialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(m.serializeWithoutMessages)}),k.serialize=D=>({...p.serialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(m.serialize)}),k.deserialize=D=>({...p.deserialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(m.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var s;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(s||(e.DetailType=s={}));var n;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(n||(e.TestDiffOpType=n={}));var o;(function(k){k.deserialize=D=>D.op===0?{op:D.op,item:p.deserialize(D.item)}:D.op===1?{op:D.op,item:t.deserialize(D.item)}:D.op===2?{op:D.op,uri:v.URI.revive(D.uri),docv:D.docv}:D,k.serialize=D=>D.op===0?{op:D.op,item:p.serialize(D.item)}:D.op===1?{op:D.op,item:t.serialize(D.item)}:D})(o||(e.TestsDiffOp=o={}));class f{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(D){const C=this.p();for(const L of D)switch(L.op){case 0:this.k(p.deserialize(L.item),C);break;case 1:this.l(t.deserialize(L.item),C);break;case 3:this.m(L.itemId,C);break;case 5:this.o(L.itemId);break;case 4:this.updatePendingRoots(L.amount);break;case 6:this.d.set(L.tag.id,L.tag);break;case 7:this.d.delete(L.id);break}C.complete?.()}k(D,C){const L=r.$xI.parentId(D.item.extId)?.toString();let U;if(!L)U=this.q(D),this.g.add(U),this.f.set(D.item.extId,U);else if(this.f.has(L)){const x=this.f.get(L);x.children.add(D.item.extId),U=this.q(D,x),this.f.set(D.item.extId,U)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(D)}`);return}return C.add?.(U),D.expand===2&&this.h++,U}l(D,C){const L=this.f.get(D.extId);if(L)return D.expand!==void 0&&(L.expand===2&&this.h--,D.expand===2&&this.h++),(0,e.$DI)(L,D),C.update?.(L),L}m(D,C){const L=this.f.get(D);if(!L)return;const U=r.$xI.parentId(L.item.extId)?.toString();U?this.f.get(U).children.delete(L.item.extId):this.g.delete(L);const x=[[D]];for(;x.length;)for(const ae of x.pop()){const W=this.f.get(ae);W&&(x.push(W.children),this.f.delete(ae),C.remove?.(W,W!==L),W.expand===2&&this.h--)}}o(D){}updatePendingRoots(D){this.j+=D}p(){return{}}}e.$EI=f}),define(we[133],be([1,0,14,5,2,96,93,71]),function(le,e,v,R,r,S,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.TestItemEventOp=void 0;var b;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const $=(h,g)=>h===g,E=Object.entries({range:(h,g)=>h===g?!0:!h||!g?!1:h.equalsRange(g),busy:$,label:$,description:$,error:$,sortText:$,tags:(h,g)=>!(h.length!==g.length||h.some(y=>!g.includes(y)))}),w=(h,g)=>{let y;for(const[p,t]of E)t(h[p],g[p])||(y?y[p]=g[p]:y={[p]:g[p]});return y};class l extends r.$lb{get root(){return this.m.root}constructor(g){super(),this.m=g,this.f=this.B(new v.$Gg(()=>this.flushDiff(),200)),this.g=this.B(new R.$ec),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(g){this.h=g;for(const y of this.tree.values())this.G(y)}get resolveHandler(){return this.h}collectDiff(){const g=this.k;return this.k=[],g}pushDiff(g){switch(g.op){case 2:{for(const y of this.k)if(y.op===2&&y.uri===g.uri){y.docv=g.docv;return}break}case 1:{const y=this.k[this.k.length-1];if(y){if(y.op===1&&y.item.extId===g.item.extId){(0,I.$DI)(y.item,g.item);return}if(y.op===0&&y.item.item.extId===g.item.extId){(0,I.$DI)(y.item,g.item);return}}break}}this.k.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,y){const p=this.tree.get(g);if(p){if((p.expandLevels===void 0||y>p.expandLevels)&&(p.expandLevels=y),p.expand===1){const t=this.I(p);return t.isOpen()?this.H(p,y-1):t.wait().then(()=>this.H(p,y-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,y-1)):this.H(p,y-1)}}dispose(){for(const g of this.tree.values())this.m.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(g,y){switch(y.op){case 3:this.L(P.$xI.joinToString(g.fullId,y.id));break;case 0:this.u(y.item,g);break;case 5:for(const p of y.ops)this.p(g,p);break;case 1:this.w(y.new,y.old,g.fullId.toString());break;case 2:this.G(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:y.update}});break;case 6:this.s(g.actual.uri);break;default:(0,S.$wb)(y)}}s(g){g&&this.pushDiff({op:2,uri:g,docv:this.m.getDocumentVersion(g)})}u(g,y){const p=P.$xI.fromExtHostTestItem(g,this.root.id,y?.actual),t=this.m.getApiFor(g);t.parent&&t.parent!==y?.actual&&this.m.getChildren(t.parent).delete(g.id);let i=this.tree.get(p.toString());if(!i){i={fullId:p,actual:g,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},g.tags.forEach(this.y,this),this.tree.set(i.fullId.toString(),i),this.C(g,y),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:i.expand,item:this.m.toITestItem(g)}}),this.F(g,i,y);return}if(i.actual===g){this.D(g,i,y);return}if(i.actual.uri?.toString()!==g.uri?.toString())return this.L(p.toString()),this.u(g,y);const a=this.m.getChildren(i.actual),s=i.actual,n=w(this.m.toITestItem(s),this.m.toITestItem(g));this.m.getApiFor(s).listener=void 0,i.actual=g,i.expand=0,n&&(n.hasOwnProperty("tags")&&(this.w(g.tags,s.tags,p.toString()),delete n.tags),this.p(i,{op:4,update:n})),this.F(g,i,y);for(const[o,f]of a)this.m.getChildren(g).get(f.id)||this.L(P.$xI.joinToString(p,f.id));this.s(i.actual.uri)}w(g,y,p){const t=new Set(y.map(i=>i.id));for(const i of g)t.delete(i.id)||this.y(i);this.pushDiff({op:1,item:{extId:p,item:{tags:g.map(i=>(0,I.$BI)(this.m.controllerId,i.id))}}}),t.forEach(this.z,this)}y(g){const y=this.j.get(g.id);y?y.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.$BI)(this.m.controllerId,g.id)}}))}z(g){const y=this.j.get(g);y&&!--y.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,I.$BI)(this.m.controllerId,g)}))}C(g,y){this.m.getApiFor(g).parent=y&&y.actual!==this.root?y.actual:void 0}D(g,y,p){this.C(g,p);const t=this.m.getApiFor(g);t.parent=p?.actual,t.listener=i=>this.p(y,i),this.G(y)}F(g,y,p){this.D(g,y,p);for(const[t,i]of this.m.getChildren(g))this.u(i,y)}G(g){let y;this.h?g.resolveBarrier?y=g.resolveBarrier.isOpen()?3:2:y=g.actual.canResolveChildren?1:0:y=0,y!==g.expand&&(g.expand=y,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:y}}),y===1&&g.expandLevels!==void 0&&this.I(g))}H(g,y){if(y<0)return;const p=[];for(const[t,i]of this.m.getChildren(g.actual)){const a=this.expand(P.$xI.joinToString(g.fullId,i.id),y);(0,v.$hg)(a)&&p.push(a)}if(p.length)return Promise.all(p).then(()=>{})}I(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const i=new v.$tg;return i.open(),i}g.expand=2,this.J(g);const y=g.resolveBarrier=new v.$tg,p=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,i)};let t;try{t=this.h(g.actual===this.root?void 0:g.actual)}catch(i){p(i)}return(0,v.$hg)(t)?t.catch(p).then(()=>{y.open(),this.G(g)}):(y.open(),this.G(g)),g.resolveBarrier}J(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}L(g){const y=this.tree.get(g);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const p=[y];for(;p.length;){const t=p.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const i of t.actual.tags)this.z(i.id);this.tree.delete(t.fullId.toString());for(const[i,a]of this.m.getChildren(t.actual))p.push(this.tree.get(P.$xI.joinToString(t.fullId,a.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.$CL=l;class d extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.$DL=d;class m extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$EL=m;class c extends Error{constructor(g,y,p){super(`TestItem with ID "${g}" is from controller "${y}" and cannot be added as a child of an item from controller "${p}".`)}}e.$FL=c;const u=(h,g,y)=>{let p=new Map;return{get size(){return p.size},forEach(t,i){for(const a of p.values())t.call(i,a,this)},[Symbol.iterator](){return p.entries()},replace(t){const i=new Map,a=new Set(p.keys()),s={op:5,ops:[]};for(const n of t){if(!(n instanceof y))throw new m(n.id);const o=g(n).controllerId;if(o!==h.controllerId)throw new c(n.id,o,h.controllerId);if(i.has(n.id))throw new d(n.id);i.set(n.id,n),a.delete(n.id),s.ops.push({op:0,item:n})}for(const n of a.keys())s.ops.push({op:3,id:n});h.listener?.(s),p=i},add(t){if(!(t instanceof y))throw new m(t.id);p.set(t.id,t),h.listener?.({op:0,item:t})},delete(t){p.delete(t)&&h.listener?.({op:3,id:t})},get(t){return p.get(t)},toJSON(){return Array.from(p.values())}}};e.$GL=u}),define(we[134],be([1,0,133]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IL=e.$HL=void 0;const R=new WeakMap,r=(I,P)=>{const b={controllerId:P};return R.set(I,b),b};e.$HL=r;const S=I=>{const P=R.get(I);if(!P)throw new v.$EL(I?.id||"<unknown>");return P};e.$IL=S}),define(we[272],be([1,0,24,6]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=void 0,e.$SD=".vscode",e.$TD="settings",e.$UD=`${e.$SD}/${e.$TD}.json`,e.$VD="vscode://schemas/settings/default",e.$WD="vscode://schemas/settings/user",e.$XD="vscode://schemas/settings/profile",e.$YD="vscode://schemas/settings/machine",e.$ZD="vscode://schemas/settings/workspace",e.$1D="vscode://schemas/settings/folder",e.$2D="vscode://schemas/launch",e.$3D="vscode://schemas/tasks",e.$4D=[1],e.$5D=[2,3,4,5,6],e.$6D=[3,4,5],e.$7D=[1,...e.$6D],e.$8D=[2,3,4,5,6],e.$9D=[3,4,5,6],e.$0D=[4,5,6],e.$$D="tasks",e.$_D="launch",e.$aE=Object.create(null),e.$aE[e.$$D]=`${e.$SD}/${e.$$D}.json`,e.$aE[e.$_D]=`${e.$SD}/${e.$_D}.json`,e.$bE=Object.create(null),e.$bE[e.$$D]=`${e.$$D}.json`,e.$cE=(0,R.$qh)(v.$Vh),e.$dE=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$eE="workbench.settings.applyToAllProfiles"}),define(we[135],be([1,0,6]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=e.VariableKind=e.$yM=void 0,e.$yM=(0,v.$ph)("configurationResolverService");var R;(function(S){S.Unknown="unknown",S.Env="env",S.Config="config",S.Command="command",S.Input="input",S.ExtensionInstallFolder="extensionInstallFolder",S.WorkspaceFolder="workspaceFolder",S.Cwd="cwd",S.WorkspaceFolderBasename="workspaceFolderBasename",S.UserHome="userHome",S.LineNumber="lineNumber",S.SelectedText="selectedText",S.File="file",S.FileWorkspaceFolder="fileWorkspaceFolder",S.RelativeFile="relativeFile",S.RelativeFileDirname="relativeFileDirname",S.FileDirname="fileDirname",S.FileExtname="fileExtname",S.FileBasename="fileBasename",S.FileBasenameNoExtension="fileBasenameNoExtension",S.FileDirnameBasename="fileDirnameBasename",S.ExecPath="execPath",S.ExecInstallFolder="execInstallFolder",S.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class r extends Error{constructor(I,P){super(P),this.variable=I}}e.$zM=r}),define(we[273],be([1,0,7,29,8,22,3,151,202,135,17]),function(le,e,v,R,r,S,I,P,b,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0;class E{constructor(l,d,m,c){this.h=new Map,this.a=l,this.b=d,this.g=m,c&&(this.c=c.then(u=>this.i(u)))}i(l){if(I.$d){const d=Object.create(null);return Object.keys(l).forEach(m=>{d[m.toLowerCase()]=l[m]}),d}return l}resolveWithEnvironment(l,d,m){return this.l({env:this.i(l),userHome:void 0},d?d.uri:void 0,m)}async resolveAsync(l,d){const m={env:await this.c,userHome:await this.g};return this.l(m,l?l.uri:void 0,d)}async j(l,d,m,c){const u=S.$Jm(d);I.$d&&u.windows?Object.keys(u.windows).forEach(g=>u[g]=u.windows[g]):I.$e&&u.osx?Object.keys(u.osx).forEach(g=>u[g]=u.osx[g]):I.$f&&u.linux&&Object.keys(u.linux).forEach(g=>u[g]=u.linux[g]),delete u.windows,delete u.osx,delete u.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,l?l.uri:void 0,u,m,c)}async resolveAnyAsync(l,d,m){return this.j(l,d,m)}async resolveAnyMap(l,d,m){const c=new Map;return{newConfig:await this.j(l,d,m,c),resolvedVariables:c}}resolveWithInteractionReplace(l,d,m,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(l,d,m,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(l,d){if(this.h.has(l))throw new Error("Variable "+l+" is contributed twice.");this.h.set(l,d)}async l(l,d,m,c,u){if(r.$ie(m))return this.m(l,d,m,c,u);if(Array.isArray(m))return Promise.all(m.map(h=>this.l(l,d,h,c,u)));if(r.$ke(m)){const h=Object.create(null),g=await Promise.all(Object.keys(m).map(async y=>[await this.m(l,d,y,c,u),await this.l(l,d,m[y],c,u)]));for(const[y,p]of g)h[y]=p;return h}return m}m(l,d,m,c,u){return(0,A.$Dd)(m,E.VARIABLE_REGEXP,async(h,g)=>{if(g.includes(E.VARIABLE_LHS))return h;let y=await this.o(l,h,g,d,c);return u?.set(g,y),y!==h&&r.$ie(y)&&y.match(E.VARIABLE_REGEXP)&&(y=await this.m(l,d,y,c,u)),y})}n(l){return this.b?this.b.getUriLabel(l,{noPrefix:!0}):l.fsPath}async o(l,d,m,c,u){let h;const g=m.split(":");g.length>1&&(m=g[0],h=g[1]);const y=i=>{const a=this.a.getFilePath();if(a)return(0,P.$8z)(a);throw new $.$zM(i,(0,b.localize)(0,null,d))},p=i=>{const a=y(i);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,P.$8z)(s)}throw new $.$zM(i,(0,b.localize)(1,null,d,v.$_c(a)))},t=i=>{if(h){const a=this.a.getFolderUri(h);if(a)return a;throw new $.$zM(i,(0,b.localize)(2,null,d,h))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new $.$zM(i,(0,b.localize)(3,null,d)):new $.$zM(i,(0,b.localize)(4,null,d))};switch(m){case"env":if(h){if(l.env){const i=l.env[I.$d?h.toLowerCase():h];if(r.$ie(i))return i}return""}throw new $.$zM($.VariableKind.Env,(0,b.localize)(5,null,d));case"config":if(h){const i=this.a.getConfigurationValue(c,h);if(r.$re(i))throw new $.$zM($.VariableKind.Config,(0,b.localize)(6,null,d,h));if(r.$ke(i))throw new $.$zM($.VariableKind.Config,(0,b.localize)(7,null,d,h));return i}throw new $.$zM($.VariableKind.Config,(0,b.localize)(8,null,d));case"command":return this.p($.VariableKind.Command,d,h,u,"command");case"input":return this.p($.VariableKind.Input,d,h,u,"input");case"extensionInstallFolder":if(h){const i=await this.a.getExtension(h);if(!i)throw new $.$zM($.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,d,h));return this.n(i.extensionLocation)}throw new $.$zM($.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,d));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,P.$8z)(this.n(t($.VariableKind.WorkspaceFolder)));case"cwd":return c||h?(0,P.$8z)(this.n(t($.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.$8z)(v.$_c(this.n(t($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(l.userHome)return l.userHome;throw new $.$zM($.VariableKind.UserHome,(0,b.localize)(11,null,d))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new $.$zM($.VariableKind.LineNumber,(0,b.localize)(12,null,d))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new $.$zM($.VariableKind.SelectedText,(0,b.localize)(13,null,d))}case"file":return y($.VariableKind.File);case"fileWorkspaceFolder":return p($.VariableKind.FileWorkspaceFolder);case"relativeFile":return c||h?v.$0c(this.n(t($.VariableKind.RelativeFile)),y($.VariableKind.RelativeFile)):y($.VariableKind.RelativeFile);case"relativeFileDirname":{const i=v.$$c(y($.VariableKind.RelativeFileDirname));if(c||h){const a=v.$0c(this.n(t($.VariableKind.RelativeFileDirname)),i);return a.length===0?".":a}return i}case"fileDirname":return v.$$c(y($.VariableKind.FileDirname));case"fileExtname":return v.$ad(y($.VariableKind.FileExtname));case"fileBasename":return v.$_c(y($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=v.$_c(y($.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-v.$ad(i).length)}case"fileDirnameBasename":return v.$_c(v.$$c(y($.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||d}case"execInstallFolder":{const i=this.a.getAppRoot();return i||d}case"pathSeparator":return v.sep;default:try{const i=h?`${m}:${h}`:m;return this.p($.VariableKind.Unknown,d,i,u,void 0)}catch{return d}}}}p(l,d,m,c,u){if(m&&c){const h=u===void 0?c[m]:c[u+":"+m];if(typeof h=="string")return h;throw new $.$zM(l,(0,b.localize)(14,null,d))}return d}}e.$NM=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[274],be([1,0,6,92]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.$WC=e.OpenEditorContext=e.GroupsOrder=e.$VC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$UC=void 0,e.$UC=(0,v.$ph)("editorGroupsService");var r;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(r||(e.GroupDirection=r={}));var S;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(S||(e.GroupOrientation=S={}));var I;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(I||(e.GroupLocation=I={}));var P;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(P||(e.GroupsArrangement=P={}));var b;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function $(d){const m=d;return(0,R.$KE)(m?.editor)&&(0,R.$KE)(m?.replacement)}e.$VC=$;var A;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var E;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function w(d){const m=d;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.$WC=w;function l(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$XC=l}),define(we[136],be([1,0,6,274]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=e.$1C=e.$ZC=e.$YC=void 0,e.$YC=(0,v.$ph)("editorService"),e.$ZC=-1,e.$1C=-2;function r(S){const I=S;return typeof S=="number"||(0,R.$WC)(I)}e.$2C=r}),define(we[137],be([1,0,18,15,152,74,101,28,142,50,58,22,8,4,43,170,226,134,92,131,71,93,136,132]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g,y,p,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$LL=e.$KL=e.MarkdownString=e.$JL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ve){function Se(G){const{selectionStartLineNumber:Ce,selectionStartColumn:Oe,positionLineNumber:We,positionColumn:Ue}=G,Qe=new i.$NJ(Ce-1,Oe-1),at=new i.$NJ(We-1,Ue-1);return new i.$PJ(Qe,at)}ve.to=Se;function fe(G){const{anchor:Ce,active:Oe}=G;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}ve.from=fe})(a||(e.Selection=a={}));var s;(function(ve){function Se(G){if(!G)return;const{start:Ce,end:Oe}=G;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}ve.from=Se;function fe(G){if(!G)return;const{startLineNumber:Ce,startColumn:Oe,endLineNumber:We,endColumn:Ue}=G;return new i.$OJ(Ce-1,Oe-1,We-1,Ue-1)}ve.to=fe})(s||(e.Range=s={}));var n;(function(ve){function Se(fe){switch(fe){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}ve.to=Se})(n||(e.TokenType=n={}));var o;(function(ve){function Se(G){return new i.$NJ(G.lineNumber-1,G.column-1)}ve.to=Se;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}ve.from=fe})(o||(e.Position=o={}));var f;(function(ve){function Se(Ce,Oe,We){return(0,v.$jf)((0,v.$Gf)(Ce).map(Ue=>fe(Ue,Oe,We)))}ve.from=Se;function fe(Ce,Oe,We){if(typeof Ce=="string")return{$serialized:!0,language:Ce,isBuiltin:We?.isBuiltin};if(Ce)return{$serialized:!0,language:Ce.language,scheme:G(Ce.scheme,Oe),pattern:Ne.from(Ce.pattern)??void 0,exclusive:Ce.exclusive,notebookType:Ce.notebookType,isBuiltin:We?.isBuiltin}}function G(Ce,Oe){return Oe&&typeof Ce=="string"?Oe.transformOutgoingScheme(Ce):Ce}})(f||(e.DocumentSelector=f={}));var k;(function(ve){function Se(G){switch(G){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}ve.from=Se;function fe(G){switch(G){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}ve.to=fe})(k||(e.DiagnosticTag=k={}));var D;(function(ve){function Se(G){let Ce;return G.code&&((0,w.$ie)(G.code)||(0,w.$me)(G.code)?Ce=String(G.code):Ce={value:String(G.code.value),target:G.code.target}),{...s.from(G.range),message:G.message,source:G.source,code:Ce,severity:L.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(C.from),tags:Array.isArray(G.tags)?(0,v.$jf)(G.tags.map(k.from)):void 0}}ve.from=Se;function fe(G){const Ce=new i.$1J(s.to(G),G.message,L.to(G.severity));return Ce.source=G.source,Ce.code=(0,w.$ie)(G.code)?G.code:G.code?.value,Ce.relatedInformation=G.relatedInformation&&G.relatedInformation.map(C.to),Ce.tags=G.tags&&(0,v.$jf)(G.tags.map(k.to)),Ce}ve.to=fe})(D||(e.Diagnostic=D={}));var C;(function(ve){function Se(G){return{...s.from(G.location.range),message:G.message,resource:G.location.uri}}ve.from=Se;function fe(G){return new i.$ZJ(new i.$YJ(G.resource,s.to(G)),G.message)}ve.to=fe})(C||(e.DiagnosticRelatedInformation=C={}));var L;(function(ve){function Se(G){switch(G){case i.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ve.from=Se;function fe(G){switch(G){case c.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}ve.to=fe})(L||(e.DiagnosticSeverity=L={}));var U;(function(ve){function Se(G){return typeof G=="number"&&G>=i.ViewColumn.One?G-1:G===i.ViewColumn.Beside?t.$1C:t.$ZC}ve.from=Se;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=fe})(U||(e.ViewColumn=U={}));function x(ve){return typeof ve.range<"u"}function ae(ve){return ve.length===0?!0:!!x(ve[0])}e.$JL=ae;var W;(function(ve){function Se(Ue){return Ue.map(ve.from)}ve.fromMany=Se;function fe(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function G(Ue){let Qe;if(fe(Ue)){const{language:ct,value:lt}=Ue;Qe={value:"```"+ct+`
`+lt+"\n```\n"}}else i.$bK.isMarkdownString(Ue)?Qe={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml,baseUri:Ue.baseUri}:typeof Ue=="string"?Qe={value:Ue}:Qe={value:""};const at=Object.create(null);Qe.uris=at;const kt=ct=>{try{let lt=l.URI.parse(ct,!0);lt=lt.with({query:Ce(lt.query,at)}),at[ct]=lt}catch{}return""},dt=new b.marked.Renderer;return dt.link=kt,dt.image=ct=>typeof ct=="string"?kt(I.$Rj(ct).href):"",(0,b.marked)(Qe.value,{renderer:dt}),Qe}ve.from=G;function Ce(Ue,Qe){if(!Ue)return Ue;let at;try{at=(0,$.$Xg)(Ue)}catch{}if(!at)return Ue;let kt=!1;return at=(0,E.$Lm)(at,dt=>{if(l.URI.isUri(dt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return Qe[ct]=dt,kt=!0,ct}else return}),kt?JSON.stringify(at):Ue}function Oe(Ue){const Qe=new i.$bK(Ue.value,Ue.supportThemeIcons);return Qe.isTrusted=Ue.isTrusted,Qe.supportHtml=Ue.supportHtml,Qe.baseUri=Ue.baseUri?l.URI.from(Ue.baseUri):void 0,Qe}ve.to=Oe;function We(Ue){if(Ue)return typeof Ue=="string"?Ue:ve.from(Ue)}ve.fromStrict=We})(W||(e.MarkdownString=W={}));function te(ve){return ae(ve)?ve.map(Se=>({range:s.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?W.fromMany(Se.hoverMessage):Se.hoverMessage?W.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):ve.map(Se=>({range:s.from(Se)}))}e.$KL=te;function ue(ve){return typeof ve>"u"?ve:typeof ve=="string"?l.URI.file(ve):ve}e.$LL=ue;var Z;(function(ve){function Se(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?ue(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ve.from=Se})(Z||(e.ThemableDecorationAttachmentRenderOptions=Z={}));var he;(function(ve){function Se(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Z.from(fe.before):void 0,after:fe.after?Z.from(fe.after):void 0}}ve.from=Se})(he||(e.ThemableDecorationRenderOptions=he={}));var V;(function(ve){function Se(fe){if(typeof fe>"u")return fe;switch(fe){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=Se})(V||(e.DecorationRangeBehavior=V={}));var se;(function(ve){function Se(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?V.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?he.from(fe.light):void 0,dark:fe.dark?he.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Z.from(fe.before):void 0,after:fe.after?Z.from(fe.after):void 0}}ve.from=Se})(se||(e.DecorationRenderOptions=se={}));var K;(function(ve){function Se(G){return{text:G.newText,eol:G.newEol&&Ye.from(G.newEol),range:s.from(G.range)}}ve.from=Se;function fe(G){const Ce=new i.$TJ(s.to(G.range),G.text);return Ce.newEol=typeof G.eol>"u"?void 0:Ye.to(G.eol),Ce}ve.to=fe})(K||(e.TextEdit=K={}));var Y;(function(ve){function Se(G,Ce){const Oe={edits:[]};if(G instanceof i.$WJ){const We=new P.$oi;for(const Ue of G._allEntries())Ue._type===1&&l.URI.isUri(Ue.to)&&Ue.from===void 0&&We.add(Ue.to);for(const Ue of G._allEntries())if(Ue._type===1){let Qe;Ue.options?.contents&&(ArrayBuffer.isView(Ue.options.contents)?Qe={type:"base64",value:(0,R.$Yc)(R.$Ec.wrap(Ue.options.contents))}:Qe={type:"dataTransferItem",id:Ue.options.contents._itemId}),Oe.edits.push({oldResource:Ue.from,newResource:Ue.to,options:{...Ue.options,contents:Qe},metadata:Ue.metadata})}else Ue._type===2?Oe.edits.push({resource:Ue.uri,textEdit:K.from(Ue.edit),versionId:We.has(Ue.uri)?void 0:Ce?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===6?Oe.edits.push({resource:Ue.uri,textEdit:{range:s.from(Ue.range),text:Ue.edit.value,insertAsSnippet:!0},versionId:We.has(Ue.uri)?void 0:Ce?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===3?Oe.edits.push({metadata:Ue.metadata,resource:Ue.uri,cellEdit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Ce?.getNotebookDocumentVersion(Ue.uri)}):Ue._type===5&&Oe.edits.push({metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Ce?.getNotebookDocumentVersion(Ue.uri),cellEdit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Xe.from)}})}return Oe}ve.from=Se;function fe(G){const Ce=new i.$WJ,Oe=new P.$ni;for(const We of G.edits)if(We.textEdit){const Ue=We,Qe=l.URI.revive(Ue.resource),at=s.to(Ue.textEdit.range),kt=Ue.textEdit.text,dt=Ue.textEdit.insertAsSnippet;let ct;dt?ct=i.$VJ.replace(at,new i.$XJ(kt)):ct=i.$TJ.replace(at,kt);const lt=Oe.get(Qe);lt?lt.push(ct):Oe.set(Qe,[ct])}else Ce.renameFile(l.URI.revive(We.oldResource),l.URI.revive(We.newResource),We.options);for(const[We,Ue]of Oe)Ce.set(We,Ue);return Ce}ve.to=fe})(Y||(e.WorkspaceEdit=Y={}));var H;(function(ve){const Se=Object.create(null);Se[i.SymbolKind.File]=0,Se[i.SymbolKind.Module]=1,Se[i.SymbolKind.Namespace]=2,Se[i.SymbolKind.Package]=3,Se[i.SymbolKind.Class]=4,Se[i.SymbolKind.Method]=5,Se[i.SymbolKind.Property]=6,Se[i.SymbolKind.Field]=7,Se[i.SymbolKind.Constructor]=8,Se[i.SymbolKind.Enum]=9,Se[i.SymbolKind.Interface]=10,Se[i.SymbolKind.Function]=11,Se[i.SymbolKind.Variable]=12,Se[i.SymbolKind.Constant]=13,Se[i.SymbolKind.String]=14,Se[i.SymbolKind.Number]=15,Se[i.SymbolKind.Boolean]=16,Se[i.SymbolKind.Array]=17,Se[i.SymbolKind.Object]=18,Se[i.SymbolKind.Key]=19,Se[i.SymbolKind.Null]=20,Se[i.SymbolKind.EnumMember]=21,Se[i.SymbolKind.Struct]=22,Se[i.SymbolKind.Event]=23,Se[i.SymbolKind.Operator]=24,Se[i.SymbolKind.TypeParameter]=25;function fe(Ce){return typeof Se[Ce]=="number"?Se[Ce]:6}ve.from=fe;function G(Ce){for(const Oe in Se)if(Se[Oe]===Ce)return Number(Oe);return i.SymbolKind.Property}ve.to=G})(H||(e.SymbolKind=H={}));var _;(function(ve){function Se(G){switch(G){case i.SymbolTag.Deprecated:return 1}}ve.from=Se;function fe(G){switch(G){case 1:return i.SymbolTag.Deprecated}}ve.to=fe})(_||(e.SymbolTag=_={}));var ge;(function(ve){function Se(G){return{name:G.name,kind:H.from(G.kind),tags:G.tags&&G.tags.map(_.from),containerName:G.containerName,location:N.from(G.location)}}ve.from=Se;function fe(G){const Ce=new i.$4J(G.name,H.to(G.kind),G.containerName,N.to(G.location));return Ce.tags=G.tags&&G.tags.map(_.to),Ce}ve.to=fe})(ge||(e.WorkspaceSymbol=ge={}));var ne;(function(ve){function Se(G){const Ce={name:G.name||"!!MISSING: name!!",detail:G.detail,range:s.from(G.range),selectionRange:s.from(G.selectionRange),kind:H.from(G.kind),tags:G.tags?.map(_.from)??[]};return G.children&&(Ce.children=G.children.map(Se)),Ce}ve.from=Se;function fe(G){const Ce=new i.$5J(G.name,G.detail,H.to(G.kind),s.to(G.range),s.to(G.selectionRange));return(0,v.$nf)(G.tags)&&(Ce.tags=G.tags.map(_.to)),G.children&&(Ce.children=G.children.map(fe)),Ce}ve.to=fe})(ne||(e.DocumentSymbol=ne={}));var q;(function(ve){function Se(G){const Ce=new i.$0J(H.to(G.kind),G.name,G.detail||"",l.URI.revive(G.uri),s.to(G.range),s.to(G.selectionRange));return Ce._sessionId=G._sessionId,Ce._itemId=G._itemId,Ce}ve.to=Se;function fe(G,Ce,Oe){if(Ce=Ce??G._sessionId,Oe=Oe??G._itemId,Ce===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Oe,name:G.name,detail:G.detail,kind:H.from(G.kind),uri:G.uri,range:s.from(G.range),selectionRange:s.from(G.selectionRange),tags:G.tags?.map(_.from)}}ve.from=fe})(q||(e.CallHierarchyItem=q={}));var X;(function(ve){function Se(fe){return new i.$$J(q.to(fe.from),fe.fromRanges.map(G=>s.to(G)))}ve.to=Se})(X||(e.CallHierarchyIncomingCall=X={}));var O;(function(ve){function Se(fe){return new i.$_J(q.to(fe.to),fe.fromRanges.map(G=>s.to(G)))}ve.to=Se})(O||(e.CallHierarchyOutgoingCall=O={}));var N;(function(ve){function Se(G){return{range:G.range&&s.from(G.range),uri:G.uri}}ve.from=Se;function fe(G){return new i.$YJ(l.URI.revive(G.uri),s.to(G.range))}ve.to=fe})(N||(e.location=N={}));var J;(function(ve){function Se(G){const Ce=G,Oe=G;return{originSelectionRange:Ce.originSelectionRange?s.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Oe.uri,range:s.from(Ce.targetRange?Ce.targetRange:Oe.range),targetSelectionRange:Ce.targetSelectionRange?s.from(Ce.targetSelectionRange):void 0}}ve.from=Se;function fe(G){return{targetUri:l.URI.revive(G.uri),targetRange:s.to(G.range),targetSelectionRange:G.targetSelectionRange?s.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?s.to(G.originSelectionRange):void 0}}ve.to=fe})(J||(e.DefinitionLink=J={}));var ie;(function(ve){function Se(G){return{range:s.from(G.range),contents:W.fromMany(G.contents)}}ve.from=Se;function fe(G){return new i.$2J(G.contents.map(W.to),s.to(G.range))}ve.to=fe})(ie||(e.Hover=ie={}));var re;(function(ve){function Se(G){return{range:s.from(G.range),expression:G.expression}}ve.from=Se;function fe(G){return new i.$VK(s.to(G.range),G.expression)}ve.to=fe})(re||(e.EvaluatableExpression=re={}));var ee;(function(ve){function Se(G){if(G instanceof i.$WK)return{type:"text",range:s.from(G.range),text:G.text};if(G instanceof i.$XK)return{type:"variable",range:s.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof i.$YK)return{type:"expression",range:s.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=Se;function fe(G){switch(G.type){case"text":return{range:s.to(G.range),text:G.text};case"variable":return{range:s.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:s.to(G.range),expression:G.expression}}}ve.to=fe})(ee||(e.InlineValue=ee={}));var oe;(function(ve){function Se(G){return{frameId:G.frameId,stoppedLocation:s.from(G.stoppedLocation)}}ve.from=Se;function fe(G){return new i.$ZK(G.frameId,s.to(G.stoppedLocation))}ve.to=fe})(oe||(e.InlineValueContext=oe={}));var F;(function(ve){function Se(G){return{range:s.from(G.range),kind:G.kind}}ve.from=Se;function fe(G){return new i.$3J(s.to(G.range),G.kind)}ve.to=fe})(F||(e.DocumentHighlight=F={}));var z;(function(ve){function Se(fe){switch(fe){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}ve.to=Se})(z||(e.CompletionTriggerKind=z={}));var j;(function(ve){function Se(fe){return{triggerKind:z.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ve.to=Se})(j||(e.CompletionContext=j={}));var B;(function(ve){function Se(G){switch(G){case i.CompletionItemTag.Deprecated:return 1}}ve.from=Se;function fe(G){switch(G){case 1:return i.CompletionItemTag.Deprecated}}ve.to=fe})(B||(e.CompletionItemTag=B={}));var Q;(function(ve){const Se=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function fe(Oe){return Se.get(Oe)??9}ve.from=fe;const G=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Ce(Oe){return G.get(Oe)??i.CompletionItemKind.Property}ve.to=Ce})(Q||(e.CompletionItemKind=Q={}));var de;(function(ve){function Se(fe,G){const Ce=new i.$hK(fe.label);return Ce.insertText=fe.insertText,Ce.kind=Q.to(fe.kind),Ce.tags=fe.tags?.map(B.to),Ce.detail=fe.detail,Ce.documentation=I.$Mj(fe.documentation)?W.to(fe.documentation):fe.documentation,Ce.sortText=fe.sortText,Ce.filterText=fe.filterText,Ce.preselect=fe.preselect,Ce.commitCharacters=fe.commitCharacters,d.$Vr.isIRange(fe.range)?Ce.range=s.to(fe.range):typeof fe.range=="object"&&(Ce.range={inserting:s.to(fe.range.insert),replacing:s.to(fe.range.replace)}),Ce.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Ce.insertText=new i.$XJ(fe.insertText):(Ce.insertText=fe.insertText,Ce.textEdit=Ce.range instanceof i.$OJ?new i.$TJ(Ce.range,Ce.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ce.additionalTextEdits=fe.additionalTextEdits.map(Oe=>K.to(Oe))),Ce.command=G&&fe.command?G.fromInternal(fe.command):void 0,Ce}ve.to=Se})(de||(e.CompletionItem=de={}));var Ee;(function(ve){function Se(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:W.fromStrict(G.documentation)}}ve.from=Se;function fe(G){return{label:G.label,documentation:I.$Mj(G.documentation)?W.to(G.documentation):G.documentation}}ve.to=fe})(Ee||(e.ParameterInformation=Ee={}));var Pe;(function(ve){function Se(G){return{label:G.label,documentation:W.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(Ee.from):[],activeParameter:G.activeParameter}}ve.from=Se;function fe(G){return{label:G.label,documentation:I.$Mj(G.documentation)?W.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(Ee.to):[],activeParameter:G.activeParameter}}ve.to=fe})(Pe||(e.SignatureInformation=Pe={}));var Re;(function(ve){function Se(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Pe.from):[]}}ve.from=Se;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Pe.to):[]}}ve.to=fe})(Re||(e.SignatureHelp=Re={}));var Fe;(function(ve){function Se(fe,G){const Ce=new i.$gK(o.to(G.position),typeof G.label=="string"?G.label:G.label.map($e.to.bind(void 0,fe)),G.kind&&ke.to(G.kind));return Ce.textEdits=G.textEdits&&G.textEdits.map(K.to),Ce.tooltip=I.$Mj(G.tooltip)?W.to(G.tooltip):G.tooltip,Ce.paddingLeft=G.paddingLeft,Ce.paddingRight=G.paddingRight,Ce}ve.to=Se})(Fe||(e.InlayHint=Fe={}));var $e;(function(ve){function Se(fe,G){const Ce=new i.$fK(G.label);return Ce.tooltip=I.$Mj(G.tooltip)?W.to(G.tooltip):G.tooltip,m.Command.is(G.command)&&(Ce.command=fe.fromInternal(G.command)),G.location&&(Ce.location=N.to(G.location)),Ce}ve.to=Se})($e||(e.InlayHintLabelPart=$e={}));var ke;(function(ve){function Se(G){return G}ve.from=Se;function fe(G){return G}ve.to=fe})(ke||(e.InlayHintKind=ke={}));var ye;(function(ve){function Se(G){return{range:s.from(G.range),url:G.target,tooltip:G.tooltip}}ve.from=Se;function fe(G){let Ce;if(G.url)try{Ce=typeof G.url=="string"?l.URI.parse(G.url,!0):l.URI.revive(G.url)}catch{}return new i.$mK(s.to(G.range),Ce)}ve.to=fe})(ye||(e.DocumentLink=ye={}));var Te;(function(ve){function Se(G){const Ce=new i.$pK(G.label);return G.textEdit&&(Ce.textEdit=K.to(G.textEdit)),G.additionalTextEdits&&(Ce.additionalTextEdits=G.additionalTextEdits.map(Oe=>K.to(Oe))),Ce}ve.to=Se;function fe(G){return{label:G.label,textEdit:G.textEdit?K.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ce=>K.from(Ce)):void 0}}ve.from=fe})(Te||(e.ColorPresentation=Te={}));var ze;(function(ve){function Se(G){return new i.$nK(G[0],G[1],G[2],G[3])}ve.to=Se;function fe(G){return[G.red,G.green,G.blue,G.alpha]}ve.from=fe})(ze||(e.Color=ze={}));var xe;(function(ve){function Se(G){return{range:s.from(G.range)}}ve.from=Se;function fe(G){return new i.$9J(s.to(G.range))}ve.to=fe})(xe||(e.SelectionRange=xe={}));var qe;(function(ve){function Se(fe){switch(fe){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}ve.to=Se})(qe||(e.TextDocumentSaveReason=qe={}));var Ze;(function(ve){function Se(G){switch(G){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=Se;function fe(G){switch(G){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}ve.to=fe})(Ze||(e.TextEditorLineNumbersStyle=Ze={}));var Ye;(function(ve){function Se(G){if(G===i.EndOfLine.CRLF)return 1;if(G===i.EndOfLine.LF)return 0}ve.from=Se;function fe(G){if(G===1)return i.EndOfLine.CRLF;if(G===0)return i.EndOfLine.LF}ve.to=fe})(Ye||(e.EndOfLine=Ye={}));var tt;(function(ve){function Se(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=Se})(tt||(e.ProgressLocation=tt={}));var me;(function(ve){function Se(G){const Ce={start:G.start+1,end:G.end+1};return G.kind&&(Ce.kind=De.from(G.kind)),Ce}ve.from=Se;function fe(G){const Ce={start:G.start-1,end:G.end-1};return G.kind&&(Ce.kind=De.to(G.kind)),Ce}ve.to=fe})(me||(e.FoldingRange=me={}));var De;(function(ve){function Se(G){if(G)switch(G){case i.FoldingRangeKind.Comment:return m.$Bs.Comment;case i.FoldingRangeKind.Imports:return m.$Bs.Imports;case i.FoldingRangeKind.Region:return m.$Bs.Region}}ve.from=Se;function fe(G){if(G)switch(G.value){case m.$Bs.Comment.value:return i.FoldingRangeKind.Comment;case m.$Bs.Imports.value:return i.FoldingRangeKind.Imports;case m.$Bs.Region.value:return i.FoldingRangeKind.Region}}ve.to=fe})(De||(e.FoldingRangeKind=De={}));var Ae;(function(ve){function Se(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?s.from(fe.selection):void 0,override:typeof fe.override=="boolean"?h.$xE.id:void 0}}ve.from=Se})(Ae||(e.TextEditorOpenOptions=Ae={}));var Ne;(function(ve){function Se(Oe){return Oe instanceof i.$JK?Oe.toJSON():typeof Oe=="string"?Oe:fe(Oe)||G(Oe)?new i.$JK(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}ve.from=Se;function fe(Oe){const We=Oe;return We?l.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function G(Oe){const We=Oe;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function Ce(Oe){return typeof Oe=="string"?Oe:new i.$JK(l.URI.revive(Oe.baseUri),Oe.pattern)}ve.to=Ce})(Ne||(e.GlobPattern=Ne={}));var Be;(function(ve){function Se(fe){if(fe){if(Array.isArray(fe))return fe.map(Se);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:Ne.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}ve.from=Se})(Be||(e.LanguageSelector=Be={}));var Me;(function(ve){function Se(G){return!!G&&typeof G=="object"&&"selections"in G&&Array.isArray(G.selections)&&G.selections.every(Ce=>Ce instanceof i.$PJ)&&"related"in G&&Array.isArray(G.related)&&G.related.every(Ce=>Ce&&typeof Ce=="object"&&l.URI.isUri(Ce.uri)&&Ce.range instanceof i.$OJ)}ve.is=Se;function fe(G){return{selections:G.selections.map(Ce=>a.from(Ce)),related:G.related.map(Ce=>({uri:l.URI.from(Ce.uri),range:s.from(Ce.range)}))}}ve.from=fe})(Me||(e.MappedEditsContext=Me={}));var He;(function(ve){function Se(G){return{start:G.start,end:G.end}}ve.from=Se;function fe(G){return new i.$$K(G.start,G.end)}ve.to=fe})(He||(e.NotebookRange=He={}));var Ge;(function(ve){function Se(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}ve.to=Se;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}ve.from=fe})(Ge||(e.NotebookCellExecutionSummary=Ge={}));var Je;(function(ve){function Se(fe){if(fe===g.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(fe===g.NotebookCellExecutionState.Pending)return;if(fe===g.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ve.to=Se})(Je||(e.NotebookCellExecutionState=Je={}));var Ve;(function(ve){function Se(G){switch(G){case i.NotebookCellKind.Markup:return g.CellKind.Markup;case i.NotebookCellKind.Code:default:return g.CellKind.Code}}ve.from=Se;function fe(G){switch(G){case g.CellKind.Markup:return i.NotebookCellKind.Markup;case g.CellKind.Code:default:return i.NotebookCellKind.Code}}ve.to=fe})(Ve||(e.NotebookCellKind=Ve={}));var et;(function(ve){function Se(G){const Ce={metadata:G.metadata??Object.create(null),cells:[]};for(const Oe of G.cells)i.$_K.validate(Oe),Ce.cells.push(Xe.from(Oe));return Ce}ve.from=Se;function fe(G){const Ce=new i.$aL(G.cells.map(Xe.to));return(0,w.$ve)(G.metadata)||(Ce.metadata=G.metadata),Ce}ve.to=fe})(et||(e.NotebookData=et={}));var Xe;(function(ve){function Se(G){return{cellKind:Ve.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Ge.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(ft.from):[]}}ve.from=Se;function fe(G){return new i.$_K(Ve.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(ft.to):void 0,G.metadata,G.internalMetadata?Ge.to(G.internalMetadata):void 0)}ve.to=fe})(Xe||(e.NotebookCellData=Xe={}));var ot;(function(ve){function Se(G){return{mime:G.mime,valueBytes:R.$Ec.wrap(G.data)}}ve.from=Se;function fe(G){return new i.$bL(G.valueBytes.buffer,G.mime)}ve.to=fe})(ot||(e.NotebookCellOutputItem=ot={}));var ft;(function(ve){function Se(G){return{outputId:G.id,items:G.items.map(ot.from),metadata:G.metadata}}ve.from=Se;function fe(G){const Ce=G.items.map(ot.to);return new i.$cL(Ce,G.outputId,G.metadata)}ve.to=fe})(ft||(e.NotebookCellOutput=ft={}));var rt;(function(ve){function Se(Ce){return G(Ce)?{include:Ne.from(Ce.include)??void 0,exclude:Ne.from(Ce.exclude)??void 0}:Ne.from(Ce)??void 0}ve.from=Se;function fe(Ce){return G(Ce)?{include:Ne.to(Ce.include),exclude:Ne.to(Ce.exclude)}:Ne.to(Ce)}ve.to=fe;function G(Ce){const Oe=Ce;return Oe?!(0,w.$re)(Oe.include)&&!(0,w.$re)(Oe.exclude):!1}})(rt||(e.NotebookExclusiveDocumentPattern=rt={}));var Mt;(function(ve){function Se(fe,G,Ce){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Oe,Ce),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ve.from=Se})(Mt||(e.NotebookStatusBarItem=Mt={}));var $t;(function(ve){function Se(fe,G,Ce){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(Oe,Ce),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}ve.from=Se})($t||(e.NotebookKernelSourceAction=$t={}));var Ct;(function(ve){function Se(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ve.from=Se})(Ct||(e.NotebookDocumentContentOptions=Ct={}));var mt;(function(ve){function Se(G){return{uri:G.uri,provides:G.provides}}ve.from=Se;function fe(G){return new i.$eL(l.URI.revive(G.uri),G.provides)}ve.to=fe})(mt||(e.NotebookRendererScript=mt={}));var wt;(function(ve){function Se(G){return{message:W.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:s.from(G.location.range),uri:G.location.uri}}}ve.from=Se;function fe(G){const Ce=new i.$kL(typeof G.message=="string"?G.message:W.to(G.message));return Ce.actualOutput=G.actual,Ce.expectedOutput=G.expected,Ce.contextValue=G.contextValue,Ce.location=G.location?N.to(G.location):void 0,Ce}ve.to=fe})(wt||(e.TestMessage=wt={}));var vt;(function(ve){ve.namespace=p.$BI,ve.denamespace=p.$CI})(vt||(e.TestTag=vt={}));var Tt;(function(ve){function Se(G){const Ce=(0,u.$IL)(G).controllerId;return{extId:y.$xI.fromExtHostTestItem(G,Ce).toString(),label:G.label,uri:l.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Oe=>vt.namespace(Ce,Oe.id)),range:d.$Vr.lift(s.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&W.fromStrict(G.error)||null}}ve.from=Se;function fe(G){return{parent:void 0,error:void 0,id:y.$xI.fromString(G.extId).localId,label:G.label,uri:l.URI.revive(G.uri),tags:(G.tags||[]).map(Ce=>{const{tagId:Oe}=vt.denamespace(Ce);return new i.$lL(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}ve.toPlain=fe})(Tt||(e.TestItem=Tt={})),function(ve){function Se(G){return{id:G.id}}ve.from=Se;function fe(G){return new i.$lL(G.id)}ve.to=fe}(vt||(e.TestTag=vt={}));var Pt;(function(ve){const Se=(G,Ce)=>{const Oe=[];for(const[Ue,Qe]of Ce)y.$xI.compare(Qe.item.extId,Ue)===2&&(Ce.delete(Ue),Oe.push(Qe));const We={...Tt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ue=>({state:Ue.state,duration:Ue.duration,messages:Ue.messages.filter(Qe=>Qe.type===0).map(wt.to)})),children:Oe.map(Ue=>Se(Ue,Ce))};for(const Ue of We.children)Ue.parent=We;return We};function fe(G){const Ce=[],Oe=new Map;for(const We of G.items){Oe.set(We.item.extId,We);const Ue=y.$xI.root(We.item.extId);G.request.targets.some(Qe=>Qe.controllerId===Ue&&Qe.testIds.includes(We.item.extId))&&Ce.push(We)}return{completedAt:G.completedAt,results:Ce.map(We=>Se(We,Oe))}}ve.to=fe})(Pt||(e.TestResults=Pt={}));var Et;(function(ve){function Se(Oe){return{covered:Oe.covered,total:Oe.covered}}function fe(Oe){return"line"in Oe?o.from(Oe):s.from(Oe)}function G(Oe){return"branches"in Oe?{count:Oe.executionCount,location:fe(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(We=>({count:We.executionCount,location:We.location&&fe(We.location)})):void 0}:{type:0,count:Oe.executionCount,location:fe(Oe.location)}}ve.fromDetailed=G;function Ce(Oe){return{uri:Oe.uri,statement:Se(Oe.statementCoverage),branch:Oe.branchCoverage&&Se(Oe.branchCoverage),function:Oe.functionCoverage&&Se(Oe.functionCoverage),details:Oe.detailedCoverage?.map(G)}}ve.fromFile=Ce})(Et||(e.TestCoverage=Et={}));var jt;(function(ve){function Se(fe){switch(fe){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}ve.to=Se})(jt||(e.CodeActionTriggerKind=jt={}));var It;(function(ve){function Se(G){const Ce=new i.$rL(H.to(G.kind),G.name,G.detail||"",l.URI.revive(G.uri),s.to(G.range),s.to(G.selectionRange));return Ce._sessionId=G._sessionId,Ce._itemId=G._itemId,Ce}ve.to=Se;function fe(G,Ce,Oe){if(Ce=Ce??G._sessionId,Oe=Oe??G._itemId,Ce===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Oe,kind:H.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:s.from(G.range),selectionRange:s.from(G.selectionRange),tags:G.tags?.map(_.from)}}ve.from=fe})(It||(e.TypeHierarchyItem=It={}));var bt;(function(ve){function Se(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}ve.from=Se})(bt||(e.ViewBadge=bt={}));var At;(function(ve){function Se(Oe,We,Ue){const Qe=We.fileData;return Qe?new i.$CK(new i.$DK(Qe.name,l.URI.revive(Qe.uri),Qe.id,(0,S.$cb)(()=>Ue(Qe.id)))):Oe===A.$zr.uriList&&We.uriListData?new i.$BK(Ce(We.uriListData)):new i.$BK(We.asString)}ve.to=Se;async function fe(Oe,We){const Ue=await We.asString();if(Oe===A.$zr.uriList)return{asString:Ue,fileData:void 0,uriListData:G(Ue)};const Qe=We.asFile();return{asString:Ue,fileData:Qe?{name:Qe.name,uri:Qe.uri,id:Qe._itemId??Qe.id}:void 0}}ve.from=fe;function G(Oe){return r.$js.split(Oe).map(We=>{if(We.startsWith("#"))return We;try{return l.URI.parse(We)}catch{}return We})}function Ce(Oe){return r.$js.create(Oe.map(We=>typeof We=="string"?We:l.URI.revive(We)))}})(At||(e.DataTransferItem=At={}));var Lt;(function(ve){function Se(G,Ce){const Oe=G.items.map(([We,Ue])=>[We,At.to(We,Ue,Ce)]);return new i.$EK(Oe)}ve.toDataTransfer=Se;async function fe(G){const Ce={items:[]},Oe=[];for(const[We,Ue]of G)Oe.push((async()=>{Ce.items.push([We,await At.from(We,Ue)])})());return await Promise.all(Oe),Ce}ve.from=fe})(Lt||(e.DataTransfer=Lt={}));var st;(function(ve){function Se(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}ve.to=Se;function fe(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}ve.from=fe})(st||(e.ChatReplyFollowup=st={}));var pt;(function(ve){function Se(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:st.from(fe)}ve.from=Se})(pt||(e.ChatFollowup=pt={}));var gt;(function(ve){function Se(G){const Ce=new i.$BL(ut.to(G.role),G.content);return Ce.name=G.name,Ce}ve.to=Se;function fe(G){return{role:ut.from(G.role),content:G.content,name:G.name}}ve.from=fe})(gt||(e.ChatMessage=gt={}));var ut;(function(ve){function Se(G){switch(G){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}ve.to=Se;function fe(G){switch(G){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}ve.from=fe})(ut||(e.ChatMessageRole=ut={}));var zt;(function(ve){function Se(G){return{level:Rt.to(G.level),value:G.value,description:G.description}}ve.to=Se;function fe(G){return{level:Rt.from(G.level),value:G.value,description:G.description}}ve.from=fe})(zt||(e.ChatVariable=zt={}));var Rt;(function(ve){function Se(G){switch(G){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}ve.to=Se;function fe(G){switch(G){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}ve.from=fe})(Rt||(e.ChatVariableLevel=Rt={}));var Bt;(function(ve){function Se(fe,G,Ce){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand}:"uri"in fe?{uri:fe.uri}:G.toInternal(fe,Ce)}ve.from=Se})(Bt||(e.TerminalQuickFix=Bt={}))}),define(we[275],be([1,0,43,134,71,133,93,137,4]),function(le,e,v,R,r,S,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=e.$ZL=e.$YL=void 0;const $=(g,y,p,t)=>{let i=y;return{enumerable:!0,configurable:!1,get(){return i},set(a){if(!p(i,a)){const s=i;i=a,g.listener?.(t(a,s))}}}},A=(g,y)=>g===y,E={range:(g,y)=>g===y?!0:!g||!y?!1:g.isEqual(y),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(g,y)=>!(g.length!==y.length||g.some(p=>!y.find(t=>p.id===t.id)))},w=g=>y=>({op:4,update:g(y)}),l=(g,y)=>({range:(()=>{let p;const t=w(i=>({range:v.$Vr.lift(P.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return p},set(i){g.listener?.({op:6}),E.range(p,i)||(p=i,g.listener?.(t(i)))}}})(),label:$(g,y,E.label,w(p=>({label:p}))),description:$(g,void 0,E.description,w(p=>({description:p}))),sortText:$(g,void 0,E.sortText,w(p=>({sortText:p}))),canResolveChildren:$(g,!1,E.canResolveChildren,p=>({op:2,state:p})),busy:$(g,!1,E.busy,w(p=>({busy:p}))),error:$(g,void 0,E.error,w(p=>({error:P.MarkdownString.fromStrict(p)||null}))),tags:$(g,[],E.tags,(p,t)=>({op:1,new:p.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),d=g=>{const y=r.$xI.fromString(g.extId),p=new c(y.controllerId,y.localId,g.label,b.URI.revive(g.uri)||void 0);return p.range=P.Range.to(g.range||void 0),p.description=g.description||void 0,p.sortText=g.sortText||void 0,p.tags=g.tags.map(t=>P.TestTag.to({id:(0,I.$CI)(t).tagId})),p},m=g=>{let y;for(const p of g.tests){const t=d(p.item);(0,R.$IL)(t).parent=y,y=t}return y};e.$YL=m;class c{constructor(y,p,t,i){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const a=(0,R.$HL)(this,y);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof u?void 0:a.parent}},children:{value:(0,S.$GL)(a,R.$IL,c),enumerable:!0,writable:!1},...l(a,t)})}}e.$ZL=c;class u extends c{constructor(y,p){super(y,y,p,void 0),this._isRoot=!0}}e.$1L=u;class h extends S.$CL{constructor(y,p,t){super({controllerId:y,getDocumentVersion:i=>i&&t.getDocument(i)?.version,getApiFor:R.$IL,getChildren:i=>i.children,root:new u(y,p),toITestItem:P.TestItem.from})}}e.$2L=h}),define(we[276],be([1,0,272,119,90,88,135,92,136,13,221,270,89]),function(le,e,v,R,r,S,I,P,b,$,A,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=void 0,e.$PM="remoteterminal";let l=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(m,c,u,h,g,y,p,t,i,a){this.a=m,this.b=c,this.c=u,this.d=h,this.e=g,this.f=y,this.g=p,this.h=t,this.i=i,this.j=a}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(m,c,u,h,g,y,p,t){await this.c.whenRemoteConfigurationLoaded();const i=Object.create(null),a=u?this.d.getWorkspaceFolder(u)??void 0:void 0;let s;try{s=(await this.e.resolveAnyMap(a,{shellLaunchConfig:m,configuration:c})).resolvedVariables}catch(x){this.h.error(x)}if(s)for(const[x,ae]of s.entries())(/^config:/.test(x)||x==="selectedText"||x==="lineNumber")&&(i[x]=ae);const n=[];for(const[x,ae]of this.f.collections.entries())n.push([x,(0,S.$5q)(ae.map),(0,S.$6q)(ae.descriptionMap)]);const o=await this.g.resolveAuthority(this.a),f=o.options&&o.options.extensionHostEnv,k=this.d.getWorkspace(),D=k.folders,C=u?this.d.getWorkspaceFolder(u):null,L=P.$SE.getOriginalUri(this.i.activeEditor,{supportSideBySide:P.SideBySideEditor.PRIMARY,filterByScheme:[$.Schemas.file,$.Schemas.vscodeUserData,$.Schemas.vscodeRemote]}),U={configuration:c,resolvedVariables:i,envVariableCollections:n,shellLaunchConfig:m,workspaceId:k.id,workspaceName:this.j.getWorkspaceLabel(k),workspaceFolders:D,activeWorkspaceFolder:C,activeFileResource:L,shouldPersistTerminal:g,options:h,cols:y,rows:p,unicodeVersion:t,resolverEnv:f};return await this.b.call("$createProcess",U)}requestDetachInstance(m,c){return this.b.call("$requestDetachInstance",[m,c])}acceptDetachInstanceReply(m,c){return this.b.call("$acceptDetachInstanceReply",[m,c])}attachToProcess(m){return this.b.call("$attachToProcess",[m])}detachFromProcess(m,c){return this.b.call("$detachFromProcess",[m,c])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(m,c){return this.b.call("$processBinary",[m,c])}start(m){return this.b.call("$start",[m])}input(m,c){return this.b.call("$input",[m,c])}acknowledgeDataEvent(m,c){return this.b.call("$acknowledgeDataEvent",[m,c])}setUnicodeVersion(m,c){return this.b.call("$setUnicodeVersion",[m,c])}shutdown(m,c){return this.b.call("$shutdown",[m,c])}resize(m,c,u){return this.b.call("$resize",[m,c,u])}clearBuffer(m){return this.b.call("$clearBuffer",[m])}getInitialCwd(m){return this.b.call("$getInitialCwd",[m])}getCwd(m){return this.b.call("$getCwd",[m])}orphanQuestionReply(m){return this.b.call("$orphanQuestionReply",[m])}sendCommandResult(m,c,u){return this.b.call("$sendCommandResult",[m,c,u])}freePortKillProcess(m){return this.b.call("$freePortKillProcess",[m])}installAutoReply(m,c){return this.b.call("$installAutoReply",[m,c])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(m){return this.b.call("$getDefaultSystemShell",[m])}getProfiles(m,c,u){return this.b.call("$getProfiles",[this.d.getWorkspace().id,m,c,u])}acceptPtyHostResolvedVariables(m,c){return this.b.call("$acceptPtyHostResolvedVariables",[m,c])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(m,c){return this.b.call("$getWslPath",[m,c])}setTerminalLayoutInfo(m){const u={workspaceId:this.d.getWorkspace().id,tabs:m?m.tabs:[]};return this.b.call("$setTerminalLayoutInfo",u)}updateTitle(m,c,u){return this.b.call("$updateTitle",[m,c,u])}updateIcon(m,c,u,h){return this.b.call("$updateIcon",[m,c,u,h])}refreshProperty(m,c){return this.b.call("$refreshProperty",[m,c])}updateProperty(m,c,u){return this.b.call("$updateProperty",[m,c,u])}getTerminalLayoutInfo(){const c={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",c)}reviveTerminalProcesses(m,c,u){return this.b.call("$reviveTerminalProcesses",[m,c,u])}getRevivedPtyNewId(m){return this.b.call("$getRevivedPtyNewId",[m])}serializeTerminalState(m){return this.b.call("$serializeTerminalState",[m])}};e.$QM=l,e.$QM=l=Le([Ie(2,v.$cE),Ie(3,r.$yh),Ie(4,I.$yM),Ie(5,E.$dM),Ie(6,R.$wk),Ie(7,w.$Rq),Ie(8,b.$YC),Ie(9,A.$Lz)],l)}),define(we[277],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.ExtHostConnectionType=void 0;var v;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(v||(e.ExtHostConnectionType=v={}));class R{constructor(E){this.pipeName=E,this.type=1}serialize(E){E[R.ENV_KEY]=this.pipeName}}e.$bm=R,R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class r{constructor(){this.type=2}serialize(E){E[r.ENV_KEY]="1"}}e.$cm=r,r.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class S{constructor(){this.type=3}serialize(E){E[S.ENV_KEY]="1"}}e.$dm=S,S.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function I(A){delete A[R.ENV_KEY],delete A[r.ENV_KEY],delete A[S.ENV_KEY]}function P(A,E){I(E),A.serialize(E)}e.$em=P;function b(A){if(A[R.ENV_KEY])return $(A,new R(A[R.ENV_KEY]));if(A[r.ENV_KEY])return $(A,new r);if(A[S.ENV_KEY])return $(A,new S);throw new Error("No connection information defined in environment!")}e.$fm=b;function $(A,E){return I(A),E}}),define(we[278],be([1,0,15]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Sl=e.$Rl=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(R||(e.UIKind=R={}));var r;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(r||(e.ExtensionHostExitCode=r={}));var S;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(S||(e.MessageType=S={}));function I($){const A=v.$Ec.alloc(1);switch($){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$Rl=I;function P($,A){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$Sl=P;var b;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(we[279],be([1,0,6,5,12,266,278,56,36,22,4,2,200]),function(le,e,v,R,r,S,I,P,b,$,A,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=e.$5L=e.$4L=void 0;let l=class extends E.$lb{constructor(u,h){super(),this.n=u,this.p=h,this.a=this.B(new R.$ec),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$ec),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=A.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=h.createLogger(this.j,{id:b.$0n,name:(0,w.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(h.onDidChangeLogLevel(g=>{(0,r.$Ti)(g)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===r.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,h,g){const y=this.getTelemetryDetails(),p=new d(h,g,u,this.k,this.i,this.getBuiltInCommonProperties(u),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled}),t=this.m.get(u.identifier.value)??[];return this.m.set(u.identifier.value,[...t,p]),p.apiTelemetryLogger}$initializeTelemetryLevel(u,h,g){this.f=u,this.g=h,this.c=g??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(u){const h=Object.create(null);switch(h["common.extname"]=`${u.publisher}.${u.name}`,h["common.extversion"]=u.version,h["common.vscodemachineid"]=this.n.telemetryInfo.machineId,h["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,h["common.vscodeversion"]=this.n.version,h["common.isnewappinstall"]=m(this.n.telemetryInfo.firstSessionDate),h["common.product"]=this.n.environment.appHost,this.n.uiKind){case I.UIKind.Web:h["common.uikind"]="web";break;case I.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,P.$Ck)((0,b.$eo)(this.n.remote.authority)),h}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const h=this.getTelemetryDetails();this.m.forEach((g,y)=>{const p=g.filter(t=>!t.isDisposed);p.length===0?this.m.delete(y):this.m.set(y,p)}),this.m.forEach(g=>{for(const y of g)y.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(u,h){const y=this.m.get(u.value)?.filter(t=>!t.isDisposed);if(!y)return this.m.delete(u.value),!1;let p=!1;for(const t of y)t.ignoreUnhandledExtHostErrors||(t.logError(h),p=!0);return p}};e.$4L=l,e.$4L=l=Le([Ie(0,S.$3L),Ie(1,r.$Si)],l);class d{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,h,g,y,p,t,i){this.g=g,this.h=y,this.i=p,this.j=t,this.a=new R.$ec,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this.b=h?.ignoreBuiltInCommonProperties??!1,this.c=h?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}}updateTelemetryEnablements(u,h){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:h},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let h="properties"in u?u.properties??{}:u;return h=(0,b.$ho)(h,[]),this.c&&(h=(0,$.$Mm)(h,this.c)),this.b||(h=(0,$.$Mm)(h,this.j)),"properties"in u?u.properties=h:u=h,u}k(u,h){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,h=this.mixInCommonPropsAndCleanData(h||{}),this.i||this.f?.sendEventData(u,h),this.h.trace(u,h))}logUsage(u,h){this.d.isUsageEnabled&&this.k(u,h)}logError(u,h){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,h);else{const g={name:u.name,message:u.message,stack:u.stack,cause:u.cause},y=(0,b.$ho)(g,[]),p=new Error(y.message,{cause:y.cause});p.stack=y.stack,p.name=y.name,h=this.mixInCommonPropsAndCleanData(h||{}),this.i||this.f.sendErrorData(p,h),this.h.trace("exception",h)}}get apiTelemetryLogger(){if(!this.e){const u=this,h={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(h)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$5L=d;function m(c){const u=Date.now()-new Date(c).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$6L=m,e.$7L=(0,v.$ph)("IExtHostTelemetry")}),define(we[280],be([1,0,40,203,53]),function(le,e,v,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0;function S(I,P,b,$){const A=new v.$Ll;return I.forEach(E=>{const w=A.get(E.identifier);w&&$.warn((0,R.localize)(0,null,w.extensionLocation.fsPath,E.extensionLocation.fsPath)),A.set(E.identifier,E)}),P.forEach(E=>{const w=A.get(E.identifier);if(w)if(w.isBuiltin){if(r.gte(w.version,E.version)){$.warn(`Skipping extension ${E.extensionLocation.path} in favour of the builtin extension ${w.extensionLocation.path}.`);return}E.isBuiltin=!0}else $.warn((0,R.localize)(1,null,w.extensionLocation.fsPath,E.extensionLocation.fsPath));else if(E.isBuiltin){$.warn(`Skipping obsolete builtin extension ${E.extensionLocation.path}`);return}A.set(E.identifier,E)}),b.forEach(E=>{$.info((0,R.localize)(2,null,E.extensionLocation.fsPath));const w=A.get(E.identifier);w&&w.isBuiltin&&(E.isBuiltin=!0),A.set(E.identifier,E)}),Array.from(A.values())}e.$_M=S}),define(we[281],be([1,0,7,3,29,4,41,51,66,57,280,13]),function(le,e,v,R,r,S,I,P,b,$,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.$cN=void 0;class w{constructor(m,c,u,h,g,y,p){this.c=m,this.d=u,this.f=h,this.g=g,this.h=y,this.i=p,this.a=Promise.resolve(),this.b=Promise.resolve();const t=c.args["install-builtin-extension"];if(t){g.trace("Installing builtin extensions passed via args...");const a={isMachineScoped:!!c.args["do-not-sync"],installPreReleaseVersion:!!c.args["pre-release"]};I.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=m.installExtensions([],this.j(t),a,!!c.args.force).then(()=>{I.mark("code/server/didInstallBuiltinExtensions"),g.trace("Finished installing builtin extensions")},s=>{g.error(s)})}const i=c.args["install-extension"];i&&(g.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>m.installExtensions(this.j(i),[],{isMachineScoped:!!c.args["do-not-sync"],installPreReleaseVersion:!!c.args["pre-release"],isApplicationScoped:!0},!!c.args.force)).then(()=>{g.trace("Finished installing extensions")},a=>{g.error(a)}))}j(m){return m.map(c=>/\.vsix$/i.test(c)?S.URI.file((0,v.$7c)(c)?c:(0,v.$8c)((0,r.cwd)(),c)):c)}whenExtensionsReady(){return this.b}async scanExtensions(m,c,u,h){I.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${m}`),await this.a;const g=u?u.filter(p=>p.scheme===E.Schemas.file).map(p=>p.fsPath):void 0;c=c??this.d.defaultProfile.extensionsResource;const y=await this.k(c,m??R.$q,g,h);return this.g.trace("Scanned Extensions",y),this.r(y),I.mark("code/server/didScanExtensions"),y}async scanSingleExtension(m,c,u){await this.a;const h=m.scheme===E.Schemas.file?m.fsPath:null;if(!h)return null;const g=await this.o(h,c,u??R.$q);return g?(this.r([g]),g):null}async k(m,c,u,h){await this.q(c,h);const[g,y,p]=await Promise.all([this.m(c),this.n(m,c),this.l(c,u)]);return(0,A.$_M)(g,y,p,this.g)}async l(m,c){return c?(await Promise.all(c.map(u=>this.f.scanOneOrMultipleExtensions(S.URI.file((0,v.$9c)(u)),1,{language:m})))).flat().map(u=>(0,$.$jp)(u,!0)):[]}async m(m){return(await this.f.scanSystemExtensions({language:m,useCache:!0})).map(u=>(0,$.$jp)(u,!1))}async n(m,c){return(await this.f.scanUserExtensions({profileLocation:m,language:c,useCache:!0})).map(h=>(0,$.$jp)(h,!1))}async o(m,c,u){const h=S.URI.file((0,v.$9c)(m)),g=c?0:1,y=await this.f.scanExistingExtension(h,g,{language:u});return y?(0,$.$jp)(y,!1):null}async q(m,c){if(!(m===R.$a||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(h=>h.id===m)){this.g.trace(`Language Pack ${m} is already installed. Skipping language pack installation.`);return}}catch(u){this.g.error(u)}if(!c){this.g.trace(`No language pack id provided for language ${m}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${c} for language ${m} is not installed. It will be installed now.`);try{await this.c.installExtensions([c],[],{isMachineScoped:!0},!0)}catch(u){this.g.error(u)}}}r(m){const c=(t,i)=>t.replace(/file/g,"vscode-remote"),u=t=>{let i="";return i+=t.global?"g":"",i+=t.ignoreCase?"i":"",i+=t.multiline?"m":"",new RegExp(c(t.source,!0),i)},h=new class{mapDefined(t){return b.$Ai.create(t)}mapNot(t){return b.$Fi.create(t)}mapEquals(t,i){return t==="resourceScheme"&&typeof i=="string"?b.$Bi.create(t,c(i,!1)):b.$Bi.create(t,i)}mapNotEquals(t,i){return t==="resourceScheme"&&typeof i=="string"?b.$Ei.create(t,c(i,!1)):b.$Ei.create(t,i)}mapGreater(t,i){return b.$Gi.create(t,i)}mapGreaterEquals(t,i){return b.$Hi.create(t,i)}mapSmaller(t,i){return b.$Ii.create(t,i)}mapSmallerEquals(t,i){return b.$Ji.create(t,i)}mapRegex(t,i){return t==="resourceScheme"&&i?b.$Ki.create(t,u(i)):b.$Ki.create(t,i)}mapIn(t,i){return b.$Ci.create(t,i)}mapNotIn(t,i){return b.$Di.create(t,i)}},g=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const i=b.$vi.deserialize(t.when);if(!i)return;const a=i.map(h);t.when=a.serialize()},y=t=>{if(Array.isArray(t))for(const i of t)g(i);else g(t)},p=t=>{for(const i in t)y(t[i])};m.forEach(t=>{t.contributes&&(t.contributes.menus&&p(t.contributes.menus),t.contributes.keybindings&&y(t.contributes.keybindings),t.contributes.views&&p(t.contributes.views))})}}e.$cN=w;class l{constructor(m,c){this.a=m,this.b=c}listen(m,c){throw new Error("Invalid listen")}async call(m,c,u){const h=this.b(m);switch(c){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const g=u[0],y=u[1]?S.URI.revive(h.transformIncoming(u[1])):void 0,p=Array.isArray(u[2])?u[2].map(a=>S.URI.revive(h.transformIncoming(a))):void 0,t=u[3];return(await this.a.scanExtensions(g,y,p,t)).map(a=>(0,P.$rm)(a,h))}case"scanSingleExtension":{const g=await this.a.scanSingleExtension(S.URI.revive(h.transformIncoming(u[0])),u[1],u[2]);return g?(0,P.$rm)(g,h):null}}throw new Error("Invalid call")}}e.$dN=l}),define(we[138],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6z=e.$5z=e.$4z=e.$3z=void 0;class v{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++v.count}}e.$3z=v,v.count=0;const R=[];function r(P){const b=new v(P);return R[b.nid]=b,b}e.$4z=r;function S(P){return R[P].sid}e.$5z=S;class I{constructor(b){this.value=b}}e.$6z=I}),define(we[282],be([1,0,138]),function(le,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$JJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var r;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(r||(e.TabInputKind=r={}));var S;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(S||(e.TabModelOperationKind=S={}));var I;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(I||(e.WebviewEditorCapabilities=I={}));var P;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(P||(e.WebviewMessageArrayBufferViewType=P={}));var b;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var $;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var A;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class E{static mixin(c){return c._id=E.a++,c}}e.$JJ=E,E.a=0;var w;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var l;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(l||(e.ISuggestResultDtoField=l={}));var d;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$KJ={MainThreadAuthentication:(0,v.$4z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$4z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,v.$4z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,v.$4z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,v.$4z)("MainThreadChatVariables"),MainThreadClipboard:(0,v.$4z)("MainThreadClipboard"),MainThreadCommands:(0,v.$4z)("MainThreadCommands"),MainThreadComments:(0,v.$4z)("MainThreadComments"),MainThreadConfiguration:(0,v.$4z)("MainThreadConfiguration"),MainThreadConsole:(0,v.$4z)("MainThreadConsole"),MainThreadDebugService:(0,v.$4z)("MainThreadDebugService"),MainThreadDecorations:(0,v.$4z)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$4z)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$4z)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$4z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$4z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$4z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$4z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$4z)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$4z)("MainThreadErrors"),MainThreadTreeViews:(0,v.$4z)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$4z)("MainThreadDownloadService"),MainThreadKeytar:(0,v.$4z)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,v.$4z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$4z)("MainThreadLanguages"),MainThreadLogger:(0,v.$4z)("MainThreadLogger"),MainThreadMessageService:(0,v.$4z)("MainThreadMessageService"),MainThreadOutputService:(0,v.$4z)("MainThreadOutputService"),MainThreadProgress:(0,v.$4z)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$4z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$4z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$4z)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$4z)("MainThreadSecretState"),MainThreadStorage:(0,v.$4z)("MainThreadStorage"),MainThreadTelemetry:(0,v.$4z)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$4z)("MainThreadTerminalService"),MainThreadWebviews:(0,v.$4z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$4z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$4z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$4z)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$4z)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$4z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$4z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$4z)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$4z)("MainThreadFileSystem"),MainThreadExtensionService:(0,v.$4z)("MainThreadExtensionService"),MainThreadSCM:(0,v.$4z)("MainThreadSCM"),MainThreadSearch:(0,v.$4z)("MainThreadSearch"),MainThreadShare:(0,v.$4z)("MainThreadShare"),MainThreadTask:(0,v.$4z)("MainThreadTask"),MainThreadWindow:(0,v.$4z)("MainThreadWindow"),MainThreadLabelService:(0,v.$4z)("MainThreadLabelService"),MainThreadNotebook:(0,v.$4z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$4z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$4z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$4z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$4z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$4z)("MainThreadInteractive"),MainThreadChat:(0,v.$4z)("MainThreadChat"),MainThreadInlineChat:(0,v.$4z)("MainThreadInlineChatShape"),MainThreadTheming:(0,v.$4z)("MainThreadTheming"),MainThreadTunnelService:(0,v.$4z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$4z)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$4z)("MainThreadTimeline"),MainThreadTesting:(0,v.$4z)("MainThreadTesting"),MainThreadLocalization:(0,v.$4z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$4z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$4z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,v.$4z)("MainThreadIssueReporter")},e.$LJ={ExtHostCommands:(0,v.$4z)("ExtHostCommands"),ExtHostConfiguration:(0,v.$4z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$4z)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$4z)("ExtHostDebugService"),ExtHostDecorations:(0,v.$4z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$4z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$4z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$4z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$4z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$4z)("ExtHostEditors"),ExtHostTreeViews:(0,v.$4z)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$4z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$4z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$4z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$4z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$4z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$4z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$4z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$4z)("ExtHostStatusBar"),ExtHostShare:(0,v.$4z)("ExtHostShare"),ExtHostExtensionService:(0,v.$4z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$4z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$4z)("ExtHostTerminalService"),ExtHostSCM:(0,v.$4z)("ExtHostSCM"),ExtHostSearch:(0,v.$4z)("ExtHostSearch"),ExtHostTask:(0,v.$4z)("ExtHostTask"),ExtHostWorkspace:(0,v.$4z)("ExtHostWorkspace"),ExtHostWindow:(0,v.$4z)("ExtHostWindow"),ExtHostWebviews:(0,v.$4z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$4z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$4z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$4z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$4z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$4z)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$4z)("ExtHostProgress"),ExtHostComments:(0,v.$4z)("ExtHostComments"),ExtHostSecretState:(0,v.$4z)("ExtHostSecretState"),ExtHostStorage:(0,v.$4z)("ExtHostStorage"),ExtHostUrls:(0,v.$4z)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$4z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$4z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$4z)("ExtHostOutputService"),ExtHosLabelService:(0,v.$4z)("ExtHostLabelService"),ExtHostNotebook:(0,v.$4z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$4z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$4z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$4z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$4z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$4z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$4z)("ExtHostInteractive"),ExtHostInlineChat:(0,v.$4z)("ExtHostInlineChatShape"),ExtHostChat:(0,v.$4z)("ExtHostChat"),ExtHostChatSlashCommands:(0,v.$4z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,v.$4z)("ExtHostChatVariables"),ExtHostChatProvider:(0,v.$4z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,v.$4z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$4z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$4z)("ExtHostTheming"),ExtHostTunnelService:(0,v.$4z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$4z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$4z)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$4z)("ExtHostTimeline"),ExtHostTesting:(0,v.$4z)("ExtHostTesting"),ExtHostTelemetry:(0,v.$4z)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$4z)("ExtHostLocalization"),ExtHostIssueReporter:(0,v.$4z)("ExtHostIssueReporter")}});var Ft=this&&this.__classPrivateFieldSet||function(le,e,v,R,r){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!r)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?le!==e||!r:!e.has(le))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?r.call(le,v):r?r.value=v:e.set(le,v),v},it=this&&this.__classPrivateFieldGet||function(le,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?le!==e||!R:!e.has(le))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(le):R?R.value:e.get(le)};define(we[283],be([1,0,8,132,137,22,282,18,12,50,43,109,4,2,6,267,275,15,138,39,60,36,279]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g,y,p,t){"use strict";var i,a,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=void 0;let n=class{constructor(L,U,x){i.set(this,void 0),this.b=new Map,this.c=new Map,a.set(this,void 0),s.set(this,void 0),Ft(this,i,L.getProxy(I.$KJ.MainThreadCommands),"f"),this.d=U,Ft(this,s,x,"f"),Ft(this,a,L.getProxy(I.$KJ.MainThreadTelemetry),"f"),this.converter=new o(this,ae=>{const W=this.c.get(ae);return W?.result===k.Void?W:void 0},U),this.f=[{processArgument(ae){return(0,$.$Yg)(ae)}},{processArgument(ae){return(0,S.$Lm)(ae,function(W){if(A.$Vr.isIRange(W))return r.Range.to(W);if(E.$Ur.isIPosition(W))return r.Position.to(W);if(A.$Vr.isIRange(W.range)&&w.URI.isUri(W.uri))return r.location.to(W);if(W instanceof u.$Ec)return W.buffer.buffer;if(!Array.isArray(W))return W})}}]}registerArgumentProcessor(L){this.f.push(L)}registerApiCommand(L){const U=this.registerCommand(!1,L.id,async(...x)=>{const ae=L.args.map((te,ue)=>{if(!te.validate(x[ue]))throw new Error(`Invalid argument '${te.name}' when running '${L.id}', received: ${x[ue]}`);return te.convert(x[ue])}),W=await this.executeCommand(L.internalId,...ae);return L.result.convert(W,x,this.converter)},void 0,{description:L.description,args:L.args,returns:L.result.description});return this.c.set(L.id,L),new R.$MJ(()=>{U.dispose(),this.c.delete(L.id)})}registerCommand(L,U,x,ae,W,te){if(this.d.trace("ExtHostCommands#registerCommand",U),!U.trim().length)throw new Error("invalid id");if(this.b.has(U))throw new Error(`command '${U}' already exists`);return this.b.set(U,{callback:x,thisArg:ae,description:W,extension:te}),L&&it(this,i,"f").$registerCommand(U),new R.$MJ(()=>{this.b.delete(U)&&L&&it(this,i,"f").$unregisterCommand(U)})}executeCommand(L,...U){return this.d.trace("ExtHostCommands#executeCommand",L),this.g(L,U,!0)}async g(L,U,x){if(this.b.has(L))return it(this,i,"f").$fireCommandActivationEvent(L),this.h(L,U,!1);{let ae=!1;const W=(0,S.$Lm)(U,function(te){if(te instanceof R.$NJ)return r.Position.from(te);if(te instanceof R.$OJ)return r.Range.from(te);if(te instanceof R.$YJ)return r.location.from(te);if(R.$$K.isNotebookRange(te))return r.NotebookRange.from(te);if(te instanceof ArrayBuffer)return ae=!0,u.$Ec.wrap(new Uint8Array(te));if(te instanceof Uint8Array)return ae=!0,u.$Ec.wrap(te);if(te instanceof u.$Ec)return ae=!0,te;if(!Array.isArray(te))return te});try{const te=await it(this,i,"f").$executeCommand(L,ae?new h.$6z(W):W,x);return(0,$.$Yg)(te)}catch(te){if(te instanceof Error&&te.message==="$executeCommand:retry")return this.g(L,U,!1);throw te}}}async h(L,U,x){const ae=this.b.get(L);if(!ae)throw new Error("Unknown command");const{callback:W,thisArg:te,description:ue}=ae;if(ue)for(let he=0;he<ue.args.length;he++)try{(0,v.$ze)(U[he],ue.args[he].constraint)}catch{throw new Error(`Running the contributed command: '${L}' failed. Illegal argument '${ue.args[he].name}' - ${ue.args[he].description}`)}const Z=y.$ac.create();try{return await W.apply(te,U)}catch(he){if(L===this.converter.delegatingCommandId){const V=this.converter.getActualCommand(...U);V&&(L=V.command)}if(this.d.error(he,L,ae.extension?.identifier),!x)throw he;if(ae.extension?.identifier){const V=it(this,s,"f").onExtensionError(ae.extension.identifier,he);this.d.trace("forwarded error to extension?",V,ae.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.$ai)(he)),this.id=L,this.source=ae.extension?.displayName??ae.extension?.name}}}finally{this.j(ae,L,Z.elapsed())}}j(L,U,x){L.extension&&it(this,a,"f").$publicLog2("Extension:ActionExecuted",{extensionId:L.extension.identifier.value,id:new p.$5n(U),duration:x})}$executeContributedCommand(L,...U){this.d.trace("ExtHostCommands#$executeContributedCommand",L);const x=this.b.get(L);return x?(U=U.map(ae=>this.f.reduce((W,te)=>te.processArgument(W,x.extension?.identifier),ae)),this.h(L,U,!0)):Promise.reject(new Error(`Contributed command '${L}' does not exist.`))}getCommands(L=!1){return this.d.trace("ExtHostCommands#getCommands",L),it(this,i,"f").$getCommands().then(U=>(L&&(U=U.filter(x=>x[0]!=="_")),U))}$getContributedCommandHandlerDescriptions(){const L=Object.create(null);for(const[U,x]of this.b){const{description:ae}=x;ae&&(L[U]=ae)}return Promise.resolve(L)}};e.$8L=n,i=new WeakMap,a=new WeakMap,s=new WeakMap,e.$8L=n=Le([Ie(0,m.$ML),Ie(1,b.$Ri),Ie(2,t.$7L)],n),e.$9L=(0,d.$ph)("IExtHostCommands");class o{constructor(L,U,x){this.d=L,this.f=U,this.g=x,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(L,U){if(!L)return;const x={$ident:void 0,id:L.command,title:L.title,tooltip:L.tooltip};if(!L.command)return x;const ae=this.f(L.command);if(ae)x.id=ae.internalId,x.arguments=ae.args.map((W,te)=>W.convert(L.arguments&&L.arguments[te]));else if((0,P.$nf)(L.arguments)){const W=`${L.command}/${++this.c}`;this.b.set(W,L),U.add((0,l.$jb)(()=>{this.b.delete(W),this.g.trace("CommandsConverter#DISPOSE",W)})),x.$ident=W,x.id=this.delegatingCommandId,x.arguments=[W],this.g.trace("CommandsConverter#CREATE",L.command,W)}return x}fromInternal(L){return typeof L.$ident=="string"?this.b.get(L.$ident):{command:L.id,title:L.title,arguments:L.arguments}}getActualCommand(...L){return this.b.get(L[0])}h(...L){const U=this.getActualCommand(...L);return this.g.trace("CommandsConverter#EXECUTE",L[0],U?U.command:"MISSING"),U?this.d.executeCommand(U.command,...U.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${L[0]}`)}}e.$0L=o;class f{static Arr(L){return new f(`${L.name}_array`,`Array of ${L.name}, ${L.description}`,U=>Array.isArray(U)&&U.every(x=>L.validate(x)),U=>U.map(x=>L.convert(x)))}constructor(L,U,x,ae){this.name=L,this.description=U,this.validate=x,this.convert=ae}optional(){return new f(this.name,`(optional) ${this.description}`,L=>L==null||this.validate(L),L=>L===void 0?void 0:L===null?null:this.convert(L))}with(L,U){return new f(L??this.name,U??this.description,this.validate,this.convert)}}e.$$L=f,f.Uri=new f("uri","Uri of a text document",C=>w.URI.isUri(C),C=>C),f.Position=new f("position","A position in a text document",C=>R.$NJ.isPosition(C),r.Position.from),f.Range=new f("range","A range in a text document",C=>R.$OJ.isRange(C),r.Range.from),f.Selection=new f("selection","A selection in a text document",C=>R.$PJ.isSelection(C),r.Selection.from),f.Number=new f("number","",C=>typeof C=="number",C=>C),f.String=new f("string","",C=>typeof C=="string",C=>C),f.StringArray=f.Arr(f.String),f.CallHierarchyItem=new f("item","A call hierarchy item",C=>C instanceof R.$0J,r.CallHierarchyItem.from),f.TypeHierarchyItem=new f("item","A type hierarchy item",C=>C instanceof R.$rL,r.TypeHierarchyItem.from),f.TestItem=new f("testItem","A VS Code TestItem",C=>C instanceof c.$ZL,r.TestItem.from);class k{constructor(L,U){this.description=L,this.convert=U}}e.$_L=k,k.Void=new k("no result",C=>C);class D{constructor(L,U,x,ae,W){this.id=L,this.internalId=U,this.description=x,this.args=ae,this.result=W}}e.$aM=D}),define(we[284],be([1,0,11,2,13,216]),function(le,e,v,R,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=void 0,e.$TM="remoteFilesystem";class I extends S.$SM{static register(b,$,A){const E=b.getConnection();if(!E)return R.$lb.None;const w=new R.$kb,l=(async()=>{try{const d=await b.getRawEnvironment();d?$.registerProvider(r.Schemas.vscodeRemote,w.add(new I(d,E))):A.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(d){A.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,v.$9)(d))}})();return w.add($.onWillActivateFileSystemProvider(d=>{d.scheme===r.Schemas.vscodeRemote&&d.join(l)})),w}constructor(b,$){super($.getChannel(e.$TM),{pathCaseSensitive:b.os===3})}}e.$UM=I}),define(we[94],be([1,0,30,14,7,8,21,168,302,303]),function(le,e,v,R,r,S,I,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.zip=e.$6o=e.$5o=void 0,e.$5o="end of central directory record signature not found";const A=new RegExp(e.$5o);class E extends Error{constructor(i,a){let s=a.message;switch(i){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=i,this.cause=a}}e.$6o=E;function w(t){const i=t.externalFileAttributes>>16||33188;return[448,56,7].map(a=>i&a).reduce((a,s)=>a+s,i&61440)}function l(t){if(t instanceof E)return t;let i;return A.test(t.message)&&(i="CorruptZip"),new E(i,t)}function d(t,i,a,s,n,o){const f=r.$$c(i),k=r.$8c(s,f);if(!k.startsWith(s))return Promise.reject(new Error(P.localize(0,null,i)));const D=r.$8c(s,i);let C;return o.onCancellationRequested(()=>{C?.destroy()}),Promise.resolve(I.Promises.mkdir(k,{recursive:!0})).then(()=>new Promise((L,U)=>{if(!o.isCancellationRequested)try{C=(0,v.createWriteStream)(D,{mode:a}),C.once("close",()=>L()),C.once("error",U),t.once("error",U),t.pipe(C)}catch(x){U(x)}}))}function m(t,i,a,s){let n=(0,R.$ig)(()=>Promise.resolve()),o=0;return s.onCancellationRequested(()=>{n.cancel(),t.close()}),new Promise((f,k)=>{const D=new R.$pg,C=L=>{L.isCancellationRequested||(o++,t.readEntry())};t.once("error",k),t.once("close",()=>n.then(()=>{s.isCancellationRequested||t.entryCount===o?f():k(new E("Incomplete",new Error(P.localize(1,null,o,t.entryCount))))},k)),t.readEntry(),t.on("entry",L=>{if(s.isCancellationRequested)return;if(!a.sourcePathRegex.test(L.fileName)){C(s);return}const U=L.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(U)){const W=r.$8c(i,U);n=(0,R.$ig)(te=>I.Promises.mkdir(W,{recursive:!0}).then(()=>C(te)).then(void 0,k));return}const x=u(t,L),ae=w(L);n=(0,R.$ig)(W=>D.queue(()=>x.then(te=>d(te,U,ae,i,a,W).then(()=>C(W)))).then(null,k))})})}function c(t,i=!1){return new Promise((a,s)=>{(0,b.open)(t,i?{lazyEntries:!0}:void 0,(n,o)=>{n?s(l(n)):a((0,S.$te)(o))})})}function u(t,i){return new Promise((a,s)=>{t.openReadStream(i,(n,o)=>{n?s(l(n)):a((0,S.$te)(o))})})}function h(t,i){return new Promise((a,s)=>{const n=new $.ZipFile;i.forEach(f=>{f.contents?n.addBuffer(typeof f.contents=="string"?Buffer.from(f.contents,"utf8"):f.contents,f.path):f.localPath&&n.addFile(f.localPath,f.path)}),n.end();const o=(0,v.createWriteStream)(t);n.outputStream.pipe(o),n.outputStream.once("error",s),o.once("error",s),o.once("finish",()=>a(t))})}e.zip=h;function g(t,i,a={},s){const n=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let o=c(t,!0);return a.overwrite&&(o=o.then(f=>I.Promises.rm(i).then(()=>f))),o.then(f=>m(f,i,{sourcePathRegex:n},s))}e.$8o=g;function y(t,i){return c(t).then(a=>new Promise((s,n)=>{a.on("entry",o=>{o.fileName===i&&u(a,o).then(f=>s(f),f=>n(f))}),a.once("close",()=>n(new Error(P.localize(2,null,i))))}))}function p(t,i){return y(t,i).then(a=>new Promise((s,n)=>{const o=[];a.once("error",n),a.on("data",f=>o.push(f)),a.on("end",()=>s(Buffer.concat(o)))}))}e.$9o=p}),define(we[285],be([1,0,14,11,2,13,19,53,8,23,21,94,24,25,31,37,82,16,12]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;let y=g=class extends r.$lb{constructor(t,i,a,s,n,o){super(),this.h=i,this.i=a,this.j=s,this.k=n,this.l=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(t,i,a){await this.g;const s=(0,I.$9f)(this.extensionsDownloadDir,this.u(t));try{await this.r(t,s,o=>this.i.download(t,o,i))}catch(o){throw new d.$Tn(o.message,d.ExtensionManagementErrorCode.Download)}let n=!1;if(a&&this.m(t)){const o=await this.n(t);try{n=await this.k.verify(s.fsPath,o.fsPath,this.l.getLevel()===h.LogLevel.Trace)}catch(f){const k=f;if(n=k.code,k.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${k.output}`),n===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new d.$Tn(E.$5o,d.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(f){this.l.error(f)}}}return n===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:s,verificationStatus:n}}m(t){if(!t.isSigned)return!1;const i=this.j.getValue("extensions.verifySignature");return(0,b.$oe)(i)?i:!0}async n(t){await this.g;const i=(0,I.$9f)(this.extensionsDownloadDir,`${this.u(t)}${g.c}`);return await this.r(t,i,a=>this.i.downloadSignatureArchive(t,a)),i}async r(t,i,a){if(await this.h.exists(i))return;if(i.scheme!==S.Schemas.file){await a(i);return}const s=(0,I.$9f)(this.extensionsDownloadDir,`.${(0,$.$3e)()}`);await this.h.exists(s)||await a(s);try{await A.Promises.rename(s.fsPath,i.fsPath,2*60*1e3)}catch(n){try{await this.h.del(s)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,i.path);else throw this.l.info(`Rename failed because of ${(0,R.$9)(n)}. Deleted the file from downloaded location`,s.path),n}}async delete(t){await this.g,await this.h.del(t)}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const i=[],a=[],s=[];for(const f of t.children)if(f.name.endsWith(g.c))s.push(f.resource);else{const k=m.$jo.parse(f.name);k&&a.push([k,f])}const n=(0,m.$oo)(a,([f])=>f),o=[];for(const f of n)f.sort((k,D)=>P.rcompare(k[0].version,D[0].version)),i.push(...f.slice(1).map(k=>k[1].resource)),o.push(f[0][1]);o.sort((f,k)=>f.mtime-k.mtime),i.push(...o.slice(0,Math.max(0,o.length-this.f)).map(f=>f.resource)),i.push(...s),await v.Promises.settled(i.map(f=>(this.l.trace("Deleting from cache",f.path),this.h.del(f))))}}catch(t){this.l.error(t)}}u(t){return this.f?m.$jo.create(t).toString().toLowerCase():(0,$.$3e)()}};e.$lp=y,y.c=".sigzip",e.$lp=y=g=Le([Ie(0,l.$xh),Ie(1,u.$Sj),Ie(2,d.$Sn),Ie(3,w.$Vh),Ie(4,c.$Yo),Ie(5,h.$Ri)],y)}),define(we[286],be([1,0,94,182]),function(le,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;function r(S){return(0,v.$9o)(S,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.$np=r}),define(we[139],be([1,0,14,15,20,39,11,5,61,2,28,13,7,19,53,8,4,23,21,94,181,81,25,256,31,37,45,57,285,257,286,231,240,79,16,6,12,27,32,34,33]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g,y,p,t,i,a,s,n,o,f,k,D,C,L,U,x,ae,W,te,ue,Z,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=void 0,e.$qp=(0,ae.$qh)(a.$Un);const V=".vsctmp";let se=class extends i.$0o{constructor(q,X,O,N,J,ie,re,ee,oe,F,z,j){super(q,X,z,O,F,j),this.bb=J,this.cb=ie,this.db=re,this.eb=oe,this.ab=new Map,this.nb=new A.$oi;const B=this.B(ee.createInstance(k.$mp));this.Y=this.B(ee.createInstance(K,de=>B.postUninstall(de))),this.Z=this.B(new C.$op(j,oe,z,this,this.y)),this.$=this.B(ee.createInstance(f.$lp));const Q=this.B(new L.$pp(this,this.bb,j,ie,z,oe,O));this.B(Q.onDidChangeExtensionsByAnotherSource(de=>this.mb(de))),this.ob()}getTargetPlatform(){return this.fb||(this.fb=(0,s.$to)(this.eb,this.y)),this.fb}async zip(q){this.y.trace("ExtensionManagementService#zip",q.identifier.id);const X=await this.lb(q),O=await(0,g.zip)((0,l.$9f)(this.$.extensionsDownloadDir,(0,u.$3e)()).fsPath,X);return c.URI.file(O)}async unzip(q){return this.y.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:X,cleanup:O}=await this.hb(q),N=w.$9c(X.fsPath);try{return await(0,D.$np)(N)}finally{await O()}}getInstalled(q,X=this.C.defaultProfile.extensionsResource){return this.Y.scanExtensions(q??null,X)}scanAllUserInstalledExtensions(){return this.Y.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.Y.scanUserExtensionAtLocation(q)}async install(q,X={}){this.y.trace("ExtensionManagementService#install",q.toString());const{location:O,cleanup:N}=await this.hb(q);try{const J=await(0,D.$np)(w.$9c(O.fsPath)),ie=(0,s.$no)(J.publisher,J.name);if(J.engines&&J.engines.vscode&&!(0,U.$Ao)(J.engines.vscode,this.z.version,this.z.date))throw new Error(y.localize(0,null,ie,this.z.version));const ee=(await this.D([{manifest:J,extension:O,options:X}])).find(({identifier:oe})=>(0,s.$io)(oe,{id:ie}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,i.$_o)(new Error(`Unknown error while installing extension ${ie}`))}finally{await N()}}async installFromLocation(q,X){this.y.trace("ExtensionManagementService#installFromLocation",q.toString());const O=await this.Y.scanUserExtensionAtLocation(q);if(!O)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.qb([[O,void 0]],X),this.y.info("Successfully installed extension",O.identifier.id,X.toString()),O}async installExtensionsFromProfile(q,X,O){this.y.trace("ExtensionManagementService#installExtensionsFromProfile",q,X.toString(),O.toString());const N=(await this.Y.scanExtensions(1,X)).filter(J=>q.some(ie=>(0,s.$io)(ie,J.identifier)));if(N.length){const J=await Promise.all(N.map(ie=>this.Y.scanMetadata(ie,X)));await this.qb(N.map((ie,re)=>[ie,J[re]]),O),this.y.info("Successfully installed extensions",N.map(ie=>ie.identifier.id),O.toString())}return N}async updateMetadata(q,X,O=this.C.defaultProfile.extensionsResource){return this.y.trace("ExtensionManagementService#updateMetadata",q.identifier.id),X.isPreReleaseVersion&&(X.preRelease=!0),X.isMachineScoped=X.isMachineScoped||void 0,X.isBuiltin=X.isBuiltin||void 0,X.pinned=X.pinned||void 0,q=await this.Y.updateMetadata(q,X,O),this.Z.invalidate(O),this.s.fire(q),q}async reinstallFromGallery(q){if(this.y.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.u.isEnabled())throw new Error(y.localize(1,null));const X=await this.getTargetPlatform(),[O]=await this.u.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:X,compatible:!0},r.CancellationToken.None);if(!O)throw new Error(y.localize(2,null));await this.Y.setUninstalled(q);try{await this.Y.removeUninstalledExtension(q)}catch(N){throw new Error(y.localize(3,null,(0,S.$ai)(N)))}return this.installFromGallery(O)}X(q,X,O,N){return this.Y.copyExtension(q,X,O,N)}copyExtensions(q,X){return this.Y.copyExtensions(q,X)}markAsUninstalled(...q){return this.Y.setUninstalled(...q)}async cleanUp(){this.y.trace("ExtensionManagementService#cleanUp");try{await this.Y.cleanUp()}catch(q){this.y.error(q)}}async download(q,X,O){const{location:N}=await this.$.download(q,X,!O);return N}async hb(q){if(q.scheme===E.Schemas.file)return{location:q,async cleanup(){}};this.y.trace("Downloading extension from",q.toString());const X=(0,l.$9f)(this.$.extensionsDownloadDir,(0,u.$3e)());return await this.db.download(q,X),this.y.info("Downloaded extension to",X.toString()),{location:X,cleanup:async()=>{try{await this.eb.del(X)}catch(N){this.y.error(N)}}}}S(){return this.C.defaultProfile.extensionsResource}U(q,X,O){if(c.URI.isUri(X))return new _(q,X,O,this.u,this.Y,this.w,this.C,this.bb,this.cb,this.y);const N=s.$jo.create(X).toString();let J=this.ab.get(N);return J||(this.ab.set(N,J=new H(q,X,O,this.$,this.Y,this.w,this.C,this.bb,this.cb,this.y)),J.waitUntilTaskIsFinished().finally(()=>this.ab.delete(N))),J}W(q,X){return new ge(q,X.profileLocation,this.cb)}async lb(q){const X=async N=>{let J=await h.Promises.readdir(N);J=J.map(ee=>w.$8c(N,ee));const ie=await Promise.all(J.map(ee=>h.Promises.stat(ee)));let re=Promise.resolve([]);return ie.forEach((ee,oe)=>{const F=J[oe];ee.isFile()&&(re=re.then(z=>[...z,F])),ee.isDirectory()&&(re=re.then(z=>X(F).then(j=>[...z,...j])))}),re};return(await X(q.location.fsPath)).map(N=>({path:`extension/${w.$0c(q.location.fsPath,N)}`,localPath:N}))}async mb({added:q,removed:X}){if(X)for(const O of X.extensions)this.y.info("Extensions removed from another source",O.id,X.profileLocation.toString()),this.p.fire({identifier:O,profileLocation:X.profileLocation});if(q){const N=(await this.Y.scanExtensions(1,q.profileLocation)).filter(J=>q.extensions.some(ie=>(0,s.$io)(ie,J.identifier)));this.m.fire(N.map(J=>(this.y.info("Extensions added from another source",J.identifier.id,q.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:q.profileLocation,operation:1})))}}async ob(){this.B(this.Y.onExtract(X=>this.nb.add(X)));const q=await this.eb.resolve(this.bb.userExtensionsLocation);for(const X of q.children??[])X.isDirectory&&this.nb.add(X.resource);this.B(this.eb.watch(this.bb.userExtensionsLocation)),this.B(this.eb.onDidFilesChange(X=>this.pb(X)))}async pb(q){if(!q.affects(this.bb.userExtensionsLocation,1))return;const X=[];for(const O of q.rawAdded){if(this.nb.has(O)||!this.w.extUri.isEqual(this.w.extUri.dirname(O),this.bb.userExtensionsLocation)||this.w.extUri.isEqual(O,this.w.extUri.joinPath(this.bb.userExtensionsLocation,".obsolete"))||this.w.extUri.basename(O).startsWith(".")||!(await this.eb.stat(O)).isDirectory)continue;const N=await this.Y.scanUserExtensionAtLocation(O);N&&N.installedTimestamp===void 0&&(this.nb.add(O),X.push(N))}X.length&&(await this.qb(X.map(O=>[O,void 0]),this.C.defaultProfile.extensionsResource),this.y.info("Added extensions to default profile from external source",X.map(O=>O.identifier.id)))}async qb(q,X){const O=q.map(N=>N[0]);await this.rb(O),await this.cb.addExtensionsToProfile(q,X),this.m.fire(O.map(N=>({local:N,identifier:N.identifier,operation:1,profileLocation:X})))}async rb(q){const X=await this.Y.getUninstalledExtensions();for(const O of q){const N=s.$jo.create(O);X[N.toString()]&&(this.y.trace("Removing the extension from uninstalled list:",N.id),await this.Y.setInstalled(N),this.y.info("Removed the extension from uninstalled list:",N.id))}}};e.$rp=se,e.$rp=se=Le([Ie(0,a.$Sn),Ie(1,ue.$Vk),Ie(2,W.$Ri),Ie(3,t.$xh),Ie(4,o.$gp),Ie(5,n.$cp),Ie(6,p.$wn),Ie(7,ae.$oh),Ie(8,x.$Sj),Ie(9,te.$0i),Ie(10,Z.$pk),Ie(11,he.$rk)],se);let K=class extends $.$lb{constructor(q,X,O,N,J,ie){super(),this.j=q,this.k=X,this.l=O,this.m=N,this.n=J,this.p=ie,this.h=this.B(new P.$ec),this.onExtract=this.h.event,this.c=(0,l.$9f)(this.l.userExtensionsLocation,".obsolete"),this.g=new v.$Bg}async cleanUp(){await this.C(),await this.z()}async scanExtensions(q,X){const O={includeInvalid:!0,profileLocation:X};let N=[];return q===null||q===0?N.push(...await this.l.scanAllExtensions({includeInvalid:!0},O,!1)):q===1&&N.push(...await this.l.scanUserExtensions(O)),N=q!==null?N.filter(J=>J.type===q):N,Promise.all(N.map(J=>this.y(J)))}async scanAllUserExtensions(q){const X=await this.l.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return Promise.all(X.map(O=>this.y(O)))}async scanUserExtensionAtLocation(q){try{const X=await this.l.scanExistingExtension(q,1,{includeInvalid:!0});if(X)return await this.y(X)}catch(X){this.p.error(X)}return null}async extractUserExtension(q,X,O,N,J){const ie=q.toString(),re=c.URI.file(w.$8c(this.l.userExtensionsLocation.fsPath,`.${(0,u.$3e)()}`)),ee=c.URI.file(w.$8c(this.l.userExtensionsLocation.fsPath,ie));let oe=await this.k.exists(ee);if(oe&&N){try{await this.t(q.id,ee,"removeExisting")}catch{throw new a.$Tn(y.localize(4,null,ee.fsPath,q.id),a.ExtensionManagementErrorCode.Delete)}oe=!1}if(!oe)try{try{this.p.trace(`Started extracting the extension from ${X} to ${ee.fsPath}`),await(0,g.$8o)(X,re.fsPath,{sourcePath:"extension",overwrite:!0},J),this.p.info(`Extracted extension to ${ee}:`,q.id)}catch(F){let z=a.ExtensionManagementErrorCode.Extract;throw F instanceof g.$6o&&(F.type==="CorruptZip"?z=a.ExtensionManagementErrorCode.CorruptZip:F.type==="Incomplete"&&(z=a.ExtensionManagementErrorCode.IncompleteZip)),new a.$Tn(F.message,z)}await this.l.updateMetadata(re,O);try{this.p.trace(`Started renaming the extension from ${re.fsPath} to ${ee.fsPath}`),await this.v(re.fsPath,ee.fsPath),this.p.info("Renamed to",ee.fsPath)}catch(F){if(F.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);else throw this.p.info(`Rename failed because of ${(0,I.$9)(F)}. Deleted from extracted location`,re),F}this.h.fire(ee)}catch(F){try{await this.k.del(re,{recursive:!0})}catch{}throw F}return this.w(ee,1)}async scanMetadata(q,X){return X?(await this.s(q,X))?.metadata:this.l.scanMetadata(q.location)}async s(q,X){return(await this.m.scanProfileExtensions(X)).find(N=>(0,s.$io)(N.identifier,q.identifier))}async updateMetadata(q,X,O){return O?await this.m.updateMetadata([[q,X]],O):await this.l.updateMetadata(q.location,X),this.w(q.location,q.type,O)}getUninstalledExtensions(){return this.u()}async setUninstalled(...q){const X=q.map(O=>s.$jo.create(O));await this.u(O=>X.forEach(N=>{O[N.toString()]=!0,this.p.info("Marked extension as uninstalled",N.toString())}))}async setInstalled(q){await this.u(X=>delete X[q.toString()])}async removeExtension(q,X){if(this.n.extUri.isEqualOrParent(q.location,this.l.userExtensionsLocation))return this.t(q.identifier.id,q.location,X)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.u(X=>delete X[s.$jo.create(q).toString()])}async copyExtension(q,X,O,N){const J=await this.s(q,X),ie=await this.s(q,O);return N={...J?.metadata,...N},ie?await this.m.updateMetadata([[q,{...ie.metadata,...N}]],O):await this.m.addExtensionsToProfile([[q,N]],O),this.w(q.location,q.type,O)}async copyExtensions(q,X){const O=await this.scanExtensions(1,q),N=await Promise.all(O.filter(J=>!J.isApplicationScoped).map(async J=>[J,await this.scanMetadata(J,q)]));await this.m.addExtensionsToProfile(N,X)}async t(q,X,O){this.p.trace(`Deleting ${O} extension from disk`,q,X.fsPath);const N=this.n.extUri.joinPath(this.n.extUri.dirname(X),`${this.n.extUri.basename(X)}.${(0,b.$di)((0,u.$3e)()).toString(16)}${V}`);await this.v(X.fsPath,N.fsPath),await this.k.del(N,{recursive:!0}),this.p.info(`Deleted ${O} extension from disk`,q,X.fsPath)}async u(q){return this.g.queue(async()=>{let X;try{X=(await this.k.readFile(this.c,"utf8")).value.toString()}catch(N){if((0,x.$9j)(N)!==1)throw N}let O={};if(X)try{O=JSON.parse(X)}catch{}return q&&(q(O),Object.keys(O).length?await this.k.writeFile(this.c,R.$Ec.fromString(JSON.stringify(O))):await this.k.del(this.c)),O})}async v(q,X){try{await h.Promises.rename(q,X,2*60*1e3)}catch(O){throw new a.$Tn(O.message||y.localize(5,null,q,X),O.code||a.ExtensionManagementErrorCode.Rename)}}async w(q,X,O){if(O){const J=(await this.l.scanUserExtensions({profileLocation:O})).find(ie=>this.n.extUri.isEqual(ie.location,q));if(J)return this.y(J)}else{const N=await this.l.scanExistingExtension(q,X,{includeInvalid:!0});if(N)return this.y(N)}throw new Error(y.localize(6,null,q.path))}async y(q){const X=await this.k.resolve(q.location);let O,N;return X.children&&(O=X.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,N=X.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:O,changelogUrl:N,publisherDisplayName:q.metadata?.publisherDisplayName||null,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned}}async z(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.p.debug("No uninstalled extensions found.");return}this.p.debug("Removing uninstalled extensions:",Object.keys(q));const X=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const J of X)q[s.$jo.create(J).toString()]||O.add(J.identifier.id.toLowerCase());try{const J=(0,s.$oo)(X,ie=>ie.identifier);await v.Promises.settled(J.map(async ie=>{const re=ie.sort((ee,oe)=>d.rcompare(ee.manifest.version,oe.manifest.version))[0];O.has(re.identifier.id.toLowerCase())||await this.j(await this.y(re))}))}catch(J){this.p.error(J)}const N=X.filter(J=>J.metadata&&q[s.$jo.create(J).toString()]);await Promise.allSettled(N.map(J=>this.removeUninstalledExtension(J)))}async C(){this.p.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.k.resolve(this.l.userExtensionsLocation)}catch(X){(0,x.$9j)(X)!==1&&this.p.error(X);return}if(q?.children)try{await Promise.allSettled(q.children.map(async X=>{if(!(!X.isDirectory||!X.name.endsWith(V))){this.p.trace("Deleting the temporarily deleted folder",X.resource.toString());try{await this.k.del(X.resource,{recursive:!0}),this.p.trace("Deleted the temporarily deleted folder",X.resource.toString())}catch(O){(0,x.$9j)(O)!==1&&this.p.error(O)}}}))}catch{}}};e.$sp=K,e.$sp=K=Le([Ie(1,x.$Sj),Ie(2,o.$gp),Ie(3,n.$cp),Ie(4,Z.$pk),Ie(5,W.$Ri)],K);class Y extends i.$ap{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,m.$pe)(this.options.operation)?this.l:this.options.operation}constructor(q,X,O,N,J,ie,re,ee,oe){super(),this.identifier=q,this.source=X,this.options=O,this.m=N,this.n=J,this.o=ie,this.p=re,this.q=ee,this.s=oe,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(q){const[X,O]=await this.x(q);return this.j=X.isBuiltin||X.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[X,O]],this.j),X}async u({zipPath:q,key:X,metadata:O},N,J){let ie=await this.v(X);return ie||(this.s.trace("Extracting extension...",X.id),ie=await this.m.extractUserExtension(X,q,O,N,J),this.s.info("Extracting extension completed.",X.id)),ie}async v(q){return await this.w(q)?(this.s.trace("Removing the extension from uninstalled list:",q.id),await this.m.setInstalled(q),this.s.info("Removed the extension from uninstalled list:",q.id),(await this.m.scanAllUserExtensions(!0)).find(N=>s.$jo.create(N).equals(q))):void 0}async w(q){return!!(await this.m.getUninstalledExtensions())[q.toString()]}}class H extends Y{constructor(q,X,O,N,J,ie,re,ee,oe,F){super(X.identifier,X,O,J,ie,re,ee,oe,F),this.y=X,this.z=N}async x(q){const O=(await this.m.scanExtensions(null,this.options.profileLocation)).find(re=>(0,s.$io)(re.identifier,this.y.identifier));O&&(this.l=3);const N={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,m.$oe)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.y.version)return[await this.m.updateMetadata(O,N),N];const{location:J,verificationStatus:ie}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=ie,this.B(J.fsPath),[await this.u({zipPath:J.fsPath,key:s.$jo.create(this.y),metadata:N},!1,q),N]}catch(re){try{await this.z.delete(J)}catch(ee){this.s.warn("Error while deleting the downloaded file",J.toString(),(0,I.$9)(ee))}throw re}}async B(q){try{await(0,D.$np)(q)}catch(X){throw new a.$Tn((0,i.$$o)(X).message,a.ExtensionManagementErrorCode.Invalid)}}}e.$tp=H;class _ extends Y{constructor(q,X,O,N,J,ie,re,ee,oe,F){super({id:(0,s.$no)(q.publisher,q.name)},X,O,J,ie,re,ee,oe,F),this.y=q,this.z=X,this.A=N}async h(q){const X=await super.h(q);return this.D(X,q),X}async x(q){const X=new s.$jo(this.identifier,this.y.version),N=(await this.m.scanExtensions(1,this.options.profileLocation)).find(re=>(0,s.$io)(this.identifier,re.identifier)),J={isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(N)if(this.l=3,X.equals(new s.$jo(N.identifier,N.manifest.version)))try{await this.m.removeExtension(N,"existing")}catch{throw new Error(y.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(N.manifest.version,this.y.version)&&await this.m.setUninstalled(N);else{const re=await this.v(X);if(re)try{await this.m.removeExtension(re,"existing")}catch{throw new Error(y.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.$9c(this.z.fsPath),key:X,metadata:J},!0,q),J]}async D(q,X){try{let[O]=await this.A.getExtensions([{id:q.identifier.id,version:q.manifest.version}],X);if(O||([O]=await this.A.getExtensions([{id:q.identifier.id}],X)),O){const N={id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(q,N,this.options.profileLocation)}}catch{}}}class ge extends i.$ap{constructor(q,X,O){super(),this.extension=q,this.j=X,this.k=O}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(we[72],be([1,0,87,78,26,287,15,11,5,2,7,3,23,42,107]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=void 0;class m{traceSocketEvent(C,L){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,L)}constructor(C,L=""){this.f=!0,this.debugLabel=L,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,P.$Y)(U)}},this.socket.on("error",this.a),this.b=U=>{this.traceSocketEvent("close",{hadError:U}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(C){const L=U=>{this.traceSocketEvent("read",U),C(I.$Ec.wrap(U))};return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(C){const L=U=>{C({type:0,hadError:U,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(C){const L=()=>{C()};return this.socket.on("end",L),{dispose:()=>this.socket.off("end",L)}}write(C){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,P.$Y)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,P.$Y)(L)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,L)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.$eh=m;var c;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var u;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(u||(u={}));class h extends $.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(C,L){this.socket.traceSocketEvent(C,L)}constructor(C,L,U,x){super(),this.f=this.B(new b.$ec),this.g=this.B(new b.$ec),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:L,inflateBytesLength:U?.byteLength||0,recordInflateBytes:x}),this.a=this.B(new g(this,L,U,x,this.f,(ae,W)=>this.k(ae,W))),this.B(this.a.onError(ae=>{console.error(ae),(0,P.$Y)(ae),this.g.fire({type:0,hadError:!0,error:ae})})),this.b=new d.$_g,this.B(this.socket.onData(ae=>this.l(ae))),this.B(this.socket.onClose(async ae=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(ae)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this.f.event(C)}onClose(C){return this.g.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let L=0;for(;L<C.byteLength;)this.a.writeMessage(C.slice(L,Math.min(L+262144,C.byteLength))),L+=262144}k(C,L){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let U=2;C.byteLength<126?U+=0:C.byteLength<2**16?U+=2:U+=8;const x=I.$Ec.alloc(U);if(L?x.writeUInt8(194,0):x.writeUInt8(130,0),C.byteLength<126)x.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){x.writeUInt8(126,1);let ae=1;x.writeUInt8(C.byteLength>>>8&255,++ae),x.writeUInt8(C.byteLength>>>0&255,++ae)}else{x.writeUInt8(127,1);let ae=1;x.writeUInt8(0,++ae),x.writeUInt8(0,++ae),x.writeUInt8(0,++ae),x.writeUInt8(0,++ae),x.writeUInt8(C.byteLength>>>24&255,++ae),x.writeUInt8(C.byteLength>>>16&255,++ae),x.writeUInt8(C.byteLength>>>8&255,++ae),x.writeUInt8(C.byteLength>>>0&255,++ae)}this.socket.write(I.$Ec.concat([x,C]))}end(){this.h=!0,this.socket.end()}l(C){if(C.byteLength!==0){for(this.b.acceptChunk(C);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const L=this.b.peek(this.j.readLen),U=L.readUInt8(0),x=(U&128)>>>7,ae=(U&64)>>>6,W=L.readUInt8(1),te=(W&128)>>>7,ue=W&127;this.j.state=2,this.j.readLen=2+(te?4:0)+(ue===126?2:0)+(ue===127?8:0),this.j.fin=x,this.j.firstFrameOfMessage&&(this.j.compressed=!!ae),this.j.firstFrameOfMessage=!!x,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const L=this.b.read(this.j.readLen),U=L.readUInt8(1),x=(U&128)>>>7;let ae=U&127,W=1;ae===126?ae=L.readUInt8(++W)*2**8+L.readUInt8(++W):ae===127&&(ae=L.readUInt8(++W)*0+L.readUInt8(++W)*0+L.readUInt8(++W)*0+L.readUInt8(++W)*0+L.readUInt8(++W)*2**24+L.readUInt8(++W)*2**16+L.readUInt8(++W)*2**8+L.readUInt8(++W));let te=0;x&&(te=L.readUInt8(++W)*2**24+L.readUInt8(++W)*2**16+L.readUInt8(++W)*2**8+L.readUInt8(++W)),this.j.state=3,this.j.readLen=ae,this.j.mask=te,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const L=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",L),t(L,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",L),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(L,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$fh=h;class g extends $.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$Ec.alloc(0)}constructor(C,L,U,x,ae,W){super(),this.l=C,this.m=ae,this.n=W,this.a=this.B(new b.$ec),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$ec),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new b.$ec),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,L?(this.b=this.B(new y(this.l,x,U,{windowBits:15})),this.f=this.B(new p(this.l,{windowBits:15})),this.B(this.b.onError(te=>this.a.fire(te))),this.B(this.f.onError(te=>this.a.fire(te)))):(this.b=null,this.f=null)}writeMessage(C){this.g.push(C),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const C=this.g.shift();if(this.f){const L=await this.s(this.f,C);this.n(L,!0)}else this.n(C,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(C,L){return new Promise((U,x)=>{C.write(L),C.flush(ae=>U(ae))})}acceptFrame(C,L,U){this.h.push({data:C,isCompressed:L,isLastFrameOfMessage:U}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const C=this.h.shift();if(this.b&&C.isCompressed){const L=await this.w(this.b,C.data,C.isLastFrameOfMessage);this.m.fire(L)}else this.m.fire(C.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(C,L,U){return new Promise((x,ae)=>{C.write(L),U&&C.write(I.$Ec.fromByteArray([0,0,255,255])),C.flush(W=>x(W))})}}class y extends $.$lb{get recordedInflateBytes(){return this.j?I.$Ec.concat(this.f):I.$Ec.alloc(0)}constructor(C,L,U,x){super(),this.h=C,this.j=L,this.a=this.B(new b.$ec),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,S.createInflateRaw)(x),this.b.on("error",ae=>{this.h.traceSocketEvent("zlibInflateError",{message:ae?.message,code:ae?.code}),this.a.fire(ae)}),this.b.on("data",ae=>{this.h.traceSocketEvent("zlibInflateData",ae),this.g.push(I.$Ec.wrap(ae))}),U&&(this.h.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this.b.write(U.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(C){this.j&&this.f.push(C.clone()),this.h.traceSocketEvent("zlibInflateWrite",C),this.b.write(C.buffer)}flush(C){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const L=I.$Ec.concat(this.g);this.g.length=0,C(L)})}}class p extends $.$lb{constructor(C,L){super(),this.g=C,this.a=this.B(new b.$ec),this.onError=this.a.event,this.f=[],this.b=(0,S.createDeflateRaw)({windowBits:15}),this.b.on("error",U=>{this.g.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.g.traceSocketEvent("zlibDeflateData",U),this.f.push(I.$Ec.wrap(U))})}write(C){this.g.traceSocketEvent("zlibDeflateWrite",C.buffer),this.b.write(C.buffer)}flush(C){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let L=I.$Ec.concat(this.f);this.f.length=0,L=L.slice(0,L.byteLength-4),C(L)})}}function t(D,C){if(C===0)return;const L=D.byteLength>>>2;for(let ue=0;ue<L;ue++){const Z=D.readUInt32BE(ue*4);D.writeUInt32BE(Z^C,ue*4)}const U=L*4,x=D.byteLength-U,ae=C>>>24&255,W=C>>>16&255,te=C>>>8&255;x>=1&&D.writeUInt8(D.readUInt8(U)^ae,U),x>=2&&D.writeUInt8(D.readUInt8(U+1)^W,U+1),x>=3&&D.writeUInt8(D.readUInt8(U+2)^te,U+2)}e.$gh=process.env.XDG_RUNTIME_DIR;const i={[2]:107,[1]:103};function a(){const D=(0,w.$3e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const C=process.platform!=="darwin"&&e.$gh?e.$gh:(0,r.tmpdir)(),L=(0,A.$8c)(C,`vscode-ipc-${D}.sock`);return n(L),L}e.$hh=a;function s(D,C,L){const U=(0,v.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${L}-${C}-sock`;const x=L.substr(0,4),ae=C.substr(0,6),W=U.substr(0,8);let te;return process.platform!=="darwin"&&e.$gh&&!process.env.VSCODE_PORTABLE?te=(0,A.$8c)(e.$gh,`vscode-${W}-${x}-${ae}.sock`):te=(0,A.$8c)(D,`${x}-${ae}.sock`),n(te),te}e.$ih=s;function n(D){const C=i[E.$o];typeof C=="number"&&D.length>=C&&console.warn(`WARNING: IPC handle "${D}" is longer than ${C} chars, try a shorter --user-data-dir`)}class o extends l.$6g{static b(C){const L=b.Event.fromNodeEventEmitter(C,"connection");return b.Event.map(L,U=>({protocol:new d.$ah(new m(U,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(U,"close"))}))}constructor(C){super(o.b(C)),this.d=C}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$jh=o;function f(D){return new Promise((C,L)=>{const U=(0,R.createServer)();U.on("error",L),U.listen(D,()=>{U.removeListener("error",L),C(new o(U))})})}e.$kh=f;function k(D,C){return new Promise((L,U)=>{const x=(0,R.createConnection)(D,()=>{x.removeListener("error",U),L(d.$bh.fromSocket(new m(x,`ipc-client${C}`),C))});x.once("error",U)})}e.$lh=k}),define(we[140],be([1,0,85,14,15,11,8,24,25,86,12,44,234,287]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;let d=class extends E.$Co{constructor(h,g,y,p){super(p),this.j=h,this.k=g,this.l=y,this.m(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const h=this.j.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,g){const{f:y,g:p}=this;let t;try{t=await(0,$.$Al)(this.j,this.l,this.k.args,process.env)}catch(s){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,S.$9)(s)))}const i={...process.env,...t},a=h.agent?h.agent:await(0,w.$Fq)(h.url||"",i,{proxyUrl:y,strictSSL:p});return h.agent=a,h.strictSSL=p,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>c(h,g))}async resolveProxy(h){}};e.$Gq=d,e.$Gq=d=Le([Ie(0,P.$Vh),Ie(1,b.$xh),Ie(2,A.$Ri),Ie(3,A.$Si)],d);async function m(u){return((0,v.parse)(u.url).protocol==="https:"?await new Promise((y,p)=>{le(["https"],y,p)}):await new Promise((y,p)=>{le(["http"],y,p)})).request}async function c(u,h){return R.Promises.withAsyncBody(async(g,y)=>{const p=(0,v.parse)(u.url),t=u.getRawRequest?u.getRawRequest(u):await m(u),i={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,I.$oe)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(i.auth=u.user+":"+u.password);const a=t(i,s=>{const n=(0,I.$me)(u.followRedirects)?u.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&n>0&&s.headers.location)c({...u,url:s.headers.location,followRedirects:n-1},h).then(g,y);else{let o=s;!u.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(o=s.pipe((0,l.createGunzip)())),g({res:s,stream:(0,r.$Tc)(o)})}});a.on("error",y),u.timeout&&a.setTimeout(u.timeout),u.isChromiumNetwork&&a.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&a.write(u.data),a.end(),h.onCancellationRequested(()=>{a.abort(),y(new S.$3)})})}e.$Hq=c}),define(we[141],be([1,0,52,78,91,13,7,15,5,72,86,12,46,3,59,129,2,277,24]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=void 0;async function g(s={},n,o,f,k,D){const C=await(0,r.$6k)(o,f.userDataPath);let L={};if(n)try{L=await(0,A.$Al)(D,k,f.args,process.env)}catch(ue){k.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ue)}const x={...process.env,...L,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(C,void 0,0),...s},ae=f.isBuilt?(0,I.$8c)(f.appRoot,"bin"):(0,I.$8c)(f.appRoot,"resources","server","bin-dev"),W=(0,I.$8c)(ae,"remote-cli");let te=t(x,"PATH");return te?te=W+I.$fd+te:te=W,i(x,"PATH",te),f.args["without-browser-env-var"]||(x.BROWSER=(0,I.$8c)(ae,"helpers",l.$d?"browser.cmd":"browser.sh")),a(x),x}e.$gm=g;class y{constructor(n,o){this.socket=n,this.initialDataChunk=o}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let n,o,f;return this.socket instanceof $.$eh?(n=!0,o=!1,f=P.$Ec.alloc(0)):(n=!1,o=this.socket.permessageDeflate,f=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:n,permessageDeflate:o,inflateBytes:f.buffer.toString("base64")}}}let p=class{constructor(n,o,f,k,D,C,L,U){this.i=n,this.j=D,this.l=C,this.m=L,this.n=U,this.b=new b.$ec,this.onClose=this.b.event,this.c=!l.$d||!this.j.args["socket-path"],this.d=!1,this.f=o,this.g=null,this.h=new y(f,k),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(n){this.l.info(`${this.o}${n}`)}q(n){this.l.error(`${this.o}${n}`)}async r(n,o){const f=new c.$kb;f.add(o.socket),f.add((0,c.$jb)(()=>{n.destroy()}));const k=()=>{f.dispose()};f.add(o.socket.onEnd(k)),f.add(o.socket.onClose(k)),f.add(b.Event.fromNodeEventEmitter(n,"end")(k)),f.add(b.Event.fromNodeEventEmitter(n,"close")(k)),f.add(b.Event.fromNodeEventEmitter(n,"error")(k)),f.add(o.socket.onData(D=>n.write(D.buffer))),f.add(b.Event.fromNodeEventEmitter(n,"data")(D=>{o.socket.write(P.$Ec.wrap(D))})),o.initialDataChunk.byteLength>0&&n.write(o.initialDataChunk.buffer)}async s(n,o){await o.socketDrain();const f=o.toIExtHostSocketMessage();let k;o.socket instanceof $.$eh?k=o.socket.socket:k=o.socket.socket.socket,n.send(f,k)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const n={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(n)}acceptReconnection(n,o,f){this.f=n,this.p("The client has reconnected.");const k=new y(o,f);if(!this.g){this.h=k;return}this.s(this.g,k)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(n){try{let o=process.execArgv?process.execArgv.filter(W=>!/^--inspect(-brk)?=/.test(W)):[];n.port&&!process.pkg&&(o=[`--inspect${n.break?"-brk":""}=${n.port}`]);const f=await g(n.env,!0,n.language,this.j,this.l,this.n);(0,d.$hl)(f);let k;if(this.c)(0,u.$em)(new u.$cm,f),k=null;else{const{namedPipeServer:W,pipeName:te}=await this.u();(0,u.$em)(new u.$bm(te),f),k=W}const D={env:f,execArgv:o,silent:!0};D.execArgv.unshift("--dns-result-order=ipv4first");const C=["--type=extensionHost","--transformURIs"],L=this.j.args["use-host-proxy"];C.push(`--useHostProxy=${L?"true":"false"}`),this.g=v.fork(S.$1e.asFileUri("bootstrap-fork").fsPath,C,D);const U=this.g.pid;this.p(`<${U}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const x=b.Event.fromNodeEventEmitter(this.g.stdout,"data"),ae=b.Event.fromNodeEventEmitter(this.g.stderr,"data");if(x(W=>this.p(`<${U}> ${W}`)),ae(W=>this.p(`<${U}><stderr> ${W}`)),this.g.on("error",W=>{this.q(`<${U}> Extension Host Process had an error`),this.l.error(W),this.t()}),this.g.on("exit",(W,te)=>{this.m.setExitInfo(this.i,{code:W,signal:te}),this.p(`<${U}> Extension Host Process exited with code: ${W}, signal: ${te}.`),this.t()}),k)k.on("connection",W=>{k.close(),this.r(W,this.h)});else{const W=te=>{te.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",W),this.s(this.g,this.h),this.h=null)};this.g.on("message",W)}}catch(o){console.error("ExtensionHostConnection errored"),o&&console.error(o)}}u(){return new Promise((n,o)=>{const f=(0,$.$hh)(),k=R.createServer();k.on("error",o),k.listen(f,()=>{k?.removeListener("error",o),n({pipeName:f,namedPipeServer:k})})})}};e.$hm=p,e.$hm=p=Le([Ie(4,w.$4l),Ie(5,E.$Ri),Ie(6,m.$_l),Ie(7,h.$Vh)],p);function t(s,n){const o=Object.keys(s).filter(k=>k.toLowerCase()===n.toLowerCase()),f=o.length>0?o[0]:n;return s[f]}function i(s,n,o){const f=Object.keys(s).filter(D=>D.toLowerCase()===n.toLowerCase()),k=f.length>0?f[0]:n;s[k]=o}function a(s){for(const n of Object.keys(s))s[n]===null&&delete s[n]}}),define(we[288],be([1,0,83,12,65,118,24,44,140,36,32,31,127,139,82,112,54,2,113,68,13,16,27,46,121,84,122,11,4,7,29,232,81,34,125,64,3,57,130,33,45,69,128,126,115,116,197,289]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g,y,p,t,i,a,s,n,o,f,k,D,C,L,U,x,ae,W,te,ue,Z,he,V,se,K,Y,H,_,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class ne extends u.$lb{constructor(N,J){super(),this.a=N,this.b=J,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const N=await this.f();await N.invokeFunction(async J=>{const ie=J.get(I.$Vh),re=J.get(R.$Ri);W.$d&&(ie.getValue("security.restrictUNCAccess")===!1?(0,ge.disableUNCAccessRestrictions)():(0,ge.addUNCHostToAllowlist)(ie.getValue("security.allowedUNCHosts")));try{await this.g(N.createInstance(a.$1o,new R.$Zi(re.getLevel(),!1)))}catch(ee){throw re.error(ee),console.error((0,o.$9)(ee)),ee}})}async f(){const N=new v.$nh,J={_serviceBrand:void 0,...c.default};N.set(t.$0i,J);const ie=new i.$5l(this.a,J);N.set(i.$4l,ie);const re=new H.$1M((0,R.$6i)(ie),ie.logsHome);N.set(R.$Si,re);const ee=new Y.$$M(this.B(re.createLogger("remoteCLI",{name:(0,_.localize)(0,null)})));N.set(R.$Ri,ee),ee.trace(`Remote configuration data at ${this.b}`),ee.trace("process arguments:",this.a);const oe=this.B(new h.$vp(ee));N.set(p.$Sj,oe),oe.registerProvider(y.Schemas.file,this.B(new g.$Up(ee)));const F=new x.$hr(oe);N.set(U.$pk,F);const z=this.B(new se.$9M(F,ie,oe,ee));N.set(Z.$rk,z);const j=this.B(new S.$nn(z.defaultProfile.settingsResource,oe,new V.$Zm,ee));return N.set(I.$Vh,j),await Promise.all([j.initialize(),z.init()]),N.set(P.$Bo,new r.$mh(b.$Gq)),N.set(L.$wn,new r.$mh(C.$rN)),N.set(A.$Vk,$.$7n),N.set(E.$Sn,new r.$mh(w.$Xo)),N.set(he.$cp,new r.$mh(K.$0M)),N.set(te.$gp,new r.$mh(ue.$VM)),N.set(d.$Yo,new r.$mh(d.$Zo)),N.set(l.$qp,new r.$mh(l.$rp)),N.set(s.$Aq,new r.$mh(n.$Cq)),new m.$Xp(N)}async g(N){if(this.a["list-extensions"])return N.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const J={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return N.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),J,!!this.a.force)}else{if(this.a["uninstall-extension"])return N.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return N.locateExtension(this.a["locate-extension"])}}h(N){return N.map(J=>/\.vsix$/i.test(J)?f.URI.file((0,k.$7c)(J)?J:(0,k.$8c)((0,D.cwd)(),J)):J)}}function q(O){setTimeout(()=>process.exit(O),0)}async function X(O,N,J){if(O.help){const re=c.default.serverApplicationName+(W.$d?".cmd":"");console.log((0,ae.$pl)(c.default.nameLong,re,c.default.version,J,{noInputFiles:!0,noPipe:!0}));return}if(O.version){console.log((0,ae.$ql)(c.default.version,c.default.commit));return}const ie=new ne(O,N);try{await ie.run(),q(0)}catch{q(1)}finally{ie.dispose()}}e.run=X}),define(we[290],be([1,0,72,264,30,283,4,12,90]),function(le,e,v,R,r,S,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=void 0;class ${constructor(w,l,d){this.b=w,this.c=l,this.f=d,this.a=R.createServer((m,c)=>this.h(m,c)),this.g().catch(m=>(l.error(m),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,l){const d=(c,u)=>{l.writeHead(c,{"content-type":"application/json"}),l.end(JSON.stringify(u||null),h=>h&&this.c.error(h))},m=[];w.setEncoding("utf8"),w.on("data",c=>m.push(c)),w.on("end",async()=>{try{const c=JSON.parse(m.join(""));let u;switch(c.type){case"open":u=await this.i(c);break;case"openExternal":u=await this.j(c);break;case"status":u=await this.l(c);break;case"extensionManagement":u=await this.k(c);break;default:d(404,`Unknown message type: ${c.type}`);break}d(200,u)}catch(c){const u=c instanceof Error?c.message:JSON.stringify(c);d(500,u),this.c.error("Error while processing pipe request",c)}})}async i(w){const{fileURIs:l,folderURIs:d,forceNewWindow:m,diffMode:c,mergeMode:u,addMode:h,forceReuseWindow:g,gotoLineMode:y,waitMarkerFilePath:p,remoteAuthority:t}=w,i=[];if(Array.isArray(d))for(const o of d)try{i.push({folderUri:I.URI.parse(o)})}catch{}if(Array.isArray(l))for(const o of l)try{(0,b.$Uh)(o)?i.push({workspaceUri:I.URI.parse(o)}):i.push({fileUri:I.URI.parse(o)})}catch{}const a=p?I.URI.file(p):void 0,n={forceNewWindow:m,diffMode:c,mergeMode:u,addMode:h,gotoLineMode:y,forceReuseWindow:g,preferNewWindow:!g&&!a&&!h,waitMarkerFileURI:a,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",i,n)}async j(w){for(const l of w.uris){const d=I.URI.parse(l),m=d.scheme==="file"?d:l;await this.b.executeCommand("_remoteCLI.openExternal",m)}}async k(w){const l=m=>m?.map(c=>/\.vsix$/i.test(c)?I.URI.parse(c):c),d={list:w.list,install:l(w.install),uninstall:l(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",d)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&r.existsSync(this.f)&&r.unlinkSync(this.f)}}e.$bM=$;let A=class extends ${constructor(w,l){super(w,l,(0,v.$hh)())}};e.$cM=A,e.$cM=A=Le([Ie(0,S.$9L),Ie(1,P.$Ri)],A)}),define(we[291],be([1,0,26,5,22,2,7,3,4,72,70,290,124,88,271,273,141]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0;class u extends m.$NM{constructor(y,p,t,i,a){super({getFolderUri:s=>{const n=p.filter(o=>o.name===s);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(s,n)=>i[`config:${n}`],getExecPath:()=>y.VSCODE_EXEC_PATH,getAppRoot:()=>y.VSCODE_CWD,getFilePath:()=>{if(t)return I.$6c(t.fsPath)},getSelectedText:()=>i.selectedText,getLineNumber:()=>i.lineNumber,getExtension:async s=>{const o=(await a.getInstalled()).find(f=>f.identifier.id===s);return o&&{extensionLocation:o.location}}},void 0,Promise.resolve(v.homedir()),Promise.resolve(y))}}class h extends S.$lb{constructor(y,p,t,i,a,s){super(),this.g=y,this.h=p,this.i=t,this.j=i,this.l=a,this.m=s,this.a=0,this.b=new Map,this.c=this.B(new R.$ec),this.onExecuteCommand=this.c.event}async call(y,p,t){switch(p){case"$restartPtyHost":return this.i.restartPtyHost.apply(this.i,t);case"$createProcess":{const i=(0,A.$ir)(y.remoteAuthority);return this.n(i,t)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,t);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,t);case"$listProcesses":return this.i.listProcesses.apply(this.i,t);case"$getLatency":return this.i.getLatency.apply(this.i,t);case"$getPerformanceMarks":return this.i.getPerformanceMarks.apply(this.i,t);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,t);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables.apply(this.i,t);case"$start":return this.i.start.apply(this.i,t);case"$input":return this.i.input.apply(this.i,t);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,t);case"$shutdown":return this.i.shutdown.apply(this.i,t);case"$resize":return this.i.resize.apply(this.i,t);case"$clearBuffer":return this.i.clearBuffer.apply(this.i,t);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,t);case"$getCwd":return this.i.getCwd.apply(this.i,t);case"$processBinary":return this.i.processBinary.apply(this.i,t);case"$sendCommandResult":return this.r(t[0],t[1],t[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,t);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,t);case"$getDefaultSystemShell":return this.s.apply(this,t);case"$getProfiles":return this.t.apply(this,t);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(t[0],t[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,t);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,t);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,t);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,t);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,t);case"$updateTitle":return this.i.updateTitle.apply(this.i,t);case"$updateProperty":return this.i.updateProperty.apply(this.i,t);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,t);case"$requestDetachInstance":return this.i.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.i.freePortKillProcess.apply(this.i,t);case"$acceptDetachInstanceReply":return this.i.acceptDetachInstanceReply.apply(this.i,t)}throw new Error(`IPC Command ${p} not found`)}listen(y,p,t){switch(p){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||R.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||R.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||R.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||R.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||R.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||R.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty}throw new Error(`IPC Command ${p} not found`)}async n(y,p){const t={name:p.shellLaunchConfig.name,executable:p.shellLaunchConfig.executable,args:p.shellLaunchConfig.args,cwd:typeof p.shellLaunchConfig.cwd=="string"||typeof p.shellLaunchConfig.cwd>"u"?p.shellLaunchConfig.cwd:b.URI.revive(y.transformIncoming(p.shellLaunchConfig.cwd)),env:p.shellLaunchConfig.env,useShellEnvironment:p.shellLaunchConfig.useShellEnvironment,reconnectionProperties:p.shellLaunchConfig.reconnectionProperties,type:p.shellLaunchConfig.type,isFeatureTerminal:p.shellLaunchConfig.isFeatureTerminal},i=await(0,c.$gm)(p.resolverEnv,!!p.shellLaunchConfig.useShellEnvironment,P.$q,this.g,this.h,this.m);this.h.trace("baseEnv",i);const a=ue=>({uri:b.URI.revive(y.transformIncoming(ue.uri)),name:ue.name,index:ue.index,toResource:()=>{throw new Error("Not implemented")}}),s=p.workspaceFolders.map(a),n=p.activeWorkspaceFolder?a(p.activeWorkspaceFolder):void 0,o=p.activeFileResource?b.URI.revive(y.transformIncoming(p.activeFileResource)):void 0,f=new u(i,s,o,p.resolvedVariables,this.l),k=d.$JM(n,process.env,f),D=await d.$IM(t,v.homedir(),k,n?.uri,p.configuration["terminal.integrated.cwd"],this.h);t.cwd=D;const C=P.$d?"terminal.integrated.env.windows":P.$e?"terminal.integrated.env.osx":"terminal.integrated.env.linux",L=p.configuration[C],U=await d.$KM(t,L,k,this.j.version,p.configuration["terminal.integrated.detectLocale"],i);if(!t.strictEnv){const ue=[];for(const[se,K,Y]of p.envVariableCollections)ue.push([se,{map:(0,l.$7q)(K),descriptionMap:(0,l.$8q)(Y)}]);const Z=new Map(ue),he=new w.$$q(Z),V=n?n??void 0:void 0;await he.applyToProcessEnvironment(U,{workspaceFolder:V},k)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:D,cols:p.cols,rows:p.rows,env:U});const x=(0,$.$hh)();U.VSCODE_IPC_HOOK_CLI=x;const ae=await this.i.createProcess(t,D,p.cols,p.rows,p.unicodeVersion,U,i,p.options,p.shouldPersistTerminal,p.workspaceId,p.workspaceName),W={executeCommand:(ue,...Z)=>this.p(ae,ue,Z,y)},te=new E.$bM(W,this.h,x);return this.i.onProcessExit(ue=>ue.id===ae&&te.dispose()),{persistentTerminalId:ae,resolvedShellLaunchConfig:t}}p(y,p,t,i){let a,s;const n=new Promise((k,D)=>{a=k,s=D}),o=++this.a;this.b.set(o,{resolve:a,reject:s,uriTransformer:i});const f=(0,r.$Lm)(t,k=>{if(k&&k.$mid===1)return i.transformOutgoing(k);if(k&&k instanceof b.URI)return i.transformOutgoingURI(k)});return this.c.fire({reqId:o,persistentProcessId:y,commandId:p,commandArgs:f}),n}r(y,p,t){const i=this.b.get(y);if(!i)return;this.b.delete(y);const a=(0,r.$Lm)(t,s=>{if(s&&s.$mid===1)return i.uriTransformer.transformIncoming(s)});p?i.reject(a):i.resolve(a)}s(y){return this.i.getDefaultSystemShell(y)}async t(y,p,t,i){return this.i.getProfiles(y,p,t,i)||[]}u(){return{...process.env}}w(y,p){return this.i.getWslPath(y,p)}y(){return this.i.reduceConnectionGraceTime()}}e.$OM=h}),define(we[292],be([1,0,26,5,2,13,7,102,21,42,24,118,80,227,205,81,206,25,127,31,82,121,215,139,16,113,68,65,112,83,84,122,12,54,27,44,233,140,120,32,36,247,89,255,34,125,268,269,238,244,291,70,46,276,284,129,57,130,45,33,263,69,245,116,128,126,115,114,199,281,230,259,252]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g,y,p,t,i,a,s,n,o,f,k,D,C,L,U,x,ae,W,te,ue,Z,he,V,se,K,Y,H,_,ge,ne,q,X,O,N,J,ie,re,ee,oe,F,z,j,B,Q,de,Ee,Pe,Re,Fe,$e,ke,ye,Te,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=e.$hN=void 0;const xe="monacoworkbench";async function qe(Be,Me,He,Ge){const Je=new k.$nh,Ve=new tt,et={_serviceBrand:void 0,...U.default};Je.set(x.$0i,et);const Xe=new N.$5l(Me,et);Je.set(u.$wh,Xe),Je.set(u.$xh,Xe);const ot=new de.$1M((0,L.$6i)(Xe),Xe.logsHome);Je.set(L.$Si,ot),Ve.registerChannel("logger",new Fe.$Tq(ot,st=>Ye(st.remoteAuthority)));const ft=ot.createLogger("remoteagent",{name:(0,$e.localize)(0,null)}),rt=new Re.$$M(ft,[new me((0,L.$6i)(Xe))]);Je.set(L.$Ri,rt),setTimeout(()=>Ne(Xe.logsHome.fsPath).then(null,st=>rt.error(st)),1e4),rt.onDidChangeLogLevel(st=>(0,L.log)(rt,st,`Log level changed to ${(0,L.$7i)(rt.getLevel())}`)),rt.trace(`Remote configuration data at ${He}`),rt.trace("process arguments:",Xe.args),Array.isArray(et.serverGreeting)&&rt.info(`

${et.serverGreeting.join(`
`)}

`),Ve.registerChannel(d.$un.ChannelName,new d.$un);const Mt=new $.$0g(st=>st.clientId==="renderer"),$t=Ge.add(new s.$vp(rt));Je.set(a.$Sj,$t),$t.registerProvider(S.Schemas.file,Ge.add(new n.$Up(rt)));const Ct=new H.$hr($t);Je.set(Y.$pk,Ct);const mt=new E.$nn(Xe.machineSettingsResource,$t,new B.$Zm,rt);Je.set(A.$Vh,mt);const wt=new Ee.$9M(Ct,Xe,$t,rt);Je.set(z.$rk,wt),Ve.registerChannel("userDataProfiles",new Te.$eN(wt,st=>Ye(st.remoteAuthority)));const[,,vt]=await Promise.all([mt.initialize(),wt.init(),(0,P.$wm)(rt.error.bind(rt))]),Tt=new re.$am;Je.set(re.$_l,Tt);const Pt=new te.$Gq(mt,Xe,rt,ot);Je.set(ae.$Bo,Pt);let Et=he.$$n;const jt=(0,he.$fo)(et,mt);if((0,he.$ao)(et,Xe)){const st=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";st?Et=new Q.$YM(Pt,!1,xe,null,()=>new j.$WM(st)):et.aiConfig&&et.aiConfig.ariaKey&&(Et=new Q.$YM(Pt,jt,xe,null,et.aiConfig.ariaKey),Ge.add((0,r.$jb)(()=>Et?.flush())));const pt={appenders:[Et],commonProperties:(0,ue.$3n)((0,v.release)(),(0,v.hostname)(),process.arch,et.commit,et.version+"-remote",vt,jt,"remoteAgent"),piiPaths:(0,he.$go)(Xe)},gt=Xe.args["telemetry-level"];let ut=3;gt==="all"?ut=3:gt==="error"?ut=2:gt==="crash"?ut=1:gt!==void 0&&(ut=0),Je.set(q.$vr,new o.$mh(q.$tr,[pt,ut]))}else Je.set(q.$vr,q.$ur);Je.set(g.$Sn,new o.$mh(h.$Xo));const It=Ve.getChannel("download",Mt);Je.set(m.$wn,new c.$yn(It,()=>Ye("renderer"))),Je.set(F.$cp,new o.$mh(Pe.$0M)),Je.set(ee.$gp,new o.$mh(oe.$VM)),Je.set(y.$Yo,new o.$mh(y.$Zo)),Je.set(i.$qp,new o.$mh(i.$rp));const bt=new f.$Xp(Je);Je.set(D.$Aq,bt.createInstance(C.$Cq));const At=bt.createInstance(ze.$gN,{graceTime:108e5,shortGraceTime:3e5,scrollback:mt.getValue("terminal.integrated.persistentSessionScrollback")??100}),Lt=bt.createInstance(K.$dr,At);return Je.set(se.$Oq,Lt),Je.set(w.$pn,new o.$mh(l.$sn)),bt.invokeFunction(st=>{const pt=st.get(i.$qp),gt=st.get(ee.$gp),ut=st.get(g.$Sn),zt=st.get(D.$Aq),Rt=new _.$pr(Be,Xe,wt,Tt);Ve.registerChannel("remoteextensionsenvironment",Rt);const Bt=new ne.$wr(st.get(q.$vr),Et);Ve.registerChannel("telemetry",Bt),Ve.registerChannel(J.$PM,new X.$OM(Xe,rt,Lt,et,pt,mt));const ve=new ke.$cN(bt.createInstance(p.$1o,rt),Xe,wt,gt,rt,ut,zt);Ve.registerChannel(ye.$bN,new ke.$dN(ve,Oe=>Ye(Oe.remoteAuthority)));const Se=new ge.$sr(rt,Xe);Ve.registerChannel(ie.$TM,Se),Ve.registerChannel("request",new W.$Dq(st.get(ae.$Bo)));const fe=new t.$2o(pt,Oe=>Ye(Oe.remoteAuthority));Ve.registerChannel("extensions",fe);const G=$.ProxyChannel.fromService(st.get(D.$Aq));Ve.registerChannel("languagePacks",G);const Ce=$.ProxyChannel.fromService(st.get(w.$pn));return Ve.registerChannel("credentials",Ce),ve.whenExtensionsReady().then(()=>pt.cleanUp()),Ge.add(new V.default(st.get(Z.$Vk))),{telemetryService:st.get(Z.$Vk)}}),{socketServer:Ve,instantiationService:bt}}e.$hN=qe;const Ze=Object.create(null);function Ye(Be){return Ze[Be]||(Ze[Be]=(0,O.$ir)(Be)),Ze[Be]}class tt extends $.$6g{constructor(){const Me=new R.$ec;super(Me.event),this.b=Me}acceptConnection(Me,He){this.b.fire({protocol:Me,onDidClientDisconnect:He})}}e.$iN=tt;class me extends L.$Wi{constructor(Me=L.$Ui){super(),this.setLevel(Me),this.g=!!process.stdout.isTTY}trace(Me,...He){this.f(L.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${De()}]\x1B[0m`,Me,...He):console.log(`[${De()}]`,Me,...He))}debug(Me,...He){this.f(L.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${De()}]\x1B[0m`,Me,...He):console.log(`[${De()}]`,Me,...He))}info(Me,...He){this.f(L.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${De()}]\x1B[0m`,Me,...He):console.log(`[${De()}]`,Me,...He))}warn(Me,...He){this.f(L.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${De()}]\x1B[0m`,Me,...He):console.warn(`[${De()}]`,Me,...He))}error(Me,...He){this.f(L.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${De()}]\x1B[0m`,Me,...He):console.error(`[${De()}]`,Me,...He))}dispose(){}flush(){}}function De(){const Be=new Date;return`${Ae(Be.getHours())}:${Ae(Be.getMinutes())}:${Ae(Be.getSeconds())}`}function Ae(Be){return Be<10?`0${Be}`:String(Be)}async function Ne(Be){const Me=I.$_c(Be),He=I.$$c(Be),Ve=(await b.Promises.readdir(He)).filter(Xe=>/^\d{8}T\d{6}$/.test(Xe)).sort().filter(Xe=>Xe!==Me),et=Ve.slice(0,Math.max(0,Ve.length-9));await Promise.all(et.map(Xe=>b.Promises.rm(I.$8c(He,Xe))))}}),define(we[293],be([1,0,87,30,78,294,85,95,15,11,38,2,13,7,41,3,17,4,23,155,157,289,107,72,24,6,12,27,56,32,141,260,261,46,292,265]),function(le,e,v,R,r,S,I,P,b,$,A,E,w,l,d,m,c,u,h,g,y,p,t,i,a,s,n,o,f,k,D,C,L,U,x,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=void 0;const W=5*60*1e3;let te=class extends E.$lb{constructor(V,se,K,Y,H,_,ge,ne){super(),this.k=V,this.l=se,this.m=K,this.n=H,this.p=_,this.r=ge,this.s=ne,this.h=Z.create(this.p),this.i=(0,f.$Dk)(_),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=Y?this.s.createInstance(ae.$lN,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(V,se){if(V.method!=="GET")return(0,ae.$jN)(V,se,405,`Unsupported method ${V.method}`);if(!V.url)return(0,ae.$jN)(V,se,400,"Bad request.");const K=I.parse(V.url,!0);let Y=K.pathname;if(!Y)return(0,ae.$jN)(V,se,400,"Bad request.");if(Y.startsWith(this.i)&&Y.charCodeAt(this.i.length)===47&&(Y=Y.substring(this.i.length)),Y==="/version")return se.writeHead(200,{"Content-Type":"text/plain"}),void se.end(this.p.commit||"");if(Y==="/delay-shutdown")return this.H(),se.writeHead(200),void se.end("OK");if(!(0,L.$om)(this.l,V,K))return(0,ae.$jN)(V,se,403,"Forbidden.");if(Y==="/vscode-remote-resource"){const H=K.query.path;if(typeof H!="string")return(0,ae.$jN)(V,se,400,"Bad request.");let _;try{_=u.URI.from({scheme:w.Schemas.file,path:H}).fsPath}catch{return(0,ae.$jN)(V,se,400,"Bad request.")}const ge=Object.create(null);this.n.isBuilt&&((0,A.$He)(_,this.n.builtinExtensionsPath,!m.$f)||(0,A.$He)(_,this.n.extensionsPath,!m.$f))&&(ge["Cache-Control"]="public, max-age=31536000"),ge.Vary="Origin";const ne=V.headers.origin;return ne&&this.h.matches(ne)&&(ge["Access-Control-Allow-Origin"]=ne),(0,ae.$kN)(_,1,this.r,V,se,ge)}if(this.g){this.g.handle(V,se,K);return}return se.writeHead(404,{"Content-Type":"text/plain"}),void se.end("Not found")}handleUpgrade(V,se){let K=(0,h.$3e)(),Y=!1,H=!1;if(V.url){const O=I.parse(V.url,!0).query;typeof O.reconnectionToken=="string"&&(K=O.reconnectionToken),O.reconnection==="true"&&(Y=!0),O.skipWebSocketFrames==="true"&&(H=!0)}if(V.headers.upgrade===void 0||V.headers.upgrade.toLowerCase()!=="websocket"){se.end("HTTP/1.1 400 Bad Request");return}const _=V.headers["sec-websocket-key"],ge=v.createHash("sha1");ge.update(_+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const q=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ge.digest("base64")}`];let X=!1;if(!H&&!this.n.args["disable-websocket-compression"]&&V.headers["sec-websocket-extensions"]){const O=Array.isArray(V.headers["sec-websocket-extensions"])?V.headers["sec-websocket-extensions"]:[V.headers["sec-websocket-extensions"]];for(const N of O)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(N)){if(/\b(permessage-deflate)\b/.test(N)){X=!0,q.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(N)){X=!0,q.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}se.write(q.join(`\r
`)+`\r
\r
`),se.setTimeout(0),se.setNoDelay(!0),H?this.v(new i.$eh(se,`server-connection-${K}`),Y,K):this.v(new i.$fh(new i.$eh(se,`server-connection-${K}`),X,null,!0),Y,K)}handleServerError(V){this.r.error("Error occurred in server"),this.r.error(V)}t(V){let se;return V instanceof i.$eh?se=V.socket:se=V.socket.socket,se.remoteAddress||"<unknown>"}async u(V,se,K){const Y=se.getSocket();this.r.error(`${V} ${K}.`);const H={type:"error",reason:K};se.sendControl(b.$Ec.fromString(JSON.stringify(H))),se.dispose(),await Y.drain(),Y.dispose()}v(V,se,K){const Y=this.t(V),H=`[${Y}][${K.substr(0,8)}]`,_=new t.$dh({socket:V}),ge=this.m?new this.m.validator:null,ne=this.m?new this.m.signer:null;let q;(function(J){J[J.WaitingForAuth=0]="WaitingForAuth",J[J.WaitingForConnectionType=1]="WaitingForConnectionType",J[J.Done=2]="Done",J[J.Error=3]="Error"})(q||(q={}));let X=0;const O=J=>{X=3,N.dispose(),this.u(H,_,J)},N=_.onControlMessage(J=>{if(X===0){let ie;try{ie=JSON.parse(J.toString())}catch{return O("Malformed first message")}if(ie.type!=="auth")return O("Invalid first message");if(this.l.type===2&&!this.l.validate(ie.auth))return O("Unauthorized client refused: auth mismatch");let re=(0,h.$3e)();if(ne)try{re=ne.sign(ie.data)}catch{}let ee=(0,h.$3e)();if(ge)try{ee=ge.createNewMessage(ee)}catch{}const oe={type:"sign",data:ee,signedData:re};_.sendControl(b.$Ec.fromString(JSON.stringify(oe))),X=1}else if(X===1){let ie;try{ie=JSON.parse(J.toString())}catch{return O("Malformed second message")}if(ie.type!=="connectionType")return O("Invalid second message");if(typeof ie.signedData!="string")return O("Invalid second message field type");const re=ie.commit,ee=this.p.commit;if(re&&ee&&re!==ee)return O("Client refused: version mismatch");let oe=!1;if(!ge)oe=!0;else if(this.l.validate(ie.signedData))oe=!0;else try{oe=ge.validate(ie.signedData)==="ok"}catch{}if(!oe){if(this.n.isBuilt)return O("Unauthorized client refused");this.r.error(`${H} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const F in this.b)this.b[F].shortenReconnectionGraceTimeIfNecessary();for(const F in this.a)this.a[F].shortenReconnectionGraceTimeIfNecessary();X=2,N.dispose(),this.w(Y,H,_,V,se,K,ie)}})}async w(V,se,K,Y,H,_,ge){const ne=ge.desiredConnectionType===1?`${se}[ManagementConnection]`:ge.desiredConnectionType===2?`${se}[ExtensionHostConnection]`:se;if(ge.desiredConnectionType===1)if(H){if(!this.b[_])return this.f.has(_)?this.u(ne,K,"Unknown reconnection token (seen before)"):this.u(ne,K,"Unknown reconnection token (never seen)");K.sendControl(b.$Ec.fromString(JSON.stringify({type:"ok"})));const q=K.readEntireBuffer();K.dispose(),this.b[_].acceptReconnection(V,Y,q)}else{if(this.b[_])return this.u(ne,K,"Duplicate reconnection token");K.sendControl(b.$Ec.fromString(JSON.stringify({type:"ok"})));const q=new C.$im(this.r,_,V,K);this.k.acceptConnection(q.protocol,q.onClose),this.b[_]=q,this.f.add(_),q.onClose(()=>{delete this.b[_]})}else if(ge.desiredConnectionType===2){const q=ge.args||{language:"en"},X=await this.C(q);if(X.port&&this.r.trace(`${ne} - startParams debug port ${X.port}`),this.r.trace(`${ne} - startParams language: ${X.language}`),this.r.trace(`${ne} - startParams env: ${JSON.stringify(X.env)}`),H){if(!this.a[_])return this.f.has(_)?this.u(ne,K,"Unknown reconnection token (seen before)"):this.u(ne,K,"Unknown reconnection token (never seen)");K.sendPause(),K.sendControl(b.$Ec.fromString(JSON.stringify(X.port?{debugPort:X.port}:{})));const O=K.readEntireBuffer();K.dispose(),this.a[_].acceptReconnection(V,Y,O)}else{if(this.a[_])return this.u(ne,K,"Duplicate reconnection token");K.sendPause(),K.sendControl(b.$Ec.fromString(JSON.stringify(X.port?{debugPort:X.port}:{})));const O=K.readEntireBuffer();K.dispose();const N=this.s.createInstance(D.$hm,_,V,Y,O);this.a[_]=N,this.f.add(_),N.onClose(()=>{delete this.a[_],this.D()}),N.start(X)}}else if(ge.desiredConnectionType===3){const q=ge.args;this.y(K,q)}else return this.u(ne,K,"Unknown initial data received")}async y(V,se){const K=V.getSocket().socket,Y=V.readEntireBuffer();V.dispose(),K.pause();const H=await this.z(se.host,se.port);Y.byteLength>0&&H.write(Y.buffer),H.on("end",()=>K.end()),H.on("close",()=>K.end()),H.on("error",()=>K.destroy()),K.on("end",()=>H.end()),K.on("close",()=>H.end()),K.on("error",()=>H.destroy()),H.pipe(K),K.pipe(H)}z(V,se){return new Promise((K,Y)=>{const H=r.createConnection({host:V,port:se,autoSelectFamily:!0},()=>{H.removeListener("error",Y),H.pause(),K(H)});H.once("error",Y)})}C(V){return typeof V.port=="number"?(0,y.$5e)(V.port,10,5e3).then(se=>(V.port=se,V)):(V.debugId=void 0,V.port=void 0,V.break=void 0,Promise.resolve(V))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(V=!1){this.n.args["enable-remote-auto-shutdown"]&&(this.n.args["remote-auto-shutdown-without-delay"]&&!V?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},W))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};te=Le([Ie(4,U.$4l),Ie(5,o.$0i),Ie(6,n.$Ri),Ie(7,s.$oh)],te);async function ue(he,V,se){const K=await(0,L.$nm)(V);K instanceof L.$lm&&(console.warn(K.message),process.exit(1));function Y(oe){(0,$.setUnexpectedErrorHandler)(F=>{(0,$.$X)(F)&&F.stack&&/unexpectedErrorHandler/.test(F.stack)||oe(F)})}const H=[];Y(oe=>{H.push(oe),console.error(oe)});let _=!1;process.on("SIGPIPE",()=>{_||(_=!0,(0,$.$Y)(new Error("Unexpected SIGPIPE")))});const ge=new E.$kb,{socketServer:ne,instantiationService:q}=await(0,x.$hN)(K,V,se,ge);q.invokeFunction(oe=>{const F=oe.get(n.$Ri);H.forEach(z=>F.error(z)),H.length=0,Y(z=>F.error(z))}),q.invokeFunction(oe=>{const F=oe.get(a.$Vh);m.$d&&(F.getValue("security.restrictUNCAccess")===!1?(0,p.disableUNCAccessRestrictions)():(0,p.addUNCHostToAllowlist)(F.getValue("security.allowedUNCHosts")))}),q.invokeFunction(oe=>{const F=oe.get(n.$Ri);if(m.$d&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const z=(0,l.$8c)(process.env.HOMEDRIVE,"node_modules"),j=(0,l.$$c)((0,l.$8c)(process.env.HOMEDRIVE,process.env.HOMEPATH)),B=(0,l.$8c)(j,"node_modules");if(R.existsSync(z)||R.existsSync(B)){const Q=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${z}
* ${B}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;F.warn(Q),console.warn(Q),process.exit(0)}}});const X=q.invokeFunction(oe=>{const F=oe.get(n.$Ri);if(R.existsSync((0,l.$8c)(w.$1e.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(j){F.error(j)}return null}),O=R.existsSync(w.$1e.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(O&&he&&typeof he!="string"){const oe=K.type!==0?`?${w.$Ue}=${K.value}`:"";console.log(`Web UI available at http://localhost${he.port===80?"":`:${he.port}`}/${oe}`)}const N=q.createInstance(te,ne,K,X,O);d.mark("code/server/ready");const J=S.performance.now(),ie=global.vscodeServerStartTime,re=global.vscodeServerListenTime,ee=global.vscodeServerCodeLoadedTime;if(q.invokeFunction(async oe=>{const F=oe.get(k.$Vk);if(F.publicLog2("serverStart",{startTime:ie,startedTime:re,codeLoadedTime:ee,readyTime:J}),m.$f){const z=oe.get(n.$Ri),j=await(0,g.$4e)(z.error.bind(z));j&&F.publicLog2("serverPlatformInfo",{platformId:j.id,platformVersionId:j.version_id,platformIdLike:j.id_like})}}),V["print-startup-performance"]){const oe=P.$S.get();let F="";F+=`

### Load AMD-module
`,F+=P.$S.toMarkdownTable(["Module","Duration"],oe.amdLoad),F+=`

### Load commonjs-module
`,F+=P.$S.toMarkdownTable(["Module","Duration"],oe.nodeRequire),F+=`

### Invoke AMD-module factory
`,F+=P.$S.toMarkdownTable(["Module","Duration"],oe.amdInvoke),F+=`

### Invoke commonjs-module
`,F+=P.$S.toMarkdownTable(["Module","Duration"],oe.nodeEval),F+=`Start-up time: ${re-ie}
`,F+=`Code loading time: ${ee-ie}
`,F+=`Initialized time: ${J-ie}
`,F+=`
`,console.log(F)}return N}e.$qN=ue;class Z{static create(V){const se=V.webEndpointUrlTemplate,K=V.commit,Y=V.quality;if(!se||!K||!Y)return new Z(null);const H=(0,h.$3e)(),ge=new URL(se.replace("{{uuid}}",H).replace("{{commit}}",K).replace("{{quality}}",Y)).origin,ne=(0,c.$pd)(ge).replace(H,"[a-zA-Z0-9\\-]+");try{const q=(0,c.$xd)(`^${ne}$`,!0,{matchCase:!1});return new Z(q)}catch{return new Z(null)}}constructor(V){this.a=V}matches(V){return this.a?this.a.test(V):!1}}}),define(we[304],be([1,0,26,30,13,288,293,64,7,294,46,54,41]),function(le,e,v,R,r,S,I,P,b,$,A,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,w.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=$.performance.now();const l={onMultipleValues:(h,g)=>{console.error(`Option '${h}' can only be defined once. Using value ${g}.`)},onEmptyValue:h=>{console.error(`Ignoring option '${h}': Value must not be empty.`)},onUnknownOption:h=>{console.error(`Ignoring option '${h}': not supported for server.`)},onDeprecatedOption:(h,g)=>{console.warn(`Option '${h}' is deprecated: ${g}`)}};function d(){return(0,P.$nl)(process.argv.slice(2),A.$3l,l)}function m(h){const g=h["server-data-dir"]||h["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,b.$8c)(v.homedir(),E.default.serverDataFolderName||".vscode-remote"),y=h["user-data-dir"]||(0,b.$8c)(g,"data"),p=(0,b.$8c)(y,"User"),t=(0,b.$8c)(p,"globalStorage"),i=(0,b.$8c)(p,"History"),a=(0,b.$8c)(y,"Machine");h["user-data-dir"]=y;const s=(0,b.$$c)(r.$1e.asFileUri("").fsPath),n=h["builtin-extensions-dir"]||(0,b.$8c)(s,"extensions");return h["builtin-extensions-dir"]=n,h["extensions-dir"]=h["extensions-dir"]||(0,b.$8c)(g,"extensions"),[g,h["extensions-dir"],y,p,a,t,i].forEach(o=>{try{R.existsSync(o)||R.mkdirSync(o,{mode:448})}catch(f){console.error(f)}}),g}function c(h=d()){return(0,S.run)(h,m(h),A.$3l)}e.spawnCli=c;function u(h,g=d()){return(0,I.$qN)(h,g,m(g))}e.createServer=u})}).call(this);

//# sourceMappingURL=server.main.js.map
