"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/base/common/uri","vs/editor/common/tokens/lineTokens","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],K=function(F){for(var e=[],T=0,S=F.length;T<S;T++)e[T]=q[F[T]];return e};define(q[21],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class T{static get(){const v=new Map,O=new Map,r=new Map,u=new Map;function t(l,n){l.has(n.detail)||l.set(n.detail,-n.timestamp)}function a(l,n){const i=l.get(n.detail);i&&(i>=0||l.set(n.detail,i+n.timestamp))}let o=[];typeof F=="function"&&typeof F.getStats=="function"&&(o=F.getStats().slice(0).sort((l,n)=>l.timestamp-n.timestamp));for(const l of o)switch(l.type){case 10:t(v,l);break;case 11:case 12:a(v,l);break;case 21:t(O,l);break;case 22:a(O,l);break;case 33:t(r,l);break;case 34:a(r,l);break;case 31:t(u,l);break;case 32:a(u,l);break}let c=0;r.forEach(l=>c+=l);function f(l){const n=[];return l.forEach((i,s)=>n.push([s,i])),n}return{amdLoad:f(v),amdInvoke:f(O),nodeRequire:f(r),nodeEval:f(u),nodeRequireTotal:c}}static toMarkdownTable(v,O){let r="";const u=[];return v.forEach((t,a)=>{u[a]=t.length}),O.forEach(t=>{t.forEach((a,o)=>{typeof a>"u"&&(a=t[o]="-");const c=a.toString().length;u[o]=Math.max(c,u[o])})}),v.forEach((t,a)=>{r+=`| ${t+" ".repeat(u[a]-t.toString().length)} `}),r+=`|
`,v.forEach((t,a)=>{r+=`| ${"-".repeat(u[a])} `}),r+=`|
`,O.forEach(t=>{t.forEach((a,o)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(u[o]-a.toString().length)} `)}),r+=`|
`}),r}}e.$S=T}),define(q[4],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vb=e.$Ub=e.$Tb=void 0;let T;function S(i){T=i}e.$Tb=S;function v(){return T}e.$Ub=v;class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([u(l("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[u(" "),a(o(s.oldValue,70),{color:"red",strikeThrough:!0}),u(" "),a(o(s.newValue,60),{color:"green"})]:[u(" (unchanged)")]:[u(" "),a(o(s.newValue,60),{color:"green"}),u(" (initial)")]}handleObservableChanged(s,$){console.log(...this.b([t("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c($)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map($=>$.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const $=s.handleChange;this.d.set(s,new Set),s.handleChange=(E,P)=>(this.d.get(s).add(E),$.apply(s,[E,P]))}handleDerivedRecomputed(s,$){const E=this.d.get(s);console.log(...this.b([t("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c($),this.formatChanges(E),{data:[{fn:s._computeFn}]}])),E.clear()}handleFromEventObservableTriggered(s,$){console.log(...this.b([t("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c($),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const $=s.handleChange;this.d.set(s,new Set),s.handleChange=(E,P)=>(this.d.get(s).add(E),$.apply(s,[E,P]))}handleAutorunTriggered(s){const $=this.d.get(s);console.log(...this.b([t("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges($),{data:[{fn:s._runFn}]}])),$.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let $=s.getDebugName();$===void 0&&($=""),console.log(...this.b([t("transaction"),a($,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Vb=O;function r(i){const s=new Array,$=[];let E="";function P(k){if("length"in k)for(const d of k)d&&P(d);else"text"in k?(E+=`%c${k.text}`,s.push(k.style),k.data&&$.push(...k.data)):"data"in k&&$.push(...k.data)}P(i);const M=[E,...s];return M.push(...$),M}function u(i){return a(i,{color:"black"})}function t(i){return a(n(`${i}: `,10),{color:"black",bold:!0})}function a(i,s={color:"black"}){function $(P){return Object.entries(P).reduce((M,[k,d])=>`${M}${k}:${d};`,"")}const E={color:s.color};return s.strikeThrough&&(E["text-decoration"]="line-through"),s.bold&&(E["font-weight"]="bold"),{text:i,style:$(E)}}function o(i,s){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=s?`"${i}"`:`"${i.substr(0,s-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?c(i,s):f(i,s);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function c(i,s){let $="[ ",E=!0;for(const P of i){if(E||($+=", "),$.length-5>s){$+="...";break}E=!1,$+=`${o(P,s-$.length)}`}return $+=" ]",$}function f(i,s){let $="{ ",E=!0;for(const[P,M]of Object.entries(i)){if(E||($+=", "),$.length-5>s){$+="...";break}E=!1,$+=`${P}: ${o(M,s-$.length)}`}return $+=" }",$}function l(i,s){let $="";for(let E=1;E<=s;E++)$+=i;return $}function n(i,s){for(;i.length<s;)i+=" ";return i}}),define(q[5],K([0,1,4]),function(F,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=void 0;let S;function v(i){S=i}e.$2b=v;class O{get TChange(){return null}reportChanges(){this.get()}read(s){return s?s.readObservable(this):this.get()}map(s){return S($=>s(this.read($),$),()=>{const $=o(s);if($!==void 0)return $;const P=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(s.toString());return P?`${this.debugName}.${P[2]}`:`${this.debugName} (mapped)`})}}e.$3b=O;class r extends O{constructor(){super(...arguments),this.c=new Set}addObserver(s){const $=this.c.size;this.c.add(s),$===0&&this.f()}removeObserver(s){this.c.delete(s)&&this.c.size===0&&this.g()}f(){}g(){}}e.$4b=r;function u(i,s){const $=new a(i,s);try{i($)}finally{$.finish()}}e.$5b=u;function t(i,s,$){i?s(i):u(s,$)}e.$6b=t;class a{constructor(s,$){this._fn=s,this.b=$,this.a=[],(0,T.$Ub)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():o(this._fn)}updateObserver(s,$){this.a.push({observer:s,observable:$}),s.beginUpdate($)}finish(){const s=this.a;this.a=null;for(const{observer:$,observable:E}of s)$.endUpdate(E);(0,T.$Ub)()?.handleEndTransaction()}}e.$7b=a;function o(i){const s=i.toString(),E=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(s);return(E?E[1]:void 0)?.trim()}e.$8b=o;function c(i,s){return new f(i,s)}e.$9b=c;class f extends r{constructor(s,$){super(),this.debugName=s,this.a=$}get(){return this.a}set(s,$,E){if(this.a===s)return;let P;$||($=P=new a(()=>{},()=>`Setting ${this.debugName}`));try{const M=this.a;this.b(s),(0,T.$Ub)()?.handleObservableChanged(this,{oldValue:M,newValue:s,change:E,didChange:!0,hadValue:!0});for(const k of this.c)$.updateObserver(k,this),k.handleChange(this,E)}finally{P&&P.finish()}}toString(){return`${this.debugName}: ${this.a}`}b(s){this.a=s}}e.$0b=f;function l(i,s){return new n(i,s)}e.$$b=l;class n extends f{b(s){this.a!==s&&(this.a&&this.a.dispose(),this.a=s)}dispose(){this.a?.dispose()}}e.$_b=n}),define(q[9],K([0,1,42,2,5,4]),function(F,e,T,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=void 0;function r(n,i){return new f(n.debugName,i,void 0,void 0)}e.$Ab=r;function u(n){return new f(void 0,n,void 0,void 0)}e.$Bb=u;function t(n,i){return new f(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$Cb=t;function a(n,i){const s=new S.$kb,$=t({debugName:n.debugName??(()=>(0,v.$8b)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(E,P)=>{s.clear(),i(E,P,s)});return(0,S.$jb)(()=>{$.dispose(),s.dispose()})}e.$Db=a;function o(n){const i=new S.$kb,s=r({debugName:()=>(0,v.$8b)(n)||"(anonymous)"},$=>{i.clear(),n($,i)});return(0,S.$jb)(()=>{s.dispose(),i.dispose()})}e.$Eb=o;var c;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(c||(c={}));class f{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const s=this.h();if(s!==void 0)return s}const i=(0,v.$8b)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,s,$,E){this.h=i,this._runFn=s,this.i=$,this.j=E,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$Ub)()?.handleAutorunCreated(this),this.k()}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear()}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,O.$Ub)()?.handleAutorunTriggered(this);const s=this.g;this.g=this.i?.(),this._runFn(this,s)}}finally{(0,O.$Ub)()?.handleAutorunFinished(this);for(const s of this.f)s.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,T.$yb)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,s){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:s,didChange:E=>E===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const s=i.get();return this.e.add(i),this.f.delete(i),s}}e.$Fb=f,function(n){n.Observer=f}(u||(e.$Bb=u={}));function l(n,i){let s;return r({debugName:()=>(0,v.$8b)(i)},$=>{const E=n.read($),P=s;s=E,i({lastValue:P,newValue:E})})}e.$Gb=l}),define(q[10],K([0,1,6,2,5,4]),function(F,e,T,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=void 0;const r=(l,n)=>l===n;function u(l,n){return new f(n,l,void 0,void 0,void 0,r)}e.$Wb=u;function t(l,n){return new f(l.debugName,n,void 0,void 0,void 0,l.equalityComparer??r)}e.$Xb=t;function a(l,n,i){return new f(l,i,n.createEmptyChangeSummary,n.handleChange,void 0,r)}e.$Yb=a;function o(l,n){const i=new S.$kb;return new f(l,s=>(i.clear(),n(s,i)),void 0,void 0,()=>i.dispose(),r)}e.$Zb=o,(0,v.$2b)(u);var c;(function(l){l[l.initial=0]="initial",l[l.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",l[l.stale=2]="stale",l[l.upToDate=3]="upToDate"})(c||(c={}));class f extends v.$4b{get debugName(){return this.m?typeof this.m=="function"?this.m():this.m:(0,v.$8b)(this._computeFn)||"(anonymous)"}constructor(n,i,s,$,E=void 0,P){super(),this.m=n,this._computeFn=i,this.n=s,this.p=$,this.q=E,this.s=P,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,O.$Ub)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.n?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.u()}while(this.e!==3);return this.h}}u(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,s=this.h;this.e=3;const $=this.l;this.l=this.n?.();try{this.h=this._computeFn(this,$)}finally{for(const P of this.k)P.removeObserver(this);this.k.clear()}const E=i&&!this.s(s,this.h);if((0,O.$Ub)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.h,change:void 0,didChange:E,hadValue:i}),E)for(const P of this.c)P.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const s of this.c)s.handlePossibleChange(this);if(i)for(const s of this.c)s.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const s of i)s.endUpdate(this)}if(this.i<0)throw new T.$bb}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const s=this.p?this.p({changedObservable:n,change:i,didChange:E=>E===n},this.l):!0,$=this.e===3;if(s&&(this.e===1||$)&&(this.e=2,$))for(const E of this.c)E.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$1b=f}),define(q[22],K([0,1,2,9,5,10,4]),function(F,e,T,S,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=void 0;function u(m){return new t(m)}e.$Hb=u;class t extends v.$3b{constructor(w){super(),this.a=w}get debugName(){return this.toString()}get(){return this.a}addObserver(w){}removeObserver(w){}toString(){return`Const: ${this.a}`}}function a(m){const w=(0,v.$9b)("promiseValue",{});return m.then(N=>{w.set({value:N},void 0)}),w}e.$Ib=a;function o(m,w){return new Promise(N=>{let D=!1,g=!1;const A=(0,S.$Bb)(U=>{const z=m.read(U);w(z)&&(D?A.dispose():g=!0,N(z))});D=!0,g&&A.dispose()})}e.$Jb=o;function c(m,w){return new f(m,w)}e.$Kb=c;class f extends v.$4b{constructor(w,N){super(),this.h=w,this._getValue=N,this.b=!1,this.k=D=>{const g=this._getValue(D),A=!this.b||this.a!==g;(0,r.$Ub)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:g,change:void 0,didChange:A,hadValue:this.b}),A&&(this.a=g,this.b&&(0,v.$5b)(U=>{for(const z of this.c)U.updateObserver(z,this),z.handleChange(this,void 0)},()=>{const U=this.i();return"Event fired"+(U?`: ${U}`:"")}),this.b=!0)}}i(){return(0,v.$8b)(this._getValue)}get debugName(){const w=this.i();return"From Event"+(w?`: ${w}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$Lb=f,function(m){m.Observer=f}(c||(e.$Kb=c={}));function l(m,w){return new n(m,w)}e.$Mb=l;class n extends v.$4b{constructor(w,N){super(),this.debugName=w,this.b=N,this.h=()=>{(0,v.$5b)(D=>{for(const g of this.c)D.updateObserver(g,this),g.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(m){return new s(m)}e.$Nb=i;class s extends v.$4b{constructor(w){super(),this.debugName=w}trigger(w,N){if(!w){(0,v.$5b)(D=>{this.trigger(D,N)},()=>`Trigger signal ${this.debugName}`);return}for(const D of this.c)w.updateObserver(D,this),D.handleChange(this,N)}get(){}}function $(m,w,N){const D=(0,v.$9b)("debounced",void 0);let g;return N.add((0,S.$Bb)(A=>{const U=m.read(A);g&&clearTimeout(g),g=setTimeout(()=>{(0,v.$5b)(z=>{D.set(U,z)})},w)})),D}e.$Ob=$;function E(m,w,N){const D=(0,v.$9b)("triggeredRecently",!1);let g;return N.add(m(()=>{D.set(!0,void 0),g&&clearTimeout(g),g=setTimeout(()=>{D.set(!1,void 0)},w)})),D}e.$Pb=E;function P(m,w){const N=new M(w??!1);return m.addObserver(N),w&&m.reportChanges(),(0,T.$jb)(()=>{m.removeObserver(N)})}e.$Qb=P;class M{constructor(w){this.b=w,this.a=0}beginUpdate(w){this.a++}endUpdate(w){this.a--,this.a===0&&this.b&&w.reportChanges()}handlePossibleChange(w){}handleChange(w,N){}}function k(m,w){let N;return(0,O.$Wb)(g=>(N=w(g,N),N),m)}e.$Rb=k;function d(m,w){let N;const D=(0,v.$9b)("derivedObservableWithWritableCache.counter",0),g=(0,O.$Wb)(A=>(D.read(A),N=w(A,N),N),m);return Object.assign(g,{clearCache:A=>{N=void 0,D.set(D.get()+1,A)}})}e.$Sb=d}),define(q[11],K([0,1,5,10,9,22,4]),function(F,e,T,S,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.keepAlive=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return T.$9b}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return T.$$b}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return T.$5b}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return T.$6b}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$Wb}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$Xb}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$Yb}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$Zb}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$Bb}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$Gb}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$Cb}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$Eb}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$Ab}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$Db}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.$Hb}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.$Ob}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$Rb}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$Sb}}),Object.defineProperty(e,"keepAlive",{enumerable:!0,get:function(){return O.$Qb}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.$Kb}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.$Ib}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.$Nb}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$Mb}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return O.$Jb}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$Pb}}),!1&&(0,r.$Tb)(new r.$Vb)}),define(q[23],K([0,1,6,2]),function(F,e,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function v(M){const k=M;return k?typeof k.read=="function":!1}e.$pc=v;function O(M){const k=M;return k?[k.on,k.pause,k.resume,k.destroy].every(d=>typeof d=="function"):!1}e.$qc=O;function r(M){const k=M;return k?O(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$rc=r;function u(M,k){return new t(M,k)}e.$sc=u;class t{constructor(k,d){this.e=k,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(d=>d(k))}h(k){this.c.error.length===0?(0,T.$Y)(k):this.c.error.slice(0).forEach(d=>d(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,d){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(k,d){if(this.a.destroyed)return;let m;switch(k){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const w=m.indexOf(d);w>=0&&m.splice(w,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(M,k){const d=[];let m;for(;(m=M.read())!==null;)d.push(m);return k(d)}e.$tc=a;function o(M,k,d){const m=[];let w;for(;(w=M.read())!==null&&m.length<d;)m.push(w);return w===null&&m.length>0?k(m):{read:()=>{if(m.length>0)return m.shift();if(typeof w<"u"){const N=w;return w=void 0,N}return M.read()}}}e.$uc=o;function c(M,k){return new Promise((d,m)=>{const w=[];f(M,{onData:N=>{k&&w.push(N)},onError:N=>{k?m(N):d(void 0)},onEnd:()=>{d(k?k(w):void 0)}})})}e.$vc=c;function f(M,k,d){M.on("error",m=>{d?.isCancellationRequested||k.onError(m)}),M.on("end",()=>{d?.isCancellationRequested||k.onEnd()}),M.on("data",m=>{d?.isCancellationRequested||k.onData(m)})}e.$wc=f;function l(M,k){return new Promise((d,m)=>{const w=new S.$kb,N=[],D=U=>{if(N.push(U),N.length>k)return w.dispose(),M.pause(),d({stream:M,buffer:N,ended:!1})},g=U=>m(U),A=()=>d({stream:M,buffer:N,ended:!0});w.add((0,S.$jb)(()=>M.removeListener("error",g))),M.on("error",g),w.add((0,S.$jb)(()=>M.removeListener("end",A))),M.on("end",A),w.add((0,S.$jb)(()=>M.removeListener("data",D))),M.on("data",D)})}e.$xc=l;function n(M,k){const d=u(k);return d.end(M),d}e.$yc=n;function i(){const M=u(()=>{throw new Error("not supported")});return M.end(),M}e.$zc=i;function s(M){let k=!1;return{read:()=>k?null:(k=!0,M)}}e.$Ac=s;function $(M,k,d){const m=u(d);return f(M,{onData:w=>m.write(k.data(w)),onError:w=>m.error(k.error?k.error(w):w),onEnd:()=>m.end()}),m}e.$Bc=$;function E(M,k,d){let m=!1;return{read:()=>{const w=k.read();return m?w:(m=!0,w!==null?d([M,w]):M)}}}e.$Cc=E;function P(M,k,d){let m=!1;const w=u(d);return f(k,{onData:N=>m?w.write(N):(m=!0,w.write(d([M,N]))),onError:N=>w.error(N),onEnd:()=>{m||(m=!0,w.write(M)),w.end()}}),w}e.$Dc=P}),define(q[12],K([0,1,43,23]),function(F,e,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=void 0;const v=typeof Buffer<"u",O=new T.$T(()=>new Uint8Array(256));let r,u;class t{static alloc(b){return v?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return v&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,j){return!(j?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(b)):(r||(r=new TextEncoder),new t(r.encode(b)))}static fromByteArray(b){const j=t.alloc(b.length);for(let p=0,Y=b.length;p<Y;p++)j.buffer[p]=b[p];return j}static concat(b,j){if(typeof j>"u"){j=0;for(let V=0,_=b.length;V<_;V++)j+=b[V].byteLength}const p=t.alloc(j);let Y=0;for(let V=0,_=b.length;V<_;V++){const W=b[V];p.set(W,Y),Y+=W.byteLength}return p}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return v?this.buffer.toString():(u||(u=new TextDecoder),u.decode(this.buffer))}slice(b,j){return new t(this.buffer.subarray(b,j))}set(b,j){if(b instanceof t)this.buffer.set(b.buffer,j);else if(b instanceof Uint8Array)this.buffer.set(b,j);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),j);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return f(this.buffer,b)}writeUInt32BE(b,j){l(this.buffer,b,j)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,j){i(this.buffer,b,j)}readUInt8(b){return s(this.buffer,b)}writeUInt8(b,j){$(this.buffer,b,j)}indexOf(b,j=0){return a(this.buffer,b instanceof t?b.buffer:b,j)}}e.$Ec=t;function a(I,b,j=0){const p=b.byteLength,Y=I.byteLength;if(p===0)return 0;if(p===1)return I.indexOf(b[0]);if(p>Y-j)return-1;const V=O.value;V.fill(b.length);for(let X=0;X<b.length;X++)V[b[X]]=b.length-X-1;let _=j+b.length-1,W=_,G=-1;for(;_<Y;)if(I[_]===b[W]){if(W===0){G=_;break}_--,W--}else _+=Math.max(b.length-W,V[I[_]]),W=b.length-1;return G}e.$Fc=a;function o(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0}e.$Gc=o;function c(I,b,j){I[j+0]=b&255,b=b>>>8,I[j+1]=b&255}e.$Hc=c;function f(I,b){return I[b]*2**24+I[b+1]*2**16+I[b+2]*2**8+I[b+3]}e.$Ic=f;function l(I,b,j){I[j+3]=b,b=b>>>8,I[j+2]=b,b=b>>>8,I[j+1]=b,b=b>>>8,I[j]=b}e.$Jc=l;function n(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0|I[b+2]<<16>>>0|I[b+3]<<24>>>0}e.$Kc=n;function i(I,b,j){I[j+0]=b&255,b=b>>>8,I[j+1]=b&255,b=b>>>8,I[j+2]=b&255,b=b>>>8,I[j+3]=b&255}e.$Lc=i;function s(I,b){return I[b]}e.$Mc=s;function $(I,b,j){I[j]=b}e.$Nc=$;function E(I){return S.$tc(I,b=>t.concat(b))}e.$Oc=E;function P(I){return S.$Ac(I)}e.$Pc=P;function M(I){return S.$vc(I,b=>t.concat(b))}e.$Qc=M;async function k(I){return I.ended?t.concat(I.buffer):t.concat([...I.buffer,await M(I.stream)])}e.$Rc=k;function d(I){return S.$yc(I,b=>t.concat(b))}e.$Sc=d;function m(I){return S.$Bc(I,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$Tc=m;function w(I){return S.$sc(b=>t.concat(b),I)}e.$Uc=w;function N(I,b){return S.$Cc(I,b,j=>t.concat(j))}e.$Vc=N;function D(I,b){return S.$Dc(I,b,j=>t.concat(j))}e.$Wc=D;function g(I){let b=0,j=0,p=0;const Y=new Uint8Array(Math.floor(I.length/4*3)),V=W=>{switch(j){case 3:Y[p++]=b|W,j=0;break;case 2:Y[p++]=b|W>>>2,b=W<<6,j=3;break;case 1:Y[p++]=b|W>>>4,b=W<<4,j=2;break;default:b=W<<2,j=1}};for(let W=0;W<I.length;W++){const G=I.charCodeAt(W);if(G>=65&&G<=90)V(G-65);else if(G>=97&&G<=122)V(G-97+26);else if(G>=48&&G<=57)V(G-48+52);else if(G===43||G===45)V(62);else if(G===47||G===95)V(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${I[W]}`)}}const _=p;for(;j>0;)V(0);return t.wrap(Y).slice(0,_)}e.$Xc=g;const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function z({buffer:I},b=!0,j=!1){const p=j?U:A;let Y="";const V=I.byteLength%3;let _=0;for(;_<I.byteLength-V;_+=3){const W=I[_+0],G=I[_+1],X=I[_+2];Y+=p[W>>>2],Y+=p[(W<<4|G>>>4)&63],Y+=p[(G<<2|X>>>6)&63],Y+=p[X&63]}if(V===1){const W=I[_+0];Y+=p[W>>>2],Y+=p[W<<4&63],b&&(Y+="==")}else if(V===2){const W=I[_+0],G=I[_+1];Y+=p[W>>>2],Y+=p[(W<<4|G>>>4)&63],Y+=p[G<<2&63],b&&(Y+="=")}return Y}e.$Yc=z}),define(q[24],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=void 0,e.$bc=Symbol("MicrotaskDelay")}),define(q[25],K([0,1,26,3,27,44]),function(F,e,T,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function r(g){return g===47||g===92}e.$Ae=r;function u(g){return g.replace(/[\\/]/g,T.$5c.sep)}e.$Be=u;function t(g){return g.indexOf("/")===-1&&(g=u(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.$Ce=t;function a(g,A=T.$5c.sep){if(!g)return"";const U=g.length,z=g.charCodeAt(0);if(r(z)){if(r(g.charCodeAt(1))&&!r(g.charCodeAt(2))){let b=3;const j=b;for(;b<U&&!r(g.charCodeAt(b));b++);if(j!==b&&!r(g.charCodeAt(b+1))){for(b+=1;b<U;b++)if(r(g.charCodeAt(b)))return g.slice(0,b+1).replace(/[\\/]/g,A)}}return A}else if($(z)&&g.charCodeAt(1)===58)return r(g.charCodeAt(2))?g.slice(0,2)+A:g.slice(0,2);let I=g.indexOf("://");if(I!==-1){for(I+=3;I<U;I++)if(r(g.charCodeAt(I)))return g.slice(0,I+1)}return""}e.$De=a;function o(g){if(!S.$d||!g||g.length<5)return!1;let A=g.charCodeAt(0);if(A!==92||(A=g.charCodeAt(1),A!==92))return!1;let U=2;const z=U;for(;U<g.length&&(A=g.charCodeAt(U),A!==92);U++);return!(z===U||(A=g.charCodeAt(U+1),isNaN(A)||A===92))}e.$Ee=o;const c=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(g,A=S.$d){const U=A?c:f;return!(!g||g.length===0||/^\s+$/.test(g)||(U.lastIndex=0,U.test(g))||A&&l.test(g)||g==="."||g===".."||A&&g[g.length-1]==="."||A&&g.length!==g.trim().length||g.length>255)}e.$Fe=n;function i(g,A,U){const z=g===A;return!U||z?z:!g||!A?!1:(0,v.$Ld)(g,A)}e.$Ge=i;function s(g,A,U,z=T.sep){if(g===A)return!0;if(!g||!A||A.length>g.length)return!1;if(U){if(!(0,v.$Md)(g,A))return!1;if(A.length===g.length)return!0;let b=A.length;return A.charAt(A.length-1)===z&&b--,g.charAt(b)===z}return A.charAt(A.length-1)!==z&&(A+=z),g.indexOf(A)===0}e.$He=s;function $(g){return g>=65&&g<=90||g>=97&&g<=122}e.$Ie=$;function E(g,A){return S.$d&&g.endsWith(":")&&(g+=T.sep),(0,T.$7c)(g)||(g=(0,T.$8c)(A,g)),g=(0,T.$6c)(g),S.$d?(g=(0,v.$ud)(g,T.sep),g.endsWith(":")&&(g+=T.sep)):(g=(0,v.$ud)(g,T.sep),g||(g=T.sep)),g}e.$Je=E;function P(g){const A=(0,T.$6c)(g);return S.$d?g.length>3?!1:M(A)&&(g.length===2||A.charCodeAt(2)===92):A===T.$5c.sep}e.$Ke=P;function M(g,A=S.$d){return A?$(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.$Le=M;function k(g,A=S.$d){return M(g,A)?g[0]:void 0}e.$Me=k;function d(g,A,U){return A.length>g.length?-1:g===A?0:(U&&(g=g.toLowerCase(),A=A.toLowerCase()),g.indexOf(A))}e.$Ne=d;function m(g){const A=g.split(":");let U,z,I;for(const b of A){const j=Number(b);(0,O.$me)(j)?z===void 0?z=j:I===void 0&&(I=j):U=U?[U,b].join(":"):b}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:z!==void 0?z:void 0,column:I!==void 0?I:z!==void 0?1:void 0}}e.$Oe=m;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",N="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(g,A,U=8){let z="";for(let b=0;b<U;b++){let j;b===0&&S.$d&&!A&&(U===3||U===4)?j=N:j=w,z+=j.charAt(Math.floor(Math.random()*j.length))}let I;return A?I=`${A}-${z}`:I=z,g?(0,T.$8c)(g,I):I}e.$Pe=D}),define(q[13],K([0,1,6,3,7]),function(F,e,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var O;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$Te="vscode-tkn",e.$Ue="tkn";class r{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(o){this.d=o}setDelegate(o){this.e=o}setServerRootPath(o){this.f=`${o}/${O.vscodeRemoteResource}`}set(o,c,f){this.a[o]=c,this.b[o]=f}setConnectionToken(o,c){this.c[o]=c}getPreferredWebSchema(){return this.d}rewrite(o){if(this.e)try{return this.e(o)}catch(s){return T.$Y(s),o}const c=o.authority;let f=this.a[c];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const l=this.b[c],n=this.c[c];let i=`path=${encodeURIComponent(o.path)}`;return typeof n=="string"&&(i+=`&${e.$Ue}=${encodeURIComponent(n)}`),v.URI.from({scheme:S.$j?this.d:O.vscodeRemoteResource,authority:`${f}:${l}`,path:S.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:i})}}e.$Ve=new r,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class u{asBrowserUri(o){const c=this.b(o,F);return this.uriToBrowserUri(c)}uriToBrowserUri(o){return o.scheme===O.vscodeRemote?e.$Ve.rewrite(o):o.scheme===O.file&&(S.$h||S.$k&&S.$b.origin===`${O.vscodeFileResource}://${u.a}`)?o.with({scheme:O.vscodeFileResource,authority:o.authority||u.a,query:null,fragment:null}):o}asFileUri(o){const c=this.b(o,F);return this.uriToFileUri(c)}uriToFileUri(o){return o.scheme===O.vscodeFileResource?o.with({scheme:O.file,authority:o.authority!==u.a?o.authority:null,query:null,fragment:null}):o}b(o,c){return v.URI.isUri(o)?o:v.URI.parse(c.toUrl(o))}}u.a="vscode-app",e.$1e=new u;var t;(function(a){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(o.get("3"));const c="vscode-coi";function f(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:v.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const s=i?.get(c);if(s)return o.get(s)}a.getHeadersFromQuery=f;function l(n,i,s){if(!globalThis.crossOriginIsolated)return;const $=i&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(c,$):n[c]=$}a.addSearchParam=l})(t||(e.COI=t={}))}),define(q[28],K([0,1,21,13,3,7]),function(F,e,T,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=void 0;class r{constructor(f,l,n){this.id=f,this.dependencies=l,this.callback=n}}class u{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,l,n)=>{typeof f!="string"&&(n=l,l=f,f=null),(typeof l!="object"||!Array.isArray(l))&&(n=l,l=null),this.c.push(new r(f,l,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const l=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!l)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(f){return new Promise((l,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const s=()=>{i.removeEventListener("load",$),i.removeEventListener("error",E)},$=P=>{s(),l(this.c.pop())},E=P=>{s(),n(P)};i.addEventListener("load",$),i.addEventListener("error",E),this.f&&(f=this.f.createScriptURL(f)),i.setAttribute("src",f),document.getElementsByTagName("head")[0].appendChild(i)})}i(f){return new Promise((l,n)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),l(this.c.pop())}catch(i){n(i)}})}async j(f){try{const l=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,s=O.URI.parse(f).fsPath,$=l.readFileSync(s).toString(),E=i.wrap($.replace(/^#!.*/,""));return new n.Script(E).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}u.INSTANCE=new u;const t=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function o(c,f,l){if(T.$R){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[c]&&(c=a[c]);const n=`${c}/${f}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const P=`${l&&!v.$j?S.$Ye:S.$Xe}/${n}`;i=S.$1e.asBrowserUri(P).toString(!0)}const s=u.INSTANCE.load(i);return t.set(n,s),s}else return await new Promise((n,i)=>{F([c],n,i)})}e.$3C=o}),define(q[14],K([0,1,25,13,26,3,27,7]),function(F,e,T,S,v,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.DataUri=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function t(l){return(0,u.$Se)(l,!0)}e.$Wf=t;class a{constructor(n){this.a=n}compare(n,i,s=!1){return n===i?0:(0,r.$Ed)(this.getComparisonKey(n,s),this.getComparisonKey(i,s))}isEqual(n,i,s=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,s)===this.getComparisonKey(i,s)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,s=!1){if(n.scheme===i.scheme){if(n.scheme===S.Schemas.file)return T.$He(t(n),t(i),this.a(n))&&n.query===i.query&&(s||n.fragment===i.fragment);if((0,e.$bg)(n.authority,i.authority))return T.$He(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(s||n.fragment===i.fragment)}return!1}joinPath(n,...i){return u.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$6f)(n)||n.authority}basename(n){return v.$5c.basename(n.path)}extname(n){return v.$5c.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===S.Schemas.file?i=u.URI.file(v.$$c(t(n))).path:(i=v.$5c.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===S.Schemas.file?i=u.URI.file(v.$6c(t(n))).path:i=v.$5c.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$bg)(n.authority,i.authority))return;if(n.scheme===S.Schemas.file){const E=v.$0c(t(n),t(i));return O.$d?T.$Be(E):E}let s=n.path||"/";const $=i.path||"/";if(this.a(n)){let E=0;for(const P=Math.min(s.length,$.length);E<P&&!(s.charCodeAt(E)!==$.charCodeAt(E)&&s.charAt(E).toLowerCase()!==$.charAt(E).toLowerCase());E++);s=$.substr(0,E)+s.substr(E)}return v.$5c.relative(s,$)}resolvePath(n,i){if(n.scheme===S.Schemas.file){const s=u.URI.file(v.$9c(t(n),i));return n.with({authority:s.authority,path:s.path})}return i=T.$Ce(i),n.with({path:v.$5c.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.$Ld)(n,i)}hasTrailingPathSeparator(n,i=v.sep){if(n.scheme===S.Schemas.file){const s=t(n);return s.length>T.$De(s).length&&s[s.length-1]===i}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=v.sep){return(0,e.$cg)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=v.sep){let s=!1;if(n.scheme===S.Schemas.file){const $=t(n);s=$!==void 0&&$.length===T.$De($).length&&$[$.length-1]===i}else{i="/";const $=n.path;s=$.length===1&&$.charCodeAt($.length-1)===47}return!s&&!(0,e.$cg)(n,i)?n.with({path:n.path+"/"}):n}}e.$Xf=a,e.$Yf=new a(()=>!1),e.$Zf=new a(l=>l.scheme===S.Schemas.file?!O.$f:!0),e.$1f=new a(l=>!0),e.$2f=e.$Yf.isEqual.bind(e.$Yf),e.$3f=e.$Yf.isEqualOrParent.bind(e.$Yf),e.$4f=e.$Yf.getComparisonKey.bind(e.$Yf),e.$5f=e.$Yf.basenameOrAuthority.bind(e.$Yf),e.$6f=e.$Yf.basename.bind(e.$Yf),e.$7f=e.$Yf.extname.bind(e.$Yf),e.$8f=e.$Yf.dirname.bind(e.$Yf),e.$9f=e.$Yf.joinPath.bind(e.$Yf),e.$0f=e.$Yf.normalizePath.bind(e.$Yf),e.$$f=e.$Yf.relativePath.bind(e.$Yf),e.$_f=e.$Yf.resolvePath.bind(e.$Yf),e.$ag=e.$Yf.isAbsolutePath.bind(e.$Yf),e.$bg=e.$Yf.isEqualAuthority.bind(e.$Yf),e.$cg=e.$Yf.hasTrailingPathSeparator.bind(e.$Yf),e.$dg=e.$Yf.removeTrailingPathSeparator.bind(e.$Yf),e.$eg=e.$Yf.addTrailingPathSeparator.bind(e.$Yf);function o(l,n){const i=[];for(let s=0;s<l.length;s++){const $=n(l[s]);l.some((E,P)=>P===s?!1:(0,e.$3f)($,n(E)))||i.push(l[s])}return i}e.$fg=o;var c;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function n(i){const s=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(P=>{const[M,k]=P.split(":");M&&k&&s.set(M,k)});const E=i.path.substring(0,i.path.indexOf(";"));return E&&s.set(l.META_DATA_MIME,E),s}l.parseMetaData=n})(c||(e.DataUri=c={}));function f(l,n,i){if(n){let s=l.path;return s&&s[0]!==v.$5c.sep&&(s=v.$5c.sep+s),l.with({scheme:i,authority:n,path:s})}return l.with({scheme:i})}e.$gg=f}),define(q[15],K([0,1,45,6,29,2,14,3,24]),function(F,e,T,S,v,O,r,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function a(L){return!!L&&typeof L.then=="function"}e.$hg=a;function o(L){const h=new T.$oc,y=L(h.token),C=new Promise((R,B)=>{const H=h.token.onCancellationRequested(()=>{H.dispose(),h.dispose(),B(new S.$3)});Promise.resolve(y).then(J=>{H.dispose(),h.dispose(),R(J)},J=>{H.dispose(),h.dispose(),B(J)})});return new class{cancel(){h.cancel()}then(R,B){return C.then(R,B)}catch(R){return this.then(void 0,R)}finally(R){return C.finally(R)}}}e.$ig=o;function c(L,h,y){return new Promise((C,R)=>{const B=h.onCancellationRequested(()=>{B.dispose(),C(y)});L.then(C,R).finally(()=>B.dispose())})}e.$jg=c;function f(L,h){return new Promise((y,C)=>{const R=h.onCancellationRequested(()=>{R.dispose(),C(new S.$3)});L.then(y,C).finally(()=>R.dispose())})}e.$kg=f;async function l(L){let h=-1;const y=L.map((C,R)=>C.then(B=>(h=R,B)));try{return await Promise.race(y)}finally{L.forEach((C,R)=>{R!==h&&C.cancel()})}}e.$lg=l;function n(L,h,y){let C;const R=setTimeout(()=>{C?.(void 0),y?.()},h);return Promise.race([L.finally(()=>clearTimeout(R)),new Promise(B=>C=B)])}e.$mg=n;function i(L){return new Promise((h,y)=>{const C=L();a(C)?C.then(h,y):h(C)})}e.$ng=i;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(h){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=h,!this.b){const y=()=>{if(this.b=null,this.f)return;const C=this.queue(this.d);return this.d=null,C};this.b=new Promise(C=>{this.a.then(y,y).then(C)})}return new Promise((y,C)=>{this.b.then(y,C)})}return this.a=h(),new Promise((y,C)=>{this.a.then(R=>{this.a=null,y(R)},R=>{this.a=null,C(R)})})}dispose(){this.f=!0}}e.$og=s;class ${constructor(){this.a=Promise.resolve(null)}queue(h){return this.a=this.a.then(()=>h(),()=>h())}}e.$pg=$;class E{constructor(){this.a=new Map}queue(h,y){const R=(this.a.get(h)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(h)===R&&this.a.delete(h)});return this.a.set(h,R),R}}e.$qg=E;const P=(L,h)=>{let y=!0;const C=setTimeout(()=>{y=!1,h()},L);return{isTriggered:()=>y,dispose:()=>{clearTimeout(C),y=!1}}},M=L=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,L())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class k{constructor(h){this.defaultDelay=h,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(h,y=this.defaultDelay){this.g=h,this.h(),this.b||(this.b=new Promise((R,B)=>{this.d=R,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const C=()=>{this.a=null,this.d?.(null)};return this.a=y===t.$bc?M(C):P(y,C),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$rg=k;class d{constructor(h){this.a=new k(h),this.b=new s}trigger(h,y){return this.a.trigger(()=>this.b.queue(h),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$sg=d;class m{constructor(){this.a=!1,this.b=new Promise((h,y)=>{this.d=h})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$tg=m;class w extends m{constructor(h){super(),this.f=setTimeout(()=>this.open(),h)}open(){clearTimeout(this.f),super.open()}}e.$ug=w;function N(L,h){return h?new Promise((y,C)=>{const R=setTimeout(()=>{B.dispose(),y()},L),B=h.onCancellationRequested(()=>{clearTimeout(R),B.dispose(),C(new S.$3)})}):o(y=>N(L,y))}e.$vg=N;function D(L,h=0){const y=setTimeout(L,h);return(0,O.$jb)(()=>clearTimeout(y))}e.$wg=D;function g(L){const h=[];let y=0;const C=L.length;function R(){return y<C?L[y++]():null}function B(H){H!=null&&h.push(H);const J=R();return J?J.then(B):Promise.resolve(h)}return Promise.resolve(null).then(B)}e.$xg=g;function A(L,h=C=>!!C,y=null){let C=0;const R=L.length,B=()=>{if(C>=R)return Promise.resolve(y);const H=L[C++];return Promise.resolve(H()).then(Q=>h(Q)?Promise.resolve(Q):B())};return B()}e.$yg=A;function U(L,h=C=>!!C,y=null){if(L.length===0)return Promise.resolve(y);let C=L.length;const R=()=>{C=-1;for(const B of L)B.cancel?.()};return new Promise((B,H)=>{for(const J of L)J.then(Q=>{--C>=0&&h(Q)?(R(),B(Q)):C===0&&B(y)}).catch(Q=>{--C>=0&&(R(),H(Q))})})}e.$zg=U;class z{constructor(h){this.a=0,this.d=h,this.f=[],this.b=0,this.g=new v.$ec}get onDrained(){return this.g.event}get size(){return this.a}queue(h){return this.a++,new Promise((y,C)=>{this.f.push({factory:h,c:y,e:C}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const h=this.f.shift();this.b++;const y=h.factory();y.then(h.c,h.e),y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Ag=z;class I extends z{constructor(){super(1)}}e.$Bg=I;class b{constructor(){this.a=new x,this.b=0}queue(h){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,h())):this.a.run(this.b++,h())}}e.$Cg=b;class j{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const h=new te;return this.b.add(h),h.p}d(){for(const[,h]of this.a)if(h.size>0)return!1;return!0}queueFor(h,y=r.$Yf){const C=y.getComparisonKey(h);let R=this.a.get(C);return R||(R=new I,v.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(C),this.f()}),this.a.set(C,R)),R}f(){this.d()&&this.g()}g(){for(const h of this.b)h.complete();this.b.clear()}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),this.g()}}e.$Dg=j;class p{constructor(h,y){this.a=-1,typeof h=="function"&&typeof y=="number"&&this.setIfNotSet(h,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(h,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,h()},y)}setIfNotSet(h,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,h()},y))}}e.$Eg=p;class Y{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(h,y){this.cancel(),this.a=setInterval(()=>{h()},y)}}e.$Fg=Y;class V{constructor(h,y){this.b=-1,this.a=h,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(h=this.d){this.cancel(),this.b=setTimeout(this.f,h)}get delay(){return this.d}set delay(h){this.d=h}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=V;class _{constructor(h,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=h,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(h=this.b){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(h/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=_;class W extends V{constructor(h,y){super(h,y),this.j=[]}work(h){this.j.push(h),this.isScheduled()||this.schedule()}h(){const h=this.j;this.j=[],this.a?.(h)}dispose(){this.j=[],super.dispose()}}e.$Ig=W;class G extends O.$lb{constructor(h,y){super(),this.g=h,this.h=y,this.a=[],this.b=this.B(new O.$mb),this.f=!1}get pending(){return this.a.length}work(h){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+h.length>this.g.maxBufferedWork)return!1}else if(this.pending+h.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of h)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=G,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=L=>{(0,u.$v)(()=>{if(h)return;const y=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,y-Date.now())}}))});let h=!1;return{dispose(){h||(h=!0)}}}:e.$Kg=(L,h)=>{const y=requestIdleCallback(L,typeof h=="number"?{timeout:h}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(y))}}}}();class X{constructor(h){this.d=!1,this.a=()=>{try{this.f=h()}catch(y){this.g=y}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=X;async function re(L,h,y){let C;for(let R=0;R<y;R++)try{return await L()}catch(B){C=B,await N(h)}throw C}e.$Mg=re;class x{isRunning(h){return typeof h=="number"?this.a?.taskId===h:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(h,y,C){return this.a={taskId:h,cancel:()=>C?.(),promise:y},y.then(()=>this.d(h),()=>this.d(h)),y}d(h){this.a&&h===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const h=this.b;this.b=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}queue(h){if(this.b)this.b.run=h;else{let y,C;const R=new Promise((B,H)=>{y=B,C=H});this.b={run:h,promise:R,promiseResolve:y,promiseReject:C}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=x;class ae{constructor(h,y=()=>Date.now()){this.d=h,this.f=y,this.a=0,this.b=0}increment(){const h=this.f();return h-this.a>this.d&&(this.a=h,this.b=0),this.b++,this.b}}e.$Og=ae;var ee;(function(L){L[L.Resolved=0]="Resolved",L[L.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((h,y)=>{this.a=h,this.b=y})}complete(h){return new Promise(y=>{this.a(h),this.d={outcome:0,value:h},y()})}error(h){return new Promise(y=>{this.b(h),this.d={outcome:1,value:h},y()})}cancel(){return this.error(new S.$3)}}e.$Pg=te;var ne;(function(L){async function h(C){let R;const B=await Promise.all(C.map(H=>H.then(J=>J,J=>{R||(R=J)})));if(typeof R<"u")throw R;return B}L.settled=h;function y(C){return new Promise(async(R,B)=>{try{await C(R,B)}catch(H){B(H)}})}L.withAsyncBody=y})(ne||(e.Promises=ne={}));var ie;(function(L){L[L.Initial=0]="Initial",L[L.DoneOK=1]="DoneOK",L[L.DoneError=2]="DoneError"})(ie||(ie={}));class Z{static fromArray(h){return new Z(y=>{y.emitMany(h)})}static fromPromise(h){return new Z(async y=>{y.emitMany(await h)})}static fromPromises(h){return new Z(async y=>{await Promise.all(h.map(async C=>y.emitOne(await C)))})}static merge(h){return new Z(async y=>{await Promise.all(h.map(async C=>{for await(const R of C)y.emitOne(R)}))})}constructor(h){this.a=0,this.b=[],this.d=null,this.f=new v.$ec,queueMicrotask(async()=>{const y={emitOne:C=>this.g(C),emitMany:C=>this.h(C),reject:C=>this.k(C)};try{await Promise.resolve(h(y)),this.j()}catch(C){this.k(C)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(h<this.b.length)return{done:!1,value:this.b[h++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(h,y){return new Z(async C=>{for await(const R of h)C.emitOne(y(R))})}map(h){return Z.map(this,h)}static filter(h,y){return new Z(async C=>{for await(const R of h)y(R)&&C.emitOne(R)})}filter(h){return Z.filter(this,h)}static coalesce(h){return Z.filter(h,y=>!!y)}coalesce(){return Z.coalesce(this)}static async toPromise(h){const y=[];for await(const C of h)y.push(C);return y}toPromise(){return Z.toPromise(this)}g(h){this.a===0&&(this.b.push(h),this.f.fire())}h(h){this.a===0&&(this.b=this.b.concat(h),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(h){this.a===0&&(this.a=2,this.d=h,this.f.fire())}}e.$Qg=Z,Z.EMPTY=Z.fromArray([]);class se extends Z{constructor(h,y){super(y),this.l=h}cancel(){this.l.cancel()}}e.$Rg=se;function oe(L){const h=new T.$oc,y=L(h.token);return new se(h,async C=>{const R=h.token.onCancellationRequested(()=>{R.dispose(),h.dispose(),C.reject(new S.$3)});try{for await(const B of y){if(h.token.isCancellationRequested)return;C.emitOne(B)}R.dispose(),h.dispose()}catch(B){R.dispose(),h.dispose(),C.reject(B)}})}e.$Sg=oe}),define(q[16],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=e.StringEOL=void 0;var T;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(T||(e.StringEOL=T={}));function S(v){let O=0,r=0,u=0,t=0;for(let a=0,o=v.length;a<o;a++){const c=v.charCodeAt(a);c===13?(O===0&&(r=a),O++,a+1<o&&v.charCodeAt(a+1)===10?(t|=2,a++):t|=3,u=a+1):c===10&&(t|=1,O===0&&(r=a),O++,u=a+1)}return O===0&&(r=v.length),[O,r,v.length-u,t]}e.$ms=S}),define(q[17],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(T||(e.LanguageId=T={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class u{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let c="mtk"+this.getForeground(a);const f=this.getFontStyle(a);return f&1&&(c+=" mtki"),f&2&&(c+=" mtkb"),f&4&&(c+=" mtku"),f&8&&(c+=" mtks"),c}static getInlineStyleFromMetadata(a,o){const c=this.getForeground(a),f=this.getFontStyle(a);let l=`color: ${o[c]};`;f&1&&(l+="font-style: italic;"),f&2&&(l+="font-weight: bold;");let n="";return f&4&&(n+=" underline"),f&8&&(n+=" line-through"),n&&(l+=`text-decoration:${n};`),l}static getPresentationFromMetadata(a){const o=this.getForeground(a),c=this.getFontStyle(a);return{foreground:o,italic:!!(c&1),bold:!!(c&2),underline:!!(c&4),strikethrough:!!(c&8)}}}e.$ks=u}),define(q[30],K([0,1,31]),function(F,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nC=void 0;class S{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,u){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=u}replace(r,u,t){if(r>=this.a.length)return;if(u===0){this.insert(r,t);return}else if(t===0){this.delete(r,u);return}const a=this.a.slice(0,r),o=this.a.slice(r+u),c=v(t,this.b);this.a=a.concat(c,o)}delete(r,u){u===0||r>=this.a.length||this.a.splice(r,u)}insert(r,u){if(u===0||r>=this.a.length)return;const t=[];for(let a=0;a<u;a++)t[a]=this.b;this.a=(0,T.$Af)(this.a,r,t)}}e.$nC=S;function v(O,r){const u=[];for(let t=0;t<O;t++)u[t]=r;return u}}),define(q[8],K([0,1,17]),function(F,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0;class S{static createEmpty(r,u){const t=S.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=t,new S(a,r,u)}constructor(r,u,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=u,this.d=t}equals(r){return r instanceof S?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,u,t){if(this.c!==r.c||this.b!==r.b)return!1;const a=u<<1,o=a+(t<<1);for(let c=a;c<o;c++)if(this.a[c]!==r.a[c])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const u=this.a[(r<<1)+1],t=T.$ks.getLanguageId(u);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const u=this.a[(r<<1)+1];return T.$ks.getTokenType(u)}getForeground(r){const u=this.a[(r<<1)+1];return T.$ks.getForeground(u)}getClassName(r){const u=this.a[(r<<1)+1];return T.$ks.getClassNameFromMetadata(u)}getInlineStyle(r,u){const t=this.a[(r<<1)+1];return T.$ks.getInlineStyleFromMetadata(t,u)}getPresentation(r){const u=this.a[(r<<1)+1];return T.$ks.getPresentationFromMetadata(u)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return S.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,u,t){return new v(this,r,u,t)}static convertToEndOffset(r,u){const a=(r.length>>>1)-1;for(let o=0;o<a;o++)r[o<<1]=r[o+1<<1];r[a<<1]=u}static findIndexInTokensArray(r,u){if(r.length<=2)return 0;let t=0,a=(r.length>>>1)-1;for(;t<a;){const o=t+Math.floor((a-t)/2),c=r[o<<1];if(c===u)return o+1;c<u?t=o+1:c>u&&(a=o)}return t}withInserted(r){if(r.length===0)return this;let u=0,t=0,a="";const o=new Array;let c=0;for(;;){const f=u<this.b?this.a[u<<1]:-1,l=t<r.length?r[t]:null;if(f!==-1&&(l===null||f<=l.offset)){a+=this.c.substring(c,f);const n=this.a[(u<<1)+1];o.push(a.length,n),u++,c=f}else if(l){if(l.offset>c){a+=this.c.substring(c,l.offset);const n=this.a[(u<<1)+1];o.push(a.length,n),c=l.offset}a+=l.text,o.push(a.length,l.tokenMetadata),t++}else break}return new S(new Uint32Array(o),a,this.d)}}e.$ns=S,S.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0;class v{constructor(r,u,t,a){this.a=r,this.b=u,this.c=t,this.d=a,this.e=r.findTokenIndexAtOffset(u),this.f=0;for(let o=this.e,c=r.getCount();o<c&&!(r.getStartOffset(o)>=t);o++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof v?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const u=this.a.getEndOffset(this.e+r);return Math.min(this.c,u)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,u){return this.a.getInlineStyle(this.e+r,u)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(q[32],K([0,1,8]),function(F,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=e.$ps=e.$os=void 0,e.$os=new Uint32Array(0).buffer;class S{static deleteBeginning(r,u){return r===null||r===e.$os?r:S.delete(r,0,u)}static deleteEnding(r,u){if(r===null||r===e.$os)return r;const t=v(r),a=t[t.length-2];return S.delete(r,u,a)}static delete(r,u,t){if(r===null||r===e.$os||u===t)return r;const a=v(r),o=a.length>>>1;if(u===0&&a[a.length-2]===t)return e.$os;const c=T.$ns.findIndexInTokensArray(a,u),f=c>0?a[c-1<<1]:0,l=a[c<<1];if(t<l){const E=t-u;for(let P=c;P<o;P++)a[P<<1]-=E;return r}let n,i;f!==u?(a[c<<1]=u,n=c+1<<1,i=u):(n=c<<1,i=f);const s=t-u;for(let E=c+1;E<o;E++){const P=a[E<<1]-s;P>i&&(a[n++]=P,a[n++]=a[(E<<1)+1],i=P)}if(n===a.length)return r;const $=new Uint32Array(n);return $.set(a.subarray(0,n),0),$.buffer}static append(r,u){if(u===e.$os)return r;if(r===e.$os)return u;if(r===null)return r;if(u===null)return null;const t=v(r),a=v(u),o=a.length>>>1,c=new Uint32Array(t.length+a.length);c.set(t,0);let f=t.length;const l=t[t.length-2];for(let n=0;n<o;n++)c[f++]=a[n<<1]+l,c[f++]=a[(n<<1)+1];return c.buffer}static insert(r,u,t){if(r===null||r===e.$os)return r;const a=v(r),o=a.length>>>1;let c=T.$ns.findIndexInTokensArray(a,u);c>0&&a[c-1<<1]===u&&c--;for(let f=c;f<o;f++)a[f<<1]+=t;return r}}e.$ps=S;function v(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.$qs=v}),define(q[33],K([0,1,31,12,46,16,32,18]),function(F,e,T,S,v,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;class t{static deserialize(o,c,f){const l=new Uint32Array(o.buffer),n=(0,S.$Ic)(o,c);c+=4;const i=(0,S.$Ic)(o,c);c+=4;const s=[];for(let $=0;$<i;$++){const E=(0,S.$Ic)(o,c);c+=4,s.push(l.subarray(c/4,c/4+E/4)),c+=E}return f.push(new t(n,s)),c}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(o,c){this.a=o,this.b=c}getLineRange(){return new u.$Wr(this.a,this.a+this.b.length)}getLineTokens(o){return this.b[o-this.a]}appendLineTokens(o){this.b.push(o)}serializeSize(){let o=0;o+=4,o+=4;for(let c=0;c<this.b.length;c++){const f=this.b[c];if(!(f instanceof Uint32Array))throw new Error("Not supported!");o+=4,o+=f.byteLength}return o}serialize(o,c){(0,S.$Jc)(o,this.a,c),c+=4,(0,S.$Jc)(o,this.b.length,c),c+=4;for(let f=0;f<this.b.length;f++){const l=this.b[f];if(!(l instanceof Uint32Array))throw new Error("Not supported!");(0,S.$Jc)(o,l.byteLength,c),c+=4,o.set(new Uint8Array(l.buffer),c),c+=l.byteLength}return c}applyEdit(o,c){const[f,l]=(0,O.$ms)(c);this.c(o),this.d(new v.$Ur(o.startLineNumber,o.startColumn),f,l)}c(o){if(o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn)return;const c=o.startLineNumber-this.a,f=o.endLineNumber-this.a;if(f<0){const l=f-c;this.a-=l;return}if(!(c>=this.b.length)){if(c<0&&f>=this.b.length){this.a=0,this.b=[];return}if(c===f){this.b[c]=r.$ps.delete(this.b[c],o.startColumn-1,o.endColumn-1);return}if(c>=0)if(this.b[c]=r.$ps.deleteEnding(this.b[c],o.startColumn-1),f<this.b.length){const l=r.$ps.deleteBeginning(this.b[f],o.endColumn-1);this.b[c]=r.$ps.append(this.b[c],l),this.b.splice(c+1,f-c)}else this.b[c]=r.$ps.append(this.b[c],null),this.b=this.b.slice(0,c+1);else{const l=-c;this.a-=l,this.b[f]=r.$ps.deleteBeginning(this.b[f],o.endColumn-1),this.b=this.b.slice(f)}}}d(o,c,f){if(c===0&&f===0)return;const l=o.lineNumber-this.a;if(l<0){this.a+=c;return}if(!(l>=this.b.length)){if(c===0){this.b[l]=r.$ps.insert(this.b[l],o.column-1,f);return}this.b[l]=r.$ps.deleteEnding(this.b[l],o.column-1),this.b[l]=r.$ps.insert(this.b[l],o.column-1,f),this.e(o.lineNumber,c)}}e(o,c){if(c===0)return;const f=[];for(let l=0;l<c;l++)f[l]=null;this.b=T.$Af(this.b,o,f)}}e.$rs=t}),define(q[19],K([0,1,12,33]),function(F,e,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=void 0;class v{static deserialize(r){let u=0;const t=(0,T.$Ic)(r,u);u+=4;const a=[];for(let o=0;o<t;o++)u=S.$rs.deserialize(r,u,a);return a}constructor(){this.a=[]}add(r,u){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(u);return}}this.a.push(new S.$rs(r,[u]))}finalize(){return this.a}serialize(){const r=this.b(),u=new Uint8Array(r);return this.c(u),u}b(){let r=0;r+=4;for(let u=0;u<this.a.length;u++)r+=this.a[u].serializeSize();return r}c(r){let u=0;(0,T.$Jc)(r,this.a.length,u),u+=4;for(let t=0;t<this.a.length;t++)u=this.a[t].serialize(r,u)}}e.$oC=v}),define(q[20],K([0,1,34]),function(F,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=e.$lC=e.$kC=void 0,e.$kC=new class{clone(){return this}equals(O){return this===O}};function S(O,r){return new T.$us([new T.$ts(0,"",O)],r)}e.$lC=S;function v(O,r){const u=new Uint32Array(2);return u[0]=0,u[1]=(O<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new T.$vs(u,r===null?e.$kC:r)}e.$mC=v}),define(q[35],K([0,1,15,6,3,36,16,18,47,20,30,19,8]),function(F,e,T,S,v,O,r,u,t,a,o,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=void 0;var l;(function(k){k[k.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(l||(l={}));class n{constructor(d,m){this.tokenizationSupport=m,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(d)}getStartState(d){return this.store.getStartState(d,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$pC=n;class i extends n{constructor(d,m,w,N){super(d,m),this._textModel=w,this._languageIdCodec=N}updateTokensUntilLine(d,m){const w=this._textModel.getLanguageId();for(;;){const N=this.getFirstInvalidLine();if(!N||N.lineNumber>m)break;const D=this._textModel.getLineContent(N.lineNumber),g=P(this._languageIdCodec,w,this.tokenizationSupport,D,!0,N.startState);d.add(N.lineNumber,g.tokens),this.store.setEndState(N.lineNumber,g.endState)}}getTokenTypeIfInsertingCharacter(d,m){const w=this.getStartState(d.lineNumber);if(!w)return 0;const N=this._textModel.getLanguageId(),D=this._textModel.getLineContent(d.lineNumber),g=D.substring(0,d.column-1)+m+D.substring(d.column-1),A=P(this._languageIdCodec,N,this.tokenizationSupport,g,!0,w),U=new f.$ns(A.tokens,g,this._languageIdCodec);if(U.getCount()===0)return 0;const z=U.findTokenIndexAtOffset(d.column-1);return U.getStandardTokenType(z)}tokenizeLineWithEdit(d,m,w){const N=d.lineNumber,D=d.column,g=this.getStartState(N);if(!g)return null;const A=this._textModel.getLineContent(N),U=A.substring(0,D-1)+w+A.substring(D-1+m),z=this._textModel.getLanguageIdAtPosition(N,0),I=P(this._languageIdCodec,z,this.tokenizationSupport,U,!0,g);return new f.$ns(I.tokens,U,this._languageIdCodec)}isCheapToTokenize(d){const m=this.store.getFirstInvalidEndStateLineNumberOrMax();return d<m||d===m&&this._textModel.getLineLength(d)<2048}tokenizeHeuristically(d,m,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(d,w),{heuristicTokens:!1};let N=this.b(m);const D=this._textModel.getLanguageId();for(let g=m;g<=w;g++){const A=this._textModel.getLineContent(g),U=P(this._languageIdCodec,D,this.tokenizationSupport,A,!0,N);d.add(g,U.tokens),N=U.endState}return{heuristicTokens:!0}}b(d){let m=this._textModel.getLineFirstNonWhitespaceColumn(d);const w=[];let N=null;for(let A=d-1;m>1&&A>=1;A--){const U=this._textModel.getLineFirstNonWhitespaceColumn(A);if(U!==0&&U<m&&(w.push(this._textModel.getLineContent(A)),m=U,N=this.getStartState(A),N))break}N||(N=this.tokenizationSupport.getInitialState()),w.reverse();const D=this._textModel.getLanguageId();let g=N;for(const A of w)g=P(this._languageIdCodec,D,this.tokenizationSupport,A,!1,g).endState;return g}}e.$qC=i;class s{constructor(d){this.d=d,this.a=new $,this.b=new E,this.b.addRange(new t.$Sr(1,d+1))}getEndState(d){return this.a.getEndState(d)}setEndState(d,m){if(!m)throw new S.$bb("Cannot set null/undefined state");this.b.delete(d);const w=this.a.setEndState(d,m);return w&&d<this.d&&this.b.addRange(new t.$Sr(d+1,d+2)),w}acceptChange(d,m){this.d+=m-d.length,this.a.acceptChange(d,m),this.b.addRangeAndResize(new t.$Sr(d.startLineNumber,d.endLineNumberExclusive),m)}acceptChanges(d){for(const m of d){const[w]=(0,r.$ms)(m.text);this.acceptChange(new u.$Wr(m.range.startLineNumber,m.range.endLineNumber+1),w+1)}}invalidateEndStateRange(d){this.b.addRange(new t.$Sr(d.startLineNumber,d.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(d,m){return d===1?m:this.getEndState(d-1)}getFirstInvalidLine(d){const m=this.getFirstInvalidEndStateLineNumber();if(m===null)return null;const w=this.getStartState(m,d);if(!w)throw new S.$bb("Start state must be defined");return{lineNumber:m,startState:w}}}e.$rC=s;class ${constructor(){this.a=new o.$nC(null)}getEndState(d){return this.a.get(d)}setEndState(d,m){const w=this.a.get(d);return w&&w.equals(m)?!1:(this.a.set(d,m),!0)}acceptChange(d,m){let w=d.length;m>0&&w>0&&(w--,m--),this.a.replace(d.startLineNumber,w,m)}acceptChanges(d){for(const m of d){const[w]=(0,r.$ms)(m.text);this.acceptChange(new u.$Wr(m.range.startLineNumber,m.range.endLineNumber+1),w+1)}}}e.$sC=$;class E{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const d=this.a[0];return d.start+1===d.endExclusive?this.a.shift():this.a[0]=new t.$Sr(d.start+1,d.endExclusive),d.start}delete(d){const m=this.a.findIndex(w=>w.contains(d));if(m!==-1){const w=this.a[m];w.start===d?w.endExclusive===d+1?this.a.splice(m,1):this.a[m]=new t.$Sr(d+1,w.endExclusive):w.endExclusive===d+1?this.a[m]=new t.$Sr(w.start,d):this.a.splice(m,1,new t.$Sr(w.start,d),new t.$Sr(d+1,w.endExclusive))}}addRange(d){t.$Sr.addRange(d,this.a)}addRangeAndResize(d,m){let w=0;for(;!(w>=this.a.length||d.start<=this.a[w].endExclusive);)w++;let N=w;for(;!(N>=this.a.length||d.endExclusive<this.a[N].start);)N++;const D=m-d.length;for(let g=N;g<this.a.length;g++)this.a[g]=this.a[g].delta(D);if(w===N){const g=new t.$Sr(d.start,d.start+m);g.isEmpty||this.a.splice(w,0,g)}else{const g=Math.min(d.start,this.a[w].start),A=Math.max(d.endExclusive,this.a[N-1].endExclusive),U=new t.$Sr(g,A+D);U.isEmpty?this.a.splice(w,N-w):this.a.splice(w,N-w,U)}}toString(){return this.a.map(d=>d.toString()).join(" + ")}}e.$tC=E;function P(k,d,m,w,N,D){let g=null;if(m)try{g=m.tokenizeEncoded(w,N,D.clone())}catch(A){(0,S.$Y)(A)}return g||(g=(0,a.$mC)(k.encodeLanguageId(d),D)),f.$ns.convertToEndOffset(g.tokens,w.length),g}class M{constructor(d,m){this.b=d,this.d=m,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,T.$Kg)(d=>{this.f=!1,this.h(d)}))}h(d){const m=Date.now()+d.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<m?(0,v.$v)(w):this.g())};w()}j(){const d=this.b._textModel.getLineCount(),m=new c.$oC,w=O.$ac.create(!1);do if(w.elapsed()>1||this.l(m)>=d)break;while(this.k());this.d.setTokens(m.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(d){const m=this.b?.getFirstInvalidLine();return m?(this.b.updateTokensUntilLine(d,m.lineNumber),m.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(d,m){this.b.store.invalidateEndStateRange(new u.$Wr(d,m))}}e.$uC=M}),define(q[37],K([0,1,29,2,36,17,34]),function(F,e,T,S,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YAb=void 0;class u extends S.$lb{constructor(a,o,c,f,l,n,i){super(),this.c=a,this.f=o,this.g=c,this.h=f,this.j=l,this.k=n,this.l=i,this.a=[],this.b=this.B(new T.$ec),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,o,c){throw new Error("Not supported!")}createBackgroundTokenizer(a,o){if(this.h)return this.h(a,o)}tokenizeEncoded(a,o,c){const f=Math.random()*1e4<1,l=this.l||f,n=l?new v.$ac(!0):void 0,i=this.c.tokenizeLine2(a,c,500);if(l){const $=n.elapsed();(f||$>32)&&this.k($,a.length,f)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$vs(i.tokens,c);if(this.g){const $=this.a,E=i.tokens;for(let P=0,M=E.length>>>1;P<M;P++){const k=E[(P<<1)+1],d=O.$ks.getLanguageId(k);$[d]||($[d]=!0,this.b.fire(d))}}let s;return c.equals(i.ruleStack)?s=c:s=i.ruleStack,new r.$vs(i.tokens,s)}}e.$YAb=u}),define(q[38],K([0,1,20,2,11]),function(F,e,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZAb=void 0;class O extends S.$lb{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(u,t,a){super(),this.a=u,this.b=t,this.c=a,this.B((0,v.keepAlive)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(u,t,a){throw new Error("Not supported!")}tokenizeEncoded(u,t,a){return u.length>=this.c.get()?(0,T.$mC)(this.a,a):this.b.tokenizeEncoded(u,t,a)}createBackgroundTokenizer(u,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(u,t)}}e.$ZAb=O}),define(q[39],K([0,1,28,15,11,3,18,48,35,19,8,37,38]),function(F,e,T,S,v,O,r,u,t,a,o,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Ab=void 0;class l extends u.$Du{constructor(s,$,E,P,M,k,d,m){super(s,$,E,P),this.s=M,this.t=k,this.u=d,this.a=null,this.b=!1,this.c=(0,v.observableValue)("_maxTokenizationLineLength",-1),this.q=new S.$Gg(()=>this.w(),10),this.c.set(m,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,$){this.t=s,this.u=$,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,$){this.a&&(this.a.store.invalidateEndStateRange(new r.$Wr(s,$)),this.q.schedule())}async v(){this.a=null;const s=this.t,$=this.u,E=await this.s.getOrCreateGrammar(s,$);if(!(this.b||s!==this.t||$!==this.u||!E)){if(E.grammar){const P=new f.$ZAb(this.u,new c.$YAb(E.grammar,E.initialState,!1,void 0,()=>!1,(M,k,d)=>{this.s.reportTokenizationTime(M,s,E.sourceExtensionId,k,d)},!1),this.c);this.a=new t.$pC(this.f.length,P)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:$}=await(0,T.$3C)("vscode-textmate","release/main.js");this.m=$}const s=new Date().getTime();for(;;){let $=0;const E=new a.$oC,P=new n;for(;;){const d=this.a.getFirstInvalidLine();if(d===null||$>200)break;$++;const m=this.f[d.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded(m,!0,d.startState);if(this.a.store.setEndState(d.lineNumber,w.endState)){const D=this.m(d.startState,w.endState);P.setState(d.lineNumber,D)}else P.setState(d.lineNumber,null);if(o.$ns.convertToEndOffset(w.tokens,m.length),E.add(d.lineNumber,w.tokens),new Date().getTime()-s>20)break}if($===0)break;const M=P.getStateDeltas();if(this.s.setTokensAndStates(this.h,E.serialize(),M),new Date().getTime()-s>20){(0,O.$v)(()=>this.w());return}}}}e.$5Ab=l;class n{constructor(){this.a=-1,this.b=[]}setState(s,$){s===this.a+1?this.b[this.b.length-1].stateDeltas.push($):this.b.push({startLineNumber:s,stateDeltas:[$]}),this.a=s}getStateDeltas(){return this.b}}}),define(q[40],K([0,1,14]),function(F,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Ab=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(O){if(this.a[O.scopeName]){const r=this.a[O.scopeName];T.$2f(r.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${O.location.toString()}`)}this.a[O.scopeName]=O}getGrammarDefinition(O){return this.a[O]||null}}e.$2Ab=S}),define(q[41],K([0,1,2,40]),function(F,e,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Ab=e.$3Ab=void 0,e.$3Ab="No TM Grammar registered for this language.";class v extends T.$lb{constructor(r,u,t,a){super(),this.a=r,this.b=t.INITIAL,this.c=new S.$2Ab,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:a,loadGrammar:async o=>{const c=this.c.getGrammarDefinition(o);if(!c)return this.a.logTrace(`No grammar found for scope ${o}`),null;const f=c.location;try{const l=await this.a.readFile(f);return t.parseRawGrammar(l,f.path)}catch(l){return this.a.logError(`Unable to load and parse grammar for scope ${o} from ${f}`,l),null}},getInjections:o=>{const c=o.split(".");let f=[];for(let l=1;l<=c.length;l++){const n=c.slice(0,l).join(".");f=[...f,...this.f[n]||[]]}return f}}));for(const o of u){if(this.c.register(o),o.injectTo){for(const c of o.injectTo){let f=this.f[c];f||(this.f[c]=f=[]),f.push(o.scopeName)}if(o.embeddedLanguages)for(const c of o.injectTo){let f=this.g[c];f||(this.g[c]=f=[]),f.push(o.embeddedLanguages)}}o.language&&this.h.set(o.language,o.scopeName)}}has(r){return this.h.has(r)}setTheme(r,u){this.j.setTheme(r,u)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,u){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$3Ab);const a=this.c.getGrammarDefinition(t);if(!a)throw new Error(e.$3Ab);const o=a.embeddedLanguages;if(this.g[t]){const l=this.g[t];for(const n of l)for(const i of Object.keys(n))o[i]=n[i]}const c=Object.keys(o).length>0;let f;try{f=await this.j.loadGrammarWithConfiguration(t,u,{embeddedLanguages:o,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(l){throw l.message&&l.message.startsWith("No grammar provided for")?new Error(e.$3Ab):l}return{languageId:r,grammar:f,initialState:this.b,containsEmbeddedLanguages:c,sourceExtensionId:a.sourceExtensionId}}}e.$4Ab=v}),define(q[49],K([0,1,7,41,39]),function(F,e,T,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(u,t){return new r(u,t)}e.create=O;class r{constructor(t,a){this.f=a,this.b=new Map,this.c=[],this.a=t.host;const o=a.grammarDefinitions.map(c=>({location:T.URI.revive(c.location),language:c.language,scopeName:c.scopeName,embeddedLanguages:c.embeddedLanguages,tokenTypes:c.tokenTypes,injectTo:c.injectTo,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors,sourceExtensionId:c.sourceExtensionId}));this.d=this.g(o)}async g(t){const a=this.f.textmateMainUri,o=await new Promise((i,s)=>{F([a],i,s)}),c=await new Promise((i,s)=>{F([this.f.onigurumaMainUri],i,s)}),l=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await c.loadWASM(l);const n=Promise.resolve({createOnigScanner:i=>c.createOnigScanner(i),createOnigString:i=>c.createOnigString(i)});return new S.$4Ab({logTrace:i=>{},logError:(i,s)=>console.error(i,s),readFile:i=>this.a.readFile(i)},t,o,n)}acceptNewModel(t){const a=T.URI.revive(t.uri),o=this;this.b.set(t.controllerId,new v.$5Ab(a,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(c,f){const l=await o.d;return l?(o.c[f]||(o.c[f]=l.createGrammar(c,f)),o.c[f]):Promise.resolve(null)},setTokensAndStates(c,f,l){o.a.setTokensAndStates(t.controllerId,c,f,l)},reportTokenizationTime(c,f,l,n,i){o.a.reportTokenizationTime(c,f,l,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,a){this.b.get(t).onEvents(a)}retokenize(t,a,o){this.b.get(t).retokenize(a,o)}acceptModelLanguageChanged(t,a,o){this.b.get(t).onLanguageId(a,o)}acceptRemovedModel(t){const a=this.b.get(t);a&&(a.dispose(),this.b.delete(t))}async acceptTheme(t,a){(await this.d)?.setTheme(t,a)}acceptMaxTokenizationLineLength(t,a){this.b.get(t).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=textMateTokenizationWorker.worker.js.map
